xdeltacentre EQU xknee2     ;equivalent fields in OBJECT.
ydeltacentre EQU yknee2     ;/
nringwidth  EQU xknee3	    ;/
;NRINGWIDTH EQU 0 ;8	    ;gap between each ring(if concentric)
 ;note, old concentric-ring code doesn't reference this, uses 8 fixed.
 ;... 121200 "nringwidth" now a field of OBJECT.
NEXTRAWIDTH EQU 8   ;used to stop wires from jumping out rings.


;the general structure of all objects...
;NOTE all pointers are relative to start of TERSEDATA.
;When appl running, pTERSEDATA will have addr of start TERSEDATA.
OBJECT STRUCT
fstatus		BYTE	0	;bit0=0 invalid object,bit0=1 valid.
fstatus2	BYTE	0
fconfig		BYTE	0	;0=node,1=wire (see exttype also).
fconfig2	BYTE	0
nexttype	WORD	0	;sub-type of obj(see end this file...)
number		WORD	1	;number, starting from 1, of this object.
nfile		WORD	1  ;File that this object is allocated to.
nrings		BYTE	1	;number of rings(default 1).
fconfig3	BYTE	0
rpmethods	DWORD	0	;-->methods.
    ;relative to "ptrs", which is start of the methods.
spare10 	BYTE	0
spare11 	WORD	0
fdata		BYTE	0	;type of data held by additional data.
rpdata		DWORD	0	;-->additional data.(in object database)
rpmaster	DWORD	0	;master-object at end of parent chain.
rplock1		DWORD	0	;object that this object locked-to.
rplock2		DWORD	0	; ditto (useful for other-end of wire)
;null or data objects can have data past here ...
xtopleft	SDWORD	0	;topleft coords
ytopleft	SDWORD	0	;/
wwidth		SDWORD	0	;node: wwidth&height, arc:destination-end
height		SDWORD	0	;/			   coords.
xmid		SDWORD	0	;absolute middle coords
ymid		SDWORD	0	; /
xknee2		SDWORD	0	;2nd knee on wire. node: .xdeltacentre
yknee2		SDWORD	0	;/			 .ydeltacentre
xknee3		SDWORD	0	;3rd knee	   node: .nringwidth
yknee3		SDWORD	0	;/
xlabeloffset	SWORD	0	;move label from default position.
ylabeloffset	SWORD	0	; /
nbeginring	BYTE	1 ;Wire: ring# on parent-obj that 1stendwirelockedto.
nendring	BYTE	1 ;Wire: ring# on parent-obj that dest.end lockedto.
ncolour1	DWORD	0	;colour of label.
bez1x		SDWORD	0	;a bezier pt for drawing wire.
nfunctype	BYTE	0 ;0=not a func, 1=normal, 2=isr, 3=library.
nmemtype1	BYTE	0 ;.nfunctype--.nhierarchy->bez7.pt_y drawing wire.
nmemtype2	BYTE	0 ; /
nhierarchy	BYTE	0 ; /
ndatatype	BYTE	5	;S16
nptrtype	BYTE	1	;		     /
bez1y		SDWORD	0 ;a bezier pt for drawing wire.
nchildren	BYTE	0 ;node: # immediate child nodes attached.
nchildresources	BYTE	0 ;# resources attached to any element.
nring1colorindex BYTE	0 ;color 0--7 (ring1 of nodes) of element pen.
spare1d 	BYTE	0
nprimary	WORD	0 ;for isr funcs. these #s used in prototypes.
nsecondary	WORD	0 ;/
;everything above must remain same layout for all objects.
bez2x		SDWORD	0 ;bezier pts for drawing wire
bez2y		SDWORD	0 ; / (free for other elements)
bez6x		SDWORD	0 ;/
bez6y		SDWORD	0 ;/
bez7x		SDWORD	0 ;/ (note: bez7y is above)
spare99		SDWORD	0  ;byte before sztext1 must be 0, for text-find.
;offset 128 i think.
sztext1 	BYTE 64  DUP(0)
sztext2 	BYTE 64  DUP(0)
sztext3 	BYTE 64  DUP(0)
sztext4 	BYTE 64  DUP(0)
sztext5		BYTE 384 DUP(0)
sztext6 	BYTE 64  DUP(0)
sztext7 	BYTE 64  DUP(0)
sztext8 	BYTE 384 DUP(0)
OBJECT ENDS


;##################################################################
;this is the database. it has this format in the disk data file.
;the object-database is variable size.
;The complete TERSEDATA is a default template for a new data file,
;and everything here is copied to memory block.
NUMINITOBJS EQU 10               ;note, also defined in goosee_c.c
TERSEDATA STRUCT
nsignature   DWORD 0		    ;integrity check for database.
nversion     DWORD 10		    ;
nsizeobject  WORD (SIZEOF OBJECT)   ;
numobjects   WORD NUMINITOBJS,0	     ;number of objects in database.
				;(TOTAL, including null objects)
xleft	     DWORD 0		;	read-only, current top/left window.
ytop	     DWORD 0		;	  /
xright	  DWORD 0		; maybe bot/right coords of window?
ybot	  DWORD 0		; /
nzoom	     SBYTE 0		;	=0 normal, <0 in, >0 out.
hwindow1     DWORD 0		;
nproject     WORD 0	;number of the current diagram/project.
nsubproject  WORD 0	;number of current sub-diagram/project.
future1	 DWORD 0	;
future2	   DWORD 0		;
future3	     DWORD 0		;
future4    DWORD 0		;
future5	     DWORD 0		;
future6	     DWORD 0		;
 DB 200 DUP(0)      ;for future use.

    ;start of template for existing datafiles.
templatestart	BYTE 0
fgooseeprefs	BYTE 0		;
nindentation	BYTE 2	;=0 tab, else # spaces for a unit indentation.
fcodeprefs	BYTE 0
fviewprefs	BYTE 01000b ;bit1=1 whitespace on,bit0=1 color-codedrings on.
  DB 126 DUP(0)		;future space.
szexten      BYTE "C",0,0,0,0,0,0,0 ;file extension.
szprefix     BYTE "/*",0,0	    ;delimits start of comments.
szpostfix    BYTE "*/",0,0	    ;delimits end of comments.
szeditor     BYTE "NOTEPAD ",54 DUP(0)	;
future7      DWORD 0
nterseversion BYTE 0		    ;item# in terse config. dialog box.
szpre1	BYTE "data", 12+32 DUP(0)   ;each entry is 47+1 bytes.
szpre2	BYTE "idata",11+32 DUP(0)
szpre3	BYTE "bdata",11+32 DUP(0)
szpre4	BYTE "xdata",11+32 DUP(0)
szpre5	BYTE "pdata",11+32 DUP(0)
szpre6	BYTE "code", 12+32 DUP(0)
szpre7	BYTE 16+32 DUP(0)
szpre8	BYTE 16+32 DUP(0)
szpre9	BYTE 16+32 DUP(0)
szpre10	BYTE 16+32 DUP(0)
szpre11	BYTE 16+32 DUP(0)
szpre12	BYTE 16+32 DUP(0)
szpre13	BYTE 16+32 DUP(0)
szpre14	BYTE 16+32 DUP(0)
szpre15	BYTE 16+32 DUP(0)
szpre16	BYTE 16+32 DUP(0)
future8 DWORD 0
sztype1  BYTE	"bit",	13+32 DUP(0)	;each entry is 47+1 bytes.
sztype2  BYTE	"U8", 14+32 DUP(0)
sztype3  BYTE	"U16",13+32 DUP(0)
sztype4  BYTE	"U32",	13+32 DUP(0)
sztype5  BYTE	"S8", 14+32 DUP(0)
sztype6  BYTE	"S16", 13+32 DUP(0)
sztype7  BYTE	"S32",13+32 DUP(0)
sztype8  BYTE	"F32",13+32 DUP(0)
sztype9  BYTE	"F64",13+32 DUP(0)
sztype10 BYTE 16+32 DUP(0)
sztype11 BYTE 16+32 DUP(0)
sztype12 BYTE 16+32 DUP(0)
sztype13 BYTE 16+32 DUP(0)
sztype14 BYTE 16+32 DUP(0)
sztype15 BYTE 16+32 DUP(0)
sztype16 BYTE "reference",7+32 DUP(0)
future9  DWORD 0
szptrtype1  BYTE "RECT",    12+32 DUP(0) ;these are all structure types...
szptrtype2  BYTE "MSG",	   13+32 DUP(0)
szptrtype3  BYTE "PAINTSTRUCT",5+32 DUP(0)
szptrtype4  BYTE "WNDCLASS",8+32 DUP(0)
szptrtype5 BYTE 48 DUP(0)
szptrtype6 BYTE 48 DUP(0)
szptrtype7 BYTE 48 DUP(0)
szptrtype8  BYTE 16+32 DUP(0)
szptrtype9  BYTE 16+32 DUP(0)
szptrtype10 BYTE 16+32 DUP(0)
szptrtype11 BYTE 16+32 DUP(0)
szptrtype12 BYTE 16+32 DUP(0)
szptrtype13 BYTE 16+32 DUP(0)
szptrtype14 BYTE 16+32 DUP(0)
szptrtype15 BYTE 16+32 DUP(0)
szptrtype16 BYTE 16+32 DUP(0)
future10 BYTE 48*16 DUP(0)		;future

szgenprelim BYTE 2004 DUP(0)	 ;see szloadgenprelim

;function postfix (see language&editor dialog) ...
szpfunc1 DB "reentrant", 7+48 DUP(0)
szpfunc2 DB "interrupt 1", 5+48 DUP(0)
szpfunc3 DB 16+48 DUP(0)
szpfunc4 DB 16+48 DUP(0)
szpfunc5 DB 16+48 DUP(0)
szpfunc6 DB 16+48 DUP(0)
szpfunc7 DB 16+48 DUP(0)
szpfunc8 DB 16+48 DUP(0)

  BYTE 1024 DUP(0)	;future
szos1	 BYTE 96 DUP(0)	      ;768 bytes
szos2	 BYTE 96 DUP(0)
szos3	 BYTE 96 DUP(0)
szos4	 BYTE 96 DUP(0)
szosqual1 BYTE 96	DUP(0)
szosqual2 BYTE 96	DUP(0)
szosqual3 BYTE 96	DUP(0)
szosqual4 BYTE 96	DUP(0)

	BYTE 48 DUP(0)	;future use.
szfasync  DB "static bit fASYNC", 31 DUP(0) ;48 total.


  BYTE 4000	DUP(0)	    ;future expansion.
;end of template for existing data files.

OBJECTS OBJECT NUMINITOBJS DUP(<>)

TERSEDATA ENDS
;##################################################################
;(objects are instantiated after TERSEDATA).



;these (arbitrary) equates could have been in an include file...

;File menu ...
IDM_OPEN	EQU 107
IDM_TEMPLATE EQU 500
IDM_MERGE	EQU 501
IDM_SAVE        EQU 108
IDM_SAVEAS	EQU 109
IDM_ERASEDIA	EQU 361
IDM_PRA 	EQU 131
IDM_CPY 	EQU 165
IDM_QUIT	EQU 100
IDM_1CODE	EQU 253
IDM_PSET	EQU 254  ;printer setup.
IDM_DUP 	EQU 502
IDM_SAVEASS	EQU 510
IDM_SAVEASS_EMF EQU 511

;Objects menu ...
IDM_NODE	EQU 102
IDM_RES 	EQU 110
IDM_WIRE        EQU 103
IDM_WR		EQU 122
IDM_WRT		EQU 123
IDM_WN		EQU 124
IDM_WNT		EQU 125
IDM_WI		EQU 126
IDM_HARDWARE	EQU 128
IDM_JBUN	EQU 117
IDM_JBDN	EQU 118
IDM_COMMENT	EQU 166
IDM_ACTIONEXIT	EQU 499
IDM_SYNC2	EQU 104
IDM_ASYNC1	EQU 498
IDM_ASYNC2	EQU 497
IDM_S2T 	EQU 496
IDM_INTER	EQU 495
IDM_PTR	    EQU 503
IDM_STRUC    EQU	121
IDM_ARRAY    EQU	120
IDM_GENERIC  EQU	119
IDM_COMMANDICON EQU 504
IDM_INFOICON	EQU 505
IDM_MAKEICON	EQU 506


;Control menu ...
IDM_ZOOMNORM	EQU 116
IDM_ZOOMOUT	EQU 114
IDM_ZOOMIN	EQU 115
IDM_ORIGIN	EQU 164
IDM_SNAP	EQU 163
IDM_PROJECT	EQU 161
IDM_CONFIG	EQU 160
IDM_GENINSERT	EQU 182
IDM_OS		EQU 183
IDM_ABOUT	EQU 101
IDM_PREFS	EQU 184
IDM_TFIND	EQU 255
IDM_NFIND	EQU 256
IDM_RECT	EQU 507
IDM_MOVE	EQU 508
IDM_DELS	EQU 509

;KENTER1 dialog box (via Control/Language-and-editor...) ...
IDD_K1EXT	EQU	    204
IDD_K1COM	EQU	   205
IDD_K1EDIT	EQU	    206
IDD_K1PF	EQU	    296
IDD_TYPE1	EQU 311	;data type, kenter1.
IDD_TYPE2	EQU 312
IDD_TYPE3	EQU 313
IDD_TYPE4	EQU 314
IDD_TYPE5	EQU 315
IDD_TYPE6	EQU 316
IDD_TYPE7	EQU 317
IDD_TYPE8	EQU 318
IDD_TYPE9	EQU 319
IDD_TYPE10	EQU 320
IDD_TYPE11	EQU 321
IDD_TYPE12	EQU 322
IDD_TYPE13	EQU 323
IDD_TYPE14	EQU 324
IDD_TYPE15	EQU 325
IDD_TYPE16	EQU 326
;IDD_REF4   EQU	338
;IDD_REF5   EQU	339
;IDD_REF6   EQU	340
;IDD_REF7   EQU	341
;IDD_REF8   EQU	342
;IDD_REF9   EQU	343
;IDD_REF10  EQU	344
;IDD_REF11  EQU	345
;IDD_REF12  EQU	346
;IDD_REF13  EQU	347
;IDD_REF14  EQU	348
;IDD_REF15  EQU	349
IDD_PRE1   EQU	350
IDD_PRE2   EQU	351
IDD_PRE3   EQU	352
IDD_PRE4   EQU	353
IDD_PRE5   EQU	354
IDD_PRE6   EQU	355
IDD_PRE7   EQU	356
IDD_PRE8   EQU	357

;PROJECT management dialog box... (id=201)
IDD_PROJNUM    EQU  204
IDD_PROJSUBNUM EQU  205
IDD_DBASEVER   EQU  206

;Operating System dialog box (id=202)
IDD_OS1        EQU 204	;service for sync 1-way
IDD_OS2        EQU 205	;service for sync 2-way
IDD_OS3        EQU 206	;service for async 1-way
IDD_OS4        EQU 207	;service for async 2-way
IDD_OSQUAL1    EQU 208	;/
IDD_OSQUAL2    EQU 209	;/
IDD_OSQUAL3    EQU 210	;/
IDD_OSQUAL4    EQU 211	;/

;KENTER5 box...
;/*select font size...*/
K2F1   EQU 210
K2F15  EQU 211
K2F2   EQU	212
K2F4   EQU	213
;node fill color...*/
K5FC   EQU 220
K5NF   EQU 221
K5CF   EQU 222
;display node number...*/
KDNN   EQU 230
KDNONE EQU 231
;/* more stuff...*/
KXOFF  EQU 240
KYOFF  EQU 241
KSPEC  EQU 242
KSPF   EQU	243
KSPC   EQU	244
KSPD   EQU	245
KSPA   EQU	246
IDD_K5PU  EQU	302
IDD_INVIS EQU	303
IDM_RSUB  EQU	105
IDD_REPLYTYPE EQU	306
IDD_K2CHK1 EQU	    109
Kobjnum EQU 250
IDD_K2LABEL EQU	    102

IDM_CONDITION EQU 251
IDM_ACTION EQU 252
IDM_1CODE     EQU 253

IDM_INTEGRITY EQU 257



;funcs in goosee.asm...
ASMWNDPROC	PROTO	STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
wmdestroy	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmrbuttondown	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmlbuttonup 	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmmousemove 	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmsize		PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmcreate	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmlbuttondown	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmpaint		PROTO	STDCALL, :DWORD, :DWORD, :DWORD
wmcommand	PROTO	STDCALL, :DWORD, :DWORD, :DWORD
savedatafile	PROTO 	STDCALL
saveasdatafile	PROTO	STDCALL
selectedsaveasdatafile PROTO STDCALL
selectedsaveasemf PROTO STDCALL
opendatafile	PROTO	STDCALL
createnewobject   PROTO STDCALL, :DWORD
defaultnewnode	PROTO STDCALL, :DWORD
defaultnewcommand	PROTO STDCALL, :DWORD
defaultnewinfo	PROTO STDCALL, :DWORD
defaultnewmake	PROTO STDCALL, :DWORD
defaultnewres	PROTO STDCALL, :DWORD
defaultnewcondition	PROTO STDCALL, :DWORD
defaultnewaction	PROTO STDCALL, :DWORD
defaultnewhardware PROTO STDCALL, :DWORD
defaultnewcom	PROTO STDCALL, :DWORD	;new comment.
defaultnewwire	PROTO STDCALL, :DWORD	;new execution-flow wire.
defaultnewdatawire PROTO STDCALL, :DWORD ;new data-flow wire.
defaultnewexclusion	PROTO STDCALL, :DWORD  ;new mutual-exclusion wire.
add2wipeoutlist   PROTO STDCALL, :DWORD
add2updatelist    PROTO STDCALL, :DWORD
add2highlightedlist	  PROTO STDCALL, :DWORD
xuser		PROTO STDCALL, :DWORD, :DWORD, :DWORD
xuser1		PROTO STDCALL, :DWORD, :DWORD, :DWORD
xuser2		PROTO STDCALL, :DWORD, :DWORD, :DWORD
xuser4		PROTO STDCALL, :DWORD, :DWORD, :DWORD
;xsize		PROTO STDCALL, :DWORD, :DWORD, :DWORD
getprinterdetails PROTO STDCALL
xpaint_wipeout  PROTO STDCALL, :DWORD
xpaint_update   PROTO STDCALL, :DWORD
xpaint_entire   PROTO STDCALL, :DWORD
xpaint_extras   PROTO STDCALL, :DWORD
xpaint_print    PROTO STDCALL
TEXTOUTx  PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
isobjectinwindow PROTO STDCALL, :DWORD
origincorrection PROTO STDCALL, :DWORD
nearobjects      PROTO STDCALL, :DWORD
erasediagram     PROTO STDCALL
opentemplate     PROTO STDCALL
drawscrollbox    PROTO STDCALL, :DWORD
scrollingbymouse	 PROTO STDCALL, :DWORD, :DWORD
displaymouse     PROTO STDCALL, :DWORD, :DWORD
bin2dec          PROTO STDCALL
xtimer  PROTO STDCALL, :DWORD, :DWORD, :DWORD
xorigin 	 PROTO STDCALL
xdblclk 	PROTO STDCALL, :DWORD, :DWORD, :DWORD
bigmove 	 PROTO STDCALL
shoot		 PROTO STDCALL
openmerge	 PROTO STDCALL
str2longint	 PROTO STDCALL, :DWORD
onanobject	 PROTO STDCALL, :DWORD, :DWORD
xkeydown	PROTO STDCALL, :DWORD, :DWORD, :DWORD
xkeyup		PROTO STDCALL, :DWORD, :DWORD, :DWORD
updateslaves	 PROTO STDCALL, :DWORD, :DWORD, :DWORD
wipeoutslaves	 PROTO STDCALL, :DWORD
deleteslaves	 PROTO STDCALL, :DWORD
fixwiremid	 PROTO STDCALL, :DWORD, :DWORD
fixnewchild	 PROTO STDCALL, :DWORD, :DWORD
draw1starrow PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
draw2ndarrow PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
TESTDISPLAY  PROTO STDCALL, :DWORD
binto3dec    PROTO STDCALL, :DWORD
findifisr    PROTO STDCALL, :DWORD
insertring   PROTO STDCALL, :DWORD, :DWORD
deletering   PROTO STDCALL, :DWORD, :DWORD
openexternaleditor PROTO STDCALL, :DWORD
calcsig      PROTO STDCALL
findmaster   PROTO STDCALL, :DWORD
drawblobs    PROTO STDCALL, :DWORD, :DWORD
givenodeaname PROTO STDCALL, :DWORD
createdatawire PROTO STDCALL, :DWORD
snapclonewires PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
snapclonewires2 PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
wiresyntaxcheck PROTO STDCALL, :DWORD, :DWORD
wiresyntaxcheck0 PROTO STDCALL, :DWORD
openadiagram PROTO STDCALL, :DWORD
checkintegrity PROTO STDCALL, :DWORD
isitreturnwire PROTO STDCALL, :DWORD
duplicatehighlighted PROTO STDCALL
updateduplicates PROTO STDCALL
updatemove PROTO STDCALL
generatecode PROTO STDCALL
highlightinsiderect PROTO STDCALL
repositioncursor PROTO STDCALL
ishighlighted PROTO STDCALL, :DWORD
fixconc2nonconc PROTO STDCALL, :DWORD
fixnonconc2conc PROTO STDCALL, :DWORD, :DWORD, :DWORD


;this stuff needed to call methods...
displayPROTO TYPEDEF PROTO STDCALL, :DWORD, :DWORD   ;pdisplay
displayPTR   TYPEDEF PTR displayPROTO
dragPROTO    TYPEDEF PROTO STDCALL, :DWORD        ;pdrag
dragPTR      TYPEDEF PTR dragPROTO
deletePROTO   TYPEDEF PROTO STDCALL, :DWORD       ;pdelete
deletePTR	    TYPEDEF PTR deletePROTO
onPROTO      TYPEDEF PROTO STDCALL, :DWORD, :DWORD, :DWORD	 ;ponobject
onPTR	     TYPEDEF PTR onPROTO
wipePROTO    TYPEDEF PROTO STDCALL, :DWORD  ;pwipeslaves
wipePTR      TYPEDEF PTR wipePROTO
snapPROTO	TYPEDEF PROTO STDCALL, :DWORD, :DWORD, :DWORD	;psnap
snapPTR	    TYPEDEF PTR snapPROTO

;prototypes for the methods...
paint_node    PROTO STDCALL, :DWORD, :DWORD
paint_res     PROTO STDCALL, :DWORD, :DWORD
paint_arc	 PROTO STDCALL, :DWORD, :DWORD
paint_comp    PROTO STDCALL, :DWORD, :DWORD
paint_super   PROTO STDCALL, :DWORD, :DWORD
paint_jb      PROTO STDCALL, :DWORD, :DWORD
paint_cmt     PROTO STDCALL, :DWORD, :DWORD
paint_sub     PROTO STDCALL, :DWORD, :DWORD
paint_comp    PROTO STDCALL, :DWORD, :DWORD
paint_att     PROTO STDCALL, :DWORD, :DWORD
paint_fnc     PROTO STDCALL, :DWORD, :DWORD
paint_exec	  PROTO STDCALL, :DWORD, :DWORD
paint_info	  PROTO STDCALL, :DWORD, :DWORD
paint_make	  PROTO STDCALL, :DWORD, :DWORD
delete_node	PROTO STDCALL, :DWORD
delete_icon	PROTO STDCALL, :DWORD
delete_res	PROTO STDCALL, :DWORD
delete_any	PROTO STDCALL, :DWORD
delete_arc	PROTO STDCALL, :DWORD
delete_jb       PROTO STDCALL, :DWORD
delete_at       PROTO STDCALL, :DWORD
delete_sub      PROTO STDCALL, :DWORD
delete_fnc      PROTO STDCALL, :DWORD
drag_node       PROTO STDCALL, :DWORD
drag_arc        PROTO STDCALL, :DWORD
drag_super      PROTO STDCALL, :DWORD
drag_sub        PROTO STDCALL, :DWORD
on_node	PROTO STDCALL, :DWORD, :DWORD, :DWORD
on_cmt	PROTO STDCALL, :DWORD, :DWORD, :DWORD
on_res	PROTO STDCALL, :DWORD, :DWORD, :DWORD
on_arc	PROTO STDCALL, :DWORD, :DWORD, :DWORD
on_super	PROTO STDCALL, :DWORD, :DWORD, :DWORD
on_fnc	PROTO STDCALL, :DWORD, :DWORD, :DWORD
on_any	PROTO STDCALL, :DWORD, :DWORD, :DWORD
wipeslaves_node	PROTO STDCALL, :DWORD
wipeslaves_gen	PROTO STDCALL, :DWORD
snap_tonode	PROTO STDCALL, :DWORD, :DWORD, :DWORD
snap_tores	PROTO STDCALL, :DWORD, :DWORD, :DWORD
snap_gen	PROTO STDCALL, :DWORD, :DWORD, :DWORD
snap_toany	PROTO STDCALL, :DWORD, :DWORD, :DWORD


;functions used in GOO2C.ASM...
composenode  PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
composenodedata PROTO STDCALL,:DWORD,:DWORD,:DWORD
findactionwire PROTO STDCALL, :DWORD, :DWORD
composeprototypes PROTO STDCALL, :DWORD, :DWORD, :DWORD
composepassed	PROTO STDCALL, :DWORD
; gen1code PROTO STDCALL, :DWORD
genmanycode PROTO STDCALL, :DWORD
find1stnode	 PROTO STDCALL, :DWORD, :DWORD
findchild	 PROTO STDCALL, :DWORD, :DWORD
binto5dec	 PROTO STDCALL, :DWORD
findinnerinwire	 PROTO STDCALL, :DWORD, :DWORD
composepointer1	PROTO STDCALL, :DWORD, :DWORD, :DWORD
composeglobaldata PROTO STDCALL, :DWORD, :DWORD
composefuncdefinition	PROTO STDCALL, :DWORD, :DWORD, :DWORD
mergestrings	PROTO STDCALL, :DWORD, :DWORD, :DWORD
compose1ringconditions PROTO STDCALL, :DWORD, :DWORD
findinterwire	PROTO STDCALL, :DWORD, :DWORD
findactionwire	PROTO STDCALL, :DWORD, :DWORD
composeblock	PROTO STDCALL, :DWORD, :DWORD
composepathfromring	PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
findreentryring 	PROTO STDCALL, :DWORD, :DWORD, :DWORD, :DWORD
findoutwire	PROTO STDCALL, :DWORD, :DWORD
composecondition PROTO STDCALL, :DWORD, :DWORD
assignasyncnumber PROTO STDCALL, :DWORD
checkwireor	PROTO STDCALL, :DWORD, :DWORD, :DWORD
findsignalout	PROTO STDCALL, :DWORD, :DWORD
findcondition	PROTO STDCALL, :DWORD, :DWORD
composeprimitivevar PROTO STDCALL,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
composeprimitivearray PROTO STDCALL,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
composearrayofpointers PROTO STDCALL,:DWORD,:DWORD,:DWORD,:DWORD
indentation PROTO STDCALL, :DWORD, :DWORD
findtexticon PROTO STDCALL, :DWORD
composeinclude PROTO STDCALL, :DWORD, :DWORD

;------------------------------------
;c functions called from asm...


;public variables in goosee.asm, accessable from goosee_c.c...
;PUBLIC instantiatedOBJECT, instantiatedTERSEDATA;
PUBLIC pTERSEDATA
PUBLIC highlightedindex
PUBLIC n1stx	    ;selection rectangle.
PUBLIC n1sty	    ;/
PUBLIC n2ndx	    ;/
PUBLIC n2ndy	    ;/



;NOTES
;
;PAINTING
;--------
;To display or print an object, the calls go like this:
;WM_PAINT msg --> wmpaint() --> xpaint_entire/update/wipeout/print()
; --> paint_node/*etc*.
;Different size fonts are created in wmpaint()
;a font is assigned, a brush and/or pen is created & assigned, before
;calling each display method.
;paint_node/etc() are the methods. A change from oldgoofee, is I
;want to avoid creating and assigning fonts/brushes/pens inside these.
;
;NEW OBJECT
;----------
;From the menu, select an object, say IDM_NODE. Must be state=0.
;IDM_NODE --> createnewobject() --> defaultnewnode() --> state=4,
;g_pmovingobject pts to new node.
;createnewobject() creates a generic object.
;defaultnewnode() sets up the fields of OBJECT structure appropriate
;for a node.
;wmmousemove() tests state, if =4, displays new object, tracking the
;mouse.

;SUMMARY OF STATES:
;-----------------
;0      normal
;1      newly-selected object                        must come from 0.
;2      highlighted object                           must come from 1
;4      new object from menu, being placed.          must come from 0
;5      new object from menu, other-end being placed.must come from 4
;8	moving object (also wire ends)		     must come from 1 (or 2)

;20	drawing a selection-rectangle, 1st corner
;21	"   2nd corner.

;In states 4,5 & 8, the object is identified by pmovingobject (& pmoving).
;in state 1, object is identified by g_pselectedobjectnew.
;in state 2, object is identified by g_phighlightedobject.
;in state 0, rbuttondown on an object is identified by rbuttonobject.

;FONT TYPES
;----------
;On date 12-1-00 I changed the standard size font used in the diagram
;to Times New Roman. This scales up and down better than the previous
; MS Serif, which is non-TrueType.
;However, Times New Roman displays slightly lower. I've gone thru and
;shifted everything up 1 pixel. and marked it "12-1-00" so can go back
;quickly if it needs changing again.

;ELEMENT TYPES
;-------------
;
; .nexttype  type of element
;  -1	     invisible data object.
;  0	     node.
;  3*	     data, private (.fconfig/bits 6/5=0/0 permanent, =0/1 temporary)
;  4	     data, shareable (6/5=0/0 shareable, 7/6/5=1/0/1 shareable temp
;	       -orary, 6/5=0/1 file-visible, 6/5=1/0 public-visible.
;	       .fstatus/bit 7=1 external).
;  9	     node, library function.
; 10	     wire, execution-flow 1-way.
; 11	     wire,	   "        2-way.
; 12	     wire,	   "         "	  + timeout.
; 13	     wire, signal async 1-way.
; 14	     wire, signal async 2-way.
; 15	     wire, i/o dataflow.
; 17	     wire, interrupt dataflow.	 "
; 22	     wire, mutual-exclusion. <<not implemented.
; 30	     comment.
; 32	     condition.
; 33	     action.
;
;
; 50	     hardware, private (.fconfig/bits 6/5=0/0).   <<not implemented.
; 51	     hardware, shareable (6/5=0/0 shareable, 6/5=0/1 file
;	       -visible, 6/5=1/0 public-visible)	  <<not implemented.
; 60	     icon, execution.
; 61	     icon, text-file.
; 62	     icon, make.


; * when create new array, structure, pointer, generic, they have
;   .nexttype=3, but .fstatus2/bits 7/6/5 select which of these.
