#include <windows.h>

//###############################################################
//equates, extern, prototype declarations...

//equates...
#define AND &
#define OR |
typedef unsigned int U32;
typedef int S32;
typedef unsigned short int U16;
typedef short int S16;
typedef char S8;
typedef unsigned char U8;

//data...
struct OBJECT {
       U8 fstatus;     //bit0=0 invalid object,bit0=1 valid.
       U8 fstatus2;
       U8 fconfig;     //0=node,1=wire (see exttype also).
       U8 fconfig2;
       U16 nexttype;	//WORD	0	;sub-type of obj(see end this file...)
       U16 number;		//WORD	1	;number, starting from 1, of this object.
       U16 nfile;		//WORD	1  ;File that this object is allocated to.
       U8 nrings;		//BYTE	1	;number of rings(default 1).
       U8 fconfig3;      //BYTE	0
       U32 rpmethods;	//DWORD	0	;-->methods.
       //;relative to "ptrs", which is start of the methods.
       S8 spare10; 	    //BYTE	0
       S16 spare11; 	//WORD	0
       U8 fdata;		//BYTE	0	;type of data held by additional data.
       U32 rpdata;		//DWORD	0	;-->additional data.(in object database)
       U32 rpmaster;	//DWORD	0	;master-object at end of parent chain.
       U32 rplock1;		//DWORD	0	;object that this object locked-to.
       U32 rplock2;		//DWORD	0	; ditto (useful for other-end of wire)
       //;null or data objects can have data past here ...
       S32 xtopleft;	//SDWORD	0	;topleft coords
       S32 ytopleft;	//SDWORD	0	;/
       S32 wwidth;		//SDWORD	0	;node: wwidth&height, arc:destination-end
       S32 height;		//SDWORD	0	;/			   coords.
       S32 xmid;		//SDWORD	0	;absolute middle coords
       S32 ymid;		//SDWORD	0	; /
       S32 xknee2;		//SDWORD	0	;2nd knee on wire. node: .xdeltacentre
       S32 yknee2;		//SDWORD	0	;/			 .ydeltacentre
       S32 xknee3;		//SDWORD	0	;3rd knee	   node: .nringwidth
       S32 yknee3;		//SDWORD	0	;/
       S16 xlabeloffset;	//SWORD	0	;move label from default position.
       S16 ylabeloffset;	//SWORD	0	; /
       U8 nbeginring;	//BYTE	1 ;Wire: ring# on parent-obj that 1stendwirelockedto.
       U8 nendring;	    //BYTE	1 ;Wire: ring# on parent-obj that dest.end lockedto.
       U32 ncolour1;	//DWORD	0	;colour of label.
       S32 bez1x;		//SDWORD	0	;a bezier pt for drawing wire.
       U8 nfunctype;	//BYTE	0 ;0=not a func, 1=normal, 2=isr, 3=library.
       U8 nmemtype1;	//BYTE	0 ;.nfunctype--.nhierarchy->bez7.pt_y drawing wire.
       U8 nmemtype2;	//BYTE	0 ; /
       U8 nhierarchy;	//BYTE	0 ; /
       U8 ndatatype;	//BYTE	5	;S16
       U8 nptrtype;	    //BYTE	1	;		     /
       S32 bez1y;		//SDWORD	0 ;a bezier pt for drawing wire.
       U8 nchildren;	//BYTE	0 ;node: # immediate child nodes attached.
       U8 nchildresources;	//BYTE	0 ;# resources attached to any element.
       U8 nring1colorindex; //BYTE	0 ;color 0--7 (ring1 of nodes) of element pen.
       S8 spare1d; 	    //BYTE	0
       U16 nprimary;	//WORD	0 ;for isr funcs. these #s used in prototypes.
       U16 nsecondary;	//WORD	0 ;/
       //;everything above must remain same layout for all objects.
       S32 bez2x;		//SDWORD	0 ;bezier pts for drawing wire
       S32 bez2y;		//SDWORD	0 ; / (free for other elements)
       S32 bez6x;		//SDWORD	0 ;/
       S32 bez6y;		//SDWORD	0 ;/
       S32 bez7x;		//SDWORD	0 ;/ (note: bez7y is above)
       S32 spare99;		//SDWORD	0  ;byte before sztext1 must be 0, for text-find.
       //;offset 128 i think.
       U8 sztext1[64]; 	//BYTE 64  DUP(0)
       U8 sztext2[64]; 	//BYTE 64  DUP(0)
       U8 sztext3[64]; 	//BYTE 64  DUP(0)
       U8 sztext4[64]; 	//BYTE 64  DUP(0)
       U8 sztext5[384];		//BYTE 384 DUP(0)
       U8 sztext6[64]; 	//BYTE 64  DUP(0)
       U8 sztext7[64]; 	//BYTE 64  DUP(0)
       U8 sztext8[384]; 	//BYTE 384 DUP(0)
       };

#define NUMINITOBJS 10  //note, also defined in goosee.inc.
struct TERSEDATA {
       U32 nsignature;   //DWORD 0		    ;integrity check for database.
       U32 nversion;     //DWORD 10		    ;
       U16 nsizeobject;  //WORD (SIZEOF OBJECT)   ;
       U16 numobjects,numobjshi;   //WORD NUMINITOBJS,0	     ;number of objects in database.
				//;(TOTAL, including null objects)
       S32 xleft;	     //DWORD 0		;	read-only, current top/left window.
       S32 ytop;	     //DWORD 0		;	  /
       S32 xright;	  //DWORD 0		; maybe bot/right coords of window?
       S32 ybot;	  //DWORD 0		; /
       S8 nzoom;	     //SBYTE 0		;	=0 normal, <0 in, >0 out.
       U32 hwindow1;     //DWORD 0		;
       U16 nproject;     //WORD 0	;number of the current diagram/project.
       U16 nsubproject;  //WORD 0	;number of current sub-diagram/project.
       U32 future1;	 //DWORD 0	;
       U32 future2;	   //DWORD 0		;
       U32 future3;	     //DWORD 0		;
       U32 future4;    //DWORD 0		;
       U32 future5;	     //DWORD 0		;
       U32 future6;	     //DWORD 0		;
       U8 fff[200];      //DB 200 DUP(0)      ;for future use.
       //    ;start of template for existing datafiles.
      U8 templatestart;	//BYTE 0
      U8 fgooseeprefs;	//BYTE 0		;
      U8 nindentation;	//BYTE 2	;=0 tab, else # spaces for a unit indentation.
      U8 fcodeprefs;	//BYTE 0
      U8 fviewprefs;	//BYTE 01000b ;bit1=1 whitespace on,bit0=1 color-codedrings on.
      S8 uuu[126];      //DB 126 DUP(0)		;future space.
      U8 szexten[8];      //BYTE "C",0,0,0,0,0,0,0 ;file extension.
      U8 szprefix[4];     //BYTE "/*",0,0	    ;delimits start of comments.
      U8 szpostfix[4];    //BYTE "*/",0,0	    ;delimits end of comments.
      U8 szeditor[62];     //BYTE "NOTEPAD ",54 DUP(0)	;
      S32 future7;      //DWORD 0
      U8 nterseversion; //BYTE 0		    ;item# in terse config. dialog box.
      U8 szpre1[48];	//BYTE "data", 12+32 DUP(0)   ;each entry is 47+1 bytes.
      U8 szpre2[48];	//BYTE "idata",11+32 DUP(0)
      U8 szpre3[48];	//BYTE "bdata",11+32 DUP(0)
      U8 szpre4[48];	//BYTE "xdata",11+32 DUP(0)
      U8 szpre5[48];	//BYTE "pdata",11+32 DUP(0)
      U8 szpre6[48];	//BYTE "code", 12+32 DUP(0)
      U8 szpre7[48];	//BYTE 16+32 DUP(0)
      U8 szpre8[48];	//BYTE 16+32 DUP(0)
      U8 szpre9[48];	//BYTE 16+32 DUP(0)
      U8 szpre10[48];	//BYTE 16+32 DUP(0)
      U8 szpre11[48];	//BYTE 16+32 DUP(0)
      U8 szpre12[48];	//BYTE 16+32 DUP(0)
      U8 szpre13[48];	//BYTE 16+32 DUP(0)
      U8 szpre14[48];	//BYTE 16+32 DUP(0)
      U8 szpre15[48];	//BYTE 16+32 DUP(0)
      U8 szpre16[48];	//BYTE 16+32 DUP(0)
      U32 future8;      //DWORD 0
      U8 sztype1[48];   //BYTE	"bit",	13+32 DUP(0)	;each entry is 47+1 bytes.
      U8 sztype2[48];   //BYTE	"U8", 14+32 DUP(0)
      U8 sztype3[48];  //BYTE	"U16",13+32 DUP(0)
      U8 sztype4[48];  //BYTE	"U32",	13+32 DUP(0)
      U8 sztype5[48];  //BYTE	"S8", 14+32 DUP(0)
      U8 sztype6[48];  //BYTE	"S16", 13+32 DUP(0)
      U8 sztype7[48];  //BYTE	"S32",13+32 DUP(0)
      U8 sztype8[48];  //BYTE	"F32",13+32 DUP(0)
      U8 sztype9[48];  //BYTE	"F64",13+32 DUP(0)
      U8 sztype10[48]; //BYTE 16+32 DUP(0)
      U8 sztype11[48]; //BYTE 16+32 DUP(0)
      U8 sztype12[48]; //BYTE 16+32 DUP(0)
      U8 sztype13[48]; //BYTE 16+32 DUP(0)
      U8 sztype14[48]; //BYTE 16+32 DUP(0)
      U8 sztype15[48];  //BYTE 16+32 DUP(0)
      U8 sztype16[48]; //BYTE "reference",7+32 DUP(0)
      U32 future9;  //DWORD 0
      U8 szptrtype1[48];  //BYTE "RECT",    12+32 DUP(0) ;these are all structure types...
      U8 szptrtype2[48];  //BYTE "MSG",	   13+32 DUP(0)
      U8 szptrtype3[48];  //BYTE "PAINTSTRUCT",5+32 DUP(0)
      U8 szptrtype4[48];  //BYTE "WNDCLASS",8+32 DUP(0)
      U8 szptrtype5[48]; //BYTE 48 DUP(0)
      U8 szptrtype6[48]; //BYTE 48 DUP(0)
      U8 szptrtype7[48]; //BYTE 48 DUP(0)
      U8 szptrtype8[48];  //BYTE 16+32 DUP(0)
      U8 szptrtype9[48];  //BYTE 16+32 DUP(0)
      U8 szptrtype10[48]; //BYTE 16+32 DUP(0)
      U8 szptrtype11[48]; //BYTE 16+32 DUP(0)
      U8 szptrtype12[48]; //BYTE 16+32 DUP(0)
      U8 szptrtype13[48]; //BYTE 16+32 DUP(0)
      U8 szptrtype14[48]; //BYTE 16+32 DUP(0)
      U8 szptrtype15[48]; //BYTE 16+32 DUP(0)
      U8 szptrtype16[48]; //BYTE 16+32 DUP(0)
      U8 future10[48*16]; //BYTE 48*16 DUP(0)		;future

      U8 szgenprelim[2004]; //BYTE 2004 DUP(0)	 ;see szloadgenprelim

      //;function postfix (see language&editor dialog) ...
      U8 szpfunc1[64]; //DB "reentrant", 7+48 DUP(0)
      U8 szpfunc2[64]; //DB "interrupt 1", 5+48 DUP(0)
      U8 szpfunc3[64]; //DB 16+48 DUP(0)
      U8 szpfunc4[64]; //DB 16+48 DUP(0)
      U8 szpfunc5[64]; //DB 16+48 DUP(0)
      U8 szpfunc6[64]; //DB 16+48 DUP(0)
      U8 szpfunc7[64]; //DB 16+48 DUP(0)
      U8 szpfunc8[64]; //DB 16+48 DUP(0)

      S8 vvv[1024]; //BYTE 1024 DUP(0)	;future
      U8 szos1[96];	 //BYTE 96 DUP(0)	      ;768 bytes
      U8 szos2[96];	 //BYTE 96 DUP(0)
      U8 szos3[96];	 //BYTE 96 DUP(0)
      U8 szos4[96];	 //BYTE 96 DUP(0)
      U8 szosqual1[96]; //BYTE 96	DUP(0)
      U8 szosqual2[96]; //BYTE 96	DUP(0)
      U8 szosqual3[96]; //BYTE 96	DUP(0)
      U8 szosqual4[96]; //BYTE 96	DUP(0)

      S8 qqq[48];  //BYTE 48 DUP(0)	;future use.
      U8 szfasync[48];  //DB "static bit fASYNC", 31 DUP(0) ;48 total.

      S8 aaa[4000];  //BYTE 4000	DUP(0)	    ;future expansion.
      //;end of template for existing data files.

       struct OBJECT OBJECTS[NUMINITOBJS];
       };

extern struct TERSEDATA *pTERSEDATA;
extern S32 n1stx;	    //selection rectangle.
extern S32 n1sty;	    //
extern S32 n2ndx;	    //
extern S32 n2ndy;	    //

//prototypes...
extern void STDCALL add2highlightedlist(struct OBJECT*);


//###############################################################
//new c functions called from goosee.asm...


//###############################################################
//goosee c files converted from goosee.asm...

//--------------------------------------------------------
//highlightinsiderect PROC STDCALL USES ebx ecx edx esi edi
//    LOCAL xadiff:DWORD,yadiff:DWORD
//    LOCAL ecxsave:DWORD,esisave:DWORD,edisave:DWORD
//    LOCAL xleft:DWORD,xright:DWORD,ytop:DWORD,ybot:DWORD
//; "highlightinsiderect"
//;"control/selection rectangle" -->IDM_RECT-->g_nstate=20
//; -->wmlbuttondown, set 1st corner, g_nstate=21
//; -->wmmousemove,track 2nd corner,g_nstate=22
//; -->wmlbuttonup, set 2nd corner, call highlightinsiderect().
//; n1stx,n1sty=1st corner, n2ndx,n2ndy=2nd corner.

void STDCALL highlightinsiderect(void) {
    S32 xadiff,yadiff,xleft,xright,ytop,ybot;
    struct OBJECT *pobject;
    U32 i;

//    ;find which corner is top-left, which bot-right...
//    mov eax,n1stx
//    mov ebx,n2ndx
//    .IF SDWORD PTR eax<ebx
//	mov xleft,eax
//	mov eax,n2ndx
//	mov xright,eax
//    .ELSE
//	mov xright,eax
//	mov eax,n2ndx
//	mov xleft,eax
//    .ENDIF

    if( (S32) n1stx<n2ndx) {
	xleft=n1stx; xright=n2ndx;
    }
    else {
	xright=n1stx; xleft=n2ndx;
    }

//    mov eax,n1sty
//    mov ebx,n2ndy
//    .IF SDWORD PTR eax<ebx
//	mov ytop,eax
//	mov eax,n2ndy
//	mov ybot,eax
//    .ELSE
//	mov ybot,eax
//	mov eax,n2ndy
//	mov ytop,eax
//    .ENDIF

    if( (S32) n1sty<n2ndy) {
	ytop=n1sty; ybot=n2ndy;
    }
    else {
	ybot=n1sty; ytop=n2ndy;
    }

//    mov eax,xright
//    sub eax,xleft
//    mov xadiff,eax   ;always +ve.
//    mov eax,ybot
//    sub eax,ytop
//    mov yadiff,eax   ;always +ve.

    xadiff=xright-xleft;
    yadiff=ybot-ytop;

//	mov edi,pTERSEDATA
//	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
//	xor ecx,ecx
//	mov cx,(TERSEDATA PTR [edi]).numobjects
//	  .IF cx==0 ;empty.
//	    jmp kf4
//	  .ENDIF

    pobject= (struct OBJECT*) &(pTERSEDATA->OBJECTS);
    if(pTERSEDATA->numobjects==0) {
      n1stx=0;
      n1sty=0;
      n2ndx=0;
      n2ndy=0;
      return;
    }


//	;as we loop around, edi->start of TERSEDATA, esi->current object...
//nextobj:
//	mov esisave,esi
//	mov edisave,edi
//	mov ecxsave,ecx
//	xor eax,eax
//	mov al,(OBJECT PTR [esi]).fstatus
//	and ax,01
//	  .IF ax==01	;bit0=1, valid object.
//	    mov ax,(OBJECT PTR [esi]).nexttype
//	    .IF ax==-1
//	    .ELSE		;not a data object.
//	      ;is it inside rectangle?...
//
//	      mov eax,(OBJECT PTR [esi]).xmid
//	      mov edx,(OBJECT PTR [esi]).ymid
//	      mov ecx,xleft
//	      .IF SDWORD PTR eax>ecx	;in left side?
//		mov ecx,xright
//		.IF SDWORD PTR eax<ecx ;in right side?
//		  mov ecx,ytop
//		  .IF SDWORD PTR edx>ecx	;in top side?
//		    mov ecx,ybot
//		    .IF SDWORD PTR edx<ecx
//		      ;success! object is inside rectangle.
//		      or (OBJECT PTR [esi]).fconfig2,10000000b ;set bit7.
//		      invoke add2highlightedlist,esi
//		    .ENDIF
//		  .ENDIF
//		.ENDIF
//	      .ENDIF
//
//	    .ENDIF
//	  .ENDIF
//kf1:	mov ecx,ecxsave
//	mov edi,edisave
//	mov esi,esisave
//	xor eax,eax
//	mov ax,(TERSEDATA PTR [edi]).nsizeobject
//	add esi,eax		;addr of next object.
//	loop kf3 ;nextobj
//	jmp SHORT kf4
//kf3:	jmp nextobj

    for(i=0; i<pTERSEDATA->numobjects; i++) {
      if(pobject->fstatus AND 01) {         //test if valid object.
        if(pobject->nexttype==0xFFFF) ;     //-1  =data object
        else {	//not a data object.
        //is it inside rectangle?...
	      if( (S32) pobject->xmid>xleft) { //in left side?
	        if( (S32) pobject->xmid<xright) { //in right side?
              if( (S32) pobject->ymid>ytop) { //in top side?
                if( (S32) pobject->ymid<ybot) { //in bottom side?
		          //success! object is inside rectangle
		          pobject->fconfig2=pobject->fconfig2 OR 0x80; //set bit7
		          add2highlightedlist(pobject);
		        }
		      }
            }
          }
        }
      }
//      pobject=pobject+pTERSEDATA->nsizeobject; NO, careful, just add 1...
      pobject++;
    }

//kf4:
//    mov n1stx,0
//    mov n1sty,0
//    mov n2ndx,0
//    mov n2ndy,0
//    ret

    n1stx=0;
    n1sty=0;
    n2ndx=0;
    n2ndy=0;
    return;
}
//highlightinsiderect ENDP
//;--------------------------------------------------------------------------

