;this is the code for generating C code from GOOSEE diagrams.
;goosee.asm has a "#include goo2c.asm" at the end of the file.

;***NOTE***
;in goofee, XNUMCIRC was max allowed number of nodes.
;for goosee, this could be anything. subtable uses
;this for size of a table. i could just make it some high figure...
;actually, only store function-nodes in subtable, so 1000 looks ok...
XXNUMCIRC EQU 1000
XNUMCIRC EQU 2000
SZSCR3LIMIT EQU 4000

;------------------------------------------------------------------------
.DATA?
xsubtable DWORD XXNUMCIRC DUP(?) ;temp table (see composeprototypes()).
subtable DWORD XNUMCIRC DUP(?)	;ptrs to all nodes in subdiag.
szscr1	   DB 1024 DUP(?)	;holds prototypes.  ;was 576
szscr2	   DB 128 DUP(?) ;
szscr3	   DB 900 DUP(?) ;holds if statements for a node.
	   DB SZSCR3LIMIT DUP(?)
;...total size of these has to be >=2000, to hold szgenprelim.
;...SZSCR3LIMIT is 4000. composepathfromring() composes to szscr3,
;and for inline nesting, may need lots of space.


.DATA
szhashinc BYTE "#include ",34,0	;"34" is double-quote char.
g_nlevel    DWORD 0	;# units of indentation req'd.
fsinglemode BYTE 0
g_poutinter  DWORD 0		;pts to inter-thread o/p sync wire.
g_pininter  DWORD 0		;pts to interthread i/p sync wire.
clone	  DWORD 0		;place of clone in JB chain. =0 master.
psubtable DWORD 0		;pts to next entry in subtable.
pxsubtable DWORD 0	;ptr, xsubtable (see composeprototypes()).

;yes, we use this...
SIZECOND  EQU 64	;allows 64 rings max on a node.
pnocondwire DWORD 0
nocondwire DB SIZECOND DUP(0)  ;which rings don't have conditions.
pr1wire   DWORD 0	;pts to entire wire object, i/p to ring1 of node.
szgenfile BYTE 64 DUP(0) ;290900 was 32 bytes

szstatic DB "static",0
szgener5  BYTE "The 1-thread sub-diagram is only allowed to have a"
	  BYTE " maximum of "
szgen5	  BYTE "00000 functions. Inline-code nodes are in addition to "
	  BYTE "this. GOOSEE has aborted C code generation.",0
szgenerr  DB "ERROR: A node has more than 1 synchronous input wire to same ring."
	  DB " Delete or snap it to same terminal (physical position) as other wire "
	  DB "-- the latter is referred to as ""wired-OR"" "
	  DB " (warning: wired-OR will result in unstructured code).",0
szgener3  DB "A node has more than 1 synchronous output wire from the same ring. "
	  DB "GOOSEE has highlighted the offending node.",0
szgener6zz  BYTE "An execution-flow wire exiting from a ring>1 has a "
	    BYTE "destination at a ring-number greater than one on a "
	    BYTE "different node. This is an illegal construction. "
	    BYTE "If you are getting this error message, GOOSEE failed "
	    BYTE "in the job of visual-syntax checking earlier-on.",0Dh,0Ah
	    BYTE "Contact the software author, Barry Kauler, with all "
	    BYTE "details.",0Dh,0Ah
	    BYTE "GOOSEE has aborted C code generation and has highlighted "
	    BYTE "the offending wire.",0
;  szfasync  DB "static bit fASYNC;",0Dh,0Ah,0
szlooper1   BYTE "A wire out-of ring 1 may not loop back "
	    BYTE "to same node.",0Dh,0Ah
	    BYTE "GOOSEE has aborted C code generation and has highlighted "
	    BYTE "the offending wire.",0

szferr1   DB "ERROR: Unable to open output file.",0
szferr2   DB "ERROR: Unable to write to output file.",0
szsubger1 DB "ERROR: Too many global resources in sub-diagram.",0
szhdr1	  DB "/* C code generated for node labeled ",34,0
szhdr2	  DB "/* by GOOSEE, www4.tpg.com.au/users/void/gooseeuser */",0Dh,0Ah
	  DB 0Dh,0Ah,0
szhdr3	  DB "/* GOOSEE diagram filename: ",0
szofffile DB "/* This function is external and has it's own GOOSEE diagram. */",0Dh,0Ah
	  BYTE "/* This diagram may be opened by double-clicking on the node. */",0Dh,0Ah
	  BYTE "/* Refer to GOOSEE diagram ",0
szfunclabel DB "/*--------------",0
szfunclabel2 DB "----------------*/",0Dh,0Ah,0
szer182b  BYTE "GOOSEE cannot generate C code for this node. You have "
	  BYTE "set its double-click action to either ""open a child diagram"" "
	  BYTE "or ""execute a command"".",0Dh,0Ah
	  BYTE "Go into the node's dialog box and set double-click "
	  BYTE "action to either ""automatic naming of file"" (the default) or "
	  BYTE """custom filename"". If you check the latter option, you "
	  BYTE "must also enter the desired filename into the ""Filespec"" "
	  BYTE "edit-box -- this will be the name assigned to the generated "
	  BYTE "C file.",0
szer182c  BYTE "GOOSEE cannot generate C code for this node. You have "
	  BYTE "set its double-click action to ""custom filename"", "
	  BYTE "however you haven't entered a filename into the "
	  BYTE """Filespec"" edit box. Please go into the node's dialog "
	  BYTE "box and correct this.",0

;*NOTE* the above were originally used in gen1code(), now used
;by genmanycode().

.CODE
;------------------------------------------------------------------------
.DATA
szerne2x  BYTE "The ""Filespec"" editbox of a text-file icon does "
	  BYTE "not specify a "
	  BYTE "text-file that exists or maybe the path is wrong."
	  BYTE "Code generation will continue, but you will need to "
	  BYTE "fix the offending text-file icon to avoid this "
	  BYTE "error message.",0

.CODE
composeinclude PROC STDCALL USES eax ebx ecx edx esi edi, \
      pcnode:DWORD, genhandle:DWORD
    LOCAL ptexticon:DWORD
    LOCAL nbytes:DWORD,hfile:DWORD
; "composeinclude"
;compose "#include "filespec"", where filespec is in an attached
;text-file icon. if no attached icon, returns without composing.
  mov esi,pcnode
  invoke findtexticon, esi ;returns eax-->icon, else =0.
  .IF  eax==0
  .ELSE
    mov ptexticon,eax
    mov ebx,eax
    ;there are 3 possible insertion modes...
    mov al,(OBJECT PTR [ebx]).fconfig2
    and al,01110000b	;extract bits 4/5/6.
    .IF al==00010000b	;insert #include.
jj:   ;compose "#include ""....
      lea eax,szhashinc
      invoke lstrcpy, ADDR szscr1,eax
      invoke lstrlen, ADDR szscr1
      lea ecx,szscr1
      add ecx,eax
      ;compose filespec...
      mov ebx,ptexticon
      lea eax,(OBJECT PTR [ebx]).sztext2 ;filespec field in text icon.
      invoke lstrcpy, ecx,eax
      invoke lstrlen, ADDR szscr1
      lea ebx,szscr1
      add ebx,eax
      mov [ebx],BYTE PTR 34   ;double-quote char.
      inc ebx
      mov	[ebx],BYTE PTR 0Dh
      inc ebx
      mov	[ebx],BYTE PTR 0Ah
      inc ebx
      mov	[ebx],BYTE PTR 0Dh
      inc ebx
      mov	[ebx],BYTE PTR 0Ah
      inc ebx
      mov	[ebx],BYTE PTR 0
      add	eax,5
      mov ebx,eax
      invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
    .ELSEIF al==00100000b   ;insert file.
      mov ebx,ptexticon
      lea ecx,(OBJECT PTR [ebx]).sztext2 ;filespec
	  invoke CreateFile, ecx,\
		GENERIC_READ,\
		FILE_SHARE_READ,\
		0, OPEN_EXISTING,\	;opens an existing file.
		0, 0
	  .IF eax==INVALID_HANDLE_VALUE	;-1
	    ;open failed ...
	    lea eax,szerne2x		;msg error opening file.
	    invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	    mov eax,ptexticon
	    mov g_perrorobject,eax
	    xor eax,eax
	    ret
	  .ENDIF
	  mov hfile,eax
	  ;now copy the file...
	  invoke GetFileSize, hfile,0
	  mov ecx,eax
jjx:	  push ecx
	  invoke ReadFile,hfile,ADDR szscr1,1,ADDR nbytes,0
	  invoke WriteFile,genhandle,ADDR szscr1,1,ADDR nbytes,0
	  pop ecx
	  loop jjx
	    mov szscr1,BYTE PTR 0Dh
	    mov szscr1+1,BYTE PTR 0Ah
	    mov szscr1+2,BYTE PTR 0Dh
	    mov szscr1+3,BYTE PTR 0Ah
	    mov szscr1+4,0
	    invoke WriteFile,genhandle,ADDR szscr1,4,ADDR nbytes,0
	invoke CloseHandle,hfile

    .ELSEIF al==01000000b   ;insert text.
      ;the text is in .sztext5--8...
      mov ebx,ptexticon
      lea eax,(OBJECT PTR [ebx]).sztext5
      invoke lstrcpy, ADDR szscr1,eax
      invoke lstrlen, ADDR szscr1
      lea ebx,szscr1
      add ebx,eax
      mov	[ebx],BYTE PTR 0Dh
      inc ebx
      mov	[ebx],BYTE PTR 0Ah
      inc ebx
      mov	[ebx],BYTE PTR 0Dh
      inc ebx
      mov	[ebx],BYTE PTR 0Ah
      inc ebx
      mov	[ebx],BYTE PTR 0
      add	eax,4
      mov ebx,eax
      invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
    .ELSE
      ;none are checked...
      mov ebx,ptexticon
      or (OBJECT PTR [ebx]).fconfig2,00010000b ;set bit4.
      jmp jj
    .ENDIF

  .ENDIF
  mov szscr1,0

    ret
composeinclude ENDP
;------------------------------------------------------------------------
genmanycode PROC STDCALL USES edi esi ebx ecx edx, pfirstnode:DWORD
	LOCAL genhandle:DWORD,srcring:BYTE,exitring:BYTE
	LOCAL ebxsave:DWORD,ecxsave:DWORD,wireterminal:BYTE
	LOCAL pressave:DWORD,pstmangled:DWORD,esisave:DWORD
	LOCAL esi2save:DWORD
	LOCAL pendgenfile:DWORD
	LOCAL nbytes:DWORD
	LOCAL ebx2save:DWORD,phighi:DWORD
	LOCAL hdrhandle:DWORD
; "genmanycode"
;via menu, IDM_1CODE, for g_phighlightedobject=0 and highlightedindex non-0.
;uses list of top-level nodes in "highlighted" list, composing to 1 file.
;Convert to code, and save as auto-generated or custom filename.
;pfirstnode has 1st in list -- get rest from highlighted list.
;this func is adapted from gen1code().

	lea  eax,subtable	;ptrs to nodes in subdiag.
	mov  psubtable,eax	;pts to start of table.
	mov  g_pininter,0	;pts to interthread i/p wire.
	mov  g_poutinter,0	;pts	  "        o/p  ".
	mov szscr1,0		;text buffer.
	mov genhandle,0
	mov hdrhandle,0

;.......
;check that all top-level nodes in "highlighted" list are right type...
    mov ebx,0
    lea esi,highlighted
xend2:
    mov eax,highlightedindex
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je xend1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0	    ;precaution.
    je xend2b
    ;drop here if found node, edi->node...
	       mov  ax,(OBJECT PTR [edi]).nexttype
	       .IF  ax==00		;normal/iterative node
		 ;the node must be normal-function or ISR-function...
		 mov al,(OBJECT PTR [edi]).nfunctype
		 .IF al==1	    ;normal func., ok
		 .ELSEIF al==2	;isr
		 .ELSEIF al==3	;library func. no good.
		   lea	ebx,szer121
e121:		   invoke MessageBox,g_hwnd,ebx,0,MB_OK+MB_ICONEXCLAMATION
		   jmp SHORT f121	;get out.
		 .ELSEIF al==0	;inline code.
		   lea ebx,szer122
		   jmp e121
		 .ELSE
		 .ENDIF
	       .ELSE
		 ;have highlighted wrong kind of object...
       invoke MessageBox,g_hwnd,ADDR sznotselstart,0,MB_OK+MB_ICONEXCLAMATION
f121:		 mov g_perrorobject,edi
		 mov eax,-1
		 ret
	       .ENDIF
	  or   (OBJECT PTR [edi]).fconfig,0100b ;turn on color-fill.
	  mov  (OBJECT PTR [edi]).ncolour1,00FFFFh	;yellow.
xend2b:
    add ebx,4
    jmp xend2
xend1:

;1st node in "highlighted"...
	mov  esi,pfirstnode

;.......
;open a filename to take the generated code...
;firstly check if have selected dblclk action to a filename...
    mov al,(OBJECT PTR [esi]).fconfig
    and al,11000b
    .IF al==0		;default, autogen of filenamr.
    .ELSEIF al==01000b	;custom filename.
      mov al,(OBJECT PTR [esi]).sztext2
      .IF al==0
	lea ebx,szer182c
	jmp SHORT hh5
      .ENDIF
      lea ebx,(OBJECT PTR [esi]).sztext2    ;filespec.
	;290900...
	invoke lstrcpy, ADDR szgenfile,ebx
	lea ebx,(OBJECT PTR [esi]).sztext2    ;filespec.
      jmp hh3
    .ELSE		;child-diagram or commandline.
	    lea  ebx,szer182b
hh5:	    invoke MessageBox,g_hwnd,ebx,0,MB_OK+MB_ICONEXCLAMATION
	    mov eax,-1
	    ret 	;get out.
    .ENDIF

;let's open a file to take the generated code, auto gen of filename...
;this is same format as when dblclk in ring1...
; "SxxxEzzzzz.eee"
; Sxxx means Subproject number.
; Ezzzzz means element number.
; eee	 extension.

	  mov edi,pTERSEDATA
	  lea eax,szgenfile
	  mov pendgenfile,eax
	    mov	esi,pfirstnode
	    mov edi,pTERSEDATA
	    xor eax,eax
	    mov ax,(TERSEDATA PTR [edi]).nsubproject
	    mov ebx,pendgenfile
	    mov [ebx],BYTE PTR "S"
	    inc ebx
	    mov pendgenfile,ebx
	  invoke bin2dec		;eax-->szasciitbl to szasciitbl+9
	  lea  edi,szasciitbl+6		;(szasciitbl+10 has a zero)
	    mov  al,[edi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  edi		;/
	      mov  al,[edi]	;/
	    .ENDW		;/
	  mov ebx,pendgenfile
	  invoke lstrcpy, ebx,edi
	  invoke lstrlen, ADDR szgenfile
	  add eax,OFFSET szgenfile
	  mov pendgenfile,eax
	    xor eax,eax
	    mov	ax,(OBJECT PTR [esi]).number
	    mov ebx,pendgenfile
	    mov [ebx],BYTE PTR "E"
	    inc ebx
	    mov pendgenfile,ebx
	  invoke bin2dec		;eax-->szasciitbl
	  lea  edi,szasciitbl+4
	    mov  al,[edi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  edi		;/
	      mov  al,[edi]	;/
	    .ENDW		;/
	  mov ebx,pendgenfile
	  invoke lstrcpy, ebx,edi
	  invoke lstrlen, ADDR szgenfile
	  add eax,OFFSET szgenfile
	  mov pendgenfile,eax
	mov ebx,pendgenfile
	      mov [ebx],BYTE PTR "."
	      inc ebx
	      mov [ebx],BYTE PTR 0
	      mov pendgenfile,ebx
	    mov edi,pTERSEDATA
	    lea eax,(TERSEDATA PTR [edi]).szexten
	    mov ebx,pendgenfile
	    invoke lstrcpy, ebx, eax

;have composed filename in szgenfile, now open file...
	  lea ebx,szgenfile
hh3:	  invoke CreateFile, ebx,\
		GENERIC_READ+GENERIC_WRITE,\
		0, ;don't share FILE_SHARE_READ+FILE_SHARE_WRITE,\
		0, CREATE_ALWAYS,\  ;creates new, overwrites any existing
		FILE_ATTRIBUTE_NORMAL, 0
	  .IF eax==INVALID_HANDLE_VALUE	;-1
	    lea  ebx,szferr1
	    invoke MessageBox,g_hwnd,ebx,0,MB_OK+MB_ICONEXCLAMATION
	    mov eax,-1
	    jmp zz	;get out.
	  .ENDIF
	  mov genhandle,eax

;290900
;"Control/Configuration.../Generated source file..." dialog box
;has option to compose prototypes of public functions to an
;separate header file.
;give it same name as szgenfile (above) but ".h" extension.
  mov edi,pTERSEDATA
  mov al,(TERSEDATA PTR [edi]).fcodeprefs
  and al,01	;bit0=1 compose protos of public funcs to separate hdr.
  cmp al,01
  je k6
  mov al,(TERSEDATA PTR [edi]).fcodeprefs
  and al,010b	;bit1=1 compose header-text to separate hdr file.
  cmp al,010b
  je k6
  jmp k4	;don't open/create hdr file.
k6:
    invoke lstrcpy, ADDR szscr1, ADDR szgenfile  ;temp use szscr1
       lea ebx,szscr1
k1:    mov al,[ebx]
       cmp al,0
       je k3	      ;this is actually a fault condition.
       cmp al,"."
       je k2	      ;...szgenfile should have "." before the 0.
       inc ebx
       jmp k1
k3:    mov BYTE PTR [ebx],"."
k2:    inc ebx
       mov BYTE PTR [ebx],"h"
       inc ebx
       mov BYTE PTR [ebx],0
;now create/open the header file...
	  lea ebx,szscr1
	  invoke CreateFile, ebx,\
		GENERIC_READ+GENERIC_WRITE,\
		0, ;don't share FILE_SHARE_READ+FILE_SHARE_WRITE,\
		0, CREATE_ALWAYS,\  ;creates new, overwrites any existing
		FILE_ATTRIBUTE_NORMAL, 0
	  .IF eax==INVALID_HANDLE_VALUE	;-1
	    lea  ebx,szferr1
	    invoke MessageBox,g_hwnd,ebx,0,MB_OK+MB_ICONEXCLAMATION
	    mov eax,-1
	    jmp zz	;get out.
	  .ENDIF
	  mov hdrhandle,eax
    mov szscr1,0	;finished temp usage.
k4:


;.......
;compose header text...
	mov  edi,pfirstnode  ;edi-->first node in subdiagram.
  lea  eax,szhdr1
  invoke lstrcpy, ADDR szscr1, eax
  invoke lstrlen, ADDR szscr1
  lea  ebx,szscr1
  add  ebx,eax		;-->end of szscr1.
  lea  eax,(OBJECT PTR [edi]).sztext1  ;szlabel
  invoke lstrcpy, ebx, eax
  invoke lstrlen, ADDR szscr1
  lea  ebx,szscr1
  add  ebx,eax		;-->end of szscr1.
  mov  [ebx],BYTE PTR 34 ;double-quotation character.
  mov  [ebx+1],BYTE PTR "*"
  mov  [ebx+2],BYTE PTR "/"
  mov  [ebx+3],BYTE PTR 0Dh
  mov  [ebx+4],BYTE PTR 0Ah
  mov  [ebx+5],BYTE PTR 0
  add  ebx,5
  lea  eax,szhdr2
  invoke lstrcpy, ebx, eax

  invoke lstrlen, ADDR szscr1
  lea  ebx,szscr1
  add  ebx,eax		;-->end of szscr1.
  lea  eax,szhdr3
  invoke lstrcpy, ebx, eax
  invoke lstrlen, ADDR szscr1
  lea  ebx,szscr1
  add  ebx,eax
  lea  eax,szfile	   ;filename of goofee diagram.
  invoke lstrcpy, ebx, eax
  invoke lstrlen, ADDR szscr1
  lea  ebx,szscr1
  add  ebx,eax
  mov  [ebx],BYTE PTR " "
  mov  [ebx+1],BYTE PTR "*"
  mov  [ebx+2],BYTE PTR "/"
  mov  [ebx+3],BYTE PTR 0Dh
  mov  [ebx+4],BYTE PTR 0Ah
  mov  [ebx+5],BYTE PTR 0Dh
  mov  [ebx+6],BYTE PTR 0Ah
  mov  [ebx+7],BYTE PTR 0

  invoke lstrlen, ADDR szscr1
  mov ebx,eax
  invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
  .IF  eax==FALSE	;error.
    lea	ebx,szferr2
    invoke MessageBox,g_hwnd,ebx, 0, MB_OK+MB_ICONEXCLAMATION
	    mov  eax,-1
	    jmp  zz
  .ENDIF
  mov szscr1,0

;........
;the output file will have preliminary text...stored in database...
;(note this can be up to 2004 characters)
  mov ebx,pTERSEDATA
  lea eax,(TERSEDATA PTR [ebx]).szgenprelim
  invoke lstrcpy, ADDR szscr1,eax
  invoke lstrlen, ADDR szscr1
  lea  ebx,szscr1
  add  ebx,eax
  mov  [ebx],BYTE PTR 0Dh
  mov  [ebx+1],BYTE PTR 0Ah
  mov  [ebx+2],BYTE PTR 0Dh
  mov  [ebx+3],BYTE PTR 0Ah
  mov  [ebx+4],BYTE PTR 0
  add  eax,4
  mov ebx,eax
;290900 ...
    push ebx
    mov ebx,pTERSEDATA
    mov al,(TERSEDATA PTR [ebx]).fcodeprefs
    pop ebx
    and al,010b     ;bit1=1 write prelim text to sep. hdr file.
    .IF al==0
      invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
    .ELSE
      ;290900 write prelim text to sep. hdr file...
      invoke WriteFile, hdrhandle,ADDR szscr1,ebx,ADDR nbytes,0
    .ENDIF
  mov szscr1,0


;031100
;i want the first #include attached to top-level node, to
;compose before global data...
;...also before prototypes!...
  invoke composeinclude, pfirstnode,genhandle	;note, uses szscr1.


;.........
;generate all prototypes for nodes in sub-diagram(s) and write to file...
    mov ebx,0
end2:
    lea esi,highlighted
    mov eax,highlightedindex
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je end1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0	    ;precaution.
    je end2b
    mov phighi,ebx
      ;drop here if found an object, edi->object...
	;per-file header text is in the comment attached to the first node
	;of a subdiagram. Compose it here...
	;note, this also finds any attached comment, as well as other stuff...
	;(modifies eax, ebx,ecx)
	invoke findactionwire, edi,1	  ;1= ring 1
	.IF	eax==-1
	  jmp zz ;ret	;error exit.
	.ENDIF
;	;returns ebx-->comment label, =0 no comment.
;	.IF ebx==0
;	.ELSE
;	  invoke lstrcpy, ADDR szscr1,ebx
;	  invoke lstrlen, ADDR szscr1
;	  lea ebx,szscr1
;	  add ebx,eax
;	  mov	[ebx],BYTE PTR 0Dh
;	  mov	[ebx+1],BYTE PTR 0Ah
;	  mov	[ebx+2],BYTE PTR 0Dh
;	  mov	[ebx+3],BYTE PTR 0Ah
;	  mov	[ebx+4],BYTE PTR 0
;	  add	eax,4
;	  mov ebx,eax
;	  invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
;	.ENDIF
	mov szscr1,0
      invoke composeprototypes,edi,genhandle,hdrhandle
      .IF eax==-1	;error
	jmp zz
      .ENDIF
    mov ebx,phighi
end2b:
    add ebx,4
    jmp end2
end1:

;...............
protodone:	;prototypes have been written to file.
  mov  szscr1,0Dh			    ;blank line
  mov  szscr1+1,0Ah			    ;/
  mov  szscr1+2,0			    ;/
  invoke WriteFile, genhandle,ADDR szscr1,2,ADDR nbytes,0
  mov szscr1,0

;.........
;compose fASYNC flag for asynchronous i/p msg...
  mov ebx,pTERSEDATA
  mov al,(TERSEDATA PTR [ebx]).szfasync
  .IF al==0
  .ELSE
    lea	eax,(TERSEDATA PTR [ebx]).szfasync
    invoke lstrcpy, ADDR szscr1, eax
    invoke lstrlen, ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    dec ebx
    mov cl,[ebx]
    .IF cl==";"
     inc ebx
    .ELSE
     inc ebx
     mov [ebx],BYTE PTR ";"
     inc ebx
     inc eax
    .ENDIF
    mov [ebx],BYTE PTR 0Dh
    inc ebx
    mov [ebx],BYTE PTR 0Ah
    inc ebx
    mov [ebx],BYTE PTR 0
    inc eax
    inc eax
    mov ebx,eax
    invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
    mov szscr1,0
  .ENDIF


;compose file-visible, public-visible and external data...
;note, we have a table of functions in subdiagram in subtable.
;look for data with .rplock1 pointing to a func...
;also compose mangled shareable data. use .rpmaster to detect
;shareable data attached to a clone of a func-in-subtable...
;note, element# of pfirstnode (1st node in "highlighted" list) will
;be file# (.nfile) of all elements to be composed.
    invoke composeglobaldata, genhandle,pfirstnode
    cmp eax,-1
    je zz


;..................
finman:
;have created the mangled static data.
  mov  szscr1,0Dh			    ;new line
  mov  szscr1+1,0Ah			    ;/
  mov  szscr1+2,0Dh			    ;blank line
  mov  szscr1+3,0Ah			    ;/
  mov  szscr1+4,0			    ;/
  invoke WriteFile, genhandle,ADDR szscr1,4,ADDR nbytes,0
  mov szscr1,0

;............
;now compose the code for each function...
  lea  ebx,subtable
tab0:
  mov ebx2save,ebx
  cmp  ebx,psubtable	;if equal, end of table.
  je   tab1		;/
  mov  edi,[ebx]		;get entry from table.

    ;a little job here...
    ;assign .number of first node in subdiagram to edi.nfile...
    ;(also done in composepath from ring() --to get inline nodes,
    ; composeglobaldata(), and composenodedata() ).
    push ebx
    mov ebx,pfirstnode
    mov ax,(OBJECT PTR [ebx]).number
    pop ebx
    mov (OBJECT PTR [edi]).nfile,ax

      ;141000
      ;maybe a text-file icon attached to the
      ;node of a subdiagram. Compose it here...
      .IF edi==pfirstnode ;but if 1st node, already done above. 031100
      .ELSE
	invoke composeinclude, edi,genhandle   ;note, uses szscr1.
      .ENDIF

   ;precaution...don't compose node with dblclk to another diagram...
   ;141000 ...Note, Redundant, as library-func nodes don't get here.
   mov al,(OBJECT PTR [edi]).fconfig
   and al,00011000b		;bits 4/3.
   .IF al==00011000b
	pushad
	;compose a header line...
	invoke lstrcpy, ADDR szscr1, ADDR szfunclabel	;/*-----
	invoke lstrlen, ADDR szscr1
	lea  ebx,szscr1
	add  ebx,eax
	lea  eax,(OBJECT PTR [edi]).sztext1 ;szlabel
	invoke lstrcpy, ebx, eax
	invoke lstrlen, ADDR szscr1
	lea  ebx,szscr1
	add  ebx,eax
	invoke lstrcpy, ebx, ADDR szfunclabel2	 ;----*/
	invoke lstrlen, ADDR szscr1
	lea  ebx,szscr1
	add  ebx,eax
	invoke lstrcpy, ebx, ADDR szofffile
	invoke lstrlen, ADDR szscr1
	lea  ebx,szscr1
	add  ebx,eax
	lea	eax,(OBJECT PTR [edi]).sztext2 ;name of goofee diagram.
	invoke lstrcpy, ebx, eax
	invoke lstrlen, ADDR szscr1
	lea  ebx,szscr1
	add  ebx,eax
	mov  [ebx],BYTE PTR " "
	mov  [ebx+1],BYTE PTR "*"
	mov  [ebx+2],BYTE PTR "/"
	mov  [ebx+3],BYTE PTR 0Dh
	mov  [ebx+4],BYTE PTR 0Ah
	mov  [ebx+5],BYTE PTR 0Dh
	mov  [ebx+6],BYTE PTR 0Ah
	mov  [ebx+7],BYTE PTR 0
	invoke lstrlen, ADDR szscr1
	mov ebx,eax
	invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
	popad
   .ELSE

     ;compose a comment header...
	invoke lstrcpy, ADDR szscr1, ADDR szfunclabel
	invoke lstrlen, ADDR szscr1
	lea  ebx,szscr1
	add  ebx,eax
	lea  eax,(OBJECT PTR [edi]).sztext1
	invoke lstrcpy, ebx,eax
	invoke lstrlen, ADDR szscr1
	lea  ebx,szscr1
	add  ebx,eax
	invoke lstrcpy, ebx, ADDR szfunclabel2
	invoke lstrlen, ADDR szscr1
	mov ebx,eax
	invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
	mov szscr1,0

     mov g_nlevel,1	;# units of indentation req'd.

     ;compose function definition...
     invoke composefuncdefinition,edi,pfirstnode,genhandle
     .IF eax==-1	;error
      jmp zz
     .ENDIF

     ;compose data private to a function...
     invoke composenodedata,edi,pfirstnode,genhandle
     .IF eax==-1
       jmp zz
     .ENDIF

;compose the code inside the function...
      invoke composenode, edi,pfirstnode,genhandle,0  ;0=not inline.
      ;entered with ptr to current node, ptr to first in subdiag,
      ;handle to file.
      cmp eax,-1		;error.
      je zz		;exit.

   .ENDIF
isin1:
  mov ebx,ebx2save
  add	ebx,4		;next entry in table.
  jmp	tab0
tab1:



zz:	mov ebxsave,eax	;eax=-1 error.
	  .IF genhandle==0
	  .ELSE
	    invoke CloseHandle, genhandle
	    mov	genhandle,0
	  .ENDIF
	  .IF hdrhandle==0
	  .ELSE
	    invoke CloseHandle, hdrhandle
	    mov	hdrhandle,0
	  .ENDIF
;	  mov  edi,pfirstnode
;	  or   (OBJECT PTR [edi]).fconfig,0100b ;turn on color-fill.
;	  mov  (OBJECT PTR [edi]).ncolour1,00FFFFh	;yellow.

	mov eax,ebxsave
	;051100
	;flash top-level node to indicate successful completion...
	.IF eax==-1
	.ELSE
	  invoke GetTickCount
	  mov esisave,eax
qqq:	  invoke GetTickCount
	  sub eax,esisave
	  .IF eax<1000
	    invoke MessageBeep, -1
	    jmp qqq
	  .ENDIF
	.ENDIF

	mov eax,ebxsave
	ret
genmanycode ENDP
;------------------------------------------------------------------------
.DATA
szer191a    BYTE "You have forgotten the name for a variable.",0Dh,0Ah
	    BYTE "GOOSEE is aborting code generation. The offending "
	    BYTE "element is highlighted.",0

.CODE
composeglobaldata PROC STDCALL USES ebx ecx edx esi edi, \
			    genhandle:DWORD, pfnode:DWORD
    LOCAL ebxsave:DWORD,xebxsave:DWORD
    LOCAL plock:DWORD,plock2:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL nbytes:DWORD
    LOCAL pmaster:DWORD,pexdata:DWORD
    LOCAL pprevsave:DWORD,ecxprevsave:DWORD
;called from genmanycode().   "composeglobaldata"
;a table already exists of all funcs in subdiagram -- subtable.
;(it hasn't got clones in it)
;look at each func and find data attached -- .rplock1.
;if data is file-visible, compose with "static" prefix.
;if data is public-visible, compose with no prefix.
;if data is public-external, compose with "extern" prefix.
;(i don't think file-vis can be external)
;if data is shareable, compose mangled.

;061200
;now have generic data. a bit weird, it is always .nexttype=3,
;with .fstatus2/bits7/6/5 =100 to designate this data is generic.
;also .fconfig3/bits1/0 =01 if compose inside function, =10 if
;compose before func, =11 if compose before all funcs.
;...handle last case here.

;need a loop to search database for data...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov plock,0
	mov pmaster,0
	mov plock2,0
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	    mov ax,(OBJECT PTR [esi]).nexttype
	    .IF ax==-1	    ;data object
	    .ELSEIF ax==3
	      ;only respond to generic data here...  061200
	      mov al,(OBJECT PTR [esi]).fstatus2
	      and al,11100000b	;bits 7/6/5
	      .IF al==10000000b ;generic
		;.fconfig3 specifies where composes...
		mov al,(OBJECT PTR [esi]).fconfig3
		and al,011b
		.IF al==11b ;compose before all funcs(like normal public)
		  jmp try1  ;maybe we're in.
		.ENDIF
	      .ENDIF
	    .ELSEIF ax==4   ;global data
	      mov al,(OBJECT PTR [esi]).fconfig
	      and  al,01100000b	;extract bits6/5
	      .IF al==00100000b ;file-visible
		jmp SHORT try1
	      .ELSEIF al==01000000b ;public-visible
try1:		mov eax,(OBJECT PTR [esi]).rplock1
		.IF eax==0	;this would be an error.
		.ELSE
		  add eax,pTERSEDATA
		  mov plock,eax     ;addr of owner of data.
		  jmp SHORT qq5
		.ENDIF
	      .ELSEIF al==0 ;shareable-visible
		mov al,(OBJECT PTR [esi]).fconfig
		and al,80h  ;bit7=1 shareable-temporary
		.IF al==0
		  ;shareable data could be connected to a node in
		  ;subtable (only actual funcs, no clones in subtable)
		  ;or to a clone. compose both...
		  mov eax,(OBJECT PTR [esi]).rpmaster
		  .IF eax==0	;error
		  .ELSE
		    add eax,pTERSEDATA
		    mov pmaster,eax	;addr of master (root)
		    jmp SHORT qq5
		  .ENDIF
		.ENDIF
	      .ENDIF
	    .ELSEIF ax==15	;dataflow wire.
	      ;special case, want to detect a dataflow wire connected to
	      ;a shareable data element that is not owned by any node
	      ;in current subdiagram...
	      mov eax,(OBJECT PTR [esi]).rplock2
	      .IF eax==0
	      .ELSE
		add eax,pTERSEDATA
		mov plock2,eax
		jmp SHORT qq5
	      .ENDIF
	    .ENDIF
	  .ENDIF
x1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  j02 ;nextobj
      jmp SHORT j03
j02:  jmp nextobj
j03:
;finished looking for data in the database, so return...
    xor eax,eax
    ret

;........
qq5:
;need a loop to look thru subtable...
	    lea	ebx,subtable
qq1:	    mov ebxsave,ebx
	    cmp ebx,psubtable	;end of table
	    jge	qq2		;finished
	    mov	edi,[ebx]
	      ;is data owned by this func?
	      cmp edi,plock
	      je  datafnd
	      ;is shareable data owned by this func or a clone of this func?
	      cmp edi,pmaster
	      je  datafnd
	      cmp edi,plock2
	      je  df1		;dataflow wire on this node.
nxt1:	    mov ebx,ebxsave
	    add	ebx,4
	    jmp  qq1
qq2:  jmp x1		    ;find next data.

df1:
;ok there's a dataflow wire on this node. need to examine other end and
;see if data is owned by any node in current subdiagram. if yes, the data
;will get detected by this routine in the normal way. if not, need to
;compose it as extern...   esi->dataflow wire
    mov ebx,(OBJECT PTR [esi]).rplock1
    add ebx,pTERSEDATA	    ;data at begin-end of dataflow wire.
    mov eax,(OBJECT PTR [ebx]).rplock1
    add eax,pTERSEDATA	    ;owner of data.
    mov plock,eax
    mov pexdata,ebx
    ;now have to search subtable again...
	    lea	ebx,subtable
xqq1:	    mov xebxsave,ebx
	    cmp ebx,psubtable	;end of table
	    jge	xqq2		;finished
	    mov	edi,[ebx]
	      ;is data owned by this func?
	      cmp edi,plock
	      je  xdatafnd
	    mov ebx,xebxsave
	    add	ebx,4
	    jmp  xqq1
xdatafnd: jmp x1	    ;ignore dataflow wire, carry on as normal.
xqq2:
;pexdata->data that must be composed as extern...
    mov edi,plock	    ;real owner of data.
    mov esi,pexdata
    mov szscr1+6,BYTE PTR 0
    jmp oo1


datafnd:
;compose data element. afterward jmp x1.
;edi->owner-function, esi->data

  ;a little job here...
  ;assign .number of first node in subdiagram to esi.nfile...
  push ebx
  mov ebx,pfnode
  mov ax,(OBJECT PTR [ebx]).number
  pop ebx
  mov (OBJECT PTR [esi]).nfile,ax



    ;check the do-not-compose bit...
    mov al,(OBJECT PTR [esi]).fconfig
    test al,10b     ;bit1
    jnz x1

;061200
;is it generic data?...
       mov al,(OBJECT PTR [esi]).fstatus2
       and al,11100000b     ;extract bits7/6/5, variable type.
       .IF al==10000000b
	 ;need to compose as-is...
	 lea eax,(OBJECT PTR [esi]).sztext5
	 invoke lstrcpy, ADDR szscr1,eax
	 jmp x1s    ;write to file, then find next data.
       .ENDIF

    invoke lstrcpy, ADDR szscr1, ADDR szstatic
    mov al,(OBJECT PTR [esi]).fconfig
    and al,01100000b
    .IF al==00100000b	;file-visible
	    ;leave in"static" keyword...
    .ELSEIF al==01000000b ;public-visible
      mov al,(OBJECT PTR [esi]).fstatus
      and al,100b
      .IF al==0 	;public
	    ;remove "static" keyword...
	    mov	szscr1,BYTE PTR " "	   ;remove "static" keyword.
	    mov  szscr1+1,BYTE PTR " "
	    mov  szscr1+2,BYTE PTR " "
	    mov  szscr1+3,BYTE PTR " "
	    mov  szscr1+4,BYTE PTR " "
	    mov  szscr1+5,BYTE PTR " "
      .ELSE	   ;bit2=1 external data.
	    ;put in "extern" keyword...
oo1:	    mov  szscr1,BYTE PTR "e"
	    mov  szscr1+1,BYTE PTR "x"
	    mov  szscr1+2,BYTE PTR "t"
	    mov  szscr1+3,BYTE PTR "e"
	    mov  szscr1+4,BYTE PTR "r"
	    mov  szscr1+5,BYTE PTR "n"
      .ENDIF
    .ENDIF

	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
       mov al,(OBJECT PTR [esi]).fstatus2
       and al,11100000b     ;extract bits7/6/5, variable type.

       .IF al==0	    ;simple variable.
	 invoke composeprimitivevar, esi,0,esi,1,0,1
	 .IF eax==-1
	   ret
	 .ENDIF

       .ELSEIF al==00100000b ;pointer.
	 ;compose pointer...
	 ; "childdatatype childmemtype * ptrmemtype name"
	 ;esi -> pointer resource.

	   invoke composepointer1, esi,1,0
	   ;2nd-last param=1 suppress extra "*"
	   ;last param=0 compose variable name (but recursive calls won't)
	   ;...composes to the end of szscr1
	   cmp eax,-1
	   je  zzzz	;error exit.

       .ELSEIF al==01000000b ;structure
	 ;similar to the basic variable, except has "struct" before the
	 ;structure-type... "struct RECT memtype name"
	 ;ebx->end of szscr1, esi->structure-data-element
	      ;compose "struct"...
	      lea eax,szstruct
	      invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	       xor eax,eax
	       mov al,(OBJECT PTR [esi]).ndatatype
	    .IF al==0	      ;nothing selected.

	      ;***NOTE*** in future, structure-type=0 nothing selected,
	      ;will mean it will be a structure-template, not an
	      ;instantiation.

	    .ELSE
	      dec eax		;cos we ignore .ndatatype=0
	       mov ecx,48
	       mul ecx
	       push ebx
	       mov ebx,pTERSEDATA
	       lea ecx,(TERSEDATA PTR [ebx]).szptrtype1
	       pop ebx
	       add eax,ecx		;now have addr of string in eax.
	       invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF
	    mov al,(OBJECT PTR [esi]).nmemtype1
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [esi]).nmemtype1
	      dec al		;cos we ignore .nmemtype1=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF
	    ;now compose name...
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [esi]).sztext1
	    .IF al==0	      ;nothing selected.
	      lea eax,szer191a
	      invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	      mov g_perrorobject,esi
	      jmp	zzzz
	    .ELSE
	      lea eax,(OBJECT PTR [esi]).sztext1
	      invoke lstrcpy, ebx,eax
		;if this is shareable, mangle it with its own element#...
		mov al,(OBJECT PTR [esi]).fconfig
		and al,01100000b
		.IF al==0
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  xor eax,eax
		  mov ax,(OBJECT PTR [esi]).number
		  invoke binto5dec, ebx ;appends element#
		  add ebx,5
		  mov [ebx],BYTE PTR 0
		.ENDIF
	    .ENDIF
	    ;now compose initialisation value...
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	    mov al,(OBJECT PTR [esi]).sztext5
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      mov [ebx],BYTE PTR "="
	      inc ebx
	      mov [ebx],BYTE PTR "{"
	      inc ebx
	      lea eax,(OBJECT PTR [esi]).sztext5
	      invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR "}"
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF


       .ELSEIF al==01100000b ;array
	 ;we want to define an array. well, if the array has
	 ;elements of primitive datatype, seems straightforward...
	 ; "ndatatype nmemetype2 name[size]={initstring};"
	 ;if the .ndatatype field is zero, means that array has
	 ;attached data-elements --NOT SUPPORTED THIS VERSION
	 ;ebx->end of szscr1, esi->array-data-element
	 mov al,(OBJECT PTR [esi]).ndatatype
	 .IF al==0
	   mov pprevsave,0
	   mov ecxprevsave,0
kg2:	   mov eax,pprevsave
	   mov pprev,eax
	   mov eax,ecxprevsave
	   mov ecxprev,eax
	   invoke findchild, esi,3
	   mov ecx,pprev
	   mov pprevsave,ecx
	   mov ecx,ecxprev
	   mov ecxprevsave,ecx
	   ;...esi is node to find the child of, 3 is the .nexttype to find.
	   ;returns eax=addr of found child, else eax=0 not found.
	   .IF eax==0
	     lea eax,szer3200b
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	   .ELSE
	     mov ebx,eax
	     mov al,(OBJECT PTR [ebx]).fstatus2 ;child data-element.
	     and al,11100000b
	     .IF al==0	    ;primitive variable type.
nn1:	       invoke composeprimitivearray, ebx,0,esi,1,0,1
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSEIF al==01000000b  ;structure
	       jmp nn1		    ;(treat as like primitivedata)
	     .ELSEIF al==01100000b  ;another array.
	       ;an array attached to an array. loop back until we find
	       ;the lowest one...
	       mov esi,ebx
	       mov al,(OBJECT PTR [esi]).ndatatype
	       cmp al,0
	       jne  kg1		    ; array has no child.
	       jmp  kg2 	    ; array has a child.
	     .ELSEIF al==00100000b  ;pointer.
	       ;have an array of pointers...
	       ;ebx->pointer, esi->lowest array.
	       invoke composearrayofpointers, ebx,esi,1,0
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSE
	       ;MODIFY THIS MESSAGE NEXT GOOSEE VERSION ***NOTE*** ...
	       lea eax,szer301
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	     .ENDIF
	   .ENDIF
	 .ELSE
kg1:	   invoke composeprimitivearray, esi,0,esi,1,0,1
	   .IF eax==-1
	     ret
	   .ENDIF
	 .ENDIF

       .ELSEIF al==10000000b ;generic
       .ENDIF

	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	    mov [ebx],BYTE PTR ";"
	    inc ebx
	    mov [ebx],BYTE PTR 0Dh
	    inc ebx
	    mov [ebx],BYTE PTR 0Ah
	    inc ebx
	    mov [ebx],BYTE PTR 0
;and write data definition to file...
x1s:	invoke lstrlen, ADDR szscr1
	mov ebx,eax
	invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0

     jmp x1 ;find next data.





    xor eax,eax
    ret
zzzz:
    mov eax,-1
    ret
composeglobaldata ENDP
;------------------------------------------------------------------------
.DATA
pprev	  DWORD 0
ecxprev   DWORD 0
szstruct  BYTE "struct ",0
szisrer1  DB "An ISR-function (interrupt service routine) node can only be the "
	  BYTE "first node in a sub-diagram (i.e. the first node in a "
	  BYTE "thread-of-execution that is being composed to C code)."
	  BYTE "GOOSEE is aborting the code generation.",0
;*NOTE* currently not used...
;szisrer1b BYTE "The ISR-function node must have an attached "
;	  BYTE "hardware element, with the checkbox inside its "
;	  BYTE "dialog box set to ""Interrupt"".",0Dh,0Ah
;	  BYTE "GOOSEE is aborting the code generation.",0

szkkkker  DB "ERROR: Cannot attach shareable resource to interrupt node. "
	  DB "Attach it to another node in the same sub-diagram.",0
sznofer1  DB "A node with double-click action to "
	  DB "open a diagram, or the first node in current thread, "
	  DB "or a public node, or "
	  BYTE "an external node, must have a name "
	  DB "(which will become the function name).",0Dh,0Ah
	  BYTE "GOOSEE has highlighted the offending node. Right-click "
	  BYTE "on it to bring up its dialog box.",0
;sznofer2  DB "Cannot have open-diagram double-click action on "
;	  DB "a clone node, only a root or stand-alone node. Also, first "
;	  DB "node in thread (i.e., node that will be used to generate "
;	  BYTE "a C source file) must not be a clone.",0
sz2741	  DB "ERROR: Cannot find a sync-with-reply[-and-timeout] wire "
	  DB "into ring 1 of node.",0
sz2742	  DB "ERROR: Part of the database for the sync-with-reply[-and-"
	  DB "timeout] wire into ring 1 is missing.",0
szer181a  BYTE "Hey, you haven't properly entered the prototype for a "
	  BYTE "function. Even if there are no parameters passed to a "
	  BYTE "function, still you must enter ""void"" in the ""Passed "
	  BYTE "parameters"" box. Note that if you are passing two int "
	  BYTE "datatype parameters you would enter ""int x,int y"" ("
	  BYTE "where ""x"" and ""y"" variable names as used inside "
	  BYTE "the function).",0Dh,0Ah
	  BYTE "GOOSEE has highlighted the offending node. Right-click "
	  BYTE "on it to bring up its dialog box.",0
szer181b  BYTE "Hey, you haven't properly entered the prototype for a "
	  BYTE "function. GOOSEE detects that you haven't entered a "
	  BYTE "return datatype. For example, if a function returns a "
	  BYTE "value of type int, just enter ""int"" into the edit-box. "
	  BYTE "If a function doesn't return any value, enter ""void"".",0Dh,0Ah
	  BYTE "Note that you must also enter passed parameters into the "
	  BYTE "passed-parameters edit-box, for example ""int x,int y"" to "
	  BYTE "pass two int parameters (""x"" and ""y"" are the variable "
	  BYTE "names as used inside the function).",0Dh,0Ah
	  BYTE "Note also that the function-prefix and function-postfix "
	  BYTE "fields are optional."
	  BYTE 0Dh,0Ah
	  BYTE "GOOSEE has highlighted the offending node. Right-click "
	  BYTE "on it to bring up its dialog box.",0
szer301   BYTE "You have attached a data-element to an array-data-element "
	  BYTE "of a type that GOOSEE doesn't know how to generate C code "
	  BYTE "for. GOOSEE has highlighted the offending "
	  BYTE "array-element.",0
szer9200  BYTE "The current subdiagram is calling a clone-node, and the "
	  BYTE "master-node of the clone-chain belongs to a different "
	  BYTE "subdiagram (i.e. will be in a different C file). That's "
	  BYTE "OK, and GOOSEE will compose a prototype for it in the "
	  BYTE "current C file, however the master-node must be set as "
	  BYTE """public"" in its dialog box. Public means that it is "
	  BYTE "visible outside its current C file.",0Dh,0Ah
	  BYTE "Note that ""external"" setting for the master-node is "
	  BYTE "OK, as long as the function is defined somewhere.",0Dh,0Ah
	  BYTE "GOOSEE has highlighted the offending node. Right-click "
	  BYTE "on it to bring up its dialog box.",0


.CODE
composeprototypes PROC STDCALL USES ebx ecx edx esi edi, \
			pfnode:DWORD ,genhandle:DWORD, hdrhandle:DWORD
  LOCAL csave:DWORD,primaryisr:WORD,secondaryisr:WORD,fisisr:BYTE
  LOCAL bsave:DWORD
  LOCAL esizeobject:DWORD
  LOCAL nbytes:DWORD
  LOCAL edisave:DWORD, ecxsave:DWORD
  LOCAL cntshareable:BYTE
  LOCAL pstartparams:DWORD
  LOCAL fvoid:BYTE
  LOCAL pprevsave:DWORD,ecxprevsave:DWORD
  LOCAL xpprev:DWORD,xecxprev:DWORD
;called from genmanycode.	  "composeprototypes"
;pfnode-->first node in subdiagram.
;scan thru database looking for nodes. they must be functions
;(i.e. .nfunctype>0)... note won't write prototype for library func.
;i think if external func (.fstatus2bit2/1=11) still need prototype.
;the purpose of the subtable is a list of funcs that are to be defined
;(have code, variables, etc).
;summary:
;clone-func:   don't add to subtable, no prototype
;isr-func:     add to subtable, no prototype
;library-func: don't add to subtable, no prototype
;any other external func: don't add to subtable, need prototype

;211000
    lea	eax,xsubtable	;ptrs to nodes in subdiag. temp.table.
    mov	pxsubtable,eax	;pts to start of table.

  mov esi,pTERSEDATA
  xor eax,eax
  xor ecx,ecx
  mov  ax,(TERSEDATA PTR [esi]).nsizeobject ;esizeobject
  mov esizeobject,eax
  lea  edi,(TERSEDATA PTR [esi]).OBJECTS ;edi-->first node in database
  mov  cx,(TERSEDATA PTR [esi]).numobjects ;numnodes

look2:
  mov edisave,edi
  mov ecxsave,ecx
  test	(OBJECT PTR [edi]).fstatus,01	;bit0=1 valid object.
  jz	look3
  cmp	(OBJECT PTR [edi]).nexttype,0	;=0 node
  jne	look3
  mov al,(OBJECT PTR [edi]).nfunctype
  cmp al,0	;inline code
  je  look3
  cmp al,3	;library function
  je  look3

;201000 see below, bug fix for clones. need screen out here...
  mov eax,(OBJECT PTR [edi]).rplock1
  cmp eax,0	;non-0, a clone
  jne look3

    invoke find1stnode, pfnode,edi     ;changes eax,ebx.
    ;where pfnode is 1st in subdiag, edi is current node being examined.
    ;returns eax=-1 exit, =0 not in subdiag, =1 yes is in subdiag.
    ;returns plabel-->label in found wire, pintype-->datatypestringforwire.
    ;these two are invalid if node has proto-subnode attached.
    ;*NOTE* i'm not using plabel/pintype anymore<<<********<<<<<<
    ;returns pr1wire -> sync i/p wire into ring1.
      ;211000 returns ebx=count of hierarchy (depth from top node), else=-1.
      .IF bl==-1
      .ELSE
	mov (OBJECT PTR [edi]).nhierarchy,bl ;ebx
      .ENDIF
    .IF	eax==-1
      jmp  zzzz		;exit.
    .ELSEIF eax==0
look3:
      mov edi,edisave
      mov ecx,ecxsave
      add	edi,esizeobject
      loop look2
      jmp  protod	;exit, ok.
    .ELSEIF eax==1
      jmp  gen1		;found!
    .ENDIF

gen1:
;edi pts to current node...

;201000 ... not using this code anymore, but leave it here in case.
;problem is, got duplicate prototypes if master not in current
;subdiag but in another subdiag that is composed into same C file.
;(see above, have screened out clones).
;;previously i had screened-out clones, however need to know if master
;;of clone isn't in current subdiagram --then compose prototype.
;;normally we will ignore clones as far as prototypes are concerned.
;    mov ebx,(OBJECT PTR [edi]).rplock1
;    .IF ebx==0
;    .ELSE
;      ;this is a clone.
;      mov ebx,(OBJECT PTR [edi]).rpmaster
;      .IF ebx==0    ;precaution.
;	jmp look3
;      .ELSE
;	;ebx->master of clone chain. is it in subdiagram?...
;	add ebx,pTERSEDATA
;	push ebx
;	invoke find1stnode, pfnode,ebx	;changes ebx,eax
;	pop ebx
;	.IF eax==-1
;	  jmp zzzz
;	.ELSEIF eax==0	    ;not in subdiag.
;	  ;compose prototype for master...
;	  mov edi,ebx
;	  mov al,(OBJECT PTR [edi]).nfunctype
;	  .IF al==2	;isr func.
;	    mov fisisr,1
;	  .ELSE
;	    mov fisisr,0
;	  .ENDIF
;	  ;check that the master is public...
;	  mov al,(OBJECT PTR [edi]).fstatus2
;	  and al,0110b
;	  .IF al==100b	    ;public
;	    jmp zk2
;	  .ELSEIF al==110b  ;external
;	    jmp zk2
;	  .ELSE
;zk1:	    lea	eax,szer9200
;	    invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
;	    mov g_perrorobject,edi
;	    jmp	zzzz
;	  .ENDIF
;	.ELSE
;	  jmp look3	    ;the master will be found by normal process.
;	.ENDIF
;      .ENDIF
;    .ENDIF

;need to know if this is an interrupt routine....
  mov al,(OBJECT PTR [edi]).nfunctype
  .IF al==2 ;this node is an isr func.
    ;only the first node in subdiagram can be an isr func...
    .IF	edi==pfnode	;ok
      ;get pri/sec#'s from resource...
      ;well, goofee kept them in .datatype and .rings in the
      ;interrupt wire. goosee hasn't got an interrupt wire, so
      ;let's have this info in the node...
      mov ax,(OBJECT PTR [edi]).nprimary
      mov  primaryisr,ax
      mov ax,(OBJECT PTR [edi]).nsecondary
      mov  secondaryisr,ax
      mov  fisisr,1

;*NO* i'm not insisting on this for now...
;      ;should also verify that a hardware isr is attached to node...
;      mov pprev,0 ;used as a placemarker for repeat searches in findchild
;      invoke findchild, edi,17
;      ;...edi is node to find the child of, 17 is the .nexttype to find.
;      ;returns eax=addr of found child, else eax=0 not found.
;      .IF eax==0
;	lea  eax,szisrer1b
;	invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
;	jmp  zzzz
;      .ENDIF

    .ELSE		;error.
      lea  eax,szisrer1
      invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
      jmp  zzzz
    .ENDIF
  .ELSE
    mov fisisr,0
  .ENDIF

;.....
;any external func, don't add to subtable...
    mov al,(OBJECT PTR [edi]).fstatus2
    and al,0110b
    .IF al==0110b
      jmp ww1
    .ENDIF

;.....
;compose a table with ptrs to all found functions...
;211000 problem is, C file composes the nodes in order in
;which they are in table. so, first add node to temporary
;table, xsubtable. later on will have to sort the table, using the
;node.nhierarchy stored inside each node (see above)...

    ;edi pts to current node...
    lea  eax,xsubtable
    add  eax,(XXNUMCIRC*4)	;size limit.
    .IF  pxsubtable==eax
      ;table is full, have exceeded allowed subdiag size...
      mov  eax,XXNUMCIRC
	invoke binto5dec, OFFSET szgen5	 ;eax to dec.,retain ldg 0's.
	invoke MessageBox,g_hwnd,ADDR szgener5,0,MB_OK+MB_ICONEXCLAMATION
	  mov  ecx,csave
	  jmp  zzzz	;exit.
    .ELSE
      mov  ebx,pxsubtable
      mov  [ebx],edi
      add  pxsubtable,4
    .ENDIF

;....
;ok, it's in xsubtable.
ww1:
;for isr-func, that's enough...
;edi->node
    mov al,(OBJECT PTR [edi]).nfunctype
    cmp al,2
    je	look3	    ;keep searching database for more funcs.

;.......
zk2:
;now compose the prototype...
	  invoke lstrcpy, ADDR szscr1, ADDR szstatic
;some functions will not have the static prefix...
;edi-->node
	  mov al,(OBJECT PTR [edi]).fstatus2
	  and al,0110b	    ;extract bits 2/1
	    ;if it's the first node in the thread, must be
	    ;public...
	    .IF edi==pfnode
	      and (OBJECT PTR [edi]).fstatus2,11111101b ;set bits2/1
	      or  (OBJECT PTR [edi]).fstatus2,00000100b  ; =10.
	      jmp mi1
	    .ENDIF

	  .IF al==0	;function is private, not implementable.
	    ;leave in"static" keyword...
	  .ELSEIF al==010b ;file-visible func.
	    ;leave in "static" keyword...
	  .ELSEIF al==100b ;public-visible func.
	    ;remove "static" keyword...
mi1:	    mov	szscr1,BYTE PTR " "	   ;remove "static" keyword.
	    mov  szscr1+1,BYTE PTR " "
	    mov  szscr1+2,BYTE PTR " "
	    mov  szscr1+3,BYTE PTR " "
	    mov  szscr1+4,BYTE PTR " "
	    mov  szscr1+5,BYTE PTR " "
	  .ELSE 	   ;=11 external func
	    ;put in "extern" keyword...
	    mov  szscr1,BYTE PTR "e"
	    mov  szscr1+1,BYTE PTR "x"
	    mov  szscr1+2,BYTE PTR "t"
	    mov  szscr1+3,BYTE PTR "e"
	    mov  szscr1+4,BYTE PTR "r"
	    mov  szscr1+5,BYTE PTR "n"
	  .ENDIF

;.....
;OBJECT.sztext4 has the return data string...
      mov szscr1+6,BYTE PTR " "
      mov al,(OBJECT PTR [edi]).sztext4
      .IF al==0
	      lea  eax,szer181b
	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	      mov  g_perrorobject,edi
	jmp zzzz    ;error exit.
      .ENDIF
      lea edx,(OBJECT PTR [edi]).sztext4
      invoke lstrcpy, ADDR szscr1+7, edx

;.....
;compose function prefix
    invoke lstrlen,ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    mov [ebx],BYTE PTR " "
    inc ebx
    lea eax,(OBJECT PTR [edi]).sztext6 ;func prefix
    invoke lstrcpy, ebx,eax

;......
;compose function-name...
;111000 ... have added a checkbox in node dialogbox, to select
;label is function-name, overrrides all deliberations below
;(but leave them in for now)...
	;top-level node must use label as funcname...
	cmp edi,pfnode
	je xz1
	;note, if node is public, must use label as funcname...
	mov al,(OBJECT PTR [edi]).fstatus2
	and al,0110b
	.IF al==0100b	;bits 2/1=10 public-visible node.
xz1:	  or (OBJECT PTR [edi]).fconfig,080h ;set bit7.
	.ELSEIF al==0110b ;bits 2/1=11 external node(libraryfunc only)
	  or (OBJECT PTR [edi]).fconfig,080h ;set bit7.
	.ENDIF
    mov al,(OBJECT PTR [edi]).fconfig	 ;bit7 is from checkbox.
    and al,080h
    jnz p14	    ;bit7=1 then use label.
;old stuff...
;if node has dblclk action to open a diagram, we use the label of
;the node as the functionname. this is cos it is public and visible
;across all files...  edi-->node
;will also extend this to first node in thread (pfnode), regardless
;whether it has open-diag-dblclk...
;also, any public node...
;also any external function...
	mov al,(OBJECT PTR [edi]).fstatus2
	and al,0110b
	cmp al,0100b	;bits 2/1=10 public-visible node.
	je  p14
	cmp al,0110b	;external node.
	je  p14
	cmp  edi,pfnode
	je   p14
	mov  al,(OBJECT PTR [edi]).fconfig
	  test al,80h		;bit7=1 force label is funcname.
	  jnz  p14		;/
	and  al,00011000b	;extracts bits 4/3.
	.IF  al==00011000b	;open-diagram dblclk action.
p14:	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
	  mov  [ebx],BYTE PTR " "
	  mov  [ebx+1],BYTE PTR 0
	  inc  ebx
	  mov  al,(OBJECT PTR [edi]).sztext1  ;szlabel
	  .IF  al==0		;error, no label.
t14:	      lea  eax,sznofer1
	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	      mov  g_perrorobject,edi
	      jmp  zzzz
	  .ELSE
	    ;(note no clones come here, as screened out clones before)
;	    ;must never have open-diagram-dblclk if a clone...
;	    mov	eax,(OBJECT PTR [edi]).rplock1 ;=0 not a clone,else->parent
;	    .IF	eax==0			;carry on as normal.
	      lea  eax,(OBJECT PTR [edi]).sztext1 ;szlabel
	      invoke lstrcpy, ebx, eax
	      invoke lstrlen, ADDR szscr1
	      lea	ebx,szscr1
	      add	ebx,eax
	      mov	[ebx],BYTE PTR "("
	      mov	[ebx+1],BYTE PTR 0
;	    .ELSE
;	      lea  eax,sznofer2
;u274:	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
;	      mov  g_perrorobject,edi
;	      jmp  zzzz
;	    .ENDIF
	  .ENDIF
	.ELSE			;carry on as normal...
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
	  mov  [ebx],BYTE PTR " "
	  inc ebx
	  mov  [ebx],BYTE PTR "n"
	  inc ebx
	  mov  [ebx],BYTE PTR 0
	  ;now compose the node number...
	  xor eax,eax
	  mov  ax,(OBJECT PTR [edi]).number
	  invoke binto5dec, ebx ;eax to dec.,retain ldg 0's.
	  add ebx,5
	  mov [ebx],BYTE PTR "("
	  inc ebx
	  mov [ebx],BYTE PTR 0
	.ENDIF

;....
;now compose passed datatypes...
    invoke lstrlen,ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    mov pstartparams,ebx    ;cos if void, but find shareable below.
      ;check for error...
      mov al,(OBJECT PTR [edi]).sztext5
      .IF al==0
	      lea  eax,szer181a
	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	      mov  g_perrorobject,edi
	jmp zzzz    ;error exit.
      .ENDIF
    lea eax,(OBJECT PTR [edi]).sztext5 ;passed datatypes
    invoke lstrcpy, ebx,eax

;.....
;if there are any shareable resources attached, need to pass pointers
;to them...
       mov fvoid,0
     mov cntshareable,0
     mov xpprev,0     ;used as placemarker in findchild, for repeat searches.
     mov xecxprev,0   ;/
gg1:  mov ecx,xpprev
      mov pprev,ecx
      mov ecx,xecxprev
      mov ecxprev,ecx
      invoke findchild, edi,4	;find child .nexttype=4
      ;...eax=addr child, =0 no child
      mov ecx,pprev
      mov xpprev,ecx
      mov ecx,ecxprev
      mov xecxprev,ecx
     cmp eax,0
     je gg2
     mov esi,eax
     mov al,(OBJECT PTR [esi]).fconfig
     and al,1100000b
     cmp al,0	    ;bits6/5=00 shareable (perm or temp)
     jne gg1	    ;keep looking.
     ;a problem is a temp-shareable is defined inside the node that owns
     ;it, so only passed to other nodes. this is very awkward.
     ;it can only be passed to next-down node, and is really redundant.
     ;i suggest we do away with it...
     mov al,(OBJECT PTR [esi]).fconfig
     test al,80h    ;bit7=1 temporary.
     jnz gg1	    ;keep looking.

       cmp fvoid,2
       je  gd1	    ;prevents code executing more than once.
       ;a problem is that the above prototype passed params already
       ;composed, may be "void". need to overwrite it, hence the
       ;pstartparams marker above...
       mov ebx,pstartparams
gd2:	mov al,[ebx]
       inc ebx
       cmp al,0
       je  gd1	    ;didn't find "void" string.
       cmp al,"v"
       jne gd2
	 mov al,[ebx]
	 .IF al=="o"
	   mov al,[ebx+1]
	   .IF al=="i"
	     mov al,[ebx+2]
	     .IF al=="d"
	       ;found "void"...
	       mov ebx,pstartparams
	       mov [ebx],BYTE PTR 0   ;gets rid of "void"
	       mov fvoid,1
	       jmp SHORT gd1
	     .ENDIF
	   .ENDIF
	 .ENDIF
	 jmp gd2
gd1:

       ;found shareable child, now compose pointer to it...
       ;compose child nmemtype2 before the "*"
       ;well, for simple variable want (..., datatype nmemtype1 *)"...
       ;*NOTE* we're not using names, so no need to mangle!
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
	    .IF fvoid != 1	    ;see above code.
	      mov [ebx],BYTE PTR ","
	      inc ebx
;	      mov [ebx],BYTE PTR " "
;	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF
	    mov fvoid,2	;prevents jumping code more than once.
       mov al,(OBJECT PTR [esi]).fstatus2
       and al,11100000b     ;extract bits7/6/5, variable type.

       .IF al==0	    ;simple variable.
	 invoke composeprimitivevar, esi,0,esi,0,0,0
	 .IF eax==-1
	   ret
	 .ENDIF

       .ELSEIF al==00100000b ;pointer.
	 ;a pointer can only have one directchild. so, compose the
	 ;child first,same as above, then compose the pointer...
	 ; "funca( ... , childdatatype childmemtype * ptrmemtype *)"
	 ;CAREFUL we are adding an extra pointer!
	 ;ok, child has to be private, nexttype=3...
	 ;esi -> pointer resource.

	   invoke composepointer1, esi,0,0	;***NOTE*** was composepointer0
	   ;...composes to the end of szscr1
	   ;...different from goofee as don't have variable names/mangle.
	   ;2ndlast param=0, compose extra "*", don't compose name.
	   ;last param =0 compose name (previous param overrides it)
	   cmp eax,-1
	   je  zzzz	;error exit.

       .ELSEIF al==01000000b ;structure
	 ;similar to the basic variable, except has "struct" before the
	 ;structure-type... "struct RECT memtype *"
	 ;ebx->end of szscr1, esi->structure-data-element
	      ;compose "struct"...
	      lea eax,szstruct
	      invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	       xor eax,eax
	       mov al,(OBJECT PTR [esi]).ndatatype
	    .IF al==0	      ;nothing selected.

	      ;***NOTE*** in future, structure-type=0 nothing selected,
	      ;will mean it will be a structure-template, not an
	      ;instantiation.

	    .ELSE
	      dec eax		;cos we ignore .ndatatype=0
	       mov ecx,48
	       mul ecx
	       push ebx
	       mov ebx,pTERSEDATA
	       lea ecx,(TERSEDATA PTR [ebx]).szptrtype1
	       pop ebx
	       add eax,ecx		;now have addr of string in eax.
	       invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF
	    mov al,(OBJECT PTR [esi]).nmemtype1
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [esi]).nmemtype1
	      dec al		;cos we ignore .nmemtype1=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR 0
	    .ENDIF
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR "*"
		inc ebx
		mov [ebx],BYTE PTR 0
		;compose mangled label, ptr_name...
		mov al,(OBJECT PTR [esi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,szptr_	  ;mangle prefix
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  lea eax,(OBJECT PTR [esi]).sztext1
		  invoke lstrcpy, ebx,eax
		.ENDIF


       .ELSEIF al==01100000b ;array
	 ;we want to pass a pointer to an array. well, if the array has
	 ;elements of primitive datatype, seems straightforward...
	 ; "ndatatype nmemetype2 *"
	 ;if the .ndatatype field is zero, means that array has
	 ;attached data-elements --NOT SUPPORTED THIS VERSION
	 ;ebx->end of szscr1, esi->array-data-element
	 mov al,(OBJECT PTR [esi]).ndatatype
	 .IF al==0
	   mov pprevsave,0
	   mov ecxprevsave,0
kg2:	   mov eax,pprevsave
	   mov pprev,eax
	   mov eax,ecxprevsave
	   mov ecxprev,eax
	   invoke findchild, esi,3
	   mov ecx,pprev
	   mov pprevsave,ecx
	   mov ecx,ecxprev
	   mov ecxprevsave,ecx
	   ;...esi is node to find the child of, 3 is the .nexttype to find.
	   ;returns eax=addr of found child, else eax=0 not found.
	   .IF eax==0
	     lea eax,szer3200b
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	   .ELSE
	     mov ebx,eax
	     mov al,(OBJECT PTR [ebx]).fstatus2 ;child data-element.
	     and al,11100000b
	     .IF al==0	    ;primitive variable type.
nn1:	       invoke composeprimitivearray, ebx,0,esi,0,0,0
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSEIF al==01000000b  ;structure
	       jmp nn1		    ;(treat as like primitivedata)
	     .ELSEIF al==01100000b  ;another array.
	       ;an array attached to an array. loop back until we find
	       ;the lowest one...
	       mov esi,ebx
	       mov al,(OBJECT PTR [esi]).ndatatype
	       cmp al,0
	       jne  kg1		    ; array has no child.
	       jmp  kg2 	    ; array has a child.
	     .ELSEIF al==00100000b  ;pointer.
	       ;have an array of pointers...
	       ;ebx->pointer, esi->lowest array.
	       ;0,0 on end causes compose "*ptr_name"...
	       invoke composearrayofpointers, ebx,esi,0,0
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSE
	       ;MODIFY THIS MESSAGE NEXT GOOSEE VERSION ***NOTE*** ...
	       lea eax,szer301
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	     .ENDIF
	   .ENDIF
	 .ELSE
kg1:	   invoke composeprimitivearray, esi,0,esi,0,0,0
	   .IF eax==-1
	     ret
	   .ENDIF
	 .ENDIF

       .ELSEIF al==10000000b ;generic
       .ENDIF


     inc cntshareable
     jmp gg1
gg2:
      invoke lstrlen,ADDR szscr1
      lea ebx,szscr1
      add ebx,eax
	  mov  [ebx],BYTE PTR ")"
	  mov  [ebx+1],BYTE PTR 0

w254:	;have composed passed parameters.

;......
;compose function postfix...
    invoke lstrlen,ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    mov [ebx],BYTE PTR " "
    inc ebx
    lea eax,(OBJECT PTR [edi]).sztext7 ;func postfix
    invoke lstrcpy, ebx,eax

;......
;write prototype to the file....
	invoke lstrlen, ADDR szscr1 ;length, not incl terminator0.
	lea  ebx,szscr1
	add  ebx,eax
	mov [ebx],BYTE PTR ";"
	inc ebx
	mov  [ebx],BYTE PTR 0Dh		;carriage return.
	mov  [ebx+1],BYTE PTR 0Ah	;line feed.
	mov  [ebx+2],BYTE PTR 0
	add  eax,3
	mov ebx,eax

;290900
;prototypes of public funcs can optionally be written to separate hdr file..
;note, edi-->current node in subdiagram.
  push ebx
  mov ebx,pTERSEDATA
  mov al,(TERSEDATA PTR [ebx]).fcodeprefs
  pop ebx
  and al,01	;bit0=1 write public func protos to header file.
  .IF al==01
    mov al,(OBJECT PTR [edi]).fstatus2
    and al,0110b
    .IF al==0100b	;public function. write to header file...
      invoke WriteFile, hdrhandle,ADDR szscr1,ebx,ADDR nbytes,0
    .ELSE
      jmp SHORT m1
    .ENDIF
  .ELSE
m1:    invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
  .ENDIF

;......
  jmp  look3	;checkout next node in database.
;................

zzzz:		;error
  mov	eax,-1
  ret
protod:

  ;211000 have placed ptrs to funcs into xsubtable.
  ;sort xsubtable, using node.nhierarchy.
  ;SORT CODE HERE...
    lea esi,xsubtable	;ptr1
us1:  mov edi,esi	;ptr2
      .IF esi==pxsubtable
	;end of table.
      .ELSE
	xor ebx,ebx
	xor edx,edx
	mov ecx,255   ;start with highest+1 nhierarchy value.
	  ;now scan thru rest of table, find lowest .nhierarchy...
us2:	  add edi,4
	  .IF edi==pxsubtable ;end of table
	  .ELSE
	    xor eax,eax
	    mov ebx,[edi]
	    .IF ebx==0	    ;precaution.
	    .ELSE
	      mov al,(OBJECT PTR [ebx]).nhierarchy
	      .IF al<cl
		mov cl,al     ;record lowest nhierarchy.
		mov edx,edi   ;table-entry, node with lowest hierarchy.
	      .ENDIF
	    .ENDIF
	    jmp us2
	  .ENDIF
;drops out here with cl=lowest hierarchy,edx-->table-entry,lowest node.
	;if lower, swap entries in table...
	mov ebx,[esi]
	.IF ebx==0	;precaution.
	.ELSE
	  mov al,(OBJECT PTR [ebx]).nhierarchy
	  .IF cl<al
	    .IF edx==0	    ;precaution.
	    .ELSE
	      mov edi,edx
	      mov eax,[esi]
	      mov ecx,[edi]
	      mov [esi],ecx
	      mov [edi],eax
	    .ENDIF
	  .ENDIF
	.ENDIF
	add esi,4	;next element.
	jmp us1
      .ENDIF

  ;211000 append xsubtable to end of subtable.
  ;subtable allows more than one subdiag to be composed to same C file.
  ;however, each subdiag needs nodes sorted, hence temp xsubtable.
    lea esi,xsubtable
    mov edi,psubtable
    lea edx,xsubtable
nxt1:	.IF esi==pxsubtable
	  ;xsubtable empty.
	.ELSE
	  mov eax,[esi]
	  mov [edi],eax
	  add edi,4
	  add psubtable,4
	  add esi,4
	    ;check size limit...
	    lea	eax,subtable
	    add	eax,(XNUMCIRC*4)	;size limit.
	    .IF	psubtable==eax
	      ;table is full, have exceeded allowed subdiag size...
	      mov eax,XNUMCIRC
	      invoke binto5dec, OFFSET szgen5 ;eax to dec.,retain ldg 0's.
	      invoke MessageBox,g_hwnd,ADDR szgener5,0,MB_OK+MB_ICONEXCLAMATION
	      jmp zzzz	;error exit.
	    .ELSE
	      jmp nxt1
	    .ENDIF
	.ENDIF


  mov  eax,0
  ret

composeprototypes ENDP
;------------------------------------------------------------------------
.DATA
szptr_ BYTE "ptr_",0
szer201a    BYTE "You have not wired a synchronous input execution-flow "
	    BYTE "wire to ring-1 of a node. The node will never be able "
	    BYTE "to execute.",0Dh,0Ah
	    BYTE "GOOSEE has aborted code generation and has highlighted "
	    BYTE "the offending node.",0
szer201b    BYTE "A function-node with its passed-parameter-datatypes "
	    BYTE "box set to ""void"", has a synchronous execution-flow "
	    BYTE "input wire to ring-1 that has passed parameters. "
	    BYTE "There must not be any passed parameters.",0Dh,0Ah
	    BYTE "GOOSEE has aborted code generation and has highlighted "
	    BYTE "the offending node.",0
szer201c    BYTE "A function-node with passed-parameter-datatypes "
	    BYTE "entered in its dialog box, has a synchronous "
	    BYTE "execution-flow input wire to ring-1 that does not "
	    BYTE "pass any parameters. The type and number of passed "
	    BYTE "parameters must match the prototype.",0Dh,0Ah
	    BYTE "GOOSEE has aborted code generation and has highlighted "
	    BYTE "the offending node.",0
szerms1     BYTE "The number of parameters passed via a synchronous "
	    BYTE "execution-flow wire into ring-1 of a "
	    BYTE "function-node does not match the prototype.",0Dh,0Ah
	    BYTE "GOOSEE has aborted code generation and has highlighted "
	    BYTE "the offending node.",0

.CODE
composefuncdefinition PROC STDCALL USES ebx ecx edx esi edi, \
			pnow:DWORD,pfnode:DWORD ,genhandle:DWORD
  LOCAL csave:DWORD,primaryisr:WORD,secondaryisr:WORD,fisisr:BYTE
  LOCAL bsave:DWORD
  LOCAL nbytes:DWORD
  LOCAL edisave:DWORD, ecxsave:DWORD
  LOCAL cntshareable:BYTE
  LOCAL pstartparams:DWORD
  LOCAL fvoid:BYTE
  LOCAL pprevsave:DWORD,ecxprevsave:DWORD
  LOCAL xpprev:DWORD,xecxprev:DWORD
;called from genmanycode()	     "composefuncdefinition"
;most of code copied from composeprototypes().
;composes the actual func definition prior to the actual data & code inside
;the function.

    mov edi,pnow
;compose the prototype...
	  invoke lstrcpy, ADDR szscr1, ADDR szstatic
;some functions will not have the static prefix...
;edi-->node
	  mov al,(OBJECT PTR [edi]).fstatus2
	  and al,0110b	    ;extract bits 2/1
	    ;if it's the first node in the thread, must be
	    ;public...
	    .IF edi==pfnode
	      and (OBJECT PTR [edi]).fstatus2,11111101b ;set bits2/1
	      or  (OBJECT PTR [edi]).fstatus2,00000100b  ; =10.
	      jmp mi1
	    .ENDIF

	  .IF al==0	;function is private, not implementable.
	    ;leave in"static" keyword...
	  .ELSEIF al==010b ;file-visible func.
	    ;leave in "static" keyword...
	  .ELSEIF al==100b ;public-visible func.
	    ;remove "static" keyword...
mi1:	    mov	szscr1,BYTE PTR " "	   ;remove "static" keyword.
	    mov  szscr1+1,BYTE PTR " "
	    mov  szscr1+2,BYTE PTR " "
	    mov  szscr1+3,BYTE PTR " "
	    mov  szscr1+4,BYTE PTR " "
	    mov  szscr1+5,BYTE PTR " "
	  .ELSE 	   ;=11 external func
	    ;put in "extern" keyword...
	    mov  szscr1,BYTE PTR "e"
	    mov  szscr1+1,BYTE PTR "x"
	    mov  szscr1+2,BYTE PTR "t"
	    mov  szscr1+3,BYTE PTR "e"
	    mov  szscr1+4,BYTE PTR "r"
	    mov  szscr1+5,BYTE PTR "n"
	  .ENDIF

;.....
;OBJECT.sztext4 has the return data string...
      mov szscr1+6,BYTE PTR " "
      mov al,(OBJECT PTR [edi]).sztext4
      .IF al==0
	      lea  eax,szer181b
	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	      mov  g_perrorobject,edi
	jmp zzzz    ;error exit.
      .ENDIF
      lea edx,(OBJECT PTR [edi]).sztext4
      invoke lstrcpy, ADDR szscr1+7, edx

;.....
;compose function prefix
    invoke lstrlen,ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    mov [ebx],BYTE PTR " "
    inc ebx
    lea eax,(OBJECT PTR [edi]).sztext6 ;func prefix
    invoke lstrcpy, ebx,eax

;......
;if node has dblclk action to open a diagram, we use the label of
;the node as the functionname. this is cos it is public and visible
;across all files...  di-->node
;will also extend this to first node in thread (pfnode), regardless
;whether it has open-diag-dblclk...
;also, any public node...
;also any external function...
	mov al,(OBJECT PTR [edi]).fstatus2
	and al,0110b
	cmp al,0100b	;bits 2/1=10 public-visible node.
	je  p14
	cmp al,0110b	;external node.
	je  p14
	cmp  edi,pfnode
	je   p14
	mov  al,(OBJECT PTR [edi]).fconfig
	  test al,80h		;bit7=1 force label is funcname.
	  jnz  p14		;/
	and  al,00011000b	;extracts bits 4/3.
	.IF  al==00011000b	;open-diagram dblclk action.
p14:	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
	  mov  [ebx],BYTE PTR " "
	  mov  [ebx+1],BYTE PTR 0
	  inc  ebx
	  mov  al,(OBJECT PTR [edi]).sztext1  ;szlabel
	  .IF  al==0		;error, no label.
t14:	      lea  eax,sznofer1
	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	      mov  g_perrorobject,edi
	      jmp  zzzz
	  .ELSE
	    ;(note no clones come here, as screened out clones before)
;	    ;must never have open-diagram-dblclk if a clone...
;	    mov	eax,(OBJECT PTR [edi]).rplock1 ;=0 not a clone,else->parent
;	    .IF	eax==0			;carry on as normal.
	      lea  eax,(OBJECT PTR [edi]).sztext1 ;szlabel
	      invoke lstrcpy, ebx, eax
	      invoke lstrlen, ADDR szscr1
	      lea	ebx,szscr1
	      add	ebx,eax
	      mov	[ebx],BYTE PTR "("
	      mov	[ebx+1],BYTE PTR 0
;	    .ELSE
;	      lea  eax,sznofer2
;u274:	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
;	      mov  g_perrorobject,edi
;	      jmp  zzzz
;	    .ENDIF
	  .ENDIF
	.ELSE			;carry on as normal...
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
	  mov  [ebx],BYTE PTR " "
	  inc ebx
	  mov  [ebx],BYTE PTR "n"
	  inc ebx
	  mov  [ebx],BYTE PTR 0
	  ;now compose the node number...
	  xor eax,eax
	  mov  ax,(OBJECT PTR [edi]).number
	  invoke binto5dec, ebx ;eax to dec.,retain ldg 0's.
	  add ebx,5
	  mov [ebx],BYTE PTR "("
	  inc ebx
	  mov [ebx],BYTE PTR 0
	.ENDIF

;....
;before can compose passed datatypes, must locate passed params...
;NOTE, for checking # passed = # in protottype only.
; -- i'm now insisting on prototype have variable names.
    invoke findinnerinwire,edi,pfnode
    .IF	eax==0		;no i/p wire
      mov pr1wire,0    ;**WARNING** <<<BE CAREFUL USING THIS BELOW<<<<
      cmp edi,pfnode  ;1st node doesn't need i/p wire.
      je compp	      ;bypass error checking.<<<NOTE<<<
	;*ALSO* look in "highlighted" list, when composing multiple
	;top-level nodes...
	.IF highlightedindex==0     ;nothing in list.
	.ELSE
	  pushad
	  mov ebx,0
	  lea esi,highlighted
end2:	  mov eax,highlightedindex
	  shl eax,1
	  shl eax,1
	  cmp ebx,eax
	  je end1	    ;get out.
	  mov edi,[esi+ebx]
	  cmp edi,0
	  je end2b	    ;precaution.
	  ;have a node from list, edi->node...
	  .IF edi==pnow
	    popad
	    jmp compp	;bypass error checking.
	  .ENDIF
end2b:
	  add ebx,4
	  jmp end2
end1:	  popad
	  ;failed to find it in list...
	.ENDIF
      lea eax,szer201a
      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
      mov  g_perrorobject,edi
      jmp  zzzz
    .ELSEIF eax==1	;found i/p wire
	mov pr1wire,esi ;returned from func  note pr1wire is global.
    .ELSEIF eax==-1	;error.
      jmp  zzzz
    .ENDIF

;....
;now compose passed datatypes...
      ;check for error...
      mov al,(OBJECT PTR [edi]).sztext5 ;passed datatypes.
      .IF al==0
	      lea  eax,szer181a
	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	      mov  g_perrorobject,edi
	jmp zzzz    ;error exit.
      .ELSE
	;so, we have passed datatypes. if not "void", must check that
	;passed params on innerinwire also there...
	;edi->node, pr1wire->input wire.
	;find "void" string in node.sztext5...
	  lea ebx,(OBJECT PTR [edi]).sztext5
gd2:	  mov al,[ebx]
	  inc ebx
	  cmp al,0
	  je  gd1	    ;didn't find "void" string.
	  cmp al,"v"
	  jne gd2
	  mov al,[ebx]
	  .IF al=="o"
	    mov al,[ebx+1]
	    .IF al=="i"
	      mov al,[ebx+2]
	      .IF al=="d"
		;found "void"...
		;now see if any params passed...
		mov ebx,pr1wire
		mov al,(OBJECT PTR [ebx]).sztext1   ;passed params
		.IF al==0
		.ELSE
		  lea  eax,szer201b
gdw1:		  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		  mov  g_perrorobject,edi
		  jmp zzzz	;error exit.
		.ENDIF
		jmp SHORT gd1x
	      .ENDIF
	    .ENDIF
	  .ENDIF
	  jmp gd2
gd1:	  ;so, have passed datatypes. check for passed params...
	  mov ebx,pr1wire
	  mov al,(OBJECT PTR [ebx]).sztext1
	  .IF al==0
	    lea eax,szer201c
	    jmp gdw1
	  .ENDIF
gd1x:
      .ENDIF

compp:
;    mov ebx,pr1wire
;  .IF ebx==0	 ;no input wire!
;
;    ;invoke lstrcpy, ebx,eax
;  .ELSE
;    lea ecx,(OBJECT PTR [ebx]).sztext1	;passed params
;    push ecx
;    invoke lstrlen,ADDR szscr1
;    pop ecx
;    lea ebx,szscr1
;    add ebx,eax
;    mov pstartparams,ebx    ;cos if void, but find shareable below.
;    lea eax,(OBJECT PTR [edi]).sztext5 ;passed datatypes
;    ;merge datatypes with param names and write to scscr1...
;    invoke mergestrings, ebx,eax,ecx
;    .IF eax==-1
;      lea eax,szerms1
;      jmp gdw1
;    .ENDIF
;  .ENDIF

    invoke lstrlen,ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    mov pstartparams,ebx    ;cos if void, but find shareable below.
    lea eax,(OBJECT PTR [edi]).sztext5 ;passed datatypes
    invoke lstrcpy, ebx,eax

;.....
;if there are any shareable resources attached, need to pass pointers
;to them...
       mov fvoid,0
     mov cntshareable,0
     mov xpprev,0     ;used as placemarker in findchild, for repeat searches.
     mov xecxprev,0   ;/
gg1:  mov ecx,xpprev
      mov pprev,ecx
      mov ecx,xecxprev
      mov ecxprev,ecx
      invoke findchild, edi,4	;find child .nexttype=4
      mov ecx,pprev
      mov xpprev,ecx
      mov ecx,ecxprev
      mov xecxprev,ecx
     ;...eax=addr child, =0 no child
     cmp eax,0
     je gg2
     mov esi,eax
     mov al,(OBJECT PTR [esi]).fconfig
     and al,1100000b
     cmp al,0	    ;bits6/5=00 shareable (perm or temp)
     jne gg1	    ;keep looking.
     ;a problem is a temp-shareable is defined inside the node that owns
     ;it, so only passed to other nodes. this is very awkward.
     ;it can only be passed to next-down node, and is really redundant.
     ;i suggest we do away with it...
     mov al,(OBJECT PTR [esi]).fconfig
     test al,80h    ;bit7=1 temporary.
     jnz gg1	    ;keep looking.

       cmp fvoid,2
       je  zgd1	    ;prevents code executing more than once.
       ;a problem is that the above prototype passed params already
       ;composed, may be "void". need to overwrite it, hence the
       ;pstartparams marker above...
       mov ebx,pstartparams
zgd2:	mov al,[ebx]
       inc ebx
       cmp al,0
       je  zgd1	    ;didn't find "void" string.
       cmp al,"v"
       jne zgd2
	 mov al,[ebx]
	 .IF al=="o"
	   mov al,[ebx+1]
	   .IF al=="i"
	     mov al,[ebx+2]
	     .IF al=="d"
	       ;found "void"...
	       mov ebx,pstartparams
	       mov [ebx],BYTE PTR 0   ;gets rid of "void"
	       mov fvoid,1
	       jmp SHORT zgd1
	     .ENDIF
	   .ENDIF
	 .ENDIF
	 jmp zgd2
zgd1:

       ;found shareable child, now compose pointer to it...
       ;compose child nmemtype2 before the "*"
       ;well, for simple variable want (..., datatype nmemtype1 *ptr_name)"...
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
	    .IF fvoid != 1	    ;see above code.
	      mov [ebx],BYTE PTR ","
	      inc ebx
;	      mov [ebx],BYTE PTR " "
;	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF
	    mov fvoid,2	;prevents jumping code more than once.
       mov al,(OBJECT PTR [esi]).fstatus2
       and al,11100000b     ;extract bits7/6/5, variable type.

       .IF al==0	    ;simple variable.
	 invoke composeprimitivevar, esi,0,esi,0,0,0
	 .IF eax==-1
	   ret
	 .ENDIF

       .ELSEIF al==00100000b ;pointer.
	 ;a pointer can only have one directchild. so, compose the
	 ;child first,same as above, then compose the pointer...
	 ; "funca( ... , childdatatype childmemtype * ptrmemtype *)"
	 ;CAREFUL we are adding an extra pointer!
	 ;ok, child has to be private, nexttype=3...
	 ;esi -> pointer resource.

	   invoke composepointer1, esi,0,0	;***NOTE*** was composepointer0
	   ;...composes to the end of szscr1
	   ;...different from goofee as don't have variable names/mangle.
	   ;2ndlast param=0, compose extra "*", don't compose name.
	   ;last param =0 compose name (previous param overrides it)
	   cmp eax,-1
	   je  zzzz	;error exit.

       .ELSEIF al==01000000b ;structure
	 ;similar to the basic variable, except has "struct" before the
	 ;structure-type... "struct RECT memtype *"
	 ;ebx->end of szscr1, esi->structure-data-element
	      ;compose "struct"...
	      lea eax,szstruct
	      invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	       xor eax,eax
	       mov al,(OBJECT PTR [esi]).ndatatype
	    .IF al==0	      ;nothing selected.

	      ;***NOTE*** in future, structure-type=0 nothing selected,
	      ;will mean it will be a structure-template, not an
	      ;instantiation.

	    .ELSE
	      dec eax		;cos we ignore .ndatatype=0
	       mov ecx,48
	       mul ecx
	       push ebx
	       mov ebx,pTERSEDATA
	       lea ecx,(TERSEDATA PTR [ebx]).szptrtype1
	       pop ebx
	       add eax,ecx		;now have addr of string in eax.
	       invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF
	    mov al,(OBJECT PTR [esi]).nmemtype1
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [esi]).nmemtype1
	      dec al		;cos we ignore .nmemtype1=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR 0
	    .ENDIF
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR "*"
		inc ebx
		mov [ebx],BYTE PTR 0
		;compose mangled label, ptr_name...
		mov al,(OBJECT PTR [esi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,szptr_	  ;mangle prefix
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  lea eax,(OBJECT PTR [esi]).sztext1
		  invoke lstrcpy, ebx,eax
		.ENDIF


       .ELSEIF al==01100000b ;array
	 ;we want to pass a pointer to an array. well, if the array has
	 ;elements of primitive datatype, seems straightforward...
	 ; "ndatatype nmemetype2 *"
	 ;if the .ndatatype field is zero, means that array has
	 ;attached data-elements --NOT SUPPORTED THIS VERSION
	 ;ebx->end of szscr1, esi->array-data-element
	 mov al,(OBJECT PTR [esi]).ndatatype
	 .IF al==0
	   mov pprevsave,0
	   mov ecxprevsave,0
kg2:	   mov eax,pprevsave
	   mov pprev,eax
	   mov eax,ecxprevsave
	   mov ecxprev,eax
	   invoke findchild, esi,3
	   mov ecx,pprev
	   mov pprevsave,ecx
	   mov ecx,ecxprev
	   mov ecxprevsave,ecx
	   ;...esi is node to find the child of, 3 is the .nexttype to find.
	   ;returns eax=addr of found child, else eax=0 not found.
	   .IF eax==0
	     lea eax,szer3200b
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	   .ELSE
	     mov ebx,eax
	     mov al,(OBJECT PTR [ebx]).fstatus2 ;child data-element.
	     and al,11100000b
	     .IF al==0	    ;primitive variable type.
nn1:	       invoke composeprimitivearray, ebx,0,esi,0,0,0
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSEIF al==01000000b  ;structure
	       jmp nn1		    ;(treat as like primitivedata)
	     .ELSEIF al==01100000b  ;another array.
	       ;an array attached to an array. loop back until we find
	       ;the lowest one...
	       mov esi,ebx
	       mov al,(OBJECT PTR [esi]).ndatatype
	       cmp al,0
	       jne  kg1		    ; array has no child.
	       jmp  kg2 	    ; array has a child.
	     .ELSEIF al==00100000b  ;pointer.
	       ;have an array of pointers...
	       ;ebx->pointer, esi->lowest array.
	       ;0,0 on end causes compose "*ptr_name"...
	       invoke composearrayofpointers, ebx,esi,0,0
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSE
	       ;MODIFY THIS MESSAGE NEXT GOOSEE VERSION ***NOTE*** ...
	       lea eax,szer301
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	     .ENDIF
	   .ENDIF
	 .ELSE
kg1:	   invoke composeprimitivearray, esi,0,esi,0,0,0
	   .IF eax==-1
	     ret
	   .ENDIF
	 .ENDIF


       .ELSEIF al==10000000b ;generic
       .ENDIF


     inc cntshareable
     jmp gg1
gg2:
      invoke lstrlen,ADDR szscr1
      lea ebx,szscr1
      add ebx,eax
	.IF eax>0
	  dec ebx
	  mov al,[ebx]
	  .IF al==","
	  .ELSE
	    inc ebx
	  .ENDIF
	.ENDIF
	  mov  [ebx],BYTE PTR ")"
	  mov  [ebx+1],BYTE PTR 0

w254:	;have composed passed parameters.

;......
;compose function postfix...
    invoke lstrlen,ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    mov [ebx],BYTE PTR " "
    inc ebx
    lea eax,(OBJECT PTR [edi]).sztext7 ;func postfix
    invoke lstrcpy, ebx,eax

;......
;write prototype to the file....
	invoke lstrlen, ADDR szscr1 ;length, not incl terminator0.
	lea  ebx,szscr1
	add  ebx,eax
	mov [ebx],BYTE PTR "{"
	inc ebx
	mov  [ebx],BYTE PTR 0Dh		;carriage return.
	mov  [ebx+1],BYTE PTR 0Ah	;line feed.
	mov  [ebx+2],BYTE PTR 0
	add  eax,3
	mov ebx,eax
  invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0


protod:
  mov  eax,0
  ret
zzzz:		;error
  mov	eax,-1
  ret
composefuncdefinition ENDP
;------------------------------------------------------------------------
mergestrings PROC STDCALL USES ebx ecx edx esi edi, \
		    pdest:DWORD,pdatatypes:DWORD,pparams:DWORD
    LOCAL flips:BYTE
    LOCAL fdataend:BYTE
;called from composefuncdefinition.
;merges comma-delemited strings and writes to pdest.
;return eax=-1 if error.

    mov fdataend,0
    mov edi,pdest
    mov ebx,pdatatypes
    mov esi,pparams

    mov al,[ebx]
    .IF al==0
      xor eax,eax
      ret
    .ENDIF
		    pushad
		    invoke MessageBeep,-1
		    popad
    mov al,[esi]
    .IF al==0
      xor eax,eax
      ret
    .ENDIF


n274:		  mov flips,0	;flag now on datatype.
		    cmp fdataend,1
		    je k274	;get out
		  mov al,[ebx]
		  inc ebx
		  cmp al,0
		  jne p274
		    ;we've reached end of datatype string, so set flag...
		    mov fdataend,1
		  mov al," "
p274:		  cmp al,","
		  jne j274
		  mov al," "
j274:		  mov [edi],al
		  inc edi
		  cmp al," "
		  je  m274
		  jmp n274
m274:		  mov flips,1	;flag now on param
		  mov al,[esi]
		  inc esi
		  mov [edi],al
		  inc edi
		  cmp al,0
		  je  k274x		;finished.
		  cmp al,","
		  je  n274
		  jmp m274

k274x:
    cmp fdataend,0  ;too many datatypes.
    je	xx1
k274:
    .IF flips==0    ;unequal # of datatypes and params.
xx1:	mov eax,-1
      mov [edi],BYTE PTR 0 ;precaution.
      ret
    .ELSE
      xor eax,eax
      mov [edi],BYTE PTR 0 ;precaution.
      ret
    .ENDIF
mergestrings ENDP
;------------------------------------------------------------------------
.DATA
szerpnc1    BYTE "GOOSEE has found an error in the diagram and is aborting "
	    BYTE "code generation.",0Dh,0Ah
	    BYTE "A pointer-data-element must have a data element attached "
	    BYTE "to it, to define the datatype it points to. GOOSEE has "
	    BYTE "highlighted the offending pointer.",0
szer181d    BYTE "GOOSEE has found a problem with a datatype-node. "
	    BYTE "This is a child-node attached to a pointer data element. "
	    BYTE "As this child-node is only a datatype specifier for "
	    BYTE "the pointer, defining it as a pointer to a function, "
	    BYTE "it does not have a full prototype entered into its "
	    BYTE "dialog box -- however, it must have the return-datatype "
	    BYTE "entry. For example, if the function is to return a "
	    BYTE """int"" datatype, enter ""int"" into the edit box."
	    BYTE 0Dh,0Ah
;	    BYTE "If your C compiler requires it, you may also enter the "
;	    BYTE "passed-parameter datatypes.",0Dh,0Ah
	    BYTE "GOOSEE has highlighted the offending node. Right-"
	    BYTE "click on it to make the correction.",0

.CODE
composepointer1 PROC STDCALL USES ebx ecx edx esi edi, pptr:DWORD, \
			   fsuppress:DWORD,nlevel:DWORD
    LOCAL xpprev:DWORD
    LOCAL xecxprev:DWORD
    LOCAL pprevsave:DWORD,ecxprevsave:DWORD
;called from composeglobaldata()    "composepointer1"
;based on composepointer0(), but composes variable name also,
;(and doesn't have the extra "*")
;the data is a pointer. pptr	-> the pointer element.
;return eax=-1 error.
;NOTE i think will combine composepointer0 into this one.
;so following notes apply...
;called from composeprototypes()
;compose passed shareable, but don't compose variable name nor mangle.
;the passed data is a pointer. pptr	-> the pointer element.
;return eax=-1 error. eax=1 composition complete. eax=0 normal return.

;because shareable rsource is being passed by reference, and extra "*"
;is appended to the normal data definition. However, I call this
;func from composepointer1(), as this func composes without the variable
;name. however, need to suppress the extra "*" -- fsuppress=1.

;only compose variable name when nlevel=0.(recursive calls will have it
;set to 1)

    mov edi,pptr

    ;findchild uses two global variables, pprev and ecxprev, as
    ;placemarkers for repeat searches. composeprototypes() is in a
    ;loop calling it repeatedly and inside that loop also calls this
    ;func. so, save the globals...
      mov eax,pprev
      mov xpprev,eax
      mov eax,ecxprev
      mov xecxprev,eax
    mov pprev,0	;search from beginning of database.
    invoke findchild, edi,0 ;find .nexttype=any, directly connected to pptr.
      mov edx,xpprev
      mov pprev,edx
      mov edx,xecxprev
      mov ecxprev,edx
    ;...returns eax=addr of child, else eax=0 not found.
    ;if eax=0, error...
    .IF eax==0
      lea eax,szerpnc1
      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
      mov  g_perrorobject,edi
      mov eax,-1
      ret
    .ENDIF


    mov esi,eax
  mov ax,(OBJECT PTR [esi]).nexttype
  .IF ax==3	;private resource (all children res's must be)
    mov al,(OBJECT PTR [esi]).fstatus2
    and al,11100000b

    .IF al==0		;simple variable
      ;this is the easiest. compose as...
      ; "childdatatype childmemtype * ptrmemtype name"
      ;esi->child-of-pointer, edi->pointer.
      invoke composeprimitivevar, esi,1,edi,fsuppress,nlevel,0
      .IF eax==-1
	ret
      .ENDIF
      ;done...
      xor eax,eax
      ret

    .ELSEIF al==00100000b ;pointer

      ;so, have a pointer to a pointer...
      ;esi -> pointer-to-pointer element, edi -> pointer element.
      ;good place for recursion...
      invoke composepointer1, esi,1,1	;composepointer0() composes without
				    ;variable name. 2ndlastparam suppresses
				    ;the extra "*",allows name composition,
	     ;unless last aparam=1 suppresses name composition
      .IF eax==-1
	ret	    ;error.
      .ELSEIF eax==1 ;composition complete.
	ret
      .ELSE
	;now compose the top pointer element (edi)...
	  ;edi->pointer.
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	    mov [ebx],BYTE PTR "*"
	    inc ebx
	    mov [ebx],BYTE PTR " "
	    inc ebx
	    mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [edi]).nmemtype2
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [edi]).nmemtype2
	      dec al		;cos we ignore .nmemtype2=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF
	  ;now compose name...if fsuppress!=0...
	    .IF fsuppress==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR "*"
		inc ebx
		mov [ebx],BYTE PTR 0
		;compose mangled label, ptr_name...
	      .IF nlevel==0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,szptr_	  ;mangle prefix
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		.ENDIF
	      .ENDIF
	    .ELSE
	      .IF nlevel==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR 0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		  ;if this is shareable, mangle it with its own element#...
		  mov ax,(OBJECT PTR [edi]).nexttype
		  .IF ax==4
		    mov al,(OBJECT PTR [edi]).fconfig
		    and al,01100000b
		    .IF al==0
		      invoke lstrlen, ADDR szscr1
		      lea ebx,szscr1
		      add ebx,eax
		      xor eax,eax
		      mov ax,(OBJECT PTR [edi]).number
		      invoke binto5dec, ebx ;appends element#
		      add ebx,5
		      mov [ebx],BYTE PTR 0
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	    .ENDIF
	;done...
	xor eax,eax
	ret
      .ENDIF

    .ELSEIF al==01000000b ;structure
      ;esi->child-of-pointer, edi->pointer.
      ;firstly, compose child...
	invoke lstrlen,ADDR szscr1
	lea ebx,szscr1
	add ebx,eax
	lea eax,szstruct
	invoke lstrcpy, ebx,eax
	invoke lstrlen,ADDR szscr1
	lea ebx,szscr1
	add ebx,eax
	     xor eax,eax
	     mov al,(OBJECT PTR [esi]).ndatatype
	     .IF al==0	    ;nothing selected.
	     .ELSE
	       dec eax
	       mov ecx,48
	       mul ecx
	       push ebx
	       mov ebx,pTERSEDATA
	       lea ecx,(TERSEDATA PTR [ebx]).szptrtype1
	       pop ebx
	       add eax,ecx		;now have addr of string in eax.
	       invoke lstrcpy, ebx,eax
	     .ENDIF
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [esi]).nmemtype1
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [esi]).nmemtype1
	      dec al		;cos we ignore .nmemtype1=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF
	  ;now compose the pointer...
	  ;edi->pointer.
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	    mov [ebx],BYTE PTR "*"
	    inc ebx
	    mov [ebx],BYTE PTR " "
	    inc ebx
	    mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [edi]).nmemtype2
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [edi]).nmemtype2
	      dec al		;cos we ignore .nmemtype2=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF
	  ;now compose name...if fsuppress!=0...
	    .IF fsuppress==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR "*"
		inc ebx
		mov [ebx],BYTE PTR 0
		;compose mangled label, ptr_name...
	      .IF nlevel==0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,szptr_	  ;mangle prefix
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		.ENDIF
	      .ENDIF
	    .ELSE
	      .IF nlevel==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR 0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		  ;if this is shareable, mangle it with its own element#...
		  mov ax,(OBJECT PTR [edi]).nexttype
		  .IF ax==4
		    mov al,(OBJECT PTR [edi]).fconfig
		    and al,01100000b
		    .IF al==0
		      invoke lstrlen, ADDR szscr1
		      lea ebx,szscr1
		      add ebx,eax
		      xor eax,eax
		      mov ax,(OBJECT PTR [edi]).number
		      invoke binto5dec, ebx ;appends element#
		      add ebx,5
		      mov [ebx],BYTE PTR 0
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	    .ENDIF
      ;done...
      xor eax,eax
      ret


    .ELSEIF al==01100000b ;array
      ; "childdatatype childmemtype * ptrmemtype name"
      ;esi->child-of-pointer, edi->pointer.
	 mov al,(OBJECT PTR [esi]).ndatatype
	 .IF al==0
	   mov pprevsave,0
	   mov ecxprevsave,0
kg2:	   mov eax,pprevsave
	   mov pprev,eax
	   mov eax,ecxprevsave
	   mov ecxprev,eax
	   invoke findchild, esi,3
	   mov ecx,pprev
	   mov pprevsave,ecx
	   mov ecx,ecxprev
	   mov ecxprevsave,ecx
	   ;...esi is node to find the child of, 3 is the .nexttype to find.
	   ;returns eax=addr of found child, else eax=0 not found.
	   .IF eax==0
	     lea eax,szer3200b
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	   .ELSE
	     mov ebx,eax
	     mov al,(OBJECT PTR [ebx]).fstatus2 ;child data-element.
	     and al,11100000b
	     .IF al==0	    ;primitive variable type.
nn1:	       mov eax,ebx  ;pass this into composeprimitivearray().
	       invoke composeprimitivearray,esi,1,edi,fsuppress,nlevel,0
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSEIF al==01000000b  ;structure
	       jmp nn1		    ;(treat as like primitivedata)
	     .ELSEIF al==01100000b  ;another array.
	       ;an array attached to an array. loop back until we find
	       ;the lowest one...
	       mov esi,ebx
	       mov al,(OBJECT PTR [esi]).ndatatype
	       cmp al,0
	       jne  kg1		    ; array has no child.
	       jmp  kg2 	    ; array has a child.
	     .ELSEIF al==00100000b  ;pointer.
	       ;have an array of pointers...
	       ;ebx->pointer, esi->lowest array.
	       ;0,0 on end causes compose "*ptr_name"...
	       ;1,0 composes "*name[size]"
	       invoke composearrayofpointers, ebx,esi,fsuppress,nlevel
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSE
	       ;MODIFY THIS MESSAGE NEXT GOOSEE VERSION ***NOTE*** ...
	       lea eax,szer301
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	     .ENDIF
	   .ENDIF
	 .ELSE
kg1:	   invoke composeprimitivearray, esi,1,edi,fsuppress,nlevel,0
	   .IF eax==-1
	     ret
	   .ENDIF
	 .ENDIF
      ;done...
      xor eax,eax
      ret

    .ELSEIF al==10000000b ;generic
    .ENDIF

  .ELSEIF ax==0     ;child is a node, attached to a pointer res.

    ;so, a pointer to a function...
    ;need to compose "returntype (* ptrmemtype name) ();"
    ;there is a complication... must handle a ptr-to-a-ptr-to-a-function:
    ; "returntype (* childptrmemtype * ptrmemtype name) ();"
    ;we have to complete the composition while here, and return eax=1.
    ;esi -> node, edi -> pointer.
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	      mov al,(OBJECT PTR [esi]).sztext4
	      .IF al==0  ;error...
		lea  eax,szer181d
		invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
	      .ELSE
		lea eax,(OBJECT PTR [esi]).sztext4    ;node return datatype.
		invoke lstrcpy, ebx,eax
	      .ENDIF
	    invoke lstrlen, ADDR szscr1
	    lea ebx,szscr1
	    add ebx,eax
	    mov [ebx],BYTE PTR " "
	    inc ebx
	    mov [ebx],BYTE PTR "("
	    inc ebx
	    mov [ebx],BYTE PTR "*"
	    inc ebx
	    mov [ebx],BYTE PTR " "
	    inc ebx
	    mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [edi]).nmemtype2
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [edi]).nmemtype2
	      dec al		;cos we ignore .nmemtype2=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF

	    ;now for special problem...
	    ;see if owner of ptr is also a ptr...
	    mov ebx,(OBJECT PTR [edi]).rplock1
	    .IF ebx==0
	    .ELSE
	      add ebx,pTERSEDATA
	      mov ax,(OBJECT PTR [ebx]).nexttype
	      .IF ax==3
		jmp SHORT www1
	      .ELSEIF ax==4
www1:		mov al,(OBJECT PTR [ebx]).fstatus2
		and al,11100000b
		.IF al==00100000b
		  ;parent is a ptr, so we have ptr to ptr to func...
		  ;compose stuff for parent...
		  ;we will change edi to point to parent-ptr...
		  mov edi,ebx
		    invoke lstrlen, ADDR szscr1
		    lea ebx,szscr1
		    add ebx,eax
		    mov [ebx],BYTE PTR " "
		    inc ebx
		    mov [ebx],BYTE PTR "*"
		    inc ebx
		    mov [ebx],BYTE PTR " "
		    inc ebx
		    mov [ebx],BYTE PTR 0
		    mov al,(OBJECT PTR [edi]).nmemtype2
		  .IF al==0	      ;nothing selected.
		  .ELSE
		      xor eax,eax
		      mov al,(OBJECT PTR [edi]).nmemtype2
		      dec al		;cos we ignore .nmemtype2=0
		      mov ecx,48
		      mul ecx
		      push ebx
		      mov ebx,pTERSEDATA
		      lea ecx,(TERSEDATA PTR [ebx]).szpre1
		      pop ebx
		      add eax,ecx		;now have addr of string in eax.
		      invoke lstrcpy, ebx,eax
		  .ENDIF
		.ENDIF
	      .ENDIF
	    .ENDIF

	    ;ignore nlevel, as effectively jumping up a level here
	    ;to complete the composition...
	    ;compose name, if fsuppress != 0...
	    .IF fsuppress==0
		    invoke lstrlen, ADDR szscr1
		    lea ebx,szscr1
		    add ebx,eax
		mov [ebx],BYTE PTR "*"	;extra * cos passing ptr to shareable.
		inc ebx
		mov [ebx],BYTE PTR 0
		;compose mangled label, ptr_name...
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,szptr_	  ;mangle prefix
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		.ENDIF

	    .ELSE
	      ;ignore nlevel, as need to complete composition here...
	      ;.IF nlevel==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  mov [ebx],BYTE PTR " "
		  inc ebx
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		  ;if this is shareable, mangle it with its own element#...
		  mov ax,(OBJECT PTR [edi]).nexttype
		  .IF ax==4
		    mov al,(OBJECT PTR [edi]).fconfig
		    and al,01100000b
		    .IF al==0
		      invoke lstrlen, ADDR szscr1
		      lea ebx,szscr1
		      add ebx,eax
		      xor eax,eax
		      mov ax,(OBJECT PTR [edi]).number
		      invoke binto5dec, ebx ;appends element#
		      add ebx,5
		      mov [ebx],BYTE PTR 0
		    .ENDIF
		  .ENDIF
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		.ENDIF
	      ;.ENDIF
	    .ENDIF
	      mov [ebx],BYTE PTR ")"
	      inc ebx
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR "("
	      inc ebx
	      mov [ebx],BYTE PTR 0
		;let's also compose the passed datatypes...
		;does any C compiler require this?
		;MAKE THIS OPTIONAL --NO ERROR CHECK
		lea eax,(OBJECT PTR [esi]).sztext5 ;node passed datatypes.
		invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR ")"
	      inc ebx
	      mov [ebx],BYTE PTR 0
	  ;must return eax=1, means composition complete.
	  mov eax,1
	  ret
  .ENDIF

    xor eax,eax
    ret
zzzz:
    mov eax,-1
    ret
composepointer1 ENDP
;------------------------------------------------------------------------
find1stnode PROC STDCALL USES ecx edx esi edi,p1stnode:DWORD,pznode:DWORD
  LOCAL ncounthierarchy:DWORD
; "find1stnode"
;called from composeprototypes().
;pznode is the current node. want to find out if it is part of the
;subdiagram starting from p1stnode. trace sync i/p wires into ring-1
;back from pznode to locate p1stnode -- if found, is in subdiagram.
;returns ax=-1 error, =0 not in subdiag =1 yes is in subdiag.
;composeprototypes() needs ptr to entire wire. returns pr1wire.

;211000
;now counts how far down in the diagram hierarchy from top-node,
;in ncountnodes, returns in ebx.

  mov  edi,pznode
  mov ncounthierarchy,0

  cmp  edi,p1stnode	;is node the highlighted one?
  jne  look1
r254:
  invoke findinnerinwire,edi,p1stnode
  .IF  eax==0		;no i/p wire
    jmp  zzok
  .ELSEIF eax==1	;found 1 sync i/p wire
tstx:
;composeprototypes() needs ptr to entire wire object...
	mov pr1wire,esi
	mov  eax,1
      jmp  zzok
  .ELSEIF eax==-1	;error.
      jmp  xerr
  .ELSE 		;found more than 1 sync i/p wire...
    jmp xerr
  .ENDIF
  jmp	zzok	;...special case, first node in sub-diagram.

;........
look1:
  invoke findinnerinwire, edi,p1stnode ;rets esi=ptr to wire,eax=0/1 ok.
	.IF eax==0
	  ;no wire found...
	  jmp  zzno
	.ELSEIF eax==1	;(eax=count of #i/p sync wires found)
	      ;211000 count hierarchy (how far down from top)...
	      inc ncounthierarchy
	  ;esi points to sync. i/p wire at ring-1...
	    ;if wire is i/p to current wire, load plabel...
	    .IF  edi==pznode
	      ;composeprototypes() needs ptr to entire wire object...
	      mov  pr1wire,esi
	    .ENDIF
	  mov edi,(OBJECT PTR [esi]).rplock1 ;parent of startend of wire.
	  add edi,pTERSEDATA		;edi-->previous node.
	  .IF  edi==p1stnode
	    jmp  zzok		;found!
	  .ELSE
	    jmp  look1		;keep tracing back.
	  .ENDIF
	.ELSE
xerr:
   invoke MessageBox,g_hwnd, ADDR szgenerr, 0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,edi
	  jmp  zzerr	;exit.
	.ENDIF

zzerr:	mov  eax,-1	;error, terminate code gen.
	mov ebx,-1	;invalid hierarchy count.
	ret
zzno:	mov  eax,0	;node not in subdiagram.
	mov ebx,-1	;invalid hierarchy count.
	ret
zzok:	mov  eax,1	;node is part of subdiagram.
	mov ebx,ncounthierarchy
	ret

find1stnode ENDP
;------------------------------------------------------------------------
findinnerinwire PROC STDCALL USES edi ebx ecx edx,pxnode:DWORD,pfstnode:DWORD
;pxnode is current node, find single input sync wire to ring-1,from anywhere.
;pfstnode is first in the subdiagram.
;ignores inter-thread i/p wires (.fconfig.5 set).
;101000 ignore i/p wire with .fconfig2/bit2 =1 (1-way exec-flow i/p
; to ring-1 of node, return from a path out of same node) -- this flag
; is set in paint_arc().
;NOTE: pfstnode param not used.
;returns eax=# input wires found.
;returns esi pointing to found wire.
	LOCAL count:DWORD,pwire:DWORD
	LOCAL p2wire:DWORD,esisave:DWORD
	LOCAL ecxsave:DWORD,edisave:DWORD
	LOCAL esizeobject:DWORD
	LOCAL xdest:DWORD,ydest:DWORD

	mov  count,0		;cnt how many input wires found.
	mov  pwire,0		;points to found wire.
	mov  edi,pxnode
	mov ebx,pTERSEDATA
	lea esi,(TERSEDATA PTR [ebx]).OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [ebx]).numobjects
	xor eax,eax
	mov ax,(TERSEDATA PTR [ebx]).nsizeobject
	mov esizeobject,eax
zz:	mov edisave,edi
	mov ecxsave,ecx
	mov esisave,esi
	  mov  eax,(OBJECT PTR [esi]).rplock2	;owner of destinationend.
	  add eax,pTERSEDATA
	  cmp eax,edi	    ;wire is input to current node.
	  ;(don't know if ring1 or anything yet)...
	  je   xx			;wire found.
yy:	mov edi,edisave
	mov ecx,ecxsave
	mov esi,esisave
	add  esi,esizeobject
	loop zz
	jmp  vv 			;fail.

;wire input found, but is it a valid object?...
xx:	test (OBJECT PTR [esi]).fstatus,01
	jz   yy
;wire is found, but is it a sync wire?...
	mov  ax,(OBJECT PTR [esi]).nexttype
	.IF ax==10		;sync one-way
	  ;ignore if fconfig2/bit2 set (see paint-arc())...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,0100b
	  cmp al,0100b
	  je yy
	  jmp  ww
	.ELSEIF ax==11		;sync with reply
	  jmp  ww
	.ELSEIF ax==12		;sync with reply and timeout
	  jmp  ww
	.ELSE
	  jmp  yy
	.ENDIF

;yes, we have found an input wire!... pointed to by esi...
ww:
;well, not yet. it must come to ring 1...
	mov  al,(OBJECT PTR [esi]).nendring
	cmp  al,1
	jne  yy 	;fail, keep looking

;finally, found suitable input wire...
;no! if the wire is already known to be from another thread, ignore...
	  mov  al,(OBJECT PTR [esi]).fconfig
	  and  al,00100000b	;bit5 is inter-thread flag.
	  jnz  yy		;ignore this wire.

      inc count
      .IF count==1
	  mov pwire,esi	;mark found wire.
	mov eax,(OBJECT PTR [esi]).wwidth
	mov xdest,eax
	mov eax,(OBJECT PTR [esi]).height
	mov ydest,eax
      .ENDIF


      .IF count>1
	mov eax,(OBJECT PTR [esi]).rplock1
	mov ecx,(OBJECT PTR [esi]).rplock2
	.IF  eax==ecx
	    dec  count		;this is goto wiring, ok.
	  jmp sd1
	.ENDIF
      .ENDIF

      .IF count>1
	;need to ignore wired-or i/ps...
	mov eax,(OBJECT PTR [esi]).wwidth
	sub eax,xdest
	.IF SDWORD PTR eax<0
	  neg eax
	.ENDIF
	.IF eax<5
	  mov eax,(OBJECT PTR [esi]).height
	  sub eax,ydest
	  .IF SDWORD PTR eax<0
	    neg eax
	  .ENDIF
	  .IF eax<5
	    ;yes, it's wired-or input, so accept it.
	    dec count
	  .ENDIF
	.ENDIF
      .ENDIF
sd1:

	jmp  yy	;look for any more input wires.

vv2:	mov  eax,-1
	ret
vv:	mov  eax,count	;0 or 1 = flag ok.
	mov  esi,pwire	;found wire.
	ret
findinnerinwire ENDP
;------------------------------------------------------------------------
;------------------------------------------------------------------------
.DATA
szer211a  BYTE "There is a shareable data element attached to a clone, "
	  BYTE "but it does not ""match"" with one higher up the clone "
	  BYTE "chain. The concept here is that any shareable data "
	  BYTE "elements attached to the root-node in a clone-chain "
	  BYTE "(in fact it can be a tree structure, branching out from "
	  BYTE "the root node) can be overridden at any clone by placing "
	  BYTE "a shareable data element on the clone. A small ""blob"" "
	  BYTE "propogates from the root to all clones to show the "
	  BYTE "place on the clone to which the override data element is "
	  BYTE "to be attached.",0Dh,0Ah
	  BYTE "It seems that you have placed a data element on a clone "
	  BYTE "but it is not attached at a ""blob"" (terminal). It is therefore "
	  BYTE "invalid and GOOSEE is aborting code generation. The "
	  BYTE "offending node is highlighted.",0
szer211b  BYTE "A data element has not been given a name. GOOSEE is aborting "
	  BYTE "code generation, and has highlighted the element.",0

.CODE
composepassed PROC STDCALL USES ebx ecx edx edi esi, pcnode:DWORD
  LOCAL ebxsave:DWORD,srcring:BYTE,pressave:DWORD
  LOCAL ebx2save:DWORD,ecxsave:DWORD,something:BYTE
  LOCAL pprevsave:DWORD,ecxprevsave:DWORD
  LOCAL xsharesave:DWORD,ysharesave:DWORD
; "composepassed"
;composes shareable passed to a func when it is called.
;the "&e00007" is composed by this function. pcnode-->current node.
;where "e" is name of resource, "e00007" is mangled name.
;find all shareable resources attached to current node and compose them
;(double-line boxes) (.nexttype=4, .fconfig.6/5=0/0).
;compose into szscr1. do not write to file.
;shareable resources are passed by reference, ie with "&" prefix,
;however if resource is array, to be compilable with SDC51 C, need to
;postfix "[0]".

;scan all i/o wires, find if attached to this node,
;if yes, read label from resource at other end.

  mov  edi,pcnode	;-->current node.
  mov  something,0	;# of global static resources found.
  mov eax,(OBJECT PTR [edi]).rpmaster
  .IF eax==0		;=0 already master.
  .ELSE
    add eax,pTERSEDATA
    mov edi,eax 	;edi->master.
  .ENDIF

;scan wires here... edi-->root node
;find shareable resource attached to root node...
	mov pprevsave,0		;start from beginning of database.
	mov ecxprevsave,0
as1:	 mov eax,pprevsave	;cos of recursion.
	 mov pprev,eax
	 mov eax,ecxprevsave
	 mov ecxprev,eax
	invoke findchild, edi,4 ;find nexttype=4 child
	 mov edx,pprev
	 mov pprevsave,edx
	 mov edx,ecxprev
	 mov ecxprevsave,edx
	 mov edx,xshare
	 mov xsharesave,edx	;coords of data wire.
	 mov edx,yshare
	 mov ysharesave,edx	;/
	.IF eax==0 ;not found
	  xor eax,eax		;<<<EXIT POINT<<<<
	  mov al,something
	  ret
	.ELSE
	  mov ebx,eax
	  mov al,(OBJECT PTR [ebx]).fconfig
	  and al,11100000b ;bits6/5
	  .IF al==0	    ;shareable permanent.
	    jmp as2
	  .ENDIF
	.ENDIF
	jmp as1   ;keep looking.

as2:
;pcnode ->current node, ebx->found shareable on root node, edi->root node.
;problem is, if node is a clone, have to climb clone-chain, looking for
;closest shareable at same connection-coords on node.
;so, findchild will record the coords of the where the wire attaches to
;the root, as xshare/yshare...
    mov esi,pcnode
    cmp edi,esi
    je	fndit		;current node is a master/root.
;now loop around, climbing the chain...
xas0:	mov pprevsave,0		;start from beginning of database.
	mov ecxprevsave,0
xas1:	 mov eax,pprevsave	;cos of recursion.
	 mov pprev,eax
	 mov eax,ecxprevsave
	 mov ecxprev,eax
	invoke findchild, esi,4 ;find nexttype=4 child
	 mov edx,pprev
	 mov pprevsave,edx
	 mov edx,ecxprev
	 mov ecxprevsave,edx
	.IF eax==0 ;not found
	  .IF esi==edi	    ;have we reached the root yet?
xas5:	    lea eax,szer211a	    ;this would be an error
	    invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	    mov eax,pcnode
	    mov g_perrorobject,eax
	    mov eax,-1
	    ret
	  .ENDIF
	  ;ok, we're still in the clone-chain, so let's go one-up...
;	  mov ebx,eax
	  mov eax,(OBJECT PTR [esi]).rplock1
	  .IF eax==0
	    jmp xas5	;error
	  .ENDIF
	  add eax,pTERSEDATA
	  mov esi,eax		;next-up clone.
	  jmp xas0		;keep looking, from start of database.
	.ELSE			;eax->child resource nexttype=4.
	  mov ebx,eax
	  mov al,(OBJECT PTR [ebx]).fconfig
	  and al,11100000b ;bits6/5
	  .IF al==0	    ;shareable permanent.
	    ;found, but is it on right coords?...
	    mov eax,xshare
	    sub eax,xsharesave
	    .IF SDWORD PTR eax<0
	      neg eax
	    .ENDIF
	    .IF eax>3
	      jmp xas1 ;keep looking
	    .ENDIF
	    mov eax,yshare
	    sub eax,ysharesave
	    .IF SDWORD PTR eax<0
	      neg eax
	    .ENDIF
	    .IF eax>3
	      jmp xas1 ;keep looking
	    .ENDIF
	    ;found!...
	    ;ebx->closest shareable.
	    jmp fndit
	  .ENDIF
	.ENDIF
	jmp xas1   ;keep looking.

fndit:
;ebx->found shareable data, closest on clone chain. edi->root node
    mov pressave,ebx


;only a shareable resource gets to here, and now compose it.
;shareables can be temporary or permanent, and in former case don't
;compose if res owned by this node...
;*NOTE* i've screened out share-temps already.
;pressave-->resource, pcnode-->node. don't change esi/edi.
;(a temp-shareable is defined inside the owner-node, so not passed to
;it as a parameter)...
	mov  ebx,pressave	;-->resource.
	mov  al,(OBJECT PTR [ebx]).fconfig
	and  al,11100000b	;extract bits 7/6/5.
	.IF  al==10000000b	;bit7=1 temporary, bits6/5=0/0 shareable.
	  mov  edx,pcnode	;-->current node.
	  mov  eax,(OBJECT PTR [ebx]).rpmaster
	  add eax,pTERSEDATA
	  .IF  edx==eax
	    jmp  a34	;bypass "&exxx," parameter passing.
	  .ENDIF
	.ENDIF

	    mov  ebx,pressave
	    ;only a shareable  resource gets to here...
	    ;it must have a label...
	    mov  al,(OBJECT PTR [ebx]).sztext1
	    .IF  al==0		;no label
		mov  g_perrorobject,ebx
	      lea eax,szer211b
	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		jmp zzzz		;exit
	    .ENDIF
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
	      mov  [ebx],BYTE PTR "&"
	      mov  [ebx+1],BYTE PTR 0
	      add  ebx,1
	      mov  ebx2save,ebx
	      mov  ebx,pressave
	  lea  edx,(OBJECT PTR [ebx]).sztext1
	      mov  ebx,ebx2save
	  invoke lstrcpy, ebx, edx
;now mangle it with node number...
	    ;a shareable static resource is mangled with its own element
	    ;number...
	    mov  ebx,pressave
	    xor eax,eax
	    mov  ax,(OBJECT PTR [ebx]).number
	    mov  ebx2save,eax
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
;	  mov  [ebx],BYTE PTR "n"
;	  inc ebx
	  mov  eax,ebx2save
	  push ebx
	  invoke binto5dec, ebx	 ;eax to dec.,retain ldg 0's.
	  pop ebx
	  add ebx,5
	  mov  [ebx],BYTE PTR 0   ;(bx reloaded from cx below).
	  mov ecx,ebx

;if the resource is an array, need to postfix "[0]"...
;different from goofee, now i'm using .fstatus2 to designate reference types...
;(it was .nptrtype)
	  mov  ebx,pressave
	  mov al,(OBJECT PTR [ebx]).fstatus2
	  and al,11100000b
	  .IF al==01100000b	;array.
	      mov	ebx,ecx		;get ebx-->end string, back again.
	      mov	[ebx],BYTE PTR "["
	      inc ebx
	      mov	[ebx],BYTE PTR "0"
	      inc ebx
	      mov	[ebx],BYTE PTR "]"
	      inc ebx
	      mov	[ebx],BYTE PTR ","
	      inc ebx
	      mov	[ebx],BYTE PTR 0
	  .ELSE
fix1:
	    mov	ebx,ecx			;get bx-->end string, back again.
	    mov	[ebx],BYTE PTR ","
	    inc ebx
	    mov	[ebx],BYTE PTR 0
	  .ENDIF

  inc  something
a34:

  jmp as1	;look for more shareables. exit is also above.
zzzz:
  mov  eax,-1	;error exit.
  ret
composepassed ENDP
;------------------------------------------------------------------------
;------------------------------------------------------------------------
composenodedata PROC STDCALL USES ebx ecx edx edi esi, \
		pnow:DWORD,pfirst:DWORD,genhandle:DWORD
;called from genmanycode()	   "composenodedata"
;pnow is current function, pfirst is first func in subdiagram.
;code very similar to composeglobaldata().
;return eax=-1 if error.
    LOCAL ebxsave:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL nbytes:DWORD
    LOCAL plock:DWORD
    LOCAL pprevsave:DWORD,ecxprevsave:DWORD
    LOCAL xpprevsave:DWORD,xecxprevsave:DWORD
;find data attached -- .rplock1.
;if data is private-visible, permanent, compose with "static" prefix.
;if data is private-visible, temporary, compose with no prefix.
;if data is shareable-visible, temporary, compose mangled, no prefix.

;061200
;now have generic data. a bit weird, it is always .nexttype=3,
;with .fstatus2/bits7/6/5 =100 to designate this data is generic.
;also .fconfig3/bits1/0 =01 if compose inside function, =10 if
;compose before func, =11 if compose before all funcs.
;...handle first case here.


;;need a loop to search database for data...
;	mov edi,pTERSEDATA
;	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
;	xor ecx,ecx
;	mov cx,(TERSEDATA PTR [edi]).numobjects
;	;as we loop around, edi->start of TERSEDATA, esi->current object...
;nextobj:
;	mov plock,0
;	mov esisave,esi
;	mov edisave,edi
;	mov ecxsave,ecx
;	xor eax,eax
;	mov al,(OBJECT PTR [esi]).fstatus
;	and ax,01
;	  .IF ax==01	;bit0=1, valid object.
;	    mov ax,(OBJECT PTR [esi]).nexttype
;	    .IF ax==-1	    ;data object
;	    .ELSEIF ax==3   ;private data
;	      mov al,(OBJECT PTR [esi]).fconfig
;	      and  al,01100000b	;extract bits6/5
;	      .IF al==00000000b ;private-visible permanent.
;		jmp SHORT try1
;	      .ELSEIF al==00100000b ;private-visible temporary.
;try1:		mov eax,(OBJECT PTR [esi]).rplock1
;		.IF eax==0	;this would be an error.
;		.ELSE
;		  add eax,pTERSEDATA
;		  .IF eax==pnow     ;res attached to current func.
;		    mov plock,eax
;		    jmp SHORT qq5
;		  .ENDIF
;		.ENDIF
;	      .ENDIF
;	    .ELSEIF ax==4   ;global data
;	      mov al,(OBJECT PTR [esi]).fconfig
;	      and  al,01100000b	;extract bits6/5
;	      .IF al==00000000b ;shareable-visible.
;		mov al,(OBJECT PTR [esi]).fconfig
;		and al,80h  ;bit7=1 shareable-temporary
;		.IF al==80h
;		  mov eax,(OBJECT PTR [esi]).rplock1
;		  .IF eax==0	;error
;		  .ELSE
;		    add eax,pTERSEDATA
;		    .IF eax==pnow
;		      mov plock,eax
;		      jmp SHORT qq5
;		    .ENDIF
;		  .ENDIF
;		.ENDIF
;	      .ENDIF
;	    .ENDIF
;	  .ENDIF
;x1:	mov ecx,ecxsave
;	mov edi,edisave
;	mov esi,esisave
;	xor eax,eax
;	mov ax,(TERSEDATA PTR [edi]).nsizeobject
;	add esi,eax		;addr of next object.
;    loop  j02 ;nextobj
;      jmp SHORT j03
;j02:  jmp nextobj
;j03:

    mov xpprevsave,0
    mov xecxprevsave,0
x1:
    mov edi,pnow
    mov ecx,xpprevsave
    mov pprev,ecx
    mov ecx,xecxprevsave
    mov ecxprev,ecx
    invoke findchild, edi,0   ;ret eax->fnd data, else eax=0. any type.
    mov ecx,pprev
    mov xpprevsave,ecx
    mov ecx,ecxprev
    mov xecxprevsave,ecx
    .IF eax==0
      ;finished looking for data in the database, so return...
      xor eax,eax
      ret
    .ELSE
      mov esi,eax
	    mov ax,(OBJECT PTR [esi]).nexttype
	    .IF ax==3	 ;private data
	      ;respond to private generic data here... 061200
	      mov al,(OBJECT PTR [esi]).fstatus2
	      and al,11100000b	;bits 7/6/5
	      .IF al==10000000b ;generic
		;.fconfig3 specifies where composes...
		mov al,(OBJECT PTR [esi]).fconfig3
		and al,011b
		.IF al==01b ;compose inside func(like normal private)
		  jmp try1  ;maybe we're in.
		.ELSE
		  jmp x1    ;get next data.
		.ENDIF
	      .ENDIF
	      mov al,(OBJECT PTR [esi]).fconfig
	      and  al,01100000b	;extract bits6/5
	      .IF al==00000000b ;private-visible permanent.
		jmp SHORT try1
	      .ELSEIF al==00100000b ;private-visible temporary.
try1:		    mov edi,pnow
		    mov plock,edi
		    jmp SHORT qq5
	      .ENDIF
	    .ELSEIF ax==4   ;global data
;	      ;a special case is shareable data that is owned by another
;	      ;subdiagram but accessed by current one...
;	      mov eax,(OBJECT PTR [esi]).rplock1
;	      add eax,pTERSEDATA
;	      .IF eax==pnow	    ;pnow->current node.
;	      .ELSE
;		;do acheck that it is shareable...
;		mov cl,(OBJECT PTR [esi]).fconfig
;		and cl,01100000b
;		.IF cl==0
;		  ;compose as extern...
;		  mov edi,pnow
;		  mov plock,eax     ;real owner
;		  jmp doex1
;		.ENDIF
;	      .ENDIF
	      mov al,(OBJECT PTR [esi]).fconfig
	      and  al,01100000b	;extract bits6/5
	      .IF al==00000000b ;shareable-visible.
		mov al,(OBJECT PTR [esi]).fconfig
		and al,80h  ;bit7=1 shareable-temporary
		.IF al==80h
		      mov edi,pnow
		      mov plock,edi
		      jmp SHORT qq5
		.ENDIF
	      .ENDIF
	    .ENDIF
      jmp x1  ;get next data.
    .ENDIF

;......
;doex1:
;	    ;put in "extern" keyword...
;	    mov  szscr1,BYTE PTR "e"
;	    mov  szscr1+1,BYTE PTR "x"
;	    mov  szscr1+2,BYTE PTR "t"
;	    mov  szscr1+3,BYTE PTR "e"
;	    mov  szscr1+4,BYTE PTR "r"
;	    mov  szscr1+5,BYTE PTR "n"
;	    mov  szscr1+6,BYTE PTR 0
;	    jmp doex2


;........
qq5:
;come here with esi->found data attached to node.
    mov edi,pnow
;compose data element. afterward jmp x1.
;edi->owner-function, esi->data

  ;a little job here...
  ;assign .number of first node in subdiagram to esi.nfile...
  push ebx
  mov ebx,pfirst
  mov ax,(OBJECT PTR [ebx]).number
  pop ebx
  mov (OBJECT PTR [esi]).nfile,ax

    ;check the do-not-compose bit...
    mov al,(OBJECT PTR [esi]).fconfig
    test al,10b     ;bit1
    jnz x1

	    lea ebx,szscr1
	    invoke indentation, ebx,g_nlevel
	    mov ebx,eax	    ;returns eax->new end of szscr1.

;061200
;is it generic data?...
       mov al,(OBJECT PTR [esi]).fstatus2
       and al,11100000b     ;extract bits7/6/5, variable type.
       .IF al==10000000b
	 ;need to compose as-is...
	 lea eax,(OBJECT PTR [esi]).sztext5
	 invoke lstrcpy, ebx,eax
	 ;write to file, then find next data...
	 invoke lstrlen, ADDR szscr1
	 mov ebx,eax
	 invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
	 mov szscr1,0
	 jmp x1 ;find next data.
       .ENDIF


    push ebx
    invoke lstrcpy, ebx, ADDR szstatic
    pop ebx

  mov ax,(OBJECT PTR [esi]).nexttype
  .IF ax==3
    mov al,(OBJECT PTR [esi]).fconfig
    and al,01100000b
    .IF al==00100000b	     ;private-visible temporary
sk1:	    ;remove "static" keyword...
;;	    lea ebx,szscr1
;	    mov	[ebx],BYTE PTR " "	   ;remove "static" keyword.
;	    inc ebx
;	    mov  [ebx],BYTE PTR " "
;	    inc ebx
;	    mov  [ebx],BYTE PTR " "
;	    inc ebx
;	    mov  [ebx],BYTE PTR " "
;	    inc ebx
;	    mov  [ebx],BYTE PTR " "
;	    inc ebx
;	    mov  [ebx],BYTE PTR " "
;	    inc ebx
      mov [ebx],BYTE PTR 0	;don't leave big gap.
    .ELSEIF al==0	     ;private-visible permanent.
	    ;leave in"static" keyword...
      ;unless external...
      mov al,(OBJECT PTR [esi]).fstatus
      and al,100b
      .IF al==0
      .ELSE	   ;bit2=1 external data.
	    ;put in "extern" keyword...
;	    lea ebx,szscr1
	    mov  [ebx],BYTE PTR "e"
	    inc ebx
	    mov  [ebx],BYTE PTR "x"
	    inc ebx
	    mov  [ebx],BYTE PTR "t"
	    inc ebx
	    mov  [ebx],BYTE PTR "e"
	    inc ebx
	    mov  [ebx],BYTE PTR "r"
	    inc ebx
	    mov  [ebx],BYTE PTR "n"
	    inc ebx
      .ENDIF
    .ENDIF
  .ELSE
    ;only option left is shareable-visible temporary...
    jmp sk1
  .ENDIF

doex2:	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
       mov al,(OBJECT PTR [esi]).fstatus2
       and al,11100000b     ;extract bits7/6/5, variable type.

       .IF al==0	    ;simple variable.
	 ;have extracted this code to a common function...
	 invoke composeprimitivevar, esi,0,esi,1,0,1
	 .IF eax==-1
	   ret
	 .ENDIF

       .ELSEIF al==00100000b ;pointer.
	 ;compose pointer...
	 ; "childdatatype childmemtype * ptrmemtype name"
	 ;esi -> pointer resource.

	   invoke composepointer1, esi,1,0
	   ;2nd-last param=1 suppress extra "*"
	   ;last param=0 compose variable name (but recursive calls won't)
	   ;...composes to the end of szscr1
	   cmp eax,-1
	   je  zzzz	;error exit.

       .ELSEIF al==01000000b ;structure
	 ;similar to the basic variable, except has "struct" before the
	 ;structure-type... "struct RECT memtype name"
	 ;ebx->end of szscr1, esi->structure-data-element
	      ;compose "struct"...
	      lea eax,szstruct
	      invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	       xor eax,eax
	       mov al,(OBJECT PTR [esi]).ndatatype
	    .IF al==0	      ;nothing selected.

	      ;***NOTE*** in future, structure-type=0 nothing selected,
	      ;will mean it will be a structure-template, not an
	      ;instantiation.

	    .ELSE
	      dec eax		;cos we ignore .ndatatype=0
	       mov ecx,48
	       mul ecx
	       push ebx
	       mov ebx,pTERSEDATA
	       lea ecx,(TERSEDATA PTR [ebx]).szptrtype1
	       pop ebx
	       add eax,ecx		;now have addr of string in eax.
	       invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF
	    mov al,(OBJECT PTR [esi]).nmemtype1
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [esi]).nmemtype1
	      dec al		;cos we ignore .nmemtype1=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF
	    ;now compose name...
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [esi]).sztext1
	    .IF al==0	      ;nothing selected.
	      lea eax,szer191a
	      invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	      mov g_perrorobject,esi
	      jmp	zzzz
	    .ELSE
	      lea eax,(OBJECT PTR [esi]).sztext1
	      invoke lstrcpy, ebx,eax
		;if this is shareable, mangle it with its own element#...
	      mov ax,(OBJECT PTR [esi]).nexttype
	      .IF ax==4
		mov al,(OBJECT PTR [esi]).fconfig
		and al,01100000b
		.IF al==0
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  xor eax,eax
		  mov ax,(OBJECT PTR [esi]).number
		  invoke binto5dec, ebx ;appends element#
		  add ebx,5
		  mov [ebx],BYTE PTR 0
		.ENDIF
	      .ENDIF
	    .ENDIF
	    ;now compose initialisation value...
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	    mov al,(OBJECT PTR [esi]).sztext5
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      mov [ebx],BYTE PTR "="
	      inc ebx
	      mov [ebx],BYTE PTR "{"
	      inc ebx
	      lea eax,(OBJECT PTR [esi]).sztext5
	      invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR "}"
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF



       .ELSEIF al==01100000b ;array
	 ;we want to define an array. well, if the array has
	 ;elements of primitive datatype, seems straightforward...
	 ; "ndatatype nmemetype2 name;"
	 ;if the .ndatatype field is zero, means that array has
	 ;attached data-elements.
	 ;ebx->end of szscr1, esi->array-data-element
	 mov al,(OBJECT PTR [esi]).ndatatype
	 .IF al==0
	   mov pprevsave,0
	   mov ecxprevsave,0
kg2:	   mov eax,pprevsave
	   mov pprev,eax
	   mov eax,ecxprevsave
	   mov ecxprev,eax
	   invoke findchild, esi,3
	   mov ecx,pprev
	   mov pprevsave,ecx
	   mov ecx,ecxprev
	   mov ecxprevsave,ecx
	   ;...esi is node to find the child of, 3 is the .nexttype to find.
	   ;returns eax=addr of found child, else eax=0 not found.
	   .IF eax==0
	     lea eax,szer3200b
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	   .ELSE
	     mov ebx,eax
	     mov al,(OBJECT PTR [ebx]).fstatus2 ;child data-element.
	     and al,11100000b
	     .IF al==0	    ;primitive variable type.
nn1:	       invoke composeprimitivearray, ebx,0,esi,1,0,1
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSEIF al==01000000b  ;structure
	       jmp nn1		    ;(treat as like primitivedata)
	     .ELSEIF al==01100000b  ;another array.
	       ;an array attached to an array. loop back until we find
	       ;the lowest one...
	       mov esi,ebx
	       mov al,(OBJECT PTR [esi]).ndatatype
	       cmp al,0
	       jne  kg1		    ; array has no child.
	       jmp  kg2 	    ; array has a child.
	     .ELSEIF al==00100000b  ;pointer.
	       ;have an array of pointers...
	       ;ebx->pointer, esi->lowest array.
	       invoke composearrayofpointers, ebx,esi,1,0
	       .IF eax==-1
		 ret
	       .ENDIF
	     .ELSE
	       ;MODIFY THIS MESSAGE NEXT GOOSEE VERSION ***NOTE*** ...
	       lea eax,szer301
	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	     .ENDIF
	   .ENDIF
	 .ELSE
kg1:	   invoke composeprimitivearray, esi,0,esi,1,0,1
	   .IF eax==-1
	     ret
	   .ENDIF
	 .ENDIF


       .ELSEIF al==10000000b ;generic
       .ENDIF

	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	    mov [ebx],BYTE PTR ";"
	    inc ebx
	    mov [ebx],BYTE PTR 0Dh
	    inc ebx
	    mov [ebx],BYTE PTR 0Ah
	    inc ebx
	    mov [ebx],BYTE PTR 0
;and write data definition to file...
	invoke lstrlen, ADDR szscr1
	mov ebx,eax
	invoke WriteFile, genhandle,ADDR szscr1,ebx,ADDR nbytes,0
	mov szscr1,0
     jmp x1 ;find next data.



    xor eax,eax
    ret
zzzz:
    mov eax,-1
    ret
composenodedata ENDP
;------------------------------------------------------------------------
.DATA
szacter9  DB "ERROR: It is not appropriate to have a double-action "
	  DB "attached to ring-1 of a node. Please change it to a "
	  DB "normal action (one ""!"" only).",0
szendit DB "}",0Dh,0Ah,0Dh,0Ah,0
szendit2 DB 0 ;0Dh,0Ah,0Dh,0Ah,0

.CODE
;------------------------------------------------------------------------
composeblock PROC STDCALL USES ebx ecx edx edi esi, \
		psnode:DWORD,nring:DWORD


    xor eax,eax
    ret
composeblock ENDP
;------------------------------------------------------------------------
.DATA
szatter1  DB "ERROR: Only allowed 1 action wire to each ring.",0

.CODE
findactionwire PROC STDCALL USES edx edi esi, \
		ponode:DWORD,xring:DWORD
  LOCAL pszaction:DWORD, pszcomment:DWORD,pactionwire:DWORD
  LOCAL esizeobject:DWORD
; "findactionwire"
;enter with ponode-->node, scan all action wires, find attached to node...
;enter with xring=current ring.
;return eax-->label for action,ebx-->label for comment,ecx-->action wire,
;eax=-1 error.
  mov  edi,ponode
  mov  pszaction,0
  mov  pszcomment,0
  mov  pactionwire,0

	mov ebx,pTERSEDATA
	lea esi,(TERSEDATA PTR [ebx]).OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [ebx]).numobjects
	xor eax,eax
	mov ax,(TERSEDATA PTR [ebx]).nsizeobject
	mov esizeobject,eax
azz:	xor eax,eax
	mov  ax,(OBJECT PTR [edi]).number
	  test (OBJECT PTR [esi]).fstatus,01
	  jz ayy				;invalid wire.
	  cmp  (OBJECT PTR [esi]).nexttype,33	;action wire.
	  je ap1
	  cmp	(OBJECT PTR [esi]).nexttype,30	;comment wire.
	  je ap2
	  jmp ayy
ap1:	  mov eax,(OBJECT PTR [esi]).rplock1
	  cmp eax,0
	  je ayy    ;error
	  add eax,pTERSEDATA
	  cmp eax,edi	    ;is action attached to node?
	  jne ayy
	  mov  eax,xring
	  cmp  (OBJECT PTR [esi]).nbeginring,al
	  je   axx			;action wire found.
ayy:
	add  esi,esizeobject
	loop azz
  jmp  ado1		;finished.

ap2:	  mov eax,(OBJECT PTR [esi]).rplock1
	  cmp eax,0
	  je ayy    ;error
	  add eax,pTERSEDATA
	  cmp eax,edi	    ;is comment attached to node?
	  jne ayy
	  mov  eax,xring
	  cmp  (OBJECT PTR [esi]).nbeginring,al
	  jne  ayy
	  jmp	axxx			;comment wire found.

axx:
;action wire found...  (don't change esi,edi,ecx)...
  .IF  pszaction==0
  .ELSE 		;error, more than one action wire.
      lea  eax,szatter1
      invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	  mov	g_perrorobject,esi
	  jmp  etr3		;error exit.
  .ENDIF
  lea  eax,(OBJECT PTR [esi]).sztext2
  mov  pszaction,eax
  mov  pactionwire,esi
  jmp  ayy
axxx:
;comment wire found...
  lea  eax,(OBJECT PTR [esi]).sztext2
  mov  pszcomment,eax
  jmp  ayy

ado1:
  mov  eax,pszaction
  mov  ebx,pszcomment
  mov  ecx,pactionwire
  ret
etr3:
  mov  eax,-1
  ret

findactionwire ENDP
;------------------------------------------------------------------------
findtexticon PROC STDCALL USES ebx ecx edx edi esi, ponode:DWORD
  LOCAL esizeobject:DWORD
; "findtexticon"
;141000
;based in findactionwire().
;enter with ponode-->node,scan all text-fileicons, find attached to node...
;return eax-->text-file icon, eax=0 not found.
  mov  edi,ponode

	mov ebx,pTERSEDATA
	lea esi,(TERSEDATA PTR [ebx]).OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [ebx]).numobjects
	xor eax,eax
	mov ax,(TERSEDATA PTR [ebx]).nsizeobject
	mov esizeobject,eax
azz:	xor eax,eax
	mov  ax,(OBJECT PTR [edi]).number
	  test (OBJECT PTR [esi]).fstatus,01
	  jz ayy				;invalid wire.
	  cmp  (OBJECT PTR [esi]).nexttype,61	;text-file icon.
	  jne ayy
	    mov eax,(OBJECT PTR [esi]).rplock1
	    cmp eax,0
	    je ayy    ;not a child.
	    add eax,pTERSEDATA
	    cmp eax,edi	    ;is text icon attached to node?
	    je axx
ayy:
	add  esi,esizeobject
	loop azz
  mov eax,0	;icon not found.
  ret

axx:
;text-file icon found...
  mov eax,esi
  ret
findtexticon ENDP
;------------------------------------------------------------------------
.DATA
szinter1  DB "ERROR: Inter-thread wire with reply is not allowed to "
	  DB "have destination at ring # greater than 1.",0

.CODE
findinterwire PROC STDCALL USES edi esi, \
		pxnode:DWORD,srcring:DWORD
  LOCAL foutinterasync:DWORD,fininterasync:DWORD
  LOCAL esizeobject:DWORD
  LOCAL poutasync:DWORD,pinasync:DWORD
;pxnode is current node, srcring is current ring.
;loads g_poutinter-->inter-thread wire. =0 not found.
;also records g_pininter-->interthread i/p wire.	=0 not found.
;returns eax=foutinterasync, edx=fininterasync, eax=-1 error.

;...i'm modifying this to also return non-inter-task async,
; ebx->async i/p else =0, ecx->async o/p else =0.


	mov  foutinterasync,0		;flags output intertask async.
	mov  fininterasync,0		;flags input intertask async
	mov poutasync,0 	;->o/p async wire (not intertask)
	mov pinasync,0		;->i/p async  "       "
	mov  edi,pxnode
	mov ebx,pTERSEDATA
	lea esi,(TERSEDATA PTR [ebx]).OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [ebx]).numobjects
	xor eax,eax
	mov ax,(TERSEDATA PTR [ebx]).nsizeobject
	mov esizeobject,eax
zz:
	test (OBJECT PTR [esi]).fstatus,01	;valid
	jz   yy
	test (OBJECT PTR [esi]).fconfig,01	;wire-type
	jz yy
	mov ebx,(OBJECT PTR [esi]).rplock1 ;begin end of wire locked to.
	cmp ebx,0
	je yy
	add ebx,pTERSEDATA
	cmp ebx,edi	;is begin-end of wire on node?
	je xx			;wire output found.
	  mov ebx,(OBJECT PTR [esi]).rplock2 ;dest end of wire locked to.
	  cmp ebx,0
	  je yy
	  add ebx,pTERSEDATA
	  cmp ebx,edi	    ;is dest-end of wire on node?
	  jne  yy
	  xor eax,eax
	  mov  al,(OBJECT PTR [esi]).nendring	;end at this ring.
	  cmp  eax,srcring
	  jne  yy
	  ;is it (non intertask) async i/p wire?...
	  mov ax,(OBJECT PTR [esi]).nexttype
	  .IF ax==13	;async 1-way
	    test (OBJECT PTR [esi]).fconfig,00100000b ;bit5
	    jnz xb1x
	    ;yes, it's normal async wire...
	    mov pinasync,esi
	    jmp yy	    ;keep looking.
	  .ELSEIF ax==14	;async 2-way
	    test (OBJECT PTR [esi]).fconfig,00100000b ;bit5
	    jnz xb1x
	    ;yes, it's normal async wire...
	    mov pinasync,esi
	    mov poutasync,esi
	    jmp yy	    ;keep looking.
	  .ENDIF
xb1x:	  ;look for interthread i/p wires ...
	  test (OBJECT PTR [esi]).fconfig,00100000b ;bit5.
	  jz   yy				;not interthread
	  mov  ax,(OBJECT PTR [esi]).nexttype
wqm:	    .IF ax==10			;sync i/p wire.
	      .IF g_pininter==0	;don't overwrite.
		mov  g_pininter,esi
	      .ENDIF
	    .ELSEIF ax==11		;sync with reply.
wqm1:	      ;interthread with reply not allowed to go to ring>1...
	      .IF srcring==1
		.IF g_poutinter==0
		  mov  g_poutinter,esi
		.ENDIF
		.IF g_pininter==0
		  mov  g_pininter,esi
		.ENDIF
	      .ELSE
		lea  eax,szinter1
   invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		jmp  vverr
	      .ENDIF
	    .ELSEIF ax==12		;sync with reply & timeout.
	      jmp  wqm1

	    .ELSEIF ax==13	;async wire.
	      .IF g_pininter==0
		mov g_pininter,esi
		mov fininterasync,1
	      .ENDIF
	    .ELSEIF ax==14	;async with reply.
	      ;interthread with reply not allowed to go to ring>1...
	      .IF srcring==1
		.IF g_poutinter==0
		  mov g_poutinter,esi
		  mov foutinterasync,1
		.ENDIF
		.IF g_pininter==0
		  mov g_pininter,esi
		  mov fininterasync,1
		.ENDIF
	      .ELSE
		lea  eax,szinter1
   invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		jmp  vverr
	      .ENDIF

	    .ENDIF
yy:	add  esi,esizeobject
	loop zzgo
	jmp  vv
zzgo:	jmp  zz

;wire output found...
xx:
;well, not yet. it must go from the current ring...
	xor eax,eax
	mov  al,(OBJECT PTR [esi]).nbeginring
	cmp  eax,srcring
	jne  yy 	;fail, keep looking
;is it (non intertask) async o/p wire?...
	mov ax,(OBJECT PTR [esi]).nexttype
	.IF ax==13	;async 1-way
	  test (OBJECT PTR [esi]).fconfig,00100000b ;bit5
	  jnz xb1
	  ;yes, it's normal async wire...
	  mov poutasync,esi
	  jmp yy	    ;keep looking.
	.ELSEIF ax==14	;async 2-way
	  test (OBJECT PTR [esi]).fconfig,00100000b ;bit5
	  jnz xb1
	  ;yes, it's normal async wire...
	  mov poutasync,esi
	  mov pinasync,esi
	  jmp yy	    ;keep looking.
	.ENDIF
;is it inter-thread wire...
	test (OBJECT PTR [esi]).fconfig,00100000b ;bit5.
	jz   yy
;wire is found, but is it a sync wire?...
xb1:	mov  ax,(OBJECT PTR [esi]).nexttype
	.IF ax==10		;sync one-way
	    .IF g_poutinter==0	;don't overwrite.
	      mov	g_poutinter,esi	;ptr to inter-thread wire.
	    .ENDIF
	.ELSEIF ax==11		;sync with reply
yyy1:	    .IF g_poutinter==0	;don't overwrite.
	      mov	g_poutinter,esi	;ptr to inter-thread wire.
	    .ENDIF
	      .IF g_pininter==0	    ;don't overwrite.
		mov	g_pininter,esi	;also an interthread input msg.
	      .ENDIF
	.ELSEIF ax==12		;sync with reply and timeout
	  jmp yyy1

	.ELSEIF ax==13		;async.
	  .IF g_poutinter==0
	    mov  g_poutinter,esi
	    mov  foutinterasync,1
	  .ENDIF
	.ELSEIF ax==14		;async with reply.
	  .IF g_poutinter==0
	    mov  g_poutinter,esi
	    mov  foutinterasync,1
	  .ENDIF
	  .IF g_pininter==0
	    mov  g_pininter,esi
	    mov  fininterasync,1
	  .ENDIF

	.ENDIF
	jmp  yy
vv:  mov  eax,foutinterasync
     mov  edx,fininterasync
     mov ebx,pinasync
     mov ecx,poutasync
	ret
vverr:	mov  eax,-1	;error.
	mov  edx,0
	mov  g_poutinter,0
	mov  g_pininter,0
	xor ecx,ecx
	xor ebx,ebx
	ret
findinterwire ENDP
;------------------------------------------------------------------------
compose1ringconditions PROC STDCALL USES ebx ecx edx edi esi, \
		pqnode:DWORD,finline:DWORD
  LOCAL xring:DWORD,ecxsave:DWORD,esisave:DWORD,edisave:DWORD
  LOCAL ffound:BYTE
  LOCAL esizeobject:DWORD
;  "compose1ringconditions"
;find all condition wires attached to node, and
;compose condition statements to szscr3.
;finline=0 if not inline function.
;this is called by compose1ringnode(), for 1-ring node only.
;it is simple: "while(!(condition)) ;"	*NO PATH*

  mov  ffound,0
  mov  edi,pqnode
  mov  szscr3,0 	;null string.
  mov  xring,1
  lea  eax,nocondwire	;record which rings don't have conditions.
  mov  pnocondwire,eax	;/ start empty.
xfs0:
  xor  eax,eax
  mov  al,(OBJECT PTR [edi]).nrings ;*BUT* we already know this is 1.
  cmp  xring,eax
  ja   xfincode1
    jmp  xfs1		;compose code for one ring
xfs2:			;must come back to fs2.
  inc  xring
  jmp  xfs0
xfincode1:
  ;tidy up....
  jmp  xfincode

xfs1:
;scan wires for condition attached to this ring...
	mov  ffound,0	;flags a cond found on this ring.
	mov ebx,pTERSEDATA
	lea esi,(TERSEDATA PTR [ebx]).OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [ebx]).numobjects
	xor eax,eax
	mov ax,(TERSEDATA PTR [ebx]).nsizeobject
	mov esizeobject,eax
azz:	xor eax,eax
	mov  ax,(OBJECT PTR [edi]).number
	  test (OBJECT PTR [esi]).fstatus,01
	  jz   ayy				;invalid wire.
	  cmp  (OBJECT PTR [esi]).nexttype,32	;condition wire.
	  je   ap1
	  jmp  ayy
ap1:	  mov eax,(OBJECT PTR [esi]).rplock1
	  cmp eax,0
	  je ayy    ;error
	  add eax,pTERSEDATA
	  cmp eax,edi	    ;is condition-element attached to node?
	  jne ayy
	  mov eax,xring
	  cmp (OBJECT PTR [esi]).nbeginring,al
	  jne ayy
	    mov  ecxsave,ecx
	    mov  esisave,esi
	    mov  edisave,edi
	    jmp	axx			;wire found.
ayy1:
	    mov	edi,edisave
	    mov	esi,esisave
	    mov	ecx,ecxsave
ayy:
	add  esi,esizeobject
	loop azz

  .IF ffound==0  ;to handle multiple conds on same ring.
    ;record rings with no condition...
    mov	esi,pnocondwire
    mov	eax,xring
    mov	[esi],al
    inc	pnocondwire
  .ENDIF
  jmp  ado1		;no condition on xring.

axx:
;condition wire found...
;flag it is found...
  mov  ffound,1
  invoke lstrlen, ADDR szscr3
  lea  ebx,szscr3
  add  ebx,eax

	mov [ebx],BYTE PTR "w"
	inc ebx
	mov [ebx],BYTE PTR "h"
	inc ebx
	mov [ebx],BYTE PTR "i"
	inc ebx
	mov [ebx],BYTE PTR "l"
	inc ebx
	mov [ebx],BYTE PTR "e"
	inc ebx
	mov [ebx],BYTE PTR "("
	inc ebx
	mov [ebx],BYTE PTR "!"
	inc ebx
	mov [ebx],BYTE PTR "("
	inc ebx

  lea  eax,(OBJECT PTR [esi]).sztext2	;condition expression.
  invoke lstrcpy, ebx,eax

  invoke lstrlen, ADDR szscr3
  lea  ebx,szscr3
  add  ebx,eax
  mov  [ebx],BYTE PTR ")"
  inc ebx
  mov  [ebx],BYTE PTR ")"
  inc ebx
  mov  [ebx],BYTE PTR " "
  inc ebx
  mov  [ebx],BYTE PTR ";"
  inc ebx
  mov  [ebx],BYTE PTR 0
	   mov	[ebx],BYTE PTR 0Dh
	   inc ebx
	   mov	[ebx],BYTE PTR 0Ah
	   inc ebx
	   mov	[ebx],BYTE PTR 0

;  jmp	ayy1		;find if another cond.wire on same ring.
  ;...note, simply delete this line if only compose 1 cond per ring.

    ;as this is ring1, if-then is redundant. make it while-do...
    mov al,(OBJECT PTR [esi]).fconfig2
    and al,11111100b
    or al,010b		;set bit1/0 =10
    mov (OBJECT PTR [esi]).fconfig2,al

ado1:
  jmp  xfs2		;do next ring.

xfincode:
    xor eax,eax
    ret
compose1ringconditions ENDP
;------------------------------------------------------------------------
composecondition PROC STDCALL USES ebx ecx edx edi esi, \
		pqnode:DWORD,finline:DWORD
  LOCAL xring:DWORD,ecxsave:DWORD,esisave:DWORD,edisave:DWORD
  LOCAL ffound:BYTE
  LOCAL esizeobject:DWORD





    xor eax,eax
    ret
composecondition ENDP
;------------------------------------------------------------------------
.DATA
szfasyncissig BYTE "fASYNC=issig(",0
szdo	    BYTE "do { ",0Dh,0Ah,0
szif	    BYTE "if(",0
szwhile     BYTE "while(",0
szbreak     BYTE "break;",0Dh,0Ah,0
szcontinue  BYTE "continue;",0Dh,0Ah,0

szer291 BYTE "Ah-ha! You are asking GOOSEE to compose a ""goto"". "
	BYTE "GOOSEE has aborted code generation and has highlighted "
	BYTE "the offending node.",0Dh,0Ah
	BYTE "However, before you hit the ""OK"" button to exit this "
	BYTE "dialog box, a short lesson on ""goto"". Normally, an "
	BYTE "execution-flow wire out of a ring should return to the same "
	BYTE "ring. The return-wire is allowed to return to the next-"
	BYTE "ring or to ring-1 if you wish, but this version of GOOSEE "
	BYTE "will not accept jumps to a higher-numbered ring, nor jumps "
	BYTE "down other than those just mentioned as acceptable.",0Dh,0Ah
	BYTE "TO EXIT A NODE: You choose ""!!"" on the action-element. "
	BYTE "Forces current ring to be ""if"" and inserts ""break;"".",0Dh,0Ah
	BYTE "JUMP DOWN 1 RING: Allowed. Forces current ring to be ""if"".",0Dh,0Ah
	BYTE "JUMP DOWN TO RING-1: Allowed. Forces current ring to be ""if"" "
	BYTE "and inserts ""continue;"".",0Dh,0Ah
	BYTE "JUMP UP TO OUTERMOST RING: Allowed indirectly, by jumping down "
	BYTE "to ring-1. If ring-1 has a condition-element, a FALSE evaluation will cause "
	BYTE "execution to go out to outermost ring.",0Dh,0Ah
	BYTE "YOU CAN DO EVERYTHING WITHOUT GOTO!",0
szer182 BYTE "You have either a ""!!"" (exit-after-action) attached to a "
	BYTE "node, or an execution-flow wire jumps down to ring 1 from a "
	BYTE "higher ring. In the "
	BYTE "former case, GOOSEE will compose a ""break;"" for the purpose "
	BYTE "of exiting from the node, and in the latter case GOOSEE will "
	BYTE "compose a ""continue;"" for the purpose of execution bypassing "
	BYTE "lower rings and jumping down to ring 1.",0Dh,0Ah
	BYTE "HOWEVER for this to work, ring 1 MUST have a condition attached. "
	BYTE "This condition is an outer do-while loop for the entire node, "
	BYTE "and must be there, otherwise there is nothing to ""break out of"" "
	BYTE "or ""continue to"".",0Dh,0Ah
	BYTE "Note that the condition attached to ring 1 must be ""??"", i.e., "
	BYTE "a ""while"", but if you forget and leave it as just a ""?"" "
	BYTE "(an ""if"") GOOSEE will automatically change it to ""??"".",0Dh,0Ah
	BYTE "Note also, if you don't want the ""while"" attached to ring 1 "
	BYTE "to actually *do* anything, except serve its purpose for "
	BYTE "break/continue as described above, just put ""?? TRUE"" to "
	BYTE "make execution exit from ring 1, i.e., from the node.",0Dh,0Ah
	BYTE "HOWEVER, if the node is inline-code, the while may be on "
	BYTE "ring-1 of a higher-level node in the current function, "
	BYTE "as long as the do-while encompasses the proposed ""break"". "
	BYTE 0Dh,0Ah
	BYTE "Sorry for this very long error message!",0Dh,0Ah
	BYTE "GOOSEE has aborted code generation and has highlighted the "
	BYTE "offending node.",0

.CODE
composenode PROC STDCALL USES ebx ecx edx edi esi, \
		pnow:DWORD ,pfirst:DWORD, ghandle:DWORD,finline:DWORD
  LOCAL ebxsave:DWORD,ecxsave:DWORD
  LOCAL startn:WORD,srcring:DWORD
  LOCAL fifthen:BYTE
  LOCAL fnopath:BYTE
  LOCAL nbytes:DWORD,nreentryring:DWORD
  LOCAL pinasync1:DWORD,poutasync1:DWORD
  LOCAL pinasync:DWORD,poutasync:DWORD
  LOCAL foutinterasync1:DWORD,fininterasync1:DWORD
  LOCAL foutinterasync:DWORD,fininterasync:DWORD
  LOCAL pother:DWORD,forceifthen:BYTE
  LOCAL pactionlabel1:DWORD,paction1:DWORD
  LOCAL pactionlabel:DWORD,paction:DWORD
  LOCAL pcond1:DWORD,pcondn:DWORD
  LOCAL fexit:BYTE,fjumptoring1:BYTE
  LOCAL xpprev:DWORD,xecxprev:DWORD
  LOCAL pcmtlabel1:DWORD
; "composenode"
;derived from compose3ringnode(), which derived from compose2ringnode().
;(now deleted)
;enter with pnow-->current node, pfirst-->first node in subdiagram,
;ghandle=handle to file.
;finline=0, node not inline, =1 node inline (macro).
;compose the text for the node and write it to file.
;return nothing, except eax=-1 error.
;adapted from compose2ringnode(). this func is for composing 3-ring nodes.
; ... no, any # of rings.
;special feature is avoid use of code labels.

  mov  edi,pnow
  mov pcond1,0
  mov pcondn,0
  mov paction,0
  mov paction1,0
  mov pactionlabel,0
  mov pactionlabel1,0
  mov pcmtlabel1,0
  mov szscr1,0
  mov szscr3,0

;***NOTE*** modify composepathfromring() so it doesn't compose
;signals, i.e. postsig() and issig(), as it is done below.
;***NOTE*** composepathfromring() calls composepassed() which composes
;to szscr1 -- be careful at this level to writefile szscr1 beforehand.

    mov srcring,1
;we need to know if ring1 has a condition...
    invoke findcondition, pnow,1 ;returns eax->condition, else 0
    mov pcond1,eax
    .IF eax==0
    .ELSE

      ;191100
      ;no, it must be "if"...
      ;;it is not appropriate for the cond1 to be "if"...
      ;mov ebx,pcond1
      ;mov al,(OBJECT PTR [ebx]).fconfig2
      ;and al,11111100b
      ;or  al,00000010b	    ;set "while"
      ;mov (OBJECT PTR [ebx]).fconfig2,al

    .ENDIF

    mov srcring,1
;find action and comment wires for ring1... write comment...
  xor  eax,eax
  mov  eax,srcring
  ;note, this also finds any attached comment...
  invoke findactionwire, edi, eax	;returns eax-->label, =0 no action,
  .IF  eax==-1			      ; ecx-->action wire,ax=-1 error,
    ret	;error exit.
  .ENDIF
  mov  pactionlabel1,eax	;returns ebx-->comment label, =0 no comment.
  mov pcmtlabel1,ebx
  mov  paction1,ecx
  .IF ebx==0
  .ELSE		;write comment to disk...
  ;NOTE findactionwire() finds any comment attached to node, ignores ring#.
    ;but not if first node in subdiagram...
    ;141000 ... no, now have text-file icon to #include files...
     jmp SHORT de1	;...so, compose comment normal way always.
    mov edi,pnow
    .IF edi==pfirst
    .ELSE
de1:  lea ebx,szscr1
      invoke indentation, ebx,g_nlevel
      mov ebx,eax	;new insertion point.
      mov  [ebx],BYTE PTR "/"
      inc ebx
      mov  [ebx],BYTE PTR "*"
      inc ebx
      mov  [ebx],BYTE PTR " "
      inc ebx

	;invoke lstrcpy, ebx,pcmtlabel1
	;problem, if comment more than 1 line, all need indent...
	push esi
	mov esi,pcmtlabel1  ;copy string from here.
rr2:	mov al,[esi]
	mov [ebx],al	   ;to here.
	.IF al==0
	  pop esi
	  jmp rr1	;done.
	.ENDIF
	inc ebx
	inc esi
	.IF al==0Ah
	  mov al,[esi]
	  .IF al==0
	    mov [ebx],al
	    pop esi
	    jmp rr1	;done.
	  .ELSE
rr3:	    invoke indentation, ebx,g_nlevel
	    mov ebx,eax
	  .ENDIF
	.ELSEIF al==0Dh
	  mov al,[esi]
	  .IF al==0	;unix-style.
	    mov [ebx],al
	    pop esi
	    jmp rr1	;done
	  .ELSEIF al==0Ah
	  .ELSE 	;unix-style.
	    jmp rr3
	  .ENDIF
	.ENDIF
	jmp rr2
rr1:

      invoke lstrlen, ADDR szscr1
      lea  ebx,szscr1
;      .IF eax>65
;	mov eax,65
;	add ebx,eax
;	dec ebx
;	mov  [ebx],BYTE PTR 128 ;special char to mark string truncated.
;	inc ebx
;	mov [ebx],BYTE PTR 0
;      .ELSE
	add ebx,eax
;      .ENDIF
      mov [ebx],BYTE PTR " "
      inc ebx
      mov  [ebx],BYTE PTR "*"
      inc ebx
      mov  [ebx],BYTE PTR "/"
      inc ebx
      mov  [ebx],BYTE PTR 0Dh
      inc ebx
      mov  [ebx],BYTE PTR 0Ah
      inc ebx
      mov  [ebx],BYTE PTR 0
      add  eax,5
	mov ebx,eax
	invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
	mov szscr1,0
    .ENDIF
  .ENDIF

;read any async i/ps into ring1...
;for ring1, if there is an interthread or local-async i/p wire, get it now...
  mov  szscr1,0
    invoke findinterwire, edi,1 ;ret g_poutinter-->o/p wire,g_pininter-->i/pw.
    ;...i'm modifying this to also return non-inter-task async,
    ; ebx->async i/p else =0, ecx->async o/p else =0.
    mov pinasync1,ebx
    mov poutasync1,ecx
    ;g_pininter-->inter-thread i/p wire, if found, else 0. (global)
    ;eax=foutinterasync,edx=fininterasync; =1,flags if inter-wires are async., else 0.
    ;eax=-1 error.
    .IF  eax==-1
      ret
    .ENDIF
    mov foutinterasync1,eax
    mov fininterasync1,edx

;compose normal (non intertask) i/p async wire...
    .IF pinasync1==0
    .ELSE	;async i/p wire.
      lea ebx,szscr1
      invoke indentation, ebx,g_nlevel
      mov ebx,eax	;new insertion point.
      lea ecx,szfasyncissig
      invoke lstrcpy,ebx,ecx
      invoke lstrlen, ADDR szscr1
      lea  ebx,szscr1
      add  ebx,eax
		push ebx
		mov ebx,pinasync1    ;async i/p wire.
		mov eax,(OBJECT PTR [ebx]).rplock2
		add eax,pTERSEDATA
		.IF eax==edi	;yes dest-end at current node.
		  xor eax,eax
		  mov  ax,(OBJECT PTR [ebx]).nprimary ;see defaultnewwire().
		.ELSE  ;"i/p" is actually the reply of an o/p wire.
		  xor eax,eax
		  mov  ax,(OBJECT PTR [ebx]).nsecondary ;see defaultnewwire().
		.ENDIF
		pop ebx
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4	;5 digits max. allowed.
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  invoke lstrcpy, ebx, esi
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
      mov  [ebx],BYTE PTR ")"
      inc ebx
      mov  [ebx],BYTE PTR ";"
      inc ebx
      mov  [ebx],BYTE PTR 0Dh
      inc ebx
      mov  [ebx],BYTE PTR 0Ah
      inc ebx
      mov [ebx],BYTE PTR 0
	  invoke lstrlen, ADDR szscr1
	  mov  ebx,eax
	invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
      mov  szscr1,0
    .ENDIF
;...have written async i/p wire.

;if there is a condition on ring1, need an outer do-while loop...
  .IF pcond1==0
  .ELSE
      lea ebx,szscr1
      invoke indentation, ebx,g_nlevel
      mov ebx,eax	;new insertion point.
    lea eax,szdo
    invoke lstrcpy, ebx,eax
    invoke lstrlen, ADDR szscr1
    mov ebx,eax
    invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
    mov szscr1,0
  .ENDIF


;.......
;now compose each ring, from outermost...
    mov edi,pnow
    xor eax,eax
    mov al,(OBJECT PTR [edi]).nrings
    mov srcring,eax
jmp1:		    ;come back here to compose next-down ring.
    mov fexit,0     ;set to 1 if "!!" further down, forcing "break;".
    cmp srcring,1   ;(decr. srcring before jumping to here)
    je	jmp2	    ;finished.

;.......
;jumps are a problem, as any wire out of ring and reentry to another ring
;must force an "if" on ring...
	mov szscr3,0
	invoke findreentryring, pfirst,ghandle,pnow,srcring
      ;...modified version of composepathfromring(), doesn't compose anything.
	;... eax=ring that path returns to, eax=-1 error.
	;... ecx=0 if no path composed, else non-0.
	mov fnopath,0
	mov fjumptoring1,0
	mov forceifthen,0   ;do not force if-then
	mov nreentryring,eax
	.IF ecx==0
	  mov fnopath,1
	.ENDIF
	.IF eax==-1
	  ret
	.ELSEIF eax==1	;force if-then statement ringn.
	  mov forceifthen,1
	.ELSE
	  .IF eax==srcring
	  .ELSE
	    mov forceifthen,1
	  .ENDIF
	.ENDIF

;find action wire for ringn...
  mov  eax,srcring
  invoke findactionwire, edi, eax	;returns eax-->label, =0 no action,
  .IF  eax==-1			      ; ecx-->action wire,eax=-1 error,
    ret	;error exit.
  .ENDIF
  mov  pactionlabel,eax	;returns ebx-->comment label, =0 no comment.
  mov  paction,ecx
  ;ebx->comment label, =0 no comment. note, currently comments are only
  ;1 per node, and already composed above. they're not attachable to
		      ;particular rings.
    ;if the path nreentryring was anything other than srcring,
    ;a "!!" is not appropriate on srcring (since not returning to it)...
    mov ebx,paction
    .IF ebx==0
    .ELSE
      mov eax,nreentryring
      .IF eax==srcring
      .ELSE
	mov al,(OBJECT PTR [ebx]).fconfig
	and al,11011111b
	mov (OBJECT PTR [ebx]).fconfig,al
      .ENDIF
    .ENDIF


;determine condition for ring...
    invoke findcondition, pnow,srcring
    mov pcondn,eax
    .IF pcondn==0	;=0 no condition wire.
      mov fifthen,1
    .ELSE
      mov ebx,pcondn
      mov al,(OBJECT PTR [ebx]).fconfig2
      and al,011b
      .IF al==01	;cond wire set to "?" if-then
	mov fifthen,1
      .ELSE		;cond wire is set to "??" while-do
	.IF forceifthen==0
	  ;if action is "!!" (exit-after-reentry), must have "if"...
	  mov esi,paction
	  cmp esi,0	    ;precaution
	  je  wc1
	  mov al,(OBJECT PTR [esi]).fconfig
	  and al,0100000b	;bit5=1 "!!"
	  .IF al==0
wc1:	    mov fifthen,0	;"while"
	  .ELSE
	    mov fifthen,1	;force "if"
	    ;and change cond wire...
ch1:	    mov al,(OBJECT PTR [ebx]).fconfig2
	    and al,11111100b
	    or	al,00000001b	    ;force "?" "if"
	    mov (OBJECT PTR [ebx]).fconfig2,al
	  .ENDIF
	.ELSE
	  mov fifthen,1
	  jmp ch1
	.ENDIF
      .ENDIF
    .ENDIF

;for ring, compose an "if" or "while"...
  .IF fifthen==0
    lea eax,szwhile
  .ELSE
    lea eax,szif
  .ENDIF
  .IF pcondn==0
  .ELSE
      push eax
      lea ebx,szscr1
      mov eax,g_nlevel
      .IF pcond1 != 0
	inc eax
      .ENDIF
      invoke indentation, ebx,eax ;g_nlevel
      mov ebx,eax	;new insertion point.
      pop eax
    invoke lstrcpy, ebx,eax
    invoke lstrlen, ADDR szscr1
    mov ebx,eax
    invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
    mov szscr1,0
  .ENDIF

;now compose cond...
  .IF pcondn==0
  .ELSE
    mov ebx,pcondn
      ;if used external editor, it may have a 0Dh/0Ah on end...
      lea eax,(OBJECT PTR [ebx]).sztext2
      invoke lstrlen, eax
      mov ebx,pcondn
      lea  edx,(OBJECT PTR [ebx]).sztext2
      add  edx,eax
      mov ebx,edx
      dec ebx
      mov al,[ebx]
      .IF al==0Ah
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
	mov g_fhaschanged,1
      .ELSEIF al==0Dh
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
	mov g_fhaschanged,1
      .ENDIF
      .IF al==0Ah
	mov [ebx],BYTE PTR 0
      .ELSEIF al==0Dh
	mov [ebx],BYTE PTR 0
      .ENDIF
    mov ebx,pcondn
    lea eax,(OBJECT PTR [ebx]).sztext2
      push eax
      lea ebx,szscr1
;      invoke indentation, ebx,g_nlevel
;      mov ebx,eax	;new insertion point.
      pop eax
    invoke lstrcpy,ebx,eax
    invoke lstrlen, ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    mov [ebx],BYTE PTR ")"
    inc ebx
    mov [ebx],BYTE PTR " "
    inc ebx
    mov [ebx],BYTE PTR "{"
    inc ebx
    mov [ebx],BYTE PTR 0Dh
    inc ebx
    mov [ebx],BYTE PTR 0Ah
    inc ebx
    mov [ebx],BYTE PTR 0
    add eax,5
    mov ebx,eax
    invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
    mov szscr1,0
  .ENDIF


;now compose the action for ring...
;write the local action for the current ring...
  mov  eax,pactionlabel	;->action label. =0 if no action.
  .IF eax==0
  .ELSE 		;write action to disk...
      mov  ebx,pactionlabel	;-->action label.
      mov  al,[ebx]
      cmp  al,0 	;=0, no label.
      jne  acta
      mov  szscr1,BYTE PTR " "
      mov  szscr1+1,BYTE PTR " "
      mov  szscr1+2,BYTE PTR 0
      jmp  actb
acta:
    mov  eax,pactionlabel		   ;-->action label. 49 char max.
      push eax
      lea ebx,szscr1
      mov eax,g_nlevel
      .IF pcondn != 0
	inc eax		;1 extra indent.
      .ENDIF
      .IF pcond1 != 0
	inc eax
      .ENDIF
      invoke indentation, ebx,eax ;g_nlevel
      mov ebx,eax	;new insertion point.
      pop eax

;    invoke lstrcpy, ebx,eax
	;problem, if action more than 1 line, all need indent...
	push esi
	mov esi,eax	;copy string from here.
xrr2:	mov al,[esi]
	mov [ebx],al	   ;to here.
	.IF al==0
	  pop esi
	  jmp xrr1	;done.
	.ENDIF
	inc ebx
	inc esi
	.IF al==0Ah
	  mov al,[esi]
	  .IF al==0
	    mov [ebx],al
	    pop esi
	    jmp xrr1	;done.
	  .ELSE
xrr3:	    mov eax,g_nlevel
	    .IF pcondn != 0
	      inc eax		;1 extra indent.
	    .ENDIF
	    .IF pcond1 != 0
	      inc eax
	    .ENDIF
	    invoke indentation, ebx,eax ;g_nlevel
	    mov ebx,eax
	  .ENDIF
	.ELSEIF al==0Dh
	  mov al,[esi]
	  .IF al==0	;unix-style.
	    mov [ebx],al
	    pop esi
	    jmp xrr1	;done
	  .ELSEIF al==0Ah
	  .ELSE 	;unix-style.
	    jmp xrr3
	  .ENDIF
	.ENDIF
	jmp xrr2
xrr1:

    invoke lstrlen, ADDR szscr1
    lea  ebx,szscr1
    add  ebx,eax
    dec ebx
    mov al,[ebx]
      ;get rid of any carriage-return/linefeed...
      .IF al==0Ah
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
      .ELSEIF al==0Dh
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
      .ENDIF
      .IF al==0Ah
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
      .ELSEIF al==0Dh
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
      .ENDIF
    inc ebx
    .IF al==";"
    .ELSE
      ;auto-compose trailing ";" if it aint there...
      ;but NOT if object.fconfig2/bit3 =1...
      push ebx
      mov ebx,paction
      mov al,(OBJECT PTR [ebx]).fconfig2
      pop ebx
      and al,01000b	;extract bit3
      .IF al==0
	mov  [ebx],BYTE PTR ";" ;append.
	inc ebx
	mov  [ebx],BYTE PTR 0
      .ELSE
	mov  [ebx],BYTE PTR 0  ;precaution.
      .ENDIF
    .ENDIF

actb:	;if exit-after-action... ("double action")
      mov   ebx,paction	;ptr to action wire, found by findactionwire().
      mov   cl,(OBJECT PTR [ebx]).fconfig
      and   cl,00100000b	;bit5. set if double-action.
      .IF   cl==0
	mov fexit,0
      .ELSE
	mov fexit,1	;must compose "break;" after return to ring
      .ENDIF
      invoke lstrlen, ADDR szscr1
      lea ebx,szscr1
      add ebx,eax
	  mov  [ebx],BYTE PTR 0Dh
	  mov  [ebx+1],BYTE PTR 0Ah
	  mov  [ebx+2],BYTE PTR 0
      add eax,2
      mov ebx,eax
      invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
  .ENDIF


;now post async msgs from ring...
;compose any o/p async from ring.... (edi->current node)
;Note, findinterwire() returned poutasync, but it's just one.
;need to locate possible multiple async o/ps from same ring...
    mov xpprev,0
    mov xecxprev,0
ee1: mov eax,xpprev
     mov pprevwire,eax
     mov eax,xecxprev
     mov ecxprevwire,eax
     invoke findsignalout, edi,srcring
     ;...return eax->wire, else eax=0
     ;note, poutasync is wire with  *any* o/p path, including reply or
     ;incoming of a 2-way async wire.
     mov ecx,pprevwire	    ;save global
     mov xpprev,ecx
     mov ecx,ecxprevwire    ;/
     mov xecxprev,ecx

    mov poutasync,eax
    .IF poutasync==0
    .ELSE
      ;need to find out what node# the msg is being posted to...
      mov ebx,poutasync
      mov ecx,(OBJECT PTR [ebx]).rplock2
      add ecx,pTERSEDATA
      mov eax,(OBJECT PTR [ebx]).rplock1
      add eax,pTERSEDATA
      mov pother,eax
      .IF eax==edi
	mov pother,ecx
      .ENDIF
      lea ebx,szscr1
      mov eax,g_nlevel
      .IF pcondn != 0
	inc eax		;1 extra indent.
      .ENDIF
	    .IF pcond1 != 0
	      inc eax
	    .ENDIF
      invoke indentation, ebx,eax ;g_nlevel
      mov ebx,eax	;new insertion point.
      mov  [ebx],BYTE PTR "p"
      inc ebx
      mov  [ebx],BYTE PTR "o"
      inc ebx
      mov  [ebx],BYTE PTR "s"
      inc ebx
      mov  [ebx],BYTE PTR "t"
      inc ebx
      mov  [ebx],BYTE PTR "s" ;"m"
      inc ebx
      mov  [ebx],BYTE PTR "i" ;"s"
      inc ebx
      mov  [ebx],BYTE PTR "g" ;"g"
      inc ebx
      mov  [ebx],BYTE PTR "("
      inc ebx
		push ebx
		mov ebx,poutasync	  ;async o/p wire.
		mov eax,(OBJECT PTR [ebx]).rplock1
		add eax,pTERSEDATA
		.IF eax==edi	;yes first-end at current node.
		  xor eax,eax
		  mov  ax,(OBJECT PTR [ebx]).nprimary ;see defaultnewwire().
		.ELSE  ;"o/p" is actually the reply of an i/p wire.
		  xor eax,eax
		  mov  ax,(OBJECT PTR [ebx]).nsecondary ;see defaultnewwire().
		.ENDIF
		pop ebx
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4	;5 digits max. allowed.
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  invoke lstrcpy, ebx, esi
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
      mov  [ebx],BYTE PTR ")"
      inc ebx
      mov  [ebx],BYTE PTR ";"
      inc ebx
      mov  [ebx],BYTE PTR 0Dh
      inc ebx
      mov  [ebx],BYTE PTR 0Ah
      inc ebx
      mov [ebx],BYTE PTR 0
	  invoke lstrlen, ADDR szscr1
	  mov  ebx,eax
	invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
      mov  szscr1,0
      jmp ee1	    ;find if another async o/p to write.
    .ENDIF


;now compose path from ring...
;beginning of this func called findreentryring(), which is cutdown
;version that doesn't compose anything. Do compose now...
;note, composepathfromring() may be recursive, as if a node is inline code,
;will call composenode().
  mov szscr1,0
  .IF fnopath==0
    mov szscr3,0
	    mov eax,g_nlevel
	    push eax
	    .IF pcondn != 0
	      inc eax		;1 extra indent.
	    .ENDIF
	    .IF pcond1 != 0
	      inc eax
	    .ENDIF
	    mov g_nlevel,eax
	invoke composepathfromring, pfirst,ghandle,pnow,srcring
	    pop eax
	    mov g_nlevel,eax
    mov szscr3,0
    mov szscr1,0
  .ENDIF


;now compose async i/p to ring...
;for ring, if there is an interthread or local-async i/p wire, get it now...
;BUT, if there was path reentry to a different ring, use that...
  mov  szscr1,0
    invoke findinterwire, edi,nreentryring
    ;...i'm modifying this to also return non-inter-task async,
    ; ebx->async i/p else =0, ecx->async o/p else =0.
    mov pinasync,ebx	      ;<<<THIS is only one using here.
    mov poutasync,ecx
    ;g_pininter-->inter-thread i/p wire, if found, else 0. (global)
    ;eax=foutinterasync,edx=fininterasync; =1,flags if inter-wires are async., else 0.
    ;eax=-1 error.
    .IF  eax==-1
      ret
    .ENDIF
    mov foutinterasync,eax
    mov fininterasync,edx


;compose normal (non intertask) i/p async wire...
    .IF pinasync==0
    .ELSE	;async i/p wire.
      lea ebx,szscr1
      mov eax,g_nlevel
      .IF pcondn != 0
	inc eax		;1 extra indent.
      .ENDIF
	    .IF pcond1 != 0
	      inc eax
	    .ENDIF
      invoke indentation, ebx,eax ;g_nlevel
      mov ebx,eax	;new insertion point.
      lea ecx,szfasyncissig
      invoke lstrcpy,ebx,ecx
      invoke lstrlen, ADDR szscr1
      lea  ebx,szscr1
      add  ebx,eax
		push ebx
		mov ebx,pinasync    ;async i/p wire.
		mov eax,(OBJECT PTR [ebx]).rplock2
		add eax,pTERSEDATA
		.IF eax==edi	;yes dest-end at current node.
		  xor eax,eax
		  mov  ax,(OBJECT PTR [ebx]).nprimary ;see defaultnewwire().
		.ELSE  ;"i/p" is actually the reply of an o/p wire.
		  xor eax,eax
		  mov  ax,(OBJECT PTR [ebx]).nsecondary ;see defaultnewwire().
		.ENDIF
		pop ebx
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4	;5 digits max. allowed.
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  invoke lstrcpy, ebx, esi
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
      mov  [ebx],BYTE PTR ")"
      inc ebx
      mov  [ebx],BYTE PTR ";"
      inc ebx
      mov  [ebx],BYTE PTR 0Dh
      inc ebx
      mov  [ebx],BYTE PTR 0Ah
      inc ebx
      mov [ebx],BYTE PTR 0
	  invoke lstrlen, ADDR szscr1
	  mov  ebx,eax
	invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
      mov  szscr1,0
    .ENDIF
;...have written async i/p wire.


;if fexit flag set, must get out of node...
  .IF fexit==1
    ;need "break;"...(if is forced exit, "!!")
    lea eax,szbreak
tm1:
       ;break/continue will only work if ring1 has a "while", i.e., a
       ;condition attached (it is forced to be a while, not an if).
       .IF pcond1==0	;no cond on ring1.
	 ;101000
	 ;however, if node is inline, the "while" can be at a higher-
	 ;level node within current function...
	 mov edi,pnow
	 mov al,(OBJECT PTR [edi]).nfunctype
	 .IF al==0	;inline code

	   ;**TO DO**
	   ;should trace i/ps to find "??" on ring-1...
	   ;probably use findinnerinwire() to trace i/ps to ring1
	   ;and findcondition() to find cond attached to ring1.
	   ;**DO THIS!!!***

	   ;put this back, for composing "break;"...
	   lea eax,szbreak

	 .ELSE
	  invoke MessageBox,g_hwnd,ADDR szer182,0,MB_OK+MB_ICONEXCLAMATION
		mov edi,pnow
		mov  g_perrorobject,edi
		mov eax,-1
		ret
	 .ENDIF
       .ENDIF
      push eax
      lea ebx,szscr1
      mov eax,g_nlevel
      .IF pcondn != 0
	inc eax		;1 extra indent.
      .ENDIF
	    .IF pcond1 != 0
	      inc eax
	    .ENDIF
      invoke indentation, ebx,eax ;g_nlevel
      mov ebx,eax	;new insertion point.
      pop eax
    invoke lstrcpy, ebx,eax
    invoke lstrlen, ADDR szscr1
    mov ebx,eax
    invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
    mov szscr1,0
  .ELSE
    mov eax,nreentryring
    .IF eax<srcring	  ;path jumps down one or more rings
      mov eax,srcring
      sub eax,nreentryring
      .IF eax==1
	;jumping down 1 ring is no problem, as an "if" should have been
	;been forced, so will drop down to next if/while anyway.
      .ELSE
	;if the jump is down to ring1, compose "continue;" here...
	.IF nreentryring==1
	  lea eax,szcontinue
	  jmp tm1
	.ELSE
	  ;more difficult!   ***NOTE***   (use goto?)
jmp5:	  lea  eax,szer291
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov  g_perrorobject,edi
	  mov eax,-1
	  ret
	.ENDIF
      .ENDIF
    .ELSEIF eax>srcring   ;path jumps up one or more rings.
      ;difficult!  ***NOTE***	(use goto?)
      jmp jmp5
    .ENDIF
  .ENDIF


;now close ring's loop...
;but if no condn, the above code won't have compose "if/while(condn){"
;so, check...
  .IF pcondn==0
    mov szscr1,0
  .ELSE
      lea ebx,szscr1
	    mov eax,g_nlevel
	    .IF pcond1 != 0
	      inc eax
	    .ENDIF
      invoke indentation, ebx,eax ;g_nlevel
      mov ebx,eax	;new insertion point.
    mov [ebx],BYTE PTR "}"
    inc ebx
    mov [ebx],BYTE PTR 0Dh
    inc ebx
    mov [ebx],BYTE PTR 0Ah
    inc ebx
    mov [ebx],BYTE PTR 0
    invoke lstrlen,ADDR szscr1
    mov ebx,eax
    invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
    mov szscr1,0
  .ENDIF


;have finished composing a ring.
    dec srcring
    jmp jmp1	     ;go back to top and compose next-inner ring.


jmp2:	    ;jumps here when finished composing the rings >1.
;........
  mov szscr1,0
;now close outer do-while loop for ring1...
;but if no cond1, there won't be any....
  .IF pcond1==0
  .ELSE
      lea ebx,szscr1
      invoke indentation, ebx,g_nlevel
      mov ebx,eax	;new insertion point.
;    invoke lstrlen, ADDR szscr1
;    lea ebx,szscr1
;    add ebx,eax
    mov [ebx],BYTE PTR "}"
    inc ebx
    mov [ebx],BYTE PTR 0Dh
    inc ebx
    mov [ebx],BYTE PTR 0Ah
    inc ebx
    mov [ebx],BYTE PTR 0
  .ENDIF
  .IF szscr1==0
  .ELSE
    invoke lstrlen, ADDR szscr1
    mov ebx,eax
    invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
    mov szscr1,0
  .ENDIF


;now compose the outer while (if there is a cond1)...
  .IF pcond1==0
  .ELSE
      lea ebx,szscr1
      invoke indentation, ebx,g_nlevel
      mov ebx,eax	;new insertion point.
    lea eax,szwhile
    invoke lstrcpy, ebx,eax
    ;and the condition...
	  invoke lstrlen, ADDR szscr1
	  lea  ecx,szscr1
	  add  ecx,eax
	  mov ebx,ecx
	  mov [ebx],BYTE PTR "!"    ;exit from node if not true.
	  inc ebx
	  inc ecx
	  mov [ebx],BYTE PTR "("    ;and another "("!
	  inc ebx
	  inc ecx
	  mov [ebx],BYTE PTR 0
    mov ebx,pcond1
      ;if used external editor, it may have a 0Dh/0Ah on end...
      lea eax,(OBJECT PTR [ebx]).sztext2
      push ecx
      invoke lstrlen, eax
      pop ecx
      mov ebx,pcond1
      lea  edx,(OBJECT PTR [ebx]).sztext2
      add  edx,eax
      mov ebx,edx
      dec ebx
      mov al,[ebx]
      .IF al==0Ah
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
	mov g_fhaschanged,1
      .ELSEIF al==0Dh
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
	mov g_fhaschanged,1
      .ENDIF
      .IF al==0Ah
	mov [ebx],BYTE PTR 0
      .ELSEIF al==0Dh
	mov [ebx],BYTE PTR 0
      .ENDIF
    mov ebx,pcond1
    lea eax,(OBJECT PTR [ebx]).sztext2
    invoke lstrcpy,ecx,eax
    invoke lstrlen, ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    mov [ebx],BYTE PTR ")"
    inc ebx
    mov [ebx],BYTE PTR 0
    invoke lstrlen, ADDR szscr1
    lea ebx,szscr1
    add ebx,eax
    mov [ebx],BYTE PTR ")"
    inc ebx
    mov [ebx],BYTE PTR ";"
    inc ebx
    mov [ebx],BYTE PTR 0Dh
    inc ebx
    mov [ebx],BYTE PTR 0Ah
    inc ebx
    mov [ebx],BYTE PTR 0
    invoke lstrlen, ADDR szscr1
    mov ebx,eax
    invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
    mov szscr1,0
  .ENDIF

;.....
;compose action for ring1...
;write the local action for the current ring...
  mov  eax,pactionlabel1	;->action label. =0 if no action.
  .IF eax==0
  .ELSE 		;write action to disk...
      mov  ebx,pactionlabel1	;-->action label.
      mov  al,[ebx]
      cmp  al,0 	;=0, no label.
      jne  iacta
      mov  szscr1,BYTE PTR " "
      mov  szscr1+1,BYTE PTR " "
      mov  szscr1+2,BYTE PTR 0
      jmp  iactb
iacta:
      lea ebx,szscr1
      invoke indentation, ebx,g_nlevel
      mov ebx,eax	;new insertion point.
    mov  eax,pactionlabel1		   ;-->action label.

;    invoke lstrcpy, ebx, eax
	;problem, if action more than 1 line, all need indent...
	push esi
	mov esi,eax	;copy string from here.
zxrr2:	mov al,[esi]
	mov [ebx],al	   ;to here.
	.IF al==0
	  pop esi
	  jmp zxrr1	;done.
	.ENDIF
	inc ebx
	inc esi
	.IF al==0Ah
	  mov al,[esi]
	  .IF al==0
	    mov [ebx],al
	    pop esi
	    jmp zxrr1	;done.
	  .ELSE
zxrr3:	    mov eax,g_nlevel
	    invoke indentation, ebx,g_nlevel
	    mov ebx,eax
	  .ENDIF
	.ELSEIF al==0Dh
	  mov al,[esi]
	  .IF al==0	;unix-style.
	    mov [ebx],al
	    pop esi
	    jmp zxrr1	;done
	  .ELSEIF al==0Ah
	  .ELSE 	;unix-style.
	    jmp zxrr3
	  .ENDIF
	.ENDIF
	jmp zxrr2
zxrr1:

    invoke lstrlen, ADDR szscr1
    lea  ebx,szscr1
    add  ebx,eax
    dec ebx
    mov al,[ebx]
      ;get rid of any carriage-return/linefeed...
      .IF al==0Ah
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
      .ELSEIF al==0Dh
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
      .ENDIF
      .IF al==0Ah
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
      .ELSEIF al==0Dh
	mov [ebx],BYTE PTR 0
	dec ebx
	mov al,[ebx]
      .ENDIF
    inc ebx
    .IF al==";"
    .ELSE
      ;auto-compose trailing ";" if it aint there...
      ;but NOT if object.fconfig2/bit3 =1...
      push ebx
      mov ebx,paction1
      mov al,(OBJECT PTR [ebx]).fconfig2
      pop ebx
      and al,01000b	;extract bit3
      .IF al==0
	mov  [ebx],BYTE PTR ";" ;append.
	inc ebx
	mov  [ebx],BYTE PTR 0
      .ELSE
	mov  [ebx],BYTE PTR 0  ;precaution.
      .ENDIF
    .ENDIF

iactb:	;if exit-after-action... ("double action")
      mov   ebx,paction1  ;ptr to ring1 action wire, found by findactionwire().
      mov   cl,(OBJECT PTR [ebx]).fconfig
      and   cl,00100000b	;bit5. set if double-action.
      .IF   cl==0
hh1:	invoke lstrlen, ADDR szscr1
	lea  ebx,szscr1
	add  ebx,eax
	  mov  [ebx],BYTE PTR 0Dh
	  mov  [ebx+1],BYTE PTR 0Ah
	  mov  [ebx+2],BYTE PTR 0
	  add  eax,2
      .ELSE
	;force action1 to "!"...
	;(it is not appropriate for "!!" on ring 1)
	mov cl,(OBJECT PTR [ebx]).fconfig
	and cl,11011111b
	mov (OBJECT PTR [ebx]).fconfig,cl
	jmp hh1
      .ENDIF
      mov ebx,eax
      invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
      mov szscr1,0
  .ENDIF

;now write the default exit...
exit184:

;compose any o/p async from ring1.... (edi->current node)
;Note, findinterwire() returned poutasync, but it's just one.
;need to locate possible multiple async o/ps from same ring...
    mov xpprev,0
    mov xecxprev,0
xee1: mov eax,xpprev
     mov pprevwire,eax
     mov eax,xecxprev
     mov ecxprevwire,eax
     invoke findsignalout, edi,1 ;1=ring#
     ;...return eax->wire, else eax=0
     ;note, poutasync is wire with  *any* o/p path, including reply or
     ;incoming of a 2-way async wire.
     mov ecx,pprevwire	    ;save global
     mov xpprev,ecx
     mov ecx,ecxprevwire    ;/
     mov xecxprev,ecx

    mov poutasync1,eax
    .IF poutasync1==0
    .ELSE
      ;need to find out what node# the msg is being posted to...
      mov ebx,poutasync1
      mov ecx,(OBJECT PTR [ebx]).rplock2
      add ecx,pTERSEDATA
      mov eax,(OBJECT PTR [ebx]).rplock1
      add eax,pTERSEDATA
      mov pother,eax
      .IF eax==edi
	mov pother,ecx
      .ENDIF
      lea ebx,szscr1
      invoke indentation, ebx,g_nlevel
      mov ebx,eax	;new insertion point.
      mov  [ebx],BYTE PTR "p"
      inc ebx
      mov  [ebx],BYTE PTR "o"
      inc ebx
      mov  [ebx],BYTE PTR "s"
      inc ebx
      mov  [ebx],BYTE PTR "t"
      inc ebx
      mov  [ebx],BYTE PTR "s" ;"m"
      inc ebx
      mov  [ebx],BYTE PTR "i" ;"s"
      inc ebx
      mov  [ebx],BYTE PTR "g" ;"g"
      inc ebx
      mov  [ebx],BYTE PTR "("
      inc ebx
		push ebx
		mov ebx,poutasync1	  ;async o/p wire.
		mov eax,(OBJECT PTR [ebx]).rplock1
		add eax,pTERSEDATA
		.IF eax==edi	;yes first-end at current node.
		  xor eax,eax
		  mov  ax,(OBJECT PTR [ebx]).nprimary ;see defaultnewwire().
		.ELSE  ;"o/p" is actually the reply of an i/p wire.
		  xor eax,eax
		  mov  ax,(OBJECT PTR [ebx]).nsecondary ;see defaultnewwire().
		.ENDIF
		pop ebx
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4	;5 digits max. allowed.
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  invoke lstrcpy, ebx, esi
	  invoke lstrlen, ADDR szscr1
	  lea  ebx,szscr1
	  add  ebx,eax
      mov  [ebx],BYTE PTR ")"
      inc ebx
      mov  [ebx],BYTE PTR ";"
      inc ebx
      mov  [ebx],BYTE PTR 0Dh
      inc ebx
      mov  [ebx],BYTE PTR 0Ah
      inc ebx
      mov [ebx],BYTE PTR 0
	  invoke lstrlen, ADDR szscr1
	  mov  ebx,eax
	invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
      mov  szscr1,0
      jmp xee1	    ;find if another async o/p to write.
    .ENDIF

;compose any o/p inter-task from ring1...
    ;***NOTE*** TO DO

;compose final exit from node...
  lea  ebx,szscr1
      .IF finline==0
	invoke indentation, ebx,g_nlevel
	mov ebx,eax	;new insertion point.
	mov [ebx],BYTE PTR "r"
	inc ebx
	mov  [ebx],BYTE PTR "e"
	inc ebx
	mov  [ebx],BYTE PTR "t"
	inc ebx
	mov  [ebx],BYTE PTR "u"
	inc ebx
	mov  [ebx],BYTE PTR "r"
	inc ebx
	mov  [ebx],BYTE PTR "n"
	inc ebx
	mov  [ebx],BYTE PTR " "
	inc ebx
	mov [ebx],BYTE PTR 0
	  ;now get the return parameter...
	  mov edi,pnow		;current node.
	  lea esi,(OBJECT PTR [edi]).sztext4
	  ;look for "void"...
zgd2:	    mov al,[esi]
	    inc esi
	    cmp al,0
	    je	zgd1	    ;didn't find "void" string.
	    cmp al,"v"
	    jne zgd2
	    mov al,[esi]
	    .IF al=="o"
	     mov al,[esi+1]
	     .IF al=="i"
	       mov al,[esi+2]
	       .IF al=="d"
		 ;found "void"...
		 ;nothing after "return"...
		 jmp SHORT zk1
	       .ENDIF
	     .ENDIF
	   .ENDIF
	   jmp zgd2
zgd1:
	;if we knew a parameter name, could compose it here...
zk4:
	;no void, there is a datatype but no paramname....
	;so, just pass "0"...
	mov [ebx],BYTE PTR "0"
	inc ebx
	mov [ebx],BYTE PTR 0
zk1:
	invoke lstrlen, ADDR szscr1
	lea  ebx,szscr1
	add  ebx,eax
	mov  [ebx],BYTE PTR ";"
	inc ebx
	  mov  [ebx],BYTE PTR 0Dh
	  inc ebx
	  mov  [ebx],BYTE PTR 0Ah
	  inc ebx
	  mov  [ebx],BYTE PTR 0
      .ELSE
	  mov  [ebx],BYTE PTR 0Dh
	  inc ebx
	  mov  [ebx],BYTE PTR 0Ah
	  inc ebx
	  mov  [ebx],BYTE PTR 0
      .ENDIF

  invoke lstrlen, ADDR szscr1
	mov ebx,eax
	invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
	mov szscr1,0

;..................
fincode:
;have composed the code for the node.
;hurray!!!


  .IF finline==0
    lea	ebx,szendit
  .ELSE
    lea  ebx,szendit2
  .ENDIF
  invoke lstrcpy, ADDR szscr1, ebx
  invoke lstrlen, ADDR szscr1
	mov ebx,eax
	invoke WriteFile, ghandle,ADDR szscr1,ebx,ADDR nbytes,0
	mov szscr1,0
    xor eax,eax
    ret



    xor eax,eax
    ret

composenode ENDP
;------------------------------------------------------------------------
.DATA
szrestart DB " ",0  ;"THEEND",0	;note no longer used, but difficult to get
	;it out of the code!  I was composing a THEEND macro for exit out
	;of ring1 of 1st node, but now composing just like any other node
	;and composing the return in composereturns().	<<<goofee comments<<<
szisrend  DB " ",0
	;...this one not used now. <<<comment from goofee<<<
szer261 BYTE "GOOSEE has found a node with an execution-flow path into "
	BYTE "ring 1 but no path out of ring 1. Logically, this is a "
	BYTE "problem. Normally, execution should flow back to the "
	BYTE "original node/ring that the offending node is an expansion "
	BYTE "of.",0Dh,0Ah
	BYTE "GOOSEE has aborted C code generation and has highlighted "
	BYTE "the offending node.",0
szer261w BYTE "An execution-flow wire into ring-1 of a node that is "
	BYTE "inline code (not a function), must not pass any parameters, "
	BYTE "nor return a parameter.",0Dh,0Ah
	BYTE "GOOSEE has aborted C code generation and highlighted the "
	BYTE "offending wire. Please go into the dialog box of the wire "
	BYTE "and remove the passed parameters and return parameter, i.e., "
	BYTE "delete all text in those fields, including spaces.",0
szer3limit  BYTE "Oh dear. The current version of GOOSEE uses an internal "
	    BYTE "buffer for composing inline C code, prior to writing to "
	    BYTE "file. The software author Barry Kauler thought it was "
	    BYTE "more than big enough, but you have just hit the limit.",0Dh,0Ah
	    BYTE "Inline-code nodes are expanded inside a function-node, "
	    BYTE "and you must be trying to take this to the extreme, creating "
	    BYTE "an enormous function. This is not good design.",0Dh,0Ah
	    BYTE 0Dh,0Ah
	    BYTE "GOOSEE has highlighted the node where it reached the buffer "
	    BYTE "limit. Look at converting some inline-code nodes to functions. "
	    BYTE "BUT, as soon as you get out of this dialog box, look briefly "
	    BYTE "at where the offending node is, then EXIT from GOOSEE. The "
	    BYTE "reason is that the buffer limit may have been exceeded, making "
	    BYTE "GOOSEE unpredictable (unlikely, but better safe than sorry).",0
szer271 BYTE "GOOSEE doesn't know exactly what is wrong. Somehow an "
	BYTE "execution-flow 2-way wire is ""wrong"". You should never "
	BYTE "see this error message. GOOSEE is somehow detecting that a "
	BYTE "2-way wire is returning to a different node/ring from which "
	BYTE "it started.",0Dh,0Ah
	BYTE "C generation aborted. Examine the offending wire.",0
szer281 BYTE "There is a mismatch between parameters passed to and returned "
	BYTE "from a function call to a clone-node, and the prototype."
	BYTE 0Dh,0Ah
	BYTE "The prototype of a clone is the same as that of the master "
	BYTE "(root) node of the clone-chain, so look in the master's "
	BYTE "dialog box to edit the prototype. "
	BYTE "If nothing is to be passed/returned, be sure to enter "
	BYTE """void"" in the appropriate prototype fields (without "
	BYTE "the "" of course).",0Dh,0Ah
	BYTE "For the execution-flow wire/s in and out of ring 1, if "
	BYTE "nothing is to be passed/returned, delete any text "
	BYTE "in the appropriate fields of the wire's dialog box, "
	BYTE "including any spaces.",0Dh,0Ah
	BYTE "GOOSEE has aborted C code generation and has highlighted "
	BYTE "the offending node.",0

.CODE
composepathfromring PROC STDCALL USES ebx ecx edx esi edi, \
		pfnode:DWORD,gehandle:DWORD,panode:DWORD,srcring:DWORD
  LOCAL exitring:DWORD,endpath:BYTE
  LOCAL esisave:DWORD,esi2save:DWORD
  LOCAL poutw:DWORD,fisisr:WORD
  LOCAL finline:BYTE,entryring:BYTE
  LOCAL plabel:DWORD,plabelout:DWORD
  LOCAL nbytes:DWORD,pmaster:DWORD
;derived from composepaths()  (goofee)	 "composepathfromring"
;compose execution path from a ring of a node, to szscr3.
; -- write to file.
;pfnode-->first node in subdiag, gehandle=file handle.
;panode-->node, srcring = ring.
;return eax=ring that path returns to. =-1 if error, =0 no path.

;modified to not compose async messages, issig() and postsig(), as
;that's done back at composenode().

  mov  endpath,0
  mov  edi,panode
  mov szscr3,0
  mov  entryring,2
  mov  edi,panode
  xor  eax,eax
  mov	al,(OBJECT PTR [edi]).nrings
  cmp	eax,srcring
  jae	ook22		;ok
  mov eax,0		;finished. did not compose anything.
  ret

ook22:
;need to compose the path out of this ring, to szscr3...

  mov  eax,srcring

v3:
;edi-->current node as we go around path (initially it is the node
;currently being composed, panode). look for a sync wire exiting
;from srcring...
  mov  exitring,eax  ;note different from srcring, which is ring on node
		    ;at start of path. exitring is from current ring as
		    ;we go around the path.(1st time =srcring, then =1)
  ;a little job here...
  ;assign .number of first node in subdiagram to edi.nfile...
  push ebx
  mov ebx,pfnode
  mov ax,(OBJECT PTR [ebx]).number
  pop ebx
  mov (OBJECT PTR [edi]).nfile,ax

  invoke findoutwire, edi,exitring ;rets esi=ptr to wire,eax=#wires found.
  ;...NOTE an i/p 2way does not get detected as an o/p path here!
  ;   (code further down detects this)
  ;...if found more than 1 o/p wire, handles error, returns eax=-1.

  .IF  eax==-1			;error, handled inside findoutwire().
    mov eax,-1
    ret
  .ELSEIF eax==0			;no wire found.
    ;end of the trail.
      .IF exitring>1	    ;we're still at node being composed.
	;there is no sync wire out of the ring, so compose no path.
	xor eax,eax
	ret
      .ELSE
	;exitring=1
	;we were going around the path, following ring1 of nodes.
	;suddenly no o/p sync wire, which is an error...
	;goofee just defaulted to assuming a return to srcring, but
	;now will give an error msg...
	;edi->current node in path
	invoke MessageBox,g_hwnd, ADDR szer261,0,MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,edi
		mov eax,-1
		ret
      .ENDIF

  .ELSEIF ax==1		;esi-> sync o/p wire found.

      .IF exitring==1	;while going around the path, exitring=1, being
			;the ring that sync wires will come from.
	;need to pickup if wire has returned to start of path
	;at a different ring than path started from (srcring)...
	mov ebx,(OBJECT PTR [esi]).rplock2
	add ebx,pTERSEDATA

	.IF ebx==panode	      ;path completed.
	  xor eax,eax
	  mov al,(OBJECT PTR [esi]).nendring
	  .IF eax==srcring
	    ;fine, path completed, and back at same ring started from.
	    mov eax,srcring
	    ret
	  .ELSE
	    ;have come back to node started from, but different ring.
	    ;esi->wire
	    xor eax,eax
	    mov al,(OBJECT PTR [esi]).nendring
	    ret
	  .ENDIF
	.ENDIF
      .ELSE	;exitring>1
	;the only case when path will be completed here, is a loopback
	;wire...
	mov eax,(OBJECT PTR [esi]).rplock2
	add eax,pTERSEDATA
	.IF eax==panode
	    xor eax,eax
	    ;...no path composed. mov al,(OBJECT PTR [esi]).nendring
	    ret
	.ENDIF
      .ENDIF

    ;path still hasn't got back.
    ;find out where wire goes to...
    ;if it goes to ring>1, it will be another node, which is error.
    mov  al,(OBJECT PTR [esi]).nendring
    .IF  al>1
      invoke MessageBox,g_hwnd, ADDR szgener6zz, 0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
    .ENDIF

      ;if wire out of ring1 loops back, illegal...
      ;edi-->current node, esi-->current sync wire (out of current node).
      xor eax,eax
      mov  ax,(OBJECT PTR [edi]).number
	mov ebx,(OBJECT PTR [esi]).rplock2
	add ebx,pTERSEDATA
	xor ecx,ecx
	mov cx,(OBJECT PTR [ebx]).number
      cmp  ax,cx	;== error, loopback
      jne  noill
	lea  ebx,szlooper1
      invoke MessageBox,g_hwnd, ebx, 0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret

noill:
	mov ebx,(OBJECT PTR [esi]).rplock2
	add ebx,pTERSEDATA
	mov  edi,ebx			;edi-->next node.

;.....

    ;ok, have found next node in path.	edi->node, esi->i/p sync wire.
    ;compose it...
    ;is the node inline code?...
    mov al,(OBJECT PTR [edi]).nfunctype
    .IF al==0	    ;inline.
      mov finline,1
      ;do an error check. wire must not have any passed params...
      mov al,(OBJECT PTR [esi]).sztext1
      .IF al==0
      .ELSE
	lea ebx,szer261w
	invoke MessageBox,g_hwnd,ebx,0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
      .ENDIF
    .ELSE
      mov finline,0
    .ENDIF

;if the node is inline, go ahead and compose it inline...
;(these funcs write to file as they go)
    mov al,finline
    cmp al,0
    je	v99	    ;bypass inline composition.

;      mov eax,srcring	    ;for inserting indentation
;      mov g_nlevel,eax	    ;/

      ;141000
      ;maybe a text-file icon attached to the current
      ;inline node in path (=edi). Compose it here...
      invoke composeinclude, edi,gehandle   ;note, uses szscr1.
      ;(note, text-file icons attached to functions are composed
      ; before the function definition, by genmanycode()).

      invoke composenode, edi,pfnode,gehandle,1	;1 = inline.
      ;entered with ptr to current node, ptr to first in subdiag,
      ;handle to file, inline-flag.
;      mov g_nlevel,1	    ;back to default.
      .IF eax==-1
       ret
      .ENDIF

;then get the next wire/node in the path...
    ;edi->current node esi->i/p sync wire
    ;if the wire is 2way, we have end of path, cos reply must be back
    ;to end of path...
	  mov  ax,(OBJECT PTR [esi]).nexttype
	  .IF ax==11		;sync wire with reply
	    jmp SHORT dw1
	  .ELSEIF ax==12	;sync wire with reply&timeout
dw1:	    xor eax,eax
	    mov al,(OBJECT PTR [esi]).nbeginring
	    .IF eax==srcring	;ok
	      ret		;return immediately.
	    .ELSE
	      ;this cannot happen.
	      lea ebx,szer271
	      invoke MessageBox,g_hwnd,ebx,0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
	    .ENDIF
	  .ENDIF
    mov eax,1	    ;for ring=1.
    jmp v3


v99:
;composed inline node above, then looped back to v3: to follow the path.
;come here if the node is a function...
;edi->current node, esi->sync wire i/p to ring1

	;before go ahead an compose the function call, check if its
	;a clone. we handle call to funcname of master ok below, but
	;don't check validity of param passing
	;--for normal node, this is done earlier, in composefuncdefinition().
	mov eax,(OBJECT PTR [edi]).rpmaster
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	  mov ebx,eax
	  mov pmaster,ebx   ;save.
	  lea eax,(OBJECT PTR [ebx]).sztext5 ;passed datatype prototype.
	  mov ebx,eax
	  ;look for "void"...
wgd2:	    mov al,[ebx]
	    inc ebx
	    cmp al,0
	    je wgd1	    ;no "void" string
	    cmp al,"v"
	    jne wgd2
	    mov al,[ebx]
	    .IF al=="o"
	     mov al,[ebx+1]
	     .IF al=="i"
	       mov al,[ebx+2]
	       .IF al=="d"
		 ;found "void"...
		  mov cl,(OBJECT PTR [esi]).sztext1 ;params passed to func.
		  .IF cl==0
		  .ELSE
wf1:		    lea ebx,szer281
		    invoke MessageBox,g_hwnd,ebx,0, MB_OK+MB_ICONEXCLAMATION
		    mov	g_perrorobject,edi
		    mov eax,-1
		    ret
		  .ENDIF
	       .ENDIF
	     .ENDIF
	   .ENDIF
	   jmp wgd3
wgd1:
	  mov cl,(OBJECT PTR [esi]).sztext1 ;params passed to func.
	  .IF cl==0
	    jmp wf1
	  .ENDIF
	.ENDIF
wgd3:
	;need to write passed parameter to file...
	lea  eax,(OBJECT PTR [esi]).sztext1	;passed params
	mov  plabel,eax
	  ;if wire has reply, then it is also output wire...
	  mov endpath,0
	  mov  ax,(OBJECT PTR [esi]).nexttype
	  .IF ax==11		;sync wire with reply
	    jmp rt1
	  .ELSEIF ax==12	;sync wire with reply&timeout
rt1:	    lea  eax,(OBJECT PTR [esi]).sztext4  ;return param
	    mov  plabelout,eax
	    ;*CAREFUL* this is also end of path, so mark it...
	    mov endpath,1
	  .ELSE 		;1way sync wire.
	    ;need to call findoutwire() here because want func
	    ;return parameter...
	    mov endpath,0
	    mov  esisave,esi
	    invoke findoutwire, edi,1	;esi->o/p wire from ring1.
	    ;... aborts with eax=-1 if found >1 o/p wires.
	    .IF  eax==-1	;error, handled inside findoutwire.
	      ret
	    .ELSEIF eax==0		;  returns esi-->wire. ax=#wires
	      mov  plabelout,0
	      ;actually, this is also an error condition, as path
	      ;has suddenly stopped.
	      ;i think we should jump back to v3 and call findoutwire()
	      ;again with proper error handling...
	      mov esi,esisave
	      mov eax,1
	      jmp v3
	    .ELSE     ;eax==1 ;1 found.
	      lea eax,(OBJECT PTR [esi]).sztext1 ;return param.
	      mov plabelout,eax
	      mov  poutw,esi		;save for further down.
	    .ENDIF
	    mov  esi,esisave
	  .ENDIF

;write stuff to szscr3 here....
	  invoke lstrlen, ADDR szscr3
	  lea  ebx,szscr3
	  add  ebx,eax
	    invoke indentation, ebx,g_nlevel
	    mov ebx,eax	    ;returns eax->new end of szscr3.
	  mov  eax,plabelout	;this is variable returned from function.
	  .IF  eax==0		;no ptr
	    mov  [ebx],BYTE PTR " "
	  .ELSE
	    mov  ecx,ebx
	    mov  ebx,plabelout
	    mov  al,[ebx]
	    .IF  al==0		;no label.
	      mov  ebx,ecx
	      mov  [ebx],BYTE PTR " "
	    .ELSE
	      mov  ebx,ecx
	      mov  eax,plabelout
	      invoke lstrcpy, ebx, eax
	      invoke lstrlen, ADDR szscr3
	      lea	ebx,szscr3
	      add	ebx,eax
	      mov	[ebx],BYTE PTR "="
	    .ENDIF
	  .ENDIF
  mov  [ebx+1],BYTE PTR 0

;insert code for composing function label.
;composed above: "y="
;and we are now going to add: n00004(int x);... etc.
;edi-->current node.
;
;191000 ...no, sole criteria now is .fconfig/bit7...
;if node has dblclk action to open a diagram, we use the label of
;the node as the functionname. this is cos it is public and visible
;across all files...  edi-->node
;also for all public and external functions.
;also, same for 1st node in diagram...
	cmp  edi,pfnode
	je   k14
	mov al,(OBJECT PTR [edi]).fstatus2
	and al,0110b	    ;bits 2/1
;	cmp al,0100b	    ;public-visible node.
;	je k14
	cmp al,0110b	    ;external node.
	je k14		    ;...191000 leave this here.

	  ;191000 ...bug with clone label-as-funcname...
	  mov eax,(OBJECT PTR [edi]).rpmaster
	  .IF eax==0
	    mov	al,(OBJECT PTR [edi]).fconfig
	    test al,80h		;bit7=1 force label is funcname.
	    jnz	k14		;/ (old goofee thing)
	    ;...191000 i'm using this again.
	    jmp fm4	;"n0001()" format.
	  .ELSE
	    ;it's a clone... fix the bug...
	    and (OBJECT PTR [edi]).fconfig,07Fh ;clr bit7 on clone.
	    add eax,pTERSEDATA
	    mov ebx,eax
	    mov al,(OBJECT PTR [ebx]).fconfig
	    and al,80h	    ;extract bit7 (=1,label-is-funcname)
	    .IF al==80h     ;bit7=1
	      invoke lstrlen, ADDR szscr3
	      lea ebx,szscr3
	      add ebx,eax
	      jmp fm1  ;use funcname of master.
	    .ELSE
	      jmp fm4  ;use "n0001()" format.
	    .ENDIF
	  .ENDIF

;191000 delete, as this validation should be done in dialogbox...
;	and  al,00011000b	;extracts bits 4/3.
;	.IF  al==00011000b	;open-diagram dblclk action.
;	    ;maybe this is checked elsewhere. not allowed to dblclk
;	    ;on a clone...
;	    mov eax,(OBJECT PTR [edi]).rpmaster
;	    .IF eax==0
;	    .ELSE
;	      lea  eax,sznofer2
;	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
;	      mov  g_perrorobject,edi
;	      mov eax,-1
;	      ret
;	    .ENDIF

k14:	  invoke lstrlen, ADDR szscr3
	  lea  ebx,szscr3
	  add  ebx,eax
	  mov  al,(OBJECT PTR [edi]).sztext1	;name of node.
	  .IF  al==0		;error, no label.
t14:	      lea  eax,sznofer1
	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	      mov  g_perrorobject,edi
	      mov eax,-1
	      ret
	  .ELSE
	    ;if a clone, use func name of master...
	    mov	eax,(OBJECT PTR [edi]).rpmaster ;=0 not a clone, else-->root.
	    .IF	eax==0			;carry on as normal.
	      lea  eax,(OBJECT PTR [edi]).sztext1
uy1:	      invoke lstrcpy, ebx, eax
	      invoke lstrlen, ADDR szscr3
	      lea	ebx,szscr3
	      add	ebx,eax
	      mov	[ebx],BYTE PTR "("
	      mov	[ebx+1],BYTE PTR 0
	    .ELSE
fm1:	      ;need to use the func name of the master node...
	      push ebx
	      mov ebx,(OBJECT PTR [edi]).rpmaster
	      add ebx,pTERSEDATA
	      lea eax,(OBJECT PTR [ebx]).sztext1
	      pop ebx
	      jmp uy1
	    .ENDIF
	  .ENDIF
	jmp fm3
;	.ELSE

fm4:	  ;compose function name as "n00004("...
	  invoke lstrlen, ADDR szscr3
	  lea  ebx,szscr3
	  add  ebx,eax
	  mov  [ebx],BYTE PTR "n"
	  inc ebx
	  mov  [ebx],BYTE PTR 0
	  ;now compose the node number again...
;just about to compose "00004" again.  however, if node 00004 is a clone,
;need to substitute the # of the root node here...
;edi-->node
	  mov  eax,(OBJECT PTR [edi]).rpmaster	;=0 not a clone, else-->root.
	  .IF  eax==0			;carry on as normal.
	    mov  ax,(OBJECT PTR [edi]).number
uy3:	    invoke binto5dec, ebx	;ax to ascii, at ebx.
	    mov	[ebx+5],BYTE PTR "("
	    mov	[ebx+6],BYTE PTR 0
	  .ELSE
	    add eax,pTERSEDATA
	      ;a bug. composing "n00001(..." for clone, even when master is
	      ;public... eax->master ebx->end szscr3 edi->clone

	      ;191000 ...bug fixed, see patch above, and jump to fm4:.

;	      push ebx			;NOTE CAREFUL, push/pop here!
;	      mov ebx,eax
;	      mov cl,(OBJECT PTR [ebx]).fstatus2
;	      and cl,0110b
;	      .IF cl==100b  ;public
;		lea eax,(OBJECT PTR [ebx]).sztext1
;		pop ebx
;		dec ebx
;		mov [ebx],BYTE PTR 0 ;get rid of "n"
;		jmp uy1
;	      .ELSEIF cl==110b	;external
;		lea eax,(OBJECT PTR [ebx]).sztext1
;		pop ebx
;		dec ebx
;		mov [ebx],BYTE PTR 0
;		jmp uy1
;	      .ENDIF
;	      pop ebx

	    push ebx
	    mov ebx,eax
	    xor eax,eax
	    mov ax,(OBJECT PTR [ebx]).number
	    pop ebx
	    jmp uy3
	  .ENDIF

fm3:
;	.ENDIF

	invoke lstrlen, ADDR szscr3
	lea	ebx,szscr3
	add	ebx,eax			;ebx now at end of string.

;....
	  mov  eax,plabel	;variable passed on wire to node ring1.
	  .IF  eax==0		;no ptr
no00:	    mov  [ebx],BYTE PTR " "
	    inc ebx
	    mov  [ebx],BYTE PTR 0
	  .ELSE
	      push ebx
	      mov  ebx,plabel
	      mov  BYTE PTR al,[ebx]
	      pop  ebx
	      cmp  al,0
	      je   no00
	    mov  eax,plabel
	    invoke lstrcpy, ebx, eax
	    invoke lstrlen, ADDR szscr3
	    lea	ebx,szscr3
	    add	ebx,eax
	    mov	[ebx],BYTE PTR ","
	    inc ebx
	    mov  [ebx],BYTE PTR 0
	  .ENDIF



;compose passed shareables...
	  invoke composepassed,edi  ;ret ax=-1 error, =# resources found.
	  ;...composes passed shareables to szscr1, doesn't write it.
	  .IF eax==-1
	    ret
	  .ELSEIF eax==0	;nothing composed.
	    dec	ebx
	  .ELSE
	      invoke lstrlen, ADDR szscr1
	      .IF eax==0
	      .ELSE
		lea  ebx,szscr1
		add  ebx,eax
		dec ebx
		mov al,[ebx]
		.IF al==","
		  mov [ebx],BYTE PTR 0 ;composepassed can leave a trailing ",".
		.ENDIF
	      .ENDIF
	    invoke lstrlen, ADDR szscr3
	    lea  ebx,szscr3
	    add  ebx,eax
	    invoke lstrcpy, ebx,ADDR szscr1
	    invoke lstrlen, ADDR szscr3
	    lea  ebx,szscr3
	    add  ebx,eax
	  .ENDIF

	  mov  [ebx],BYTE PTR ")"
	  inc  ebx
	  mov  [ebx],BYTE PTR ";"
	  inc  ebx
	  mov  [ebx],BYTE PTR 0


	;check size of szscr3...
	invoke lstrlen, ADDR szscr3
	.IF eax>SZSCR3LIMIT
	  mov szscr3,0
	  invoke MessageBox,g_hwnd,ADDR szer3limit,0,MB_OK+MB_ICONEXCLAMATION
	  mov  g_perrorobject,edi
	  mov eax,-1	;exit.
	  ret
	.ENDIF

;write to file...
    invoke lstrlen,ADDR szscr3
    lea ebx,szscr3
    add ebx,eax
    mov [ebx],BYTE PTR 0Dh
    inc ebx
    mov [ebx],BYTE PTR 0Ah
    inc ebx
    mov [ebx],BYTE PTR 0
    add eax,2
    mov ebx,eax
    invoke WriteFile, gehandle,ADDR szscr3,ebx,ADDR nbytes,0
    mov szscr3,0

	;now to follow path, source ring =1...
	;but, if detected 2way sync wire earlier, endpath=1...
	.IF endpath==1
	    xor eax,eax
	    mov al,(OBJECT PTR [esi]).nbeginring
	    .IF eax==srcring	;ok
	      ret		;return immediately.
	    .ELSE
	      ;this cannot happen.
	      lea ebx,szer271
	      invoke MessageBox,g_hwnd,ebx,0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
	    .ENDIF
	.ENDIF
	mov  eax,1
	jmp  v3 	;find o/p wire of node (edi->node)

  .ENDIF

composepathfromring ENDP
;------------------------------------------------------------------------
findreentryring PROC STDCALL USES ebx edx esi edi, \
		pfnode:DWORD,gehandle:DWORD,panode:DWORD,srcring:DWORD
  LOCAL exitring:DWORD,endpath:BYTE
  LOCAL esisave:DWORD,esi2save:DWORD
  LOCAL poutw:DWORD,fisisr:WORD
  LOCAL finline:BYTE,entryring:BYTE
  LOCAL plabel:DWORD,plabelout:DWORD
;cutdown version of composepathfromring()
; -- doesn't compose anything, just finds which ring path returns to,
;also detects errors.
;pfnode-->first node in subdiag, gehandle=file handle.
;panode-->node, srcring = ring.
;return eax=ring that path returns to. =-1 if error.
;return ecx =0 if no path found.

  mov  endpath,0
  mov  edi,panode
  mov  entryring,2
  mov  edi,panode
  xor  eax,eax
  mov	al,(OBJECT PTR [edi]).nrings
  cmp	eax,srcring
  jae	ook22		;ok
  mov eax,0		;finished. did not compose anything.
  ret

ook22:
;need to compose the path out of this ring, to szscr3...

  mov  eax,srcring

v3:
;edi-->current node as we go around path (initially it is the node
;currently being composed, panode). look for a sync wire exiting
;from srcring...
  mov  exitring,eax  ;note different from srcring, which is ring on node
		    ;at start of path. exitring is from current ring as
		    ;we go around the path.(1st time =srcring, then =1)
  invoke findoutwire, edi,eax	;rets esi=ptr to wire,eax=#wires found.
  ;...NOTE an i/p 2way does not get detected as an o/p path here!
  ;...if found more than 1 o/p wire, handles error, returns eax=-1.

  .IF  eax==-1			;error, handled inside findoutwire().
    mov eax,-1
    ret
  .ELSEIF eax==0			;no wire found.
    ;end of the trail.
      .IF exitring>1	    ;we're still at node being composed.
	;there is no sync wire out of the ring, so compose no path.
	xor ecx,ecx
	mov eax,srcring
	ret
      .ELSE
	;exitring=1
;*NO* i'm going to allow this...
    mov eax,srcring   ;*assume* return to same ring.
    mov ecx,1
    ret
;	;we were going around the path, following ring1 of nodes.
;	;suddenly no o/p sync wire, which is an error...
;	;goofee just defaulted to assuming a return to srcring, but
;	;now will give an error msg...
;	;edi->current node in path
;	invoke MessageBox,g_hwnd, ADDR szer261,0,MB_OK+MB_ICONEXCLAMATION
;		mov  g_perrorobject,edi
;		mov eax,-1
;		ret
      .ENDIF

  .ELSEIF ax==1		;esi-> sync o/p wire found.

      .IF exitring==1	;while going around the path, exitring=1, being
			;the ring that sync wires will come from.
	;need to pickup if wire has returned to start of path
	;at a different ring than path started from (srcring)...
	mov ebx,(OBJECT PTR [esi]).rplock2
	add ebx,pTERSEDATA

	.IF ebx==panode	      ;path completed.
	  xor eax,eax
	  mov al,(OBJECT PTR [esi]).nendring
	  .IF eax==srcring
	    ;fine, path completed, and back at same ring started from.
	    mov eax,srcring
	    mov ecx,1
	    ret
	  .ELSE
	    ;have come back to node started from, but different ring.
	    ;esi->wire
	    xor eax,eax
	    mov al,(OBJECT PTR [esi]).nendring
	    mov ecx,1
	    ret
	  .ENDIF
	.ENDIF
      .ELSE	;exitring>1
	;the only case when path will be completed here, is a loopback
	;wire...
	mov eax,(OBJECT PTR [esi]).rplock2
	add eax,pTERSEDATA
	.IF eax==panode
	    xor eax,eax
	    mov al,(OBJECT PTR [esi]).nendring
	    xor ecx,ecx     ;no path.
	    ret
	.ENDIF
      .ENDIF

    ;path still hasn't got back.
    ;find out where wire goes to...
    ;if it goes to ring>1, it will be another node, which is error.
    mov  al,(OBJECT PTR [esi]).nendring
    .IF  al>1
      invoke MessageBox,g_hwnd, ADDR szgener6zz, 0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
    .ENDIF

      ;if wire out of ring1 loops back, illegal...
      ;edi-->current node, esi-->current sync wire (out of current node).
      xor eax,eax
      mov  ax,(OBJECT PTR [edi]).number
	mov ebx,(OBJECT PTR [esi]).rplock2
	add ebx,pTERSEDATA
	xor ecx,ecx
	mov cx,(OBJECT PTR [ebx]).number
      cmp  ax,cx	;== error, loopback
      jne  noill
	lea  ebx,szlooper1
      invoke MessageBox,g_hwnd, ebx, 0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret

noill:
	mov ebx,(OBJECT PTR [esi]).rplock2
	add ebx,pTERSEDATA
	mov  edi,ebx			;edi-->next node.

;.....

    ;ok, have found next node in path.	edi->node, esi->i/p sync wire.
    ;compose it...
    ;is the node inline code?...
    mov al,(OBJECT PTR [edi]).nfunctype
    .IF al==0	    ;inline.
      mov finline,1
      ;do an error check. wire must not have any passed params...
      mov al,(OBJECT PTR [esi]).sztext1
      .IF al==0
      .ELSE
	lea ebx,szer261w
	invoke MessageBox,g_hwnd,ebx,0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
      .ENDIF
    .ELSE
      mov finline,0
    .ENDIF

;if the node is inline, go ahead and compose it inline...
    mov al,finline
    cmp al,0
    je	v99	    ;bypass inline composition.

     ;COMPOSE CODE REMOVED

;then get the next wire/node in the path...
    ;edi->current node esi->i/p sync wire
    ;if the wire is 2way, we have end of path, cos reply must be back
    ;to end of path...
	  mov  ax,(OBJECT PTR [esi]).nexttype
	  .IF ax==11		;sync wire with reply
	    jmp SHORT dw1
	  .ELSEIF ax==12	;sync wire with reply&timeout
dw1:	    xor eax,eax
	    mov al,(OBJECT PTR [esi]).nbeginring
	    .IF eax==srcring	;ok
	      mov ecx,1
	      ret		;return immediately.
	    .ELSE
	      ;this cannot happen.
	      lea ebx,szer271
	      invoke MessageBox,g_hwnd,ebx,0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
	    .ENDIF
	  .ENDIF
    mov eax,1	    ;for ring=1.
    jmp v3


v99:
;composed inline node above, then looped back to v3: to follow the path.
;come here if the node is a function...
;edi->current node, esi->sync wire i/p to ring1

	;need to write passed parameter to file...
	lea  eax,(OBJECT PTR [esi]).sztext1	;passed params
	mov  plabel,eax
	  ;if wire has reply, then it is also output wire...
	  mov endpath,0
	  mov  ax,(OBJECT PTR [esi]).nexttype
	  .IF ax==11		;sync wire with reply
	    jmp rt1
	  .ELSEIF ax==12	;sync wire with reply&timeout
rt1:	    lea  eax,(OBJECT PTR [esi]).sztext4  ;return param
	    mov  plabelout,eax
	    ;*CAREFUL* this is also end of path, so mark it...
	    mov endpath,1
	  .ELSE 		;1way sync wire.
	    ;need to call findoutwire() here because want func
	    ;return parameter...
	    mov endpath,0
	    mov  esisave,esi
	    invoke findoutwire, edi,1	;esi->o/p wire from ring1.
	    ;... aborts with eax=-1 if found >1 o/p wires.
	    .IF  eax==-1	;error, handled inside findoutwire.
	      ret
	    .ELSEIF eax==0		;  returns esi-->wire. ax=#wires
	      mov  plabelout,0
	      ;actually, this is also an error condition, as path
	      ;has suddenly stopped.
	      ;i think we should jump back to v3 and call findoutwire()
	      ;again with proper error handling...
	      mov esi,esisave
	      mov eax,1
	      jmp v3
	    .ELSE     ;eax==1 ;1 found.
	      lea eax,(OBJECT PTR [esi]).sztext1 ;return param.
	      mov plabelout,eax
	      mov  poutw,esi		;save for further down.
	    .ENDIF
	    mov  esi,esisave
	  .ENDIF


	;COMPOSE CODE REMOVED

	;now to follow path, source ring =1...
	;but, if detected 2way sync wire earlier, endpath=1...
	.IF endpath==1
	    xor eax,eax
	    mov al,(OBJECT PTR [esi]).nbeginring
	    .IF eax==srcring	;ok
	      mov ecx,1
	      ret		;return immediately.
	    .ELSE
	      ;this cannot happen.
	      lea ebx,szer271
	      invoke MessageBox,g_hwnd,ebx,0, MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
	    .ENDIF
	.ENDIF
	mov  eax,1
	jmp  v3 	;find o/p wire of node (edi->node)

  .ENDIF

findreentryring ENDP
;------------------------------------------------------------------------
;------------------------------------------------------------------------
;------------------------------------------------------------------------
.DATA
xshare DWORD 0
yshare DWORD 0

.CODE
findchild PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD,ntypez:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
; "findchild"
;find a child of pobj (child.rplock1 -> pobj) of child.nexttype=ntypez.
;return eax=addr of child, else eax=0.
;note, i would like to come into this multiple time, to find more than
;one child...so, pprev is a placemarker, and search starts from
;there... if pprev=0 search starts from beginning of database.
;(pprev is a global variable)
;also, if ntypez=0, finds any child.

	mov edi,pTERSEDATA
	.IF pprev==0
	  lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	  xor ecx,ecx
	  mov cx,(TERSEDATA PTR [edi]).numobjects
	.ELSE
	  mov esi,pprev
	  mov ecx,ecxprev
	.ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and al,01
	  .IF al==01	;bit0=1, valid object.
	      .IF esi==pobj  ;don't test itself
	      .ELSE
		.IF esi==pprev ;don't retest last one.
		.ELSE
		  mov al,(OBJECT PTR [esi]).fconfig
		  and al,01
		  .IF al==0	;non-wire type.
		    mov eax,(OBJECT PTR [esi]).rplock1
		    .IF eax==0	    ;not a child
		    .ELSE
		      add eax,pTERSEDATA ;make absolute.
		      .IF eax==pobj	;child of pobj
			;yes, child found...
			  ;exclude shareable, cos it has to be explicitly
			  ;wired by a dataflow wire, which is found in the
			  ;code further down...
			  mov ax,(OBJECT PTR [esi]).nexttype
			  .IF ax==4
			    mov al,(OBJECT PTR [esi]).fconfig
			    and al,01100000b
			    .IF al==0	    ;bits6/5=00 shareable (perm/temp)
			      jmp kk1
			    .ENDIF
			  .ENDIF
			xor eax,eax
			mov ax,(OBJECT PTR [esi]).nexttype
			.IF eax==ntypez
			  ;yes, correct type also
			  mov eax,esi
			  mov pprev,esi ;placemarker
			  mov ecxprev,ecx ;/
			  ret
			.ELSEIF ntypez==0
			  ;then not worried about type, found...
			  mov eax,esi
			  mov pprev,esi
			  mov ecxprev,ecx
			  ret
			.ENDIF
		      .ENDIF
		    .ENDIF
		  .ELSE
		    ;it's a wire type.
		    ;but, a child can also be connected via a
		    ;data/hardware wire...
		    mov ax,(OBJECT PTR [esi]).nexttype
		    .IF ax==15	    ;general data wire.
jj1:		      mov eax,(OBJECT PTR [esi]).rplock2   ;destendof wire
		      add eax,pTERSEDATA
		      .IF eax==pobj	;wire is on pobj
			 ;save coords wire on node (global)...
			 mov ebx,eax
			 mov eax,(OBJECT PTR [ebx]).wwidth
			 mov xshare,eax
			 mov eax,(OBJECT PTR [ebx]).height
			 mov yshare,eax
			mov ebx,(OBJECT PTR [esi]).rplock1 ;startend of wire.
			add ebx,pTERSEDATA
			xor eax,eax
			mov ax,(OBJECT PTR [ebx]).nexttype
			.IF eax==ntypez
			  ;yes! found a data/hardware element
			  ;connected to pobj via a dataflow wire.
			  mov eax,ebx
			  mov pprev,esi ;placemarker.
			  mov ecxprev,ecx
			  ret
			.ELSEIF ntypez==0
			  ;then not worried about type, found...
			  mov eax,ebx
			  mov pprev,esi
			  mov ecxprev,ecx
			  ret
			.ENDIF
		      .ENDIF
		    .ELSEIF ax==17  ;interrupt data wire.
		      jmp jj1
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	  .ENDIF
kk1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
	loop uu2 ;nextobj
uu1:	jmp SHORT uu3
uu2:	jmp nextobj
uu3:

;failed to find a child...
    xor eax,eax
    ret
findchild ENDP
;------------------------------------------------------------------------
.DATA
pprevwire DWORD 0
ecxprevwire DWORD 0

.CODE
findsignalout PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD,nringx:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
; "findsignalout"
;find an async-signal wire that starts at pobj
;(child.rplock1 -> pobj), on nringx.
;return eax=addr of wire, else eax=0.
;note, i would like to come into this multiple time, to find more than
;one wire...so, pprevwire is a placemarker, and search starts from
;there... if pprevwire=0 search starts from beginning of database.
;(pprevwire is a global variable). ecxprevwire also used.

	mov edi,pTERSEDATA
	.IF pprevwire==0
	  lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	  xor ecx,ecx
	  mov cx,(TERSEDATA PTR [edi]).numobjects
	.ELSE
	  mov esi,pprevwire
	  mov ecx,ecxprevwire
	.ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and al,01
	  .IF al==01	;bit0=1, valid object.
	      .IF esi==pobj  ;don't test itself
	      .ELSE
		.IF esi==pprevwire ;don't retest last one.
		.ELSE
		  mov al,(OBJECT PTR [esi]).fconfig
		  and al,01
		  .IF al==1	;wire type.
		    mov eax,(OBJECT PTR [esi]).rplock1
		    .IF eax==0	    ;not a child
		    .ELSE
		      add eax,pTERSEDATA ;make absolute.
		      .IF eax==pobj	;child of pobj
			;yes, child found...
			xor eax,eax
			mov al,(OBJECT PTR [esi]).nbeginring
			.IF eax==nringx
			  mov ax,(OBJECT PTR [esi]).nexttype
			  .IF ax==13	;async 1way (o/p)
we1:			    mov eax,esi
			    mov pprevwire,esi ;placemarker
			    mov ecxprevwire,ecx ;/
			    ret
			  .ELSEIF ax==14 ;async 2-way (o/p)
			    jmp we1
			  .ENDIF
			.ENDIF
		      .ENDIF
		    .ENDIF
		    mov eax,(OBJECT PTR [esi]).rplock2
		    .IF eax==0	    ;not a child
		    .ELSE
		      add eax,pTERSEDATA ;make absolute.
		      .IF eax==pobj	;child of pobj
			;yes, child found...
			xor eax,eax
			mov al,(OBJECT PTR [esi]).nendring
			.IF eax==nringx
			  mov ax,(OBJECT PTR [esi]).nexttype
			  .IF ax==14	;async 2way (i/p)
			    mov eax,esi
			    mov pprevwire,esi ;placemarker
			    mov ecxprevwire,ecx ;/
			    ret
			  .ENDIF
			.ENDIF
		      .ENDIF
		    .ENDIF

		  .ENDIF
		.ENDIF
	      .ENDIF
	  .ENDIF
kk1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
	loop uu2 ;nextobj
uu1:	jmp SHORT uu3
uu2:	jmp nextobj
uu3:

;failed to find a child...
    xor eax,eax
    ret
findsignalout ENDP
;------------------------------------------------------------------------
binto5dec PROC STDCALL USES ebx ecx edx esi edi, pszdest:DWORD
;enter with value in eax, convert to 5-digit decimal ascii, retaining
;leading zeros...
  mov  edi,pszdest
	xor	edx,edx
	mov	ecx,10
	div	cx
	add	dl,30h	;ascii
	mov	BYTE PTR [edi+4],dl
	xor	edx,edx
	div	cx
	add	dl,30h
	mov	BYTE PTR [edi+3],dl
	xor	edx,edx
	div	cx
	add	dl,30h
	mov	BYTE PTR [edi+2],dl
	xor	edx,edx
	div	cx
	add	dl,30h
	mov	BYTE PTR [edi+1],dl
	xor	edx,edx
	div	cx
	add	dl,30h
	mov	BYTE PTR [edi],dl

  ret
binto5dec ENDP
;--------------------------------------------------------------------------
.DATA
szer271g    BYTE "GOOSEE has found two or more execution-flow wire "
	    BYTE "output paths from the same ring of a node. This is illegal "
	    BYTE "(this is a failsafe error message and indicates GOOSEE failed in earlier visual-syntax "
	    BYTE "checking).",0Dh,0Ah
	    BYTE "GOOSEE has highlighted the LAST offending wire (any other "
	    BYTE "execution-flow wire/s that GOOSEE found starting on the same ring "
	    BYTE "will not be highlighted).",0
szgener10   BYTE "GOOSEE has found a 2-way execution-flow wire starting "
	    BYTE "from ring-1, which is illegal. "
	    BYTE "(this is a failsafe error message and indicates GOOSEE failed in earlier visual-syntax "
	    BYTE "checking).",0Dh,0Ah
	    BYTE "GOOSEE has highlighted the offending wire.",0
.CODE
findoutwire PROC STDCALL USES ebx ecx edx edi, pxnode:DWORD,srcring:DWORD
	LOCAL count:DWORD,pwire:DWORD
	LOCAL esizeobject:DWORD
; "findoutwire"
;pxnode is current node, find single output sync wire from this node/ring.
;if more than one, abort with error.
;returns eax=# sync o/p wires found (0 or 1).
;eax=-1, error, handled inside this procedure.
;returns esi pointing to found wire.
;ignore inter-thread o/p wires (.fconfig.5 set).
;NOTE finds wire with start-end on pxnode --an i/p sync 2way wire is
;NOT registered here as an o/p wire.

	mov  count,0		;cnt how many output wires found.
	mov  pwire,0		;points to found wire.
	mov  edi,pxnode
	mov ebx,pTERSEDATA
	lea esi,(TERSEDATA PTR [ebx]).OBJECTS
	xor eax,eax
	mov ax,(TERSEDATA PTR [ebx]).nsizeobject
	mov esizeobject,eax
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [ebx]).numobjects
zz:	mov ebx,(OBJECT PTR [esi]).rplock1
	  cmp ebx,0
	  je yy
	  add ebx,pTERSEDATA
	  cmp ebx,pxnode
	  je   xx			;wire found.
yy:	add  esi,esizeobject
	loop zz
	jmp  vv 			;fail.

;wire output found, but is it a valid object?...
xx:	test (OBJECT PTR [esi]).fstatus,01
	jz   yy
;wire is found, but is it a sync wire?...
	mov  ax,(OBJECT PTR [esi]).nexttype
	.IF ax==10		;sync one-way
	  jmp  ww
	.ELSEIF ax==11		;sync with reply
	  jmp  xww
	.ELSEIF ax==12		;sync with reply and timeout
xww:
	  ;this can never be allowed to come from ring-1....
	  cmp (OBJECT PTR [esi]).nbeginring,1
	  jne  ww
	  invoke MessageBox,g_hwnd,ADDR szgener10,0,MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov  eax,-1
		ret
	.ELSE
	  jmp  yy
	.ENDIF

;yes, we have found an output wire!... pointed to by esi...
ww:
;well, not yet. it must go from the current ring...
	xor eax,eax
	mov  al,(OBJECT PTR [esi]).nbeginring
	cmp  eax,srcring
	jne  yy 	;fail, keep looking
;ignore inter-thread wire...
	test (OBJECT PTR [esi]).fconfig,00100000b ;bit5.
	jnz	yy	;keep looking.


;finally, found suitable output wire...
	  mov pwire,esi	;mark found wire.

	inc  count
	jmp  yy	;look for any more output wires.

vv:	.IF count>1	;error.
	  invoke MessageBox,g_hwnd,ADDR szer271g,0,MB_OK+MB_ICONEXCLAMATION
	  mov esi,pwire
	  mov  g_perrorobject,esi
	  mov eax,-1
	  ret
	.ENDIF
	mov  eax,count	;0 or 1 = flag ok.
	mov  esi,pwire	;found wire.
	ret
findoutwire ENDP
;--------------------------------------------------------------------------
.DATA
szerc9 BYTE "A ring has more than one condition-element attached. "
       BYTE "This is not allowed. GOOSEE will go ahead and generate "
       BYTE "the code, but you will keep getting this message until "
       BYTE "you delete all but one of them.",0
.CODE
findcondition PROC STDCALL USES ebx ecx edx edi, pxnode:DWORD,srcring:DWORD
	LOCAL esizeobject:DWORD
	LOCAL pfound:DWORD
	LOCAL ncnt:DWORD
; "findcondition"
;pxnode is current node, find single condition on srcring.
;returns eax=0 not found, or eax->condition.

	mov pfound,0
	mov ncnt,0
	mov  edi,pxnode
	mov ebx,pTERSEDATA
	lea esi,(TERSEDATA PTR [ebx]).OBJECTS
	xor eax,eax
	mov ax,(TERSEDATA PTR [ebx]).nsizeobject
	mov esizeobject,eax
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [ebx]).numobjects
zz:	mov ebx,(OBJECT PTR [esi]).rplock1
	cmp ebx,0
	je yy
	add ebx,pTERSEDATA
	cmp ebx,edi
	je   xx 			;child found.
yy:	add  esi,esizeobject
	loop zz
	jmp  vv 			;end of database.

;child found, but is it a valid object?...
xx:	test (OBJECT PTR [esi]).fstatus,01
	jz   yy
;wire is found, but is it a condition?...
	mov  ax,(OBJECT PTR [esi]).nexttype
	cmp ax,32
	jne yy

;yes, we have found a condition!... pointed to by esi...
ww:
;well, not yet. it must be at the current ring...
	xor eax,eax
	mov  al,(OBJECT PTR [esi]).nbeginring
	cmp  eax,srcring
	jne  yy 	;fail, keep looking
	  mov pfound,esi
	  inc ncnt
	  jmp yy	;look for any more.
	  ;mov eax,esi	;found condition.
	  ;ret
vv:	.IF ncnt==0
		xor eax,eax	;fail
	.ELSEIF ncnt==1
	  mov eax,pfound	;ok.
	.ELSE			;more than 1 cond.
	  lea eax,szerc9
	  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	  mov eax,pfound
	  mov g_perrorobject,eax
	.ENDIF
	ret
findcondition ENDP
;--------------------------------------------------------------------------
composeprimitivevar PROC STDCALL USES ebx ecx edx esi edi, \
 pdatavar:DWORD,nptr:DWORD,pname:DWORD,fsuppress:DWORD,nlevel:DWORD,finitval:DWORD
    LOCAL dummy:BYTE
;called from composeglobaldata(), composeprototypes(), composefuncdefinition()
;composepointer1(), and composenodedata().
    mov esi,pdatavar	;->data-element has datatype spec. (child)
    mov edi,pname	;->data-element has name of variable.

      ;firstly, compose child...
	invoke lstrlen,ADDR szscr1
	lea ebx,szscr1
	add ebx,eax
	       xor eax,eax
	       mov al,(OBJECT PTR [esi]).ndatatype
	       mov ecx,48
	       mul ecx
	       push ebx
	       mov ebx,pTERSEDATA
	       lea ecx,(TERSEDATA PTR [ebx]).sztype1
	       pop ebx
	       add eax,ecx		;now have addr of string in eax.
	       invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [esi]).nmemtype1
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [esi]).nmemtype1
	      dec al		;cos we ignore .nmemtype1=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF

;now compose the pointer...
;if nptr=0, won't get any "*"s composed here...
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	    .IF nptr==0
	    .ELSE
	      .WHILE nptr>0
		mov [ebx],BYTE PTR "*"
		inc ebx
		dec nptr
	      .ENDW
	      mov [ebx],BYTE PTR " "
	      inc ebx
	    .ENDIF
	    mov [ebx],BYTE PTR 0

;only compose if esi different from edi...
	    .IF esi==edi
	    .ELSE
	      mov al,(OBJECT PTR [edi]).nmemtype2
	      .IF al==0	      ;nothing selected.
	      .ELSE
		xor eax,eax
		mov al,(OBJECT PTR [edi]).nmemtype2
		dec al		;cos we ignore .nmemtype2=0
		mov ecx,48
		mul ecx
		push ebx
		mov ebx,pTERSEDATA
		lea ecx,(TERSEDATA PTR [ebx]).szpre1
		pop ebx
		add eax,ecx		;now have addr of string in eax.
		invoke lstrcpy, ebx,eax
	      .ENDIF
	    .ENDIF

;now compose name...if fsuppress!=0...
	    .IF fsuppress==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR "*"
		inc ebx
		mov [ebx],BYTE PTR 0
		;compose mangled label, ptr_name...
	      .IF nlevel==0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,szptr_	  ;mangle prefix
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		.ENDIF
	      .ENDIF
	    .ELSE
	      .IF nlevel==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR 0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		  ;if this is shareable, mangle it with its own element#...
		  mov ax,(OBJECT PTR [edi]).nexttype
		  .IF ax==4
		    mov al,(OBJECT PTR [edi]).fconfig
		    and al,01100000b
		    .IF al==0
		      invoke lstrlen, ADDR szscr1
		      lea ebx,szscr1
		      add ebx,eax
		      xor eax,eax
		      mov ax,(OBJECT PTR [edi]).number
		      invoke binto5dec, ebx ;appends element#
		      add ebx,5
		      mov [ebx],BYTE PTR 0
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	    .ENDIF

;now compose initialisation value...(of child data element)
    .IF finitval==1
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	    mov al,(OBJECT PTR [esi]).sztext2
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      mov [ebx],BYTE PTR "="
	      inc ebx
	      lea eax,(OBJECT PTR [esi]).sztext2
	      invoke lstrcpy, ebx,eax
	    .ENDIF
    .ENDIF

      ;done...
      xor eax,eax
      ret
zzzz: mov eax,-1
      ret
composeprimitivevar ENDP
;------------------------------------------------------------------------
.DATA
szer3200    BYTE "You have a data-element attached to an array-data-"
	    BYTE "element, which specifies the datatype of the array's "
	    BYTE "elements. However, the datatype field inside the array "
	    BYTE "dialog box is also specifying a datatype. This is a "
	    BYTE "conflict. Please go into the array dialog box and select "
	    BYTE "the first entry (blank) in the datatype listbox.",0Dh,0Ah
	    BYTE "GOOSEE has aborted code generation and has highlighted "
	    BYTE "the offending array element.",0
szer3200b   BYTE "You have not specified a datatype for the elements of an "
	    BYTE "array-element. You have a choice. You can set the "
	    BYTE "datatype field in the array dialog box, or you "
	    BYTE "can attach a child-data-element.",0Dh,0Ah
	    BYTE "GOOSEE has aborted code generation and has highlighted "
	    BYTE "the offending array element.",0
szer4200    BYTE "You have an array of structures, but you haven't "
	    BYTE "selected a structure-type in the structure dialog box.",0Dh,0Ah
	    BYTE "Note that the structure-type field is the only one that you "
	    BYTE "will enter anything into in the structure dialog box. Any "
	    BYTE "array initialization must be entered into the array dialog box.",0Dh,0Ah
	    BYTE "GOOSEE has aborted code generation and has highlighted "
	    BYTE "the offending structure element.",0
szer4200b   BYTE "You have an array of structures, but you have attached "
	    BYTE "an element to the structure-element. The structure-element "
	    BYTE "specifies the datatype of the elements of the array, and a "
	    BYTE "selection must be made in the listbox inside the structure "
	    BYTE "dialog box. That is, it must be a predefined structure, and it "
	    BYTE "is not correct to attach anything to the structure-element.",0Dh,0Ah
	    BYTE "GOOSEE has aborted code generation and has highlighted "
	    BYTE "the offending structure element.",0



.CODE
composeprimitivearray PROC STDCALL USES ebx ecx edx esi edi, \
 pdatavar:DWORD,nptr:DWORD,pname:DWORD,fsuppress:DWORD,nlevel:DWORD,finitval:DWORD
    LOCAL nptr1:DWORD
    LOCAL pactualdatavar:DWORD
    LOCAL fstruc:BYTE
    LOCAL phighest:DWORD
; "composeprimitivearray"
;called from composeglobaldata(), composeprototypes(), composefuncdefinition()
;composepointer1(), and composenodedata().
;if nptr=0 pdatavar will be the element with the datatype, pname will be
;the element with the array memtype/name. these two will be different
;elements only if a child datatype-element is attached to an array-element.
;if nptr>0 then pname is a pointer-element, pdatavar is the array.
;we are now composing array with structure-child in this func.
;we are now composing multidimensional arrays.
    mov esi,pdatavar	;->data-element has datatype spec. (child)
    mov edi,pname	;->data-element has name of variable.
    mov ecx,nptr	;# of *'s to insert.
    mov nptr1,ecx

    mov pactualdatavar,esi
    .IF nptr==0	      ;a problem if nptr>0, pdatavar->array,
		      ;pname->pointer. but what if array has an
    .ELSE	      ;attached datatype element? it is passed into
      mov cl,(OBJECT PTR [esi]).ndatatype
      .IF cl==0
	.IF eax==0
	  lea eax,szer3200b
	  jmp zs1
	.ENDIF
	mov pactualdatavar,eax	;here in eax.
      .ENDIF
    .ENDIF

;error check on parent...
	 .IF nptr==0
	   mov esi,pname    ;this is array-element.
	 .ELSE
	   mov esi,pdatavar ;this is array-element.
	 .ENDIF
	   mov al,(OBJECT PTR [esi]).nchildresources
	   .IF al==0
	     mov al,(OBJECT PTR [esi]).ndatatype
	     .IF al==0
	       ;must specify a datatype...
	       lea eax,szer3200b
	       jmp SHORT zs1
	     .ENDIF
	   .ELSE
	     mov al,(OBJECT PTR [esi]).ndatatype
	     .IF al==0
	     .ELSE
	       ;must not have child resources if .ndatatype >0...
	       lea eax,szer3200
zs1:	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
	     .ENDIF
	   .ENDIF
    mov esi,pdatavar	;->data-element has datatype spec. (child)
    mov edi,pname	;->data-element has name of variable.


;firstly, compose datatype...
	mov esi,pactualdatavar
	mov fstruc,0
;if datatype is a structure, put "struct" first...
	  mov al,(OBJECT PTR [esi]).fstatus2
	  and al,11100000b
	  .IF al==01000000b   ;structure.
	    invoke lstrlen,ADDR szscr1
	    lea ebx,szscr1
	    add ebx,eax
	    lea eax,szstruct
	    invoke lstrcpy, ebx,eax
	    mov fstruc,1	    ;flag
	      ;do an error check...
	      ;if structure is a child, must not have anything attached
	      ;to it, and must have its internal .ndatatype set...
	      mov eax,(OBJECT PTR [esi]).rplock1
	      .IF eax==0
	      .ELSE
		mov (OBJECT PTR [esi]).nmemtype1,0  ;precaution.
		mov (OBJECT PTR [esi]).sztext5,0    ; / initialisation field.
		mov al,(OBJECT PTR [esi]).ndatatype
		.IF al==0
		  lea eax,szer4200
df1:		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,esi
		  mov eax,-1
		  ret
		.ENDIF
		mov al,(OBJECT PTR [esi]).nchildresources
		.IF al==0
		.ELSE
		  lea eax,szer4200b
		  jmp df1
		.ENDIF
	      .ENDIF
	  .ENDIF
	invoke lstrlen,ADDR szscr1
	lea ebx,szscr1
	add ebx,eax
	       xor eax,eax
	       mov al,(OBJECT PTR [esi]).ndatatype
	     .IF al==0
	       ;screened out before calling this func.
	     .ELSE
		 ;the datatype can be either inside the array, or in a child
		 ;data element. if a primitive child data element, don't
		 ;want to decr...
		 mov cl,(OBJECT PTR [esi]).fstatus2
		 and cl,11100000b
		 .IF cl==0	    ;primitive variable.
		 .ELSEIF cl==10000000b ;generic data.
		 .ELSE
		   dec al	    ;cos ignore 0.(0 means attached datatype)
		 .ENDIF
	       mov ecx,48
	       mul ecx
	       push ebx
	       mov ebx,pTERSEDATA
	       .IF fstruc==0
		 lea ecx,(TERSEDATA PTR [ebx]).sztype1
	       .ELSE
		 lea ecx,(TERSEDATA PTR [ebx]).szptrtype1
	       .ENDIF
	       pop ebx
	       add eax,ecx		;now have addr of string in eax.
	       invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	     .ENDIF
	    xor eax,eax
	    mov cl,(OBJECT PTR [esi]).fstatus2
	    and cl,11100000b
	    .IF cl==0	    ;simple primitive data.
	      mov al,(OBJECT PTR [esi]).nmemtype1
	    .ELSE
	      mov al,(OBJECT PTR [esi]).nmemtype2
	    .ENDIF

	jmp hack1
	;...a 1-dim array with memtype-field set, composed as:
	; "U8 xdata xdata arrayname[0];"
	;this hack gets rid of the extra "xdata".

	    .IF al==0	      ;nothing selected.
	    .ELSE
	      dec al		;cos we ignore .nmemtype1/2=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF
hack1:
;    mov esi,pdatavar	;->data-element has datatype spec. (child)

;now compose the pointer/name...
	  ;edi->pointer/name.
	  mov edi,pname	;->data-element has name of variable.
	    ;multidimensional arrays are a problem....
	    mov al,(OBJECT PTR [edi]).fstatus2
	    and al,11100000b
	    .IF al==01100000b	;array
	      ;locate highest array-chain...
ks1:	      mov ebx,(OBJECT PTR [edi]).rplock1
	      .IF ebx==0    ;error
	      .ELSE
		add ebx,pTERSEDATA
		mov al,(OBJECT PTR [ebx]).fstatus2
		and al,11100000b
		.IF al==01100000b	;array.
		  mov edi,ebx
		  jmp ks1
		.ENDIF
	      .ENDIF
	    .ENDIF
	    ;if entered above edi->array, drop out here edi->highest array.
	    mov phighest,edi
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
		.IF nptr1==0
		.ELSE
		  .WHILE nptr1>0
		    mov [ebx],BYTE PTR "*"
		    inc ebx
		    dec nptr1
		  .ENDW
		  mov [ebx],BYTE PTR " "
		  inc ebx
		.ENDIF
	    mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [edi]).nmemtype2
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [edi]).nmemtype2
	      dec al		;cos we ignore .nmemtype2=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF
	  ;now compose name...if fsuppress!=0...
	    .IF fsuppress==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR "*"
		inc ebx
		mov [ebx],BYTE PTR 0
		;compose mangled label, ptr_name...
	      .IF nlevel==0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,szptr_	  ;mangle prefix
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		.ENDIF
	      .ENDIF
	    .ELSE
	      .IF nlevel==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR 0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		  ;if this is shareable, mangle it with its own element#...
		  mov ax,(OBJECT PTR [edi]).nexttype
		  .IF ax==4
		    mov al,(OBJECT PTR [edi]).fconfig
		    and al,01100000b
		    .IF al==0
		      invoke lstrlen, ADDR szscr1
		      lea ebx,szscr1
		      add ebx,eax
		      xor eax,eax
		      mov ax,(OBJECT PTR [edi]).number
		      invoke binto5dec, ebx ;appends element#
		      add ebx,5
		      mov [ebx],BYTE PTR 0
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	    .ENDIF

;now compose "[size]={initialisation}"...
;if nptr=0 use fields of pname, if nptr>0 use fields of pdatavar...
      mov esi,pdatavar
      .IF finitval==1
	.IF nptr==0
	  mov esi,pname
	.ENDIF
;      ;multidimensional arrays are a problem. check that we have highest one...
;      mov al,(OBJECT PTR [esi]).fstatus2
;      and al,11100000b
;      .IF al==01100000b ;array.
;	mov esi,phighest	;found above
;      .ENDIF
ku1:	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR "["
	      inc ebx
	      mov [ebx],BYTE PTR 0
		cmp esi,phighest	   ;equal if not multidim. array.
		jne de1
		mov al,(OBJECT PTR [esi]).sztext5   ;initialisation string.
		.IF al==34	; " double-quote char.
		  mov [ebx],BYTE PTR "]"
		  inc ebx
		  mov [ebx],BYTE PTR 0
		.ELSE
de1:		  ;must have size...
		  ;stored in .ntimeout field... *NO* now its a
		  ;ascii string in .sztext2...
		  ;mov eax,(OBJECT PTR [esi]).ntimeout
		  mov al,(OBJECT PTR [esi]).sztext2
		  .IF al==0
		    mov [ebx],BYTE PTR "0"
		    inc ebx
		    mov [ebx],BYTE PTR 0
		  .ELSE
		    mov ecx,ebx
		    push ecx
		    ;invoke bin2dec	    ;eax->szasciitbl
		    ;lea ebx,szasciitbl
		    lea ebx,(OBJECT PTR [esi]).sztext2
		    mov al,[ebx]
		    .WHILE al==" "
		      inc ebx
		      mov al,[ebx]
		    .ENDW
		    pop ecx
		    invoke lstrcpy, ecx,ebx
		  .ENDIF
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  mov [ebx],BYTE PTR "]"
		  inc ebx
		  mov [ebx],BYTE PTR 0
		    ;if multidimensional...
		    mov ebx,(OBJECT PTR [esi]).rplock1
		    add ebx,pTERSEDATA
		    mov al,(OBJECT PTR [ebx]).fstatus2
		    and al,11100000b
		    .IF al==01100000b	;array
		      ;parent is also an array...
		      mov esi,ebx
		      jmp ku1	    ;compose next "[size]".
		    .ENDIF
		.ENDIF
	    ;now compose initialisation value...
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	    mov al,(OBJECT PTR [esi]).sztext5
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      mov [ebx],BYTE PTR "="
	      inc ebx
	      mov [ebx],BYTE PTR "{"
	      inc ebx
	      lea eax,(OBJECT PTR [esi]).sztext5
	      invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR "}"
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF
      .ENDIF
      mov esi,pdatavar
      mov edi,pname

    xor eax,eax
    ret
zzzz: mov eax,-1
      ret
composeprimitivearray ENDP
;------------------------------------------------------------------------
.DATA
szer5200    BYTE "Pointer must have an attached datatype element.",0
szer6200    BYTE "You have an array of pointers to functions. It is not "
	    BYTE "correct to have child-data-elements attached to the "
	    BYTE "node. The node is behaving as a datatype-specifier for "
	    BYTe "the pointer to which it is attached, and the node must "
	    BYTE "be the end of the chain.",0

.CODE
composearrayofpointers PROC STDCALL USES ebx ecx edx esi edi, \
	   pptr:DWORD,pname:DWORD,fsuppress:DWORD,nlevel:DWORD
    LOCAL nptr1:DWORD
    LOCAL pactualdatavar:DWORD
    LOCAL fstruc:BYTE
    LOCAL phighest:DWORD
    LOCAL pdatavar:DWORD
    LOCAL pprevsave:DWORD,ecxprevsave:DWORD
;called from composeglobaldata(), composeprototypes(), composefuncdefinition()
;composepointer1(), and composenodedata().
;when fsuppress=1, nlevel=0...
;array of ptrs to functions: "returntype (* ptrmemtype name[size]) ();"
;array of ptrs to primitive: "datatype memtype * memtype name[size];
;when fsuppress=0,nlevel=0...
;ptr to array of ptrs to functions: "returntype (*ptrmemtype *ptr_name)();"
;ptr to array of ptrs to primitives: "datatype memtype *memtype *ptr_name;"

;no, coming into here with pdatavar->pointer. want to find lowest
;element in chain... assign to pdatavar...
    mov esi,pptr
    mov al,(OBJECT PTR [esi]).nchildresources
    .IF al==0	;error, ptr must have a child.
	     lea eax,szer5200
out3:	       invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
	       mov g_perrorobject,esi
	       mov eax,-1
	       ret
    .ENDIF
	   mov pprevsave,0
	   mov ecxprevsave,0
kg2:	   mov eax,pprevsave
	   mov pprev,eax
	   mov eax,ecxprevsave
	   mov ecxprev,eax
	   invoke findchild, esi,0
	   mov ecx,pprev
	   mov pprevsave,ecx
	   mov ecx,ecxprev
	   mov ecxprevsave,ecx
	   ;...esi is node to find the child of, 0 is find any .nexttype.
	   ;returns eax=addr of found child, else eax=0 not found.
	   .IF eax==0
	   .ELSE
	     ;careful, only looking for .nexttype=0 or 3...
	     mov ebx,eax
	     mov cx,(OBJECT PTR [ebx]).nexttype
	     .IF cx==3
	       mov esi,eax
	     .ELSEIF cx==0  ;actually, a node would have to be lowest.
	       mov esi,eax
	       ;let's just do an error check...
	       mov al,(OBJECT PTR [esi]).nchildresources
	       .IF al==0   ;ok.
	       .ELSE
		 lea eax,szer6200
		 jmp out3
	       .ENDIF
	       jmp SHORT out1
	     .ENDIF
	     jmp kg2
	   .ENDIF
out1:
    mov pdatavar,esi	    ;lowest element in chain.

;pname -> array
;pdatavar -> lowest element in chain.(primitive,node,structure,array)
;the chain will be:
; array > ptr > primitive|node|structure|array
; pname	  pptr	pdatavar
;if multidimensional, pname->lowest array in chain.

    mov esi,pdatavar
    mov edi,pname

;determine if this is a multidimensional array...
	    mov al,(OBJECT PTR [edi]).fstatus2
	    and al,11100000b
	    .IF al==01100000b	;array
	      ;locate highest array-chain...
ks1:	      mov ebx,(OBJECT PTR [edi]).rplock1
	      .IF ebx==0    ;error
	      .ELSE
		add ebx,pTERSEDATA
		mov al,(OBJECT PTR [ebx]).fstatus2
		and al,11100000b
		.IF al==01100000b	;array.
		  mov edi,ebx
		  jmp ks1
		.ENDIF
	      .ENDIF
	    .ENDIF
	    ;if entered above edi->array, drop out here edi->highest array.
	    mov phighest,edi

;determine type of array...
    mov al,(OBJECT PTR [esi]).fstatus2
    mov cl,al
    and cl,11100000b	    ;bits7/6/5.
    and al,01000b	    ;bit3.

    .IF al==1000b	    ;this is a child-node.
      ;this is an array of pointers to functions.

      ;if its an array of ptrs to functions,
      ;we have to complete the composition while here, and return eax=1.
      ;esi -> node, edi -> array.
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	      mov al,(OBJECT PTR [esi]).sztext4    ;return datatype.
	      .IF al==0  ;error...
		lea  eax,szer181d
		invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		mov  g_perrorobject,esi
		mov eax,-1
		ret
	      .ELSE
		lea eax,(OBJECT PTR [esi]).sztext4    ;node return datatype.
		invoke lstrcpy, ebx,eax
	      .ENDIF
	    invoke lstrlen, ADDR szscr1
	    lea ebx,szscr1
	    add ebx,eax
	    mov [ebx],BYTE PTR " "
	    inc ebx
	    mov [ebx],BYTE PTR "("
	    inc ebx
	    mov [ebx],BYTE PTR "*"
	    inc ebx
	    mov [ebx],BYTE PTR " "
	    inc ebx
	    mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [edi]).nmemtype2
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [edi]).nmemtype2
	      dec al		;cos we ignore .nmemtype2=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF

	    ;ignore nlevel, as effectively jumping up a level here
	    ;to complete the composition...
	    ;compose name, if fsuppress != 0...
	    .IF fsuppress==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR "*"
		inc ebx
		mov [ebx],BYTE PTR 0
		;compose mangled label, ptr_name...
;	      .IF nlevel==0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,szptr_	  ;mangle prefix
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		.ENDIF
;	      .ENDIF
	    .ELSE
	      ;ignore nlevel, as need to complete composition here...
	      ;.IF nlevel==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  mov [ebx],BYTE PTR " "
		  inc ebx
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		  ;if this is shareable, mangle it with its own element#...
		  mov ax,(OBJECT PTR [edi]).nexttype
		  .IF ax==4
		    mov al,(OBJECT PTR [edi]).fconfig
		    and al,01100000b
		    .IF al==0
		      invoke lstrlen, ADDR szscr1
		      lea ebx,szscr1
		      add ebx,eax
		      xor eax,eax
		      mov ax,(OBJECT PTR [edi]).number
		      invoke binto5dec, ebx ;appends element#
		      add ebx,5
		      mov [ebx],BYTE PTR 0
		    .ENDIF
		  .ENDIF
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		.ENDIF
	      ;.ENDIF
	    .ENDIF

       ;now for "[size]"...
       cmp fsuppress,0
       je  ku5		    ;don't compose "[size]"
	      mov esi,pname	;lowest array in multidimensional.
ku1:		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
	      mov [ebx],BYTE PTR "["
	      inc ebx
	      mov [ebx],BYTE PTR 0
		  ;must have size...
		  ;stored in .ntimeout field... *NO* now stored as
		  ;ascii string in .sztext2...
		  ;mov eax,(OBJECT PTR [esi]).ntimeout
		  mov al,(OBJECT PTR [esi]).sztext2
		  .IF al==0
		    mov [ebx],BYTE PTR "0"
		    inc ebx
		    mov [ebx],BYTE PTR 0
		  .ELSE
		    mov ecx,ebx
		    push ecx
		    ;invoke bin2dec	    ;eax->szasciitbl
		    ;lea ebx,szasciitbl
		    lea ebx,(OBJECT PTR [esi]).sztext2
		    mov al,[ebx]
		    .WHILE al==" "
		      inc ebx
		      mov al,[ebx]
		    .ENDW
		    pop ecx
		    invoke lstrcpy, ecx,ebx
		  .ENDIF
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  mov [ebx],BYTE PTR "]"
		  inc ebx
		  mov [ebx],BYTE PTR 0
		    ;if multidimensional...
		    mov ebx,(OBJECT PTR [esi]).rplock1
		    add ebx,pTERSEDATA
		    mov al,(OBJECT PTR [ebx]).fstatus2
		    and al,11100000b
		    .IF al==01100000b	;array
		      ;parent is also an array...
		      mov esi,ebx
		      jmp ku1	    ;compose next "[size]".
		    .ENDIF
ku5:		;bypass composing "[size]"

		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
	      mov [ebx],BYTE PTR ")"
	      inc ebx
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR "("
	      inc ebx
	      mov [ebx],BYTE PTR 0
	;let's also compose the passed datatypes...
		;does any C compiler require this?
		;MAKE THIS OPTIONAL --NO ERROR CHECK
	      mov esi,pdatavar
		lea eax,(OBJECT PTR [esi]).sztext5 ;node passed datatypes.
		invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR ")"
	      inc ebx
	      mov [ebx],BYTE PTR 0

	  ;now compose initialization...
ou7:	  .IF fsuppress==0
	  .ELSE
	    mov esi,phighest  ;(actually, esi already =highest array)
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	    mov al,(OBJECT PTR [esi]).sztext5
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      mov [ebx],BYTE PTR "="
	      inc ebx
	      mov [ebx],BYTE PTR "{"
	      inc ebx
	      lea eax,(OBJECT PTR [esi]).sztext5
	      invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR "}"
	      inc ebx
	      mov [ebx],BYTE PTR 0
	    .ENDIF
	  .ENDIF
	  ;must return eax=1, means composition complete.
	  mov eax,1
	  ret


    ;other types of array-of-ptrs-to- here...

    .ELSEIF cl==0	    ;primitive data is lowest in chain.
      ;compose "int *name[size];"...
      ;pdatavar=esi->lowest in chain,pname->lowest array,
      ;phighest->highest array,pptr->pointer.
      ;i'll also handle structure-lowest here...
ou6:	mov fstruc,0
	;if datatype is a structure, put "struct" first...
	  mov al,(OBJECT PTR [esi]).fstatus2
	  and al,11100000b
	  .IF al==01000000b   ;structure.
	    invoke lstrlen,ADDR szscr1
	    lea ebx,szscr1
	    add ebx,eax
	    lea eax,szstruct
	    invoke lstrcpy, ebx,eax
	    mov fstruc,1	    ;flag
	      ;do an error check...
	      ;if structure is a child, must not have anything attached
	      ;to it, and must have its internal .ndatatype set...
	      mov eax,(OBJECT PTR [esi]).rplock1
	      .IF eax==0
	      .ELSE
		mov (OBJECT PTR [esi]).nmemtype1,0  ;precaution.
		mov (OBJECT PTR [esi]).sztext5,0    ; / initialisation field.
		mov al,(OBJECT PTR [esi]).ndatatype
		.IF al==0
		  lea eax,szer4200
df1:		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,esi
		  mov eax,-1
		  ret
		.ENDIF
		mov al,(OBJECT PTR [esi]).nchildresources
		.IF al==0
		.ELSE
		  lea eax,szer4200b
		  jmp df1
		.ENDIF
	      .ENDIF
	  .ENDIF
	invoke lstrlen,ADDR szscr1
	lea ebx,szscr1
	add ebx,eax
	       xor eax,eax
	       mov al,(OBJECT PTR [esi]).ndatatype
	     .IF al==0
	       ;screened out before calling this func.
	     .ELSE
	       ;the datatype can be either inside the array, or in a child
		 ;data element. if a primitive child data element, don't
		 ;want to decr...
		 mov cl,(OBJECT PTR [esi]).fstatus2
		 and cl,11100000b
		 .IF cl==0	    ;primitive variable.
		 .ELSEIF cl==10000000b ;generic data.
		 .ELSE
		   dec al	    ;cos ignore 0.(0 means attached datatype)
		 .ENDIF
	       mov ecx,48
	       mul ecx
	       push ebx
	       mov ebx,pTERSEDATA
	       .IF fstruc==0
		 lea ecx,(TERSEDATA PTR [ebx]).sztype1
	       .ELSE
		 lea ecx,(TERSEDATA PTR [ebx]).szptrtype1
	       .ENDIF
	       pop ebx
	       add eax,ecx		;now have addr of string in eax.
	       invoke lstrcpy, ebx,eax
	      invoke lstrlen, ADDR szscr1
	      lea ebx,szscr1
	      add ebx,eax
	      mov [ebx],BYTE PTR " "
	      inc ebx
	      mov [ebx],BYTE PTR 0
	     .ENDIF
	    xor eax,eax
	    mov cl,(OBJECT PTR [esi]).fstatus2
	    and cl,11100000b
	    .IF cl==0	    ;simple primitive data.
	      mov al,(OBJECT PTR [esi]).nmemtype1
	    .ELSE
	      mov al,(OBJECT PTR [esi]).nmemtype2
	    .ENDIF
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      dec al		;cos we ignore .nmemtype1/2=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF
	;so far we've composed the datatype.
	;now compose "*name[size]"...
	mov edi,phighest		;highest array in chain.
	    invoke lstrlen, ADDR szscr1
	    lea ebx,szscr1
	    add ebx,eax
	    mov [ebx],BYTE PTR " "
	    inc ebx
	    mov [ebx],BYTE PTR "*"
	    inc ebx
	    mov [ebx],BYTE PTR " "
	    inc ebx
	    mov [ebx],BYTE PTR 0
	    mov al,(OBJECT PTR [edi]).nmemtype2
	    .IF al==0	      ;nothing selected.
	    .ELSE
	      xor eax,eax
	      mov al,(OBJECT PTR [edi]).nmemtype2
	      dec al		;cos we ignore .nmemtype2=0
	      mov ecx,48
	      mul ecx
	      push ebx
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).szpre1
	      pop ebx
	      add eax,ecx		;now have addr of string in eax.
	      invoke lstrcpy, ebx,eax
	    .ENDIF
	    ;ignore nlevel, as effectively jumping up a level here
	    ;to complete the composition...
	    ;compose name, if fsuppress != 0...
	    .IF fsuppress==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov [ebx],BYTE PTR " "
		inc ebx
		mov [ebx],BYTE PTR "*"
		inc ebx
		mov [ebx],BYTE PTR 0
		;compose mangled label, ptr_name...
;	      .IF nlevel==0
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  lea eax,szptr_	  ;mangle prefix
		  invoke lstrcpy, ebx,eax
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		.ENDIF
;	      .ENDIF
	    .ELSE
	      ;ignore nlevel, as need to complete composition here...
	      ;.IF nlevel==0
		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
		mov al,(OBJECT PTR [edi]).sztext1
		.IF al==0	      ;nothing selected.
		  lea eax,szer191a
		  invoke MessageBox,g_hwnd,eax, 0, MB_OK+MB_ICONEXCLAMATION
		  mov g_perrorobject,edi
		  jmp	zzzz
		.ELSE
		  mov [ebx],BYTE PTR " "
		  inc ebx
		  lea eax,(OBJECT PTR [edi]).sztext1
		  invoke lstrcpy, ebx,eax
		  ;if this is shareable, mangle it with its own element#...
		  mov ax,(OBJECT PTR [edi]).nexttype
		  .IF ax==4
		    mov al,(OBJECT PTR [edi]).fconfig
		    and al,01100000b
		    .IF al==0
		      invoke lstrlen, ADDR szscr1
		      lea ebx,szscr1
		      add ebx,eax
		      xor eax,eax
		      mov ax,(OBJECT PTR [edi]).number
		      invoke binto5dec, ebx ;appends element#
		      add ebx,5
		      mov [ebx],BYTE PTR 0
		    .ENDIF
		  .ENDIF
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		.ENDIF
	      ;.ENDIF
	    .ENDIF

       ;now for "[size]"...
       cmp fsuppress,0
       je  xku5		    ;don't compose "[size]"
	      mov esi,pname	;lowest array in multidimensional.
xku1:		invoke lstrlen, ADDR szscr1
		lea ebx,szscr1
		add ebx,eax
	      mov [ebx],BYTE PTR "["
	      inc ebx
	      mov [ebx],BYTE PTR 0
		  ;must have size...
		  ;stored in .ntimeout field... *NO* now stored as
		  ;ascii string in .sztext2...
		  ;mov eax,(OBJECT PTR [esi]).ntimeout
		  mov al,(OBJECT PTR [esi]).sztext2
		  .IF al==0
		    mov [ebx],BYTE PTR "0"
		    inc ebx
		    mov [ebx],BYTE PTR 0
		  .ELSE
		    mov ecx,ebx
		    push ecx
		    ;invoke bin2dec	    ;eax->szasciitbl
		    ;lea ebx,szasciitbl
		    lea ebx,(OBJECT PTR [esi]).sztext2
		    mov al,[ebx]
		    .WHILE al==" "
		      inc ebx
		      mov al,[ebx]
		    .ENDW
		    pop ecx
		    invoke lstrcpy, ecx,ebx
		  .ENDIF
		  invoke lstrlen, ADDR szscr1
		  lea ebx,szscr1
		  add ebx,eax
		  mov [ebx],BYTE PTR "]"
		  inc ebx
		  mov [ebx],BYTE PTR 0
		    ;if multidimensional...
		    mov ebx,(OBJECT PTR [esi]).rplock1
		    add ebx,pTERSEDATA
		    mov al,(OBJECT PTR [ebx]).fstatus2
		    and al,11100000b
		    .IF al==01100000b	;array
		      ;parent is also an array...
		      mov esi,ebx
		      jmp xku1	    ;compose next "[size]".
		    .ENDIF
xku5:		;bypass composing "[size]"

	  ;now compose initialization...
	  jmp ou7
	  ;must return eax=1, means composition complete.
	  mov eax,1
	  ret


    .ELSEIF cl==01000000b   ;structure is lowest in chain.
      ;comose "struct RECT *name[size];"...
      ;pdatavar=esi->lowest in chain,pname->lowest array,
      ;phighest->highest array,pptr->pointer.
      jmp ou6

    .ENDIF


    xor eax,eax
    ret
zzzz:
    mov eax,-1
    ret
composearrayofpointers ENDP
;------------------------------------------------------------------------
indentation PROC STDCALL USES ebx ecx edx esi edi, \
					 pinsert:DWORD,nlevel:DWORD
; "indentation"
;ppinsert pts to where to insert spaces.
;nlevel is number of units of spaces/tabs to insert.
;returns eax ptg to next free location.
    xor eax,eax
    xor ecx,ecx
    mov edi,pinsert
    mov ebx,pTERSEDATA
    mov al,(TERSEDATA PTR [ebx]).nindentation
    .IF al==0
      .WHILE ecx<nlevel
	mov [edi],BYTE PTR 09	;tab char.
	inc edi
	inc ecx
      .ENDW
    .ELSE
      .WHILE ecx<nlevel
	xor eax,eax
	xor edx,edx
	mov al,(TERSEDATA PTR [ebx]).nindentation
	.WHILE edx<eax
	  mov [edi],BYTE PTR " "	    ;space char.
	  inc edi
	  inc edx
	.ENDW
	inc ecx
      .ENDW
    .ENDIF
    mov eax,edi
    ret
indentation ENDP
;------------------------------------------------------------------------
;------------------------------------------------------------------------
;------------------------------------------------------------------------
