;By Barry Kauler 2000
;GOOSEE.ASM --> GOOSEE.EXE
;Win32 application written for masm 6.14

;NOTES ON GCC--MASM
;------------------
;just to show how to call from gnu gcc ...
;here is an asm procedure...
;
;ASMPROC PROC PUBLIC USES eax ebx ecx edx esi edi ebp
; LOCAL dummy:DWORD
;
; ret
;ASMPROC ENDP
;
;it is by default STDCALL.
;in the c file, define this:
;
;extern void STDCALL ASMPROC(void);
;
;to call c function from asm file ...
; invoke demo1
;and define a prototype in goosee.inc ...
; demo1 PROTO STDCALL

;put this into c file...
;
;void STDCALL demo1(void) {
;
; return;
; }
;
;for data in goosee.asm, declare it public...
; PUBLIC highlightedindex
;
;In the .c file, declare it external...
; extern unsigned int highlightedindex;
;
;Note, both .c and .asm will export as "_highlightedindex",
;so they match.
;-----------------------------------

.386
.387
.MODEL FLAT,STDCALL
      option casemap :none   ; case sensitive
UNICODE = 0
INCLUDE WIN32ML.INC

INCLUDE GOOSEE.INC



.DATA
  BYTE 32 DUP(?)
DATASTART LABEL PTR NEAR

;these are the methods for each type of object...
;note "*" comment at end of row fully implemented ***NOTE***
ptrs   LABEL DWORD
pnode  DWORD paint_node, delete_node,drag_node, on_node, wipeslaves_node, snap_tonode ;*
pres   DWORD paint_res,  delete_res,drag_node, on_res,	wipeslaves_node, snap_tores ;*
phard  DWORD paint_hard,delete_res,drag_node, on_res,	wipeslaves_node, snap_tores ;*
pcmt   DWORD paint_cmt,  delete_any,drag_node, on_cmt,	wipeslaves_node,snap_toany ;*
pcond  DWORD paint_cond,delete_any,drag_node, on_cmt,	wipeslaves_node,snap_toany ;*
pact   DWORD paint_act,	delete_any,drag_node, on_cmt,	wipeslaves_node,snap_toany ;*
parc   DWORD paint_arc, delete_arc, drag_arc , on_arc,	wipeslaves_gen , snap_toarc ;*
pexec  DWORD paint_exec, delete_icon,drag_node, on_any, wipeslaves_node, snap_toany ;*
pinfo  DWORD paint_info, delete_icon,drag_node, on_any, wipeslaves_node, snap_toany ;*
pmake  DWORD paint_make, delete_icon,drag_node, on_any, wipeslaves_node, snap_toany ;*

pcomp  DWORD paint_comp, delete_node,drag_super,on_super,wipeslaves_node, snap_tonode
psuper DWORD paint_super,delete_node,drag_super,on_super,wipeslaves_node, snap_tonode
pjb    DWORD paint_jb,	 delete_jb,  drag_arc,	on_arc,  wipeslaves_gen,  snap_gen
psub   DWORD paint_sub,  delete_sub, drag_sub,	on_node, wipeslaves_node, snap_tonode
pscomp DWORD paint_comp, delete_node,drag_node, on_super,wipeslaves_node, snap_tonode
pssuper DWORD paint_super,delete_node,drag_node,on_super,wipeslaves_node, snap_tonode
patt   DWORD paint_att,  delete_at,  drag_att,	on_arc,  wipeslaves_gen,  snap_tonode
pfnc   DWORD paint_fnc,  delete_fnc, drag_node, on_fnc,  wipeslaves_node, snap_tonode
;these are the polymorphic method names...
pdisplay    EQU 0   ; / paint current object.
pdelete     EQU 4   ; / delete current object.
pdrag	    EQU 8   ; / drag current object.
ponobject   EQU 12  ; / test if mouse on current object.
pwipeslaves EQU 16  ; / for white-out of current object.
psnap	    EQU 20  ;/	for snapping wire-end to current object.

instantiatedOBJECT    OBJECT    <>  ;instantiated single object, to copy.
instantiatedTERSEDATA TERSEDATA <>	;instantiate structure here, for
						;copying to mem block.

pTERSEDATA  DWORD   0	;when a file is loaded, this will point to it.
    ;(when i allocate memory and load a file, must store ptr to here).
    ;(see wmcreate() and opendatafile() functions)
    ;(also, when starting new default datafile, above TERSEDATA is
    ; copied to memory block, and pTERSEDATA will point to it)
    ;TERSEDATA.rpobjects has start OBJECTS database, relative to TERSEDATA.
    ;The first ten objects are actually inside TERSEDATA, at end.
    ;  ... i.e. OBJECTS is inside TERSEDATA.
    ;All pointers in OBJECT are relative to start of OBJECTS.
    ;The total size (TERSEDATA + extra objects) is tracked by g_nfilesize.

;this is to be loaded into TERSEDATA.szgenprelim by wmcreate()...
szloadgenprelim BYTE "/* THIS TEXT WILL BE INSERTED AT START OF SOURCE FILE */",0Dh,0Ah
	       BYTE "/* NOTE, goosee00.c should be compiled with all projects */",0Dh,0Ah
	     BYTE 0Dh,0Ah
	       DB "/* put your include files here! */",0Dh,0Ah
	     BYTE 0Dh,0Ah
	     DB "#define bit unsigned char /* if no bit datatype */",0Dh,0Ah
	     DB "#define U8 unsigned char",0Dh,0Ah
	     DB "#define U16 unsigned int",0Dh,0Ah
	     DB "#define U32 unsigned long",0Dh,0Ah
	     DB "#define S8 signed char",0Dh,0Ah
	     DB "#define S16 signed int",0Dh,0Ah
	     DB "#define S32 signed long",0Dh,0Ah
	     DB "#define F32 float",0Dh,0Ah
	     DB "#define F64 double",0Dh,0Ah
	    BYTE 0Dh,0Ah
	    BYTE "/* These are in goosee00.c ... */",0Dh,0Ah
	    BYTE "extern bit issig(U8);",0Dh,0Ah
	    BYTE "extern void postsig(U8);",0Dh,0Ah
genprelimend LABEL NEAR PTR


;--------------------------------------------------------------------------

g_hinst		DWORD 0
mainhwnd         DWORD 0
s1		 WNDCLASS    <?>
s2		 MSG	 <?>
szTitleName	 DB "Win32 GOOSEE Graphical OO Software Engineering Environment",0
szClassName	 DB "GOOSEE",0
sziconname	 DB "ICON_1",0	    ;name of icon in .RC file.

g_hwnd	  DWORD 0	;handle for main window.

szaboutstr DB  "Graphical OO Software Engineering Environment",0Dh,0Ah ;messagebox
  DB  """GOOSEE"" 32-bit version 1.3",0Dh,0Ah
  DB  "http://www4.tpg.com.au/users/void/gooseeuser",0 ;0Dh,0Ah
;  DB  "----------------------",0Dh,0Ah
;  DB  "GOO DIAGRAMS ARE INTRODUCED IN THE TEXTBOOK",0Dh,0Ah
;  DB  """FLOW DESIGN FOR EMBEDDED SYSTEMS""",0Dh,0Ah
;  DB  "by Barry Kauler, published by",0Dh,0Ah
;  DB  "R&D Books USA, http://www.rdbooks.com/",0
sztitlestr	DB	'Copyright (c) 2000 Barry Kauler',0

g_fhaschanged	BYTE 0	;=1 if datafile has changed. IDM_OPEN checks this.
g_nstate	DB 0		;0=normal start-up and running state.

;warning, these are absolute pointers. are invalid if LocalRealloc().
;note also pointers in updates & wipeouts lists are invalid.
g_pmovingobject   DWORD 0		;pts to moving object.
g_pselectedobject DWORD 0		; (note i clear all of these after
g_pselectedobjectnew DWORD 0	;   calling LocalRealloc() )
g_phighlightedobject DWORD 0
;g_phighlightedobjectprev DWORD 0 ;previous highlighted, if any.
;see object.fconfig2/bit7, add2highlightedobject(), for multiple
;highlighted objects. this flag clears them all...
g_fclrhighlighted BYTE 0
g_perrorobject	  DWORD 0
poldmovingobject DWORD 0 ;pmovingobject saved here. used to delete last
			;object, even though not selected.

g_nknee     BYTE 0  ;set by on_arc(), =1 mid, =2 knee2, =3 knee3 selected.
g_fredrawdiag	    BYTE  0	;flags for redrawing diagram.
g2_fredrawdiag BYTE 0  ;paint_*() funcs-->wmpaint() to reload g_fredrawdiag
WIPEOUTobjs	EQU 1		; /
UPDATEobjs	   EQU 2	; /
ENTIRE	    EQU 3	; /
META	    EQU 4		; /

;for printing...
szport		BYTE 8	DUP(0)	      ;port (LPT1) <<<PROBABLY WON'T USE
szdriver        BYTE 16 DUP(0)        ;printer-driver name
szname		BYTE 32 DUP(0)	      ;printer name
myprintdlg PRINTDLGA <(SIZEOF PRINTDLGA),0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0>


ctrlkey   DB 0		;=1 if control-key down when a node is selected.
g_fhack1   BYTE 0		;see WM_SYSCOMMAND and wmdestroy().

g_naccelx   SDWORD 0	;higher magnitude (+ or -), faster scrolling.
g_naccely    SDWORD 0	;/
clientrect RECT <>	 ;scrolling (actual region of diagram in window)
clientrectold RECT <>	;/(top,left always =0,0 bot,right =height,width)
  ;note, clientrect width/height will always track clientrectold.right/bot.
 ;i.e. the width/height always the same, but clientrect has varying top/left.
windowrect RECT <>  ;used to clip cursor.

szascii1 DB 4 DUP(0)
szascii2 DB 4 DUP(0)
szascii3 DB 2 DUP(0)
sznull	DB 0,0


;names of dialog boxes...
;***NOTE*** i'm going to replace these with res #s, as per KENTER1...

;sztersedlg DB "tersedlg",0  ;used by idm_terse, dialog box.
;***szKENTER1  DB "KENTER1",0	;used by IDM_CONFIG, dialog box.(name in RC)
;szKENTER2  DB "KENTER2",0   ;wire configuration dialog box.
;szKENTER17 DB "KENTER17",0  ;interrupt wire dialog box.
;szKENTER3  DB "KENTER3",0   ;wire with reply dialog box.
;szKENTER3M DB "KENTER3M",0  ;wire with reply, goes to library or proto node.
;szKENTER4  DB "KENTER4",0   ;wire with reply & timeout dialog box.
;szKENTER4M  DB "KENTER4M",0   ;wire with reply & timeout dialog box.
;szKENTER30  DB "KENTER30",0   ;condition-wire configuration dialog box.
;szKENTER30C DB "KENTER30C",0  ;comment-wire dialog.
;szKENTER33  DB "KENTER33",0   ;action wire dialog box.
;szKENTER5  DB "KENTER5",0   ;node configuration dialog box.
;szKENTER5X  DB "KENTER5X",0   ;node configuration dialog box.
;szKENTER5PROTO DB "KENTER5PROTO",0 ;prototype subnode dialog.
;szKENTER6  DB "KENTER6",0   ;resource configuration dialog box.
;szKENTER10  DB "KENTER10",0   ;auto-snap dialog box.
;szKENTERCH  DB "KENTERCH",0 ;change object type.
;szGENINSERT DB "GENINSERT",0 ;text to be inserted into generated code.

;painting stuff...
CURRENTPOINTSIZE  EQU 12
CURRENT2POINTSIZE EQU 12
CURRENT3POINTSIZE EQU 11    ;using for courier.
CURRENT4POINTSIZE EQU 16    ;using for 1.5 times font.
szface		DB  "Courier New",0
szface2 	      DB "MS Serif",0
szface3 	      DB "Arial Bold",0 
szface4           DB "Courier",0
szface5           DB "Times New Roman",0	
szface6           DB "Arial",0
g_nmousex SDWORD 0             ;mouse coords, corrected for origin-shift.
g_nmousey SDWORD 0             ;/  
iiwparammouse SDWORD 0	    ;only valid when scrolling.
iilparammouse SDWORD 0	;/
g_xdiff   SDWORD 0	;when lbuttondown, difference between mouse pos.
g_ydiff   SDWORD 0	; and object coords.
g_fprintingnow	DB FALSE	;fixes a win95 printing problem
; g_hfontx1ms DWORD 0	;standard size, non-TrueType.
g_hfontx1x  DWORD 0 ;
g_hfontx1   DWORD 0	;standard size font.
g_hfontx1p5 DWORD 0	;big fonts used in xpaint.
g_hfontx2   DWORD 0	;/
g_hfontx4   DWORD 0	;/
g_htextfont DWORD 0	;standard size font handle.
g_hpengrey  DWORD 0	;1-pixel wide grey pen.

g_hcrosshair  DWORD 0 ;handle for cross-hair cursor.
g_hnormcursor DWORD 0	 ;normal cursor.
g_nring  DWORD 0    ;on_node() returns which ring mousex/y is on.
g_nsnapring DWORD 0   ;non-0, snap_tonode() force mousex/y snap to ring.
g_xdiffnorm  SDWORD 0	;set by snap_ method, used for drawing arrows.
g_ydiffnorm  SDWORD 0	;/



.CODE
;-----------------------------------------------------------------------------
;..................................................................

start:


  invoke  GetModuleHandle, NULL
  mov	    g_hinst, eax

; initialize the WndClass structure
        mov     s1.w_style, CS_HREDRAW OR CS_VREDRAW OR CS_DBLCLKS
	mov	s1.w_lpfnWndProc, offset ASMWNDPROC
	mov	s1.w_cbClsExtra, 0
	mov	s1.w_cbWndExtra, 0

	mov	eax, g_hinst
	mov	s1.w_hInstance, eax

;  call LoadIcon, NULL, IDI_APPLICATION	  ;loads default icon.
;let's load a custom icon....
	mov eax,470	    ;icon id in goosee.rc
	invoke	LoadIcon, g_hinst, 470	;OFFSET sziconname
	mov	s1.w_hIcon, eax

;; 191100
;;to be able to change cursors, think need to set this param to 0...
;;(also see further down)
	invoke	LoadCursor,NULL, IDC_ARROW
	mov	s1.w_hCursor, eax
;	mov s1.w_hCursor,NULL
	mov g_hnormcursor,eax

	invoke GetStockObject, WHITE_BRUSH
	mov	s1.w_hbrBackground,eax ;COLOR_WINDOW + 1
	mov	s1.w_lpszMenuName, OFFSET szClassName
	mov	s1.w_lpszClassName, OFFSET szClassName

    invoke RegisterClass, OFFSET s1
    test  eax,eax
    jz	  end_loop  ;exit if eax=0.

    invoke CreateWindowEx,0,OFFSET szClassName,OFFSET szTitleName, \
	WS_OVERLAPPEDWINDOW,5,10, \
	625,440, 0, 0, g_hinst, 0
	;note i had x/y = CW_USEDEFAULT & width/height =CW_USEDEFAULT,
	;i now have 5,10,625,440
	test eax,eax
	jz   end_loop	    ;exit if eax=0.
	mov	mainhwnd, eax

    invoke ShowWindow, mainhwnd,SW_SHOWNORMAL
    invoke UpdateWindow, mainhwnd


; 191100
;load this also, for use later...
    invoke LoadCursor, NULL,IDC_CROSS	;cross-hair.
    mov g_hcrosshair,eax
;;load standard cursor (see modification above)...
;	invoke	LoadCursor,NULL, IDC_ARROW
;	mov g_hnormcursor,eax
;	invoke SetCursor,eax


msg_loop:
    invoke GetMessage, OFFSET s2, 0,0,0
	cmp	ax, 0
        je      end_loop
    invoke TranslateMessage, OFFSET s2
    invoke DispatchMessage, OFFSET s2
	jmp	msg_loop

end_loop:
    invoke ExitProcess, s2.ms_wParam

;-----------------------------------------------------------------------------
    PUBLIC ASMWNDPROC
ASMWNDPROC PROC USES ebx edi esi,hwnd:DWORD,wmsg:DWORD,wparam:DWORD,lparam:DWORD

    mov eax,hwnd	    ;useful to make this static.
    mov g_hwnd,eax


	xor eax,eax
        mov ax,WORD PTR wmsg
	.IF ax==WM_DESTROY	;DestroyWindow() generates this.
	  invoke wmdestroy, wmsg,wparam,lparam
	.ELSEIF ax==WM_SYSCOMMAND
	  ;i want to do default handling of this, except get an error
	  ;when closing the mem block when user selects close-box.
	  mov eax,wparam
	  and eax,0FFF0h		;see win32api docs.
	  .IF eax==SC_CLOSE
	    ;it seems that Windows has already destroyed the mem block
	    ;by time get to my wmdestroy() func.
	    ;therefore, set a flag...
	    mov g_fhack1,1
	    jmp def1
	  .ELSE
	    jmp def1
	  .ENDIF
	.ELSEIF ax==WM_RBUTTONDOWN
	  invoke wmrbuttondown, wmsg,wparam,lparam
	.ELSEIF ax==WM_SIZE
	  invoke wmsize, wmsg,wparam,lparam
	.ELSEIF ax==WM_CREATE
	  invoke wmcreate, wmsg,wparam,lparam
	.ELSEIF ax==WM_LBUTTONDOWN
	  invoke wmlbuttondown, wmsg,wparam,lparam
	.ELSEIF ax==WM_LBUTTONUP
	  invoke wmlbuttonup, wmsg,wparam,lparam
	.ELSEIF ax==WM_MOUSEMOVE
	  invoke wmmousemove, wmsg,wparam,lparam
	.ELSEIF ax==WM_PAINT
	  invoke wmpaint, wmsg,wparam,lparam
	.ELSEIF ax==WM_COMMAND
	  invoke wmcommand, wmsg,wparam,lparam
	.ELSEIF ax==(WM_USER+100h)
	  invoke xuser, wmsg,wparam,lparam
	.ELSEIF ax==(WM_USER+1+100h)
	  invoke xuser1, wmsg,wparam,lparam
	.ELSEIF ax==(WM_USER+2+100h)
	  invoke xuser2, wmsg,wparam,lparam
	.ELSEIF ax==(WM_USER+4+100h)
	  invoke xuser4, wmsg,wparam,lparam
;	.ELSEIF ax==WM_SIZE
;	  invoke xsize, wmsg,wparam,lparam
	.ELSEIF ax==WM_SETFOCUS    ;this window has just got input focus.
	  invoke InvalidateRgn, g_hwnd,0,FALSE
	  mov g_fredrawdiag,ENTIRE	       ;redraw entire window.
	.ELSEIF ax==WM_TIMER
	  invoke xtimer, wmsg,wparam,lparam
	.ELSEIF ax==WM_LBUTTONDBLCLK
	  invoke xdblclk, wmsg,wparam,lparam
	.ELSEIF ax==WM_KEYDOWN
	  invoke  xkeydown, wmsg,wparam,lparam
	.ELSEIF ax==WM_KEYUP
	  invoke xkeyup, wmsg,wparam,lparam

	.ELSE
def1:	  invoke DefWindowProc, hwnd,wmsg,wparam,lparam
	  ret
	.ENDIF
	xor eax,eax
	ret
ASMWNDPROC ENDP
;-----------------------------------------------------------------------------
.DATA?
newpoint POINT <?,?>

.DATA
fmovinghighlighted BYTE 0
nnewwiretype WORD 0
fvartype     BYTE 0
szgoosee   BYTE "GOOSEE",0
szchanged  DB "The current diagram has changed. Do you want to save it?",0
szfsave1   BYTE "Save of the current diagram was aborted. Do you want to "
	   BYTE "continue with opening a new .GOO file?",0
szerh9	   BYTE "An Action element must be selected (highlighted) before "
	   BYTE "you toggle it's double-action (exit) feature.",0
sznotselstart DB "You must highlight first node in 1-thread sub-diagram",0
szer121   BYTE "You have highlighted a library function node. "
	  BYTE "This is an external function, for example the "
	  BYTE "MS Windows API functions, and does not have any internal "
	  BYTE "code in this diagram. GOOSEE is aborting the code "
	  BYTE "generation operation.",0
szer122   BYTE "You have highlighted an inline-code node. GOOSEE will "
	  BYTE "not generate code for this. You must first highlight "
	  BYTE "a normal-function or ISR-function. The function that "
	  BYTE "you highlight will be the top-level function in the "
	  BYTE "generated C source file.",0Dh,0Ah
	  BYTE "If you really want the inline-code node to be the "
	  BYTE "first or highest-level code in the generated file, "
	  BYTE "change it into a function.",0Dh,0Ah
	  BYTE "GOOSEE is aborting the code generation operation.",0
szerhi1 BYTE "You have got to highlight some elements before you "
	BYTE "can duplicate or move them. You highlight elements "
	BYTE "from the menu ""Control/Selection rectangle"" or "
	BYTE "manually by holding down the <shift> key and left-clicking "
	BYTE "on elements.",0
szerhi1b BYTE "You have got to highlight some elements first. "
	BYTE "You highlight elements "
	BYTE "from the menu ""Control/Selection rectangle"" or "
	BYTE "manually by holding down the <shift> key and left-clicking "
	BYTE "on elements.",0


.CODE
wmcommand PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
	mov ax,WORD PTR lparam
	.IF ax==0
	  mov  ax,WORD PTR wparam
	  .IF ax==IDM_QUIT
	    invoke DestroyWindow, g_hwnd	  ;exit GOOSEE
	    ;NOTE this will post WM_DESTROY msg, which calls wmdestroy()
	    ;which closes things down and posts PostQuitMessage().
	  .ELSEIF ax==IDM_ABOUT
	    invoke MessageBox, g_hwnd, OFFSET szaboutstr, OFFSET sztitlestr, MB_OK
	  .ELSEIF ax==IDM_OPEN
	    ;first, save diagram if it has changed...
	    .IF  g_fhaschanged==1
	      invoke MessageBox,g_hwnd,ADDR szchanged,ADDR szgoosee,MB_OK+MB_YESNO+MB_ICONQUESTION
	      .IF ax==IDYES
		invoke savedatafile
		.IF eax==1  ;aborted save.
ww8:		  invoke MessageBox,g_hwnd,ADDR szfsave1,ADDR szgoosee,MB_OK+MB_YESNO+MB_ICONQUESTION
		  .IF ax==IDYES
		  .ELSE
		    ret     ;abort opening file.
		  .ENDIF
		.ELSEIF eax==2 ;cancel save.
		  jmp ww8
		.ENDIF
	      .ENDIF
	    .ENDIF
	    invoke opendatafile
	    mov g_fhaschanged,0
	  .ELSEIF ax==IDM_SAVE
	    invoke savedatafile
	    mov g_fhaschanged,0
	  .ELSEIF ax==IDM_SAVEAS
	    invoke saveasdatafile
	    mov g_fhaschanged,0

	  .ELSEIF ax==IDM_SAVEASS   ;save-as selected elements.
	    ;duplicate part of a diagram...
	    .IF highlightedindex==0
		;error...
		lea eax,szerhi1b
		invoke MessageBox, g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	    .ELSE
	      invoke selectedsaveasdatafile
	    .ENDIF

	  .ELSEIF ax==IDM_SAVEASS_EMF	;save-as selected elements to EMF.
	    ;duplicate part of a diagram...
	    .IF highlightedindex==0
		;error...
		lea eax,szerhi1b
		invoke MessageBox, g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	    .ELSE
	      invoke selectedsaveasemf
	    .ENDIF


	  .ELSEIF ax==IDM_NODE
	    invoke createnewobject,1	;returns eax=0 no obj created
		;param =1 means always create at end of database.
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a node...
		invoke defaultnewnode, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF

	  .ELSEIF ax==IDM_COMMANDICON
	    invoke createnewobject,0	;returns eax=0 no obj created
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a command icon (a node, dblclk=command)...
		invoke defaultnewcommand, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF

	  .ELSEIF ax==IDM_INFOICON	;text-file icon
	    invoke createnewobject,0	;returns eax=0 no obj created
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		invoke defaultnewinfo, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF

	  .ELSEIF ax==IDM_MAKEICON  ;make-icon
	    invoke createnewobject,0	;returns eax=0 no obj created
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		invoke defaultnewmake, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF


	  .ELSEIF ax==IDM_PTR	    ;new resource, pointer.
	    ;defaultnewres() uses this...
	    mov fvartype,00100000b
	    jmp SHORT uu1
	  .ELSEIF ax==IDM_STRUC     ;new resource, structure.
	    mov fvartype,01000000b
	    jmp SHORT uu1
	  .ELSEIF ax==IDM_ARRAY     ;new resource, array.
	    mov fvartype,01100000b
	    jmp SHORT uu1
	  .ELSEIF ax==IDM_GENERIC   ;new resource, generic data.
	    mov fvartype,10000000b
	    jmp SHORT uu1
	  .ELSEIF ax==IDM_RES	    ;new resource/data. simple variable.
	    mov fvartype,0	    ;simple variable.
uu1:	    invoke createnewobject,0	;returns eax=0 no obj created
	      ;param=0 means can create anywhere in databse vacant place.
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a resource...
		invoke defaultnewres, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF
	  .ELSEIF ax==IDM_HARDWARE	    ;new hardware.
	    invoke createnewobject,0	;returns eax=0 no obj created
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a hardware object...
		invoke defaultnewhardware, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF
	  .ELSEIF ax==IDM_COMMENT	;comment object.
	    invoke createnewobject,0	;returns eax=0 no obj created
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a resource...
		invoke defaultnewcom, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF
	  .ELSEIF ax==IDM_CONDITION	;condition object.
	    invoke createnewobject,1	;returns eax=0 no obj created
	      ;param=1 always create at end of database.
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a resource...
		invoke defaultnewcondition, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF
	  .ELSEIF ax==IDM_ACTION	;condition object.
	    invoke createnewobject,1	;returns eax=0 no obj created
	      ;param=1 always create at end of databse.
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a resource...
		invoke defaultnewaction, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF
	  .ELSEIF ax==IDM_ACTIONEXIT
	    ;toggles double-action of action element.
	    ;an action element must be highlighted...
	    mov ebx,g_phighlightedobject
	    .IF ebx==0
er1:		lea eax,szerh9
		invoke MessageBox, g_hwnd, eax,0,MB_OK+MB_ICONEXCLAMATION
	    .ELSE
	      mov g_phighlightedobject,0
	      mov g_nstate,0
	       push ebx
	       invoke add2updatelist, ebx
	       invoke InvalidateRgn, g_hwnd,0,FALSE
	       mov g_fredrawdiag,UPDATEobjs
	       pop ebx
	      mov ax,(OBJECT PTR [ebx]).nexttype
	      .IF ax==33
		xor (OBJECT PTR [ebx]).fconfig,0100000b ;toggle bit5.
	      .ELSE
		jmp er1
	      .ENDIF
	    .ENDIF

	  .ELSEIF ax==IDM_INTER
	    ;as per IDM_WIRE, except .fconfig/bit5 set, inter-task.
	    ;need to tell defaultnewwire() to do this.
	    ;use a dummy value...
	    mov nnewwiretype,999
	    jmp wk1
	  .ELSEIF ax==IDM_SYNC2
	    mov nnewwiretype,11 	;sync 2-way
	    jmp wk1
	  .ELSEIF ax==IDM_ASYNC1
	    mov nnewwiretype,13 	;async 1-way
	    jmp wk1
	  .ELSEIF ax==IDM_ASYNC2
	    mov nnewwiretype,14 	;async 2-way
	    jmp wk1
	  .ELSEIF ax==IDM_WIRE		;Execution-flow wire object.
	    mov nnewwiretype,10 	;sync 1-way (see defaultnewwire())
wk1:	    invoke createnewobject,1	;returns eax=0 no obj created
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a resource...
		invoke defaultnewwire, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF
	  .ELSEIF ax==IDM_WI		;data-flow wire object.
	    invoke createnewobject,1	;returns eax=0 no obj created
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a resource...
		invoke defaultnewdatawire, eax
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF
	  .ELSEIF ax==IDM_JBDN	;mutual-exclusion bar (wire).
	    ;***NOTE*** NOT YET IMPLEMENTED ***NOTE***
	    invoke createnewobject,1	;returns eax=0 no obj created
	    .IF eax==0
	    .ELSE
		;eax points to the new object. 
		mov g_pmovingobject,eax	;used for placing the object.
		;customise to a resource...
		invoke defaultnewexclusion, eax   ;***NOTE***
		mov g_nstate,4		;placing new object, first end.
	    .ENDIF

	  .ELSEIF ax==IDM_ERASEDIA  ;erase diagram.
	    invoke erasediagram
	  .ELSEIF ax==IDM_TEMPLATE
	    invoke opentemplate	  ;apply a template to current database.
	  .ELSEIF ax==IDM_MERGE
	    invoke openmerge	;merge another diagram.
	  .ELSEIF ax==IDM_ORIGIN  ;restore origin to top/left client area.
	    invoke xorigin
	  .ELSEIF ax==IDM_ZOOMOUT
	    mov esi,pTERSEDATA
	    mov al,(TERSEDATA PTR [esi]).nzoom
	    .IF al==6	    ;max zoom out.
	    .ELSE
	      inc (TERSEDATA PTR [esi]).nzoom
zoo1:	      invoke InvalidateRgn,g_hwnd,0,TRUE ;invalidate entire window.
	      mov g_fredrawdiag,ENTIRE		;redraw entire window.
	    .ENDIF
	  .ELSEIF ax==IDM_ZOOMNORM
	    mov esi,pTERSEDATA
	    mov (TERSEDATA PTR [esi]).nzoom,0
	    jmp zoo1
	  .ELSEIF ax==IDM_ZOOMIN
	    mov esi,pTERSEDATA
	    dec (TERSEDATA PTR [esi]).nzoom
	    jmp zoo1
	  .ELSEIF ax==IDM_PSET	;printer setup.
	 ;   ;just display a printer setup dialog box...
	 ;   mov eax,g_hwnd
	 ;   mov myprintdlg.pr_hwndOwner,eax
	 ;   mov myprintdlg.pr_Flags,PD_PRINTSETUP
	 ;   invoke PrintDlgA, ADDR myprintdlg

	    ;...***NOTE*** code to update the settings i got in
	    ;wmcreate().

	  .ELSEIF ax==IDM_PRA	;print
;	    mov	g_fprintdiag,3
;	    invoke InvalidateRgn, g_hwnd,0,FALSE
	    mov	g_phighlightedobject,0
	    mov	g_nstate,0
	      mov g_fprintingnow,TRUE
;	      mov	g_fredrawdiag,ENTIRE
	      invoke xpaint_print
	      invoke PostMessage, g_hwnd,WM_USER+4+100h,0,0	;delay repaint.
	      mov g_fredrawdiag,0
	      mov g_fprintdiag,0
	      mov g_fprintingnow,FALSE

	  .ELSEIF ax==IDM_CPY	;copy diagram to clipboard.
	    invoke shoot
	  .ELSEIF ax==IDM_CONFIG	;KENTER1 dialog box.
	    ;(menu Control/Language&editor...)
	    lea	ecx,KENTER1proc
	    ;(NOTE DialogBox() replaced...)
	    mov eax,200       ;resource number of KENTER1 in goosee.rc
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSEIF ax==IDM_PROJECT ;Project management dialog.
	    lea ecx,PROJECTproc
	    mov eax,201 ;resource number of PROJECT dialog in goosee.rc.
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSEIF ax==IDM_OS	;Operating System dialog.
	    lea ecx,OSproc
	    mov eax,202 ;resource number of OS dialog in goosee.rc.
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSEIF ax==IDM_GENINSERT ;generated source file dialog.
	    lea ecx,GENINSERTproc
	    mov eax,203 ;resource number of OS dialog in goosee.rc.
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSEIF ax==IDM_PREFS ;generated source file dialog.
	    lea ecx,PREFSproc
	    mov eax,212 ;resource number of PREFS dialog in goosee.rc.
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0

	  .ELSEIF ax==IDM_1CODE	;generate 1-thread code
	    invoke generatecode

	  .ELSEIF ax==IDM_INTEGRITY
	    ;check integrity of entire current .goo database.
	    invoke checkintegrity,0 ;param=0 display all msgs.

	  .ELSEIF ax==IDM_DUP
	    ;duplicate part of a diagram...
	    .IF highlightedindex==0
		;error...
		lea eax,szerhi1
		invoke MessageBox, g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	    .ELSE
	      ;need to move the mouse-cursor...
	      invoke repositioncursor
	      ;duplicate and track mouse...
	      invoke duplicatehighlighted
	      ; mov highlightedindex,0	;remove list of highlighted elements.
	    .ENDIF

	  .ELSEIF ax==IDM_RECT	;draw a selection-rectangle.
	    mov g_nstate,20
	    ;need a cross-hair cursor...
	    invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hcrosshair ;NULL
	      ;...remove class cursor, allows a replacement.
	      ;invoke SetCursor,g_hcrosshair
	    ;wherever press left-button, start corner,
	    ;release button, end corner...

	  .ELSEIF ax==IDM_MOVE ;move highlighted elements.
	    ;duplicatehighlighted() above, calls updateduplicates()
	    ;when there is a mousemove.
	    ;we can have a similar thing here, called updatemove().
	    .IF highlightedindex==0
		;error...
		lea eax,szerhi1
		invoke MessageBox, g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	    .ELSE
	      ;need to move the mouse-cursor...
	      invoke repositioncursor
	      mov fmovinghighlighted,1 ;use in wmmousemove/wmlbuttonup.
	    .ENDIF


	  .ELSEIF ax==IDM_NFIND ;element# find.
	    lea ecx,NFINDproc
	    mov eax,220 ;resource number of NFIND dialog in goosee.rc.
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .IF xg_perrorobject==0
	    .ELSE
	      mov eax,xg_perrorobject
	      mov g_perrorobject,eax
	      mov highlightedindex,0  ;attempt fix.
	      mov g_fclrhighlighted,1 ;/
	      mov g_phighlightedobject,0 ;/
	      mov g_nstate,0		;/
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE
	    .ENDIF

	  .ELSEIF ax==IDM_TFIND ;text find.
	    lea ecx,TFINDproc
	    mov eax,221 ;resource number of TFIND dialog in goosee.rc.
	    invoke DialogBoxParam, g_hinst,eax,0,ecx,0	 ;NO OWNER WINDOW!
	      mov highlightedindex,0  ;don't think these necessary.
	      mov g_fclrhighlighted,1 ;/
	      mov g_phighlightedobject,0 ;/
	      mov g_nstate,0		;/
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE

	  .ENDIF
	.ENDIF
    ret
wmcommand ENDP
;------------------------------------------------------------------------
repositioncursor PROC STDCALL USES ebx ecx edx esi edi
    LOCAL zoom:SBYTE
    LOCAL ncurx:SDWORD,ncury:SDWORD
; "repositioncursor"
;called from IDM_DUP and IDM_MOVE

	      lea ebx,highlighted ;1st highlighted element.
	      mov eax,[ebx]	    ;/
	      .IF eax==0
	      .ELSE
		mov ebx,eax
		mov al,(OBJECT PTR [ebx]).fconfig
		and al,01
		.IF al==1	;wire.
		  ;position cursor at midpoint of wire...
		  mov eax,(OBJECT PTR [ebx]).xmid
		  mov ncurx,eax
		  mov eax,(OBJECT PTR [ebx]).ymid
		  mov ncury,eax
		.ELSE
		  ;position cursor top/left of element...
		  mov eax,(OBJECT PTR [ebx]).xtopleft
		  mov ncurx,eax
		  mov eax,(OBJECT PTR [ebx]).ytopleft
		  mov ncury,eax
		.ENDIF
		;...these are in logical coords, want screen coords.
		  mov esi,pTERSEDATA
		  mov al,(TERSEDATA PTR [esi]).nzoom
		  mov zoom,al
		  ;correct for zoom-factor...
		  .IF zoom==0
		  .ELSEIF zoom>0
		    mov cl,zoom
		    sar ncurx,cl
		    sar ncury,cl
		  .ELSEIF zoom<0
		    mov cl,zoom
		    neg cl
		    sal ncurx,cl
		    sal ncury,cl
		  .ENDIF

		    ;correct for origin shift...
		    mov eax,clientrect.rc_left
		    sub ncurx,eax
		    mov eax,clientrect.rc_top
		    sub ncury,eax

		  ;...now have client coords.
		  mov eax,ncurx
		  mov newpoint.pt_x,eax
		  mov eax,ncury
		  mov newpoint.pt_y,eax
		  invoke ClientToScreen, g_hwnd,ADDR newpoint
		  .IF eax==0	;failed.
		  .ELSE
		    ;...now have screen coords.
		    mov eax,newpoint.pt_x
		    mov ecx,newpoint.pt_y
		    invoke SetCursorPos, eax,ecx
		  .ENDIF
		    mov nmxold,0  ;track prev mouse pos.
		    mov nmyold,0  ;/
		    ;...wmmousemove() sets deltax/deltay, =0 if
		    ;if these vars are zero.
	      .ENDIF


    ret
repositioncursor ENDP
;------------------------------------------------------------------------
generatecode PROC STDCALL USES ebx ecx edx esi edi
    LOCAL dummy:DWORD
; "generatecode"
;called from File/generate 1-thread code --> IDM_1CODE
;also by mouse-double-click --> xdblclk() on a Make-icon.

	    .IF g_phighlightedobject==0
	      .IF highlightedindex==0
       invoke MessageBox,g_hwnd,ADDR sznotselstart,0,MB_OK+MB_ICONEXCLAMATION
	      .ELSE
		;have selected multiple top-level functions...
		mov edi,highlighted    ;get first in highlighted-list.
		invoke genmanycode,edi ;compose C code.
		 mov highlightedindex,0
		 mov g_fclrhighlighted,1
		jmp mg1
	      .ENDIF
	    .ELSE
	       mov  edi,g_phighlightedobject
	       mov  ax,(OBJECT PTR [edi]).nexttype
	       .IF  ax==00		;normal/iterative node

		 ;the node must be normal-function or ISR-function...
		 mov al,(OBJECT PTR [edi]).nfunctype
		 .IF al==1	    ;normal func., ok
		 .ELSEIF al==2	;isr
		 .ELSEIF al==3	;library func. no good.
		   lea	ebx,szer121
e121:		   invoke MessageBox,g_hwnd,ebx,0,MB_OK+MB_ICONEXCLAMATION
		   jmp SHORT f121	;get out.
		 .ELSEIF al==0	;inline code.
		   lea ebx,szer122
		   jmp e121
		 .ELSE
		 .ENDIF

		 ;force node to display label, not number...
		 and (OBJECT PTR [edi]).fstatus,10111111b ;clr bit6,no displ.#
		 or (OBJECT PTR [edi]).fstatus,00100000b ;set bit5,edisplaylbl.

;201000 i've decided to remove gen1code(). so, put g_phighlightobject
;into highlighted list...
		   invoke add2highlightedlist, edi
		   mov g_phighlightedobject,0
		   mov g_nstate,0
		   invoke genmanycode, edi
;		 mov  fsinglemode,1
;		 invoke gen1code,edi	;generate 1-thread code.
;		 mov  fsinglemode,0

f121:		 invoke add2updatelist, edi	      ;adds object to list.
		 mov highlightedindex,0
		 mov g_fclrhighlighted,1

mg1:		   mov	g_phighlightedobject,0	      ;
		   invoke InvalidateRgn, g_hwnd,0,TRUE	;FALSE
		   mov	g_fredrawdiag,ENTIRE  ;UPDATEobjs
		   mov	g_nstate,0
	       .ELSE
		 ;have highlighted wrong kind of object...
       invoke MessageBox,g_hwnd,ADDR sznotselstart,0,MB_OK+MB_ICONEXCLAMATION
		 invoke add2updatelist, edi	      ;adds object to list.
		 mov  g_phighlightedobject,0	      ;
		 invoke InvalidateRgn, g_hwnd,0,TRUE  ;FALSE
		 mov  g_fredrawdiag,ENTIRE  ;UPDATEobjs
		 mov  g_nstate,0
	       .ENDIF
	    .ENDIF

    ret
generatecode ENDP
;------------------------------------------------------------------------
.DATA
g_hpenwhite5 DWORD 0
g_hpen000 DWORD 0
g_hpen001 DWORD 0
g_hpen010 DWORD 0
g_hpen011 DWORD 0
g_hpen100 DWORD 0
g_hpen101 DWORD 0
g_hpen110 DWORD 0
g_hpen111 DWORD 0

.CODE
wmpaint PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
	LOCAL hdc:DWORD
	LOCAL s3:PAINTSTRUCT
	LOCAL zoom:SBYTE
	LOCAL xradius:SDWORD, yradius:SDWORD
	LOCAL xleft:DWORD,xright:DWORD,ytop:DWORD,ybot:DWORD
;called from WM_PAINT  "wmpaint"
	mov hdc,0
	mov zoom,0
	mov g2_fredrawdiag,0
	
	.IF g_fprintingnow==TRUE	  
	  ret		  
	.ENDIF			  


;check if paint to printer...
;(i'm now printing direct from IDM_PRA)
    .IF g_fprintdiag==0
    .ELSE
      ret
    .ENDIF


;normal paint to screen...
    invoke BeginPaint, g_hwnd,ADDR s3
	mov	hdc, eax

	mov esi,pTERSEDATA
	mov al,(TERSEDATA PTR [esi]).nzoom
	mov zoom,al

;221000
;so, from note on problem below, why not always set zoom=0 if fault...
	.IF g_perrorobject==0
	.ELSE
	  mov (TERSEDATA PTR [esi]).nzoom,0
	  mov zoom,0
	.ENDIF


	.IF zoom==0			    ;"toggle zoom" via IDM_ZOOM
	  invoke GetMapMode, hdc	;retrieves current mapping mode.
	  .IF eax==MM_TEXT          ;MM_TEXT, 1 logical unit = 1 pixel
	  .ELSE                     ; and x incr right, y incr down.
	    invoke SetMapMode, hdc,MM_TEXT
	  .ENDIF
	.ELSE
	  invoke GetMapMode, hdc
	  .IF eax==MM_TEXT
          invoke SetMapMode, hdc,MM_ANISOTROPIC  ;MM_ANISOTROPIC,
          mov  eax,clientrect.rc_right           ; scalable mapping.
          mov  ebx,clientrect.rc_bottom
	      .IF zoom>0
		mov cl,zoom
              sal eax,cl
              sal ebx,cl
	      .ELSE
		mov cl,zoom
		neg cl	  ;only cl part need get changed to +ve.
              sar eax,cl
              sar ebx,cl
	      .ENDIF
	    invoke SetWindowExtEx, hdc,eax,ebx,0  ;new window extent.
          invoke SetViewportExtEx, hdc,clientrect.rc_right,clientrect.rc_bottom,0
	  .ENDIF
	.ENDIF

;shift coordinate origin... uses clientrect as current region...
;(clientrectold is the original region-- and is the physical client coords
; top,left always=0,0 bot,right always = height,width of client)
      mov eax,clientrect.rc_left
	neg eax			      ;aah... weird, but necessary
      mov ebx,clientrect.rc_top
	neg ebx			      ;/
    invoke SetViewportOrgEx, hdc,eax,ebx,0  ;0,0 is now top/left of client.

;if g_perrorobject is non-zero, i want to be sure it's always visible in
;the window...
;don't know why, but this only works if zoom=0 (default zoom)
;(look at isobjectinwindow() to see how to cater for zoom factor)
;221000 ...fixed, see above.
      cmp zoom,0
      jne oke
      mov ebx,g_perrorobject
      cmp ebx,0
      je oke
	mov eax,(OBJECT PTR [ebx]).xmid
	mov ecx,clientrect.rc_left
	.IF SDWORD PTR eax>ecx	;in left side?
	  mov ecx,clientrect.rc_right
	  .IF SDWORD PTR eax<ecx ;in right side?
	    mov eax,(OBJECT PTR [ebx]).ymid
	    mov ecx,clientrect.rc_top
	    .IF SDWORD PTR eax>ecx	;in top side?
	      mov ecx,clientrect.rc_bottom
	      .IF SDWORD PTR eax<ecx
		;success! object is inside window client area
		jmp SHORT oke
	      .ENDIF
	    .ENDIF
	  .ENDIF
	.ENDIF
;fall out here, fail...
	mov eax,clientrect.rc_right
	sub eax,clientrect.rc_left
	sar eax,1
;	.IF SDWORD eax<0
;	  neg eax
;	.ENDIF
	mov xradius,eax
	mov eax,clientrect.rc_bottom
	sub eax,clientrect.rc_top
	sar eax,1
;	.IF SDWORD eax<0
;	  neg eax
;	.ENDIF
	mov yradius,eax
	;now set client area so error-object right in middle...
	mov eax,(OBJECT PTR [ebx]).xmid
	sub eax,xradius
	mov clientrect.rc_left,eax
	mov eax,(OBJECT PTR [ebx]).xmid
	add eax,xradius
	mov clientrect.rc_right,eax
	mov eax,(OBJECT PTR [ebx]).ymid
	sub eax,yradius
	mov clientrect.rc_top,eax
	mov eax,(OBJECT PTR [ebx]).ymid
	add eax,yradius
	mov clientrect.rc_bottom,eax
	mov g_fredrawdiag,ENTIRE
      mov eax,clientrect.rc_left
	neg eax			      ;aah... weird, but necessary
      mov ebx,clientrect.rc_top
	neg ebx			      ;/
    invoke SetViewportOrgEx, hdc,eax,ebx,0  ;0,0 is now top/left of client.
oke:

f12:
;createfont for each size...
;note that xpaint_extras() and xuser()>displaymouse() create their own
;font (szface2 =MS Serif) for the non-client area.

	  mov eax,CURRENT3POINTSIZE
	  neg eax
;	  invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,FIXED_PITCH,ADDR szface
	  mov  g_hfontx1,eax		;11-point courier new.

	mov  eax,CURRENTPOINTSIZE
	neg  eax
;	invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface5 ;2
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface5
	mov  g_hfontx1x,eax		;12-point Times New Roman

;	mov  eax,CURRENT2POINTSIZE
;	shr  eax,1		;/2
;	add  eax,CURRENT2POINTSIZE ;font x1.5
	  mov eax,CURRENT4POINTSIZE ; 12-1-00
	neg  eax
;	invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface6 ;3 ;2
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface6
	mov  g_hfontx1p5,eax
	mov  eax,CURRENT2POINTSIZE
	mov  ebx,2
	mul  ebx 	;font twice standard size.
	neg  eax
;	invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface3
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface3
	mov  g_hfontx2,eax
	mov  eax,CURRENT2POINTSIZE
	mov  ebx,4
	mul  ebx 	;font 4 times standard size.
	neg  eax
;	invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface3
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface3
	mov  g_hfontx4,eax

;let's also create a grey pen...
      invoke CreatePen, PS_SOLID,1,0C0C0C0h	;want 1-wide,grey.
      mov g_hpengrey,eax

;300900
;create a global white wide pen...
      invoke CreatePen, PS_SOLID,7,0FFFFFFh	;want 5-wide,white.
      mov g_hpenwhite5,eax			;...no, 7 wide

;011000
;create 8 color pens, 1-pixel wide (for color coding of rings)...
;(refer paint_*() drawing routine for each element)
      invoke CreatePen, PS_SOLID,1,0000000h	;black.
      mov g_hpen000,eax
      invoke CreatePen, PS_SOLID,1,00000FFh	;red
      mov g_hpen001,eax
      invoke CreatePen, PS_SOLID,1,000FF00h	;green
      mov g_hpen010,eax
      invoke CreatePen, PS_SOLID,1,000C0C0h	;dirty-yellow
      mov g_hpen011,eax
      invoke CreatePen, PS_SOLID,1,0FF0000h	;blue
      mov g_hpen100,eax
      invoke CreatePen, PS_SOLID,1,0FF00FFh	;pink
      mov g_hpen101,eax
      invoke CreatePen, PS_SOLID,1,0FFFF00h	;aqua-blue
      mov g_hpen110,eax
      invoke CreatePen, PS_SOLID,1,0C0C0C0h	;grey
      mov g_hpen111,eax



;  invoke TESTDISPLAY, hdc	;***TEST***

;now for the specific cases...
	.IF g_fprintdiag==0		;non-0 if want to print.
	      .IF g_fredrawdiag==WIPEOUTobjs
		invoke xpaint_wipeout, hdc
	  	  .ELSEIF g_fredrawdiag==UPDATEobjs
		invoke xpaint_update, hdc
	  	  .ELSEIF g_fredrawdiag==ENTIRE
		invoke xpaint_entire, hdc
                invoke xpaint_extras, hdc ;common stuff.
	  	  .ENDIF
	.ELSE	 ;NO LONGER PRINT FROM HERE!!!!!!
        mov	g_fprintingnow,TRUE     
	  mov  g_fredrawdiag,ENTIRE    
	  invoke xpaint_print      
      invoke PostMessage, g_hwnd,WM_USER+4+100h,0,0  ;delay repaint.
	  mov g_fprintingnow,FALSE   
	.ENDIF

;delete the fonts created at start of this proc...
	invoke DeleteObject,g_hfontx1x
	invoke DeleteObject,g_hfontx1
	invoke DeleteObject,g_hfontx1p5
	invoke DeleteObject,g_hfontx2
	invoke DeleteObject,g_hfontx4
	invoke DeleteObject,g_hpengrey
	invoke DeleteObject,g_hpenwhite5
	invoke DeleteObject,g_hpen000
	invoke DeleteObject,g_hpen001
	invoke DeleteObject,g_hpen010
	invoke DeleteObject,g_hpen011
	invoke DeleteObject,g_hpen100
	invoke DeleteObject,g_hpen101
	invoke DeleteObject,g_hpen110
	invoke DeleteObject,g_hpen111
	mov g_hfontx1x,0
	mov g_hfontx1,0
	mov g_hfontx1p5,0
	mov g_hfontx2,0
	mov g_hfontx4,0
	mov g_hpengrey,0
	mov g_hpenwhite5,0
	mov g_hpen000,0
	mov g_hpen001,0
	mov g_hpen010,0
	mov g_hpen011,0
	mov g_hpen100,0
	mov g_hpen101,0
	mov g_hpen110,0
	mov g_hpen111,0


    invoke EndPaint, g_hwnd,ADDR s3

    mov al,g2_fredrawdiag
    .IF al==0
      mov g_fredrawdiag,0
    .ELSE
      mov g_fredrawdiag,al  ;some paint_*() funcs want to redraw certain
      invoke InvalidateRgn, g_hwnd,0,FALSE
	;elements.
    .ENDIF

    ret
wmpaint ENDP
;------------------------------------------------------------------------
xpaint_wipeout PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD
	LOCAL dummy:BYTE
	LOCAL hbrushold:DWORD
	LOCAL hbrushgreen:DWORD
	LOCAL holdtextfont:DWORD
	LOCAL hpencolor:DWORD
	LOCAL hpenold:DWORD
	LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD,ebxsave:DWORD
	LOCAL xleft:DWORD,xright:DWORD,ytop:DWORD,ybot:DWORD
;redraws all objects in wipeouts objects database.   "xpaint_wipeout"
;basically, same as xpaint_update(), except draws pen/text/brush white.

	mov hbrushold,0
	mov hbrushgreen,0
	mov holdtextfont,0
	mov hpencolor,0
	mov hpenold,0

	  ;colour for filling polygons....
	    invoke GetStockObject, WHITE_BRUSH
	   mov hbrushgreen,eax
	    invoke SelectObject, hdc,hbrushgreen
	   mov hbrushold,eax

	invoke SetBkMode, hdc, TRANSPARENT   ;leave background showing.
	invoke SetTextColor, hdc,00FFFFFFh  ;white.

;also want a white pen...
;	invoke GetStockObject, WHITE_PEN
	invoke CreatePen, PS_SOLID,3,0FFFFFFh	;3-units wide,white.
	mov hpencolor,eax
	invoke SelectObject, hdc, hpencolor
	mov hpenold,eax


	      ;191100
	      ;draw selection-rectangle...
	      .IF g_nstate==22	;mousemove while drawing rectangle.
		;find which corner is top-left, which bot-right...
		mov eax,n1stx
		mov ebx,n2ndx
		.IF SDWORD PTR eax<ebx
		  mov xleft,eax
		  mov eax,n2ndx
		  mov xright,eax
		.ELSE
		  mov xright,eax
		  mov eax,n2ndx
		  mov xleft,eax
		.ENDIF
		mov eax,n1sty
		mov ebx,n2ndy
		.IF SDWORD PTR eax<ebx
		  mov ytop,eax
		  mov eax,n2ndy
		  mov ybot,eax
		.ELSE
		  mov ybot,eax
		  mov eax,n2ndy
		  mov ytop,eax
		.ENDIF
		invoke Rectangle, hdc,xleft,ytop,xright,ybot
	      .ENDIF




;redraw only from wipeouts list...
        mov ebx,wipeoutsindex     ;pts to next free entry.
        lea esi,wipeouts
        shl ebx,1                ;convert index to relative-offset
	  shl ebx,1			; / 4 bytes per entry
end2:   cmp ebx,0
        je  end1                ;nothing/nothing-more to wipeout, get out.
        dec ebx
        dec ebx
	  dec ebx
	  dec ebx
        mov edi,[esi+ebx]          ;get an object
        cmp edi,0			;precaution.
        je  end2                ;invalid object
	  ;drop here if found an object, edi->object.

nextobj:
;here down to "end common code" is *almost* same in xpaint_entire().
;(and pretty much same in xpaint_print())
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	mov ebxsave,ebx
	;code in here uses esi->object, so...
	mov esi,edi
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	mov ax,(OBJECT PTR [esi]).nexttype
        .IF ax==-1
	    .ELSE		;not a data object.
		  ;chose a font size...
		xor eax,eax
		mov	al,(OBJECT PTR [esi]).fstatus
	        and	al,011000b	;test for bits3/4.
	        .IF	al==0
		    ;assign the standard font to DC. 
		    invoke SelectObject, hdc,g_hfontx1
	        .ELSEIF al==001000b	;1.5 times font.
	          invoke SelectObject,hdc,g_hfontx1p5
	        .ELSEIF al==010000b	;2 times font.
	          invoke SelectObject,hdc,g_hfontx2
	        .ELSEIF al==011000b	;4 times font.
	          invoke SelectObject,hdc,g_hfontx4
		  .ENDIF
	        mov  holdtextfont,eax
;finally, call the method to display object...
	          mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
		  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdc,esi
	        invoke SelectObject, hdc,holdtextfont	;restore original.
	    .ENDIF
	  .ENDIF
	mov ebx,ebxsave
	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
;end common code.


      jmp end2			;get next object from updates database.
end1: mov wipeoutsindex,0      ;buffer now empty.

	invoke SelectObject, hdc, hpenold	;restore old pen.
	invoke DeleteObject, hpencolor
	invoke SelectObject, hdc, hbrushold	;restore old brush.
      invoke DeleteObject, hbrushgreen


	ret
xpaint_wipeout ENDP
;------------------------------------------------------------------------
xpaint_update PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD
	LOCAL dummy:BYTE
	LOCAL hbrushold:DWORD
	LOCAL hbrushdefault:DWORD
	LOCAL holdtextfont:DWORD
	LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD,ebxsave:DWORD
	LOCAL hbrushnewcolor:DWORD, hbrusholdcolor:DWORD
;redraws all objects in updateobjects database.
;basically, same as xpaint_entire(), except doesn't loop thru all
;of OBJECTS database, only goes thru updates database.

;there is a problem. xpaint_entire() paints objects in order in which
;they are in the OBJECTS database, from beginning. Therefore wires
;will always paint after a node to which they are attached.
;nearobjects() scans the database, inserting objects into update list
;again in forward order, BUT xpaint_update paints in reverse, working
;back from the end of the list. it would seem best to change
;xpaint_update... (ok, it's done)
;note that xpaint_wipeout works back also, but that's actually desirable.

	mov hbrushold,0
	mov hbrushdefault,0
	mov holdtextfont,0
	mov hbrushnewcolor,0
	mov hbrusholdcolor,0

	  ;default colour for filling polygons....
	    invoke GetStockObject, NULL_BRUSH
	  mov hbrushdefault,eax
	    invoke SelectObject, hdc,hbrushdefault
          mov hbrushold,eax

	invoke SetBkMode, hdc, TRANSPARENT   ;leave background showing.
;	invoke SetTextColor, hdc, 000000FFh ;full-bright 7Fh  ;red,half-bright.

;redraw only from update list...
  mov ebx,0  ;start from first item in list.
  lea esi,updates
end2:
  mov eax,updatesindex	;index of next free entry.
  shl eax,1		;convert index to relative offset (4bytes/entry)
  shl eax,1		;/
  cmp ebx,eax
  je  end1		;nothing more to update, getout.
  mov edi,[esi+ebx]	   ;get an object
  cmp edi,0			;precaution.
  je	end2b	       ;invalid object
  ;drop here if found an object, edi->object.

nextobj:
;here down to "end common code" is *almost* same in xpaint_entire().
;(and pretty much same in xpaint_print())
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	mov ebxsave,ebx
	;code in here uses esi->object, so...
	mov esi,edi
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	mov ax,(OBJECT PTR [esi]).nexttype
        .IF ax==-1
	    .ELSE		;not a data object.
		  ;chose a font size...
		xor eax,eax
		mov	al,(OBJECT PTR [esi]).fstatus
	        and	al,011000b	;test for bits3/4.
	        .IF	al==0
		    ;assign the standard font to DC. 
		    invoke SelectObject, hdc,g_hfontx1
	        .ELSEIF al==001000b	;1.5 times font.
	          invoke SelectObject,hdc,g_hfontx1p5
	        .ELSEIF al==010000b	;2 times font.
	          invoke SelectObject,hdc,g_hfontx2
	        .ELSEIF al==011000b	;4 times font.
	          invoke SelectObject,hdc,g_hfontx4
		  .ENDIF
		mov  holdtextfont,eax

;		    ;chose a new brush, maybe...
;		    mov al,(OBJECT PTR [esi]).fconfig
;		    and al,0100b    ;bit2=1 turn on colour.
;		    .IF al==0100b
;		      mov eax,(OBJECT PTR [esi]).ncolour1
;		      invoke CreateSolidBrush, eax
;		      mov hbrushnewcolor,eax
;		      invoke SelectObject, hdc,hbrushnewcolor
;		      mov hbrusholdcolor,eax
;		    .ENDIF

;finally, call the method to display object...
	          mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
		  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdc,esi

		invoke SelectObject, hdc,holdtextfont	;restore original.
;		  ;and restore default brush...
;		    mov al,(OBJECT PTR [esi]).fconfig
;		    and al,0100b    ;bit2=1 turn on colour.
;		    .IF al==0100b
;		      invoke SelectObject, hdc, hbrusholdcolor
;		      invoke DeleteObject, hbrushnewcolor
;		    .ENDIF

	    .ENDIF
	  .ENDIF
	mov ebx,ebxsave
	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
;end common code.

end2b:
  add ebx,4
  jmp end2			;get next object from updates database.
end1: mov updatesindex,0      ;buffer now empty.

	invoke SelectObject, hdc, hbrushold	;restore old brush.
      invoke DeleteObject, hbrushdefault

	ret
xpaint_update ENDP
;------------------------------------------------------------------------
.CODE
xpaint_entire PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD
	LOCAL dummy:BYTE
	LOCAL hbrushold:DWORD
	LOCAL hbrushdefault:DWORD
	LOCAL holdtextfont:DWORD
	LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD,ebxsave:DWORD
	LOCAL hbrushnewcolor:DWORD, hbrusholdcolor:DWORD
	LOCAL xleft:DWORD,xright:DWORD,ytop:DWORD,ybot:DWORD
;redraws all objects within screen boundaries.	 "xpaint_entire"
;this is a large function, so for now, i'll just have the basic loop...
;***NOTE***

	mov hbrushold,0
	mov hbrushdefault,0
	mov holdtextfont,0
	mov hbrushnewcolor,0
	mov hbrusholdcolor,0

;default colour for filling polygons....
	    invoke GetStockObject, NULL_BRUSH
	   mov hbrushdefault,eax
	    invoke SelectObject, hdc,hbrushdefault
	   mov hbrushold,eax

	invoke SetBkMode, hdc, TRANSPARENT   ;leave background showing.
;	invoke SetTextColor, hdc, 000000FFh ;full-bright 7Fh  ;red,half-bright.


	      ;191100
	      ;draw selection-rectangle...
	      .IF g_nstate==22	;mousemove while drawing rectangle.
		;find which corner is top-left, which bot-right...
		mov eax,n1stx
		mov ebx,n2ndx
		.IF SDWORD PTR eax<ebx
		  mov xleft,eax
		  mov eax,n2ndx
		  mov xright,eax
		.ELSE
		  mov xright,eax
		  mov eax,n2ndx
		  mov xleft,eax
		.ENDIF
		mov eax,n1sty
		mov ebx,n2ndy
		.IF SDWORD PTR eax<ebx
		  mov ytop,eax
		  mov eax,n2ndy
		  mov ybot,eax
		.ELSE
		  mov ybot,eax
		  mov eax,n2ndy
		  mov ytop,eax
		.ENDIF
		invoke Rectangle, hdc,xleft,ytop,xright,ybot
	      .ENDIF



 mov updatesindex,0
 mov wipeoutsindex,0

	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0	;empty database.
	    jmp	nextobjy
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	mov ax,(OBJECT PTR [esi]).nexttype
        .IF ax==-1
	    .ELSE		;not a data object.

	  mov al,(TERSEDATA PTR [edi]).fgooseeprefs
	  and al,01000b ;bit3=1 disable intelligent window paint.
	  .IF al==0
	   invoke isobjectinwindow, esi	;return TRUE if yes.
	  .ELSE
	    mov eax,TRUE    ;redraw every element in diagram.
	  .ENDIF

		.IF eax==TRUE
		  ;chose a font size...
		  xor eax,eax
		  mov	al,(OBJECT PTR [esi]).fstatus
		  and	al,011000b	;test for bits3/4.
		  .IF	al==0
		    ;assign the standard font to DC. 
def1:		    invoke SelectObject, hdc,g_hfontx1
		  .ELSEIF al==001000b	;1.5 times font.
		    invoke SelectObject,hdc,g_hfontx1p5
		  .ELSEIF al==010000b	;2 times font.
		    invoke SelectObject,hdc,g_hfontx2
		  .ELSEIF al==011000b	;4 times font.
		    invoke SelectObject,hdc,g_hfontx4
		  .ENDIF
		  mov  holdtextfont,eax

;		    ;chose a new brush, maybe...
;		    mov al,(OBJECT PTR [esi]).fconfig
;		    and al,0100b    ;bit2=1 turn on colour.
;		    .IF al==0100b
;		      mov eax,(OBJECT PTR [esi]).ncolour1
;		      invoke CreateSolidBrush, eax
;		      mov hbrushnewcolor,eax
;		      invoke SelectObject, hdc,hbrushnewcolor
;		      mov hbrusholdcolor,eax
;		    .ENDIF

;finally, call the method to display object...
	          mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
		  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdc,esi

		  invoke SelectObject, hdc,holdtextfont	;restore original.
;		  ;and restore default brush...
;		    mov al,(OBJECT PTR [esi]).fconfig
;		    and al,0100b    ;bit2=1 turn on colour.
;		    .IF al==0100b
;		      invoke SelectObject, hdc, hbrusholdcolor
;		      invoke DeleteObject, hbrushnewcolor
;		    .ENDIF

		.ENDIF
	    .ENDIF
	  .ENDIF
	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop nextobjx
    jmp  SHORT nextobjy
nextobjx: jmp nextobj
nextobjy:

	    invoke SelectObject, hdc, hbrushold	;restore old brush.
	  invoke DeleteObject, hbrushdefault

  ret
xpaint_entire ENDP
;------------------------------------------------------------------------
.DATA
mousexold DWORD 0
mouseyold DWORD 0
mousexolder DWORD 0
mouseyolder DWORD 0
fbumping  BYTE 0

.CODE
origincorrection PROC STDCALL USES ebx ecx edx esi edi, lparam:DWORD
    LOCAL zoom:SBYTE
; "origincorrection"
;mouse coords have origin at top/left of client area of window.
;they need to be corrected if origin is moved or zoom not 0.
;corrected mouse coords are saved in g_mousex and g_mousey.

	mov esi,pTERSEDATA
	mov al,(TERSEDATA PTR [esi]).nzoom
	mov zoom,al

;save the previous g_nmousex/g_nmousey...
	.IF fbumping==0
      mov  eax,mousexold
      mov  mousexolder,eax
      mov  eax,mouseyold
      mov  mouseyolder,eax
      mov  eax,g_nmousex
      mov  mousexold,eax
      mov  eax,g_nmousey
      mov  mouseyold,eax
	.ELSE		       ;refuse to move mouse, if have bumped a
	  .IF g_nstate==8			;only relevant if dragging...
       mov  eax,mousexold
       mov  g_nmousex,eax    ;(see dragchilddiag).
	   mov	WORD PTR lparam,ax
       mov  eax,mousexolder  ;comp/super up against another.
       mov  mousexold,eax
       mov  eax,mouseyold
       mov  g_nmousey,eax
	   mov	WORD PTR lparam+2,ax
       mov  eax,mouseyolder
       mov  mouseyold,eax
	   ret
	  .ENDIF
	.ENDIF

;all mouse messages need to be corrected, if the screen is shifted.
        mov eax,clientrect.rc_left  ;this is the correction.
        mov ebx,clientrect.rc_top   ;/
          push eax              ;convert 16 to 32 bit.
          mov ax,WORD PTR lparam  ;/      ;mouse x
          cwde                  ;/
          mov ecx,eax           ;/
          pop eax               ;/
          push eax              ;convert 16 to 32 bit.
          mov ax,WORD PTR lparam+2  ;/      ;mouse y
          cwde                  ;/
          mov edx,eax           ;/
          pop eax               ;/
        add ecx,eax
        add edx,ebx
        mov g_nmousex,ecx            ;save
        mov g_nmousey,edx                   ;/

	  .IF zoom==0
	  .ELSEIF zoom>0
	    mov cl,zoom
	    sal g_nmousex,cl
	    sal g_nmousey,cl
	  .ELSEIF zoom<0
	    mov cl,zoom
	    neg cl
	    sar g_nmousex,cl
	    sar g_nmousey,cl
	  .ENDIF

	ret
origincorrection ENDP
;------------------------------------------------------------------------
.DATA
szerper3  BYTE "The destination-end of a wire must "
	  BYTE "be on a node (ALL types of wires must end on a "
	  BYTE "node). When first placing a hardware/data wire, "
	  BYTE "move mouse over "
	  BYTE "a data/hardware element and drag to a node. "
	  BYTE "When placing an execution-flow wire, it must "
	  BYTE "start from a node and also end on a node.",0
.CODE
wmlbuttonup PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL plock:DWORD
;comes via WM_LBUTTONUP    "wmlbuttonup"

;duplicatehighlighted() created new duplicate elements, and
;wmmousemove()/updateduplicates() is causing them to track
;the mouse. Freeze them in-place now...
    mov highlightedindexnewlist,0 ;remove all from highlightednewlist.

;;when moving a highlighted elements, fmovinghighlighted=1.
;;clear it now...
;    .IF fmovinghighlighted==0
;    .ELSE
;      mov highlightedindex,0	;remove selected elements.
;      mov g_fclrhighlighted,1	;wmpaint will clr .fconfig2/bit7.
;      mov fmovinghighlighted,0
;    .ENDIF

;lparam has mouse coords...x=low-word,y=hi-word (client coords)
	invoke  origincorrection, lparam 
		;returns corrected coords in g_nmousex & g_nmousey
	  ;i'll correct lparam as well, cos old goofee code expected it...
	  ;wmmousemove()>WM_USER>xuser() does.
	  mov eax,g_nmousex
	  mov WORD PTR lparam,ax
	  mov eax,g_nmousey
	  mov WORD PTR lparam+2,ax

	mov g_naccelx,0 ;this is acceleration during scrolling.=0notscrolling
	mov g_naccely,0    ;..precaution, as scrolling() does clr it when done.
	mov  ctrlkey,0	 ;set if control-key held down, mouse on a node.


	;231100
	;if moving a group of elements, buttonup must terminate it...
	.IF fmovinghighlighted==1
	    ;this flag allows display multiple highlighted when 0...
	    mov g_fclrhighlighted,1  ;wmpaint() will clr fconfig2/bit7.
	    mov	g_phighlightedobject,0
	    mov highlightedindex,0
	    mov g_nstate,0
	    mov fmovinghighlighted,0
	    invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background.
	    mov g_fredrawdiag,ENTIRE
	.ENDIF

	;if duplicating a group of elements, buttonup must terminate it...
	.IF highlightedindexnewlist==0
	.ELSE
	    mov g_fclrhighlighted,1  ;wmpaint() will clr fconfig2/bit7.
	    mov	g_phighlightedobject,0
	    mov highlightedindex,0   ;precaution.
	    mov g_nstate,0
	    mov fmovinghighlighted,0 ;precaution.
	    mov highlightedindexnewlist,0
	    invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background.
	    mov g_fredrawdiag,ENTIRE
	.ENDIF

	.IF g_nstate==0		;normal state at startup & during operation.
	  nop

      .ELSEIF g_nstate==1	 ;a prior lbuttondn has selected an obj.
                                ;...can only come here from state-0.
				;g_pselectedobjectnew=object selected.
	  .IF g_pselectedobjectnew==0  ;precaution. maybe redundant.
	    mov g_nstate,0		;/
	  .ELSE
	    mov g_nstate,2
;		;181000 ...save previous highlighted (if any)...
;		mov eax,g_phighlightedobject
;		mov g_phighlightedobjectprev,eax
	    mov ebx,g_pselectedobjectnew ;done by lbuttondoen(& mouse not moved)
	      mov g_phighlightedobject,ebx	 ;make highlighted.
	      mov g_pselectedobjectnew,0
	      invoke add2updatelist, g_phighlightedobject
	    ;this flag allows multiple highlighted when 0...
	    mov g_fclrhighlighted,0
	    ;if <shift> key held down, we are selecting multiple
	    ;highlighted elements...
	    invoke GetAsyncKeyState, VK_SHIFT
	    and ax,8000h	;bit15=1 if key pressed.
	    .IF ax==8000h
	      mov ebx,g_phighlightedobject
	      or (OBJECT PTR [ebx]).fconfig2,10000000b ;set bit7.
	      invoke add2highlightedlist,ebx
	      mov g_nstate,0 ;back to state0 so can make more selections.
	      mov g_phighlightedobject,0 ;cos we're in state0.
	      ;...only use g_phighlightedobject for a single highlighted
	      ;element.
	    .ENDIF
	      invoke InvalidateRgn, g_hwnd,0,FALSE ;inval.,not erase bkgrnd
	      mov  g_fredrawdiag,UPDATEobjs
          .ENDIF

      .ELSEIF g_nstate==2	 ;no mousemove, an lbuttonup, confirms
                                ;...this state, an obj is highlighted.
                                ;...can only come here from state-1.
				;g_pselectedobject=object selected.

      .ELSEIF g_nstate==4	 ;a new object is being placed, first "end".
                                ;...can only come here from state-0.
          ;error...
	  mov g_nstate,0	   ;precaution. maybe redundant.
          mov esi,g_pmovingobject  ;/
          mov (OBJECT PTR [esi]).fstatus,0  ;/
          mov g_pmovingobject,0   ;/

      .ELSEIF g_nstate==5	 ;a new obj is being placed, second "end".
				;...can only come here from state-4.

;	;if i've created a new resource, previously paint_res() and
;	;paint_hard() drew a straight line to the parent node.
;	;however, i've decided to auto-create a dataflow wire to do
;	;this job. wmlbuttondown()/state4 saved mouse coords in
;	;nmousex_save/nmousey_save. so, create the wire...
;	mov esi,g_pmovingobject
;	mov ax,(OBJECT PTR [esi]).nexttype
;	.IF ax==3
;	  jmp SHORT mm1
;	.ELSEIF ax==4
;	  jmp SHORT mm1
;	.ELSEIF ax==50
;	  jmp SHORT mm1
;	.ELSEIF ax==51
;mm1:	  invoke createdatawire, esi
;	.ENDIF

;really only applies to wires, but if lbuttonup on an existing node,
;set rplock2 pointing to parent...
;note onanobject() excludes g_pmovingobject from search...
	  invoke onanobject, g_nmousex,g_nmousey
	  ;return with eax=0 fail, else eax pts to found object.
	  mov plock,eax
	    .IF eax==0
	      ;error if a wire-type...
	      mov esi,g_pmovingobject
	      mov al,(OBJECT PTR [esi]).fconfig
	      and al,01   ;bit0=1 if a wire type.
	      .IF al==1
		lea eax,szerper
per1:		    invoke MessageBox, g_hwnd, eax,\
			 0, MB_OK+MB_ICONEXCLAMATION
per8:		    invoke add2wipeoutlist,g_pmovingobject
		    mov g_fredrawdiag,WIPEOUTobjs
		    invoke InvalidateRgn, g_hwnd,0,FALSE
		    ;have to do an immediate paint cos paint funcs
		    ;won't paint an invalid object...
		    invoke UpdateWindow,g_hwnd
		      ;invoke nearobjects,g_pmovingobject ;experiment
		      ;	;...adds nearby objects to updatelist.
		    mov g_fredrawdiag,ENTIRE ;UPDATEobjs
		    invoke InvalidateRgn, g_hwnd,0,FALSE
		    mov (OBJECT PTR [esi]).fstatus,0 ;delete the wire.
		    mov g_pmovingobject,0
		    mov poldmovingobject,0
		    mov g_nstate,0
		    ret
	      .ENDIF
	    .ELSE

	      ;i want to exclude non-wire objs from setting rplock2...
	      mov esi,g_pmovingobject	;new object.
	      mov edi,plock		;parent object.
		;firstly wipeout current position of child obj...
		invoke add2wipeoutlist, g_pmovingobject
		invoke InvalidateRgn, g_hwnd,0,FALSE
		mov  g_fredrawdiag,WIPEOUTobjs
		push edi
		push esi
		invoke UpdateWindow, g_hwnd		;wipe immediately.
		pop  esi
		pop  edi
	      mov bl,(OBJECT PTR [esi]).fconfig
	      and bl,01	   ;bit0=1 if a wire-type object.
	      .IF bl==01

		;dataflow wires must end on a node...
		;in fact, ALL wires must end on a node...
		mov ax,(OBJECT PTR [esi]).nexttype
		.IF ax==15   ;default dataflow wire
per2:		  mov ax,(OBJECT PTR [edi]).nexttype ;parent.
		  .IF ax==0   ;node
		  .ELSE
		    lea eax,szerper3
		    jmp per1	;error.
		  .ENDIF
		.ELSEIF ax==10	;sync 1-way execution-flow wire.
		  jmp per2
		.ELSEIF ax==11	;sync 2-way
		  jmp per2
		.ELSEIF ax==12	;+timeout
		  jmp per2
		.ELSEIF ax==13	;async 1-way
		  jmp per2
		.ELSEIF ax==14	;async 2-way
		  jmp per2
		.ELSEIF ax==22	;mutual-exc.
		  jmp per2
		.ENDIF

			    ;ALL OBJECT PTRS RELATIVE TO START TERSEDATA...
			    ;assuming edi has value to be written...
			    mov  eax,edi
			    sub eax,pTERSEDATA
		mov (OBJECT PTR [esi]).rplock2,eax ;lock child to parent.
			    mov eax,edi
		;if both ends of wire in same parent, need to auto-
		;shift xmid/ymid outside of parent obj...
		mov ebx,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO START TERSEDATA...
			    ;assuming ebx has value to be written...
			    .IF ebx==0
			    .ELSE
			      add ebx,pTERSEDATA
			    .ENDIF
		.IF ebx==eax
		  invoke fixwiremid, edi,esi ;parent-obj,pnew-obj
		  ;a problem below, UpdateWindow() causes paint_arc()
		  ;which draws wire-mid overriding what we did in fixwiremid()
		  ;cos we're in state 5.
		  ;so, can we just get back to state 0...
		  mov g_nstate,0
		  mov g_pmovingobject,0
		  ;WARNING don't use g_pmovingobject below, use esi.
		.ENDIF

	  mov g_nstate,0	  ;051000
	  mov g_pmovingobject,0   ;/
		;if we've just placed a new wire, do some basic
		;syntax checking...
		;uh-huh! newwire.nendring isn't set until paint_arc()
		;executes, as it's computed dynamicallybased on the
		;end coords. wiresyntaxcheck0() needs it though.
		;so, do a quick paint...
		mov g_fredrawdiag,UPDATEobjs
		invoke add2updatelist,esi
		invoke InvalidateRgn, g_hwnd,0,FALSE
		invoke UpdateWindow, g_hwnd
		;now do syntax check...
		invoke wiresyntaxcheck0, esi
		.IF eax==-1
		  jmp per8	;delete wire.
		.ENDIF
		;have problem with some objects getting wiped...
		;this adds nearby objects to update list...
		invoke nearobjects,esi

	      .ELSE
		;it's a non-wire new obj and i've released button
		;while still inside parent obj. this is a problem.
		;i need to auto-relocate the new obj outside parent...
		invoke fixnewchild, edi,esi
	      .ENDIF
	      invoke add2updatelist, esi ;g_pmovingobject
	      invoke InvalidateRgn, g_hwnd,0,FALSE
	      mov  g_fredrawdiag,UPDATEobjs
	    .ENDIF
	  mov g_nstate,0
	  mov g_pmovingobject,0


      .ELSEIF g_nstate==8	 ;an object (not new) is being moved.
	  mov g_nstate,0	   ;...can only come here from state-1.

	  ;if use was moving a wire-end, will have g_nknee=4/5.
	  ;may have changed which ring wire is on, so do a syntax
	  ;check...
	  mov ebx,g_pmovingobject
	  mov al,(OBJECT PTR [ebx]).fconfig
	  and al,01
	  .IF al==01	    ;wire-type
	    .IF g_nknee==4
gn1:	      invoke wiresyntaxcheck0, g_pmovingobject
	      .IF eax==-1
		mov eax,g_pmovingobject
		mov g_perrorobject,eax	;highlights it when painted.
	      .ENDIF
	    .ELSEIF g_nknee==5
	      jmp gn1
	    .ENDIF
	  .ENDIF

	  mov g_pmovingobject,0	;g_pmovingobject=object being moved.
          ;...lbuttonup stops the object moving.
	   invoke InvalidateRgn, g_hwnd,0,FALSE  ;invalidate entire window.
	   mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  mov  fbumping,0	;see origincorrection & dragchilddiag.

	.ELSEIF g_nstate==10	;have repositioned begin-end of a wire.
	  mov  esi,g_phighlightedobject

;***NOTE*** USING state8 for wire-end repositioning, with g_nknee=4/5.

	  mov  g_nstate,0
	  mov  g_phighlightedobject,0
	  invoke InvalidateRgn, g_hwnd,0,TRUE
	  mov g_fredrawdiag,ENTIRE


	.ELSEIF g_nstate==21
	  ;have placed 1st corner of selection-rectangle, but
	  ;haven't moved mouse, so invalid..
	    ;restore normal class cursor...
	    invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
	    ;invoke SetCursor,g_hnormcursor ;restore cursor.
	  mov n1stx,0
	  mov n1sty,0
	  mov n2ndx,0
	  mov n2ndy,0
	  mov g_nstate,0


	.ELSEIF g_nstate==22
	    ;restore normal class cursor...
	    invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
	    ;invoke SetCursor,g_hnormcursor ;restore cursor.
	  ;set 2nd corner of selection rectangle...
	  mov eax,g_nmousex
	  mov n2ndx,eax
	  mov eax,g_nmousey
	  mov n2ndy,eax
	  mov g_nstate,0
	    ;this flag allows display multiple highlighted when 0...
	    mov g_fclrhighlighted,0
	  ;now, have to find all elements inside rectangle and
	  ;highlight them...
      pushad                       ;precaution, func now in C.
	  invoke highlightinsiderect      ;NOW IN GOOSEE_C.C
      popad                        ;/
	    mov	g_phighlightedobject,0
	    invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background.
	    mov g_fredrawdiag,ENTIRE


	.ELSE
	  mov g_nstate,0	     ;error, default back to state 0.
	  mov g_pmovingobject,0
	  mov g_pselectedobjectnew,0
	  mov g_phighlightedobject,0
	.ENDIF

	ret
wmlbuttonup ENDP
;------------------------------------------------------------------------
.DATA
n1stx DWORD 0	    ;selection rectangle.
n1sty DWORD 0	    ;/
n2ndx DWORD 0	    ;/
n2ndy DWORD 0	    ;/
nmousex_save	DWORD 0
nmousey_save	DWORD 0
szerdf1   BYTE "Placing of new data/hardware wires has a restriction. "
	  BYTE "The first end must be on a data or hardware element, "
	  BYTE "and the destination end on a node. Try again.",0
szerper   BYTE "Both ends of a wire must be placed on a node or "
	  BYTE "data/hardware element. After selecting a new wire "
	  BYTE "from the menu, move the mouse cursor over an existing "
	  BYTE "element on the diagram, press the left mouse button, "
	  BYTE "and drag to place the second end over another element.",0
szernp1   BYTE "An execution-flow wire must start and end on a node. "
	  BYTE "After selecting it from the menu, move mouse cursor over "
	  BYTE "a node, press the left mouse button, and drag "
	  BYTE "destination-end of wire onto another node, then release "
	  BYTE "the button.",0
szernn1   BYTE "A new data element can only be owned by a node "
	  BYTE "or a reference-type data element (pointer, structure, "
	  BYTE "array). A hardware-interface element can only be owned by a "
	  BYTE "node. Try again.",0
szdefname BYTE "fnc",0
szerdh6   BYTE "The only elements that are allowed to be placed ""free"" on "
	  BYTE "the diagram are the Node, the Comment, and the ""icons"". All other elements must be "
	  BYTE """owned"" (and are referred to as ""child"" elements). "
	  BYTE "To place a new child element after selection from menu, "
	  BYTE "move the mouse cursor over an existing element, "
	  BYTE "press the left mouse button and drag to where the new element "
	  BYTE "is desired to be located.",0
szerwd	  BYTE "When a data/hardware element is first placed, it is owned "
	  BYTE "by a node. Later, you can draw data/hardware wires to "
	  BYTE "connect the data/hardware element to other nodes, but this "
	  BYTE "can only be done with shareable data/hardware elements. "
	  BYTE "Go into the data/hardware dialog box (right-click with "
	  BYTE "mouse) and configure it as shareable.",0
szerch5   BYTE "A child-node (clone) can only be a child of another node, "
	  BYTE "or a pointer-data-element. "
	  BYTE "After selecting menu ""Element/Node"", move mouse cursor "
	  BYTE "over an existing node (or pointer-data-element) and drag to where the new child-node "
	  BYTE "is desired to be located.",0
szerlfc1  BYTE "A library-function node must be standalone, i.e., it is "
	  BYTE "not allowed to have any attached children.",0
;szer151   BYTE "The clone that you have attached a data/hardware resource "
;	  BYTE "to is a child of an external node. Therefore, it has not "
;	  BYTE "got code inside it and cannot have attached data/hardware. "
;	  BYTE 0
szer171a  BYTE "A pointer-data-element and an array-data-element can only "
	  BYTE "have one child-data-element attached directly, though they "
	  BYTE "can be chained. The reason is that the child-element "
	  BYTE "defines the datatype of the parent reference-element, so "
	  BYTE "can only be singular. Structures are an exception, as "
	  BYTE "multiple children directly attached are the various "
	  BYTE "elements of the structure.",0Dh,0Ah
	  BYTE "GOOSEE is now deleting the new element.",0
szer17v   BYTE "You have tried to attach a node to a datatype-node, "
	  BYTE "which is not allowed. A datatype-node is a child of a "
	  BYTE "data pointer, used to designate a pointer to a function. "
	  BYTE "The datatype-node is not a function though, and cannot have "
	  BYTE "anything attached to it.",0
szer7200  BYTE "Don't do that. If you want a pointer-to-an-array, don't "
	  BYTE "attach an array element to a pointer element. Instead, "
	  BYTE "attach an element of the datatype of the cells of the "
	  BYTE "array.",0Dh,0Ah
	  BYTE "That is, for an array of simple (primitive) datatypes, "
	  BYTE "attach a ""simple variable"" element to the pointer. "
	  BYTE "For an array of structures, attach a ""structure"" "
	  BYTE "element to the pointer. For an array of pointers to "
	  BYTE "some datatype, attach a pointer then a datatype element. "
	  BYTE "In the case of an array of pointers to functions, "
	  BYTE "attach a pointer to the pointer, then a node. In other "
	  BYTE "words, the array element is simply left out.",0Dh,0Ah
	  BYTE "Note also that data elements must always be cascaded or "
	  BYTE "chained -- only the structure template will allow more "
	  BYTE "than one data element to be directly attached to it.",0
szer7200b BYTE "No, you can't do that. You have tried to attach a data "
	  BYTE "element to a structure element, however that is not "
	  BYTE "allowed in this context. The only situation in which "
	  BYTE "you would be allowed to attach data elements to a "
	  BYTE "structure is when the structure is a template. In the "
	  BYTE "current situation however, the structure is the datatype "
	  BYTE "specifier (i.e., the child) for another data element "
	  BYTE "and must have a predefined structure type, selected "
	  BYTE "inside its own dialog box.",0
szerg	  BYTE "A generic-data element can only attach to a node, and "
	  BYTE "the node must be a function, not in-line code.",0

.CODE
wmlbuttondown PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL plock:DWORD
    LOCAL xend:DWORD, yend:DWORD
;comes via WM_LBUTTONDOWN msg.	 "wmlbuttondown"

;lparam has mouse coords...x=low-word,y=hi-word
	invoke  origincorrection, lparam 
		;returns corrected in g_nmousex & g_nmousey
	  ;i'll correct lparam as well, cos old goofee code expected it...
	  ;wmmousemove()>WM_USER>xuser() does.
	  mov eax,g_nmousex
	  mov WORD PTR lparam,ax
	  mov eax,g_nmousey
	  mov WORD PTR lparam+2,ax


      ;231100
      ;when moving a group of elements, they simply track mouse,
      ;deposited by lbuttonup, so do nothing here...
      .IF fmovinghighlighted==1
	ret
      .ENDIF

      ;when duplicating a group of elements, they simply track mouse,
      ;deposited by lbuttonup, so do nothing here...
      .IF highlightedindexnewlist==0
      .ELSE
	ret
      .ENDIF

      .IF g_nstate==0		;normal state at startup & during operation.
	  ;need to decide if button-press is on an object...
	  ;if so, we go to state=1 and g_pselectedobjectnew >object...
	  invoke onanobject, g_nmousex,g_nmousey
	    ;return with eax=0 fail, else eax pts to found object.
	    .IF eax==0
	      ;do nothing
	      mov g_pselectedobjectnew,0	;precaution.
	      .IF highlightedindex==0
	      .ELSE
		mov g_fclrhighlighted,1
		mov highlightedindex,0
		;...the flag set will cause paint_*() to clr .fconfig2/bit7,
		;removing any highlighting. the index removes list of
		;highlighted objects.
		invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
		mov	g_fredrawdiag,ENTIRE
	      .ENDIF
	    .ELSE
	      mov g_pselectedobjectnew,eax
	      mov g_nstate,1
	    .ENDIF



      .ELSEIF g_nstate==1	 ;a prior lbuttondn has highlighted an obj.
                                ;...can only come here from state-0.
				;g_pselectedobjectnew=object selected.
          ;error...  cannot be in this state when lbuttondn...
	  mov g_pselectedobjectnew,0
	  mov g_nstate,0

      .ELSEIF g_nstate==2
	;lbuttondown/state0/on an object > state1 > no mousemove > lbuttonup
	; > state2. If do another lbuttondown, toggle the highlighted
	;object off, regardless where button pressed...NO...
	.IF g_phighlightedobject==0
	.ELSE
	  ;well, if have clicked on a wire that is already highlighted,
	  ;may have clicked on one of the "controls", knee2 and knee3...
	  ;if so, allow to drag the control...
	  mov esi,g_phighlightedobject
	  mov al,(OBJECT PTR [esi]).fconfig
	  and al,01
	  .IF al==01	;wire-type object
		 ;invoke onanobject, g_nmousex,g_nmousey
		 ;no, can't call onanobject(), must call the method for
		 ;wire directly, to only quiz the one object...
		 invoke on_arc, g_phighlightedobject,g_nmousex,g_nmousey
	      ;return with eax=0 fail, else eax pts to found object.
	      .IF eax==g_phighlightedobject  ;have clicked on a wire
		.IF g_nknee==2		     ; that is already highlighted.
		  jmp SHORT s2to8
		.ELSEIF g_nknee==3    ;2nd-half-mid
		  jmp SHORT s2to8
		.ELSEIF g_nknee==4    ;start of wire.
		  jmp SHORT s2to8
		.ELSEIF g_nknee==5    ;destination of wire.
s2to8:		  mov g_nstate,8
		  mov eax,g_phighlightedobject
		  mov g_pmovingobject,eax
		  mov g_phighlightedobject,0
		.ELSE
		  jmp SHORT s2to0
		.ENDIF
	      .ELSE
		jmp SHORT s2to0
	      .ENDIF
	  .ELSE
s2to0:	      mov g_nknee,0
	      invoke add2wipeoutlist, g_phighlightedobject
	      mov  g_fredrawdiag,WIPEOUTobjs
	      mov  eax,g_phighlightedobject
	      mov  g_phighlightedobject,0  ;else paint_ will use black brush.
	      push eax
	      invoke UpdateWindow, g_hwnd		;wipe immediately.
	      pop  eax
		;i've got a problem with multiring node drawing and
		;hiding wires. this cos whited it out, then redraw
		;only it. so, add all slaves to update list...
		push eax
	      invoke add2updatelist, eax	;g_phighlightedobject
		pop  eax
		invoke updateslaves, eax,0,0 ;0,0=no change in coords.
		;...i added g_phighlighted first, cos get drawn first.
	      invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
	      mov	g_fredrawdiag,UPDATEobjs
	      mov g_phighlightedobject,0
	      mov g_nstate,0
	  .ENDIF
	.ENDIF



      .ELSEIF g_nstate==4	 ;a new object is being placed, first "end".
                                ;...can only come here from state-0.

	  mov esi,g_pmovingobject
	  mov poldmovingobject,esi
	  ;...used to delete last object, even if not highlighted.
	  ;(refer xkeydown())

;i want to detect if a new object is placed on top of an existing one...
;note onanobject() excludes g_pmovingobject from search...
	  invoke onanobject, g_nmousex,g_nmousey
	  ;return with eax=0 fail, else eax pts to found object.
	  mov plock,eax
	    .IF eax==0
	      mov esi,g_pmovingobject
	      mov ax,(OBJECT PTR [esi]).nexttype
	      .IF ax==0 ;only nodes are allowed to be free.
	      .ELSEIF ax==30  ;...comments also.
	      .ELSEIF ax==60  ;execution-icons also.
	      .ELSEIF ax==61  ;text-fileicons also.
	      .ELSEIF ax==62  ;make-icons also.
	      .ELSE
		mov al,(OBJECT PTR [esi]).fconfig
		;error if a wire-type...
		and al,01   ;bit0=1 if a wire type.
		.IF al==1
		  lea eax,szerper
per8:		    invoke MessageBox, g_hwnd, eax,\
			 0, MB_OK+MB_ICONEXCLAMATION
		    invoke add2wipeoutlist,g_pmovingobject
		    mov g_fredrawdiag,WIPEOUTobjs
		    invoke InvalidateRgn, g_hwnd,0,FALSE
		    ;have to do an immediate paint cos paint funcs
		    ;won't paint an invalid object...
		    invoke UpdateWindow,g_hwnd
		      ;invoke nearobjects,g_pmovingobject ;experiment
		      ;	;...adds nearby objects to updatelist.
		    mov g_fredrawdiag,ENTIRE ;UPDATEobjs
		    invoke InvalidateRgn, g_hwnd,0,FALSE
		    mov (OBJECT PTR [esi]).fstatus,0 ;delete the wire.
		    mov g_pmovingobject,0
		    mov poldmovingobject,0
		    mov g_nstate,0
		    ret
		.ELSE
		  ;also error if a data/hardware element...
		  ;or anything other than a node/comment...
		  lea eax,szerdh6
		  jmp per8  ;1
		.ENDIF
	      .ENDIF
	    .ELSE
	      mov esi,g_pmovingobject

	      ;061200
	      ;generic data must only attach to a node...
	      mov al,(OBJECT PTR [esi]).fstatus2
	      and al,11100000b
	      .IF al==10000000b
		mov ebx,plock
		mov ax,(OBJECT PTR [ebx]).nexttype
		.IF ax==0   ;node
		  mov al,(OBJECT PTR [ebx]).nfunctype
		  .IF al==0 ;inline code.
		    jmp gga
		  .ENDIF
		.ELSE
gga:		  lea eax,szerg
		  jmp per8
		.ENDIF
	      .ENDIF

	      ;if new obj is child in a chain, need to store master addr...
	      invoke findmaster, plock	    ;returns addr master in eax.
	      sub eax,pTERSEDATA	    ;store relative addr.
	      mov (OBJECT PTR [esi]).rpmaster,eax

	      ;tell the immediate-parent that it has a child-node (this is
	      ;useful for snapclonewires() and for code gen.)...
	      ;only do this for nodes...
	      mov ax,(OBJECT PTR [esi]).nexttype
	      .IF ax==0 ;new obj is a node.
		mov ebx,plock
		mov ax,(OBJECT PTR [ebx]).nexttype
		.IF ax==0	;parent must also be anode
		  ;there is one exception...if parent is a datatype-node
		  ;(itself a child of a pointer), it cannot have children...
		  mov al,(OBJECT PTR [ebx]).fstatus2
		  and al,01000b     ;extract bit3
		  .IF al==1000b     ;datatype-node
		    lea eax,szer17v
		    jmp per8 ;1
		  .ELSE
		    ;everythings ok...
		    inc (OBJECT PTR [ebx]).nchildren ;non-0 means has child
		  .ENDIF
		.ELSEIF ax==3 ;private resource.
		  jmp SHORT w17
		.ELSEIF ax==4 ;global res.
w17:		  ;a node is allowed to be attached to a pointer...
		  mov al,(OBJECT PTR [ebx]).fstatus2
		  and al,11100000b
		  .IF al==00100000b ;pointer data.
		    inc (OBJECT PTR [ebx]).nchildresources ;non-0 means has child
		    ;... the child is NOT a node now, it is a datatype, meaning
		    ;pointer to a function.
		    ;so, let's distinguish it...
		    mov (OBJECT PTR [esi]).fstatus2,00001000b
		    ;...bits2/1 visibility=private, bit3=1 node is a datatype.
		    mov (OBJECT PTR [esi]).nfunctype,1	;normal function.
		    ;and a physical...
		    mov (OBJECT PTR [esi]).wwidth,16
		    mov (OBJECT PTR [esi]).height,16
		    ;i'm not sure where this gets set, but clear it now as there
		    ;isn't room...
		    and (OBJECT PTR [esi]).fstatus,11111011b ;not external
		  .ELSE
		    jmp SHORT w18
		  .ENDIF
		.ELSE
w18:		  lea eax,szerch5
		  jmp per8 ;1
		.ENDIF
	      .ELSEIF ax==3	;default new data resource.
		;esi->new resource, ebx->parent.
		mov ebx,plock
		mov al,(OBJECT PTR [ebx]).fstatus2
		and al,11100000b
		.IF al==00100000b	;owner is a pointer.
		  mov al,(OBJECT PTR [esi]).fstatus2
		  and al,11100000b
		  ;if this is an array, don't allow attach to a pointer...
		  .IF al==01100000b	;array.
		    lea eax,szer7200
		    jmp per8 ;1
		  .ENDIF
		.ENDIF
		;if parent is a structure,
		;don't allow anything to attach to structure, cos it
		;shouldn't be a template in this situation...
		mov al,(OBJECT PTR [ebx]).fstatus2
		and al,11100000b
		.IF al==01000000b	;structure
		  mov eax,(OBJECT PTR [ebx]).rplock1
		  .IF eax==0
		  .ELSE
		    add eax,pTERSEDATA	;eax->parent's parent.
		    mov ebx,eax
		    mov ax,(OBJECT PTR [ebx]).nexttype
		    .IF ax==3
		      lea eax,szer7200b
		      jmp per8 ;1
		    .ELSEIF ax==4
		      lea eax,szer7200b
		      jmp per8 ;1
		    .ENDIF
		    mov ebx,plock
		  .ENDIF
		.ENDIF
		;maybe now do check... if parent a datatype-node,
		;don't allow child res to attach...
		  mov al,(OBJECT PTR [ebx]).fstatus2
		  and al,01000b     ;extract bit3
		  .IF al==1000b     ;datatype-node
		    lea eax,szer17v
		    jmp per8 ;1
		  .ENDIF
		inc (OBJECT PTR [ebx]).nchildresources
	      .ELSEIF ax==50	;default new hardware resource.
dhq1:		;resources also tell parent how many attached...
		;(any type of parent)
		;esi->new resource, ebx->parent.
		mov ebx,plock
		;maybe now do check... if parent a datatype-node,
		;don't allow child res to attach...
		  mov al,(OBJECT PTR [ebx]).fstatus2
		  and al,01000b     ;extract bit3
		  .IF al==1000b     ;datatype-node
		    lea eax,szer17v
		    jmp per8 ;1
		  .ENDIF
		inc (OBJECT PTR [ebx]).nchildresources
	      .ENDIF

	      ;action/condition objects are a special problem.
	      ;for wires, drag_arc tracks 1st-end coords in state4
	      ;and paint_arc snaps to nearest ring.
	      ;action/cond however are node-type objects. we set
	      ;newobject.nbeginring here, and later on when paint_act()
	      ;and paint_cond() call snap_tonode(), this ring# is
	      ;passed and it is snapped to...
	      mov ax,(OBJECT PTR [esi]).nexttype
	      .IF ax==32    ;condition
fix1:		mov eax,g_nmousex
		mov xend,eax
		mov eax,g_nmousey
		mov yend,eax
		invoke snap_tonode, plock,ADDR xend,ADDR yend
		;...returns ring# in eax
		mov (OBJECT PTR [esi]).nbeginring,al
	      .ELSEIF ax==33 ;action
		jmp fix1
	      .ENDIF

			    ;ALL OBJECT PTRS RELATIVE TO START TERSEDATA...
			    ;assuming eax has value to be written...
			    mov eax,plock
			    sub eax,pTERSEDATA
	      mov (OBJECT PTR [esi]).rplock1,eax	;lock child to parent.

		;NOTE that when resources are placed, they are normally
		;dragged from a parent node, so connecting line already
		;exists. but sometimes need to create extra dataflow
		;wires. hence here...
		;i want dataflow wires to always start from a resource.
		;(and the resource must be shareable permament or temporary)
		;(nexttype=3 (private), =4 (global), =50 (private hardware),
		; =51 (global hardware). also, default when new is nexttype=15
		;which is dataflow wire from memory data object. -- if from a
		;interrupt hardware object (.nfunctype=1), make wire into
		;interupt type, .nexttype=17...
		xor eax,eax
		mov ax,(OBJECT PTR [esi]).nexttype    ;wire type.
		.IF ax==15			      ;default dataflow wire.
		  mov ebx,plock
		  mov ax,(OBJECT PTR [ebx]).nexttype  ;parent type.
		  .IF ax==3
zz1:		    lea eax,szerwd  ;error. parent isn't shareable data.
		    jmp per8 ;1
		  .ELSEIF ax==4
ss1:		    mov al,(OBJECT PTR [ebx]).fconfig
		    and al,01100000b	;extract bits 6/5
		    .IF al==0		;shareable, perm or temp., ok
		    .ELSE
		      jmp zz1
		    .ENDIF
		  .ELSEIF ax==50
		    lea eax,szerwd  ;error, parent isn't shareable.
		    jmp per8 ;1
		  .ELSEIF ax==51
		    ;if parent.nfunctype =1, then it's interrupt object...
		    mov al,(OBJECT PTR [ebx]).nfunctype
		    .IF al==1
		      mov (OBJECT PTR [esi]).nexttype,17 ;interrupt wire.
		    .ENDIF
		    ;but, check that parent is shareable...
		    jmp ss1
		  .ELSE
		    ;fail...
		    lea eax,szerdf1
		    jmp per8
per1:		    invoke MessageBox, g_hwnd, eax,\
			 0, MB_OK+MB_ICONEXCLAMATION
		    mov (OBJECT PTR [esi]).fstatus,0 ;delete the wire.
		    mov g_pmovingobject,0
		    mov poldmovingobject,0
		    mov g_nstate,0
		    ret
		  .ENDIF
		.ELSEIF ax==10	;sync 1-way execution-flow wire.
cc1:		  ;this must start and end on a node...
		  mov ebx,plock
		  mov ax,(OBJECT PTR [ebx]).nexttype  ;parent type.
		  .IF ax==0	 ;node, ok.
		  .ELSE
		    lea eax,szernp1
		    jmp per8 ;1
		  .ENDIF
		.ELSEIF ax==11
		  jmp cc1
		.ELSEIF ax==12
		  jmp cc1
		.ELSEIF ax==13
		  jmp cc1
		.ELSEIF ax==14
		  jmp cc1
		.ELSEIF ax==22
		  jmp cc1
		.ENDIF

		;if the new object is a data/hardware element, attached
		;to a parent, the parent must be a node, and the node
		;must be a function...
		;(special case of parent being datatype-node handled earlier)
		;esi->new element
		mov ax,(OBJECT PTR [esi]).nexttype
		.IF ax==3   ;private data  (new default)
		  jmp SHORT tnd1
		.ELSEIF ax==50 ;private hardware ( " )
tnd1:		  ;save current mouse coords, cos i've decided to create
		  ;a dataflow wire to connect resource to parent node...
		  ;these coords used in wmlbuttonup()/state5...
		  mov eax,g_nmousex
		  mov nmousex_save,eax
		  mov eax,g_nmousey
		  mov nmousey_save,eax
		  mov ebx,plock 	     ;parent
		  mov ax,(OBJECT PTR [ebx]).nexttype
		  .IF ax==0	;node
		       ;ok, data/hardware obj is on a node, but if it's a
		       ;child-node, it can only be shareable-permanent...
		       mov eax,(OBJECT PTR [ebx]).rplock1 ;non-0 if a child.
		       .IF eax==0
			 ;also, a library-func node is not allowed to have
			 ;any children (nodes or resources)...
			 mov al,(OBJECT PTR [ebx]).nfunctype ;parent
			 .IF al==3	;library func
			   mov (OBJECT PTR [ebx]).nchildren,0
			   mov (OBJECT PTR [ebx]).nchildresources,0
			   lea eax,szerlfc1
			   jmp per8 ;1
			 .ENDIF
			 ;come here if new data/hardware resource, placed
			 ;on a node, node is free/master.
			 ;now, if node is external, so to must be the
			 ;resources (BUT clones if the node can have local
			 ;data)...
			 ;ebx -> parent
			 mov al,(OBJECT PTR [ebx]).fstatus2
			 and al,0110b
			 .IF al==0110b	;external
			   ;set resource external...
			   or (OBJECT PTR [esi]).fstatus,100b ;bit2
			 .ENDIF
		       .ELSE
			 ;come here when new data/hardware placed on a
			 ;clone.
;			 ;but, if root-node is external, clone not allowed
;			 ;to have attached resources...
;			 push ebx
;			 mov ebx,(OBJECT PTR [esi]).rpmaster
;			 add ebx,pTERSEDATA
;			 mov al,(OBJECT PTR [ebx]).fstatus2   ;root
;			 pop ebx
;			 and al,0110b
;			 .IF al==0110b	;external
;			   ;already incr .nchildresources on parent...
;			   dec (OBJECT PTR [ebx]).nchildresources
;			   lea eax,szer151
;			   jmp per1
;			 .ENDIF
			 mov ax,(OBJECT PTR [esi]).nexttype
			 .IF ax==3  ;default new data.
			   mov (OBJECT PTR [esi]).nexttype,4	;make global.
			   and (OBJECT PTR [esi]).fconfig,10011111b ;bits 6/5
			   ;... makes it shareable permanent data obj.
			 .ELSEIF ax==50 ;default new hardware.
			   mov (OBJECT PTR [esi]).nexttype,51 ;make global.
			   and (OBJECT PTR [esi]).fconfig,10011111b ;bits 6/5
			   ;...makes it shareable permanent hardware obj.
			 .ENDIF
		       .ENDIF
		    ;ok, but is node a function (.nfunctype != 0)?...
		    mov al,(OBJECT PTR [ebx]).nfunctype
		    .IF al==0
		      mov (OBJECT PTR [ebx]).nfunctype,1
		    .ENDIF
		    mov al,(OBJECT PTR [ebx]).sztext1
		    .IF al==0
		      ;node must have a function name...
		      mov al,(OBJECT PTR [ebx]).sztext1
		      .IF al==0
			invoke givenodeaname, ebx ;auto generates a name.
		      .ENDIF
		    .ENDIF
		  .ELSE
		    ;esi->new data/hardware element, ax=parent nexttype.
		    mov cx,(OBJECT PTR [esi]).nexttype
		    .IF cx==3	    ;nexttype, default data element
		      ;a new data element is allowed to affix to an
		      ;existing reference-type data element...
		      .IF ax==3
			jmp SHORT te3
		      .ELSEIF ax==4
te3:			mov ebx,plock	     ;parent
			mov al,(OBJECT PTR [ebx]).fstatus2
			and al,11100000b
			.IF al==0	    ;a simple variable.
			  jmp SHORT re1     ;not allowed.
			.ELSE
			  ;new element must inherit the parent's
			  ;public or external ...
			  ;.nexttype=4,.fconfig/bits6/5=10 =public
			  ;.fstatus/bit2=1 =external
			  mov al,(OBJECT PTR [ebx]).fstatus
			  and al,100b
			  .IF al==100b	    ;external
			    or (OBJECT PTR [esi]).fstatus,100b ;set itinchild
			  .ENDIF
			  mov ax,(OBJECT PTR [ebx]).nexttype
			  .IF ax==4	    ;global
			    ;err, i don't think we want the child res
			    ;to be marked as public...
			    ;could test for parent' .fconfig/bits6/5 here,
			    ;but i think children should stay private
			    ;to parent.
			  .ENDIF
			  ;the new child res. attached to a res., which
			  ;is a reference type. (all checked above).
			  ;but, if parent is a pointer or array, can only
			  ;have one child directly attached...
			  ;parent.nchildresources was incr'd above.
			  ;ebx->parent.
			  mov al,(OBJECT PTR [ebx]).nchildresources
			  .IF al>1
			    dec (OBJECT PTR [ebx]).nchildresources
			    lea eax,szer171a
			    jmp per8 ;1
			  .ENDIF
			  ;ok, i think we should also clear .ndatatype
			  ;of parent...
			  mov (OBJECT PTR [ebx]).ndatatype,0
			  ;(if parent is array or structure or ptr)
			.ENDIF
		      .ELSE
			jmp SHORT re1
		      .ENDIF
		    .ELSE	    ;nexttype=50,default hardware element.
		      ;parent is not a node or resource, error...
re1:		      lea eax,szernn1
		      jmp per8 ;1
		    .ENDIF
		  .ENDIF
		.ENDIF

		;we come here because new object is a child.
		;now, if it is a child-node (clone), it must be a
		;function, and so to must the parent...
		mov ax,(OBJECT PTR [esi]).nexttype
		.IF ax==0   ;node
		  mov ebx,plock
		    ;there is a special case, new node is attached to a
		    ;pointer data element.
		    ;in that case, ignore this name-gen stuff...
		    ;note this is the only data element that a node is
		    ;allowed to attach to...
		    mov ax,(OBJECT PTR [ebx]).nexttype
		    .IF ax==3
		      jmp SHORT aa1
		    .ELSEIF ax==4
aa1:		      mov al,(OBJECT PTR [ebx]).fstatus2
		      and al,11100000b
		      .IF al==00100000b ;pointer.
			jmp qq1   ;bypass
		      .ENDIF
		    .ENDIF
		  mov al,(OBJECT PTR [ebx]).nfunctype ;get parent's functype.
		  .IF al==0
		    mov (OBJECT PTR [ebx]).nfunctype,1
		    mov al,(OBJECT PTR [ebx]).sztext1
		    .IF al==0	;it has no name.
		      invoke givenodeaname, ebx  ;give parent-node a name.
;121000 ... and set label to be function-name...
		      or (OBJECT PTR [ebx]).fconfig,080h ;set bit7.
		      ;and file-visible...
		      mov al,(OBJECT PTR [ebx]).fstatus2
		      and al,11111001b	;set bits2/1 =0/1
		      or  al,00000010b	;/
		      mov (OBJECT PTR [ebx]).fstatus2,al
		    .ENDIF
		    mov al,1
		  .ELSEIF al==3 ;but library func not allowed to have a clone
		    ;but i already incr parent .nchildren above...
		    mov (OBJECT PTR [ebx]).nchildren,0
		    mov (OBJECT PTR [ebx]).nchildresources,0
		    lea eax,szerlfc1
		    jmp per8 ;1
		  .ENDIF
		  mov (OBJECT PTR [esi]).nfunctype,al ;make child same type.
		  mov al,(OBJECT PTR [esi]).sztext1
		  .IF al==0
;121000 ... no, clone doesn't need a name...
;		    invoke givenodeaname, esi ;give new child-node a name.
		  .ENDIF

		  ;the child node also inherits the prototype of root...
		  ;well, of parent also...
		  lea eax,(OBJECT PTR [ebx]).sztext4 ;copy .sztext4/5/6/7
		  lea ecx,(OBJECT PTR [esi]).sztext4
		  invoke lstrcpyn, ecx,eax,64+384+64+64
		.ENDIF
qq1:

	    .ENDIF
	  mov g_nstate,5



      .ELSEIF g_nstate==5	 ;a new obj is being placed, second "end".
                                ;...can only come here from state-4.
          ;error...  (cannot already be in this state at lbuttondn)
	  mov g_nstate,0		  ;precaution

      .ELSEIF g_nstate==8	 ;an object is being moved.
          invoke add2updatelist, g_pmovingobject
                                ;...can only come here from state-1.
                                ;g_pmovingobject=object being moved.
          ;error... (cannot already be in this state at lbuttondn)
	  mov g_nstate,0		  ;precaution
	  mov g_phighlightedobject,0	 ;/
	  mov g_pselectedobjectnew,0	 ;/

      .ELSEIF g_nstate==20 ;first corner of a selection-rectangle.
	;created via menu "control/selection rectangle" -> IDM_RECT
	; -> g_nstate=20.
	mov eax,g_nmousex
	mov n1stx,eax
	mov eax,g_nmousey
	mov n1sty,eax
	mov g_nstate,21

      .ELSEIF g_nstate==21
	;a mousemove will set state=22, so if come here, invalid...
	mov n1stx,0
	mov n1sty,0
	mov n2ndx,0
	mov n2ndy,0
	mov g_nstate,0

      .ELSEIF g_nstate==22
	;clicked to place 1st corner, now clicking again, but ignore
	;now, respond on buttonup to set 2nd corner.


      .ELSE
	 mov g_nstate,0 	    ;error, default back to state 0.
	 mov g_phighlightedobject,0
	 mov g_pselectedobjectnew,0
      .ENDIF



    ret
wmlbuttondown ENDP
;------------------------------------------------------------------------
givenodeaname PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD
;called from wmlbuttondown()/state4
;assigns a name to a node, of form "fncx", where x=element number.

    mov ebx,pobj
			lea eax,(OBJECT PTR [ebx]).sztext1
			invoke lstrcpy, eax,ADDR szdefname
			  xor eax,eax
			  mov ebx,pobj
			  mov	ax,(OBJECT PTR [ebx]).number
			  invoke bin2dec		;eax-->szasciitbl
			  lea	edi,szasciitbl+4
			  mov	al,[edi]	;ignore leading blanks.
			  .WHILE al==" "	;/
			    inc	edi		;/
			    mov	al,[edi]	;/
			  .ENDW		;/
			mov ebx,pobj
			lea ecx,(OBJECT PTR [ebx]).sztext1
			 push ecx
			invoke lstrlen, ecx
			 pop ecx
			add eax,ecx
			invoke lstrcpy, eax,edi


  ret
givenodeaname ENDP
;------------------------------------------------------------------------
.DATA
prbuttonobject DWORD 0 ;global, but restricted use.
.CODE
wmrbuttondown PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
;comes via WM_RBUTTONDOWN msg.	   "wmrbuttondown"
;the basic purpose is to popup a dialog box if mouse over an object.

    mov poldmovingobject,0 ;see wmlbuttondown/state4

;lparam has mouse coords...x=low-word,y=hi-word
	invoke  origincorrection, lparam 
		;returns corrected in g_nmousex & g_nmousey
	  ;i'll correct lparam as well, cos old goofee code expected it...
	  ;wmmousemove()>WM_USER>xuser() does.
	  mov eax,g_nmousex
	  mov WORD PTR lparam,ax
	  mov eax,g_nmousey
	  mov WORD PTR lparam+2,ax

    .IF g_nstate==0
      ;test if mouse cursor on an object...
      invoke onanobject, g_nmousex,g_nmousey
      ;return with eax=0 fail, else eax pts to found object.
      .IF eax==0
	;right-click somewhere on screen, not on an object, redraw
	;everything, wiping background...
	  ;051100 bug fix...
	  ;if have multiple highlighted elements, for code gen or
	  ;duplication, by holding down shift key, when operation is
	  ;finished, wmpaint() will use this flag to remove highlighting,
	  ;but only for elements that get redrawn. some elements further
	  ;away can miss out. hack-fix now is to set flag again when
	  ;do right-click, to wipe any highlighting...
	  mov g_fclrhighlighted,1
	mov g_fredrawdiag,ENTIRE
	invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background
      .ELSE
	mov edi,eax
	mov prbuttonobject,eax
	mov al,(OBJECT PTR [edi]).fconfig
	and al,01
	.IF al==01	;wire type.
	  mov ax,(OBJECT PTR [edi]).nexttype
	  .IF ax==10	    ;sync, 1-way
dlgw:	    lea	ecx,KENTER2proc 	       ;"wireproc"
	    mov eax,206	     ;resource number of KENTER2 in goosee.rc
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSEIF ax==11    ;sync, 2-way
	    jmp dlgw
	  .ELSEIF ax==12    ;sync, 2-way+timeout
	    jmp dlgw
	  .ELSEIF ax==13    ;async, 1-way
xdlgw:	    lea	ecx,xKENTER2proc	       ;
	    mov eax,213	     ;resource number of xKENTER2 in goosee.rc
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSEIF ax==14    ;async, 2-way
	    jmp xdlgw
	  .ELSEIF ax==17    ;interrupt
	  .ELSEIF ax==22    ;mutual-exclusion
	  .ELSE
	  .ENDIF
	.ELSE		;node type
	  mov ax,(OBJECT PTR [edi]).nexttype
	  .IF ax==0	   ;normal node
	    mov al,(OBJECT PTR [edi]).fconfig
	    and al,011000b	;bits 4/3 =1/0 dblclk-action =executecommand
	    .IF al==10000b ;**REDUNDANT** as now have .nexttype=60
		; for execution-icon.
	      lea ecx,commandproc
	      mov eax,222	     ;resource number in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .ELSE
	      lea ecx,KENTER5proc     ;nodeproc
	      mov eax,205	     ;resource number of KENTER5 in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .ENDIF
	  .ELSEIF ax==1    ;super node
	  .ELSEIF ax==3	   ;hidden data resource (default when new)

dat1:	    ;there is also a variable-type (simple variable, pointer,
	    ;structure, array, generic), held in .fstatus2/bits7/6/5.
	    ;each has a different dialog box...
	    mov al,(OBJECT PTR [edi]).fstatus2
	    and al,11100000b
	    .IF al==0		;simple variable.
	      lea ecx,KENTER6proc    ;dataproc
	      mov eax,210	     ;resource number of KENTER6 in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .ELSEIF al==00100000b   ;pointer
	      lea ecx,PTRproc	   ;pointer variable type.
	      mov eax,217	     ;resource number in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .ELSEIF al==01000000b   ;structure.
	      lea ecx,STRUCproc	   ;structure variable type.
	      mov eax,218	     ;resource number in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .ELSEIF al==01100000b   ;array.
	      lea ecx,ARRAYproc	   ;pointer variable type.
	      mov eax,219	     ;resource number in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .ELSEIF al==10000000b   ;generic data.
	      lea ecx,genericproc	   ;generic variable type.
	      mov eax,225     ;resource number in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0

	    .ENDIF

	  .ELSEIF ax==4	   ;global data resource
	    jmp dat1
	  .ELSEIF ax==50     ;hardware object, private (default).
har1:	    lea	ecx,HARDWAREproc	   ;"hardwareproc"
	    mov eax,211	     ;resource number of HARDWARE in goosee.rc
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSEIF ax==51    ;hardware object, global.
	    jmp har1
	  .ELSEIF ax==30    ;comment
	      ;don't go to dialog box if using external editor...
	      mov ebx,pTERSEDATA
	      mov al,(TERSEDATA PTR [ebx]).fgooseeprefs
	      and al,01
	      .IF al==01	;bit0=1 use external editor. **NOT USED**
		lea eax,(OBJECT PTR [edi]).sztext2
		invoke openexternaleditor, eax
		mov g_fredrawdiag,ENTIRE
		invoke InvalidateRgn, g_hwnd,0,FALSE
	      .ELSE
		lea	ecx,KENTER30Cproc	       ;"commentproc"
		mov eax,207	     ;resource number of KENTER30C in goosee.rc
		invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	      .ENDIF
	  .ELSEIF ax==32    ;condition
	      ;don't go to dialog box if using external editor...
	      mov ebx,pTERSEDATA
	      mov al,(TERSEDATA PTR [ebx]).fgooseeprefs
	      and al,01
	      .IF al==01	;bit0=1 use external editor. **NOTUSED**
		lea eax,(OBJECT PTR [edi]).sztext2
		invoke openexternaleditor, eax
		mov g_fredrawdiag,ENTIRE
		invoke InvalidateRgn, g_hwnd,0,FALSE
	      .ELSE
		lea	ecx,KENTER30proc	       ;"conditionproc"
		mov eax,209	     ;resource number of KENTER30 in goosee.rc
		invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	      .ENDIF
	  .ELSEIF ax==33    ;action
	      ;don't go to dialog box if using external editor...
	      mov ebx,pTERSEDATA
	      mov al,(TERSEDATA PTR [ebx]).fgooseeprefs
	      and al,01
	      .IF al==01	;bit0=1 use external editor. **NOT USED**
		lea eax,(OBJECT PTR [edi]).sztext2
		invoke openexternaleditor, eax
		mov g_fredrawdiag,ENTIRE
		invoke InvalidateRgn, g_hwnd,0,FALSE
	      .ELSE
		lea	ecx,KENTER33proc	       ;"actionproc"
		mov eax,208	     ;resource number of KENTER33 in goosee.rc
		invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	      .ENDIF
	  .ELSEIF ax==60    ;execution-icon
	      lea ecx,commandproc
	      mov eax,222	     ;resource number in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSEIF ax==61    ;text-file-icon
	      lea ecx,infoproc
	      mov eax,223	     ;resource number in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSEIF ax==62    ;make-icon
	      lea ecx,makeproc
	      mov eax,224	     ;resource number in goosee.rc
	      invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	  .ELSE
	  .ENDIF
	.ENDIF
      .ENDIF
    .ENDIF

    mov prbuttonobject,0
    ret
wmrbuttondown ENDP

;------------------------------------------------------------------------
wmsize PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
;WM_SIZE causes this, in response to window size changing. "wmsize"

	invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.

;clientrectold is not "old" --it is the current physical client coords.
;i.e. top,left =0,0 bot,right = height,width of client region.
        invoke GetClientRect, g_hwnd, ADDR clientrectold ;backup copy.

;save width and height of client area...
	mov  ax,WORD PTR lparam	;(used by xkeydown)
	cwde
	mov  xclientpixels,eax
	mov  ax,WORD PTR lparam+2
	cwde
	mov  yclientpixels,eax

;280900
;update window coords...
    invoke GetWindowRect, g_hwnd, ADDR windowrect	;used for clipping.
	      ;... see scrollingbymouse()

;280900
;there seems to be a problem with clientrect not getting updated.
;this results in some elements not drawing when the window is resized.
	mov eax,clientrect.rc_left
	add eax,xclientpixels
	mov clientrect.rc_right,eax
	mov eax,clientrect.rc_top
	add eax,yclientpixels
	mov clientrect.rc_bottom,eax

    ret
wmsize ENDP
;-----------------------------------------------------------------------------
.DATA
szfilter DB "GOOSEE Data Files ",0,"*.goo",0,0
         DB 20 DUP(0)
szemffilter DB "Enhanced Metafiles ",0,"*.emf",0,0
         DB 20 DUP(0)
sizeszfile EQU 256
szdeffile	 DB "*.goo", sizeszfile-4 DUP(0)
szdefemffile	 DB "*.emf", sizeszfile-4 DUP(0)
szfile	 DB "*.goo", sizeszfile-4 DUP(0)
szemffile	 DB "*.emf", sizeszfile-4 DUP(0)
szoldfile	 DB "*.goo", sizeszfile-4 DUP(0)
szextension DB "goo",0
szemfextension DB "emf",0
defaulttersefile OPENFILENAME <, 0, 0, (OFFSET szfilter) ,0,\
                0, 1, (OFFSET szfile), sizeszfile,\
		0, 0, 0, 0,\
                OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
                0, 0, (OFFSET szextension), 0 ,0, 0>
		DB 0,0
opentersefile OPENFILENAME <, 0, 0, (OFFSET szfilter) ,0,\
                0, 1, (OFFSET szfile), sizeszfile,\
		0, 0, 0, 0,\
                OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
                0, 0, (OFFSET szextension), 0 ,0, 0>
                ;first field is size of structure.
		DB 0,0
defaultemffile OPENFILENAME <, 0, 0, (OFFSET szemffilter) ,0,\
		0, 1, (OFFSET szemffile), sizeszfile,\
		0, 0, 0, 0,\
                OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
		0, 0, (OFFSET szemfextension), 0 ,0, 0>
                ;first field is size of structure.
		DB 0,0
openemffile OPENFILENAME <, 0, 0, (OFFSET szemffilter) ,0,\
		0, 1, (OFFSET szemffile), sizeszfile,\
		0, 0, 0, 0,\
                OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
		0, 0, (OFFSET szemfextension), 0 ,0, 0>
                ;first field is size of structure.
		DB 0,0
g_hfile DWORD -1   ;handle of data file.(initialised to nothing open).
g_nfilesize      DWORD 0,0    ;size of datafile on disk & mem block.
testsignature  DWORD 0	;signature read from datafile.
testversion    DWORD 0	;version number read from datafile.
nbytesread	   DWORD 0,0 ;ReadFile reports here how many bytes read.
szerr1       DB "E001: Error opening file. Probably it doesn't exist.",0
szerrnogoo      DB "E002: The file you have tried to open does not have .GOO "
                DB "extension.",0
szerrortitle DB "PROGRAM OR USER ERROR",0
szerrortitle2 DB "USER WARNING",0
szerroldver  DB "E003: The file you have tried to open is for an earlier "
             DB "version of GOOFEE Diagrammer. Cannot convert.",0
szerrfuturever  DB "E004: The file you have tried to open is for a later "
                DB "version of GOOSEE. Cannot open.",0
szerrfailread  DB "The file you have just opened cannot be read "
               DB "from. Closing file.",0
szerralloc     DB "E006: Oh dear. Have opened data file, but cannot "
               DB "allocate a RAM block. Closing file.",0
szerralloc1	DB "Oh dear. GOOSEE Has opened data file, but cannot "
               DB "resize a RAM block to hold it. Closing file. "
		    BYTE "Recommend that you exit from GOOSEE.",0
szerralloc2	   DB "Oh dear. GOOSEE cannot allocate a RAM block. "
			DB "Exiting from GOOSEE.",0 ;(see wmcreate())
szerralloc2b   DB "E009: Oh dear. GOOSEE failed to resize a RAM block. "
			DB "Exiting from GOOSEE.",0
szerralloc2c   DB "E009: Oh dear. GOOSEE failed to allocate a RAM block. "
			DB "Aborting operation.",0
szerrget	   DB "WARNING. You haven't opened a file. Keeping "
               DB "previously-opened file.",0
;szerrget2	   DB "WARNING. You haven't opened a file.",0
szerrfree	   DB "GOOSEE was unable to release a block of RAM. "
		   DB "Can keep going, but advise exiting GOOSEE.",0
szersig1    BYTE "The .GOO data file you have just opened has failed "
	    BYTE "GOOSEE's integrity check. With the current version of "
	    BYTE "GOOSEE this is a signature (checksum or CRC code). "
	    BYTE "Future versions are planned to perform further "
	    BYTE "integrity checks. For now, you will have to examine "
	    BYTE "the diagram visually for any problems, or try "
	    BYTE "reloading the file or load another file.",0
.CODE
opendatafile PROC STDCALL USES edi eax ebx ecx edx
	LOCAL dummy:WORD
; "opendatafile"
	;first, copy default structure...
	lea edi,opentersefile
	lea ebx,defaulttersefile
	mov ecx,OPENFILENAME_
oo1:	mov al,[ebx]
	mov [edi],al
	inc ebx
	inc edi
	dec ecx
	jnz oo1
	;do same for szfile...
		;first save current contents...
		lea edi,szoldfile
		lea ebx,szfile
		mov ecx,sizeszfile
oo3:		mov al,[ebx]
		mov [edi],al
		inc ebx
		inc edi
		dec ecx
		jnz oo3
	lea edi,szfile
	lea ebx,szdeffile
	mov ecx,sizeszfile
oo2:	mov al,[ebx]
	mov [edi],al
	inc ebx
	inc edi
	dec ecx
	jnz oo2
        invoke GetOpenFileName, ADDR opentersefile
	    .IF eax==0		;0=error/cancel
		;not necessarily an error here, but put up a msgbox...
		   ;we can keep the previously open file, so restore szfile...
			lea edi,szfile
			lea ebx,szoldfile
			mov ecx,sizeszfile
oo4:			mov al,[ebx]
			mov [edi],al
			inc ebx
			inc edi
			dec ecx
			jnz oo4
        .IF g_hfile==-1
		  ;lea eax,szerrget2
		  ;jmp ferr2
		  mov g_nstate,0
		  mov g_pmovingobject,0
		  mov g_pselectedobjectnew,0
		  ret
		.ELSE
		  lea eax,szerrget
ferr2:	      mov g_nstate,0
              mov g_pmovingobject,0
	      mov g_pselectedobjectnew,0
                invoke MessageBox, g_hwnd, eax,\
        		 ADDR szerrortitle2, MB_OK+MB_ICONEXCLAMATION
	        ret
		.ENDIF
	    .ENDIF

;point of no-return for previously opened file. reload mem block with
;new default database...  close file first...
      .IF g_hfile==-1 ;-1 means no file previously open.
	  .ELSE
            invoke CloseHandle, g_hfile ;close previous file.
            mov g_hfile,-1
	  .ENDIF
;now copy complete default template to memory block...
                .IF pTERSEDATA==0
                .ELSE   ;should always come here.
                  ;the mem block already exists, made in wmcreate, so really
                  ;just need to call LocalReAlloc() to resize it ...
        invoke LocalReAlloc, pTERSEDATA,(SIZEOF TERSEDATA)+128,LMEM_MOVEABLE
                  .IF eax==0
                    ;fail...
                    mov g_nfilesize,0
                    lea eax,szerralloc2b
                    ;error message and exit GOOSEE...
                    invoke MessageBox, g_hwnd, eax,\
        		 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
                    invoke DestroyWindow, g_hwnd
                    ret
                  .ELSE
					;all absolute pointers are invalid...
					mov g_pmovingobject,0
					mov poldmovingobject,0
					mov g_pselectedobject,0
					mov g_pselectedobjectnew,0
					mov g_phighlightedobject,0
					mov g_perrorobject,0
					mov wipeoutsindex,0
					mov updatesindex,0
					mov highlightedindex,0
					mov g_nstate,0
					mov highlightedindexnewlist,0
		    mov g_nfilesize,(SIZEOF TERSEDATA)
                    mov pTERSEDATA,eax    ;new pointer.
                  .ENDIF
			mov edi,pTERSEDATA
			lea ebx,instantiatedTERSEDATA
                        mov ecx,(SIZEOF TERSEDATA)
oo6:                    mov al,[ebx]
			mov [edi],al
			inc ebx
			inc edi
			dec ecx
                        jnz oo6
                .ENDIF
	  invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
	  mov g_fredrawdiag,ENTIRE		;redraw entire window.

	;open existing file...
	invoke CreateFile, ADDR szfile,\
		GENERIC_READ+GENERIC_WRITE,\
		FILE_SHARE_READ+FILE_SHARE_WRITE,\
		0, OPEN_EXISTING,\	;only opens an existing file.
		FILE_ATTRIBUTE_NORMAL, 0
	cmp eax,INVALID_HANDLE_VALUE	;-1
	jne ofok
	  ;open failed ...
	  mov g_nstate,0
        mov g_pmovingobject,0
	mov g_pselectedobjectnew,0
          invoke MessageBox, g_hwnd, ADDR szerr1,\
        		 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION  ;E001
        mov g_hfile,-1
	  ret
ofok:
    mov g_hfile,eax   ;handle of newly-opened file.
;NOTE: it has to be an existing file to get this far.
;When creating a new file, I suggest adding "File/Import template ..."
;can apply the template to an existing or new datafile.

;Before we go ahead and read the file, is it .GOO? Is it correct
;signature? correct version?
;opentersefile, type OPENFILENAME structure, has .on_nFileExtension
;that is an offset into szfile, where is datafile extension ...
	xor eax,eax
	mov ax,opentersefile.on_nFileExtension
	lea ebx,szfile
	add ebx,eax
	;now compare this with content of szextension...
	invoke lstrcmpi, ebx,ADDR szextension
	.IF eax==0
	.ELSE
	  ;compare failed...
	  lea eax,szerrnogoo
ferr:	mov g_nstate,0
        mov g_pmovingobject,0
	mov g_pselectedobjectnew,0
          invoke MessageBox, g_hwnd, eax,\
        		 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
        invoke CloseHandle, g_hfile ;close file.
        mov g_hfile,-1
                ;NOTE i'll leave mem. block alone, as i have
                ;already restored it back to new default.
                ;the only place we'll call LocalFree() will be
                ;in wmdestroy().
	  ret
	.ENDIF
;now check for correct signature and version...
    invoke ReadFile, g_hfile,ADDR testsignature,8,ADDR nbytesread,0 
								;read first 8 bytes.
	.IF eax==0		;=0 if failed.
	  ;failed to read file...
ferrr:  lea eax,szerrfailread
	  jmp ferr		;error message and close file.
	.ELSE
	  ;set filepointer back to start of file...
      invoke SetFilePointer, g_hfile,0,0,FILE_BEGIN
	  .IF eax==-1
		;fail...
		jmp ferrr
	  .ENDIF
	  .IF testversion==10
	    ;correct version. now test for signature...
	    .IF testsignature==0
	      ;i will accept this as ok...
	    .ELSE
	      ;no, i really want to load the whole database first.
	      ;so, i'm checking for signature further down...
	    .ENDIF
	  .ELSE
	    ;incorrect version...
	    .IF testversion<10
		;old datafile version...
	      lea eax,szerroldver
		jmp ferr	;error message and close file.
	    .ELSE
	      ;later version????....
	      lea eax,szerrfuturever
	      jmp ferr	;error message and close file.
	    .ENDIF
	  .ENDIF
	.ENDIF
;if get here, file open and correct version etc...

;get size of file...
    invoke GetFileSize, g_hfile,0
	.IF eax==-1
	  ;function failed...
	  jmp ferrr
	.ELSE
      mov g_nfilesize,eax
	.ENDIF

;allocate a memory block...
;actually, the mem block already exists, made in wmcreate, so really
;just need to call LocalReAlloc() to resize it ...
        invoke LocalReAlloc, pTERSEDATA,g_nfilesize,LMEM_MOVEABLE
					;all absolute pointers are invalid...
					mov g_pmovingobject,0
					mov poldmovingobject,0
					mov g_pselectedobject,0
					mov g_pselectedobjectnew,0
					mov g_phighlightedobject,0
					mov g_perrorobject,0
					mov wipeoutsindex,0
					mov updatesindex,0
					mov highlightedindex,0
					mov g_nstate,0
					mov highlightedindexnewlist,0
	.IF eax==0
	  ;LocalRealloc() fail...
	  lea eax,szerralloc1
	  jmp ferr		;error message and close file.
        .ELSE
          mov pTERSEDATA,eax    ;new pointer.
        .ENDIF


;read file and write to block...
	mov eax,pTERSEDATA
    invoke ReadFile, g_hfile,eax,g_nfilesize,ADDR nbytesread,0
	.IF eax==0
	  ;fail...
	  jmp ferrr		;error message and close file.
	.ELSE
	.ENDIF

;if get here, then file has been opened and loaded to memory!
;pTERSEDATA points to memory block.

;a bit late, but now check signature...
    invoke calcsig  ;returns sig in eax.
    mov esi,pTERSEDATA
    cmp (TERSEDATA PTR [esi]).nsignature,eax
    je	ok2
    invoke MessageBox, g_hwnd, ADDR szersig1,\
			 0, MB_OK+MB_ICONEXCLAMATION
ok2:


	  ;241000
	  ;load top/left client-window coords (saved in database)...
	  mov esi,pTERSEDATA
	  mov eax,clientrect.rc_right
	  sub eax,clientrect.rc_left	 ;width.
	  mov ebx,clientrect.rc_bottom
	  sub ebx,clientrect.rc_top	 ;height.
	  mov ecx,(TERSEDATA PTR [esi]).xleft
	  mov clientrect.rc_left,ecx
	  add ecx,eax
	  mov clientrect.rc_right,ecx
	  mov ecx,(TERSEDATA PTR [esi]).ytop
	  mov clientrect.rc_top,ecx
	  add ecx,ebx
	  mov clientrect.rc_bottom,ecx


      mov g_nstate,0
      mov g_pmovingobject,0
      mov g_pselectedobjectnew,0
      mov g_phighlightedobject,0
	mov poldmovingobject,0
	mov g_pselectedobject,0
	mov g_perrorobject,0
	mov wipeoutsindex,0
	mov updatesindex,0
	mov highlightedindex,0
	mov highlightedindexnewlist,0
	invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.

  ret
opendatafile ENDP
;--------------------------------------------------------------------------
.DATA
szdeffiletemplate DB "*.GOO", sizeszfile-4 DUP(0)
szfiletemplate	 DB "*.GOO", sizeszfile-4 DUP(0)
szextensiontemplate DB "GOO",0
defaulttemplate OPENFILENAME <, 0, 0, (OFFSET szfilter) ,0,\
                0, 1, (OFFSET szfiletemplate), sizeszfile,\
		0, 0, 0, 0,\
                OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
                0, 0, (OFFSET szextension), 0 ,0, 0>
		DB 0,0
openfiletemplate OPENFILENAME <, 0, 0, (OFFSET szfilter) ,0,\
                0, 1, (OFFSET szfiletemplate), sizeszfile,\
		0, 0, 0, 0,\
                OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
                0, 0, (OFFSET szextension), 0 ,0, 0>
                ;first field is size of structure.
		DB 0,0
sztemplate1  BYTE """Import template..."" gives you the opportunity to "
             BYTE "open any .GOO file and apply all of its settings to "
             BYTE "the current file (Note: the settings are those you "
	     BYTE "choose under the ""Control/Configuration..."" menu). Do you want "
             BYTE "to continue?",0
testsigtemplate DWORD 0	 ;signature read from datafile.    (MUST be in
testvertemplate DWORD 0	 ;version number read from datafile. this order!)

.CODE
opentemplate PROC STDCALL USES ebx ecx edx esi edi
	LOCAL hfiletemplate:DWORD
	LOCAL nfilesizetemplate:DWORD  ;size of datafile on disk & mem block.
	LOCAL nbytestemplate:DWORD  ;ReadFile reports here how many bytes read.
    LOCAL ntstart:DWORD, ntsize:DWORD
;like opendatafile(), except only reads template portion of TERSEDATA.

  mov hfiletemplate,-1

  invoke MessageBox,g_hwnd,ADDR sztemplate1, \
		ADDR szgoosee,MB_OK+MB_YESNO+MB_ICONQUESTION
  .IF ax==IDYES
  .ELSE
    ret
  .ENDIF

;first, copy default structure...
	lea edi,openfiletemplate
	lea ebx,defaulttemplate
	mov ecx,OPENFILENAME_
oo1:	mov al,[ebx]
	mov [edi],al
	inc ebx
	inc edi
	dec ecx
	jnz oo1

;do same for szfiletemplate...
	lea edi,szfiletemplate
	lea ebx,szdeffiletemplate
	mov ecx,sizeszfile
oo2:	mov al,[ebx]
	mov [edi],al
	inc ebx
	inc edi
	dec ecx
	jnz oo2

  invoke GetOpenFileName, ADDR openfiletemplate  ;<<<DIALOG BOX<<<<
  .IF eax==0		;0=error/cancel
	      ;	  lea eax,szerrget2  ;just a warning.
	      mov g_nstate,0
              mov g_pmovingobject,0
	      mov g_pselectedobjectnew,0
	      mov g_phighlightedobject,0
	      mov g_pselectedobject,0
	      mov g_perrorobject,0
	      ;invoke MessageBox, g_hwnd, eax,\
	      ;		 0, MB_OK+MB_ICONEXCLAMATION
	        ret
  .ENDIF

;open existing file, read-only...
  invoke CreateFile, ADDR szfiletemplate,\
		GENERIC_READ,\
		FILE_SHARE_READ+FILE_SHARE_WRITE,\
		0, OPEN_EXISTING,\	;only opens an existing file.
		FILE_ATTRIBUTE_NORMAL, 0
  .IF eax==INVALID_HANDLE_VALUE	;-1
	  ;open failed ...
        lea eax,szerr1		;msg error opening file.
	      mov g_nstate,0
              mov g_pmovingobject,0
	      mov g_pselectedobjectnew,0
	      mov g_phighlightedobject,0
	      mov g_pselectedobject,0
	      mov g_perrorobject,0
	      invoke MessageBox, g_hwnd, eax,\
			 ADDR szgoosee, MB_OK+MB_ICONEXCLAMATION
	        ret
  .ENDIF
  mov hfiletemplate,eax   ;handle of newly-opened file.

;Before we go ahead and read the file, is it .GOO? Is it correct
;signature? correct version?
;openfiletemplate, type OPENFILENAME structure, has .on_nFileExtension
;that is an offset into szfiletemplate, where is datafile extension ...
	xor eax,eax
	mov ax,openfiletemplate.on_nFileExtension
	lea ebx,szfiletemplate
	add ebx,eax
	;now compare this with content of szextension...
	invoke lstrcmpi, ebx,ADDR szextension
	.IF eax==0
	.ELSE
	  ;compare failed...
        invoke CloseHandle, hfiletemplate ;close file.
	  lea eax,szerrnogoo
		;error msg and return.
ex1:	      mov g_nstate,0
              mov g_pmovingobject,0
	      mov g_pselectedobjectnew,0
	      mov g_phighlightedobject,0
	      mov g_pselectedobject,0
	      mov g_perrorobject,0
	      invoke MessageBox, g_hwnd, eax,\
			 0, MB_OK+MB_ICONEXCLAMATION
	        ret
	.ENDIF

;now check for correct signature and version...
  invoke ReadFile,hfiletemplate,ADDR testsigtemplate,8,ADDR nbytestemplate,0 
								;read first 8 bytes.
	.IF eax==0		;=0 if failed.
	  ;failed to read file...
        invoke CloseHandle, hfiletemplate ;close file.
	  lea eax,szerrfailread
	  jmp ex1		;error msg and return.
	.ENDIF

;set filepointer back to start of file...
  invoke SetFilePointer, hfiletemplate,0,0,FILE_BEGIN
	  .IF eax==-1
		;fail...
            invoke CloseHandle, hfiletemplate ;close file.
	      lea eax,szerrfailread
	      jmp ex1		;error msg and close file.
	  .ENDIF

  .IF testvertemplate==10	;ReadFile read 8 bytes!
	    ;correct version. now test for signature...
	    .IF testsigtemplate==0
	      ;i will accept this as ok...
	    .ELSE
	      ;***NOTE*** need code here in future, to read entire
	      ;file, compute signature and compare ***NOTE***
	    .ENDIF   ;(opendatafile() has same problem)
  .ELSE
	    ;incorrect version...
	    .IF testvertemplate<10
		;old datafile version...
            invoke CloseHandle, hfiletemplate ;close file.
	      lea eax,szerroldver
	      jmp ex1		;error msg and close file.
	    .ELSE
	      ;later version????....
            invoke CloseHandle, hfiletemplate ;close file.
	      lea eax,szerrfuturever
	      jmp ex1		;error msg and close file.
	    .ENDIF
  .ENDIF

;if get here, file open and correct version etc...

;read file and write to block...
  mov esi,pTERSEDATA
  lea ebx,(TERSEDATA PTR [esi]).templatestart ;start of template area.
  lea eax,(TERSEDATA PTR [esi]).OBJECTS   ;end of template area.
  sub eax,ebx		;size of template area.
  mov ntsize,eax
  mov ntstart,ebx
  invoke ReadFile,hfiletemplate,ntstart,ntsize,ADDR nbytestemplate,0
	.IF eax==0
	  ;fail...
        invoke CloseHandle, hfiletemplate ;close file.
	  lea eax,szerrfailread
	  jmp ex1		;error msg and close file.
	.ENDIF

;if get here, then file has been opened and template loaded to memory!
;we don't need the file anymore...
  invoke CloseHandle, hfiletemplate ;close file.
              mov g_pmovingobject,0
	      mov g_pselectedobjectnew,0
	      mov g_phighlightedobject,0
	      mov g_pselectedobject,0
	      mov g_perrorobject,0
      mov g_nstate,0
	invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.

  ret
opentemplate ENDP
;--------------------------------------------------------------------------
.DATA
szmerge1   BYTE "You have chosen to merge another .GOO diagram with "
	   BYTE "the current one. The other diagram .GOO file will "
	   BYTE "still exist, and if you only want to view the merged "
	   BYTE "diagrams and not permanently have the elements of the "
	   BYTE "other diagram in the current one, simply remember NOT "
	   BYTE " to File/Save.", 0Dh,0Ah
	   BYTE "The files must have the same ""Project"" number "
	   BYTE "see menu "
	   BYTE """Control/Configuration.../Project management..."".", 0Dh,0Ah
	   BYTE "The elements of the imported diagram will be highlighted, "
	   BYTE "and you may go to the menu ""Control"" to move/duplicate/delete "
	   BYTE "the highlighted (selected) elements.",0Dh,0Ah
	   BYTE	"Do you want to continue?",0
szerrprojnum BYTE "The .GOO file that you have chosen to merge with the "
	   BYTE "current one has a different Project number. The operation "
	   BYTE "is not allowed. See menu ""Control/Project management..."".",0
szerrsubprojnum BYTE "The .GOO file that you have chosen to merge with the "
	   BYTE "current one must have a different Sub-project number. "
	   BYTE "GOOSEE will abort the current operation. See menu "
	   BYTE """Control/Configuration.../Project management..."".",0
testsigtemp DWORD 0   ;signature read from datafile.	(MUST be in
testvertemp DWORD 0   ;version number read from datafile.  this order!)
szersh	   BYTE "Oops! The diagram that you are trying to import "
	   BYTE "is too big to move. Please look at the User Manual for the "
	   BYTE "limit on number of elements that can be highlighted "
	   BYTE "(selected) -- "
	   BYTE "note that the limit is an arbitrary restriction "
	   BYTE "designed into GOOSEE and can be increased if there "
	   BYTE "is a demand by users to import larger diagrams. ",0Dh,0Ah
	   BYTE "The import operation will go ahead, however not all "
	   BYTE "of the imported diagram will be highlighted, meaning "
	   BYTE "that you will not be able to move/duplicate/delete "
	   BYTE "all of it. Right-click to cancel highlighting.",0

.CODE
openmerge PROC STDCALL USES ebx ecx edx esi edi
	LOCAL hfiletemp:DWORD
	LOCAL nfilesizetemp:DWORD  ;size of datafile on disk & mem block.
	LOCAL nbytestemp:DWORD	;ReadFile reports here how many bytes read.
	LOCAL pTERSEDATAtemp:DWORD
	LOCAL nsubproj:WORD
	LOCAL nsizeobjectstemp:DWORD, nsizeobjectsold:DWORD
	LOCAL nsizeactualold:DWORD, numobjectstemp:WORD
	LOCAL pendactualold:DWORD
; "openmerge"
;from "File/Import diagram..." > IDM_MERGE.
;very similar to opentemplate(), except copies OBJECTS database into
;current mem block. doesn't close current file.

;TERSEDATA has .nproject and .nsubproject. .nproject must be the
;same for the two diagrams to merge, BUT .nsubproject must be
;different.
;OBJECTS has .nsubproject. If GOOSEE sees that an incoming object
;already exists in current database, it will only be replaced if
;the incoming OBJECT.nsubproject is different from the current
;file's TERSEDATA.nsubproject.

  mov hfiletemp,-1
  mov pTERSEDATAtemp,0
  mov nsubproj,0

  invoke MessageBox,g_hwnd,ADDR szmerge1,ADDR szgoosee,MB_OK+MB_YESNO+MB_ICONQUESTION
  .IF ax==IDYES
  .ELSE
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
    ret
  .ENDIF

;first, copy default structure...
	lea edi,openfiletemplate
	lea ebx,defaulttemplate
	mov ecx,OPENFILENAME_
oo1:	mov al,[ebx]
	mov [edi],al
	inc ebx
	inc edi
	dec ecx
	jnz oo1

;do same for szfiletemplate...
	lea edi,szfiletemplate
	lea ebx,szdeffiletemplate
	mov ecx,sizeszfile
oo2:	mov al,[ebx]
	mov [edi],al
	inc ebx
	inc edi
	dec ecx
	jnz oo2

  invoke GetOpenFileName, ADDR openfiletemplate  ;<<<DIALOG BOX<<<<
  .IF eax==0		;0=error/cancel
    ;	  lea eax,szerrget2  ;just a warning.
    ;	  jmp ex1
    jmp exx
  .ENDIF

;open existing file, read-only...
  invoke CreateFile, ADDR szfiletemplate,\
		GENERIC_READ,\
		FILE_SHARE_READ+FILE_SHARE_WRITE,\
		0, OPEN_EXISTING,\	;only opens an existing file.
		FILE_ATTRIBUTE_NORMAL, 0
  .IF eax==INVALID_HANDLE_VALUE	;-1
	  ;open failed ...
        lea eax,szerr1		;msg error opening file.
        jmp ex1
  .ENDIF
  mov hfiletemp,eax	 ;handle of newly-opened file.

;Before we go ahead and read the file, is it .GOO? Is it correct
;signature? correct version?
;openfiletemplate, type OPENFILENAME structure, has .on_nFileExtension
;that is an offset into szfiletemplate, where is datafile extension ...
	xor eax,eax
	mov ax,openfiletemplate.on_nFileExtension
	lea ebx,szfiletemplate
	add ebx,eax
	;now compare this with content of szextension...
	invoke lstrcmpi, ebx,ADDR szextension
	.IF eax==0
	.ELSE
	  ;compare failed...
	invoke CloseHandle, hfiletemp ;close file.
	  lea eax,szerrnogoo
	  jmp ex1		;error msg and return.
	.ENDIF

;now check for correct signature and version...
  invoke ReadFile,hfiletemp,ADDR testsigtemp,8,ADDR nbytestemp,0
								;read first 8 bytes.
	.IF eax==0		;=0 if failed.
	  ;failed to read file...
	invoke CloseHandle, hfiletemp ;close file.
	  lea eax,szerrfailread
	  jmp ex1		;error msg and return.
	.ENDIF

;set filepointer back to start of file...
  invoke SetFilePointer, hfiletemp,0,0,FILE_BEGIN
	  .IF eax==-1
		;fail...
	    invoke CloseHandle, hfiletemp ;close file.
	      lea eax,szerrfailread
	      jmp ex1		;error msg and close file.
	  .ENDIF

  .IF testvertemp==10	;ReadFile read 8 bytes!
	    ;correct version. now test for signature...
	    .IF testsigtemp==0
	      ;i will accept this as ok...
	    .ELSE
	      ;***NOTE*** need code here in future, to read entire
	      ;file, compute signature and compare ***NOTE***
	    .ENDIF   ;(opendatafile() opentemplate() have same problem)
  .ELSE
	    ;incorrect version...
	    .IF testvertemp<10
		;old datafile version...
	    invoke CloseHandle, hfiletemp ;close file.
	      lea eax,szerroldver
	      jmp ex1		;error msg and close file.
	    .ELSE
	      ;later version????....
	    invoke CloseHandle, hfiletemp ;close file.
	      lea eax,szerrfuturever
	      jmp ex1		;error msg and close file.
	    .ENDIF
  .ENDIF

;if get here, file open and correct version etc...

;get size of file...
    invoke GetFileSize, hfiletemp,0
	.IF eax==-1
	  ;function failed...
	  lea eax,szerrfailread
	  jmp ex1
	.ELSE
	  mov nfilesizetemp,eax
	.ENDIF

;we have to open a new mem block...
	invoke LocalAlloc, LMEM_FIXED,nfilesizetemp
	.IF eax==0		;NULL
	  ;fail...
	  mov pTERSEDATAtemp,0
	  invoke CloseHandle, hfiletemp ;close file.
	  lea eax,szerralloc2c
	  jmp ex1
	.ELSE
	  mov pTERSEDATAtemp,eax	;address of memory block.
	.ENDIF

;now read the entire file and write to mem block...
   invoke ReadFile, hfiletemp,pTERSEDATAtemp,nfilesizetemp,ADDR nbytestemp,0
	.IF eax==0
	  ;fail...
	  mov pTERSEDATAtemp,0
	  invoke CloseHandle, hfiletemp ;close file.
	  lea eax,szerrfailread
	  jmp ex1
	.ENDIF

;now close the file...
;we don't need the file anymore...
  invoke CloseHandle, hfiletemp
  mov hfiletemp,0

;does the new diagram have the same Project number?...
    mov esi,pTERSEDATAtemp
    mov ax,(TERSEDATA PTR [esi]).nproject
    mov esi,pTERSEDATA
    mov bx,(TERSEDATA PTR [esi]).nproject
    .IF ax==bx
    .ELSE
	  lea eax,szerrprojnum
	  jmp ex1
    .ENDIF

;051200
;don't worry about this...
;does new diagram have a different Sub-project number?...
    mov esi,pTERSEDATAtemp
    mov ax,(TERSEDATA PTR [esi]).nsubproject
    mov esi,pTERSEDATA
    mov bx,(TERSEDATA PTR [esi]).nsubproject
    mov nsubproj,bx	;save destination-diagram sub-project number.
;    .IF ax==bx
;	  lea eax,szerrsubprojnum
;	  jmp ex1
;    .ELSE
;    .ENDIF

;TERSEDATA mem block will have to be increased...
    ;NOTE the actual size of the database is not necessarily the
    ;same as g_nfilesize -- this is the size of the FILE, which
    ;depends on LocalAlloc() and may be a little bigger...
    ;!!!! ***NOTE*** NO, i think g_nfilesize IS actual size <<<<
    mov esi,pTERSEDATA
    xor eax,eax
    xor ecx,ecx
    xor edx,edx
    mov ax,(TERSEDATA PTR [esi]).numobjects
    mov cx,(TERSEDATA PTR [esi]).nsizeobject
    mul ecx	    ;eax=size of OBJECTS database.
    mov nsizeobjectsold,eax	;save size of old OBJECTS database.
    lea ebx,(TERSEDATA PTR [esi]).OBJECTS
    add ebx,eax 	    ;ACTUAL end of total database.
    mov pendactualold,ebx	 ;save. ***SEE RECALC BELOW***
    sub ebx,pTERSEDATA
    mov nsizeactualold,ebx    ;ACTUAL size of total database.
	;now do similar for the incoming database...
	mov esi,pTERSEDATAtemp
	xor eax,eax
	xor ecx,ecx
	xor edx,edx
	mov ax,(TERSEDATA PTR [esi]).numobjects
	mov numobjectstemp,ax		;save number incoming objects.
	mov cx,(TERSEDATA PTR [esi]).nsizeobject
	mul ecx	    ;eax=size of OBJECTS database.
	mov nsizeobjectstemp,eax	;save size of incoming OBJECTS database.

    mov eax,nsizeactualold
    add eax,nsizeobjectstemp
    mov g_nfilesize,eax 	;new total size of database.
    invoke LocalReAlloc, pTERSEDATA,eax,LMEM_MOVEABLE
                  .IF eax==0
                    ;fail...
		    invoke DestroyWindow, g_hwnd     ;exit.
		    mov g_nfilesize,0
		    lea eax,szerralloc2b    ;serious. exit goosee.
		    jmp ex1
		  .ENDIF
		  mov pTERSEDATA,eax	;new pointer.
    ;ah-ha! pendactualold (pointer to total end of old database) is
    ;now invalid. recalculate it...
    add eax,nsizeactualold
    mov pendactualold,eax

;now copy objects from pTERSEDATAtemp across to pTERSEDATA...
    mov ebx,pTERSEDATAtemp
    xor ecx,ecx
    mov cx,(TERSEDATA PTR [ebx]).numobjects  ;number objects incoming.

	;051200
	;adding some intelligence. add incoming objects to
	;highlighted list, so can move them...
	.IF cx>numhighlighted	;size limit on highlighted list (128).
	  pushad
	  lea eax,szersh
	  invoke MessageBox, g_hwnd, eax,\
			 0, MB_OK+MB_ICONEXCLAMATION
	  popad
	.ENDIF

    lea esi,(TERSEDATA PTR [ebx]).OBJECTS  ;where objects start,TERSEDATAtemp.
    mov ebx,pTERSEDATA
    mov edi,pendactualold  ;total end of old database.
    ;ebx-->TERSEDATA...

	;051200
	mov highlightedindex,0	;empty highlighted list.
	mov g_nstate,0	;precaution.
	mov g_fclrhighlighted,0 ;allow display multiple highlighted.
	mov g_phighlightedobject,0 ;precaution.

nxtobj:
;we copy objects *regardless* of valid/data/null types...
;as we are copying into a newly allocated region in TERSEDATA, no
;problem with clashing with existing objects (except for those that
;may occupy same coords). so, we copy *everything* across...
		   ;copy one object...
		   pushad
		   xor ecx,ecx
		   mov cx,(TERSEDATA PTR [ebx]).nsizeobject
nxtbyte:	   mov al,[esi]
		   mov [edi],al
		   inc esi
		   inc edi
		   loop nxtbyte
		   popad

	;051200
	invoke add2highlightedlist,edi
	or (OBJECT PTR [edi]).fconfig2,10000000b ;bit7,display highlighted.

    xor eax,eax
    mov ax,(TERSEDATA PTR [ebx]).nsizeobject
    add edi,eax 		    ;next object
    add esi,eax 		    ;/
    loop nxtobj

;update the number-of-objects field in TERSEDATA...
    ;update .numobjects...
    mov esi,pTERSEDATAtemp
    mov edi,pTERSEDATA
    xor ecx,ecx
    mov cx,(TERSEDATA PTR [esi]).numobjects
    add (TERSEDATA PTR [edi]).numobjects,cx

;now need to scan thru the newly-added objects and offset all
;OBJECT pointer fields, by amount nsizeobjectsold...
    mov esi,pTERSEDATA
    mov edi,pendactualold	 ;start of newly imported objects.
    xor ecx,ecx
    mov cx,numobjectstemp   ;number of incoming objects.
nxt1:
      ;now update all the pointers in the object...
      mov ebx,nsizeobjectsold
      mov eax,(OBJECT PTR [edi]).rpdata
      .IF eax != 0
	add (OBJECT PTR [edi]).rpdata,ebx
      .ENDIF
      mov eax,(OBJECT PTR [edi]).rpmaster
      .IF eax != 0
	add (OBJECT PTR [edi]).rpmaster,ebx
      .ENDIF
      mov eax,(OBJECT PTR [edi]).rplock1
      .IF eax != 0
	add (OBJECT PTR [edi]).rplock1,ebx
      .ENDIF
      mov eax,(OBJECT PTR [edi]).rplock2
      .IF eax != 0
	add (OBJECT PTR [edi]).rplock2,ebx
      .ENDIF
    xor eax,eax
    mov ax,(TERSEDATA PTR [esi]).nsizeobject
    add edi,eax
    loop nxt1

;we also need to examine objects with same coords (overlap) with
;each other. some imported objects may be proxies for ones that
;already exist in the parent database...

    ;***NOTE***


;now deallocate pTERSEDATAtemp...
		invoke LocalFree, pTERSEDATAtemp
		mov pTERSEDATAtemp,0
		  .IF eax==0	;returns 0 if succeeds.
		  .ELSE
			;LocalFree() failed...
			lea eax,szerrfree2			;E011
			jmp ex1
		  .ENDIF

;now tidy up...
exx:	      mov g_pmovingobject,0
	      mov g_pselectedobjectnew,0
	      mov g_phighlightedobject,0
	      mov g_pselectedobject,0
	      mov g_perrorobject,0
      mov g_nstate,0
	invoke InvalidateRgn, g_hwnd,0,FALSE	;don't erase existing.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
  ret

ex1:  ;error exit
      invoke MessageBox, g_hwnd, eax,\
        		 0, MB_OK+MB_ICONEXCLAMATION
      jmp exx
openmerge ENDP
;--------------------------------------------------------------------------
.DATA
xscreenpixels DWORD 0	;display pixels/inch, x
yscreenpixels DWORD 0	;display pixels/inch, y
xprintpixels  DWORD 0	;ditto, printer
yprintpixels  DWORD 0	;/
g_nxratio	      SDWORD 0	;printer>display scaling, x
g_nyratio	      SDWORD 0	;/ ,y	(actually these always +ve values)
g_nxprnpixsize   DWORD 0	;width of printer paper, in pixels.
g_nyprnpixsize   DWORD 0	;height /
xclientpixels DWORD 0	;width of client area, in pixels.
yclientpixels DWORD 0	;/
xwinext    SDWORD 0	;# pixels corresponding to paper width.
ywinext    SDWORD 0	;/  " height.
XMARGINADJ EQU 10
YMARGINADJ EQU 10

.CODE
wmcreate PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
	LOCAL hdc1:DWORD, hdcp:DWORD

;initialise some uninitialised data...	"wmcreate"
    mov szscr1,0
    mov szscr2,0
    mov szscr3,0

;one of the first jobs is to create a new default database...
        mov g_nfilesize,(SIZEOF TERSEDATA)+128 ;128 is slop space.
	invoke LocalAlloc, LMEM_FIXED,g_nfilesize
	.IF eax==0		;NULL
	  ;fail...
	  lea eax,szerralloc2
        invoke MessageBox, g_hwnd, eax,\
        		 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
	  mov pTERSEDATA,0		;should be 0, but be sure.
        invoke DestroyWindow, g_hwnd      ;exit GOOSEE
		;NOTE this will post WM_DESTROY msg, which calls wmdestroy()
		;which posts PostQuitMessage().
 	  ret
	.ELSE
	  mov pTERSEDATA,eax	;address of memory block.
	.ENDIF
;now copy complete default template to memory block...
			mov edi,pTERSEDATA
			lea ebx,instantiatedTERSEDATA
                        mov ecx,(SIZEOF TERSEDATA)
oo1:			mov al,[ebx]
			mov [edi],al
			inc ebx
			inc edi
			dec ecx
			jnz oo1

;now copy default preliminary text for generated source file...
    mov ebx,pTERSEDATA
    lea edi,(TERSEDATA PTR [ebx]).szgenprelim
    lea ebx,szloadgenprelim
    lea ecx,genprelimend
    sub ecx,ebx 	   ;size to transfer.
moo1:			mov al,[ebx]
			mov [edi],al
			inc ebx
			inc edi
			dec ecx
			jnz moo1
    mov edi,pTERSEDATA

;now here's the stuff from old goofee...

        invoke GetClientRect, g_hwnd, ADDR clientrect
   ;..returns coord of client rect. (left/top=0/0, right/bottom=width/height)
   ;..we only use the left/top origin coords, for origin-shifting.
          add clientrect.rc_left,4         ;
          add clientrect.rc_right,4        ;/  (fixes a zooming problem
          add clientrect.rc_top,4          ;/   when scrolling on axis)
          add clientrect.rc_bottom,4       ;/
	invoke GetClientRect, g_hwnd, ADDR clientrectold ;backup copy.

;280900
;wmsize() (WM_SIZE) invoked when window has been resized, sets
;xclientpixels,yclientpixels =width,height of client area, for use by
;xkeydown() for window scrolling by arrow-keys.
;however, I should set them initially here also? ...
	mov eax,clientrectold.rc_right
	mov xclientpixels,eax
	mov eax,clientrectold.rc_bottom
	mov yclientpixels,eax

          add clientrectold.rc_left,4      ;
          add clientrectold.rc_right,4     ;/
          add clientrectold.rc_top,4               ;/
          add clientrectold.rc_bottom,4    ;/
	invoke GetWindowRect, g_hwnd, ADDR windowrect	;used for clipping.

;timer...
	invoke SetTimer, g_hwnd,1,250,0 ;generates WM_TIMER, every 500msec.
		       ;***NOTE*** experiment with 250msec, for scrolling

;find out the resolution of the display...
	invoke GetDC, g_hwnd		;-->ax=display context client area.
	mov  hdc1,eax
	invoke GetDeviceCaps, hdc1,LOGPIXELSX	;query pixels/inch.
	mov  xscreenpixels,eax
	invoke GetDeviceCaps, hdc1,LOGPIXELSY	;query pixels/inch.
	mov  yscreenpixels,eax
	invoke ReleaseDC, g_hwnd,hdc1

;find out resolution of the printer...
	invoke getprinterdetails ;-->szname,szdriver,szport
	invoke CreateDC, 0,ADDR szname,0,0
	;...1st param was "ADDR szdriver", now NULL for win95.
	;...2nd last param was "ADDR szport" (LPT1: normally),
	;win95 prefers NULL.
	mov  hdcp,eax
	invoke GetDeviceCaps, hdcp,LOGPIXELSX	;query pixels/inch.
	mov  xprintpixels,eax
	invoke GetDeviceCaps, hdcp,LOGPIXELSY	;query pixels/inch.
	mov  yprintpixels,eax
	invoke GetDeviceCaps, hdcp,HORZRES	;query width in pixels.
	mov  g_nxprnpixsize,eax
	invoke GetDeviceCaps, hdcp,VERTRES	;query height in pixels.
	mov  g_nyprnpixsize,eax
	invoke DeleteDC, hdcp
;caclulate the ratio...
	mov  eax,xprintpixels	;print width. unsigned.
	shl  eax,1			;*4, so can be more accurate.
	shl  eax,1			;/
	xor  edx,edx
	mov  ebx,xscreenpixels	;screen width, unsigned.
	div  ebx		;unsigned divide
;***NOTE*** g_nxratio & g_nyratio should always be +ve,
;but i've defined them as SDWORD.
	mov  g_nxratio,eax	;display>printer scaling, x.
	mov  eax,yprintpixels	;print paper height.
	shl  eax,1			;*4, more accurate.
	shl  eax,1			;/
	xor  edx,edx
	mov  ebx,yscreenpixels	;display height.
	div  ebx
	mov  g_nyratio,eax	;display>printer scaling, y.

;setup logical-->device scaling...
	  mov  eax,g_nxprnpixsize		;size of paper, found above.
	  mov  ebx,g_nyprnpixsize		;/
	      .IF g_nxratio>1	    ;should always be!(higher prtr res.)
		  xor  edx,edx				   ;prn/scrn ratio
		  shl eax,1		;cos we modified xratio*4
		  shl eax,1		; back in xcreate.
		  div  g_nxratio	;scale-up by prn/scrn ratio. ;/
;		  shl eax,1		;cos we modified xratio*4
;		  shl eax,1		; back in xcreate.
		  push eax 				     ;/
		    mov  eax,ebx				     ;/
		    xor  edx,edx				     ;/
		  shl eax,1		;cos we modified xratio*4
		  shl eax,1		; back in xcreate.
		  div	g_nyratio			 ;/
;		    shl  eax,1		;ditto, correct yratio*4
;		    shl  eax,1		;/
		  mov  ebx,eax	 ;new .rc_right in ax		 ;/
		  pop  eax	;new .rc_bottom in bx.	       ;/
	      .ENDIF
	  ;***NOTE*** actually +ve values, but these vars are signed...
	  sub eax,XMARGINADJ
	  mov  xwinext,eax	;save. used by ctrl-arrow keys.
	  sub ebx,YMARGINADJ
	  mov  ywinext,ebx	;/




      mov g_nstate,0
      mov g_pmovingobject,0
      mov g_pselectedobjectnew,0
	invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
    ret
wmcreate ENDP


;--------------------------------------------------------------------------
.DATA
szerrfree2 DB "E011: GOOSEE was unable to free a RAM memory block. "
		DB "Don't know the cause, but it isn't good.",0
.CODE
wmdestroy PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
	;close current datafile memory block...
	.IF pTERSEDATA==0
	.ELSE
	  ;it should always be non-zero, meaning a mem block exists...

	    .IF  g_fhaschanged==1
	      invoke MessageBox,g_hwnd,ADDR szchanged,ADDR szgoosee,MB_OK+MB_YESNO+MB_ICONQUESTION
	      .IF ax==IDYES
		invoke savedatafile
	      .ENDIF
	    .ENDIF


	  ;free the memory block...
		invoke LocalFree, pTERSEDATA
		mov pTERSEDATA,0
	      .IF g_fhack1==1
	        ;user selected close-box at top of window (see WM_SYSCOMMAND)
	        ;seems that Windows frees the local memory block before
	        ;getting here, so the above will fail.
		;so, don't give any error msg.
		;NO!!! i just got the return flag wrong...
		jmp SHORT freeme
	      .ELSE
freeme:		  .IF eax==0   ;0 if *succeeds*
		  .ELSE
			;LocalFree() failed...
			lea eax,szerrfree2			;E011
                  invoke MessageBox, g_hwnd, eax,\
        		 	  ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
		  .ENDIF
	      .ENDIF
	.ENDIF

    invoke PostQuitMessage,0
    ret
wmdestroy ENDP
;--------------------------------------------------------------------------
.DATA
szerrnewnode1 DB "E012: GOOSEE cannot add another element to database, "
          BYTE "as RAM block cannot be resized.",0
.CODE
createnewobject PROC STDCALL USES esi edi ebx ecx edx, fatend:DWORD
	LOCAL pnewobject:DWORD
	LOCAL rpnewobject:DWORD
	mov pnewobject,0
;menu selection to create new node, via IDM_NODE, comes here...
;ditto for all other new elements (wires, etc).   "createnewobject"
;300900 fatend=1 if new object must be created at end of database.

	;can only place new object if in norm state...
	;no, i'm calling this func from state5, so allow...
;	;(refer createdatawire())	    ***NOTE, NOT USING***
;	cmp g_nstate,5
;	je  SHORT ok1
	cmp g_nstate,0
	jne getout
;ok1:

	mov edi,pTERSEDATA				;start of mem block.
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;start of objects database.

;300900
;if fatend=1 must create new object at end of database...
      .IF fatend==1
	xor eax,eax
        mov ax,(TERSEDATA PTR [edi]).nsizeobject
	xor ecx,ecx
	xor edx,edx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	mul ecx 	;eax=size of OBJECTS database.
	add esi,eax	;esi=address beyond end of database.
	jmp atend1
      .ENDIF

;search objects database for null (empty) object...
   xor ecx,ecx
   mov cx,(TERSEDATA PTR [edi]).numobjects
   .IF ecx==(DWORD PTR 0)                       ;hope this never happens.
   .ELSE
nod1:   test (OBJECT PTR [esi]).fstatus,01       ;bit0=0 if null object.
	jz foundone			;with esi ptg to found object.
        xor eax,eax
        mov ax,(TERSEDATA PTR [edi]).nsizeobject
        add  esi,eax
	loop nod1
   .ENDIF
	  ;no null objects, so increase mem block and create a new one...
      ;we come here with esi->beyond end of TERSEDATA.

atend1:
;	 mov pnewobject,esi  ;save.
	 ;no, bug. we need to save a relative addr...
	 mov eax,esi	     ;don't change esi here, need it below.
	 sub eax,pTERSEDATA
	 mov rpnewobject,eax

        mov eax,pTERSEDATA
        sub esi,eax         ;gives total size of TERSEDATA.
        add esi,(SIZEOF OBJECT) ;make it bigger.
        mov g_nfilesize,esi   ;save it here.
            invoke LocalReAlloc, pTERSEDATA,g_nfilesize,LMEM_MOVEABLE
					;all absolute pointers are invalid...
					mov g_pmovingobject,0
					mov poldmovingobject,0
					mov g_pselectedobject,0
					mov g_pselectedobjectnew,0
					mov g_phighlightedobject,0
					mov poldmovingobject,0
					mov g_perrorobject,0
					mov wipeoutsindex,0
					mov updatesindex,0
					mov highlightedindex,0
					mov g_nstate,0
					mov highlightedindexnewlist,0
	    .IF eax==0
              ;fail...
              lea eax,szerrnewnode1
              jmp err1        ;error message and close file.
            .ELSE
              mov pTERSEDATA,eax    ;new pointer.
	    .ENDIF

	   ;now copy instantiatedOBJECT to the new object...
	    mov edi,pTERSEDATA
	    mov ebx,rpnewobject ;fix
	    add ebx,edi 	;make absolute addr new object.
	    mov pnewobject,ebx	;save it.
	    lea esi,instantiatedOBJECT ;default to copy to memblock
            mov ecx,(SIZEOF OBJECT)
oo1:        mov al,[esi]
	    mov [ebx],al    ;append end of objects database.
			inc ebx
			inc esi
			dec ecx
			jnz oo1
	  ;update...
		inc (TERSEDATA PTR [edi]).numobjects
		jmp done	;new object created. pnewobject pts to it.

foundone:	mov pnewobject,esi
		;this is an existing empty object, but may
		;have stuff in it from earlier usage!!!...
	    mov edi,pTERSEDATA
            mov ebx,pnewobject
	    lea esi,instantiatedOBJECT ;default to copy to memblock
            mov ecx,(SIZEOF OBJECT)
oo3:	   mov al,[esi]
	    mov [ebx],al
			inc ebx
			inc esi
			dec ecx
			jnz oo3

done:

;defaultnew***() sets the fields for each type of object, but all of
;them need an element number...
	mov ebx,pTERSEDATA
	lea ecx,(TERSEDATA PTR [ebx]).OBJECTS ;start of objects database.
	mov eax,pnewobject
	sub eax,ecx
	xor edx,edx
	xor ecx,ecx
	mov ecx,(SIZEOF OBJECT) ;(TERSEDATA PTR [ebx]).nsizeobject
	div ecx
	mov esi,pnewobject
	mov (OBJECT PTR [esi]).number,ax

	mov eax,pnewobject	;return this.
	ret
getout:
	xor eax,eax				;return 0, no new obj.
	ret
err1:
      invoke MessageBox, g_hwnd, eax,\
     	 	  ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
	xor eax,eax				;return 0.
	ret
createnewobject ENDP
;--------------------------------------------------------------------------
defaultnewnode PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
    LOCAL dummy:DWORD
; "defaultnewnode"
;menu selection to create new node, via IDM_NODE, via createnewobject().
;now have to customise new object with default settings for a node.
;entered with pnew ptg to new node in mem block.
	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,0	;it is a node.
	mov (OBJECT PTR [edi]).nexttype,0	;normal node.
	mov (OBJECT PTR [edi]).wwidth,32
	mov (OBJECT PTR [edi]).height,32
;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid node.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (pnode-ptrs)

;concentric, totem, rings...
    and (OBJECT PTR [edi]).fconfig3,11100011b
    mov ebx,pTERSEDATA
    mov al,(TERSEDATA PTR [ebx]).fviewprefs
    and al,01100b   ;bits 3/2, new node ring defaults.
    .IF al==0	    ;concentric.
	mov (OBJECT PTR [edi]).xdeltacentre,0	;default anyway.
	mov (OBJECT PTR [edi]).ydeltacentre,0	;/
	mov (OBJECT PTR [edi]).nringwidth,8 ;gap between each conc. ring.
    .ELSEIF al==00100b ;totem, grow-up.
	;offset each ring...
	mov (OBJECT PTR [edi]).xdeltacentre,0	;default anyway.
	mov (OBJECT PTR [edi]).ydeltacentre,-42
	mov (OBJECT PTR [edi]).nringwidth,0 ;gap between each conc. ring.
	  ;flag set for non-concentric rings...
	  or (OBJECT PTR [edi]).fconfig3,0100b	;set bit2.
	  ;...snap_tonode(), on_node(), paint_node() test .wwidth/.height
    .ELSEIF al==01000b	;totem, grow-down.
	;offset each ring...
	mov (OBJECT PTR [edi]).xdeltacentre,0	;default anyway.
	mov (OBJECT PTR [edi]).ydeltacentre,42
	mov (OBJECT PTR [edi]).nringwidth,0 ;gap between each conc. ring.
	  ;flag set for non-concentric rings...
	  or (OBJECT PTR [edi]).fconfig3,1100b	;set bits3/2.
	  ;...snap_tonode(), on_node(), paint_node() test .wwidth/.height
    .ENDIF

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

	ret
defaultnewnode ENDP
;--------------------------------------------------------------------------
defaultnewcommand PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
    LOCAL dummy:DWORD
; "defaultnewcommand"
;031000
;this is actually a node, with dblclk-action =command.
;i decided to create it separately and it will have its own icon.
;menu selection to create new node, via IDM_NODE, via createnewobject().
;now have to customise new object with default settings for a node.
;entered with pnew ptg to new node in mem block.

;121000 ... now has its own methods "pexec" (based on node methods)...

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,010000b	;it is a node.
	  ;...bits 4/3 =1/0 dblclk-action =execute a command.
	mov (OBJECT PTR [edi]).nexttype,60	;execution-icon.
	mov (OBJECT PTR [edi]).wwidth,48 ;32
	mov (OBJECT PTR [edi]).height,48 ;32
;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid node.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (pexec-ptrs)

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

;color-fill for "command" dblclk action...
	  or   (OBJECT PTR [edi]).fconfig,0100b ;turn on color-fill.
	  mov  (OBJECT PTR [edi]).ncolour1,0FFh ;bright red.
	    ;... prior to v1.08 it was =0FF00FFh ;pink-purple.

;;set ring-color to purple-pink (same as fill)...
;    mov (OBJECT PTR [edi]).nring1colorindex,3

	ret
defaultnewcommand ENDP
;--------------------------------------------------------------------------
defaultnewinfo PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
    LOCAL dummy:DWORD
; "defaultnewinfo"
;131000
;elements/text-fileicon --> idm_infoicon --> here
;this is based on execution-icon/defaultnewcommand(),
;which is based on a node node, with dblclk-action =command.
;i decided to create it separately and it will have its own icon.
;entered with pnew ptg to new node in mem block.

;121000 ... now has its own methods "pinfo" (based on pexec methods)...

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,001000b	;bit0=it is a node.
	  ;...bits 4/3 =0/1 dblclk-action =open a custom filename.
	mov (OBJECT PTR [edi]).nexttype,61	;text-file-icon.
	mov (OBJECT PTR [edi]).wwidth,48 ;32
	mov (OBJECT PTR [edi]).height,48 ;32
;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid node.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (pinfo-ptrs)

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

;color-fill for "command" dblclk action...
	  or   (OBJECT PTR [edi]).fconfig,0100b ;turn on color-fill.
	  mov  (OBJECT PTR [edi]).ncolour1,0FF00FFh  ;purple-pink "fuschia"
	    ;... was =08080FFh ;B-G-R, pale-red.

;;set ring-color to purple-pink (same as fill)...
;    mov (OBJECT PTR [edi]).nring1colorindex,3

	ret
defaultnewinfo ENDP
;--------------------------------------------------------------------------
defaultnewmake PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
    LOCAL dummy:DWORD
; "defaultnewmake"
;171000
;elements/make-icon --> idm_makeicon --> here
;this is based on execution-icon/defaultnewcommand(),
;which is based on a node node, with dblclk-action =command.
;i decided to create it separately and it will have its own icon.
;has its own methods-row  "pmake" based on pinfo methods...

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,001000b	;bit0=it is a node.
	  ;...bits 4/3 =0/1 dblclk-action =open a custom filename.
	mov (OBJECT PTR [edi]).nexttype,62	;make-icon.
	mov (OBJECT PTR [edi]).wwidth,48 ;32
	mov (OBJECT PTR [edi]).height,48 ;32
;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid node.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (pmake-ptrs)

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

;color-fill for "command" dblclk action...
	  or   (OBJECT PTR [edi]).fconfig,0100b ;turn on color-fill.
	  mov  (OBJECT PTR [edi]).ncolour1,0000FFh ;B-G-R, bright-red.

;;set ring-color to purple-pink (same as fill)...
;    mov (OBJECT PTR [edi]).nring1colorindex,3

	ret
defaultnewmake ENDP
;--------------------------------------------------------------------------
defaultnewres PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
    LOCAL dummy:DWORD
; "defaultnewres"
;menu selection to create new res, via IDM_RES, via createnewobject().
;now have to customise new object with default settings for a resource.
;entered with pnew ptg to new object in mem block.

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,0	;it is a node/res.
	mov (OBJECT PTR [edi]).nexttype,03	;hidden resource.
	mov (OBJECT PTR [edi]).wwidth,26 ;24  ;32
	mov (OBJECT PTR [edi]).height,14 ;16
;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid res.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;value set at IDM_RES, etc...
    mov al,fvartype
    mov (OBJECT PTR [edi]).fstatus2,al ;variable type (simple variable,
		    ;pointer, structure, etc.)

;structure data, .ndatatype is structure type...
    .IF fvartype==01000000b
      mov (OBJECT PTR [edi]).ndatatype,0
    .ENDIF

;generic data...
    .IF fvartype==10000000b
	mov (OBJECT PTR [edi]).wwidth,12 ;26
    .ENDIF

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (pres-ptrs)

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

	ret
defaultnewres ENDP
;--------------------------------------------------------------------------
defaultnewhardware PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
    LOCAL dummy:DWORD
;menu selection to create new hardware obj, via IDM_HARDWARE,
;via createnewobject().
;now have to customise new object with default settings for a hardware.
;entered with pnew ptg to new object in mem block.

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,0	;it is a node-type..
	mov (OBJECT PTR [edi]).nexttype,50	;hardware. private-type.
	mov (OBJECT PTR [edi]).wwidth,26 ;24 ;16
	mov (OBJECT PTR [edi]).height,14 ;16
;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid res.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;;paint_hard draws a cross to designate box as different from data,
;;but don't think enough impact. use red fill...
;    mov (OBJECT PTR [edi]).ncolour1,0255    ;red
;    mov (OBJECT PTR [edi]).fconfig,0100b    ;bit2=1, display colour.

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (phard-ptrs)

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

	ret
defaultnewhardware ENDP
;--------------------------------------------------------------------------
defaultnewcom PROC STDCALL USES ebx ecx edx edi esi, pnew:DWORD
    LOCAL dummy:DWORD
;menu selection to create new comment, via IDM_COMMENT, via createnewobject().
;now have to customise new object with default settings for a comment.
;entered with pnew ptg to new object in mem block.

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,0	;it is a node/res type.
	mov (OBJECT PTR [edi]).nexttype,30	;comment object.
	mov (OBJECT PTR [edi]).wwidth,4
	mov (OBJECT PTR [edi]).height,4
;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid object.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (pcmt-ptrs)

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

	ret
defaultnewcom ENDP
;--------------------------------------------------------------------------
defaultnewcondition PROC STDCALL USES ebx ecx edx edi esi, pnew:DWORD
    LOCAL dummy:DWORD
;menu selection to create new condition, via IDM_CONDITION, via createnewobject().
;now have to customise new object with default settings for a condition.
;entered with pnew ptg to new object in mem block.

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,0	;it is a node/res type.
	mov (OBJECT PTR [edi]).nexttype,32	;condition object.
	mov (OBJECT PTR [edi]).wwidth,4
	mov (OBJECT PTR [edi]).height,4
	mov (OBJECT PTR [edi]).nbeginring,0 ;not yet owned by a node.
;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid object.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

	mov (OBJECT PTR [edi]).fconfig2,01  ;bit0=1 if-then condition.

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (pcond-ptrs)

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

	ret
defaultnewcondition ENDP
;--------------------------------------------------------------------------
defaultnewaction PROC STDCALL USES ebx ecx edx edi esi, pnew:DWORD
    LOCAL dummy:DWORD
;menu selection to create new action, via IDM_ACTION, via createnewobject().
;now have to customise new object with default settings for a action.
;entered with pnew ptg to new object in mem block.

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,0	;it is a node/res type.
	mov (OBJECT PTR [edi]).nexttype,33	;action object.
	mov (OBJECT PTR [edi]).wwidth,4
	mov (OBJECT PTR [edi]).height,4
	mov (OBJECT PTR [edi]).nbeginring,0 ;not yet owned by a node.
;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid object.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (pact-ptrs)

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

	ret
defaultnewaction ENDP
;--------------------------------------------------------------------------
defaultnewwire PROC STDCALL USES ebx ecx edx edi esi, pnew:DWORD
    LOCAL dummy:DWORD
; "defaultnewwire"
;menu selection to create new execution-flow wire, via IDM_WIRE,
;via createnewobject().
;now have to customise new object with default settings for a
;execution-flow wire.
;entered with pnew ptg to new object in mem block.
;i've created a global variable "nnewwiretype" set by IDM_WIRE,
;IDM_SYNC2, IDM_ASYNC1, IDM_ASYNC2.

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,1 ;bit0=1, it is a wire type.

	mov ax,nnewwiretype ;see note above.
	.IF ax==999	    ;see IDM_INTER. inter-task wire.
	  mov (OBJECT PTR [edi]).nexttype,10
	  or (OBJECT PTR [edi]).fconfig,0100000b ;set bit5
	.ELSE
	mov (OBJECT PTR [edi]).nexttype,ax
	.ENDIF

;start with a short wire...
	mov eax,(OBJECT PTR [edi]).xtopleft
	add eax,10
	mov (OBJECT PTR [edi]).xknee2,eax
	add eax,10
	mov (OBJECT PTR [edi]).xmid,eax
	add eax,10
	mov (OBJECT PTR [edi]).xknee3,eax
	add eax,10
	mov (OBJECT PTR [edi]).wwidth,eax   ;wwidth is end-x for wires.
	mov eax,(OBJECT PTR [edi]).ytopleft
	sub eax,10
	mov (OBJECT PTR [edi]).yknee2,eax
	sub eax,10
	mov (OBJECT PTR [edi]).ymid,eax
	sub eax,10
	mov (OBJECT PTR [edi]).yknee3,eax
	sub eax,10
	mov (OBJECT PTR [edi]).height,eax

;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid object.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (parc-ptrs)

;for async wires, need to assign unique numbers...
;these are used in the issig() postsig() mechanism...
	mov ax,(OBJECT PTR [edi]).nexttype
	.IF ax==13	;async 1-way.
	  jmp SHORT dd1
	.ELSEIF ax==14	;async 2-way.
dd1:	  invoke assignasyncnumber, edi
	  mov (OBJECT PTR [edi]).nprimary,ax	 ;used for postsig()
	  inc eax
	  mov (OBJECT PTR [edi]).nsecondary,ax	 ;/
	.ENDIF

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

	ret
defaultnewwire ENDP
;--------------------------------------------------------------------------
assignasyncnumber PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
    LOCAL nlowestfree:WORD, nlowestold:WORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
;called from defaultnewwire().
;scan database, find all asyncs, look for unique new number to assign
;to .nprimary and .nsecondary fields.
;return .nprimary value in eax.

zz0:	mov nlowestfree,0

zz1:	mov ax,nlowestfree
	mov nlowestold,ax

	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp nextobjy
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	.IF ax==01	;bit0=1, valid object.
	  .IF esi==pnew	;don't test itself.
	  .ELSE

	    mov ax,(OBJECT PTR [esi]).nexttype

	    .IF ax==13	     ;async 1-way.
	      jmp SHORT ss1
	    .ELSEIF ax==14   ;async 2-way.
ss1:	      mov bx,(OBJECT PTR [esi]).nprimary
	      .IF bx==nlowestfree
		inc nlowestfree
		inc nlowestfree
	      .ENDIF
	    .ENDIF

	  .ENDIF
	.ENDIF
	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop nextobjx
    jmp  SHORT nextobjy
nextobjx: jmp nextobj
nextobjy:

    mov ax,nlowestfree
    cmp ax,nlowestold
    jne zz1		;keep looking

      xor eax,eax
      mov ax,nlowestfree

    ret
assignasyncnumber ENDP
;--------------------------------------------------------------------------
defaultnewdatawire PROC STDCALL USES ebx ecx edx edi esi, pnew:DWORD
    LOCAL dummy:DWORD
;menu selection to create new data-flow wire, via IDM_WI,
;now have to customise new object with default settings for a
;data-flow wire.
;entered with pnew ptg to new object in mem block.
;dataflow wires can be of two types nexttype=15 normal (no arrows
;either end) =17 interrupt (zigzag at destination end) -- refer
;draw2ndarrow().

	mov edi,pnew
	mov (OBJECT PTR [edi]).fconfig,1 ;bit0=1, it is a wire type.
	mov (OBJECT PTR [edi]).nexttype,15 ;dataflow wire.

;start with a short wire...
	mov eax,(OBJECT PTR [edi]).xtopleft
	add eax,10
	mov (OBJECT PTR [edi]).xknee2,eax
	add eax,10
	mov (OBJECT PTR [edi]).xmid,eax
	add eax,10
	mov (OBJECT PTR [edi]).xknee3,eax
	add eax,10
	mov (OBJECT PTR [edi]).wwidth,eax   ;wwidth is end-x for wires.
	mov eax,(OBJECT PTR [edi]).ytopleft
	sub eax,10
	mov (OBJECT PTR [edi]).yknee2,eax
	sub eax,10
	mov (OBJECT PTR [edi]).ymid,eax
	sub eax,10
	mov (OBJECT PTR [edi]).yknee3,eax
	sub eax,10
	mov (OBJECT PTR [edi]).height,eax

;	mov (OBJECT PTR [edi]).fstatus,01	;now a valid object.
	  ;ah, but want bit5=1 so default is to display label...
	  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
	mov (OBJECT PTR [edi]).rpmethods,OFFSET (parc-ptrs)


;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

	ret
defaultnewdatawire ENDP
;--------------------------------------------------------------------------
defaultnewexclusion PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
    LOCAL dummy:DWORD
;from Objects/Wires.../Mutual-exclusion > IDM_JBDN
;note that we will assign the mutual-exclusion wire TERSEDATA.nexttype=22.
;note, .number of object set in createnewobject().

;***NOTE*** not yet implemented.


  ret
defaultnewexclusion ENDP
;--------------------------------------------------------------------------
.DATA
nmxold SDWORD 0
nmyold SDWORD 0
deltax SDWORD 0
deltay SDWORD 0

.CODE
wmmousemove PROC STDCALL wmsg:DWORD,wparam:DWORD,lparam:DWORD
;WM_MOUSEMOVE causes entry here.

;if mousemove to boundary, can we scroll screen?...  "wmmousemove"
  mov ebx,pTERSEDATA
  mov al,(TERSEDATA PTR [ebx]).fgooseeprefs
  and al,0100b		;bit2=1 disable scrolling by mouse.
  .IF al==0
    invoke scrollingbymouse, wparam,lparam
  .ENDIF

;lparam is client coords, origin is top/left of client area...
	invoke  origincorrection, lparam  
		;returns corrected for origin-shift in g_nmousex & g_nmousey
	  ;i'll correct lparam as well, cos old goofee code expected it...
	  ;wmmousemove()>WM_USER>xuser() does.
	  mov eax,g_nmousex
	  mov WORD PTR lparam,ax
	  mov eax,g_nmousey
	  mov WORD PTR lparam+2,ax

	invoke	displaymouse, g_nmousex,g_nmousey ;display mouse coords.

;save mouse coords, so can calc change each time...
	.IF nmxold==0
	  mov deltax,0
	.ELSE
	  mov eax,g_nmousex
	  sub eax,nmxold
	  mov deltax,eax
	.ENDIF
	mov eax,g_nmousex
	mov nmxold,eax
	.IF nmyold==0
	  mov deltay,0
	.ELSE
	  mov eax,g_nmousey
	  sub eax,nmyold
	  mov deltay,eax
	.ENDIF
	mov eax,g_nmousey
	mov nmyold,eax


	.IF g_nstate==0 	   ;normal state at startup & during operation.
	  ;if there are new duplicated elements, they will track the mouse
	  ;until lbuttonup...
	  .IF highlightedindexnewlist==0
	    ;if highlighted elements are being moved, fmovinghighlighted=1...
	    .IF fmovinghighlighted==0
	    .ELSE
	      invoke updatemove
	      invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
	      mov  g_fredrawdiag,ENTIRE
	    .ENDIF
	  .ELSE
	    invoke updateduplicates
	    invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
	    mov  g_fredrawdiag,ENTIRE
	  .ENDIF


	.ELSEIF g_nstate==1	   ;a prior lbuttondn has selected an obj.
          ;...can only come here from state-0.
	  ;g_pselectedobjectnew=object selected
	  ;A selected object cannot be highlighted (g_phighlightedobject,
	  ; state-2)as mouse moved.
	    mov eax,g_pselectedobjectnew
            mov g_pmovingobject,eax      ;required for state-8.
	    mov g_pselectedobjectnew,0
	    mov g_nstate,8

	.ELSEIF g_nstate==2	 ;...this state, an obj is highlighted.
                              ;ignore.

	.ELSEIF g_nstate==4	   ;a new object is being placed, first "end".
                                ;...can only come here from state-0.
          ;new object must track the mouse...(first-end not yet placed)
          ;before moving the object, erase its current location...
	    invoke add2wipeoutlist, g_pmovingobject
          invoke PostMessage, g_hwnd,WM_USER+100h,wparam,lparam
                                        ;come back to draw new position.
	    invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
	    mov  g_fredrawdiag,WIPEOUTobjs
	    invoke UpdateWindow, g_hwnd		;wipe immediately.
          ;...will stay in this state until lbuttondn.

	.ELSEIF g_nstate==5	   ;a new obj is being placed, second "end".
                                ;...can only come here from state-4.
          ;lbuttondn on a node, while dragging a new wire, causes state-5.
	  ;the other-end of the wire has to track the mouse...
;ditto for any objects, if placed by lbuttondown on top of existing
;object, it becomes parent. now we are dragging it away from middle
;of parent...

	  .IF g_pmovingobject==0	  ;precaution.
	    mov g_nstate,0		;precaution
	  .ELSE
	    ;before moving the object, erase its current location...
	    invoke add2wipeoutlist, g_pmovingobject ;(attached wires
	    mov edi,g_pmovingobject
	    .IF g_naccelx != 0		;non-0 =scrolling is happening.
	      jmp SHORT xacc1
	    .ELSE
	      .IF g_naccely != 0
xacc1:		;scrolling() has already called updatewindow().
		invoke PostMessage,g_hwnd,WM_USER+2+100h,wparam,lparam
			;NOTE lparam is now WORLD coords.(see above)
	      .ELSE	;no scrolling happening.
		invoke PostMessage, g_hwnd,WM_USER+2+100h,wparam,lparam
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw bkgrnd.
		mov  g_fredrawdiag,WIPEOUTobjs
		invoke UpdateWindow, g_hwnd	     ;wipe immediately.
	      .ENDIF
	    .ENDIF
	  .ENDIF


	.ELSEIF g_nstate==8	;an object is being moved.(dragged)
				;...can only come here from state-1.

	  ;g_pmovingobject=object being moved.
	  .IF g_pmovingobject==0	  ;precaution.
	    mov g_nstate,0		;precaution
	  .ELSE
	    ;before moving the object, erase its current location...
	    invoke add2wipeoutlist, g_pmovingobject
	    mov edi,g_pmovingobject
	    mov  ebx,(OBJECT PTR [edi]).rpmethods
	    invoke wipePTR PTR [ebx+ptrs+pwipeslaves], g_pmovingobject
		;... adds any slave-objects to wipeout-list.
	    .IF g_naccelx != 0		;non-0 =scrolling is happening.
	      jmp SHORT acc1
	    .ELSE
	      .IF g_naccely != 0
acc1:		;scrolling() has already called updatewindow().
		invoke PostMessage,g_hwnd,WM_USER+1+100h,wparam,lparam
			;NOTE lparam is now WORLD coords.(see above)
			;xuser1 adds g_pmovingobject+slaves to updatelist.
	      .ELSE	;no scrolling happening.
		invoke PostMessage, g_hwnd,WM_USER+1+100h,wparam,lparam
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw bkgrnd.
		mov  g_fredrawdiag,WIPEOUTobjs
		invoke UpdateWindow, g_hwnd	     ;wipe immediately.
	      .ENDIF
	    .ENDIF
	  .ENDIF
stay1:	  ;...will stay in this state until lbuttonup.


; **NO** g_nstate=8 used for moving ends (with g_nknee=4 or 5)...

	.ELSEIF g_nstate==10	;beginning-end of a wire is being moved.
	  ;before moving the object, erase its current location...
;	  invoke add2wipeoutlist, g_phighlightedobject
;	  inc  externsync
;     invoke POSTMESSAGE, iihwnd,WM_USER+5+100h,iiwparam,iilparam
;                                        ;come back to draw new position.
;	  invoke INVALIDATERGN, iihwnd,0,FALSE ;TRUE
;	  mov  g_fredrawdiag,WIPEOUTobjs
;	  invoke UPDATEWINDOW, iihwnd		;wipe immediately.

	.ELSEIF g_nstate==11	;destination-end of a wire is being moved.
	  ;before moving the object, erase its current location...
;	  invoke add2wipeoutlist, g_phighlightedobject
;	  inc  externsync
;     invoke POSTMESSAGE, iihwnd,WM_USER+6+100h,iiwparam,iilparam
;                                        ;come back to draw new position.
;	  invoke INVALIDATERGN, iihwnd,0,FALSE ;TRUE
;	  mov  g_fredrawdiag,WIPEOUTobjs
;	  invoke UPDATEWINDOW, iihwnd		;wipe immediately.


	.ELSEIF g_nstate==20
	  ;menu "control/selection rectangle"-->IDM_RECT-->state=20
	  ;do nothing (need lbuttondown to put it into state=21)

	.ELSEIF g_nstate==21 ;drawing 2nd corner selection-rectangle.
	  ;menu "control/selection rectangle" -->IDM_RECT-->state=20.
	  mov g_nstate,22   ;flag a mouse-move has occurred.
	  jmp SHORT yy9

	.ELSEIF g_nstate==22
yy9:	  ;paint wipeout immediately...
	    invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
	    mov	g_fredrawdiag,WIPEOUTobjs
	    push g_nmousex
	    push g_nmousey
	    invoke UpdateWindow, g_hwnd		;wipe immediately.
	    pop g_nmousey
	    pop g_nmousex
	    mov eax,g_nmousex
	    mov n2ndx,eax
	    mov eax,g_nmousey
	    mov n2ndy,eax
	  ;paint immediately...
	  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
	  mov  g_fredrawdiag,ENTIRE
	    push g_nmousex
	    push g_nmousey
	  invoke UpdateWindow, g_hwnd
	    pop g_nmousey
	    pop g_nmousex


	.ELSE
	  mov g_nstate,0	    ;error, default back to state 0.
	.ENDIF

	ret
wmmousemove ENDP
;--------------------------------------------------------------------------
newmousetrack PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,wparam:DWORD,lparam:DWORD
;called by "new object" --> state=4 -->WM_MOUSEMOVE --> wmmousemove()
; --> WM_USER+100h --> xuser().
;display object at mouse coords.
;note that when coords origin shifted from window top corner or zoom not 0,
;taken care of by wmmousemove() --> origincorrection().

          mov edi,pobj
          mov ax,WORD PTR lparam       ;mouse x-coord
	    cwde
          mov (OBJECT PTR [edi]).xtopleft,eax
          mov ax,WORD PTR lparam+2    ;y-coord
	    cwde
          mov (OBJECT PTR [edi]).ytopleft,eax

	mov al,(OBJECT PTR [edi]).fconfig
	and al,01			;extract bit0.
	.IF al==01			;bit0=1 wire.
          mov ax,WORD PTR lparam             ;just draw a short wire.
	    cwde
	    add eax,10			       ;/
	    mov (OBJECT PTR [edi]).xmid,eax
	    add eax,10
          mov (OBJECT PTR [edi]).wwidth,eax     ;/
          mov ax,WORD PTR lparam+2           ;/
	    cwde
	    add eax,10			       ;/
	    mov (OBJECT PTR [edi]).ymid,eax
	    add eax,10
	    mov (OBJECT PTR [edi]).height,eax	;/
	.ELSE
	    ;object is a node (any type), so xmid/ymid should also track....
	    xor eax,eax
	    mov  eax,(OBJECT PTR [edi]).wwidth
	    sar  eax,1				;xradius.
	    mov  ebx,(OBJECT PTR [edi]).xtopleft
	    add  eax,ebx
	    mov  (OBJECT PTR [edi]).xmid,eax		;centre of node
	    mov  eax,(OBJECT PTR [edi]).height
	    sar  eax,1				;yradius.
	    mov  ebx,(OBJECT PTR [edi]).ytopleft
	    add  eax,ebx
	    mov  (OBJECT PTR [edi]).ymid,eax		;centre of node.
	.ENDIF
	 

	ret
newmousetrack ENDP
;--------------------------------------------------------------------------
nearobjects PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD
	LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD,ebxsave:DWORD
; "nearobjects"
;we can quickly scan database; any object near mouse will get added
;to updatelist...    uses g_nmousex/g_nmousey....

;this code basically same as inside xpaint_entire()...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0 ;empty.
	    jmp kf4
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	    mov ax,(OBJECT PTR [esi]).nexttype
	    .IF ax==-1
	    .ELSE		;not a data object.
;		;now ask if object close to pobj...
;	      mov esi,pobj
;	      mov  eax,(OBJECT PTR [esi]).xmid
;	      and  ax,0FFC0h			;rough roundoff.
;	      mov  ebx,(OBJECT PTR [esi]).ymid
;	      and  bx,0FFC0h
;	      mov  edx,g_nmousex
;	      and  dx,0FFC0h
;	      .IF  eax==edx
;		mov  edx,g_nmousey
;		and  dx,0FFC0h
;		.IF  ebx==edx
;	       invoke add2updatelist,esisave
;		.ENDIF
;	      .ENDIF
	      mov eax,(OBJECT PTR [esi]).xmid
	      sub eax,g_nmousex
	      .IF SDWORD PTR eax<0
		neg eax
	      .ENDIF
	      .IF eax<100
		mov eax,(OBJECT PTR [esi]).ymid
		sub eax,g_nmousey
		.IF SDWORD PTR eax<0
		  neg eax
		.ENDIF
		.IF eax<100
		  invoke add2updatelist,esi
		  jmp kf1
		.ENDIF
	      .ENDIF
	      mov al,(OBJECT PTR [esi]).fconfig
	      and al,01
	      .IF al==01    ;wire-type
		mov eax,(OBJECT PTR [esi]).xtopleft
		sub eax,g_nmousex
		.IF SDWORD PTR eax<0
		  neg eax
		.ENDIF
		.IF eax<40
		  mov eax,(OBJECT PTR [esi]).ytopleft
		  sub eax,g_nmousey
		  .IF SDWORD PTR eax<0
		    neg eax
		  .ENDIF
		  .IF eax<40
		    invoke add2updatelist,esi
		    jmp kf1
		  .ENDIF
		.ENDIF
		mov eax,(OBJECT PTR [esi]).wwidth
		sub eax,g_nmousex
		.IF SDWORD PTR eax<0
		  neg eax
		.ENDIF
		.IF eax<40
		  mov eax,(OBJECT PTR [esi]).height
		  sub eax,g_nmousey
		  .IF SDWORD PTR eax<0
		    neg eax
		  .ENDIF
		  .IF eax<40
		    invoke add2updatelist,esi
		    jmp kf1
		  .ENDIF
		.ENDIF
	      .ENDIF
	    .ENDIF
	  .ENDIF
kf1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop kf3 ;nextobj
    jmp SHORT kf4
kf3: jmp nextobj
kf4:

	ret
nearobjects ENDP
;--------------------------------------------------------------------------
xuser PROC STDCALL, wmsg:DWORD,wparam:DWORD,lparam:DWORD
;called via state=4 --> WM_MOUSEMOVE --> wmmousemove() --> WM_USER+100h msg.
;update position, and redraw, new moving object.
;when WM_PAINT is next generated, wmpaint() --> xpaint_update()
;(which paints to screen/printer from updatelist)

;we can quickly scan database; any object near mouse will get added
;to updatelist...
	invoke  nearobjects ,g_pmovingobject 
	;...if g_nmousex/g_nmousey near object.

 invoke  newmousetrack, g_pmovingobject,wparam,lparam ;object must follow mouse.

          invoke add2updatelist, g_pmovingobject
	  invoke InvalidateRgn, g_hwnd,0,FALSE ;TRUE	 ;*N0*updatewindow
	  mov  g_fredrawdiag,UPDATEobjs

	ret
xuser ENDP
;--------------------------------------------------------------------------
xuser1 PROC STDCALL, wmsg:DWORD,wparam:DWORD,lparam:DWORD
;called via wmmousemove()/state8   "xuser1"
;note that lparam is WORLD coords.
;this routine adds g_pmovingobject and any slave objects (locked to it)
;are also added to update list.


;we can quickly scan database; any object near mouse will get added
;to updatelist...
	invoke	nearobjects, g_pmovingobject

    mov edi,g_pmovingobject
    mov  ebx,(OBJECT PTR [edi]).rpmethods
    invoke dragPTR PTR [ebx+ptrs+pdrag], g_pmovingobject
    ;...pdrag takes care of adding any slave-objects to updatelist.
    ;...it also updates the coordinates of movingobject & slaves.
    invoke add2updatelist, g_pmovingobject ;add last so gets painted last.
    invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
    mov	g_fredrawdiag,UPDATEobjs

  ret
xuser1 ENDP
;--------------------------------------------------------------------------
xuser2 PROC STDCALL, wmsg:DWORD,wparam:DWORD,lparam:DWORD
;from wmmousemove()/state5 (2nd end being placed) > WM_USER+2

;we can quickly scan database; any object near mouse will get added
;to updatelist...
	invoke	nearobjects, g_pmovingobject

    mov edi,g_pmovingobject
    mov  ebx,(OBJECT PTR [edi]).rpmethods
    invoke dragPTR PTR [ebx+ptrs+pdrag], g_pmovingobject
    ;...pdrag takes care of adding any slave-objects to updatelist.
    ;(although this is a new object and hasn't got any)
    ;...it also updates the coordinates of movingobject & slaves.
    invoke add2updatelist, g_pmovingobject
    invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
    mov	g_fredrawdiag,UPDATEobjs


  ret
xuser2 ENDP
;--------------------------------------------------------------------------
xuser4 PROC STDCALL, wmsg:DWORD,wparam:DWORD,lparam:DWORD
;comes here indirectly via xpaint_print...
	      invoke InvalidateRgn, g_hwnd,0,FALSE
	      mov g_fredrawdiag,ENTIRE
	ret
xuser4 ENDP
;--------------------------------------------------------------------------


.DATA
;used by add2wipeoutlist() ...
numwipeouts   EQU 96
wipeouts      DWORD numwipeouts DUP (0) ;list of objects requiring erasing.
		  ;(contains pointers to the objects)
wipeoutsindex DWORD 0              ;index of next free entry.
.CODE
add2wipeoutlist PROC STDCALL USES eax ebx ecx edx edi esi, pobj:DWORD
    LOCAL dummy:BYTE
;adds the object, pobj, to the wipeout-list, for future screen repainting.
;difference from add2updatelist, is these objects are to be redraw
;same colour as background....

;see note in add2updatelist()...
    .IF pobj==0
      ret
    .ENDIF

         mov eax,pobj
         mov ebx,wipeoutsindex   ;index to next free entry.
       .IF DWORD PTR ebx<numwipeouts	  ;max size of wipeout-list buffer.
         shl ebx,1              ;convert to relative offset.
	   shl ebx,1		  ;/ (4 bytes per entry)
         lea esi,wipeouts        ;/
         cmp ebx,0              ;empty list.
         je  wipe3             ;/
wipe2:	dec ebx
	 	dec ebx
		dec ebx
		dec ebx
	   mov edx,[ebx+esi]	 ;find out if it is already in list.
         cmp edx,eax
         je  wipe			;jmp if it is.
	     cmp ebx,0
           jne wipe2
         mov ebx,wipeoutsindex    ;reload bx.
	 shl ebx,1		 ;/ 4 bytes
	 shl ebx,1		 ;/
wipe3:
         mov [ebx+esi],eax        ;add object to list
         inc wipeoutsindex      ;update index
wipe:
       .ENDIF
	invoke InvalidateRgn, g_hwnd,0,FALSE  ;TRUE
	 nop
 
	ret
add2wipeoutlist ENDP 
;--------------------------------------------------------------------------
.DATA
;used by add2updatelist() ...
numupdates   EQU	96
updates      DWORD numupdates DUP (0)  ;list of objects requiring screen 
			;updating. contains pointers to the objects.
updatesindex DWORD 0       ;index of next free entry in updates.

.CODE
add2updatelist PROC STDCALL USES eax ebx ecx edx edi esi, pobj:DWORD
    LOCAL dummy:BYTE
;WM_PAINT will cause objects in this list to be drawn.	"add2updatelist"
;adds the object, pobj, to the update-list, for future screen repainting.

;i had a problem that exited from snapclonewires2(), to snapclonewires(),
;to drag_arc(), with error eax=-1. drag_arc() exited back to xuser1()
;(which had been called from wmmousemove()/state8). situation was
;dragging a wire-end on master-clone of a clone-chain.
;anyway, comes back to xuer1() with g_pmovingobject=0, and then
;calls add2updatelist() with passed param of 0. so, screen this out...
    .IF pobj==0
      ret
    .ENDIF

         mov eax,pobj
         mov ebx,updatesindex   ;index to next free entry.
       .IF DWORD PTR ebx<numupdates	 ;max size of update-list buffer.
         shl ebx,1              ;convert to relative offset.
	   shl ebx,1		  ;(based on 4 bytes per entry)
         lea esi,updates        ;/
         cmp ebx,0              ;empty list.
         je  nadd3             ;/
nadd2:	dec ebx			;find out if it is already in list.
	      dec ebx			;/
	      dec ebx			;/
            dec ebx			;/
	      mov edx,[ebx+esi]	      ;/
            cmp edx,eax			;/
            je  nadd			;/jmp if yes it is.
	      cmp ebx,0			;/
            jne nadd2			;/
	      ;fall down here if it isn't already in list.
;add object to list...
              mov ebx,updatesindex    ;append it to end of list.
              shl ebx,1               ;/
	        shl ebx,1		   ;/
nadd3:   mov [ebx+esi],eax        ;/
         inc updatesindex      ;/
nadd:
       .ENDIF

	ret
add2updatelist ENDP 
;--------------------------------------------------------------------------
;xsize PROC STDCALL wmsg:DWORD, wparam:DWORD, lparam:DWORD
;;called via WM_SIZE msg.
;
;	 invoke InvalidateRgn, g_hwnd,0,TRUE	;invalidate entire window.
;	mov g_fredrawdiag,ENTIRE		;redraw entire window.
;
;;clientrectold is not "old" --it is the current physical client coords.
;	 invoke GetClientRect, g_hwnd, ADDR clientrectold ;backup copy.
;
;;save width and height of client area...
;;note, these ARE 16-bit moves...
;	mov  ax,WORD PTR lparam	;(used by xkeydown)
;	cwde
;	mov  xclientpixels,eax
;	mov  ax,WORD PTR lparam+2
;	cwde
;	mov  yclientpixels,eax
;
;	ret
;xsize ENDP
;--------------------------------------------------------------------------
.DATA
xtest DWORD 0
ytest DWORD 0
szwinspool BYTE "WINSPOOL",0
szprntitle DB "Print instructions",0
szprntext  DB "Press Cancel to abort printing now, OK to continue.",0Ah,0Dh
	   DB "After each page prints, press an CTRL-Arrow to select",0Ah,0Dh
	   DB "next page (up,down,left,right), and print again.",0
;used by getprinterdetails() and xpaint()....
pregion         DWORD 0
g_fprintdiag    BYTE 0            ;non-0 if want to print.
szwininititle   BYTE "windows",0
szwininisub     BYTE "device",0
szwininiline    BYTE 64 DUP(0) ;returns found line in win.ini
szwininidef     BYTE 64 DUP(0)
szprname	BYTE "GOOSEE diagram",0
szerpr1 	BYTE "Printer-to-screen scaling cannot be set "
		BYTE "properly. Printed output will be incorrect size.",0
szname1 BYTE "HP LaserJet 6P",0

.CODE
xpaint_print PROC STDCALL USES ebx ecx edx esi edi
	LOCAL hdcp:DWORD		;device context for printer.
	LOCAL zoom:SBYTE		;zoom factor.
	LOCAL printdocinfo:DOCINFO
	LOCAL prnleft:DWORD		;viewport origin for printing.
	LOCAL prntop:DWORD		;/
	LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
	LOCAL hbrushold:DWORD, hbrushgreen:DWORD
	LOCAL holdtextfont:DWORD
	LOCAL hbrushnewcolor:DWORD,hbrusholdcolor:DWORD
;	"xpaint_print"
;if g_fprintdiag non-0, output is to printer....

	mov prnleft,0
	mov prntop,0
	mov hbrushold,0
	mov hbrushgreen,0
	mov hdcp,0
	mov zoom,0
	mov holdtextfont,0
	mov hbrushnewcolor,0
	mov hbrusholdcolor,0

;keyboard instructions...
	invoke MessageBox, g_hwnd,ADDR szprntext,ADDR szprntitle,MB_OKCANCEL
	.IF eax==IDCANCEL
	  mov  g_fprintdiag,0
	  ret
	.ENDIF

;setup printdocinfo structure...
    mov printdocinfo.cbSize,SIZEOF DOCINFO ;20	;size of structure.
	;lea eax,szfile
	lea eax,szprname
	mov printdocinfo.lpszDocName,eax ;name of document.
	; note we could load addr of szfile for above paramter.
	mov printdocinfo.lpszOutput,0	;name of o/p file --use DC.
	mov printdocinfo.lpszDataType,0
	mov printdocinfo.fwType,0

;create a display-context for the printer...
    ;mov ebx,SIZEOF PRINTDLGA
    ;invoke ZeroMemory, ADDR myprintdlg,ebx
	    mov myprintdlg.pr_lStructSize,SIZEOF PRINTDLGA
	    mov myprintdlg.pr_hwndOwner,0
	    mov myprintdlg.pr_hDevMode,0
	    mov myprintdlg.pr_hDevNames,0
	    mov myprintdlg.pr_hDC,0
	    mov myprintdlg.pr_nFromPage,0
	    mov myprintdlg.pr_nToPage,0
	    mov myprintdlg.pr_nMinPage,0
	    mov myprintdlg.pr_nMaxPage,0
	    mov myprintdlg.pr_nCopies,0
	    mov myprintdlg.pr_hInstance,0
	    mov myprintdlg.pr_lCustData,0
	    mov myprintdlg.pr_lpfnPrintHook,0
	    mov myprintdlg.pr_lpfnSetupHook,0
	    mov myprintdlg.pr_lpPrintTemplateName,0
	    mov myprintdlg.pr_lpSetupTemplateName,0
	    mov myprintdlg.pr_hPrintTemplate,0
	    mov myprintdlg.pr_hSetupTemplate,0
	    mov eax,g_hwnd
	    mov myprintdlg.pr_hwndOwner,0 ;eax
    mov myprintdlg.pr_Flags,PD_RETURNDC+PD_RETURNDEFAULT
    invoke PrintDlgA, ADDR myprintdlg
    .IF eax==0	;error.
	  mov eax,myprintdlg.pr_hDC
	  .IF eax==0
	  .ELSE
	    invoke DeleteDC,eax
	  .ENDIF
	  ;free global memory objects...
	  mov eax,myprintdlg.pr_hDevMode
	  .IF eax==0
	  .ELSE
	    invoke GlobalFree,eax
	  .ENDIF
	  mov eax,myprintdlg.pr_hDevNames
	  .IF eax==0
	  .ELSE
	    invoke GlobalFree,eax
	  .ENDIF
      ret
    .ENDIF
    mov ecx,myprintdlg.pr_hDC
    mov hdcp,ecx

;;create a display-context for the printer...
;	  invoke CreateDC, 0,ADDR szname1,0,0
;	   ;...1st param was "ADDR szdriver", now NULL for win95.
;	   ;...2nd=last param is "ADDR szport", which is normally LPT1:
;	   ;however win95 prefers NULL entry.
;	  mov  hdcp,eax


  invoke StartDoc, hdcp,ADDR printdocinfo  ;start a print job.
  invoke StartPage, hdcp	;prepares printer driver to accept data.

	    ;invoke GetMapMode, hdcp
	    invoke SetMapMode, hdcp,MM_ANISOTROPIC
	    ;(needed for SetWindowExtEx() to work)
	    .IF eax==0	;failed
	     pushad
	     invoke MessageBox,g_hwnd,ADDR szerpr1,0,MB_OK+MB_ICONEXCLAMATION
	     popad
	    .ENDIF
	    invoke GetMapMode, hdcp
	    .IF eax==MM_ANISOTROPIC
	    .ELSE
	     pushad
	     invoke MessageBox,g_hwnd,ADDR szerpr1,0,MB_OK+MB_ICONEXCLAMATION
	     popad
	    .ENDIF

; jmp tst1 ;***TEST

;	      mov	g_fprintingnow,TRUE
	      mov eax,CURRENT3POINTSIZE
	      neg eax
;	      invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,FIXED_PITCH,ADDR szface
	      mov	g_hfontx1,eax		;11-point courier new.
	      mov	eax,CURRENTPOINTSIZE
	      neg	eax
;	      invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface5 ;2
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface5
	      mov	g_hfontx1x,eax		;12-point Times New Roman
	      mov eax,CURRENT4POINTSIZE ; 12-1-00
	      neg eax
;	      invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface6 ;3 ;2
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface6
	      mov	g_hfontx1p5,eax     ;arial
	      mov	eax,CURRENT2POINTSIZE
	      mov	ebx,2
	      mul	ebx	;font twice standard size.
	      neg	eax
;	      invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface3
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface3
	      mov	g_hfontx2,eax	    ;arial bold
	      mov	eax,CURRENT2POINTSIZE
	      mov	ebx,4
	      mul	ebx	;font 4 times standard size.
	      neg	eax
;	      invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface3
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface3
	      mov	g_hfontx4,eax	    ;arial bold.
;let's also create a grey pen...
	      invoke CreatePen, PS_SOLID,1,0C0C0C0h	;want 1-wide,grey.
	      mov g_hpengrey,eax


;300900     (same as wmpaint())
;create a global white wide pen...
      invoke CreatePen, PS_SOLID,7,0FFFFFFh	;want 5-wide,white.
      mov g_hpenwhite5,eax			;...no, 7 wide

;011000     (same as wmpaint())
;create 8 color pens, 1-pixel wide (for color coding of rings)...
;(refer paint_*() drawing routine for each element)
      invoke CreatePen, PS_SOLID,1,0000000h	;black.
      mov g_hpen000,eax
      invoke CreatePen, PS_SOLID,1,00000FFh	;red
      mov g_hpen001,eax
      invoke CreatePen, PS_SOLID,1,000FF00h	;green
      mov g_hpen010,eax
      invoke CreatePen, PS_SOLID,1,000C0C0h	;dirty-yellow
      mov g_hpen011,eax
      invoke CreatePen, PS_SOLID,1,0FF0000h	;blue
      mov g_hpen100,eax
      invoke CreatePen, PS_SOLID,1,0FF00FFh	;pink
      mov g_hpen101,eax
      invoke CreatePen, PS_SOLID,1,0FFFF00h	;aqua-blue
      mov g_hpen110,eax
      invoke CreatePen, PS_SOLID,1,0C0C0C0h	;grey
      mov g_hpen111,eax



;;assign font to display context...
;;the standard size font.
; invoke SelectObject, hdcp,g_hfontx1
; mov  holdtextfont,eax

;colour for filling polygons....
     invoke GetStockObject, NULL_BRUSH
	 mov hbrushgreen,eax
	invoke SelectObject, hdcp,hbrushgreen
	 mov hbrushold,eax
;colour for text....
	invoke SetBkMode, hdcp, TRANSPARENT   ;leave background showing.

; jmp tst1

;	  invoke SetWindowExtEx, hdcp,748,1088,0	;<<<<<<<TEST<<<<******
;	  .IF eax==0 ;fail
;	    pushad
;	    invoke MessageBox, g_hwnd,ADDR szerpr1,0,MB_OK+MB_ICONEXCLAMATION
;	    popad
;	  .ENDIF
;      invoke SetViewportExtEx, hdcp,g_nxprnpixsize,g_nyprnpixsize,0
;      invoke SetViewportExtEx, hdcp,4676,6814,0	;<<<<<<<TEST<<<<<******
;      .IF eax==0 ;fail
;	pushad
;	invoke MessageBox, g_hwnd,ADDR szerpr1,0,MB_OK+MB_ICONEXCLAMATION
;	popad
;      .ENDIF

;    invoke ScaleViewportExtEx, hdcp,6,0,6,0,0


;copied from wmcreate()...
;find out resolution of the printer...
	invoke GetDeviceCaps, hdcp,LOGPIXELSX	;query pixels/inch.
	mov  xprintpixels,eax
	invoke GetDeviceCaps, hdcp,LOGPIXELSY	;query pixels/inch.
	mov  yprintpixels,eax
	invoke GetDeviceCaps, hdcp,HORZRES	;query width in pixels.
	mov  g_nxprnpixsize,eax
	invoke GetDeviceCaps, hdcp,VERTRES	;query height in pixels.
	mov  g_nyprnpixsize,eax
;caclulate the ratio...
	mov  eax,xprintpixels	;print width. unsigned.
	shl  eax,1			;*4, so can be more accurate.
	shl  eax,1			;/
	xor  edx,edx
	mov  ebx,xscreenpixels	;screen width, unsigned.
	div  ebx		;unsigned divide
;***NOTE*** g_nxratio & g_nyratio should always be +ve,
;but i've defined them as SDWORD.
	mov  g_nxratio,eax	;display>printer scaling, x.
	mov  eax,yprintpixels	;print paper height.
	shl  eax,1			;*4, more accurate.
	shl  eax,1			;/
	xor  edx,edx
	mov  ebx,yscreenpixels	;display height.
	div  ebx
	mov  g_nyratio,eax	;display>printer scaling, y.

;setup logical-->device scaling...
	  mov  eax,g_nxprnpixsize		;size of paper, found above.
	  mov  ebx,g_nyprnpixsize		;/
	      .IF g_nxratio>1	    ;should always be!(higher prtr res.)
		  xor  edx,edx				   ;prn/scrn ratio
		  shl eax,1		;cos we modified xratio*4
		  shl eax,1		; back in xcreate.
		  div  g_nxratio	;scale-up by prn/scrn ratio. ;/
;		  shl eax,1		;cos we modified xratio*4
;		  shl eax,1		; back in xcreate.
		  push eax 				     ;/
		    mov  eax,ebx				     ;/
		    xor  edx,edx				     ;/
		    shl  eax,1		;ditto, correct yratio*4
		    shl  eax,1		;/
		  div	g_nyratio			 ;/
;		    shl  eax,1		;ditto, correct yratio*4
;		    shl  eax,1		;/
		  mov  ebx,eax	 ;new .rc_right in eax		 ;/
		  pop  eax	;new .rc_bottom in ebx.	       ;/
	      .ENDIF
	  ;***NOTE*** actually +ve values, but these vars are signed...
	  sub eax,XMARGINADJ	;***NOTE*** this fixes edge of printout lost
			;IN FUTURE, configurable by user.
	  mov  xwinext,eax	;save. used by ctrl-arrow keys.
	  sub ebx,YMARGINADJ	;***ditto.
	  mov  ywinext,ebx	;/(+ve value always).






;setup logical-->device scaling...
	mov esi,pTERSEDATA
	mov al,(TERSEDATA PTR [esi]).nzoom
	mov zoom,al
	  mov  eax,g_nxprnpixsize	;size of paper, found by wmcreate.
	  mov  ebx,g_nyprnpixsize	;/  (unsigned values) in dots.
	      .IF zoom>0
		  mov cl,zoom
		  sal	eax,cl
		  sal	ebx,cl
	      .ELSEIF zoom==0
	      .ELSE
		  mov cl,zoom
		  neg cl		;***NOTE*** is this right?
		  sar eax,cl
		  sar ebx,cl
	      .ENDIF
	      .IF g_nxratio>1	  ;*always* +ve!
		  xor  edx,edx				   ;prn/scrn ratio
		    shl  eax,1		;ditto, correct yratio*4
		    shl  eax,1		;/
		  div g_nxratio	;scale-up by prn/scrn ratio. ;/
;		  shl eax,1		;cos we modified xratio*4
;		  shl eax,1		; back in xcreate.
		  push eax 				     ;/
		    mov  eax,ebx				     ;/
		    xor  edx,edx				     ;/
		    shl  eax,1		;ditto, correct yratio*4
		    shl  eax,1		;/
		  div g_nyratio		     ;/
;		    shl  eax,1		;ditto, correct yratio*4
;		    shl  eax,1		;/
		    mov  ebx,eax	;new .right in eax	     ;/
		  pop  eax 	;new .bottom in ebx.	     ;/
	      .ENDIF
	  invoke SetWindowExtEx, hdcp,eax,ebx,0

      invoke SetViewportExtEx, hdcp,g_nxprnpixsize,g_nyprnpixsize,0
;      invoke SetViewportExtEx, hdcp,4676,6814,0	;<<<<<<<TEST<<<<<******
      .IF eax==0 ;fail
	pushad
	invoke MessageBox, g_hwnd,ADDR szerpr1,0,MB_OK+MB_ICONEXCLAMATION
	popad
      .ENDIF

 jmp tst5

;tst1:
;      invoke SetWindowExtEx,hdcp,748,1088,0
;      invoke SetViewportExtEx,hdcp,4678,6814,0
tst5:
  jmp tst6
;      invoke SetViewportOrgEx,hdcp,0,0,0
;  jmp tst4
;      invoke Ellipse,hdcp,30,30,500,500
;  jmp tst3
;      invoke EndPage,hdcp
;      invoke EndDoc,hdcp
;      jmp tst2


;;*NOTE* also has to be after StartPage to work...
;;orign for window...
;	mov eax,clientrect.rc_left
;	;neg eax
;	mov ebx,clientrect.rc_top
;	;neg ebx
;	invoke SetWindowOrgEx,hdcp,0,0,0	;-600,-600 moves it right/down

tst6:
;*NOTE* this has to be after StartPage() to work...
;origin for printer... uses clientrect as current region...
;problem...viewport seems to be printer pixel (device) coords...
	  mov eax,clientrect.rc_left
	  xor edx,edx
	  imul g_nxratio		;remember, xratio is *4.
	  mov  ecx,4		;/
	  idiv ecx		;/
	  neg eax			;used for axis polarity.
	  mov prnleft,eax
	  mov eax,clientrect.rc_top
	  xor edx,edx
	  imul g_nyratio
	  mov  ecx,4
	  idiv ecx
	  neg eax			;/
	  mov prntop,eax
      invoke SetViewportOrgEx, hdcp,prnleft,prntop,0	;600,600 moves it right/down.

tst4:
;now go ahead and print all the objects...
;***NOTE*** a change from oldgoofee, is haven't checked the bigger
;fonts here (in .fstatus bits3/4), but intend to do it inside each
;object drawing method.***NOTE***
 mov updatesindex,0
 mov wipeoutsindex,0
 mov highlightedindex,0

	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp jj3
	  .ENDIF
nextobj:

	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	.IF ax==01	;bit0=1, valid object.
	mov ax,(OBJECT PTR [esi]).nexttype
	  .IF ax==-1
	  .ELSE		;not a data object.


	  invoke isobjectinwindow, esi	;return TRUE if yes.

		.IF eax==TRUE
		  ;chose a font size...
		  xor eax,eax
		  mov	al,(OBJECT PTR [esi]).fstatus
		  and	al,011000b	;test for bits3/4.
		  .IF	al==0
		    ;assign the standard font to DC. 
def1:		    invoke SelectObject, hdcp,g_hfontx1
		  .ELSEIF al==001000b	;1.5 times font.
		    invoke SelectObject,hdcp,g_hfontx1p5
		  .ELSEIF al==010000b	;2 times font.
		    invoke SelectObject,hdcp,g_hfontx2
		  .ELSEIF al==011000b	;4 times font.
		    invoke SelectObject,hdcp,g_hfontx4
		  .ENDIF
		  mov  holdtextfont,eax

;		    ;chose a new brush, maybe...
;		    mov al,(OBJECT PTR [esi]).fconfig
;		    and al,0100b    ;bit2=1 turn on colour.
;		    .IF al==0100b
;		      mov eax,(OBJECT PTR [esi]).ncolour1
;		      invoke CreateSolidBrush, eax
;		      mov hbrushnewcolor,eax
;		      invoke SelectObject, hdcp,hbrushnewcolor
;		      mov hbrusholdcolor,eax
;		    .ENDIF

;finally, call the method to display object...
	          mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
		  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdcp,esi

		  invoke SelectObject, hdcp,holdtextfont	;restore original.
;		  ;and restore default brush...
;		    mov al,(OBJECT PTR [esi]).fconfig
;		    and al,0100b    ;bit2=1 turn on colour.
;		    .IF al==0100b
;		      invoke SelectObject, hdcp, hbrusholdcolor
;		      invoke DeleteObject, hbrushnewcolor
;		    .ENDIF

		.ENDIF



;	      mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
;	      ;(relative to "ptrs", which is start of the methods table)
;	      invoke displayPTR PTR [ebx+ptrs+pdisplay], hdcp,esi
	  .ENDIF
	.ENDIF
	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
	loop jj2 ;nextobj
jj1:	jmp SHORT jj3
jj2:	jmp nextobj
jj3:


tst3:
;;restore original font to DC...
;	invoke SelectObject, hdcp,holdtextfont

	invoke SelectObject, hdcp, hbrushold
      invoke DeleteObject, hbrushgreen

	      invoke DeleteObject,g_hfontx1x
	      invoke DeleteObject,g_hfontx1
	      invoke DeleteObject,g_hfontx1p5
	      invoke DeleteObject,g_hfontx2
	      invoke DeleteObject,g_hfontx4
	      invoke DeleteObject,g_hpengrey
	invoke DeleteObject,g_hpen000
	invoke DeleteObject,g_hpen001
	invoke DeleteObject,g_hpen010
	invoke DeleteObject,g_hpen011
	invoke DeleteObject,g_hpen100
	invoke DeleteObject,g_hpen101
	invoke DeleteObject,g_hpen110
	invoke DeleteObject,g_hpen111
	      mov g_hfontx1x,0
	      mov g_hfontx1,0
	      mov g_hfontx1p5,0
	      mov g_hfontx2,0
	      mov g_hfontx4,0
	      mov g_hpengrey,0
	mov g_hpen000,0
	mov g_hpen001,0
	mov g_hpen010,0
	mov g_hpen011,0
	mov g_hpen100,0
	mov g_hpen101,0
	mov g_hpen110,0
	mov g_hpen111,0

;end of redrawdiag code.  have outputted to printer, restore status...
	  invoke EndPage, hdcp
	  invoke EndDoc, hdcp


;tst2:
	mov  g_fprintdiag,0
	invoke DeleteDC,hdcp
	  ;free global memory objects...
	  mov eax,myprintdlg.pr_hDevMode
	  .IF eax==0
	  .ELSE
	    invoke GlobalFree,eax
	  .ENDIF
	  mov eax,myprintdlg.pr_hDevNames
	  .IF eax==0
	  .ELSE
	    invoke GlobalFree,eax
	  .ENDIF
	mov  hdcp,0
	mov  pregion,0

	ret
xpaint_print ENDP
;--------------------------------------------------------------------------
isobjectinwindow PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD
	LOCAL zoom:SBYTE
	LOCAL xadiff:SDWORD, yadiff:SDWORD
; "isobjectinwindow"
;xpaint_entire() and xpaint_print() call here, passing ptr to an object.
;return TRUE if object is showing on the current window.
;note that oldgoofee did this checking inside xpaint_entire().

	mov edi,pobj
    mov esi,pTERSEDATA
    mov al,(TERSEDATA PTR [esi]).nzoom
	mov zoom,al

;no, capture everything within 1.5 times client window...

    mov eax,clientrect.rc_right     ;purpose is to make rect twice size
    sub eax,clientrect.rc_left	    ;so will draw everything inside
    sar eax,1			;actually, will always be +ve.
    mov xadiff,eax		    ;twice client rect.
    mov eax,clientrect.rc_bottom
    sub eax,clientrect.rc_top
    sar eax,1
    mov yadiff,eax		;always +ve.

	mov eax,(OBJECT PTR [edi]).xtopleft ;xmid
	mov edx,(OBJECT PTR [edi]).ytopleft ;ymid
	mov  cl,zoom		;+ve=zoomed-out, -ve=zoomed-in
	.IF  zoom>0
	  sar  eax,cl
	  sar edx,cl
	.ELSEIF zoom<0
	  neg  cl
	  sal  eax,cl
	  sal  edx,cl
	.ENDIF			;0=normal size.
	mov ecx,clientrect.rc_left
	sub ecx,xadiff		;make rect twice size.
	.IF SDWORD PTR eax>ecx	;in left side?
	  mov ecx,clientrect.rc_right
	  add ecx,xadiff
	  .IF SDWORD PTR eax<ecx ;in right side?
	    mov ecx,clientrect.rc_top
	    sub ecx,yadiff
	    .IF SDWORD PTR edx>ecx	;in top side?
	      mov ecx,clientrect.rc_bottom
	      add ecx,yadiff
	      .IF SDWORD PTR edx<ecx
		;success! object is inside window client area
		mov eax,TRUE
		ret
	      .ENDIF
	    .ENDIF
	  .ENDIF
	.ENDIF


      mov al,(OBJECT PTR [edi]).fconfig
      and al,01
      .IF al==01		;wire-type element.
	mov eax,(OBJECT PTR [edi]).wwidth
	mov edx,(OBJECT PTR [edi]).height
	mov  cl,zoom		;+ve=zoomed-out, -ve=zoomed-in
	.IF  zoom>0
	  sar  eax,cl
	  sar edx,cl
	.ELSEIF zoom<0
	  neg  cl
	  sal  eax,cl
	  sal  edx,cl
	.ENDIF			;0=normal size.
	mov ecx,clientrect.rc_left
	sub ecx,xadiff		;make rect twice size.
	.IF SDWORD PTR eax>ecx	;in left side?
	  mov ecx,clientrect.rc_right
	  add ecx,xadiff
	  .IF SDWORD PTR eax<ecx ;in right side?
	    mov ecx,clientrect.rc_top
	    sub ecx,yadiff
	    .IF SDWORD PTR edx>ecx	;in top side?
	      mov ecx,clientrect.rc_bottom
	      add ecx,yadiff
	      .IF SDWORD PTR edx<ecx
		;success! object is inside window client area
		mov eax,TRUE
		ret
	      .ENDIF
	    .ENDIF
	  .ENDIF
	.ENDIF
      .ENDIF

;151200
;totem-pole nodes can be very long, so check outermost-ring...
      mov al,(OBJECT PTR [edi]).fconfig3
      and al,0100b  ;bit2.
      .IF al==0100b ;totem-pole node.
	xor eax,eax
	mov al,(OBJECT PTR [edi]).nrings
	dec eax
	mov ebx,(OBJECT PTR [edi]).ydeltacentre
	imul ebx
	add eax,(OBJECT PTR [edi]).ymid
	mov edx,eax
	mov eax,(OBJECT PTR [edi]).xmid
	mov  cl,zoom		;+ve=zoomed-out, -ve=zoomed-in
	.IF  zoom>0
	  sar  eax,cl
	  sar edx,cl
	.ELSEIF zoom<0
	  neg  cl
	  sal  eax,cl
	  sal  edx,cl
	.ENDIF			;0=normal size.
	mov ecx,clientrect.rc_left
	sub ecx,xadiff		;make rect twice size.
	.IF SDWORD PTR eax>ecx	;in left side?
	  mov ecx,clientrect.rc_right
	  add ecx,xadiff
	  .IF SDWORD PTR eax<ecx ;in right side?
	    mov ecx,clientrect.rc_top
	    sub ecx,yadiff
	    .IF SDWORD PTR edx>ecx	;in top side?
	      mov ecx,clientrect.rc_bottom
	      add ecx,yadiff
	      .IF SDWORD PTR edx<ecx
		;success! object is inside window client area
		mov eax,TRUE
		ret
	      .ENDIF
	    .ENDIF
	  .ENDIF
	.ENDIF
      .ENDIF


;fall out here, fail...
    mov eax,FALSE
    ret
isobjectinwindow ENDP
;--------------------------------------------------------------------------
calcsig PROC STDCALL USES ebx ecx edx esi edi
     LOCAL pend:DWORD

    mov esi,pTERSEDATA
    xor eax,eax
    mov ax,(TERSEDATA PTR [esi]).numobjects
    xor ecx,ecx
    mov cx,(TERSEDATA PTR [esi]).nsizeobject
    mul ecx
    lea ecx,(TERSEDATA PTR [esi]).OBJECTS
    add eax,ecx
    mov pend,eax
    xor edx,edx
    sub pend,4		;prevent overrun end of database.
    add esi,4		;bypass nsignature field.
go2:	test edx,80000000h	;msb
	jz calc1
	xor edx,41081048h	;tapping points
calc1:	xor edx,[esi]
	shl edx,1		;this is signature.
    add esi,4
    cmp esi,pend
    jb	go2

  mov eax,edx	;return the signature.
  ret
calcsig ENDP
;--------------------------------------------------------------------------
.DATA
nbyteswrote DWORD 0,0
szerrfs1    BYTE "E013: Cannot save datafile. Aborting Save.",0
szerrfs2    BYTE "E014: GOOSEE program error. Suggest exit.",0
szerrproj2  BYTE "Excuse me, but you did not allocate non-zero "
	    BYTE "Project and Sub-project numbers to this diagram. "
	    BYTE "Aborting save operation.",0
.CODE
savedatafile PROC STDCALL USES ebx ecx edx esi edi
    LOCAL pend:DWORD
; "savedatafile"
;return eax=1 if error aborted save, eax=2 cancel save.

	  ;241000
	  ;save top/left coords of window to database...
	  ;(must do this before calcsig())
	  mov esi,pTERSEDATA
	  mov eax,clientrect.rc_left
	  mov (TERSEDATA PTR [esi]).xleft,eax
	  mov eax,clientrect.rc_top
	  mov (TERSEDATA PTR [esi]).ytop,eax

;check that .nproject and .nsubproject numbers are non-0...
    mov esi,pTERSEDATA
    mov ax,(TERSEDATA PTR [esi]).nproject
    .IF ax==0
	    lea ecx,PROJECTproc
	    mov eax,201 ;resource number of PROJECT dialog in goosee.rc.
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .IF eax==2	    ;EndDialog() supplied 2, cancel dialog box.
	      ret
	    .ENDIF
	    mov ax,(TERSEDATA PTR [esi]).nproject
	    .IF ax==0
	      invoke MessageBox, g_hwnd, ADDR szerrproj2,\
			 ADDR szgoosee, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	      mov eax,1
	      ret
	    .ELSE
;	      ;also need to scan OBJECTS and if .nsubproject==0, correct it...
;	      mov esi,pTERSEDATA
;	      xor ecx,ecx
;	      mov cx,(TERSEDATA PTR [esi]).numobjects
;	      lea edi,(TERSEDATA PTR [esi]).OBJECTS
;getnxt:	mov ax,(OBJECT PTR [edi]).nsubproject
;		.IF ax==0
;		  mov ax,(TERSEDATA PTR [esi]).nsubproject
;		  mov (OBJECT PTR [edi]).nsubproject,ax
;		.ENDIF
;	      xor eax,eax
;	      mov ax,(TERSEDATA PTR [esi]).nsizeobject
;	      add edi,eax
;	      loop getnxt
	    .ENDIF
    .ENDIF

    .IF g_hfile==-1   ;invalid or no file open.
      ;we will have to do saveas...
      invoke saveasdatafile
    .ELSE
      ;move the filepointer to beginning of file...
      invoke SetFilePointer, g_hfile,0,0,FILE_BEGIN
      .IF eax==-1
		;fail...
ferr:   invoke MessageBox, g_hwnd, ADDR szerrfs1,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	mov eax,1
      .ELSE
        ;ok, now write entire TERSEDATA to file...
	;g_nfilesize is size of memory block, pTERSEDATA->start TERSEDATA.
	.IF g_nfilesize==0
          ;never come here, as g_nfilesize setup by wmcreate().
          invoke MessageBox, g_hwnd, ADDR szerrfs2,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	  mov eax,1
        .ELSE
	  ;ok now we can write it...

	invoke checkintegrity,2 ;=2 display any errors, not final msg.
	;...also fixes.

	;calculate signature...
	invoke calcsig
	mov esi,pTERSEDATA
	mov (TERSEDATA PTR [esi]).nsignature,eax

	  mov eax,pTERSEDATA
          invoke WriteFile, g_hfile,eax,g_nfilesize,ADDR nbyteswrote,0
          .IF eax==0
            ;fail...
            jmp ferr     ;error message.
	  .ENDIF
	  mov eax,0	;return flag succeeded.
        .ENDIF
      .ENDIF
    .ENDIF

  ret
savedatafile ENDP
;--------------------------------------------------------------------------
.DATA
szerrsave      DB "WARNING. You haven't saved-as the file. Keeping "
               DB "previously-opened file.",0
;szerrsave2	   DB "WARNING. You haven't saved the diagram.",0
szerrfs3     BYTE "GOOSEE was unable to save the diagram.",0

.CODE
saveasdatafile PROC STDCALL USES ebx ecx edx esi edi
	LOCAL dummy:BYTE
; "saveasdatafile"
;returns eax=1 if aborted with error, eax=2 if cancel, else eax=0 succeeded.

	mov g_nstate,0
        mov g_pmovingobject,0
	mov g_pselectedobjectnew,0

	  ;241000
	  ;save top/left coords of window to database...
	  ;(must do this before calcsig())
	  mov esi,pTERSEDATA
	  mov eax,clientrect.rc_left
	  mov (TERSEDATA PTR [esi]).xleft,eax
	  mov eax,clientrect.rc_top
	  mov (TERSEDATA PTR [esi]).ytop,eax

;check that .nproject and .nsubproject numbers are non-0...
    mov esi,pTERSEDATA
    mov ax,(TERSEDATA PTR [esi]).nproject
    .IF ax==0
	    lea ecx,PROJECTproc
	    mov eax,201 ;resource number of PROJECT dialog in goosee.rc.
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .IF eax==2	    ;EndDialog() supplied 2, meaning cancel.
	      ret
	    .ENDIF
	    mov ax,(TERSEDATA PTR [esi]).nproject
	    .IF ax==0
	      invoke MessageBox, g_hwnd, ADDR szerrproj2,\
			 ADDR szgoosee, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	      mov eax,1
	      ret
	    .ELSE
;	      ;also need to scan OBJECTS and if .nsubproject==0, correct it...
;	      mov esi,pTERSEDATA
;	      xor ecx,ecx
;	      mov cx,(TERSEDATA PTR [esi]).numobjects
;	      lea edi,(TERSEDATA PTR [esi]).OBJECTS
;getnxt:	mov ax,(OBJECT PTR [edi]).nsubproject
;		.IF ax==0
;		  mov ax,(TERSEDATA PTR [esi]).nsubproject
;		  mov (OBJECT PTR [edi]).nsubproject,ax
;		.ENDIF
;	      xor eax,eax
;	      mov ax,(TERSEDATA PTR [esi]).nsizeobject
;	      add edi,eax
;	      loop getnxt
	    .ENDIF
    .ENDIF


        .IF g_nfilesize==0
          ;never come here, as wmcreate() sets up g_nfilesixe.
          invoke MessageBox, g_hwnd, ADDR szerrfs2,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	  mov eax,1
          ret
        .ENDIF

    .IF g_hfile==-1     ;invalid or nothing open.
      ;go ahead and bring up a dialog box...
    .ELSE
      ;first close current file...
      invoke CloseHandle, g_hfile ;close previous file.
      mov g_hfile,-1
      mov szfile,0
    .ENDIF

	  ;first, copy default structure...
	  lea edi,opentersefile
	  lea ebx,defaulttersefile
	  mov ecx,OPENFILENAME_
oo1:	  mov al,[ebx]
	  mov [edi],al
	  inc ebx
	  inc edi
	  dec ecx
	  jnz oo1
	  ;do same for szfile...
		;first save current contents...
		lea edi,szoldfile
		lea ebx,szfile
		mov ecx,sizeszfile
oo3:		mov al,[ebx]
		mov [edi],al
		inc ebx
		inc edi
		dec ecx
		jnz oo3
	  lea edi,szfile
	  lea ebx,szdeffile
	  mov ecx,sizeszfile
oo2:	  mov al,[ebx]
	  mov [edi],al
	  inc ebx
	  inc edi
	  dec ecx
	  jnz oo2
        invoke GetSaveFileName, ADDR opentersefile ;<<<DIALOG BOX
        .IF eax==0		;0=error/cancel
		;not necessarily an error here, but put up a msgbox...
            ;we can keep the previously open file, so restore szfile...
			lea edi,szfile
			lea ebx,szoldfile
			mov ecx,sizeszfile
oo4:			mov al,[ebx]
			mov [edi],al
			inc ebx
			inc edi
			dec ecx
			jnz oo4
                  .IF g_hfile==-1
		    ;	 lea eax,szerrsave2
		    ;	 jmp ferr2
		    jmp SHORT fe88
		  .ELSE
		        lea eax,szerrsave
ferr2:              invoke MessageBox, g_hwnd, eax,\
			    ADDR szgoosee, MB_OK+MB_ICONEXCLAMATION
fe88:		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
		      mov eax,2
	              ret
		  .ENDIF
	  .ENDIF

;point of no-return for previously opened file...
        .IF g_hfile==-1 ;-1 means no file previously open.
	  .ELSE
            invoke CloseHandle, g_hfile ;close previous file.
            mov g_hfile,-1
	  .ENDIF

;create the file...
	invoke CreateFile, ADDR szfile,\
		GENERIC_READ+GENERIC_WRITE,\
		FILE_SHARE_READ+FILE_SHARE_WRITE,\
		0, CREATE_NEW,\	;creates a new file.
		FILE_ATTRIBUTE_NORMAL, 0
	.IF eax==INVALID_HANDLE_VALUE	;-1
fer5:   mov g_hfile,-1
        mov szfile,0
        invoke MessageBox, g_hwnd, ADDR szerrfs3,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	mov eax,1
        ret
      .ELSE
        mov g_hfile,eax
	;now go ahead and write all of TERSEDATA to the file...

	;do this first...
	invoke checkintegrity,2 ;=2 display any errors,not final msg.
	;...fixes also.

	;calculate signature...
	invoke calcsig
	mov esi,pTERSEDATA
	mov (TERSEDATA PTR [esi]).nsignature,eax

	  mov eax,pTERSEDATA
        invoke WriteFile, g_hfile,eax,g_nfilesize,ADDR nbyteswrote,0
	  .IF eax==0
	    ;fail...
            invoke CloseHandle, g_hfile ;close file.
	    jmp fer5		;error message.
	  .ENDIF
      .ENDIF


		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
    mov eax,0	;succeeded.
    ret
saveasdatafile ENDP
;--------------------------------------------------------------------------
selectedsaveasdatafile PROC STDCALL USES ebx ecx edx esi edi
	LOCAL numobjectsprev:DWORD,nsizenew:DWORD
	LOCAL nsizeobjectsold:DWORD
; "selectedsaveasdatafile"
;called via file/selected elements save as..." > idm_saveass
;adapted from saveasdatafile().
;returns eax=1 if aborted with error, eax=2 if cancel, else eax=0 succeeded.

	mov g_nstate,0
        mov g_pmovingobject,0
	mov g_pselectedobjectnew,0

	  ;241000
	  ;save top/left coords of window to database...
	  ;(must do this before calcsig())
	  mov esi,pTERSEDATA
	  mov eax,clientrect.rc_left
	  mov (TERSEDATA PTR [esi]).xleft,eax
	  mov eax,clientrect.rc_top
	  mov (TERSEDATA PTR [esi]).ytop,eax

;check that .nproject and .nsubproject numbers are non-0...
    mov esi,pTERSEDATA
    mov ax,(TERSEDATA PTR [esi]).nproject
    .IF ax==0
	    lea ecx,PROJECTproc
	    mov eax,201 ;resource number of PROJECT dialog in goosee.rc.
	    invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
	    .IF eax==2	    ;EndDialog() supplied 2, meaning cancel.
	      ret
	    .ENDIF
	    mov ax,(TERSEDATA PTR [esi]).nproject
	    .IF ax==0
	      invoke MessageBox, g_hwnd, ADDR szerrproj2,\
			 ADDR szgoosee, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	      mov eax,1
	      ret
	    .ELSE
;	      ;also need to scan OBJECTS and if .nsubproject==0, correct it...
;	      mov esi,pTERSEDATA
;	      xor ecx,ecx
;	      mov cx,(TERSEDATA PTR [esi]).numobjects
;	      lea edi,(TERSEDATA PTR [esi]).OBJECTS
;getnxt:	mov ax,(OBJECT PTR [edi]).nsubproject
;		.IF ax==0
;		  mov ax,(TERSEDATA PTR [esi]).nsubproject
;		  mov (OBJECT PTR [edi]).nsubproject,ax
;		.ENDIF
;	      xor eax,eax
;	      mov ax,(TERSEDATA PTR [esi]).nsizeobject
;	      add edi,eax
;	      loop getnxt
	    .ENDIF
    .ENDIF


        .IF g_nfilesize==0
          ;never come here, as wmcreate() sets up g_nfilesixe.
          invoke MessageBox, g_hwnd, ADDR szerrfs2,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	  mov eax,1
          ret
        .ENDIF

    .IF g_hfile==-1     ;invalid or nothing open.
      ;go ahead and bring up a dialog box...
    .ELSE
      ;first close current file...
      invoke CloseHandle, g_hfile ;close previous file.
      mov g_hfile,-1
      mov szfile,0
    .ENDIF

	  ;first, copy default structure...
	  lea edi,opentersefile
	  lea ebx,defaulttersefile
	  mov ecx,OPENFILENAME_
oo1:	  mov al,[ebx]
	  mov [edi],al
	  inc ebx
	  inc edi
	  dec ecx
	  jnz oo1
	  ;do same for szfile...
		;first save current contents...
		lea edi,szoldfile
		lea ebx,szfile
		mov ecx,sizeszfile
oo3:		mov al,[ebx]
		mov [edi],al
		inc ebx
		inc edi
		dec ecx
		jnz oo3
	  lea edi,szfile
	  lea ebx,szdeffile
	  mov ecx,sizeszfile
oo2:	  mov al,[ebx]
	  mov [edi],al
	  inc ebx
	  inc edi
	  dec ecx
	  jnz oo2
        invoke GetSaveFileName, ADDR opentersefile ;<<<DIALOG BOX
        .IF eax==0		;0=error/cancel
		;not necessarily an error here, but put up a msgbox...
            ;we can keep the previously open file, so restore szfile...
			lea edi,szfile
			lea ebx,szoldfile
			mov ecx,sizeszfile
oo4:			mov al,[ebx]
			mov [edi],al
			inc ebx
			inc edi
			dec ecx
			jnz oo4
                  .IF g_hfile==-1
		    ;	 lea eax,szerrsave2
		    ;	 jmp ferr2
		    jmp SHORT fe88
		  .ELSE
		        lea eax,szerrsave
ferr2:              invoke MessageBox, g_hwnd, eax,\
			    ADDR szgoosee, MB_OK+MB_ICONEXCLAMATION
fe88:		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
		      mov eax,2
	              ret
		  .ENDIF
	  .ENDIF

;point of no-return for previously opened file...
        .IF g_hfile==-1 ;-1 means no file previously open.
	  .ELSE
            invoke CloseHandle, g_hfile ;close previous file.
            mov g_hfile,-1
	  .ENDIF

;create the file...
	invoke CreateFile, ADDR szfile,\
		GENERIC_READ+GENERIC_WRITE,\
		FILE_SHARE_READ+FILE_SHARE_WRITE,\
		0, CREATE_NEW,\	;creates a new file.
		FILE_ATTRIBUTE_NORMAL, 0
	.IF eax==INVALID_HANDLE_VALUE	;-1
fer5:   mov g_hfile,-1
        mov szfile,0
        invoke MessageBox, g_hwnd, ADDR szerrfs3,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	mov eax,1
        ret
      .ELSE
        mov g_hfile,eax
	;now go ahead and write all of TERSEDATA to the file...

	  ;this is where will differ from saveasdatafile()...

	  ;only save selected elements...
	  invoke repositioncursor ;move mouse to 1st highlighted element.
	  invoke duplicatehighlighted ;copy duplicate elements to end dbase.
	   ;...exit from this routine with highlightednewlist pointing to
	   ;   all of the duplicated elements.
	   ;   their coords track the mouse until a left-click.
	   ; returns eax=previous # objects in database.
	  ;now delete all elements not duplicated...
	   mov numobjectsprev,eax
	   .IF eax==0
	     jmp no1
	   .ELSE
	     mov ecx,eax	;# objects to delete.
	     xor eax,eax
	     mov esi,pTERSEDATA
	     mov ax,(TERSEDATA PTR [esi]).nsizeobject
	     lea ebx,(TERSEDATA PTR [esi]).OBJECTS
nxtobj:	     mov (OBJECT PTR [ebx]).fstatus,0
	     add ebx,eax
	     loop nxtobj
	   .ENDIF


	  ;now move elements to begining of dbase...
	  xor ecx,ecx
	  mov eax,numobjectsprev
	  mov cx,(TERSEDATA PTR [esi]).nsizeobject
	  mul ecx
	  mov nsizeobjectsold,eax	;size of prev OBJECTS dbase.
	  lea ebx,(TERSEDATA PTR [esi]).OBJECTS
	  add ebx,eax	;actual end addr of previous database.
	    xor ecx,ecx
	    xor eax,eax
	    mov ax,(TERSEDATA PTR [esi]).numobjects
	    mov cx,(TERSEDATA PTR [esi]).nsizeobject
	    mul ecx
	    lea edi,(TERSEDATA PTR [esi]).OBJECTS
	    add edi,eax	;actual end addr of current database.
	      sub edi,ebx   ;size of new elements.
	      mov ecx,edi
	  ;now relocate...
	  ;ebx=start of new elements, ecx=size new elements...
	  mov nsizenew,ecx
	  .IF ecx==0
	  .ELSE
	    lea edi,(TERSEDATA PTR [esi]).OBJECTS ;relocation destination.
mvobjs:     mov al,[ebx]
	    mov [edi],al
	    inc ebx
	    inc edi
	    loop mvobjs
	  .ENDIF

	  ;fix pointers...
	    ;update the number-of-objects field in TERSEDATA...
	    xor ecx,ecx
	    mov cx,(TERSEDATA PTR [esi]).numobjects
	    sub ecx,numobjectsprev
	    mov (TERSEDATA PTR [esi]).numobjects,cx
	  ;now need to scan thru the newly-added objects and offset all
	  ;OBJECT pointer fields, by amount nsizeobjectsold...
	  ;nsizeobjectsold =size previous database.
	  ;numobjectsprev  =# objects previous database.
	  lea edi,(TERSEDATA PTR [esi]).OBJECTS
	  xor ecx,ecx
	  mov cx,(TERSEDATA PTR [esi]).numobjects
	  .IF ecx==0
	  .ELSE
nxt1:	    ;now update all the pointers in the object...
	    mov ebx,nsizeobjectsold
	    mov eax,(OBJECT PTR [edi]).rpdata
	    .IF eax != 0
	      sub (OBJECT PTR [edi]).rpdata,ebx
	    .ENDIF
	    mov eax,(OBJECT PTR [edi]).rpmaster
	    .IF eax != 0
	      sub (OBJECT PTR [edi]).rpmaster,ebx
	    .ENDIF
	    mov eax,(OBJECT PTR [edi]).rplock1
	    .IF eax != 0
	      sub (OBJECT PTR [edi]).rplock1,ebx
	    .ENDIF
	    mov eax,(OBJECT PTR [edi]).rplock2
	    .IF eax != 0
	      sub (OBJECT PTR [edi]).rplock2,ebx
	    .ENDIF
	    xor eax,eax
	    mov ax,(TERSEDATA PTR [esi]).nsizeobject
	    add edi,eax
	    loop nxt1
	  .ENDIF

	  ;and resize database...
	  lea eax,(TERSEDATA PTR [esi]).OBJECTS
	  add eax,nsizenew
	  sub eax,pTERSEDATA	;total size TERSEDATA database.
	  mov g_nfilesize,eax
	  invoke LocalReAlloc, pTERSEDATA,eax,LMEM_MOVEABLE
					;all absolute pointers are invalid...
					mov g_pmovingobject,0
					mov poldmovingobject,0
					mov g_pselectedobject,0
					mov g_pselectedobjectnew,0
					mov g_phighlightedobject,0
					mov g_perrorobject,0
					mov wipeoutsindex,0
					mov updatesindex,0
					mov highlightedindex,0
					mov g_nstate,0
					mov highlightedindexnewlist,0
					mov highlightedindexnewlist,0
	.IF eax==0
	  ;LocalRealloc() fail...
	  lea eax,szerralloc1
	  jmp ferr		;error message and close file.
        .ELSE
          mov pTERSEDATA,eax    ;new pointer.
        .ENDIF

	    ;do an integrity check...
	    invoke checkintegrity,1 ;=1, suppress all msgs.
	    ;...need this to fix .number field in elements.

	    ;calculate signature...
	    invoke calcsig
	    mov esi,pTERSEDATA
	    mov (TERSEDATA PTR [esi]).nsignature,eax


no1:	  mov eax,pTERSEDATA
        invoke WriteFile, g_hfile,eax,g_nfilesize,ADDR nbyteswrote,0
	  .IF eax==0
ferr:	    ;fail...
            invoke CloseHandle, g_hfile ;close file.
	    jmp fer5		;error message.
	  .ENDIF
      .ENDIF


		invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
    mov eax,0	;succeeded.
    ret
selectedsaveasdatafile ENDP
;--------------------------------------------------------------------------
.DATA
szerremf BYTE "Selected save-as to .EMF file operation not completed.",0
szerremf2 BYTE "Failure to create the .EMF file",0
szerremf5 BYTE "You have saved the .EMF file ok, but somehow GOOSEE "
	  BYTE "has stuffed up the current .GOO file. If already on "
	  BYTE "disk, don't save -- save-as if you must keep it.",0Dh,0Ah
	  BYTE "Try running ""Control/Database integrity check"".",0
.CODE
selectedsaveasemf PROC STDCALL USES ebx ecx edx esi edi
	LOCAL numobjectsprev:DWORD,nsizenew:DWORD,nobjshigh:DWORD
	LOCAL nsizeobjectsold:DWORD,pendprev:DWORD
	LOCAL hdc:DWORD
	LOCAL hbrushold:DWORD
	LOCAL hbrushdefault:DWORD
	LOCAL holdtextfont:DWORD, hbrushnewcolor:DWORD
	LOCAL hbrusholdcolor:DWORD
	LOCAL edisave:DWORD,esisave:DWORD,ecxsave:DWORD
; "selectedsaveasemf"
;called via file/selected elements save as EMF..." > idm_saveass_emf
;adapted from saveasdatafile()/selectedsaveasdatafile().
;returns eax=1 if aborted with error, eax=2 if cancel, else eax=0 succeeded.

	mov g_nstate,0
        mov g_pmovingobject,0
	mov g_pselectedobjectnew,0

	    ;calculate signature...
	    invoke calcsig
	    mov esi,pTERSEDATA
	    mov (TERSEDATA PTR [esi]).nsignature,eax

	.IF g_nfilesize==0
          ;never come here, as wmcreate() sets up g_nfilesixe.
          invoke MessageBox, g_hwnd, ADDR szerrfs2,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	  mov eax,1
          ret
        .ENDIF


	  ;first, copy default structure...
	  lea edi,openemffile
	  lea ebx,defaultemffile
	  mov ecx,OPENFILENAME_
oo1:	  mov al,[ebx]
	  mov [edi],al
	  inc ebx
	  inc edi
	  dec ecx
	  jnz oo1
	  ;do same for szemffile...
	  lea edi,szemffile
	  lea ebx,szdefemffile
	  mov ecx,sizeszfile
oo2:	  mov al,[ebx]
	  mov [edi],al
	  inc ebx
	  inc edi
	  dec ecx
	  jnz oo2
	invoke GetSaveFileName, ADDR openemffile ;<<<DIALOG BOX
        .IF eax==0		;0=error/cancel
		;not necessarily an error here, but put up a msgbox...
			lea eax,szerremf
ferr2:              invoke MessageBox, g_hwnd, eax,\
			    ADDR szgoosee, MB_OK+MB_ICONEXCLAMATION
fe88:		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
		      mov eax,2
	              ret
	  .ENDIF


	;now copy all selected elements to end of database...

	  ;only save selected elements...
	  invoke repositioncursor ;move mouse to 1st highlighted element.
	  invoke duplicatehighlighted ;copy duplicate elements to end dbase.
	   ;...exit from this routine with highlightednewlist pointing to
	   ;   all of the duplicated elements.
	   ;   their coords track the mouse until a left-click.
	   ; returns eax=previous # objects in database.
	   mov numobjectsprev,eax

	  mov esi,pTERSEDATA
	  xor ecx,ecx
	  mov eax,numobjectsprev
	  mov cx,(TERSEDATA PTR [esi]).nsizeobject
	  mul ecx
	  mov nsizeobjectsold,eax	;size of prev OBJECTS dbase.
	  lea ebx,(TERSEDATA PTR [esi]).OBJECTS
	  add ebx,eax	;actual end addr of previous database.
	  mov pendprev,ebx

	  xor eax,eax
	  xor ecx,ecx
	  mov ax,(TERSEDATA PTR [esi]).numobjects
	  mov cx,(TERSEDATA PTR [esi]).nsizeobject
	  mul ecx
	  lea ebx,(TERSEDATA PTR [esi]).OBJECTS
	  add ebx,eax	;actual end.
	  sub ebx,pendprev ;size highlighted objs.
	  xor edx,edx
	  mov eax,ebx
	  idiv ecx ;# highlighted elements.
	  mov nobjshigh,eax


	;need to create a DC for an EMF...
	invoke CreateEnhMetaFileA, 0,ADDR szemffile,0,0
	.IF eax==0
ferr:
fer5:	  mov szemffile,0
	  invoke MessageBox, g_hwnd, ADDR szerremf2,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
	  mov eax,1
	  ret
	.ELSE
	  mov hdc,eax
	  mov g_fredrawdiag,ENTIRE	;draw all.


	  mov hbrushold,0
	  mov hbrushdefault,0
	  mov holdtextfont,0
	  mov hbrushnewcolor,0
	  mov hbrusholdcolor,0

	  mov eax,CURRENT3POINTSIZE
	  neg eax
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,FIXED_PITCH,ADDR szface
	  mov  g_hfontx1,eax		;11-point courier new.

	mov  eax,CURRENTPOINTSIZE
	neg  eax
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface5
	mov  g_hfontx1x,eax		;12-point Times New Roman

	  mov eax,CURRENT4POINTSIZE ; 12-1-00
	neg  eax
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface6
	mov  g_hfontx1p5,eax
	mov  eax,CURRENT2POINTSIZE
	mov  ebx,2
	mul  ebx 	;font twice standard size.
	neg  eax
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface3
	mov  g_hfontx2,eax
	mov  eax,CURRENT2POINTSIZE
	mov  ebx,4
	mul  ebx 	;font 4 times standard size.
	neg  eax
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface3
	mov  g_hfontx4,eax

;let's also create a grey pen...
      invoke CreatePen, PS_SOLID,1,0C0C0C0h	;want 1-wide,grey.
      mov g_hpengrey,eax

;create a global white wide pen...
      invoke CreatePen, PS_SOLID,7,0FFFFFFh	;want 5-wide,white.
      mov g_hpenwhite5,eax			;...no, 7 wide

;create 8 color pens, 1-pixel wide (for color coding of rings)...
;(refer paint_*() drawing routine for each element)
      invoke CreatePen, PS_SOLID,1,0000000h	;black.
      mov g_hpen000,eax
      invoke CreatePen, PS_SOLID,1,00000FFh	;red
      mov g_hpen001,eax
      invoke CreatePen, PS_SOLID,1,000FF00h	;green
      mov g_hpen010,eax
      invoke CreatePen, PS_SOLID,1,000C0C0h	;dirty-yellow
      mov g_hpen011,eax
      invoke CreatePen, PS_SOLID,1,0FF0000h	;blue
      mov g_hpen100,eax
      invoke CreatePen, PS_SOLID,1,0FF00FFh	;pink
      mov g_hpen101,eax
      invoke CreatePen, PS_SOLID,1,0FFFF00h	;aqua-blue
      mov g_hpen110,eax
      invoke CreatePen, PS_SOLID,1,0C0C0C0h	;grey
      mov g_hpen111,eax


	  ;default colour for filling polygons....
	    invoke GetStockObject, NULL_BRUSH
	   mov hbrushdefault,eax
	    invoke SelectObject, hdc,hbrushdefault
	   mov hbrushold,eax

	  invoke SetBkMode, hdc, TRANSPARENT   ;leave background showing.
;	  invoke SetTextColor, hdc, 000000FFh ;full-bright 7Fh	;red,half-bright.

	  mov updatesindex,0
	  mov wipeoutsindex,0

	  mov edi,pTERSEDATA
	  mov esi,pendprev ;end prev objects.
	  mov ecx,nobjshigh ;# highlighted elements.
	  .IF cx==0	;empty database.
	    jmp	nextobjy
	  .ENDIF
	  ;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	  mov esisave,esi
	  mov edisave,edi
	  mov ecxsave,ecx
	  xor eax,eax
	  mov al,(OBJECT PTR [esi]).fstatus
	  and ax,01
	  .IF ax==01	;bit0=1, valid object.
	    mov ax,(OBJECT PTR [esi]).nexttype
	    .IF ax==-1
	    .ELSE		;not a data object.

		  ;chose a font size...
		  xor eax,eax
		  mov	al,(OBJECT PTR [esi]).fstatus
		  and	al,011000b	;test for bits3/4.
		  .IF	al==0
		    ;assign the standard font to DC. 
def1:		    invoke SelectObject, hdc,g_hfontx1
		  .ELSEIF al==001000b	;1.5 times font.
		    invoke SelectObject,hdc,g_hfontx1p5
		  .ELSEIF al==010000b	;2 times font.
		    invoke SelectObject,hdc,g_hfontx2
		  .ELSEIF al==011000b	;4 times font.
		    invoke SelectObject,hdc,g_hfontx4
		  .ENDIF
		  mov  holdtextfont,eax

		  ;finally, call the method to display object...
	          mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
		  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdc,esi

		  invoke SelectObject, hdc,holdtextfont	;restore original.

	    .ENDIF
	  .ENDIF
	  mov ecx,ecxsave
	  mov edi,edisave
	  mov esi,esisave
	  xor eax,eax
	  mov ax,(TERSEDATA PTR [edi]).nsizeobject
	  add esi,eax		;addr of next object.
	  loop nextobjx
	  jmp  SHORT nextobjy
nextobjx: jmp nextobj
nextobjy:

	  invoke SelectObject, hdc, hbrushold	;restore old brush.
	  invoke DeleteObject, hbrushdefault

;delete the fonts created at start of this proc...
	invoke DeleteObject,g_hfontx1x
	invoke DeleteObject,g_hfontx1
	invoke DeleteObject,g_hfontx1p5
	invoke DeleteObject,g_hfontx2
	invoke DeleteObject,g_hfontx4
	invoke DeleteObject,g_hpengrey
	invoke DeleteObject,g_hpenwhite5
	invoke DeleteObject,g_hpen000
	invoke DeleteObject,g_hpen001
	invoke DeleteObject,g_hpen010
	invoke DeleteObject,g_hpen011
	invoke DeleteObject,g_hpen100
	invoke DeleteObject,g_hpen101
	invoke DeleteObject,g_hpen110
	invoke DeleteObject,g_hpen111
	mov g_hfontx1x,0
	mov g_hfontx1,0
	mov g_hfontx1p5,0
	mov g_hfontx2,0
	mov g_hfontx4,0
	mov g_hpengrey,0
	mov g_hpenwhite5,0
	mov g_hpen000,0
	mov g_hpen001,0
	mov g_hpen010,0
	mov g_hpen011,0
	mov g_hpen100,0
	mov g_hpen101,0
	mov g_hpen110,0
	mov g_hpen111,0


	  invoke CloseEnhMetaFile,hdc
	  ;...dunno why, but need this to actually write the file to disk.
	.ENDIF


	  ;and resize database...
	  ;(duplicatehighlighted() made it bigger, so restore)...
	  ;(this wipes out the new elements).
	   mov esi,pTERSEDATA
	   mov eax,numobjectsprev
	   mov (TERSEDATA PTR [esi]).numobjects,ax
	  lea eax,(TERSEDATA PTR [esi]).OBJECTS
	  add eax,nsizeobjectsold
	  sub eax,pTERSEDATA	;total size TERSEDATA database.
	  mov g_nfilesize,eax
	  invoke LocalReAlloc, pTERSEDATA,eax,LMEM_MOVEABLE
					;all absolute pointers are invalid...
					mov g_pmovingobject,0
					mov poldmovingobject,0
					mov g_pselectedobject,0
					mov g_pselectedobjectnew,0
					mov g_phighlightedobject,0
					mov g_perrorobject,0
					mov wipeoutsindex,0
					mov updatesindex,0
					mov highlightedindex,0
					mov g_nstate,0
					mov highlightedindexnewlist,0
					mov highlightedindexnewlist,0
	.IF eax==0
	  ;LocalRealloc() fail...
	  lea eax,szerralloc1
	  jmp ferr		;error message and close file.
        .ELSE
          mov pTERSEDATA,eax    ;new pointer.
        .ENDIF

;we copied the selected elements to end of database, wrote them to
;emf disk file, then resized the database back to previous, thus
;wiping out the duplicates. messy, so check that signature still
;computes the same...
	    ;calculate signature...
	    invoke calcsig
	    mov esi,pTERSEDATA
	    mov ecx,(TERSEDATA PTR [esi]).nsignature
	    .IF eax==ecx    ;ok.
	    .ELSE
	      mov (TERSEDATA PTR [esi]).nsignature,eax
	      invoke MessageBox, g_hwnd, ADDR szerremf5,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
	    .ENDIF




		invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
		mov g_fredrawdiag,ENTIRE	;redraw entire window.
    mov eax,0	;succeeded.
    ret
selectedsaveasemf ENDP
;--------------------------------------------------------------------------
getprinterdetails PROC STDCALL USES esi edi eax ebx ecx edx
    LOCAL dummy:DWORD
;called from wmcreate().

	  invoke GetProfileString,ADDR szwininititle,ADDR szwininisub,\
		 ADDR szwininidef,ADDR szwininiline,48 ;-->ax=#bytes copied.
	  lea  ebx,szwininiline		;line returned by getprofilestring.
	  mov  edx,ebx
	  add  edx,eax			;end of line.
	  lea  esi,szname
tot2:	  mov  al,[ebx]
	  .IF  al==","		;delimiter
	    mov [esi],BYTE PTR 0
	    jmp SHORT tot3
	  .ELSE
	    mov	[esi],al		;extract the printer name.
	    inc esi
	  .ENDIF
	  inc  ebx
	  cmp  ebx,edx
	  jne  tot2
	  jmp  tot4	       ;done
tot3:	  lea  esi,szdriver
	  inc  ebx
tot7:	  mov  al,[ebx]
	  .IF  al==","		;delimiter
	    mov  [esi],BYTE PTR 0
	    jmp SHORT tot6
	  .ELSE
	    mov	[esi],al		;extract the driver name.
	    inc esi
	  .ENDIF
	  inc  ebx
	  cmp  ebx,edx
	  jne  tot7
	  jmp  tot4		;done
tot6:	  lea  esi,szport
	  inc  ebx
tot8:	  mov  al,[ebx]
	  .IF  al==","		;delimiter
	    jmp SHORT tot11
	  .ELSEIF al==":"
	    jmp SHORT tot11
	  .ELSEIF al==0Dh
	    jmp SHORT tot11
	  .ELSE
	    mov	[esi],al		;extract the printer port.
	    inc esi
	  .ENDIF
	  inc  ebx
	  cmp  ebx,edx
	  jne  tot8
tot4:
tot11:	  mov  [esi],BYTE PTR 0

;find out capabilities of printer...
;  invoke DEVICECAPABILITIES,



        ret
getprinterdetails ENDP
;--------------------------------------------------------------------------
.DATA
szapi BYTE "API",0
szisr BYTE "ISR",0
.CODE
paint_node PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL ringwidth:DWORD
	LOCAL ringstmp:BYTE
	LOCAL xright:DWORD
	LOCAL ybottom:DWORD
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL xend1:SDWORD, yend1:SDWORD
	LOCAL state:BYTE
	LOCAL holdfont:DWORD
	LOCAL hpensaved:DWORD, hpendefault:DWORD, hpenold2:DWORD
	LOCAL ncolorindex:BYTE
	LOCAL x1:SDWORD,y1:SDWORD,x2:SDWORD,y2:SDWORD,ring:DWORD
	LOCAL hbrusholdcolor:DWORD,hbrushnewcolor:DWORD
	LOCAL xmid2:SDWORD,ymid2:SDWORD
;this is a method, to display nodes.	   "paint_node"
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF


      mov esi,pobject

	mov eax,(OBJECT PTR [esi]).wwidth
      add eax,(OBJECT PTR [esi]).xtopleft
	mov xright,eax
      mov ebx,(OBJECT PTR [esi]).height
      add ebx,(OBJECT PTR [esi]).ytopleft
	mov ybottom,ebx


;101200
;new code for rings not concentric...
;    mov eax,(OBJECT PTR [esi]).wwidth
;    mov ecx,(OBJECT PTR [esi]).height
;    .IF eax==ecx
;      ;use old code.
;      ;note, it handles ellipses, concentric.
;    .ELSE
;      ;new code for non-concentric...
;      jmp newnonconcentric
;    .ENDIF
    test (OBJECT PTR [esi]).fconfig3,0100b ;bit2.
    jz old1
    jmp newnonconcentric
old1:

;121200 precaution...
    ;concentric rings, don't reference object.nringwidth, but if
    ;do at some future date, make sure old diags ok...
    mov eax,(OBJECT PTR [esi]).nringwidth
    .IF eax==0	    ;no gap between rings!
      mov (OBJECT PTR [esi]).nringwidth,8
    .ENDIF

;021000
;optional color-coding of rings...
	mov ebx,pTERSEDATA
	mov al,(TERSEDATA PTR [ebx]).fviewprefs
	and al,01	;bit0=1 color coded rings.
	jz mono1
	cmp g_fredrawdiag,WIPEOUTobjs
	je mono1
	  invoke SelectObject, hdc,g_hpen000	;black.
	  mov hpendefault,eax
	  mov al,(OBJECT PTR [esi]).nring1colorindex
	  add al,(OBJECT PTR [esi]).nrings  ;number of rings.
	  dec al
	  mov ncolorindex,al
	    ;draw each ring, one inside the other....
	    mov eax,xright
	    mov ebx,ybottom
	    mov cl,(OBJECT PTR [esi]).nrings
	    mov ringstmp,cl
xiter1:	    pushad
	    xor ecx,ecx
	    mov cl,ringstmp
	    dec cl
	    shl cl,1	;*2
	    shl cl,1	;*2 again
	    shl cl,1	;mult by 8 total
	    mov ringwidth,ecx
	    mov ecx,(OBJECT PTR [esi]).xtopleft
	    sub ecx,ringwidth
	    mov edx,(OBJECT PTR [esi]).ytopleft
	    sub edx,ringwidth
	    add eax,ringwidth
	    mov edi,eax
	    add ebx,ringwidth
	      pushad
	      mov al,ncolorindex
	      and al,0111b
	      .IF al==0
		mov eax,g_hpen000      ;black
	      .ELSEIF al==001b
		mov eax,g_hpen001      ;red
	      .ELSEIF al==010b
		mov eax,g_hpen100      ;blue
	      .ELSEIF al==011b
		mov eax,g_hpen101      ;pink
	      .ELSEIF al==100b
		mov eax,g_hpen110      ;aqua-blue
	      .ELSEIF al==101b
		mov eax,g_hpen010      ;green
	      .ELSEIF al==110b
		mov eax,g_hpen011      ;yellow
	      .ELSEIF al==111b
		mov eax,g_hpen111      ;grey
	      .ENDIF
	      invoke SelectObject, hdc,eax
	      popad
	    invoke Ellipse, hdc, ecx,edx, eax,ebx	 ;
	    popad
	    dec ncolorindex
	    dec ringstmp
	    cmp ringstmp,0
	    ja xiter1

	    ;if node has color-fill...
	    .IF g_fredrawdiag==WIPEOUTobjs
	      ;xpaint_wipeout has already activate white brush.
	    .ELSE
	      ;xpaint_entire,_update,_print activate a null-brush.
	      ;but if need color fill...
		    mov al,(OBJECT PTR [esi]).fconfig
		    and al,0100b    ;bit2=1 turn on colour.
		    .IF al==0100b
kka:		      mov eax,(OBJECT PTR [esi]).ncolour1
		      invoke CreateSolidBrush, eax
		      mov hbrushnewcolor,eax
		      invoke SelectObject, hdc,hbrushnewcolor
		      mov hbrusholdcolor,eax
			;draw another circle, inside ring1...
			mov eax,(OBJECT PTR [esi]).xtopleft
			mov ebx,(OBJECT PTR [esi]).ytopleft
			mov ecx,xright
			mov edx,ybottom
			inc eax
			inc ebx
			dec ecx
			dec edx
			invoke Ellipse, hdc, eax,ebx, ecx,edx
		      invoke SelectObject, hdc, hbrusholdcolor
		      invoke DeleteObject, hbrushnewcolor
		    .ELSE
		      ;171200 have decided all funcs have color-fill,
		      ;default grey...
		      mov al,(OBJECT PTR [esi]).nfunctype
		      .IF al==0	    ;inline code.
			;thicker ring1, no color-fill...
			;draw another circle, inside ring1...
			mov eax,(OBJECT PTR [esi]).xtopleft
			mov ebx,(OBJECT PTR [esi]).ytopleft
			mov ecx,xright
			mov edx,ybottom
			inc eax
			inc ebx
			dec ecx
			dec edx
			invoke Ellipse, hdc, eax,ebx, ecx,edx
		      .ELSE
			test (OBJECT PTR [esi]).fconfig,0100b ;bit2.
			jnz kka     ;display thick ring1, color-fill.
			mov (OBJECT PTR [esi]).ncolour1,0C0C0C0h ;greydefault.
			or (OBJECT PTR [esi]).fconfig,0100b ;set bit2.
			jmp kka
		      .ENDIF
		    .ENDIF
	    .ENDIF

;	    ;if node is a function, display innermost ring thicker...
;	    mov al,(OBJECT PTR [esi]).nfunctype
;	    .IF al==0	    ;inline code.
;	    .ELSE
;	      mov eax,(OBJECT PTR [esi]).xtopleft
;	      mov ebx,(OBJECT PTR [esi]).ytopleft
;	      mov ecx,xright
;	      mov edx,ybottom
;	      inc eax
;	      inc ebx
;	      dec ecx
;	      dec edx
;	      pushad
;	      invoke Ellipse, hdc, eax,ebx, ecx,edx
;	      popad
;	      inc eax
;	      inc ebx
;	      dec ecx
;	      dec edx
;	      invoke Ellipse, hdc, eax,ebx, ecx,edx
;	    .ENDIF

	    invoke SelectObject, hdc,hpendefault ;when entered this func.
	jmp monobypass1

mono1:
;draw each ring, one inside the other....
	mov eax,xright
	mov ebx,ybottom
	mov cl,(OBJECT PTR [esi]).nrings
	mov ringstmp,cl
iter1:
	pushad
	xor ecx,ecx
	mov cl,ringstmp
	dec cl
	shl cl,1	;*2
	shl cl,1	;*2 again
	shl cl,1	;mult by 8 total
	mov ringwidth,ecx
	mov ecx,(OBJECT PTR [esi]).xtopleft
	sub ecx,ringwidth
	mov edx,(OBJECT PTR [esi]).ytopleft
	sub edx,ringwidth
	add eax,ringwidth
	add ebx,ringwidth
	invoke Ellipse, hdc, ecx,edx, eax,ebx	 ;
	popad
	dec ringstmp
	cmp ringstmp,0
	ja iter1

	    ;if node has color-fill...
	    .IF g_fredrawdiag==WIPEOUTobjs
	      ;xpaint_wipeout has already activate white brush.
	    .ELSE
	      ;xpaint_entire,_update,_print activate a null-brush.
	      ;but if need color fill...
		    mov al,(OBJECT PTR [esi]).fconfig
		    and al,0100b    ;bit2=1 turn on colour.
		    .IF al==0100b
xkka:		      mov eax,(OBJECT PTR [esi]).ncolour1
		      invoke CreateSolidBrush, eax
		      mov hbrushnewcolor,eax
		      invoke SelectObject, hdc,hbrushnewcolor
		      mov hbrusholdcolor,eax
			;draw another circle, inside ring1...
			mov eax,(OBJECT PTR [esi]).xtopleft
			mov ebx,(OBJECT PTR [esi]).ytopleft
			mov ecx,xright
			mov edx,ybottom
			inc eax
			inc ebx
			dec ecx
			dec edx
			invoke Ellipse, hdc, eax,ebx, ecx,edx
		      invoke SelectObject, hdc, hbrusholdcolor
		      invoke DeleteObject, hbrushnewcolor
		    .ELSE
		      ;171200 have decided all funcs have color-fill,
		      ;default grey...
		      mov al,(OBJECT PTR [esi]).nfunctype
		      .IF al==0	    ;inline code.
			;thicker ring1, no color-fill...
			;draw another circle, inside ring1...
			mov eax,(OBJECT PTR [esi]).xtopleft
			mov ebx,(OBJECT PTR [esi]).ytopleft
			mov ecx,xright
			mov edx,ybottom
			inc eax
			inc ebx
			dec ecx
			dec edx
			invoke Ellipse, hdc, eax,ebx, ecx,edx
		      .ELSE
			test (OBJECT PTR [esi]).fconfig,0100b ;bit2.
			jnz xkka     ;display thick ring1, color-fill.
			mov (OBJECT PTR [esi]).ncolour1,0C0C0C0h ;greydefault.
			or (OBJECT PTR [esi]).fconfig,0100b ;set bit2.
			jmp xkka
		      .ENDIF
		    .ENDIF
	    .ENDIF


;;if node is a function, display innermost ring thicker...
;    mov al,(OBJECT PTR [esi]).nfunctype
;    .IF al==0	    ;inline code.
;    .ELSE
;      mov eax,(OBJECT PTR [esi]).xtopleft
;      mov ebx,(OBJECT PTR [esi]).ytopleft
;      mov ecx,xright
;      mov edx,ybottom
;      inc eax
;      inc ebx
;      dec ecx
;      dec edx
;      pushad
;      invoke Ellipse, hdc, eax,ebx, ecx,edx
;      popad
;      inc eax
;      inc ebx
;      dec ecx
;      dec edx
;      invoke Ellipse, hdc, eax,ebx, ecx,edx
;    .ENDIF
monobypass1:


;121000 ... NO, now execution-icon has its own paint method,
;paint_exec(), called via "pexec" row in method table.
;but, leave this in for now...
;111000
;execution-icon now totally separate from a node, but still uses
;this paint func. the brush has already been selected for color-fill
;so above circle has drawn a solid circle, now superimpose an "X"...
    mov al,(OBJECT PTR [esi]).fconfig
    and al,011000b
    .IF al==010000b	;bits4/3=1/0 dblclk to execute winapp.
      invoke SelectObject, hdc, g_hpenwhite5 ;wide white pen.
      mov hpenold2,eax
      mov eax,(OBJECT PTR [esi]).xtopleft
      mov ebx,(OBJECT PTR [esi]).ytopleft
      invoke MoveToEx, hdc,eax,ebx,0
      invoke LineTo, hdc,xright,ybottom
      mov eax,(OBJECT PTR [esi]).xtopleft
      invoke MoveToEx, hdc,eax,ybottom,0
      mov eax,(OBJECT PTR [esi]).ytopleft
      invoke LineTo, hdc,xright,eax
      invoke SelectObject, hdc, hpenold2
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,6
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,6
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,xright
	sub eax,6
	mov ebx,ybottom
	sub ebx,6
	invoke LineTo, hdc,eax,ebx
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,6
	mov ebx,ybottom
	sub ebx,6
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).ytopleft
	add eax,6
	mov ebx,xright
	sub ebx,6
	invoke LineTo, hdc,ebx,eax
    .ENDIF


;    mov  esi,pobject

jjw:
;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 invoke CreateEllipticRgn, (OBJECT PTR [esi]).xtopleft,\
			(OBJECT PTR [esi]).ytopleft,\
                     xright,ybottom     ;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...
	mov esi,pobject
	mov eax,(OBJECT PTR [esi]).xtopleft	    ;display text in node
	add eax,34 ;2
	test (OBJECT PTR [esi]).fconfig3,0100b ;bit2.
	jnz eea     ;totem-pole rings.
	  xor ebx,ebx
	  mov bl,(OBJECT PTR [esi]).nrings
	  dec bl
	  shl ebx,1	;multiply by 8, ring width
	  shl ebx,1
	  shl ebx,1
	  add eax,ebx	;auto-move label to outside of node.
eea:	 mov ebx,(OBJECT PTR [esi]).ytopleft	       ;/
        mov ecx,(OBJECT PTR [esi]).height             ;/
	sar ecx,1				   ;/
      add ebx,ecx                                   ;/
	sub ebx,8 ;7  12-1-00
;offset text, from OBJECT.x/ylabeloffset ....
	mov ecx,eax
	mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	cwde		;sign-extends ax -->eax.
	add ecx,eax	;new x-coord.
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov eax,ecx	;restore ax=x-coord

  xor ecx,ecx
  mov cl,(OBJECT PTR [esi]).fstatus
  and cx,01100000b  ;extract bits 5/6
  .IF cl==00100000b   ;display label
	lea edx,(OBJECT PTR [esi]).sztext1
	 invoke TEXTOUTx, hdc,eax,ebx,edx,62	;/
  .ELSEIF cl==01000000b	;test bit6, display filespec.
	lea edx,(OBJECT PTR [esi]).sztext2
	 invoke TEXTOUTx, hdc,eax,ebx,edx,125	;/
  .ENDIF

;for totem-pole (nonconcentric) rings, display ring# inside
;each ring...
	test (OBJECT PTR [esi]).fconfig3,0100b ;bit2.
	jz eeb	    ;concentric.
	  .IF g_fredrawdiag==WIPEOUTobjs
	    ;xpaint_*() has already activated a white brush.
	    mov hbrusholdcolor,0
	    mov hbrushnewcolor,0
	  .ELSE
		      mov eax,0 ;black
		      invoke CreateSolidBrush, eax
		      mov hbrushnewcolor,eax
		      invoke SelectObject, hdc,hbrushnewcolor
		      mov hbrusholdcolor,eax
	  .ENDIF
	xor ecx,ecx
	mov cl,(OBJECT PTR [esi]).nrings
eec:	nop
	.IF ecx>1
	  mov eax,ecx
	  invoke bin2dec    ;eax-->szasciitbl.
	  mov eax,(OBJECT PTR [esi]).xdeltacentre
	  mov edx,ecx
	  dec edx
	  imul edx
	  add eax,(OBJECT PTR [esi]).xmid
	  mov xmid2,eax
	  sub eax,11
	  mov ebx,eax
	  mov eax,(OBJECT PTR [esi]).ydeltacentre
	  mov edx,ecx
	  dec edx
	  imul edx
	  add eax,(OBJECT PTR [esi]).ymid
	  mov ymid2,eax
	  sub eax,6
	  lea edx,szasciitbl+8
	  invoke TEXTOUTx, hdc,ebx,eax,edx,2	;/
	    ;draw a black-filled rectangle between rings...
	    .IF SDWORD PTR (OBJECT PTR [esi]).ydeltacentre<0  ;totem-up.
	      push ecx
	      mov eax,xmid2
	      sub eax,4	    ;xleft
	      mov ebx,ymid2
	      mov edx,(OBJECT PTR [esi]).height
	      shr edx,1
	      add ebx,edx     ;ytop
	      mov ecx,eax
	      add ecx,8	    ;xright
	      mov edx,ebx
	      sub edx,(OBJECT PTR [esi]).ydeltacentre
	      sub edx,(OBJECT PTR [esi]).height	;ybottom.
	      invoke Rectangle, hdc,eax,ebx,ecx,edx
	      pop ecx
	    .ELSE	      ;totem grows down.
	      push ecx
	      mov eax,xmid2
	      sub eax,4	    ;xleft
	      mov ebx,ymid2
	      mov edx,(OBJECT PTR [esi]).height
	      shr edx,1
	      sub ebx,edx    ;ybottom	   ;ytop
	      mov ecx,ymid2
	      sub ecx,(OBJECT PTR [esi]).ydeltacentre
	      add ecx,edx
	      mov edx,ecx   ;ytop
	      mov ecx,eax
	      add ecx,8	    ;xright
	      invoke Rectangle, hdc,eax,edx,ecx,ebx
	      pop ecx
	    .ENDIF
	  loop eecx
	  jmp SHORT eecxx
eecx:	  jmp eec
eecxx:
	.ENDIF
	.IF hbrushnewcolor==0
	.ELSE
	    invoke SelectObject, hdc,hbrusholdcolor
	    invoke DeleteObject, hbrushnewcolor
	.ENDIF
eeb:

;now draw a line from node to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if node locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE
	mov edi,plock	;parent.
	mov al,(OBJECT PTR [edi]).fconfig3
	and al,0100b	;bit2.
	.IF al==0100b	;totem-pole.
	  mov g_nsnapring,1 ;snap line to ring1 of parent.
	.ELSE
	  mov g_nsnapring,0 ;snap xend/yend to closest ring on parent.
	.ENDIF
	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of node.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.
	;...or on ring1 in case of totem-pole rings.
      ;now draw line...
	  ;aah, except also want line at "this end" to be on boundary...
		  mov eax,xend
		  mov xend1,eax
		  mov eax,yend
		  mov yend1,eax
		  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	invoke snapPTR PTR [ebx+ptrs+psnap], esi,ADDR xend1,ADDR yend1
      ;NOW can draw line...
      invoke MoveToEx, hdc, xend1,yend1,0
	;however, if line very long, would like a grey line...
	mov eax,xend1
	sub eax,xend
	.IF SDWORD PTR eax<0
	  neg eax
	.ENDIF
	.IF eax>300
	  jmp SHORT dg1
	.ELSE
	  mov eax,yend1
	  sub eax,yend
	  .IF SDWORD PTR eax<0
	    neg eax
	  .ENDIF
	  .IF eax>300
dg1:	    .IF g_fredrawdiag==WIPEOUTobjs
	      jmp dg2	    ;need to wipe it out.
	    .ELSE
	      invoke SelectObject, hdc,g_hpengrey
	      mov hpensaved,eax
	      invoke LineTo, hdc, xend,yend
	      invoke SelectObject, hdc,hpensaved
	    .ENDIF
	  .ELSE
dg2:	    invoke LineTo, hdc, xend,yend
	  .ENDIF
	.ENDIF
    .ENDIF


;	    ;for some reason, when drag a node, xmid/ymid drifts off.
;	    ;don't know why, but hack is to keep it correct here...
;	    mov eax,(OBJECT PTR [esi]).wwidth
;	    shr eax,1
;	    add eax,(OBJECT PTR [esi]).xtopleft
;	    mov (OBJECT PTR [esi]).xmid,eax
;	    mov eax,(OBJECT PTR [esi]).height
;	    shr eax,1
;	    add eax,(OBJECT PTR [esi]).ytopleft
;	    mov (OBJECT PTR [esi]).ymid,eax



    .IF state==4
    .ELSEIF state==5
    .ELSE
      ;must always use standard font size...
      invoke SelectObject, hdc, g_hfontx1x  ;g_hfontx1	12-1-00
      mov holdfont,eax
      mov esi,pobject
;if node is a function, put a message inside...
;(we already have a thick border for elipse to show function)
      mov al,(OBJECT PTR [esi]).nfunctype
      .IF al==1	   ;normal function
      .ELSEIF al==2 ;isr
	lea eax,szisr
	jmp SHORT ap1
      .ELSEIF al==3 ;library func.
	lea eax,szapi
ap1:	mov ebx,(OBJECT PTR [esi]).xmid
	sub ebx,10
	mov ecx,(OBJECT PTR [esi]).ymid
	sub ecx,1 ;7 ;6	12-1-00 15-1-00
	invoke TEXTOUTx, hdc, ebx,ecx, eax,3
      .ENDIF

;if node is public or external...
      mov al,(OBJECT PTR [esi]).fstatus2
      and al,0110b	;extract bits2/1.
      .IF al==0100b	;public
	lea eax,szpublic
	jmp SHORT xap1
      .ELSEIF al==0110b ;external
	lea eax,szextern2
xap1:	mov ebx,(OBJECT PTR [esi]).xmid
	sub ebx,14
	mov ecx,(OBJECT PTR [esi]).ymid
	sub ecx,11
	invoke TEXTOUTx, hdc, ebx,ecx, eax,6
      .ENDIF

      invoke SelectObject, hdc,holdfont

      ;if node is a child, draw inherited blobs...
      mov eax,(OBJECT PTR [esi]).rplock1
      .IF eax==0	 ;free node (or master)
      .ELSE
	;but not if its a datatype-node (attached to a pointer resource)...
	mov al,(OBJECT PTR [esi]).fstatus2
	and al,01000b	;bit3 =1 datatype-node.
	.IF al==1000b
	.ELSE
	  invoke drawblobs, hdc,esi
	.ENDIF
      .ENDIF
    .ENDIF

;    ;for color-coded rings, need this. redundent for mono...
;    invoke SelectObject, hdc,hpendefault ;when entered this func.

    ret

;.................
newnonconcentric:
;101200
;this is a jump out of the code above, to paint non-concentric rings.
;will jump back up to jjw:.

;optional color-coding of rings...
	mov ebx,pTERSEDATA
	mov al,(TERSEDATA PTR [ebx]).fviewprefs
	and al,01	;bit0=1 color coded rings.
	jz zmono1
	cmp g_fredrawdiag,WIPEOUTobjs
	je zmono1
	  invoke SelectObject, hdc,g_hpen000	;black.
	  mov hpendefault,eax
	  mov al,(OBJECT PTR [esi]).nring1colorindex
	  add al,(OBJECT PTR [esi]).nrings  ;number of rings.
	  dec al
	  mov ncolorindex,al
	    ;draw each ring, maybe non-concentric....
	    xor ecx,ecx
	    mov cl,(OBJECT PTR [esi]).nrings
	    mov ring,ecx
zxiter1:		  ;loop here to draw each ring.
	    mov ecx,ring
	    dec ecx
	    mov eax,(OBJECT PTR [esi]).nringwidth ;NRINGWIDTH
	    mul ecx
	    mov ringwidth,eax ;total width, from ring1.
	      mov ecx,(OBJECT PTR [esi]).wwidth
	      shr ecx,1
	      add ecx,ringwidth	 ;total x-radius from centre of ring.
	       mov eax,(OBJECT PTR [esi]).xdeltacentre
	       mov edx,ring
	       dec edx
	       imul edx
	       add eax,(OBJECT PTR [esi]).xmid	;middle of ring.
	       mov edx,eax
	       sub edx,ecx
	       mov x1,edx   ;x-coord, top-left ellipse.
	       add eax,ecx
	       mov x2,eax   ;x-coord, bot-right ellipse.
	      mov ecx,(OBJECT PTR [esi]).height
	      shr ecx,1
	      add ecx,ringwidth	 ;total y-radius from centre of ring.
	       mov eax,(OBJECT PTR [esi]).ydeltacentre
	       mov edx,ring
	       dec edx
	       imul edx
	       add eax,(OBJECT PTR [esi]).ymid	;middle of ring.
	       mov edx,eax
	       sub edx,ecx
	       mov y1,edx   ;y-coord, top-left ellipse.
	       add eax,ecx
	       mov y2,eax   ;y-coord, bot-right ellipse.

	      mov al,ncolorindex
	      and al,0111b
	      .IF al==0
		mov eax,g_hpen000      ;black
	      .ELSEIF al==001b
		mov eax,g_hpen001      ;red
	      .ELSEIF al==010b
		mov eax,g_hpen100      ;blue
	      .ELSEIF al==011b
		mov eax,g_hpen101      ;pink
	      .ELSEIF al==100b
		mov eax,g_hpen110      ;aqua-blue
	      .ELSEIF al==101b
		mov eax,g_hpen010      ;green
	      .ELSEIF al==110b
		mov eax,g_hpen011      ;yellow
	      .ELSEIF al==111b
		mov eax,g_hpen111      ;grey
	      .ENDIF
	      invoke SelectObject, hdc,eax

	    invoke Ellipse, hdc, x1,y1, x2,y2

	    dec ncolorindex
	    dec ring
	    cmp ring,0
	    ja zxiter1

	    ;if node has color-fill...
	    .IF g_fredrawdiag==WIPEOUTobjs
	      ;xpaint_wipeout has already activate white brush.
	    .ELSE
	      ;xpaint_entire,_update,_print activate a null-brush.
	      ;but if need color fill...
		    mov al,(OBJECT PTR [esi]).fconfig
		    and al,0100b    ;bit2=1 turn on colour.
		    .IF al==0100b
vkka:		      mov eax,(OBJECT PTR [esi]).ncolour1
		      invoke CreateSolidBrush, eax
		      mov hbrushnewcolor,eax
		      invoke SelectObject, hdc,hbrushnewcolor
		      mov hbrusholdcolor,eax
			;draw another circle, inside ring1...
			mov eax,(OBJECT PTR [esi]).xtopleft
			mov ebx,(OBJECT PTR [esi]).ytopleft
			mov ecx,xright
			mov edx,ybottom
			inc eax
			inc ebx
			dec ecx
			dec edx
			invoke Ellipse, hdc, eax,ebx, ecx,edx
		      invoke SelectObject, hdc, hbrusholdcolor
		      invoke DeleteObject, hbrushnewcolor
		    .ELSE
		      ;171200 have decided all funcs have color-fill,
		      ;default grey...
		      mov al,(OBJECT PTR [esi]).nfunctype
		      .IF al==0	    ;inline code.
			;thicker ring1, no color-fill...
			;draw another circle, inside ring1...
			mov eax,(OBJECT PTR [esi]).xtopleft
			mov ebx,(OBJECT PTR [esi]).ytopleft
			mov ecx,xright
			mov edx,ybottom
			inc eax
			inc ebx
			dec ecx
			dec edx
			invoke Ellipse, hdc, eax,ebx, ecx,edx
		      .ELSE
			test (OBJECT PTR [esi]).fconfig,0100b ;bit2.
			jnz vkka     ;display thick ring1, color-fill.
			mov (OBJECT PTR [esi]).ncolour1,0C0C0C0h ;greydefault.
			or (OBJECT PTR [esi]).fconfig,0100b ;set bit2.
			jmp vkka
		      .ENDIF
		    .ENDIF
	    .ENDIF


;	    ;if node is a function, display innermost ring thicker...
;	    mov al,(OBJECT PTR [esi]).nfunctype
;	    .IF al==0	    ;inline code.
;	    .ELSE
;	      mov eax,(OBJECT PTR [esi]).xtopleft
;	      mov ebx,(OBJECT PTR [esi]).ytopleft
;	      mov ecx,(OBJECT PTR [esi]).wwidth
;	      add ecx,eax ;xright
;	      mov edx,(OBJECT PTR [esi]).height
;	      add edx,ebx ;ybottom
;	      inc eax
;	      inc ebx
;	      dec ecx
;	      dec edx
;	      invoke Ellipse, hdc, eax,ebx, ecx,edx
;	    .ENDIF

	    invoke SelectObject, hdc,hpendefault ;when entered this func.
	jmp zmonobypass1

zmono1:
;draw each ring, maybe non-concentric....
	    xor ecx,ecx
	    mov cl,(OBJECT PTR [esi]).nrings
	    mov ring,ecx
vzxiter1:		  ;loop here to draw each ring.
	    mov ecx,ring
	    dec ecx
	    mov eax,(OBJECT PTR [esi]).nringwidth ;NRINGWIDTH
	    mul ecx
	    mov ringwidth,eax ;total width, from ring1.
	      mov ecx,(OBJECT PTR [esi]).wwidth
	      shr ecx,1
	      add ecx,ringwidth	 ;total x-radius from centre of ring.
	       mov eax,(OBJECT PTR [esi]).xdeltacentre
	       mov edx,ring
	       dec edx
	       imul edx
	       add eax,(OBJECT PTR [esi]).xmid	;middle of ring.
	       mov edx,eax
	       sub edx,ecx
	       mov x1,edx   ;x-coord, top-left ellipse.
	       add eax,ecx
	       mov x2,eax   ;x-coord, bot-right ellipse.
	      mov ecx,(OBJECT PTR [esi]).height
	      shr ecx,1
	      add ecx,ringwidth	 ;total y-radius from centre of ring.
	       mov eax,(OBJECT PTR [esi]).ydeltacentre
	       mov edx,ring
	       dec edx
	       imul edx
	       add eax,(OBJECT PTR [esi]).ymid	;middle of ring.
	       mov edx,eax
	       sub edx,ecx
	       mov y1,edx   ;y-coord, top-left ellipse.
	       add eax,ecx
	       mov y2,eax   ;y-coord, bot-right ellipse.

	    invoke Ellipse, hdc, x1,y1, x2,y2

	    dec ring
	    cmp ring,0
	    ja vzxiter1

	    ;if node has color-fill...
	    .IF g_fredrawdiag==WIPEOUTobjs
	      ;xpaint_wipeout has already activate white brush.
	    .ELSE
	      ;xpaint_entire,_update,_print activate a null-brush.
	      ;but if need color fill...
		    mov al,(OBJECT PTR [esi]).fconfig
		    and al,0100b    ;bit2=1 turn on colour.
		    .IF al==0100b
wkka:		      mov eax,(OBJECT PTR [esi]).ncolour1
		      invoke CreateSolidBrush, eax
		      mov hbrushnewcolor,eax
		      invoke SelectObject, hdc,hbrushnewcolor
		      mov hbrusholdcolor,eax
			;draw another circle, inside ring1...
			mov eax,(OBJECT PTR [esi]).xtopleft
			mov ebx,(OBJECT PTR [esi]).ytopleft
			mov ecx,xright
			mov edx,ybottom
			inc eax
			inc ebx
			dec ecx
			dec edx
			invoke Ellipse, hdc, eax,ebx, ecx,edx
		      invoke SelectObject, hdc, hbrusholdcolor
		      invoke DeleteObject, hbrushnewcolor
		    .ELSE
		      ;171200 have decided all funcs have color-fill,
		      ;default grey...
		      mov al,(OBJECT PTR [esi]).nfunctype
		      .IF al==0	    ;inline code.
			;thicker ring1, no color-fill...
			;draw another circle, inside ring1...
			mov eax,(OBJECT PTR [esi]).xtopleft
			mov ebx,(OBJECT PTR [esi]).ytopleft
			mov ecx,xright
			mov edx,ybottom
			inc eax
			inc ebx
			dec ecx
			dec edx
			invoke Ellipse, hdc, eax,ebx, ecx,edx
		      .ELSE
			test (OBJECT PTR [esi]).fconfig,0100b ;bit2.
			jnz wkka     ;display thick ring1, color-fill.
			mov (OBJECT PTR [esi]).ncolour1,0C0C0C0h ;greydefault.
			or (OBJECT PTR [esi]).fconfig,0100b ;set bit2.
			jmp wkka
		      .ENDIF
		    .ENDIF
	    .ENDIF


;	    ;if node is a function, display innermost ring thicker...
;	    mov al,(OBJECT PTR [esi]).nfunctype
;	    .IF al==0	    ;inline code.
;	    .ELSE
;	      mov eax,(OBJECT PTR [esi]).xtopleft
;	      mov ebx,(OBJECT PTR [esi]).ytopleft
;	      mov ecx,(OBJECT PTR [esi]).wwidth
;	      add ecx,eax ;xright
;	      mov edx,(OBJECT PTR [esi]).height
;	      add edx,ebx ;ybottom
;	      inc eax
;	      inc ebx
;	      dec ecx
;	      dec edx
;	      invoke Ellipse, hdc, eax,ebx, ecx,edx
;	    .ENDIF

zmonobypass1:
    jmp jjw	;back to main code for this func.

paint_node ENDP
;--------------------------------------------------------------------------
.DATA
sz_win	BYTE "win",0
sz_exec BYTE "E    ec",0
.CODE
paint_exec PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL ringwidth:DWORD
	LOCAL ringstmp:BYTE
	LOCAL xright:DWORD
	LOCAL ybottom:DWORD
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL xend1:SDWORD, yend1:SDWORD
	LOCAL state:BYTE
	LOCAL holdfont:DWORD
	LOCAL hpensaved:DWORD, hpendefault:DWORD, hpenold2:DWORD
	LOCAL ncolorindex:BYTE
	LOCAL hbrusholdcolor:DWORD,hbrushnewcolor:DWORD
; "paint_exec"
;121000 for execution-icon, via "pexec" row in method table
; -- based on paint_node() code.
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF


      mov esi,pobject

	mov eax,(OBJECT PTR [esi]).wwidth
      add eax,(OBJECT PTR [esi]).xtopleft
	mov xright,eax
      mov ebx,(OBJECT PTR [esi]).height
      add ebx,(OBJECT PTR [esi]).ytopleft
	mov ybottom,ebx

;draw ring, with color-fill...
	    .IF g_fredrawdiag==WIPEOUTobjs
	      ;xpaint_wipeout has already activate white brush.
	      mov eax,xright
	      mov ebx,ybottom
	      mov ecx,(OBJECT PTR [esi]).xtopleft
	      mov edx,(OBJECT PTR [esi]).ytopleft
	      invoke Ellipse, hdc, ecx,edx, eax,ebx	 ;
	    .ELSE
		      mov eax,(OBJECT PTR [esi]).ncolour1
		      invoke CreateSolidBrush, eax
		      mov hbrushnewcolor,eax
		      invoke SelectObject, hdc,hbrushnewcolor
		      mov hbrusholdcolor,eax
	      mov eax,xright
	      mov ebx,ybottom
	      mov ecx,(OBJECT PTR [esi]).xtopleft
	      mov edx,(OBJECT PTR [esi]).ytopleft
	      invoke Ellipse, hdc, ecx,edx, eax,ebx	 ;
		      invoke SelectObject, hdc, hbrusholdcolor
		      invoke DeleteObject, hbrushnewcolor
	    .ENDIF

;111000
;execution-icon now totally separate from a node, but still uses
;this paint func. the brush has already been selected for color-fill
;so above circle has drawn a solid circle, now superimpose an "X"...
;    mov al,(OBJECT PTR [esi]).fconfig
;    and al,011000b
;    .IF al==010000b	;bits4/3=1/0 dblclk to execute winapp.
      invoke SelectObject, hdc, g_hpenwhite5 ;wide white pen.
      mov hpenold2,eax
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,14 ;10
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,14 ;10
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,xright
	sub eax,14 ;10
	mov ebx,ybottom
	sub ebx,14 ;10
	invoke LineTo, hdc,eax,ebx
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,14 ;10
	mov ebx,ybottom
	sub ebx,14 ;10
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).ytopleft
	add eax,14 ;10
	mov ebx,xright
	sub ebx,14 ;10
	invoke LineTo, hdc,ebx,eax
      invoke SelectObject, hdc, hpenold2
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,14 ;7
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,14 ;7
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,xright
	sub eax,14 ;7
	mov ebx,ybottom
	sub ebx,14 ;7
	invoke LineTo, hdc,eax,ebx
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,14 ;7
	mov ebx,ybottom
	sub ebx,14 ;7
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).ytopleft
	add eax,14 ;7
	mov ebx,xright
	sub ebx,14 ;7
	invoke LineTo, hdc,ebx,eax
;    .ENDIF
	  ;now for text...
	  ;must always use standard font size...
	  invoke SelectObject, hdc, g_hfontx1x	;g_hfontx1
	  mov holdfont,eax
	  mov esi,pobject
	    lea eax,sz_win
	    mov ebx,(OBJECT PTR [esi]).xtopleft
	    add ebx,14 ;4 ;3
	    mov ecx,(OBJECT PTR [esi]).ytopleft
	    add ecx,2 ;4 ;3
	    invoke TEXTOUTx, hdc, ebx,ecx, eax,3
	  lea eax,sz_exec
	  mov ebx,(OBJECT PTR [esi]).xtopleft
	  add ebx,11 ;4 ;3
	  mov ecx,(OBJECT PTR [esi]).ytopleft
	  add ecx,16 ;14 ;4 ;3
	  invoke TEXTOUTx, hdc, ebx,ecx, eax,7
	  invoke SelectObject, hdc,holdfont


;    mov  esi,pobject


;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 invoke CreateEllipticRgn, (OBJECT PTR [esi]).xtopleft,\
			(OBJECT PTR [esi]).ytopleft,\
                     xright,ybottom     ;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...
	mov esi,pobject
	mov eax,(OBJECT PTR [esi]).xtopleft	    ;display text in node
	add eax,50 ;34 ;2
	  xor ebx,ebx
	  mov bl,(OBJECT PTR [esi]).nrings
	  dec bl
	  shl ebx,1	;multiply by 8, ring width
	  shl ebx,1
	  shl ebx,1
	add eax,ebx	;auto-move label to outside of node.
        mov ebx,(OBJECT PTR [esi]).ytopleft           ;/
        mov ecx,(OBJECT PTR [esi]).height             ;/
	sar ecx,1				   ;/
      add ebx,ecx                                   ;/
	sub ebx,8 ;7  12-1-00
;offset text, from OBJECT.x/ylabeloffset ....
	mov ecx,eax
	mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	cwde		;sign-extends ax -->eax.
	add ecx,eax	;new x-coord.
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov eax,ecx	;restore ax=x-coord

  xor ecx,ecx
  mov cl,(OBJECT PTR [esi]).fstatus
  and cx,01100000b  ;extract bits 5/6
  .IF cl==00100000b   ;display label
	lea edx,(OBJECT PTR [esi]).sztext1
	 invoke TEXTOUTx, hdc,eax,ebx,edx,62	;/
  .ELSEIF cl==01000000b	;test bit6, display filespec.
	lea edx,(OBJECT PTR [esi]).sztext2
	 invoke TEXTOUTx, hdc,eax,ebx,edx,125	;/
  .ENDIF

;now draw a line from node to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if node locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE
	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of node.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
	  ;as these coords outside node, snap_tonode() will return
	  ;xend/yend snapped to outermost ring. however for non-concentric
	  ;rings want to snap to ring 1...
	  mov edi,plock
	  mov ax,(OBJECT PTR [edi]).nexttype
	  .IF ax==0 ;node.
	    mov eax,(OBJECT PTR [edi]).xdeltacentre
	    .IF eax==0	;no x-offset of rings.
	      mov eax,(OBJECT PTR [edi]).ydeltacentre
	      .IF eax==0
		;rings are concentric...
	      .ELSE
jjt:		;rings non-concentric...
		mov g_nsnapring,1
		;...global variable, used by snap_tonode(), forces
		;snap to that ring. (default is g_nsnapring=0).
	      .ENDIF
	    .ELSE
	      jmp jjt
	    .ENDIF
	  .ENDIF
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.
      ;now draw line...
	  ;aah, except also want line at "this end" to be on boundary...
		  mov eax,xend
		  mov xend1,eax
		  mov eax,yend
		  mov yend1,eax
		  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	invoke snapPTR PTR [ebx+ptrs+psnap], esi,ADDR xend1,ADDR yend1
      ;NOW can draw line...
      invoke MoveToEx, hdc, xend1,yend1,0
	;however, if line very long, would like a grey line...
	mov eax,xend1
	sub eax,xend
	.IF SDWORD PTR eax<0
	  neg eax
	.ENDIF
	.IF eax>300
	  jmp SHORT dg1
	.ELSE
	  mov eax,yend1
	  sub eax,yend
	  .IF SDWORD PTR eax<0
	    neg eax
	  .ENDIF
	  .IF eax>300
dg1:	    .IF g_fredrawdiag==WIPEOUTobjs
	      jmp dg2	    ;need to wipe it out.
	    .ELSE
	      invoke SelectObject, hdc,g_hpengrey
	      mov hpensaved,eax
	      invoke LineTo, hdc, xend,yend
	      invoke SelectObject, hdc,hpensaved
	    .ENDIF
	  .ELSE
dg2:	    invoke LineTo, hdc, xend,yend
	  .ENDIF
	.ENDIF
    .ENDIF


;	    ;for some reason, when drag a node, xmid/ymid drifts off.
;	    ;don't know why, but hack is to keep it correct here...
;	    mov eax,(OBJECT PTR [esi]).wwidth
;	    shr eax,1
;	    add eax,(OBJECT PTR [esi]).xtopleft
;	    mov (OBJECT PTR [esi]).xmid,eax
;	    mov eax,(OBJECT PTR [esi]).height
;	    shr eax,1
;	    add eax,(OBJECT PTR [esi]).ytopleft
;	    mov (OBJECT PTR [esi]).ymid,eax



    .IF state==4
    .ELSEIF state==5
    .ELSE
      ;must always use standard font size...
      invoke SelectObject, hdc, g_hfontx1x  ;g_hfontx1	12-1-00
      mov holdfont,eax
      mov esi,pobject
;121000 ... exec-icon doesn't need this...
;;if node is a function, put a message inside...
;;(we already have a thick border for elipse to show function)
;      mov al,(OBJECT PTR [esi]).nfunctype
;      .IF al==1	   ;normal function
;      .ELSEIF al==2 ;isr
;	lea eax,szisr
;	jmp SHORT ap1
;      .ELSEIF al==3 ;library func.
;	lea eax,szapi
;ap1:	mov ebx,(OBJECT PTR [esi]).xmid
;	sub ebx,10
;	mov ecx,(OBJECT PTR [esi]).ymid
;	sub ecx,1 ;7 ;6	12-1-00 15-1-00
;	invoke TEXTOUTx, hdc, ebx,ecx, eax,3
;      .ENDIF

;121000 ... ditto...
;;if node is public or external...
;      mov al,(OBJECT PTR [esi]).fstatus2
;      and al,0110b	;extract bits2/1.
;      .IF al==0100b	;public
;	lea eax,szpublic
;	jmp SHORT xap1
;      .ELSEIF al==0110b ;external
;	lea eax,szextern2
;xap1:	mov ebx,(OBJECT PTR [esi]).xmid
;	sub ebx,14
;	mov ecx,(OBJECT PTR [esi]).ymid
;	sub ecx,11
;	invoke TEXTOUTx, hdc, ebx,ecx, eax,6
;      .ENDIF

      invoke SelectObject, hdc,holdfont

;121000 ... exec-icon doesn't need this...
;      ;if node is a child, draw inherited blobs...
;      mov eax,(OBJECT PTR [esi]).rplock1
;      .IF eax==0	 ;free node (or master)
;      .ELSE
;	;but not if its a datatype-node (attached to a pointer resource)...
;	mov al,(OBJECT PTR [esi]).fstatus2
;	and al,01000b	;bit3 =1 datatype-node.
;	.IF al==1000b
;	.ELSE
;	  invoke drawblobs, hdc,esi
;	.ENDIF
;      .ENDIF

    .ENDIF

;    ;for color-coded rings, need this. redundent for mono...
;    invoke SelectObject, hdc,hpendefault ;when entered this func.


    ret
paint_exec ENDP
;--------------------------------------------------------------------------
.DATA
szinc  BYTE "include",0
sz_ext	BYTE "ext",0
sz_file BYTE "file",0
.CODE
paint_info PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL ringwidth:DWORD
	LOCAL ringstmp:BYTE
	LOCAL xright:DWORD
	LOCAL ybottom:DWORD
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL xend1:SDWORD, yend1:SDWORD
	LOCAL state:BYTE
	LOCAL holdfont:DWORD
	LOCAL hpensaved:DWORD, hpendefault:DWORD, hpenold2:DWORD
	LOCAL ncolorindex:BYTE
	LOCAL hbrusholdcolor:DWORD,hbrushnewcolor:DWORD
; "paint_info"
;131000 for text-file-icon, via "pinfo" row in method table
; -- based on paint_exec() code.
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF


      mov esi,pobject

	mov eax,(OBJECT PTR [esi]).wwidth
      add eax,(OBJECT PTR [esi]).xtopleft
	mov xright,eax
      mov ebx,(OBJECT PTR [esi]).height
      add ebx,(OBJECT PTR [esi]).ytopleft
	mov ybottom,ebx

;draw ring, with color-fill...
	    .IF g_fredrawdiag==WIPEOUTobjs
	      ;xpaint_wipeout has already activate white brush.
	      mov eax,xright
	      mov ebx,ybottom
	      mov ecx,(OBJECT PTR [esi]).xtopleft
	      mov edx,(OBJECT PTR [esi]).ytopleft
	      invoke Ellipse, hdc, ecx,edx, eax,ebx	 ;
	    .ELSE
		      mov eax,(OBJECT PTR [esi]).ncolour1
		      invoke CreateSolidBrush, eax
		      mov hbrushnewcolor,eax
		      invoke SelectObject, hdc,hbrushnewcolor
		      mov hbrusholdcolor,eax
	      mov eax,xright
	      mov ebx,ybottom
	      mov ecx,(OBJECT PTR [esi]).xtopleft
	      mov edx,(OBJECT PTR [esi]).ytopleft
	      invoke Ellipse, hdc, ecx,edx, eax,ebx	 ;
		      invoke SelectObject, hdc, hbrusholdcolor
		      invoke DeleteObject, hbrushnewcolor
	    .ENDIF

;131000
;text-file-icon now totally separate from a node, but still uses
;this paint func. the brush has already been selected for color-fill
;so above circle has drawn a solid circle, now superimpose an "T"...
    mov al,(OBJECT PTR [esi]).fconfig
    and al,011000b
    .IF al==001000b	;bits4/3=0/1 dblclk to open custom filename.
      mov eax,(OBJECT PTR [esi]).rplock1
      .IF eax==0	;freestanding text-file icon.

	invoke SelectObject, hdc, g_hpenwhite5 ;wide white pen.
	mov hpenold2,eax
	;white top bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,15
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,15
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).ytopleft
	add eax,15
	mov ebx,xright
	sub ebx,15
	invoke LineTo, hdc,ebx,eax
	;white vert bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,17
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,34 ;40 ;42 ;47
	invoke LineTo, hdc,eax,ebx
	invoke SelectObject, hdc, hpenold2
	;top bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,15
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,15
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).ytopleft
	add eax,15
	mov ebx,xright
	sub ebx,15
	invoke LineTo, hdc,ebx,eax
	;vert bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,24 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,16 ;17
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,24 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,34 ;40 ;42 ;47
	invoke LineTo, hdc,eax,ebx
	  ;now "ext file" text...
	  ;must always use standard font size...
	  invoke SelectObject, hdc, g_hfontx1x	;g_hfontx1
	  mov holdfont,eax
	  mov esi,pobject
	  lea eax,sz_ext
	  mov ebx,(OBJECT PTR [esi]).xmid
	  ;sub ebx,15 ;10
	  add ebx,3
	  mov ecx,(OBJECT PTR [esi]).ymid
	  sub ecx,2
	  ;add ecx,4 ;3
	  invoke TEXTOUTx, hdc, ebx,ecx, eax,3
	    lea eax,sz_file
	    mov ebx,(OBJECT PTR [esi]).xmid
	    sub ebx,11 ;10
	    mov ecx,(OBJECT PTR [esi]).ymid
	    ;sub ecx,1
	    add ecx,8 ;3
	    invoke TEXTOUTx, hdc, ebx,ecx, eax,4 ;3
	  invoke SelectObject, hdc,holdfont
      .ELSE
	;icon is a child...
	invoke SelectObject, hdc, g_hpenwhite5 ;wide white pen.
	mov hpenold2,eax
	;white top bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,15
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,15
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).ytopleft
	add eax,15
	mov ebx,xright
	sub ebx,15
	invoke LineTo, hdc,ebx,eax
	;2nd horiz bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,15
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,25 ;15
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).ytopleft
	add eax,25 ;15
	mov ebx,xright
	sub ebx,15
	invoke LineTo, hdc,ebx,eax
	;white vert bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,20 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,12 ;13 ;15 ;17
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,20 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,30 ;40 ;42 ;47
	invoke LineTo, hdc,eax,ebx
	;2nd white vert bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,30 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,12 ;13 ;15 ;17
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,30 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,30 ;40 ;42 ;47
	invoke LineTo, hdc,eax,ebx
	invoke SelectObject, hdc, hpenold2

	;top bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,15
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,15
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).ytopleft
	add eax,15
	mov ebx,xright
	sub ebx,15
	invoke LineTo, hdc,ebx,eax
	;2nd horiz bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,15
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,25 ;15
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).ytopleft
	add eax,25 ;15
	mov ebx,xright
	sub ebx,15
	invoke LineTo, hdc,ebx,eax
	;vert bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,19 ;20 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,12 ;13 ;15 ;17
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,19 ;20 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,30 ;40 ;42 ;47
	invoke LineTo, hdc,eax,ebx
	;2nd vert bar...
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,29 ;30 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,12 ;13 ;15 ;17
	invoke MoveToEx, hdc,eax,ebx,0
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,29 ;30 ;25 ;35
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,30 ;40 ;42 ;47
	invoke LineTo, hdc,eax,ebx
	  ;now "inc" text...
	  ;must always use standard font size...
	  invoke SelectObject, hdc, g_hfontx1x	;g_hfontx1
	  mov holdfont,eax
	  mov esi,pobject
	  lea eax,szinc
	  mov ebx,(OBJECT PTR [esi]).xmid
	  sub ebx,15 ;10
	  mov ecx,(OBJECT PTR [esi]).ymid
	  ;sub ecx,1
	  add ecx,4 ;3
	  invoke TEXTOUTx, hdc, ebx,ecx, eax,7 ;3
	  invoke SelectObject, hdc,holdfont
      .ENDIF
    .ENDIF



;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 invoke CreateEllipticRgn, (OBJECT PTR [esi]).xtopleft,\
			(OBJECT PTR [esi]).ytopleft,\
                     xright,ybottom     ;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...
	mov esi,pobject
	mov eax,(OBJECT PTR [esi]).xtopleft	    ;display text in node
	add eax,50 ;34 ;2
	  xor ebx,ebx
	  mov bl,(OBJECT PTR [esi]).nrings
	  dec bl
	  shl ebx,1	;multiply by 8, ring width
	  shl ebx,1
	  shl ebx,1
	add eax,ebx	;auto-move label to outside of node.
        mov ebx,(OBJECT PTR [esi]).ytopleft           ;/
        mov ecx,(OBJECT PTR [esi]).height             ;/
	sar ecx,1				   ;/
      add ebx,ecx                                   ;/
	sub ebx,8 ;7  12-1-00
;offset text, from OBJECT.x/ylabeloffset ....
	mov ecx,eax
	mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	cwde		;sign-extends ax -->eax.
	add ecx,eax	;new x-coord.
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov eax,ecx	;restore ax=x-coord

  xor ecx,ecx
  mov cl,(OBJECT PTR [esi]).fstatus
  and cx,01100000b  ;extract bits 5/6
  .IF cl==00100000b   ;display label
	lea edx,(OBJECT PTR [esi]).sztext1
	 invoke TEXTOUTx, hdc,eax,ebx,edx,62	;/
  .ELSEIF cl==01000000b	;test bit6, display filespec.
	lea edx,(OBJECT PTR [esi]).sztext2
	 invoke TEXTOUTx, hdc,eax,ebx,edx,125	;/
  .ENDIF

;now draw a line from node to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if node locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE
	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of node.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
	  ;as these coords outside node, snap_tonode() will return
	  ;xend/yend snapped to outermost ring. however for non-concentric
	  ;rings want to snap to ring 1...
	  mov edi,plock
	  mov ax,(OBJECT PTR [edi]).nexttype
	  .IF ax==0 ;node.
	    mov eax,(OBJECT PTR [edi]).xdeltacentre
	    .IF eax==0	;no x-offset of rings.
	      mov eax,(OBJECT PTR [edi]).ydeltacentre
	      .IF eax==0
		;rings are concentric...
	      .ELSE
jjt:		;rings non-concentric...
		mov g_nsnapring,1
		;...global variable, used by snap_tonode(), forces
		;snap to that ring. (default is g_nsnapring=0).
	      .ENDIF
	    .ELSE
	      jmp jjt
	    .ENDIF
	  .ENDIF
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.
      ;now draw line...
	  ;aah, except also want line at "this end" to be on boundary...
		  mov eax,xend
		  mov xend1,eax
		  mov eax,yend
		  mov yend1,eax
		  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	invoke snapPTR PTR [ebx+ptrs+psnap], esi,ADDR xend1,ADDR yend1
      ;NOW can draw line...
      invoke MoveToEx, hdc, xend1,yend1,0
	;however, if line very long, would like a grey line...
	mov eax,xend1
	sub eax,xend
	.IF SDWORD PTR eax<0
	  neg eax
	.ENDIF
	.IF eax>300
	  jmp SHORT dg1
	.ELSE
	  mov eax,yend1
	  sub eax,yend
	  .IF SDWORD PTR eax<0
	    neg eax
	  .ENDIF
	  .IF eax>300
dg1:	    .IF g_fredrawdiag==WIPEOUTobjs
	      jmp dg2	    ;need to wipe it out.
	    .ELSE
	      invoke SelectObject, hdc,g_hpengrey
	      mov hpensaved,eax
	      invoke LineTo, hdc, xend,yend
	      invoke SelectObject, hdc,hpensaved
	    .ENDIF
	  .ELSE
dg2:	    invoke LineTo, hdc, xend,yend
	  .ENDIF
	.ENDIF
    .ENDIF



    .IF state==4
    .ELSEIF state==5
    .ELSE
      ;must always use standard font size...
      invoke SelectObject, hdc, g_hfontx1x  ;g_hfontx1	12-1-00
      mov holdfont,eax
      mov esi,pobject

      invoke SelectObject, hdc,holdfont

    .ENDIF


    ret
paint_info ENDP
;--------------------------------------------------------------------------
.DATA
sz_goo BYTE "GOO",0
sz_make BYTE "MAKE",0
.CODE
paint_make PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL ringwidth:DWORD
	LOCAL ringstmp:BYTE
	LOCAL xright:DWORD
	LOCAL ybottom:DWORD
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL xend1:SDWORD, yend1:SDWORD
	LOCAL state:BYTE
	LOCAL holdfont:DWORD
	LOCAL hpensaved:DWORD, hpendefault:DWORD, hpenold2:DWORD
	LOCAL ncolorindex:BYTE
	LOCAL hbrusholdcolor:DWORD,hbrushnewcolor:DWORD
; "paint_make"
;171000 for make-icon, via "pmake" row in method table
; -- based on paint_info() code.
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF


      mov esi,pobject

	mov eax,(OBJECT PTR [esi]).wwidth
      add eax,(OBJECT PTR [esi]).xtopleft
	mov xright,eax
      mov ebx,(OBJECT PTR [esi]).height
      add ebx,(OBJECT PTR [esi]).ytopleft
	mov ybottom,ebx

;draw ring, with color-fill...
	    .IF g_fredrawdiag==WIPEOUTobjs
	      ;xpaint_wipeout has already activate white brush.
	      mov eax,xright
	      mov ebx,ybottom
	      mov ecx,(OBJECT PTR [esi]).xtopleft
	      mov edx,(OBJECT PTR [esi]).ytopleft
	      invoke Ellipse, hdc, ecx,edx, eax,ebx	 ;
	    .ELSE
		      mov eax,(OBJECT PTR [esi]).ncolour1
		      invoke CreateSolidBrush, eax
		      mov hbrushnewcolor,eax
		      invoke SelectObject, hdc,hbrushnewcolor
		      mov hbrusholdcolor,eax
	      mov eax,xright
	      mov ebx,ybottom
	      mov ecx,(OBJECT PTR [esi]).xtopleft
	      mov edx,(OBJECT PTR [esi]).ytopleft
	      invoke Ellipse, hdc, ecx,edx, eax,ebx	 ;
		      invoke SelectObject, hdc, hbrusholdcolor
		      invoke DeleteObject, hbrushnewcolor
	    .ENDIF

;the brush has already been selected for color-fill
;so above circle has drawn a solid circle, now superimpose...
	invoke SelectObject, hdc, g_hpenwhite5 ;wide white pen.
	mov hpenold2,eax
	mov eax,(OBJECT PTR [esi]).xtopleft
	add eax,14 ;10
	mov ebx,(OBJECT PTR [esi]).ytopleft
	add ebx,14 ;10
	mov ecx,xright
	sub ecx,14 ;10
	mov edx,ybottom
	sub edx,14 ;10
	invoke Ellipse, hdc,eax,ebx,ecx,edx
	invoke SelectObject, hdc, hpenold2
	  ;now "MAKE" text...
	  ;must always use standard font size...
	  invoke SelectObject, hdc, g_hfontx1x	;g_hfontx1
	  mov holdfont,eax
	  mov esi,pobject
	    lea eax,sz_goo
	    mov ebx,(OBJECT PTR [esi]).xtopleft
	    add ebx,11 ;12 ;14 ;4 ;3
	    mov ecx,(OBJECT PTR [esi]).ytopleft
	    add ecx,4 ;2 ;4 ;3
	    invoke TEXTOUTx, hdc, ebx,ecx, eax,3
	  lea eax,sz_make
	  mov ebx,(OBJECT PTR [esi]).xtopleft
	  add ebx,6 ;4 ;3
	  mov ecx,(OBJECT PTR [esi]).ytopleft
	  add ecx,16 ;14 ;4 ;3
	  invoke TEXTOUTx, hdc, ebx,ecx, eax,4
	  invoke SelectObject, hdc,holdfont


;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 invoke CreateEllipticRgn, (OBJECT PTR [esi]).xtopleft,\
			(OBJECT PTR [esi]).ytopleft,\
                     xright,ybottom     ;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...
	mov esi,pobject
	mov eax,(OBJECT PTR [esi]).xtopleft	    ;display text in node
	add eax,50 ;34 ;2
	  xor ebx,ebx
	  mov bl,(OBJECT PTR [esi]).nrings
	  dec bl
	  shl ebx,1	;multiply by 8, ring width
	  shl ebx,1
	  shl ebx,1
	add eax,ebx	;auto-move label to outside of node.
        mov ebx,(OBJECT PTR [esi]).ytopleft           ;/
        mov ecx,(OBJECT PTR [esi]).height             ;/
	sar ecx,1				   ;/
      add ebx,ecx                                   ;/
	sub ebx,8 ;7  12-1-00
;offset text, from OBJECT.x/ylabeloffset ....
	mov ecx,eax
	mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	cwde		;sign-extends ax -->eax.
	add ecx,eax	;new x-coord.
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov eax,ecx	;restore ax=x-coord

  xor ecx,ecx
  mov cl,(OBJECT PTR [esi]).fstatus
  and cx,01100000b  ;extract bits 5/6
  .IF cl==00100000b   ;display label
	lea edx,(OBJECT PTR [esi]).sztext1
	 invoke TEXTOUTx, hdc,eax,ebx,edx,62	;/
  .ELSEIF cl==01000000b	;test bit6, display filespec.
	lea edx,(OBJECT PTR [esi]).sztext2
	 invoke TEXTOUTx, hdc,eax,ebx,edx,125	;/
  .ENDIF

;now draw a line from node to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if node locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE
	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of node.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
	  ;as these coords outside node, snap_tonode() will return
	  ;xend/yend snapped to outermost ring. however for non-concentric
	  ;rings want to snap to ring 1...
	  mov edi,plock
	  mov ax,(OBJECT PTR [edi]).nexttype
	  .IF ax==0 ;node.
	    mov eax,(OBJECT PTR [edi]).xdeltacentre
	    .IF eax==0	;no x-offset of rings.
	      mov eax,(OBJECT PTR [edi]).ydeltacentre
	      .IF eax==0
		;rings are concentric...
	      .ELSE
jjt:		;rings non-concentric...
		mov g_nsnapring,1
		;...global variable, used by snap_tonode(), forces
		;snap to that ring. (default is g_nsnapring=0).
	      .ENDIF
	    .ELSE
	      jmp jjt
	    .ENDIF
	  .ENDIF
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.
      ;now draw line...
	  ;aah, except also want line at "this end" to be on boundary...
		  mov eax,xend
		  mov xend1,eax
		  mov eax,yend
		  mov yend1,eax
		  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	invoke snapPTR PTR [ebx+ptrs+psnap], esi,ADDR xend1,ADDR yend1
      ;NOW can draw line...
      invoke MoveToEx, hdc, xend1,yend1,0
	;however, if line very long, would like a grey line...
	mov eax,xend1
	sub eax,xend
	.IF SDWORD PTR eax<0
	  neg eax
	.ENDIF
	.IF eax>300
	  jmp SHORT dg1
	.ELSE
	  mov eax,yend1
	  sub eax,yend
	  .IF SDWORD PTR eax<0
	    neg eax
	  .ENDIF
	  .IF eax>300
dg1:	    .IF g_fredrawdiag==WIPEOUTobjs
	      jmp dg2	    ;need to wipe it out.
	    .ELSE
	      invoke SelectObject, hdc,g_hpengrey
	      mov hpensaved,eax
	      invoke LineTo, hdc, xend,yend
	      invoke SelectObject, hdc,hpensaved
	    .ENDIF
	  .ELSE
dg2:	    invoke LineTo, hdc, xend,yend
	  .ENDIF
	.ENDIF
    .ENDIF



    .IF state==4
    .ELSEIF state==5
    .ELSE
      ;must always use standard font size...
      invoke SelectObject, hdc, g_hfontx1x  ;g_hfontx1	12-1-00
      mov holdfont,eax
      mov esi,pobject

      invoke SelectObject, hdc,holdfont

    .ENDIF


    ret
paint_make ENDP
;--------------------------------------------------------------------------
TEXTOUTx  PROC STDCALL USES eax ebx ecx edx esi edi, hdc:DWORD,tx:DWORD,\
				     ty:DWORD,lpt:DWORD,tn:DWORD
  LOCAL nactual:DWORD
;this is an envelope for TEXTOUT, to remove trailing 0s.
;entered with hdc=displaycontext,tx/ty=coords, lpt=farpointer to text
;tn=max. number chars to display
;modified, displays chars until first 0.
	mov  nactual,0
	mov  edi,lpt
txtry:
	cmp  [edi],BYTE PTR 0
	je   txdone
	mov  eax,tn		;max chars to display.
	inc  edi
	inc  nactual
	cmp  eax,nactual
	jg   txtry
txdone:
 	cmp  nactual,0
	je   txpass
	mov  edi,lpt
	invoke TextOut, hdc,tx,ty,edi,nactual
txpass:
      ret
TEXTOUTx  ENDP
;--------------------------------------------------------------------------
xpaint_extras PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD
	LOCAL htmpwin:DWORD
	LOCAL hfilefont:DWORD
	LOCAL holdfilefont:DWORD
	LOCAL holdblackpen:DWORD
;called by wmpaint().  "xpaint_extras"

;display current data file...
  invoke GetWindowDC, g_hwnd
  mov  htmpwin,eax
;select font...
  mov  eax,CURRENT2POINTSIZE
  neg  eax
;  invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface2
 ;times new roman...
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface5
  mov  hfilefont,eax
;assign font to display context...
  invoke SelectObject, htmpwin,hfilefont
  mov  holdfilefont,eax

  invoke SetBkMode, htmpwin,TRANSPARENT	;leave background showing.

;;  invoke Rectangle, htmpwin,188,24,470,39
;;  invoke TEXTOUTx, htmpwin,190,25,ADDR szfile,70 ;display szfile
;  invoke Rectangle, htmpwin,178,24,490,40
  .IF szfile=="*"
  .ELSE
    invoke TEXTOUTx, htmpwin,180,24,ADDR szfile,254 ;display szfile
  .ENDIF

;***NOTE*** REMOVED
;i've implemented another way of getting around -- user dblclks when
;zoomed in or out, to go to that place.(see xdblclk() > bigmove())
;while i've got the window-dc, display scrolling arrows...
;  invoke	drawscrollbox, htmpwin

  invoke SelectObject,htmpwin,holdfilefont
  invoke DeleteObject,hfilefont 	 ;***NOTE***move after selectobj.
  invoke ReleaseDC, g_hwnd,htmpwin

;display zero x and y axis...
;note win95 still has only 16-bit x/y coord system...
;note this allows +/- 32,0000, actually.
;  invoke CreatePen, PS_SOLID,1,0FFh	;red pen.
;  mov	hredpen,eax
;  invoke SelectObject, hdc,hredpen
;  mov	holdblackpen,eax
    invoke SelectObject, hdc,g_hpengrey ;grey 1pixel pen.
    mov holdblackpen,eax

    invoke MoveToEx, hdc, -15000,0, 0
    invoke LineTo, hdc,	15000,0
    invoke MoveToEx, hdc, 0,-15000, 0
    invoke LineTo, hdc,	0,15000

    ;also put box around boundary...
    invoke LineTo, hdc,	15000,15000
    invoke LineTo, hdc,	15000,-15000
    invoke LineTo, hdc,	-15000,-15000
    invoke LineTo, hdc,	-15000,15000
    invoke LineTo, hdc,	0,15000

  invoke SelectObject, hdc,holdblackpen
;  invoke DeleteObject, hredpen

  ret
xpaint_extras ENDP
;--------------------------------------------------------------------------
.DATA
polypts LABEL POINT
    DWORD  25,42 ;490,0
    DWORD  45,62 ;510,20
    DWORD  25,82  ;490,40
    DWORD  5, 62  ;470,20
polypts2 LABEL POINT
    DWORD  15,52 ;480,10
    DWORD  35,52 ;500,10
    DWORD  35,72 ;500,30
    DWORD  15,72 ;480,30
polypts3 LABEL POINT
    DWORD  25,52 ;490,10
    DWORD  35,62 ;500,20
    DWORD  25,72 ;490,30
    DWORD  15,62 ;480,20
polypts4 LABEL POINT
    DWORD  20,57 ;485,15
    DWORD  30,57 ;495,15
    DWORD  30,67 ;495,25
    DWORD  20,67 ;485,25

.CODE
drawscrollbox PROC STDCALL USES ebx ecx edx esi edi, hnonclient:DWORD
	LOCAL hbnew:DWORD, hbold:DWORD
;called by xpaint_extras().
;hnonclient is a DC for the entire window, not just client area.

  mov  esi,hnonclient

;colour for filling polygons.... (previously was white)
  invoke CreateSolidBrush, 0808080h ;grey0000FFh ;bright red	;ret-->hbrush
  mov hbnew,eax
  invoke SelectObject, esi,hbnew
  mov hbold,eax
  invoke Polygon, esi,ADDR polypts,4
  invoke SelectObject, esi, hbold
  invoke DeleteObject, hbnew

  invoke Polygon, esi,ADDR polypts2,4     ;white fill.

  invoke CreateSolidBrush, 0 ;black0000FFh ;bright red    ;inside polygon.
  mov hbnew,eax
  invoke SelectObject, esi,hbnew
  mov hbold,eax
  invoke Polygon, esi,ADDR polypts3,4
  invoke SelectObject, esi, hbold
  invoke DeleteObject, hbnew

  invoke Polygon, esi,ADDR polypts4,4	 ;white fill.

  ret
drawscrollbox ENDP
;--------------------------------------------------------------------------
erasediagram PROC STDCALL USES ebx ecx edx esi edi
	LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
;via File/Erase-diagram --> IDM_ERASEDIA.

;scan through all objects, clearing .fstatus member...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0	;already empty
	    jmp nextobjy
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	    mov (OBJECT PTR [esi]).fstatus,0	;invalidate it.
	  .ENDIF
	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
      loop nextobj
nextobjy:

    mov (TERSEDATA PTR [edi]).numobjects,0 ;no objects in database.

;so, can now decrease mem block...
  invoke LocalReAlloc, pTERSEDATA,(SIZEOF TERSEDATA)+128,LMEM_MOVEABLE
  .IF eax==0
     ;fail...
     mov g_nfilesize,0
     lea eax,szerralloc2b
     ;error message and exit GOOSEE...
     invoke MessageBox, g_hwnd, eax,\
        		 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
     invoke DestroyWindow, g_hwnd
     ret
  .ELSE
     ;all absolute pointers are invalid...
     mov poldmovingobject,0
     mov g_pmovingobject,0
     mov g_pselectedobject,0
     mov g_pselectedobjectnew,0
     mov g_phighlightedobject,0
     mov g_perrorobject,0
     mov wipeoutsindex,0
     mov updatesindex,0
     mov highlightedindex,0
     mov g_nstate,0
     mov g_nfilesize,(SIZEOF TERSEDATA)
     mov pTERSEDATA,eax    ;new pointer.
     mov highlightedindexnewlist,0
  .ENDIF

  invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
  mov g_fredrawdiag,ENTIRE		;redraw entire window.


  ret
erasediagram ENDP
;--------------------------------------------------------------------------
.DATA
fclipped BYTE 0
fdelay	 BYTE 0     ;delay scrolling effect when mouse at boundary.
nGAP EQU 7 ;5	;how close to edge of window before scrolling.
SCDELAY EQU 0	;2 = 1 second delay

.CODE
scrollingbymouse PROC STDCALL USES ebx ecx edx esi edi, wparam:DWORD,lparam:DWORD
    LOCAL mousex:WORD, mousey:WORD  ;unsigned!
    LOCAL eaxsave:DWORD,ebxsave:DWORD,ecxsave:DWORD
;called by wmmousemove().  "scrollingbymouse"
;when mouse approaching boundary, start scrolling window.
;lparam is mouse client coords, origin relative to top/left client area.

;i use clientrectold here, as it is top,left =0,0 bot,right =height,width
;of client, and lparam is mouse coords in client-coords, i.e. mouse
;0,0 coord is top,left of client area.
;note that clientrect is the actual region of the diagram being displayed,
;but it must have the same height,width as clientrectold.
;therefore, when xtimer() does the actual scrolling (not done in this func)
;it scrolls clientrect.

;note that wparam of WM_MOUSEMOVE is non-zero if shift/ctrl or any
;mouse button pressed.
;i think i'll scroll if any of these pressed...
    .IF wparam==0
      jmp sc6	    ;make sure everything is clear then ret.
    .ENDIF

	  mov ax,WORD PTR lparam+2
	  mov mousey,ax
          cwde
          mov ebx,eax
	  mov ax,WORD PTR lparam
	  mov mousex,ax
	  cwde				       ;actually...
	  mov ecx,clientrectold.rc_left        ;=0 as original unshifted.
	  mov edx,clientrectold.rc_right       ;=width " (client coords)
	  mov edi,clientrectold.rc_top	       ;=0  "
	  mov esi,clientrectold.rc_bottom      ;=height "

;i've got a problem with scrolling happening when mouse is just outside
;the window...
    .IF mousex>dx   ;unsigned, as these values always +ve.
sc6:  mov g_naccelx,0
      mov g_naccely,0
      mov fdelay,0
      jmp sc4	    ;get out, but free cursor just in case it's clipped.
    .ENDIF
    .IF mousey>si
      jmp sc6
    .ENDIF

	sub ecx,eax		;how close to left side.
	.IF SDWORD PTR ecx<0
	  neg  ecx		;convert to +ve.
	.ENDIF
	sub edx,eax
	.IF SDWORD PTR edx<0
	  neg  edx
	.ENDIF
	sub edi,ebx		;how close to top.
	.IF SDWORD PTR	edi<0
	  neg  edi		;convert to +ve.
	.ENDIF
	sub esi,ebx
	.IF SDWORD PTR	esi<0
	  neg  esi
	.ENDIF

  .IF eax==ebx            ;invalid condition, occurs if over top.
    mov g_naccelx,0
    mov g_naccely,0
    jmp done1
  .ENDIF

;firstly, x direction...
  .IF ecx<nGAP		 ;mouse on left side?
      .IF g_naccelx==0	;i only want xtimer to incr it beyond 2.
	sub g_naccelx,2		;(accel will be a -ve value)
      .ENDIF
    jmp done1
  .ELSEIF edx<nGAP     ;mouse on right side?
      .IF g_naccelx==0
	add g_naccelx,2	   ;(accel will be a +ve value)
      .ENDIF
    jmp done1
  .ELSE
    mov g_naccelx,0
  .ENDIF

;now for y direction...
  .IF edi<nGAP	     ;mouse on top side?
      .IF g_naccely==0
	sub g_naccely,2		;(accel will be -ve value)
      .ENDIF
      jmp done1
  .ELSEIF esi<nGAP   ;mouse on bottom side?
      .IF g_naccely==0
	add g_naccely,2
      .ENDIF
      jmp done1
  .ELSE         ;fail
     mov g_naccely,0
  .ENDIF

done1:

;that's it. xtimer() runs every 500msec and looks at g_naccelx/g_naccely
;to scroll if they're non-zero.

;if scrolling is to occur, clip the cursor...
  .IF fclipped==0		;prevent calling ClipCursor more than once.
    .IF g_naccely != 0
      jmp sc3
    .ENDIF
    .IF g_naccelx != 0
sc3:
      .IF fdelay>=SCDELAY	;# entries to xtimer (2 = 1 sec) delay.
	invoke GetWindowRect, g_hwnd,ADDR windowrect
	add windowrect.rc_left,4 ;3 ;2	  ;limit region to inside client area.
	add windowrect.rc_top,42   ;/  (i'm clipping cursor in from edges
	sub windowrect.rc_right,4 ;3 ;2	;/ as getting resize-arrows
	sub windowrect.rc_bottom,4 ;3 ;2	;/ appearing)
	invoke ClipCursor, ADDR windowrect
	mov fclipped,1
      .ENDIF
    .ENDIF
  .ENDIF

;280900
;note, windowrect is setup in wmcreate() and i'm now updating it in
;wmsize() (everytime window is resized) so not really necessary to
;call GetWindowRect() above.


sc4:
  .IF g_naccely==0
    .IF g_naccelx==0
      .IF fclipped==1
        invoke ClipCursor, 0	;free the cursor.
	mov fclipped,0
	mov fdelay,0
      .ENDIF
    .ENDIF
  .ENDIF

   ret
scrollingbymouse ENDP
;--------------------------------------------------------------------------
.DATA
	 DB 0 ;for testing, i insert a sign before szasciitbl.
szasciitbl DB 14 DUP(0)	;used by bin2dec.
szblanks DB 24 DUP(" ")
	 DB 0

.CODE
displaymouse PROC STDCALL USES ebx ecx edx esi edi, nmx:DWORD, nmy:DWORD
	LOCAL htmpwinx:DWORD
	LOCAL htextfont:DWORD
	LOCAL holdtextfont:DWORD
	LOCAL fneg:BYTE
;entered with corrected mouse coords.  "displaymouse"
;display them. called from xtimer() and wmmousemove().

	mov fneg,0
	invoke GetWindowDC, g_hwnd
	mov  htmpwinx,eax

;select font...
  mov  eax,CURRENT2POINTSIZE
  neg  eax
;  invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szface2
 ;times new roman...
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR szface5
  mov  htextfont,eax
;assign font to display context...
  invoke SelectObject, htmpwinx,htextfont
  mov  holdtextfont,eax

;  invoke SetBkMode, htmpwinx,TRANSPARENT

;i've got a problem as win95 is only 16bit coords. so, -ve coord
;will have bit15=1, but can i be sure there is sign extension?
;i'm testing just bit15 here... ***NOTE***
	mov  eax,nmx
	 mov edx,0
	   test eax,8000h	;test if -ve coord. ***NOTE***
	   jz	dim1
	   neg	ax		;make it +ve.
         cwde		;sign-extend. i think this will fill eax with 0s.
	   mov	fneg,1		;flag that it is neg.
dim1:	 invoke bin2dec 	 ;eax-->szasciitbl(convert to ascii)
	 lea edi,szasciitbl+1
	 mov [edi],WORD PTR "=X"  ;prefix with title
	   .IF fneg==1
;*	     mov  [edi+2],BYTE PTR "-"	;-ve sign.
	     mov  fneg,0
	     invoke SetTextColor, htmpwinx,00FFh ;red
	     push eax
	     invoke TextOut, htmpwinx, 508,24,ADDR szblanks,18 ;21
	     invoke TextOut, htmpwinx, 508,24,edi,9 ;8 ;paint 8 chars.no, 9.
	     pop  eax
	     invoke SetTextColor, htmpwinx,eax ;restore.
	   .ELSE
	     invoke TextOut, htmpwinx, 508,24,ADDR szblanks,18 ;21
	     invoke TextOut, htmpwinx, 508,24,edi,9 ;8
	   .ENDIF

;now do it all again for y coord...
	mov eax,nmy
	 mov edx,0
	   test ax,8000h	;test if -ve coord.
	   jz	xdim1
	   neg	ax		;make it +ve.
         cwde			;try this again, sign-extend to eax.
	   mov	fneg,1		;flag that it is neg.
xdim1:	 invoke bin2dec
	 lea edi,szasciitbl+1
	 mov [edi],WORD PTR "=Y"
	   .IF fneg==1
;*	     mov  [edi+2],BYTE PTR "-"	;-ve sign.
	     mov  fneg,0
	     invoke SetTextColor, htmpwinx,00FFh ;red
	     push eax
	     invoke TextOut, htmpwinx, 565,24,ADDR szblanks,18 ;21
	     invoke TextOut, htmpwinx, 565,24,edi,9 ;8
	     pop  eax
	     invoke SetTextColor, htmpwinx,eax	;restore.
	   .ELSE
	     invoke TextOut, htmpwinx, 565,24,ADDR szblanks,18 ;21
	     invoke TextOut, htmpwinx,565,24,edi,9 ;8
	   .ENDIF

;***NOTE*** found must delete object AFTER selecting old one back to DC...
;(otherwise, fonts go funny)
	invoke SelectObject, htmpwinx,holdtextfont
	invoke DeleteObject, htextfont

	invoke ReleaseDC, g_hwnd,htmpwinx

  ret
displaymouse ENDP
;--------------------------------------------------------------------------
bin2dec PROC STDCALL USES ebx ecx edx edi esi
	LOCAL dummy:WORD
;binary to ascii-bcd conversion.  requires binary number in eax
;returns asciiz string in szasciitbl.
;The generated string is right-justified to asciitbl+9, with
;blanks from ascittbl to the string.

	xor edx,edx

        lea edi,szasciitbl
        mov ebx,edi
	add edi,10 
        mov BYTE PTR [edi],0
        dec edi
ssss:	mov ecx,10		
	div ecx 		;edx:eax/2 -->edx has remainder
        add dl,30h
sssss:  mov [edi],dl
        dec edi
	mov edx,0
	cmp eax,0		
        jne ssss
        mov dl," "
        cmp ebx,edi
	jbe sssss

	   .IF szasciitbl+9==" "
	     mov szasciitbl+9,0  ;we want a zero to display, not nothing.
	   .ENDIF

	ret
bin2dec ENDP
;--------------------------------------------------------------------------
ACCELMAXPOS EQU 200
ACCELMAXNEG EQU -200
xtimer PROC STDCALL USES edi esi ebx ecx edx,wmsg:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;called every 500msec. (now 250msec) "xtimer"
;if g_naccelx or g_naccely non-0 then scroll...

;record if diagram has changed...
	.IF g_nstate>3
	  mov  g_fhaschanged,1
	.ENDIF

  .IF g_naccelx != 0
    .IF fdelay<SCDELAY
      inc fdelay	;we count entries to xtimer.
      ret
    .ELSE
	mov eax,g_naccelx  ;real acceleration.
        sar eax,1       ;  divide by 2
	add g_naccelx,eax  ;  now it's 1.5 times bigger.
	  .IF SDWORD PTR g_naccelx<ACCELMAXNEG
	    mov g_naccelx,ACCELMAXNEG
	  .ELSEIF SDWORD PTR g_naccelx>ACCELMAXPOS
	    mov g_naccelx,ACCELMAXPOS
	  .ENDIF
      mov edx,g_naccelx		;this is a signed number.
      add clientrect.rc_left,edx
      add clientrect.rc_right,edx
      add g_nmousex,edx		;so mouse coords also keep track
      jmp xt1				; while mouse may be stationary.
    .ENDIF
  .ENDIF

  .IF g_naccely != 0
    .IF fdelay<SCDELAY
      inc fdelay	;we count entries to xtimer.
      ret
    .ELSE
	mov eax,g_naccely	;real acceleration.
        sar eax,1       ; / divide by 2
	add g_naccely,eax
	  .IF SDWORD PTR g_naccely<ACCELMAXNEG
	    mov g_naccely,ACCELMAXNEG
	  .ELSEIF SDWORD PTR g_naccely>ACCELMAXPOS
	    mov g_naccely,ACCELMAXPOS
	  .ENDIF
      mov ebx,g_naccely
      add clientrect.rc_top,ebx
      add clientrect.rc_bottom,ebx
      add g_nmousey,ebx
xt1:  invoke InvalidateRgn, g_hwnd,0,TRUE   ;invalidate entire window.
      mov g_fredrawdiag,ENTIRE		       ;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
      invoke  displaymouse, g_nmousex,g_nmousey	;display mouse coords.
    .ENDIF
  .ENDIF

  ret
xtimer ENDP
;--------------------------------------------------------------------------
xorigin PROC STDCALL
;from menu Control/Go to origin > IDM_ORIGIN.

	  mov  eax,clientrect.rc_right
	  sub  eax,clientrect.rc_left
	    add eax,4
	  mov  clientrect.rc_right,eax
	  mov  clientrect.rc_left,4
	  mov  eax,clientrect.rc_bottom
	  sub  eax,clientrect.rc_top
	    add eax,4
	  mov  clientrect.rc_bottom,eax
	  mov  clientrect.rc_top,4
	  invoke InvalidateRgn, g_hwnd,0,TRUE	;invalidate entire window.
	  mov g_fredrawdiag,ENTIRE		;redraw entire window.

  ret
xorigin ENDP
;--------------------------------------------------------------------------
xkeyup PROC STDCALL USES edi esi ebx ecx edx,wmsg:DWORD,wparam:DWORD,lparam:DWORD
;from WM_KEYUP
	      mov g_naccelx,0	;stops xtimer() from scrolling.
	      mov g_naccely,0	;/
	      mov fdelay,0	;/
    ret
xkeyup ENDP
;--------------------------------------------------------------------------
xkeydown PROC STDCALL USES edi esi ebx ecx edx,wmsg:DWORD,wparam:DWORD,lparam:DWORD
;from WM_KEYDOWN...

      .IF g_nstate==0
;we can use arrow keys to scroll window...
;if ctrl key is helf down, scrolling is by printer paper-size,
;else by size of window client area...
	invoke GetAsyncKeyState, VK_CONTROL
	and  ax,8000h			;bit15=1 if key down.
	.IF ax==8000h
	  .IF wparam==VK_RIGHT
	      mov  eax,clientrect.rc_left
	      add  eax,xwinext		;width of prn page, scaled down.
	      mov  clientrect.rc_left,eax
	      mov  eax,clientrect.rc_right
	      add  eax,xwinext
	      mov  clientrect.rc_right,eax
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE
	  .ELSEIF wparam==VK_LEFT
	      mov  eax,clientrect.rc_left
	      sub  eax,xwinext
	      mov  clientrect.rc_left,eax
	      mov  eax,clientrect.rc_right
	      sub  eax,xwinext
	      mov  clientrect.rc_right,eax
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE
	  .ELSEIF wparam==VK_DOWN
	      mov  eax,clientrect.rc_top
	      add  eax,ywinext		;height of prn page, scaled down.
	      mov  clientrect.rc_top,eax
	      mov  eax,clientrect.rc_bottom
	      add  eax,ywinext
	      mov  clientrect.rc_bottom,eax
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE
	  .ELSEIF wparam==VK_UP
	      mov  eax,clientrect.rc_top
	      sub  eax,ywinext
	      mov  clientrect.rc_top,eax
	      mov  eax,clientrect.rc_bottom
	      sub  eax,ywinext
	      mov  clientrect.rc_bottom,eax
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE
	  .ELSEIF wparam==VK_DELETE
	    ;delete most recently placed object...
	    mov edi,poldmovingobject
	    .IF edi==0
	    .ELSE
	      mov  ebx,(OBJECT PTR [edi]).rpmethods
	      invoke deletePTR PTR [ebx+ptrs+pdelete], edi ;delete the object.
	      mov poldmovingobject,0
	      mov g_phighlightedobject,0 ;just in case.
	      mov g_pmovingobject,0	 ;/
	      mov g_nstate,0	 ;back to normal state, just in case.
	      invoke InvalidateRgn, g_hwnd,0,TRUE	;invalidate entire window.
	      mov g_fredrawdiag,ENTIRE		;redraw entire window.
	    .ENDIF

	  .ENDIF
	.ELSE			      ;ctrl key not held down.
	  mov ebx,pTERSEDATA
	  mov al,(TERSEDATA PTR [ebx]).fgooseeprefs
	  and al,010b	    ;bit1
	  .IF al==0	    ;incremental scroll.
	    ;note, wmmousemove()-->scrolling() tests mouse on boundary
	    ;with <ctrl> held down, then does same thing.
	    ;xtimer() does the actual scrolling.
	    ;note, need to clear g_naccelx and g_naccely. for mouse,
	    ;wmlbuttonup does it. for here, use xkeyup().
	    .IF wparam==VK_RIGHT    ;scroll to right.
	      .IF g_naccelx==0
		add g_naccelx,2	   ;(accel will be a +ve value)
	      .ENDIF
	    .ELSEIF wparam==VK_LEFT ;scroll to left.
	      .IF g_naccelx==0	;i only want xtimer to incr it beyond 2.
		sub g_naccelx,2		;(accel will be a -ve value)
	      .ENDIF
	    .ELSEIF wparam==VK_DOWN
	      .IF g_naccely==0
		add g_naccely,2	   ;(accel will be a +ve value)
	      .ENDIF
	    .ELSEIF wparam==VK_UP
	      .IF g_naccely==0	;i only want xtimer to incr it beyond 2.
		sub g_naccely,2		;(accel will be a -ve value)
	      .ENDIF
;	    .ELSE
;	      mov g_naccelx,0	;stops xtimer() from scrolling.
;	      mov g_naccely,0	;/
;	      mov fdelay,0	;/
	    .ENDIF
	  .ELSE 	    ;scroll a window at a time.
	    .IF wparam==VK_RIGHT
	      mov  eax,clientrect.rc_left
	      add  eax,xclientpixels		;width of client area.
	      mov  clientrect.rc_left,eax
	      mov  eax,clientrect.rc_right
	      add  eax,xclientpixels
	      mov  clientrect.rc_right,eax
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE
	    .ELSEIF wparam==VK_LEFT
	      mov  eax,clientrect.rc_left
	      sub  eax,xclientpixels
	      mov  clientrect.rc_left,eax
	      mov  eax,clientrect.rc_right
	      sub  eax,xclientpixels
	      mov  clientrect.rc_right,eax
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE
	    .ELSEIF wparam==VK_DOWN
	      mov  eax,clientrect.rc_top
	      add  eax,yclientpixels		;height of client area.
	      mov  clientrect.rc_top,eax
	      mov  eax,clientrect.rc_bottom
	      add  eax,yclientpixels
	      mov  clientrect.rc_bottom,eax
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE
	    .ELSEIF wparam==VK_UP
	      mov  eax,clientrect.rc_top
	      sub  eax,yclientpixels
	      mov  clientrect.rc_top,eax
	      mov  eax,clientrect.rc_bottom
	      sub  eax,yclientpixels
	      mov  clientrect.rc_bottom,eax
	      invoke InvalidateRgn, g_hwnd,0,TRUE
	      mov g_fredrawdiag,ENTIRE
	    .ENDIF
	  .ENDIF
	.ENDIF


      .ELSEIF g_nstate==2		 ;object-highlighted state
	;if user presses DEL key, while an object is highlighted, it deletes.
	;if a node, any attached wires also delete...
	.IF wparam==VK_DELETE	 ;delete key?
	 .IF g_phighlightedobject==0	  ;***redundant, as cannot be in
	   nop				;***state-2 without this set.
	   mov	g_nstate,0
         .ELSE
	   mov edi,g_phighlightedobject
	    mov  ebx,(OBJECT PTR [edi]).rpmethods
  invoke deletePTR PTR [ebx+ptrs+pdelete], edi	;delete the highlighted object.
	    mov g_phighlightedobject,0
	    mov g_nstate,0		 ;back to normal state.
	    invoke InvalidateRgn, g_hwnd,0,TRUE	;invalidate entire window.
	    mov g_fredrawdiag,ENTIRE		;redraw entire window.
	 .ENDIF
	.ENDIF
      .ENDIF

  ret
xkeydown ENDP
;--------------------------------------------------------------------------
.DATA
szler1	   DB "ERROR: Cannot open diagram.  The node you have double-"
	   DB "clicked on must have a label. This is used as the label for "
	   DB "the matching node in the child diagram.",0
szcommandline DB 64+128 DUP(0) ;used by WM_LBUTTONDBLCLK, to launch editor.
szerdbc    BYTE "Double-clicking on a child-element has no effect. "
	   BYTE "You will see from the dialog-box for a node (right-click "
	   BYTE "on the node) that various double-click actions can be "
	   BYTE "selected -- however these only apply to ""free"" or "
	   BYTE "master nodes. Note that child-nodes (clones) inherit code "
	   BYTE "from the master, and have no internal code themselves.",0
szer11300  BYTE "This version of GOOSEE requires that only a library-"
	   BYTE "function node can have a child diagram. Go into the "
	   BYTE "dialog box for the node and change it.",0
szerdbs    BYTE "Double-click on a node will only work if it is a "
	   BYTE "top-level function in a subdiagram, a free-standing "
	   BYTE "node, or a library-function node. Refer to the node "
	   BYTE "dialog-box.",0
szermake1  BYTE "You need to have one or more node #s of top-level "
	   BYTE "node[s] in the ""Node# list:"" edit-box inside the "
	   BYTE "Make-icon dialog-box.",0

.CODE
xdblclk PROC STDCALL USES edi esi ebx ecx edx,wmsg:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL zoom:SBYTE
    LOCAL horizshift:DWORD, vertshift:DWORD
    LOCAL xend:DWORD, yend:DWORD
    LOCAL nring:WORD
    LOCAL pendeditor:DWORD
    LOCAL fdone:BYTE, ptop:DWORD, pfirsttop:DWORD, pmakeicon:DWORD
    LOCAL psz2:DWORD
;called via WM_LBUTTONDBLCLK	"xdblclk"

  .IF g_nstate==0
      ;my idea here is when zoomed out, if dblclk somewhere, it becomes
      ;new client origin and zoom=0...
      ;also if zoomed in, will jump to zoomed out, keeping same place...
      invoke bigmove

  .ELSEIF g_nstate==1


  .ELSEIF g_nstate==2

;wmlbuttondown() on a node causes g_nstate=1.
;this is followed by wmlbuttonup() which puts g_nstate=2.

    mov esi,g_phighlightedobject
    mov pmakeicon,esi

;if have dblclked on a comment, action, or condition, open editor...
;171000 ... dblclk on make-icon, generate code...
;(if drops past here, we have dblclk action for a node)
	  mov ax,(OBJECT PTR [esi]).nexttype
	  .IF ax==30	  ;comment
za1:		lea eax,(OBJECT PTR [esi]).sztext2
		mov prbuttonobject,esi
		;...editor originally designed to be opened by a right-
		;button click on cond/action/comment.
		invoke openexternaleditor, eax
		mov prbuttonobject,0
		mov g_fredrawdiag,ENTIRE
		invoke InvalidateRgn, g_hwnd,0,FALSE
		mov g_phighlightedobject,0	;remove highlighting
		mov g_nstate,0			;/
		xor eax,eax
		ret
	  .ELSEIF ax==32    ;condition
		jmp za1
	  .ELSEIF ax==33    ;action
		jmp za1
	  .ELSEIF ax==62    ;make-icon
	    ;make-icon has the list of node#s in object.sztext2/3.
	    ;multiple entries are comma-separated #s in .sztext2/3.
	    ;convert each ascii->binary and store in "highlighted" table
	    ;using add2highlightedlist()...
	    ;need to zero this...
	    mov g_phighlightedobject,0
	    ;...cos is getting node#[s] from "highlighted" list and
	    ;checks if this 0 first. then calls genmanycode().
	      mov szasciitbl,0
	      mov fdone,0
	      mov pfirsttop,0
	      mov highlightedindex,0 ;going to put node ptrs in highlightedlist.
	      lea edi,(OBJECT PTR [esi]).sztext2	;2/3 node#-list.
	      mov psz2,edi
pe0:	      lea ebx,szasciitbl
pe1:	      ;extract an node# to szasciitbl...
	      mov edi,psz2
	      mov al,[edi]
	      .IF al==0
		mov fdone,1
	      .ELSE
		.IF al==","	;separator.
		  inc psz2 ;edi
		.ELSE
		  mov [ebx],al
		  inc ebx
		  mov [ebx],BYTE PTR 0
		  inc psz2 ;edi	;ptr to place in .sztext2/3.
		  jmp pe1
		.ENDIF
	      .ENDIF
	    .IF szasciitbl==0
	      ;nothing in the list...
	      lea eax,szermake1
	      jmp erm1	;get out.
	    .ENDIF
	    ;now convert ascii in szasciitbl to binary...
	      invoke str2longint, ADDR szasciitbl	;--> eax.
	    ;now convert node# to pointer...
	      xor ecx,ecx
	      mov ebx,pTERSEDATA
	      mov cx,(TERSEDATA PTR [ebx]).numobjects
	      .IF SDWORD PTR eax<0
xx1:		lea	eax,sznfinderr
		jmp erm1	;get out.
	      .ELSEIF eax>=ecx
		jmp xx1
	      .ENDIF
		xor ecx,ecx
		xor edx,edx
		mov cx,(TERSEDATA PTR [ebx]).nsizeobject
		mul ecx
		lea ecx,(TERSEDATA PTR [ebx]).OBJECTS ;starting addr of OBJECTS
		add eax,ecx	;eax now has address of element.
		mov ebx,eax
		mov cl,(OBJECT PTR [ebx]).fstatus
		and cl,01
		.IF cl==0
		  ;invalid element...
		  jmp xx1
		.ENDIF
		mov cx,(OBJECT PTR [ebx]).nexttype
		.IF cx==-1
		  ;non-display element...
		  jmp xx1
		.ENDIF
		;...eax now pts to node.
		mov ptop,eax
		.IF pfirsttop==0
		  mov pfirsttop,eax ;first top-level node in list.
		  ;lock make-icon to it...
		  mov ecx,eax
		  sub ecx,pTERSEDATA	;convert to relative ptr.
		  mov ebx,pmakeicon
		  mov (OBJECT PTR [ebx]).rplock1,ecx
		.ENDIF
	    ;put it into highlight list...
	      invoke add2updatelist, ptop
	      mov ebx,ptop
	      or (OBJECT PTR [ebx]).fconfig2,10000000b ;set bit7.
	      invoke add2highlightedlist,ebx
	    ;loop back up, get any more node#s in list...
	      cmp fdone,0
	      je pe0
	    ;now go ahead and generate the code...
;	      ;i would like to paint the highlighted nodes now...
;	      ;(generatecode will clr them and repaint entire)
	      ;this flag allows display multiple highlighted when 0...
	      mov g_fclrhighlighted,0
	      mov g_nstate,0 ;back to state0.
	      mov g_phighlightedobject,0 ;cos we're in state0.
	      ;...and generatecode() needs this clr.
	      ;...only use g_phighlightedobject for a single highlighted
	      ;element.
;	      invoke InvalidateRgn, g_hwnd,0,FALSE ;inval.,not erase bkgrnd
;	      mov  g_fredrawdiag,UPDATEobjs
;	      invoke UpdateWindow, g_hwnd
	    ;code-gen same as per file/generate code-->idm_1code...
	    invoke generatecode
	    xor eax,eax
	    ret
	  .ENDIF



;double-click action on a node, wrong level...
;111000 ... if .nring1colorindex>0, then node isn't top-level, so
;don't allow double-click action. exception is library-func...
    mov ax,(OBJECT PTR [esi]).nexttype
    .IF ax==0	    ;normal node.
      ;121000 ... REDUNDANT exec-icon now nexttype=60...
      ;the "execution-icon" is exempt. it is a normal node with
      ;.fconfig/bits4/3 =1/0 (dblclk to execute a command)...
      mov al,(OBJECT PTR [esi]).fconfig
      and al,011000b
      .IF al==010000b	    ;"execution-icon"
	;and, we don't care if it's a child...
	jmp rc1     ;bypass child/clone checking.
      .ELSE
	mov al,(OBJECT PTR [esi]).nfunctype
	.IF al==0	    ;inline code, don't allow double-click if not top.
tstdbl:	  mov al,(OBJECT PTR [esi]).nring1colorindex
	  .IF al==0	;ring1=black, top-level node.
	    jmp okdbl
	  .ELSE	    ;not top-level.
	    lea eax,szerdbs
erm1:	    invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	    invoke add2wipeoutlist,esi
	    mov g_fredrawdiag,WIPEOUTobjs
	    invoke InvalidateRgn,g_hwnd,0,FALSE
	    mov	g_phighlightedobject,0	;else paint_ will use black brush.
	    mov	g_nstate,0
	    invoke UpdateWindow, g_hwnd
	    invoke add2updatelist,esi
	    mov g_fredrawdiag,UPDATEobjs
	    invoke InvalidateRgn,g_hwnd,0,FALSE
	    jmp xdb9	    ;do nothing, get out.
	  .ENDIF
	.ELSEIF al==1	;normal func, /
	  jmp tstdbl
	.ELSEIF al==2	;isr, /
	  jmp tstdbl
	.ELSE	    ;library func, etc(future).
okdbl:
	.ENDIF
      .ENDIF
    .ELSEIF ax==60  ;exec-icon
      jmp rc1	;bypass level checking(above) and child/clone checking.
    .ELSEIF ax==61  ;text-file-icon
      jmp rc1	;bypass level checking(above) and child/clone checking.
;    .ELSEIF ax==62  ;make-icon
;      jmp rc1	;bypass level checking(above) and child/clone checking.
    .ENDIF


;dblclking on a child object should have no effect...
    mov eax,(OBJECT PTR [esi]).rplock1
    .IF eax==0	    ;free, or a master.
    .ELSE
      lea eax,szerdbc
      jmp erm1
;      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
;      invoke add2wipeoutlist,esi
;      mov g_fredrawdiag,WIPEOUTobjs
;      invoke InvalidateRgn,g_hwnd,0,FALSE
;      mov  g_phighlightedobject,0  ;else paint_ will use black brush.
;      mov  g_nstate,0
;      invoke UpdateWindow, g_hwnd
;      jmp xdb9	    ;do nothing, get out.
    .ENDIF


rc1:
;find out what ring dblclked on...
    mov ax,(OBJECT PTR [esi]).nexttype
    .IF ax==0	    ;node.
rc2:  mov eax,g_nmousex
      mov xend,eax
      mov eax,g_nmousey
      mov yend,eax
      invoke snap_tonode, esi, ADDR xend,ADDR yend
	;...will return nearest ring on parent, in xend/yend.
	;...also eax=ring#, =0 if outside node.
      mov nring,ax
    .ELSEIF ax==60   ;exec-icon
      ;basically uses same code as a node...
      jmp rc2
    .ELSEIF ax==61   ;text-file-icon
      ;basically uses same code as a node...
      jmp rc2
;    .ELSEIF ax==62   ;make-icon
    .ELSE
      ;for now, don't do anything when dblclk on anything other
      ;than a node.
      ret
    .ENDIF

;need to decide on a format for auto-gen of filenames. i suggest
; "SxxxEzzzzzRyy.eee"
; Sxxx means Subproject number.
; Ezzzzz means element number.
; Ryy	 means ring number.
; eee	 extension.


	mov  al,(OBJECT PTR [esi]).fconfig
	and  al,00011000b  ;get bits3/4

	.IF  al==0		;none set. default, auto-gen.
;change the node to pale yellow...
	  test (OBJECT PTR [esi]).fconfig,0100b   ;colour-on bit.
	  jnz  colon1		;don't change existing colour.
	  or   (OBJECT PTR [esi]).fconfig,0100b ;turn on color-fill.
	  mov  (OBJECT PTR [esi]).ncolour1,0C0FFFFh ;080FFFFh ;pale yellow.
colon1:
	  jmp  xdb6		;auto gen of filename for editor.


	.ELSEIF al==00001000b	;custom filename for editor.
	  mov edi,pTERSEDATA
	  lea eax,(TERSEDATA PTR [edi]).szeditor
	  invoke lstrcpy, ADDR szcommandline, eax
	  invoke lstrlen, ADDR szcommandline
	  add eax,OFFSET szcommandline
	  mov pendeditor,eax	;we will place the filespec after this.
	  mov ebx,pendeditor
	  mov [ebx],BYTE PTR " "	;/
	  inc pendeditor

	  lea	eax,(OBJECT PTR [esi]).sztext2	;sztext2/3, 126+2 bytes.
	  mov ebx,pendeditor
	  invoke lstrcpy, ebx,eax
;change the node to pale red... 171000 no, purple-pink...
	  test (OBJECT PTR [esi]).fconfig,0100b
	  jnz  colon2		;don't change existing colour.
	  or   (OBJECT PTR [esi]).fconfig,0100b ;turn on color-fill.
	  mov  (OBJECT PTR [esi]).ncolour1,0FF00FFh ;purple-pink
	    ;... was =008080FFh ;pale red.
colon2:
	  jmp  xdb8

;.......
	.ELSEIF al==00010000b	;execute application.
	    lea  eax,(OBJECT PTR [esi]).sztext2
	  invoke WinExec, eax, SW_SHOW ;call editor.
;change the node to pink-purple... 171000 no, now red...
;	  test (OBJECT PTR [esi]).fconfig,0100b
;	  jnz  colon3		;don't change existing colour.
	  or   (OBJECT PTR [esi]).fconfig,0100b ;turn on color-fill.
	  mov  (OBJECT PTR [esi]).ncolour1,0FFh ;red
	    ;... was purple-pink =0FF00FFh
colon3:
	  jmp  xdb9

;.......
	.ELSE		     ;open another diagram.
	  ;node must be library-function...
	  mov al,(OBJECT PTR [esi]).nfunctype
	  .IF al==3	;library func.
	  .ELSE
	    lea eax,szer11300
	    jmp SHORT ww1
	  .ENDIF
;change the node to aqua-blue...
;	  test (OBJECT PTR [esi]).fconfig,0100b
;	  jnz  p44		;don't change existing colour.
	  or   (OBJECT PTR [esi]).fconfig,0100b ;turn on color-fill.
	  mov  (OBJECT PTR [esi]).ncolour1,0FFFF00h
;	  mov  g_fhaschanged,1
;p44:
;	  ;only open if control key held down...
;	      invoke GetAsyncKeyState, VK_CONTROL ;ax bit7 set if pressed.
;	      and  ax,8000h
;	      rol  ax,1 	;=1 if ctrl key pressed.
;	      cmp  al,1
;	      jne  xdb6	;not down, so run editor with auto-filename.
	  .IF  g_fhaschanged==1
	    lea	eax,szchanged
	    invoke MessageBox,g_hwnd,eax,ADDR szgoosee,MB_YESNO+MB_ICONQUESTION
	    .IF eax==IDYES
	      invoke savedatafile
	    .ENDIF
	    mov g_fhaschanged,0
	  .ENDIF

;current object must have a label...
	  mov  al,(OBJECT PTR [esi]).sztext1
	  .IF al==0	;no label, cannot go to child diagram.
	    lea	eax,szler1
ww1:	    invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONQUESTION
	    jmp  xdb9	;exit.
	  .ENDIF

	  invoke openadiagram,esi ;opens linked-to diagram

	    ;returns ax=0 ok, ax=-1 if aborted opening new diagram.
	  jmp  xdb9		;exit.
	.ENDIF

;........
xdb6:		    ;auto-gen of filename.
	  mov edi,pTERSEDATA
	  lea eax,(TERSEDATA PTR [edi]).szeditor
	  invoke lstrcpy, ADDR szcommandline, eax
	  invoke lstrlen, ADDR szcommandline
	  add eax,OFFSET szcommandline
	  mov pendeditor,eax	;we will place the filespec after this.
	  mov ebx,pendeditor
	  mov [ebx],BYTE PTR " "	;/
	  inc pendeditor

	  mov  esi,g_phighlightedobject

	  mov edi,pTERSEDATA
	  xor eax,eax
	  mov ax,(TERSEDATA PTR [edi]).nsubproject
	  mov ebx,pendeditor
	  mov [ebx],BYTE PTR "S"
	  inc ebx
	  mov pendeditor,ebx

	  invoke bin2dec		;eax-->szasciitbl to szasciitbl+9
	  lea  edi,szasciitbl+6		;(szasciitbl+10 has a zero)
	    mov  al,[edi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  edi		;/
	      mov  al,[edi]	;/
	    .ENDW		;/
	  mov ebx,pendeditor
	  invoke lstrcpy, ebx,edi
	  invoke lstrlen, ADDR szcommandline
	  add eax,OFFSET szcommandline
	  mov pendeditor,eax

	  xor eax,eax
	  mov  ax,(OBJECT PTR [esi]).number
	  mov ebx,pendeditor
	  mov [ebx],BYTE PTR "E"
	  inc ebx
	  mov pendeditor,ebx

	  invoke bin2dec		;eax-->szasciitbl
	  lea  edi,szasciitbl+4
	    mov  al,[edi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  edi		;/
	      mov  al,[edi]	;/
	    .ENDW		;/
	  mov ebx,pendeditor
	  invoke lstrcpy, ebx,edi
	  invoke lstrlen, ADDR szcommandline
	  add eax,OFFSET szcommandline
	  mov pendeditor,eax

	mov ebx,pendeditor
;	cmp nring,1	;don't have this part if in ring1
;	je  byr1
;111000 ... don't need this ring# stuff, so bypass it always...
      jmp SHORT byr1
	mov [ebx],BYTE PTR "R"
	add ebx,2
	mov  ax,nring
	    xor dx,dx			     ;convert it to ascii.
	    mov cx,10
	    div cx	 ;dx=remainder has digit
	    add dl,30h	 ;-->ascii
	    mov [ebx],dl
	    xor dx,dx
	    div cx
	    add dl,30h
	    dec ebx
	    mov [ebx],dl
	    add ebx,2

byr1:	    mov [ebx],BYTE PTR "."
	    inc ebx
	    mov [ebx],BYTE PTR 0
	    mov pendeditor,ebx

	    mov edi,pTERSEDATA
	    lea eax,(TERSEDATA PTR [edi]).szexten
	    mov ebx,pendeditor
	    invoke lstrcpy, ebx, eax


xdb8:	  invoke WinExec, ADDR szcommandline, SW_SHOW ;call editor.
xdb9:	  mov  g_phighlightedobject,0	;remove highlighting
	  mov  g_nstate,0			;/


  .ENDIF

  ret
xdblclk ENDP
;--------------------------------------------------------------------------
bigmove PROC STDCALL USES ebx ecx edx esi edi
    LOCAL zoom:SBYTE
;from xdblclk.

      mov esi,pTERSEDATA
      mov al,(TERSEDATA PTR [esi]).nzoom
      mov zoom,al
      .IF zoom>0
	    mov (TERSEDATA PTR [esi]).nzoom,0
big1:	    ;make logical mouse coords the new origin...
	    ;first do x coord...
	    mov eax,clientrect.rc_left
	    mov ebx,g_nmousex
	    mov clientrect.rc_left,ebx	;set left to g_nmousex
	    sub ebx,eax
	    add clientrect.rc_right,ebx ;move right by same amount.
	      ;then do y coord...
	      mov eax,clientrect.rc_top
	      mov ebx,g_nmousey
	      mov clientrect.rc_top,ebx	;set left to g_nmousex
	      sub ebx,eax
	      add clientrect.rc_bottom,ebx ;move right by same amount.
	    invoke InvalidateRgn,g_hwnd,0,TRUE	;invalidate entire window.
	    mov g_fredrawdiag,ENTIRE		;redraw entire window.
      .ELSEIF zoom<0
	    mov (TERSEDATA PTR [esi]).nzoom,2 ;zoom out
	    jmp big1
      .ENDIF

  ret
bigmove ENDP
;--------------------------------------------------------------------------
shoot PROC STDCALL USES ebx ecx edx esi edi
;from File/Copy > IDM_CPY. copies diagram to clipboard.
	LOCAL chdc:DWORD, crect:RECT, memdc:DWORD,hcpybitmap:DWORD
	LOCAL cwidth:DWORD, cheight:DWORD, hclipbrd:DWORD
	LOCAL holdbitmap:DWORD
;copy entire client area to clipboard...(as a bitmap)
	invoke GetDC, g_hwnd	;dc for client area.
	mov  chdc,eax

	invoke GetClientRect, g_hwnd,ADDR crect
	mov  eax,crect.rc_right
	sub  eax,crect.rc_left
	mov  cwidth,eax
	mov  ebx,crect.rc_bottom
	sub  ebx,crect.rc_top
	mov  cheight,ebx
	invoke CreateCompatibleDC, chdc
	mov  memdc,eax
	invoke CreateCompatibleBitmap, chdc,cwidth,cheight
	mov  hcpybitmap,eax			;handle of bitmap.
	invoke SelectObject, memdc,hcpybitmap
	mov  holdbitmap,eax
	invoke BitBlt, memdc,0,0,cwidth,cheight,chdc,0,0,SRCCOPY
	invoke OpenClipboard, g_hwnd
	mov  hclipbrd,eax			;handle for clipboard.
	invoke EmptyClipboard
	invoke SetClipboardData,CF_BITMAP,hcpybitmap
	invoke CloseClipboard
	invoke SelectObject, memdc,holdbitmap
	invoke DeleteDC, memdc

	invoke ReleaseDC, g_hwnd,chdc

  ret
shoot ENDP
;--------------------------------------------------------------------------
KENTER1proc PROC STDCALL USES ebx edi esi,khdlg:DWORD,kmessage:DWORD,kwparam:DWORD,klparam:DWORD
    LOCAL dummy:BYTE
;callback for KENTER1 dialog box, called via IDM_CONFIG.
;for Language & Editor dialog box.

;get addressability to TERSEDATA memory block...
    mov esi,pTERSEDATA

	.IF kmessage==WM_INITDIALOG
;set limits on max chars...
 ;C source files extension...
 invoke SendDlgItemMessage,khdlg,IDD_K1EXT,EM_LIMITTEXT,6,0 ;set limit.
 ;C source comment prefix...
 invoke SendDlgItemMessage,khdlg,IDD_K1COM,EM_LIMITTEXT,2,0 ;set limit.
 ;C source comment postfix...
 invoke SendDlgItemMessage,khdlg,IDD_K1PF,EM_LIMITTEXT,2,0
 ;editor name...
 invoke SendDlgItemMessage,khdlg,IDD_K1EDIT,EM_LIMITTEXT,60,0 ;set limit.

;read current settings from database...
	lea eax,(TERSEDATA PTR [esi]).szexten
 invoke SendDlgItemMessage,khdlg,IDD_K1EXT,WM_SETTEXT,0,eax ;ADDR szexten
	lea eax,(TERSEDATA PTR [esi]).szprefix
 invoke SendDlgItemMessage,khdlg,IDD_K1COM,WM_SETTEXT,0,eax ;ADDR szprefix
	lea eax,(TERSEDATA PTR [esi]).szpostfix
 invoke SendDlgItemMessage,khdlg,IDD_K1PF,WM_SETTEXT,0,eax ;ADDR szpostfix
	lea eax,(TERSEDATA PTR [esi]).szeditor
 invoke SendDlgItemMessage,khdlg,IDD_K1EDIT,WM_SETTEXT,0,eax ;ADDR szeditor

;for now make comment pre/postfix readonly...
       invoke SendDlgItemMessage,khdlg,205,EM_SETREADONLY,TRUE,0 ;prefix
       invoke SendDlgItemMessage,khdlg,296,EM_SETREADONLY,TRUE,0 ;postfix


;data types...
	lea eax,(TERSEDATA PTR [esi]).sztype1
 invoke SendDlgItemMessage,khdlg,IDD_TYPE1,WM_SETTEXT,0,eax ;ADDR sztype1
 invoke SendDlgItemMessage,khdlg,IDD_TYPE1,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype2
 invoke SendDlgItemMessage,khdlg,IDD_TYPE2,WM_SETTEXT,0,eax ;ADDR sztype2
 invoke SendDlgItemMessage,khdlg,IDD_TYPE2,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype3
 invoke SendDlgItemMessage,khdlg,IDD_TYPE3,WM_SETTEXT,0,eax ;ADDR sztype3
 invoke SendDlgItemMessage,khdlg,IDD_TYPE3,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype4
 invoke SendDlgItemMessage,khdlg,IDD_TYPE4,WM_SETTEXT,0,eax ;ADDR sztype4
 invoke SendDlgItemMessage,khdlg,IDD_TYPE4,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype5
 invoke SendDlgItemMessage,khdlg,IDD_TYPE5,WM_SETTEXT,0,eax ;ADDR sztype5
 invoke SendDlgItemMessage,khdlg,IDD_TYPE5,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype6
 invoke SendDlgItemMessage,khdlg,IDD_TYPE6,WM_SETTEXT,0,eax ;ADDR sztype6
 invoke SendDlgItemMessage,khdlg,IDD_TYPE6,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype7
 invoke SendDlgItemMessage,khdlg,IDD_TYPE7,WM_SETTEXT,0,eax ;ADDR sztype7
 invoke SendDlgItemMessage,khdlg,IDD_TYPE7,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype8
 invoke SendDlgItemMessage,khdlg,IDD_TYPE8,WM_SETTEXT,0,eax ;ADDR sztype8
 invoke SendDlgItemMessage,khdlg,IDD_TYPE8,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype9
 invoke SendDlgItemMessage,khdlg,IDD_TYPE9,WM_SETTEXT,0,eax ;ADDR sztype9
 invoke SendDlgItemMessage,khdlg,IDD_TYPE9,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype10
 invoke SendDlgItemMessage,khdlg,IDD_TYPE10,WM_SETTEXT,0,eax ;ADDR sztype10
 invoke SendDlgItemMessage,khdlg,IDD_TYPE10,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype11
 invoke SendDlgItemMessage,khdlg,IDD_TYPE11,WM_SETTEXT,0,eax ;ADDR sztype11
 invoke SendDlgItemMessage,khdlg,IDD_TYPE11,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype12
 invoke SendDlgItemMessage,khdlg,IDD_TYPE12,WM_SETTEXT,0,eax ;ADDR sztype12
 invoke SendDlgItemMessage,khdlg,IDD_TYPE12,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype13
 invoke SendDlgItemMessage,khdlg,IDD_TYPE13,WM_SETTEXT,0,eax ;ADDR sztype13
 invoke SendDlgItemMessage,khdlg,IDD_TYPE13,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype14
 invoke SendDlgItemMessage,khdlg,IDD_TYPE14,WM_SETTEXT,0,eax ;ADDR sztype14
 invoke SendDlgItemMessage,khdlg,IDD_TYPE14,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).sztype15
 invoke SendDlgItemMessage,khdlg,IDD_TYPE15,WM_SETTEXT,0,eax ;ADDR sztype15
 invoke SendDlgItemMessage,khdlg,IDD_TYPE15,EM_LIMITTEXT,46,0

;structure/reference data types...
	lea eax,(TERSEDATA PTR [esi]).szptrtype1
 invoke SendDlgItemMessage,khdlg,338,WM_SETTEXT,0,eax ;ADDR szptrtype1
 invoke SendDlgItemMessage,khdlg,338,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype2
 invoke SendDlgItemMessage,khdlg,339,WM_SETTEXT,0,eax ;ADDR szptrtype2
 invoke SendDlgItemMessage,khdlg,339,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype3
 invoke SendDlgItemMessage,khdlg,340,WM_SETTEXT,0,eax ;ADDR szptrtype3
 invoke SendDlgItemMessage,khdlg,340,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype4
 invoke SendDlgItemMessage,khdlg,341,WM_SETTEXT,0,eax ;ADDR szptrtype4
 invoke SendDlgItemMessage,khdlg,341,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype5
 invoke SendDlgItemMessage,khdlg,342,WM_SETTEXT,0,eax ;ADDR szptrtype5
 invoke SendDlgItemMessage,khdlg,342,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype6
 invoke SendDlgItemMessage,khdlg,343,WM_SETTEXT,0,eax ;ADDR szptrtype6
 invoke SendDlgItemMessage,khdlg,343,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype7
 invoke SendDlgItemMessage,khdlg,344,WM_SETTEXT,0,eax ;ADDR szptrtype7
 invoke SendDlgItemMessage,khdlg,344,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype8
 invoke SendDlgItemMessage,khdlg,345,WM_SETTEXT,0,eax ;ADDR szptrtype8
 invoke SendDlgItemMessage,khdlg,345,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype9
 invoke SendDlgItemMessage,khdlg,346,WM_SETTEXT,0,eax ;ADDR szptrtype9
 invoke SendDlgItemMessage,khdlg,346,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype10
 invoke SendDlgItemMessage,khdlg,347,WM_SETTEXT,0,eax ;ADDR szptrtype10
 invoke SendDlgItemMessage,khdlg,347,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype11
 invoke SendDlgItemMessage,khdlg,348,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,348,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype12
 invoke SendDlgItemMessage,khdlg,349,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,349,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szptrtype13
 invoke SendDlgItemMessage,khdlg,295,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,295,EM_LIMITTEXT,46,0

;data type declaration pre/postfixes...
	lea eax,(TERSEDATA PTR [esi]).szpre1
 invoke SendDlgItemMessage,khdlg,IDD_PRE1,WM_SETTEXT,0,eax ;ADDR szpre1
 invoke SendDlgItemMessage,khdlg,IDD_PRE1,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre2
 invoke SendDlgItemMessage,khdlg,IDD_PRE2,WM_SETTEXT,0,eax ;ADDR szpre2
 invoke SendDlgItemMessage,khdlg,IDD_PRE2,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre3
 invoke SendDlgItemMessage,khdlg,IDD_PRE3,WM_SETTEXT,0,eax ;ADDR szpre3
 invoke SendDlgItemMessage,khdlg,IDD_PRE3,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre4
 invoke SendDlgItemMessage,khdlg,IDD_PRE4,WM_SETTEXT,0,eax ;ADDR szpre4
 invoke SendDlgItemMessage,khdlg,IDD_PRE4,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre5
 invoke SendDlgItemMessage,khdlg,IDD_PRE5,WM_SETTEXT,0,eax ;ADDR szpre5
 invoke SendDlgItemMessage,khdlg,IDD_PRE5,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre6
 invoke SendDlgItemMessage,khdlg,IDD_PRE6,WM_SETTEXT,0,eax ;ADDR szpre6
 invoke SendDlgItemMessage,khdlg,IDD_PRE6,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre7
 invoke SendDlgItemMessage,khdlg,IDD_PRE7,WM_SETTEXT,0,eax ;ADDR szpre7
 invoke SendDlgItemMessage,khdlg,IDD_PRE7,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre8
 invoke SendDlgItemMessage,khdlg,IDD_PRE8,WM_SETTEXT,0,eax ;ADDR szpre8
 invoke SendDlgItemMessage,khdlg,IDD_PRE8,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre9
 invoke SendDlgItemMessage,khdlg,358,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,358,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre10
 invoke SendDlgItemMessage,khdlg,359,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,359,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre11
 invoke SendDlgItemMessage,khdlg,360,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,360,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre12
 invoke SendDlgItemMessage,khdlg,361,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,361,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre13
 invoke SendDlgItemMessage,khdlg,362,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,362,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre14
 invoke SendDlgItemMessage,khdlg,363,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,363,EM_LIMITTEXT,46,0
	lea eax,(TERSEDATA PTR [esi]).szpre15
 invoke SendDlgItemMessage,khdlg,364,WM_SETTEXT,0,eax
 invoke SendDlgItemMessage,khdlg,364,EM_LIMITTEXT,46,0

;function pre/postfixes...
	lea eax,(TERSEDATA PTR [esi]).szpfunc1
 invoke SendDlgItemMessage,khdlg,170,WM_SETTEXT,0,eax ;ADDR szpfunc1
 invoke SendDlgItemMessage,khdlg,170,EM_LIMITTEXT,62,0
	lea eax,(TERSEDATA PTR [esi]).szpfunc2
 invoke SendDlgItemMessage,khdlg,171,WM_SETTEXT,0,eax ;ADDR szpfunc2
 invoke SendDlgItemMessage,khdlg,171,EM_LIMITTEXT,62,0
	lea eax,(TERSEDATA PTR [esi]).szpfunc3
 invoke SendDlgItemMessage,khdlg,172,WM_SETTEXT,0,eax ;ADDR szpfunc3
 invoke SendDlgItemMessage,khdlg,172,EM_LIMITTEXT,62,0
	lea eax,(TERSEDATA PTR [esi]).szpfunc4
 invoke SendDlgItemMessage,khdlg,173,WM_SETTEXT,0,eax ;ADDR szpfunc4
 invoke SendDlgItemMessage,khdlg,173,EM_LIMITTEXT,62,0
	lea eax,(TERSEDATA PTR [esi]).szpfunc5
 invoke SendDlgItemMessage,khdlg,174,WM_SETTEXT,0,eax ;ADDR szpfunc5
 invoke SendDlgItemMessage,khdlg,174,EM_LIMITTEXT,62,0
	lea eax,(TERSEDATA PTR [esi]).szpfunc6
 invoke SendDlgItemMessage,khdlg,175,WM_SETTEXT,0,eax ;ADDR szpfunc6
 invoke SendDlgItemMessage,khdlg,175,EM_LIMITTEXT,62,0
	lea eax,(TERSEDATA PTR [esi]).szpfunc7
 invoke SendDlgItemMessage,khdlg,176,WM_SETTEXT,0,eax ;ADDR szpfunc7
 invoke SendDlgItemMessage,khdlg,176,EM_LIMITTEXT,62,0
	lea eax,(TERSEDATA PTR [esi]).szpfunc8
 invoke SendDlgItemMessage,khdlg,177,WM_SETTEXT,0,eax ;ADDR szpfunc8
 invoke SendDlgItemMessage,khdlg,177,EM_LIMITTEXT,62,0

;;format for interrupt functions...
;	lea eax,(TERSEDATA PTR [esi]).szisr
; invoke SendDlgItemMessage,khdlg,303,WM_SETTEXT,0,eax
; invoke SendDlgItemMessage,khdlg,303,EM_LIMITTEXT,94,0


	  mov  eax,TRUE		;return TRUE (non-zero).
;...................................
	.ELSEIF kmessage==WM_COMMAND
	  .IF  kwparam==IDOK
	    mov  g_fhaschanged,1
;update the database...
	lea eax,(TERSEDATA PTR [esi]).szexten
 invoke SendDlgItemMessage,khdlg,IDD_K1EXT,WM_GETTEXT,7,eax ;ADDR szexten
	lea eax,(TERSEDATA PTR [esi]).szprefix
 invoke SendDlgItemMessage,khdlg,IDD_K1COM,WM_GETTEXT,3,eax ;ADDR szprefix
	lea eax,(TERSEDATA PTR [esi]).szpostfix
 invoke SendDlgItemMessage,khdlg,IDD_K1PF,WM_GETTEXT,3,eax ;ADDR szprefix
	lea eax,(TERSEDATA PTR [esi]).szeditor
 invoke SendDlgItemMessage,khdlg,IDD_K1EDIT,WM_GETTEXT,61,eax ;ADDR szeditor

;update primitive data types...
	lea eax,(TERSEDATA PTR [esi]).sztype1
 invoke SendDlgItemMessage,khdlg,IDD_TYPE1,WM_GETTEXT,47,eax ;ADDR sztype1
	lea eax,(TERSEDATA PTR [esi]).sztype2
 invoke SendDlgItemMessage,khdlg,IDD_TYPE2,WM_GETTEXT,47,eax ;ADDR sztype2
	lea eax,(TERSEDATA PTR [esi]).sztype3
 invoke SendDlgItemMessage,khdlg,IDD_TYPE3,WM_GETTEXT,47,eax ;ADDR sztype3
	lea eax,(TERSEDATA PTR [esi]).sztype4
 invoke SendDlgItemMessage,khdlg,IDD_TYPE4,WM_GETTEXT,47,eax ;ADDR sztype4
	lea eax,(TERSEDATA PTR [esi]).sztype5
 invoke SendDlgItemMessage,khdlg,IDD_TYPE5,WM_GETTEXT,47,eax ;ADDR sztype5
	lea eax,(TERSEDATA PTR [esi]).sztype6
 invoke SendDlgItemMessage,khdlg,IDD_TYPE6,WM_GETTEXT,47,eax ;ADDR sztype6
	lea eax,(TERSEDATA PTR [esi]).sztype7
 invoke SendDlgItemMessage,khdlg,IDD_TYPE7,WM_GETTEXT,47,eax ;ADDR sztype7
	lea eax,(TERSEDATA PTR [esi]).sztype8
 invoke SendDlgItemMessage,khdlg,IDD_TYPE8,WM_GETTEXT,47,eax ;ADDR sztype8
	lea eax,(TERSEDATA PTR [esi]).sztype9
 invoke SendDlgItemMessage,khdlg,IDD_TYPE9,WM_GETTEXT,47,eax ;ADDR sztype9
	lea eax,(TERSEDATA PTR [esi]).sztype10
 invoke SendDlgItemMessage,khdlg,IDD_TYPE10,WM_GETTEXT,47,eax ;ADDR sztype10
	lea eax,(TERSEDATA PTR [esi]).sztype11
 invoke SendDlgItemMessage,khdlg,IDD_TYPE11,WM_GETTEXT,47,eax ;ADDR sztype11
	lea eax,(TERSEDATA PTR [esi]).sztype12
 invoke SendDlgItemMessage,khdlg,IDD_TYPE12,WM_GETTEXT,47,eax ;ADDR sztype12
	lea eax,(TERSEDATA PTR [esi]).sztype13
 invoke SendDlgItemMessage,khdlg,IDD_TYPE13,WM_GETTEXT,47,eax ;ADDR sztype13
	lea eax,(TERSEDATA PTR [esi]).sztype14
 invoke SendDlgItemMessage,khdlg,IDD_TYPE14,WM_GETTEXT,47,eax ;ADDR sztype14
	lea eax,(TERSEDATA PTR [esi]).sztype15
 invoke SendDlgItemMessage,khdlg,IDD_TYPE15,WM_GETTEXT,47,eax ;ADDR sztype15
; invoke SendDlgItemMessage,khdlg,IDD_TYPE16,WM_GETTEXT,47,ADDR sztype16
;... don't allow pointer datatype label to be changed.

;structure/reference data types...
	lea eax,(TERSEDATA PTR [esi]).szptrtype1
 invoke SendDlgItemMessage,khdlg,338,WM_GETTEXT,47,eax ;ADDR szptrtype4
	lea eax,(TERSEDATA PTR [esi]).szptrtype2
 invoke SendDlgItemMessage,khdlg,339,WM_GETTEXT,47,eax ;ADDR szptrtype5
	lea eax,(TERSEDATA PTR [esi]).szptrtype3
 invoke SendDlgItemMessage,khdlg,340,WM_GETTEXT,47,eax ;ADDR szptrtype6
	lea eax,(TERSEDATA PTR [esi]).szptrtype4
 invoke SendDlgItemMessage,khdlg,341,WM_GETTEXT,47,eax ;ADDR szptrtype7
	lea eax,(TERSEDATA PTR [esi]).szptrtype5
 invoke SendDlgItemMessage,khdlg,342,WM_GETTEXT,47,eax ;ADDR szptrtype8
	lea eax,(TERSEDATA PTR [esi]).szptrtype6
 invoke SendDlgItemMessage,khdlg,343,WM_GETTEXT,47,eax ;ADDR szptrtype9
	lea eax,(TERSEDATA PTR [esi]).szptrtype7
 invoke SendDlgItemMessage,khdlg,344,WM_GETTEXT,47,eax ;ADDR szptrtype10
	lea eax,(TERSEDATA PTR [esi]).szptrtype8
 invoke SendDlgItemMessage,khdlg,345,WM_GETTEXT,47,eax ;ADDR szptrtype11
	lea eax,(TERSEDATA PTR [esi]).szptrtype9
 invoke SendDlgItemMessage,khdlg,346,WM_GETTEXT,47,eax ;ADDR szptrtype12
	lea eax,(TERSEDATA PTR [esi]).szptrtype10
 invoke SendDlgItemMessage,khdlg,347,WM_GETTEXT,47,eax ;ADDR szptrtype13
	lea eax,(TERSEDATA PTR [esi]).szptrtype11
 invoke SendDlgItemMessage,khdlg,348,WM_GETTEXT,47,eax
	lea eax,(TERSEDATA PTR [esi]).szptrtype12
 invoke SendDlgItemMessage,khdlg,349,WM_GETTEXT,47,eax
	lea eax,(TERSEDATA PTR [esi]).szptrtype13
 invoke SendDlgItemMessage,khdlg,295,WM_GETTEXT,47,eax

;update data type declaration pre/postfixes...
	lea eax,(TERSEDATA PTR [esi]).szpre1
 invoke SendDlgItemMessage,khdlg,IDD_PRE1,WM_GETTEXT,47,eax ;ADDR szpre1
	lea eax,(TERSEDATA PTR [esi]).szpre2
 invoke SendDlgItemMessage,khdlg,IDD_PRE2,WM_GETTEXT,47,eax ;ADDR szpre2
	lea eax,(TERSEDATA PTR [esi]).szpre3
 invoke SendDlgItemMessage,khdlg,IDD_PRE3,WM_GETTEXT,47,eax ;ADDR szpre3
	lea eax,(TERSEDATA PTR [esi]).szpre4
 invoke SendDlgItemMessage,khdlg,IDD_PRE4,WM_GETTEXT,47,eax ;ADDR szpre4
	lea eax,(TERSEDATA PTR [esi]).szpre5
 invoke SendDlgItemMessage,khdlg,IDD_PRE5,WM_GETTEXT,47,eax ;ADDR szpre5
	lea eax,(TERSEDATA PTR [esi]).szpre6
 invoke SendDlgItemMessage,khdlg,IDD_PRE6,WM_GETTEXT,47,eax ;ADDR szpre6
	lea eax,(TERSEDATA PTR [esi]).szpre7
 invoke SendDlgItemMessage,khdlg,IDD_PRE7,WM_GETTEXT,47,eax ;ADDR szpre7
	lea eax,(TERSEDATA PTR [esi]).szpre8
 invoke SendDlgItemMessage,khdlg,IDD_PRE8,WM_GETTEXT,47,eax ;ADDR szpre8
	lea eax,(TERSEDATA PTR [esi]).szpre9
 invoke SendDlgItemMessage,khdlg,358,WM_GETTEXT,47,eax
	lea eax,(TERSEDATA PTR [esi]).szpre10
 invoke SendDlgItemMessage,khdlg,359,WM_GETTEXT,47,eax
	lea eax,(TERSEDATA PTR [esi]).szpre11
 invoke SendDlgItemMessage,khdlg,360,WM_GETTEXT,47,eax
	lea eax,(TERSEDATA PTR [esi]).szpre12
 invoke SendDlgItemMessage,khdlg,361,WM_GETTEXT,47,eax
	lea eax,(TERSEDATA PTR [esi]).szpre13
 invoke SendDlgItemMessage,khdlg,362,WM_GETTEXT,47,eax
	lea eax,(TERSEDATA PTR [esi]).szpre14
 invoke SendDlgItemMessage,khdlg,363,WM_GETTEXT,47,eax
	lea eax,(TERSEDATA PTR [esi]).szpre15
 invoke SendDlgItemMessage,khdlg,364,WM_GETTEXT,47,eax

;function postfixes...
	lea eax,(TERSEDATA PTR [esi]).szpfunc1
 invoke SendDlgItemMessage,khdlg,170,WM_GETTEXT,63,eax ;ADDR szpfunc1
	lea eax,(TERSEDATA PTR [esi]).szpfunc2
 invoke SendDlgItemMessage,khdlg,171,WM_GETTEXT,63,eax ;ADDR szpfunc2
	lea eax,(TERSEDATA PTR [esi]).szpfunc3
 invoke SendDlgItemMessage,khdlg,172,WM_GETTEXT,63,eax ;ADDR szpfunc3
	lea eax,(TERSEDATA PTR [esi]).szpfunc4
 invoke SendDlgItemMessage,khdlg,173,WM_GETTEXT,63,eax ;ADDR szpfunc4
	lea eax,(TERSEDATA PTR [esi]).szpfunc5
 invoke SendDlgItemMessage,khdlg,174,WM_GETTEXT,63,eax ;ADDR szpfunc5
	lea eax,(TERSEDATA PTR [esi]).szpfunc6
 invoke SendDlgItemMessage,khdlg,175,WM_GETTEXT,63,eax ;ADDR szpfunc6
	lea eax,(TERSEDATA PTR [esi]).szpfunc7
 invoke SendDlgItemMessage,khdlg,176,WM_GETTEXT,63,eax ;ADDR szpfunc7
	lea eax,(TERSEDATA PTR [esi]).szpfunc8
 invoke SendDlgItemMessage,khdlg,177,WM_GETTEXT,63,eax ;ADDR szpfunc8

;;get interrupt format...
;	lea eax,(TERSEDATA PTR [esi]).szisr
; invoke SendDlgItemMessage,khdlg,303,WM_GETTEXT,95,eax


	    invoke EndDialog, khdlg,TRUE
	    mov eax,TRUE
	  .ELSEIF kwparam==IDCANCEL
	    invoke EndDialog, khdlg,TRUE
	    mov eax,TRUE
	  .ELSE
	    mov eax,FALSE
	  .ENDIF
     .ELSEIF kmessage==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
     .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
     .ENDIF
	ret
KENTER1proc ENDP
;--------------------------------------------------------------------------
PROJECTproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;menu Control/Project-management > IDM_PROJECT > PROJECT dialog box.

      mov esi,pTERSEDATA

  .IF message==WM_INITDIALOG
      ;IDD_PROJNUM is the control for project number =TERSEDATA.nproject
      ;IDD_SUBPROJNUM is control for sub-project number =TERSEDATA.nsubproject
      ;IDD_DBASEVER is control for database version =TERSEDATA.nversion
      xor eax,eax
      mov ax,(TERSEDATA PTR [esi]).nproject
      invoke bin2dec	    ;-->asciitbl--asciitbl+9, right-justified.
      lea eax,szasciitbl+6
      invoke SendDlgItemMessage,hdlg,IDD_PROJNUM,WM_SETTEXT,0,eax
      invoke SendDlgItemMessage,hdlg,IDD_PROJNUM,EM_LIMITTEXT,4,0
      xor eax,eax
      mov ax,(TERSEDATA PTR [esi]).nsubproject
      invoke bin2dec
      lea eax,szasciitbl+6
      invoke SendDlgItemMessage,hdlg,IDD_PROJSUBNUM,WM_SETTEXT,0,eax
      invoke SendDlgItemMessage,hdlg,IDD_PROJSUBNUM,EM_LIMITTEXT,4,0
      mov eax,(TERSEDATA PTR [esi]).nversion
      invoke bin2dec
      lea eax,szasciitbl+6
      invoke SendDlgItemMessage,hdlg,IDD_DBASEVER,WM_SETTEXT,0,eax

      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK
      mov  g_fhaschanged,1

      lea  eax,szasciitbl
      invoke SendDlgItemMessage,hdlg,IDD_PROJNUM,WM_GETTEXT,5,eax
      invoke str2longint, ADDR szasciitbl  ;--> eax.
      mov (TERSEDATA PTR [esi]).nproject,ax
      lea  eax,szasciitbl
      invoke SendDlgItemMessage,hdlg,IDD_PROJSUBNUM,WM_GETTEXT,5,eax
      invoke str2longint, ADDR szasciitbl  ;--> eax.
      mov (TERSEDATA PTR [esi]).nsubproject,ax


      invoke EndDialog, hdlg,1 ;TRUE
      mov eax,TRUE
    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,2 ;2 is returned to dialogboxparam() TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
PROJECTproc ENDP
;--------------------------------------------------------------------------
.DATA
xg_perrorobject DWORD 0
sznfinderr BYTE "Invalid or out-of-range element number.",0
.CODE
NFINDproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
; "nfindproc"
;menu Control/Element find > IDM_NFIND > NFIND dialog box (id=220).

      mov esi,pTERSEDATA

  .IF message==WM_INITDIALOG
      mov xg_perrorobject,0
      invoke SendDlgItemMessage,hdlg,204,EM_LIMITTEXT,4,0
      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK

      mov esi,pTERSEDATA
      lea  eax,szasciitbl
      invoke SendDlgItemMessage,hdlg,204,WM_GETTEXT,5,eax
      invoke str2longint, ADDR szasciitbl  ;--> eax.
	xor ebx,ebx
	mov bx,(TERSEDATA PTR [esi]).numobjects
	.IF SDWORD PTR eax<0
xx1:	      lea	eax,sznfinderr
	      invoke MessageBox,hdlg,eax,0,MB_OK+MB_ICONEXCLAMATION
	      jmp   nfindno	;do not end dialog box.
	.ELSEIF eax>=ebx
	  jmp xx1
	.ELSE
	  xor ebx,ebx
	  xor edx,edx
	  mov bx,(TERSEDATA PTR [esi]).nsizeobject
	  mul ebx
	  lea ebx,(TERSEDATA PTR [esi]).OBJECTS	;starting addr of OBJECTS
	  add eax,ebx	;eax now has address of element.
	    mov ebx,eax
	    mov cl,(OBJECT PTR [ebx]).fstatus
	    and cl,01
	    .IF cl==0
	      ;invalid element...
	      jmp xx1
	    .ENDIF
	    mov cx,(OBJECT PTR [ebx]).nexttype
	    .IF cx==-1
	      ;non-display element...
	      jmp xx1
	    .ENDIF
	  mov xg_perrorobject,eax ;xpaint_entire() will use this to move diag.
	  ;...when window redraws, need the element# in centre.
	  mov (TERSEDATA PTR [esi]).nzoom,0 ;diagram move only works at zoom=0.
	  ;221000 ...note also, have fixed wmpaint() to zoom=0 when
	  ;  g_perrorobject<>0 (for error on composing).
	.ENDIF

      invoke EndDialog, hdlg,1 ;TRUE
nfindno:
      mov eax,TRUE
    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,2 ;2 is returned to dialogboxparam() TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
NFINDproc ENDP
;--------------------------------------------------------------------------
.DATA	       ;must all be static...
nlength  DWORD 0	  ;length of test string (not incl 0-terminator)
psource  DWORD 0	  ;ptr into element being tested.
pfoundelement DWORD 0
tesisave DWORD 0
tedisave DWORD 0
tecxsave DWORD 0
sztfind BYTE 64 DUP(0)
sztfindold BYTE 64 DUP(0)
sztsource  BYTE 64 DUP(0)
sztend	 BYTE "Search complete. Enter a new text string and press ""Find"" "
	 BYTE "button to perform another search.",0
.CODE
TFINDproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
; "tfindproc"
;menu Control/Text find > IDM_TFIND > TFIND dialog box (id=221).

  .IF message==WM_INITDIALOG
      mov pfoundelement,0
      mov sztfindold,0
      invoke SendDlgItemMessage,hdlg,204,EM_LIMITTEXT,62,0
      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK	       ;"Find" button.

      lea  eax,sztfind
      invoke SendDlgItemMessage,hdlg,204,WM_GETTEXT,63,eax
      ;...saved in sztfind
      invoke lstrlen, ADDR sztfind
      mov nlength,eax
      .IF sztfindold==0
ee1:	invoke lstrcpy, ADDR sztfindold, ADDR sztfind
      .ELSE
	invoke lstrcmp, ADDR sztfindold, ADDR sztfind
	.IF eax==0
	  ;strings are equal...
	.ELSE
	  ;string has been changed, so start search from beginning...
	  mov pfoundelement,0
	  jmp ee1
	.ENDIF
      .ENDIF

      ;if a continuation of the search, pfoundelement is non-0...
      .IF pfoundelement==0
      .ELSE
	jmp kf1
      .ENDIF

      ;go thru all elements, looking for text string, with allowed
      ;delimiters.
      ;when found, set g_perrorobject ptg to that element.
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0 ;empty.
	    jmp kf4
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov tesisave,esi
	mov tedisave,edi
	mov tecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	    mov ax,(OBJECT PTR [esi]).nexttype
	    .IF ax==-1
	    .ELSE		;not a data object.

		;mov psource,esi     ;start of element.
		lea eax,(OBJECT PTR [esi]).sztext1 ;1st text field.
		mov psource,eax

ss3:		  ;gone over end of element?...
		  xor eax,eax
		  mov ax,(TERSEDATA PTR [edi]).nsizeobject
		  add eax,esi	    ;addr of next element.
		  .IF psource>=eax
		    ;have finished searching this element, gotonext one...
		    jmp kf1
		  .ELSE
		    mov ebx,psource
		    add ebx,nlength
		    inc ebx	    ;need room for end-delimiter also.
		    .IF ebx>=eax
		      ;string being tested goes over end of this element...
		      jmp kf1
		    .ENDIF
		  .ENDIF
		mov ebx,psource
		dec ebx 	;look for start-delimiter before string.
		mov al,[ebx]
		  ;look for a delimiter...
		  .IF al==0	;end of previous field.
		    jmp ss1
		  .ELSEIF al=="{"
ss1:		      ;zeroise sztsource buffer...
		      lea ebx,sztsource
		      mov ecx,nlength
		      inc ecx
ss2:		      mov [ebx],BYTE PTR 0
		      inc ebx
		      loop ss2
		    mov ebx,psource
		    ;**TRICKY!** this actually copies nlength-1 chars
		    ;from psource, followed by a zero...
		    ;invoke lstrcpyn, ADDR sztsource,ebx,nlength
		    ;so, do it this way...
		      mov eax,nlength
		      inc eax
		      invoke lstrcpyn, ADDR sztsource,ebx,eax
		    invoke lstrcmp, ADDR sztfind,ADDR sztsource
		    .IF eax==0
		      ;strings are the same, but test end-delimiter valid...
		      mov ebx,psource
		      add ebx,nlength
		      mov al,[ebx]	;get end-delimiter.
		      .IF al==0
			jmp ss5
		      .ELSEIF al=="{"
ss5:			;found, set pfoundelement...
			mov pfoundelement,esi
			;then...
			;when window redraws, need the element in centre.
			mov (TERSEDATA PTR [edi]).nzoom,0
			;...diagram move only works at zoom=0.
			invoke InvalidateRgn, g_hwnd,0,TRUE
			;...invalidate entire window, TRUE=wipe previous
			;221000 ...note, wmpaint() now detects g_perrorobject
			;not=0 and sets zoom=0.
			jmp ss9
			;...gets out of this loop but doesn't end dialog.
		      .ELSEIF al=="}"
			jmp ss5
		      .ELSEIF al=="("
			jmp ss5
		      .ELSEIF al==")"
			jmp ss5
		      .ELSEIF al=="~"
			jmp ss5
		      .ELSEIF al=="^"
			jmp ss5
		      .ELSEIF al=="|"
			jmp ss5
		      .ELSEIF al=="!"
			jmp ss5
		      .ELSEIF al=="="
			jmp ss5
		      .ELSEIF al==">"
			jmp ss5
		      .ELSEIF al=="<"
			jmp ss5
		      .ELSEIF al=="%"
			jmp ss5
		      .ELSEIF al=="/"
			jmp ss5
		      .ELSEIF al=="\"
			jmp ss5
		      .ELSEIF al=="#"
			jmp ss5
		      .ELSEIF al==","
			jmp ss5
		      .ELSEIF al==" "
			jmp ss5
		      .ELSEIF al==";"
			jmp ss5
		      .ELSEIF al==":"
			jmp ss5
		      .ELSEIF al=="+"
			jmp ss5
		      .ELSEIF al=="-"
			jmp ss5
		      .ELSEIF al=="*"
			jmp ss5
		      .ELSEIF al=="&"
			jmp ss5
		      .ELSEIF al=="."
			jmp ss5
		      .ELSEIF al=="$"
			jmp ss5
		      .ELSEIF al==0Dh
			jmp ss5
		      .ELSEIF al==0Ah
			jmp ss5
		      .ELSEIF al==09	;tab char
			jmp ss5
		      .ELSE
			;incorrect end-delimiter, keep searching...
			inc psource
			jmp ss3
		      .ENDIF
		    .ELSE
		      ;strings not the same, keep searching...
		      inc psource
		      jmp ss3
		    .ENDIF

		  .ELSEIF al=="}"
		    jmp ss1
		  .ELSEIF al=="("
		    jmp ss1
		  .ELSEIF al==")"
		    jmp ss1
		  .ELSEIF al=="~"
		    jmp ss1
		  .ELSEIF al=="^"
		    jmp ss1
		  .ELSEIF al=="|"
		    jmp ss1
		  .ELSEIF al=="!"
		    jmp ss1
		  .ELSEIF al=="="
		    jmp ss1
		  .ELSEIF al==">"
		    jmp ss1
		  .ELSEIF al=="<"
		    jmp ss1
		  .ELSEIF al=="%"
		    jmp ss1
		  .ELSEIF al=="/"
		    jmp ss1
		  .ELSEIF al=="\"
		    jmp ss1
		  .ELSEIF al=="#"
		    jmp ss1
		  .ELSEIF al==","
		    jmp ss1
		  .ELSEIF al==" "
		    jmp ss1
		  .ELSEIF al==";"
		    jmp ss1
		  .ELSEIF al==":"
		    jmp ss1
		  .ELSEIF al=="+"
		    jmp ss1
		  .ELSEIF al=="-"
		    jmp ss1
		  .ELSEIF al=="*"
		    jmp ss1
		  .ELSEIF al=="&"
		    jmp ss1
		  .ELSEIF al=="."
		    jmp ss1
		  .ELSEIF al=="$"
		    jmp ss1
		  .ELSEIF al==0Dh
		    jmp ss1
		  .ELSEIF al==0Ah
		    jmp ss1
		  .ELSEIF al==09    ;tab char.
		    jmp ss1
		  .ENDIF
		  inc psource
		  jmp ss3  ;keep searching this element.
	    .ENDIF
	  .ENDIF
kf1:	mov ecx,tecxsave
	mov edi,tedisave
	mov esi,tesisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
      loop kf3 ;nextobj
      jmp SHORT kf4
kf3:  jmp nextobj
kf4:
      ;put up a messagebox here, end of search...
      mov pfoundelement,0
	      lea eax,sztend
	      invoke MessageBox,hdlg,eax,0,MB_OK
      ;do not end dialog box.
      mov eax,TRUE

    .ELSEIF wparam==IDCANCEL	   ;"Done" button.
      invoke EndDialog, hdlg,2 ;2 is returned to dialogboxparam() TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
ss9:	mov eax,pfoundelement	;keeps found element highlighted.
	mov g_perrorobject,eax	; / (xpaint_entire() clears it after 1 paint)
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
TFINDproc ENDP
;--------------------------------------------------------------------------
OSproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;Control/Configuration.../Operating-System > IDM_OS >

    mov esi,pTERSEDATA

  .IF message==WM_INITDIALOG

;each of the strings TERSEDATA.szos1/2/3/4 needs to be uploaded to
;IDD_OS1/2/3/4...
	lea eax,(TERSEDATA PTR [esi]).szos1
	invoke SendDlgItemMessage,hdlg,IDD_OS1,WM_SETTEXT,0,eax
	invoke SendDlgItemMessage,hdlg,IDD_OS1,EM_LIMITTEXT,94,0
	lea eax,(TERSEDATA PTR [esi]).szos2
	invoke SendDlgItemMessage,hdlg,IDD_OS2,WM_SETTEXT,0,eax
	invoke SendDlgItemMessage,hdlg,IDD_OS2,EM_LIMITTEXT,94,0
	lea eax,(TERSEDATA PTR [esi]).szos3
	invoke SendDlgItemMessage,hdlg,IDD_OS3,WM_SETTEXT,0,eax
	invoke SendDlgItemMessage,hdlg,IDD_OS3,EM_LIMITTEXT,94,0
	lea eax,(TERSEDATA PTR [esi]).szos4
	invoke SendDlgItemMessage,hdlg,IDD_OS4,WM_SETTEXT,0,eax
	invoke SendDlgItemMessage,hdlg,IDD_OS4,EM_LIMITTEXT,94,0

;each of the strings szosqual1/2/3/4 needs to be uploaded to
;IDD_OSQUAL1/2/3/4...
	lea eax,(TERSEDATA PTR [esi]).szosqual1
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL1,WM_SETTEXT,0,eax
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL1,EM_LIMITTEXT,94,0
	lea eax,(TERSEDATA PTR [esi]).szosqual2
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL2,WM_SETTEXT,0,eax
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL2,EM_LIMITTEXT,94,0
	lea eax,(TERSEDATA PTR [esi]).szosqual3
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL3,WM_SETTEXT,0,eax
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL3,EM_LIMITTEXT,94,0
	lea eax,(TERSEDATA PTR [esi]).szosqual4
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL4,WM_SETTEXT,0,eax
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL4,EM_LIMITTEXT,94,0


      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK
      mov  g_fhaschanged,1
	lea eax,(TERSEDATA PTR [esi]).szos1
	invoke SendDlgItemMessage,hdlg,IDD_OS1,WM_GETTEXT,95,eax
	lea eax,(TERSEDATA PTR [esi]).szos2
	invoke SendDlgItemMessage,hdlg,IDD_OS2,WM_GETTEXT,95,eax
	lea eax,(TERSEDATA PTR [esi]).szos3
	invoke SendDlgItemMessage,hdlg,IDD_OS3,WM_GETTEXT,95,eax
	lea eax,(TERSEDATA PTR [esi]).szos4
	invoke SendDlgItemMessage,hdlg,IDD_OS4,WM_GETTEXT,95,eax

	lea eax,(TERSEDATA PTR [esi]).szosqual1
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL1,WM_GETTEXT,95,eax
	lea eax,(TERSEDATA PTR [esi]).szosqual2
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL2,WM_GETTEXT,95,eax
	lea eax,(TERSEDATA PTR [esi]).szosqual3
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL3,WM_GETTEXT,95,eax
	lea eax,(TERSEDATA PTR [esi]).szosqual4
	invoke SendDlgItemMessage,hdlg,IDD_OSQUAL4,WM_GETTEXT,95,eax

      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
OSproc	 ENDP
;--------------------------------------------------------------------------
GENINSERTproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;generated source file dialog.	 resource id=203
;callback for GENINSERT dialog box, called via IDM_GENINSERT.
;identifiers: preliminary text =101,
;ok button =105, cancel button =106.

    mov esi,pTERSEDATA

     .IF message==WM_INITDIALOG
       ;Preliminary source text...
       invoke SendDlgItemMessage,hdlg,101,EM_LIMITTEXT,2000,0 ;set limit.
       ;read current settings from database...
       lea eax,(TERSEDATA PTR [esi]).szgenprelim
       invoke SendDlgItemMessage,hdlg,101,WM_SETTEXT,0,eax

;;inline expansion...
;	mov al,(TERSEDATA PTR [esi]).inlinemode
;	.IF al==0
;	  invoke SendDlgItemMessage,hdlg,202,BM_SETCHECK,1,0
;	.ELSEIF al==1
;	  invoke SendDlgItemMessage,hdlg,203,BM_SETCHECK,1,0
;	.ELSEIF al==2
;	  invoke SendDlgItemMessage,hdlg,207,BM_SETCHECK,1,0
;	.ENDIF

;upload definitions of flags req'd by goosee...
       ;fASYNC flag...
       invoke SendDlgItemMessage,hdlg,112,EM_LIMITTEXT,46,0 ;set limit.
       lea eax,(TERSEDATA PTR [esi]).szfasync
       invoke SendDlgItemMessage,hdlg,112,WM_SETTEXT,0,eax
;	;fSTAY flag...
;	invoke SendDlgItemMessage,hdlg,114,EM_LIMITTEXT,46,0 ;set limit.
;	lea eax,(TERSEDATA PTR [esi]).szfstay
;	invoke SendDlgItemMessage,hdlg,114,WM_SETTEXT,0,eax


;upload indentation...
	mov al,(TERSEDATA PTR [esi]).nindentation
	.IF al==0
	  invoke SendDlgItemMessage,hdlg,214,BM_SETCHECK,1,0
	.ELSE
	  invoke SendDlgItemMessage,hdlg,215,BM_SETCHECK,1,0
	.ENDIF
	xor eax,eax
	mov al,(TERSEDATA PTR [esi]).nindentation
	invoke bin2dec		;eax-->asciitbl+0 to +9 (10 digits)
	lea  edi,szasciitbl
	    mov  al,[edi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  edi		;/
	      mov  al,[edi]	;/
	    .ENDW		;/
	invoke SendDlgItemMessage,hdlg,220,WM_SETTEXT,0,edi
	invoke SendDlgItemMessage,hdlg,220,EM_LIMITTEXT,1,0 ;set limit.

;290900
;option introduced to compose prototypes of public functions
;to separate header file...
	mov al,(TERSEDATA PTR [esi]).fcodeprefs
	and al,01	;extract bit0.
	.IF al==0	;default.
	  invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,1,0
	.ELSE
	  invoke SendDlgItemMessage,hdlg,224,BM_SETCHECK,1,0
	.ENDIF

;290900
;option introduced to compose header text to separate hdr file...
	mov al,(TERSEDATA PTR [esi]).fcodeprefs
	and al,010b	;extract bit1.
	.IF al==0	;default.
	  invoke SendDlgItemMessage,hdlg,225,BM_SETCHECK,1,0
	.ELSE
	  invoke SendDlgItemMessage,hdlg,226,BM_SETCHECK,1,0
	.ENDIF


	  mov  eax,TRUE		;return TRUE (non-zero).
     .ELSEIF message==WM_COMMAND
	  .IF  wparam==105		;ok button
	    mov  g_fhaschanged,1
;update the database...
 lea eax,(TERSEDATA PTR [esi]).szgenprelim
 invoke SendDlgItemMessage,hdlg,101,WM_GETTEXT,2001,eax

;;inline expansion...
;	invoke SendDlgItemMessage,hdlg,202,BM_GETCHECK,0,0
;	.IF ax==1
;	  mov (TERSEDATA PTR [esi]).inlinemode,0	;no inline expansion.
;	.ELSE
;	  invoke SendDlgItemMessage,hdlg,203,BM_GETCHECK,0,0
;	  .IF ax==1
;	    mov (TERSEDATA PTR [esi]).inlinemode,1	;1-ring nodes only.
;	  .ELSE
;	    mov (TERSEDATA PTR [esi]).inlinemode,2	;1- and 2-ring nodes.
;	  .ENDIF
;	.ENDIF

;get flag definitions...
 lea eax,(TERSEDATA PTR [esi]).szfasync
 invoke SendDlgItemMessage,hdlg,112,WM_GETTEXT,47,eax
; lea eax,(TERSEDATA PTR [esi]).szfstay
; invoke SendDlgItemMessage,hdlg,114,WM_GETTEXT,47,eax

;download indentation...
	  invoke SendDlgItemMessage,hdlg,214,BM_GETCHECK,0,0 ;tab char.
	  .IF ax==1
	    mov (TERSEDATA PTR [esi]).nindentation,0
	  .ELSE
	    mov szasciitbl,"0"
	    invoke SendDlgItemMessage,hdlg,220,WM_GETTEXT,2,ADDR szasciitbl+1
	    invoke str2longint, ADDR szasciitbl	;-->integer in eax
	    mov	(TERSEDATA PTR [esi]).nindentation,al
	  .ENDIF

;290900
;option introduced to compose prototypes of public functions
;to separate header file...
	  invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0 ;in same file.
	  .IF ax==1
	    and (TERSEDATA PTR [esi]).fcodeprefs,11111110b
	  .ELSE
	    or (TERSEDATA PTR [esi]).fcodeprefs,01  ;separate header file.
	  .ENDIF

;290900
;option introduced to compose header text to separate hdr file...
	  invoke SendDlgItemMessage,hdlg,225,BM_GETCHECK,0,0 ;in same file.
	  .IF ax==1
	    and (TERSEDATA PTR [esi]).fcodeprefs,11111101b
	  .ELSE
	    or (TERSEDATA PTR [esi]).fcodeprefs,010b  ;separate header file.
	  .ENDIF


	    invoke EndDialog, hdlg,TRUE
	    mov eax,TRUE
	  .ELSEIF wparam==104		;cancel button
	    invoke EndDialog, hdlg,TRUE
	    mov eax,TRUE
	  .ELSE
	    mov eax,FALSE
	  .ENDIF
     .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
     .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
     .ENDIF
	ret
GENINSERTproc ENDP

;--------------------------------------------------------------------------
str2longint  PROC STDCALL USES ebx ecx edx esi edi, lpstr2:DWORD
    LOCAL dummy:WORD
;enter with address of string. returns binary value in eax.
;this routine reads a "-" char and will convert to 2s-complement binary.
;***NOTE*** i haven't fully converted this from 16bit, just put
;a fix on the end to return eax.

	push ebp

	mov  esi,lpstr2
	xor  eax,eax

            xor ax,ax               ;DX:AX = 0
            xor bh,bh               ;BH = 0
            cwd
            mov cx,10               ;CX = 10

p1_ploop:   mov bl,[esi]	     ;Load char
	    inc esi
            cmp bl,' '              ;Loop while char is space
	    je p1_ploop 	    ;(20h, or 09h thru 0Dh)
	cmp  bl,"0"	;me
	je   p1_ploop	;/
            cmp bl,9
            jna p1_cont
            cmp bl,13
            jbe p1_ploop

p1_cont:    xor bp,bp               ;BP = 0
            cmp bl,'+'              ;If char = '+', ignore
            je p1_loop
            cmp bl,'-'              ;If char <> '-', keep it
            jne p1_skip
            inc bp                  ;Set negative flag

p1_loop:    mov bl,[esi]	     ;Load char
	    inc esi

p1_skip:    cmp bl,'9'              ;Not a digit, finish
            ja p1_finish
            sub bl,'0'
            jc p1_finish

            mul cx                  ;Multiply by 10
            add ax,bx               ;Add in digit...
            adc dl,dh
            jz p1_loop              ;Not a long yet, loop
            jmp p1_lload            ;Go into long loop

p1_lloop:   mov di,dx               ;DI = old hi word
            mov cx,10               ;Multiply old lo word by 10
            mul cx
            xchg dx,cx              ;CX = new hi word(1)
            xchg ax,di              ;DI = new lo word
            mul dx                  ;Multiply old hi word by 10
            xchg ax,dx              ;DX = new hi word(2)
            xchg ax,di              ;AX = new lo word
            add ax,bx               ;Add in digit
            adc dx,cx               ;DX:AX = new value

p1_lload:   mov bl,[esi]	     ;load char
	    inc esi

            cmp bl,'9'              ;Not a digit, finish
            ja p1_finish
            sub bl,'0'
            jnc p1_lloop            ;Jump to loop

p1_finish:  dec bp                  ;Positive, don't negate
            jl p1_done

            neg dx                  ;Negate the result
            neg ax
            sbb dx,0

p1_done:
	mov bx,ax   ;convert dx:ax to eax.
	mov ax,dx   ;/
	mov cl,16   ;/
	shl eax,cl   ;/
	mov ax,bx   ;/


	pop ebp

	ret
str2longint ENDP
;--------------------------------------------------------------------------
onanobject PROC  STDCALL USES edi esi ebx ecx edx,nmousex:DWORD,nmousey:DWORD
    LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
; "onanobject"
;called from wmlbuttondown(), state=0.
;also called from wmlbuttondown()/state=4.(placing 1st end new obj).
;returns eax=0 if mouse cursor not on an object, else eax pts to object.

;i would like to explicitly exclude g_pmovingobject (if non0)
;as when placing new child objects, i want to test if it is placed
;on top of an existing object...

	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp nextobjy
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	.IF ax==01	;bit0=1, valid object.
	  mov ax,(OBJECT PTR [esi]).nexttype
	  .IF ax==-1
	  .ELSE		;not a data object.
	    .IF esi==g_pmovingobject	;exclude this from search.
	    .ELSE
	      ;finally, call the method test if mouse an an object...
	      mov	ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	      ;(relative to "ptrs", which is start of the methods table)
	      invoke onPTR PTR [ebx+ptrs+ponobject], esi,nmousex,nmousey
	      ;returns eax=0 fail, else eax pts to object.
	      .IF eax==0
	      .ELSE
		jmp getout
	      .ENDIF
	    .ENDIF
	  .ENDIF
	.ENDIF
	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop nextobj
nextobjy:
    mov eax,0	    ;fail.

getout:

  ret
onanobject ENDP
;--------------------------------------------------------------------------
.DATA
szextern2  BYTE "extern",0
szpublic   BYTE "public",0
szptr	   BYTE "PTR",0
szstruc    BYTE " ",149,0,0
szarray    BYTE "[ ]",0
szgen	   BYTE "GEN",0
szequals   BYTE "=",0

.CODE
paint_res	PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL xright:SDWORD
	LOCAL ybottom:SDWORD
	LOCAL xleft:SDWORD
	LOCAL ytop:SDWORD
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL xend1:SDWORD, yend1:SDWORD
	LOCAL state:BYTE
	LOCAL hpenold:DWORD, holdfont:DWORD
	LOCAL fchildres:BYTE, textrect:RECT
	LOCAL hbrushnewcolor:DWORD,hbrusholdcolor:DWORD
;this is a method, to display resources.      "paint_res"
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;ANY CODE INSERTED BELOW SHOULD TEST "STATE", not g_nstate.
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF


      mov esi,pobject

;determine if this resource is a child of another resource...
    mov fchildres,0
    mov eax,(OBJECT PTR [esi]).rplock1
    add eax,pTERSEDATA
    mov ebx,eax
    mov ax,(OBJECT PTR [ebx]).nexttype
    .IF ax==3
      mov fchildres,1
    .ELSEIF ax==4
      mov fchildres,1
    .ENDIF

;dimensions for basic data element... (private)
      mov eax,(OBJECT PTR [esi]).wwidth
      add eax,(OBJECT PTR [esi]).xtopleft
      mov xright,eax
      mov ebx,(OBJECT PTR [esi]).height
      add ebx,(OBJECT PTR [esi]).ytopleft
      mov ybottom,ebx
      mov eax,(OBJECT PTR [esi]).xtopleft
      mov xleft,eax
      mov eax,(OBJECT PTR [esi]).ytopleft
      mov ytop,eax

;171200
	    .IF g_fredrawdiag==WIPEOUTobjs
	      ;xpaint_wipeout has already activate white brush.
		      mov hbrusholdcolor,0
		      mov hbrushnewcolor,0
	    .ELSE
	      ;xpaint_entire,_update,_print activate a null-brush.
	      ;but if need color fill...
		    mov al,(OBJECT PTR [esi]).fconfig
		    and al,0100b    ;bit2=1 turn on colour.
		    .IF al==0100b
		      mov eax,(OBJECT PTR [esi]).ncolour1
		      invoke CreateSolidBrush, eax
		      mov hbrushnewcolor,eax
		      invoke SelectObject, hdc,hbrushnewcolor
		      mov hbrusholdcolor,eax
		    .ELSE
		      mov hbrusholdcolor,0
		      mov hbrushnewcolor,0
		    .ENDIF
	    .ENDIF


;draw private data...
;we draw this basic box for all data objects, and a black pen
;is private/permanent, .nexttype=3/.fconfig/bits6/5=0/0.
;however, a private/temporary data object, .nexttype=3/
;.fconfig/bits6/5=0/1, displays as grey pen...
  mov ax,(OBJECT PTR [esi]).nexttype
  .IF ax==03	;private.
    mov al,(OBJECT PTR [esi]).fconfig
    and al,01100000b	;extract bits 6/5
    .IF al==0		;private permanent (static)
we2:	invoke Rectangle, hdc, xleft,ytop, xright,ybottom
    .ELSEIF al==0100000b	;private temporary.
      ;we want to avoid selecting pens/brushes/fonts inside
      ;paint_ methods, but necessary here.
      ;however, don't if doing a wipeout...
      .IF g_fredrawdiag==WIPEOUTobjs
	jmp we2
      .ELSE
	;a grey pen is created in wmpaint(), so can select it here...
	invoke SelectObject, hdc, g_hpengrey
	mov hpenold,eax
	invoke Rectangle, hdc, xleft,ytop, xright,ybottom
	invoke SelectObject, hdc, hpenold
     .ENDIF
    .ENDIF
  .ENDIF

;draw global data...
;global data has .nexttype=4. .fconfig/bits6/5=0/0 =shareable
;permanent. .fconfig/bits6/5=0/1 =task-visible permanent.
;.fconfig/bits6/5=1/0 =global visible permenent.
  mov ax,(OBJECT PTR [esi]).nexttype
  .IF ax==04	;global
    mov al,(OBJECT PTR [esi]).fconfig
    and al, 11100000b	;extract bits 7/6/5
    .IF al==10000000b	;6/5=0/0, bit7=1 is shareable-temporary.
      .IF g_fredrawdiag==WIPEOUTobjs
	jmp sa1 	;don't use grey pen, as wiping.
      .ELSE
	;a grey pen is created in wmpaint(), so can select it here...
	invoke SelectObject, hdc, g_hpengrey
	mov hpenold,eax
	mov eax,xleft	;draw another box slightly larger
	dec eax		;(get effect of two boxes, space between)
	dec eax
	mov ebx,ytop
	dec ebx
	dec ebx
	mov ecx,xright
	inc ecx
	inc ecx
	mov edx,ybottom
	inc edx
	inc edx
	invoke Rectangle, hdc, eax,ebx, ecx,edx
	invoke Rectangle, hdc, xleft,ytop, xright,ybottom
	invoke SelectObject, hdc, hpenold
      .ENDIF
    .ELSE
    .ENDIF
    mov al,(OBJECT PTR [esi]).fconfig
    and al,011100000b	;extract bits 7/6/5
    .IF al==0		;shareable permanent.
sa1:	mov eax,xleft	;draw another box slightly larger
	dec eax		;(get effect of two boxes, space between)
	dec eax
	mov ebx,ytop
	dec ebx
	dec ebx
	mov ecx,xright
	inc ecx
	inc ecx
	mov edx,ybottom
	inc edx
	inc edx
	invoke Rectangle, hdc,eax,ebx,ecx,edx
	invoke Rectangle, hdc, xleft,ytop, xright,ybottom
    .ELSEIF al==0100000b  ;task-global perm. (file visible)
tsk1:	mov eax,xleft	;draw another box slightly larger
	dec eax		;(get effect of two boxes, space between)
	dec eax
	mov ebx,ytop
	dec ebx
	dec ebx
	mov ecx,xright
	inc ecx
	inc ecx
	mov edx,ybottom
	inc edx
	inc edx
	invoke Rectangle, hdc,eax,ebx,ecx,edx
	  mov eax,xleft
	  dec eax		;
	  mov ebx,ytop
	  dec ebx
	  mov ecx,xright
	  inc ecx
	  mov edx,ybottom
	  inc edx
	  invoke Rectangle, hdc,eax,ebx,ecx,edx
	invoke Rectangle, hdc, xleft,ytop, xright,ybottom
    .ELSEIF al==1000000b  ;global over files. perm. (public)
      jmp tsk1
    .ENDIF
  .ENDIF

;061200
;generic data...
      mov cl,(OBJECT PTR [esi]).fstatus2
      and cl,11100000b
      .IF cl==10000000b ;generic data.
	mov cl,(OBJECT PTR [esi]).fconfig3
	and cl,011b
	.IF cl==011b  ;global generic data.
kks:	  mov eax,xleft	;draw another box slightly smaller.
	  inc eax
	  mov ebx,ytop
	  inc ebx
	  mov ecx,xright
	  dec ecx
	  mov edx,ybottom
	  dec edx
	  invoke Rectangle, hdc, eax,ebx, ecx,edx
	.ELSEIF cl==010b ;compose before func.
	  jmp kks
	.ENDIF
      .ENDIF

;171200
	.IF hbrushnewcolor==0
	.ELSE
	  invoke SelectObject, hdc, hbrusholdcolor
	  invoke DeleteObject, hbrushnewcolor
	.ENDIF

;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 invoke CreateRectRgn, xleft,ytop, xright,ybottom	  ;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...
	mov esi,pobject
	mov eax,(OBJECT PTR [esi]).xtopleft	    ;display text in res
	add eax,28 ;26 ;2     ; 13-1-00
        mov ebx,(OBJECT PTR [esi]).ytopleft           ;/
        mov ecx,(OBJECT PTR [esi]).height             ;/
	sar ecx,1				   ;/
      add ebx,ecx                                   ;/
	sub ebx,8 ;7 12-1-00
;offset text, from OBJECT.x/ylabeloffset ....
	mov ecx,eax
	mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	cwde		;sign-extends ax -->eax.
	add ecx,eax	;new x-coord.
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov eax,ecx	;restore ax=x-coord

  xor ecx,ecx
  mov cl,(OBJECT PTR [esi]).fstatus
  and cx,00100000b  ;extract bit 5
  .IF cl==00100000b   ;display label
    .IF fchildres==0  ;parent is not a resource.
      mov cl,(OBJECT PTR [esi]).fstatus2
      and cl,11100000b
      .IF cl==10000000b ;generic data.
	jmp jja
      .ENDIF
      lea edx,(OBJECT PTR [esi]).sztext1
    .ELSE
      ;for child-array/structure of a resource, display datatype, not name...
      mov cl,(OBJECT PTR [esi]).fstatus2
      and cl,11100000b
      .IF cl==01100000b     ;array
	xor ecx,ecx
	mov cl,(OBJECT PTR [esi]).ndatatype
	.IF cl==0
	  jmp tt1
	.ELSE
	  dec ecx
	  push eax
	  push ebx
	  push edi
	  mov eax,ecx
	  and  al,0Fh
	  mov ebx,48
	  mul ebx
	  mov edi,pTERSEDATA
	  lea ebx,(TERSEDATA PTR [edi]).sztype1
	  add eax,ebx	;now have addr of correct data type.
	  mov edx,eax
	  pop edi
	  pop ebx
	  pop eax
	.ENDIF
      .ELSEIF cl==01000000b ;structure also.
	xor ecx,ecx
	mov cl,(OBJECT PTR [esi]).ndatatype
	.IF cl==0
	  jmp tt1
	.ELSE
	  dec ecx
	  push eax
	  push ebx
	  push edi
	  mov eax,ecx
	  and  al,0Fh
	  mov ebx,48
	  mul ebx
	  mov edi,pTERSEDATA
	  lea ebx,(TERSEDATA PTR [edi]).szptrtype1
	  add eax,ebx	;now have addr of correct data type.
	  mov edx,eax
	  pop edi
	  pop ebx
	  pop eax
	.ENDIF
      .ELSEIF cl==10000000b ;generic data.
jja:	lea edx,(OBJECT PTR [esi]).sztext1
	sub eax,14  ;x-coord.
      .ELSE
	jmp SHORT tt1
      .ENDIF
    .ENDIF
    invoke TEXTOUTx, hdc,eax,ebx,edx,62	;/
  .ELSE     ;don't display label.
      mov cl,(OBJECT PTR [esi]).fstatus2
      and cl,11100000b
      .IF cl==10000000b ;generic data.
	mov cl,(OBJECT PTR [esi]).fstatus
	and cl,01000000b	;extract bit 6
	.IF cl==01000000b	;display data declaration.
	  ;this can be multiline...
	  lea edx,(OBJECT PTR [esi]).sztext5
	  sub eax,14	;x-coord.
	  mov textrect.rc_left,eax
	  mov textrect.rc_top,ebx
	  ;invoke TEXTOUTx, hdc,eax,ebx,edx,894
	  invoke DrawText, hdc,edx,-1,ADDR textrect,DT_CALCRECT
	  lea edx,(OBJECT PTR [esi]).sztext5
	  invoke DrawText, hdc,edx,-1,ADDR textrect,DT_NOCLIP+DT_NOPREFIX
	.ENDIF
      .ENDIF
  .ENDIF
  ;note display initial value is further down.
tt1:

;now draw a line from resource to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if cmt locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE
	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of resource.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
	  ;as these coords outside node, snap_tonode() will return
	  ;xend/yend snapped to outermost ring. however for non-concentric
	  ;rings want to snap to ring 1...
	  mov edi,plock
	  mov ax,(OBJECT PTR [edi]).nexttype
	  .IF ax==0 ;node.
	    mov eax,(OBJECT PTR [edi]).xdeltacentre
	    .IF eax==0	;no x-offset of rings.
	      mov eax,(OBJECT PTR [edi]).ydeltacentre
	      .IF eax==0
		;rings are concentric...
	      .ELSE
jjt:		;rings non-concentric...
		mov g_nsnapring,1
		;...global variable, used by snap_tonode(), forces
		;snap to that ring. (default is g_nsnapring=0).
	      .ENDIF
	    .ELSE
	      jmp jjt
	    .ENDIF
	  .ENDIF
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  ;mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.
      ;now draw line...
	  ;aah, except also want line at "this end" to be on boundary...
		  mov eax,xend
		  mov xend1,eax
		  mov eax,yend
		  mov yend1,eax
		  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	invoke snapPTR PTR [ebx+ptrs+psnap], esi,ADDR xend1,ADDR yend1
      ;NOW can draw line...
      ;but don't if resource is shareable...
      mov ax,(OBJECT PTR [esi]).nexttype
      .IF ax==4     ;global data resource.
	mov al,(OBJECT PTR [esi]).fconfig
	and al,01100000b
	.IF al==0	;shareable
	.ELSE
do8:	  invoke MoveToEx, hdc, xend1,yend1,0
	  invoke LineTo, hdc, xend,yend
	.ENDIF
      .ELSE
	jmp do8
      .ENDIF
    .ENDIF


    .IF state==4
;    .ELSEIF state==5
    .ELSE
      ;must always use standard font size...
      invoke SelectObject, hdc, g_hfontx1x  ;g_hfontx1 12-1-00
      mov holdfont,eax

;if data is externally-declared, put "extern" above box...
      xor eax,eax
      mov al,(OBJECT PTR [esi]).fstatus
      and ax,0100b    ;bit2=1, external.
      .IF ax==0100b
	lea eax,szextern2
	mov ebx,ytop
	sub ebx,14 ;13 12-1-00
	mov ecx,xleft
	sub ecx,2
	invoke TEXTOUTx, hdc, ecx,ebx, eax,6
      .ELSE
;if data is public, put "public" above box (extern always overrides)...
	mov ax,(OBJECT PTR [esi]).nexttype
	.IF ax==4   ;global data.
	  mov al,(OBJECT PTR [esi]).fconfig
	  and al,011100000b ;extract bits 7/6/5.
	  .IF al==01000000b ;global (public)
	    lea eax,szpublic
	    mov ebx,ytop
	    sub ebx,14 ;13  12-1-00
	    mov ecx,xleft
	    sub ecx,2
	    invoke TEXTOUTx, hdc, ecx,ebx, eax,6
	  .ENDIF
	.ENDIF
      .ENDIF
      invoke SelectObject, hdc,holdfont

      ;use standard size courier font...
      invoke SelectObject, hdc, g_hfontx1
      mov holdfont,eax
;want to display data-type inside box (label is on right side)...
      ;it depends on variable type...
      mov al,(OBJECT PTR [esi]).fstatus2
      and al,11100000b
      .IF al==0 	;simple variable
	mov al,(OBJECT PTR [esi]).ndatatype
	and al,0Fh			;lower 4 bits only.
	.IF al==0Fh		;pointer datatype.
	  xor  eax,eax
	  mov  al,(OBJECT PTR [esi]).nptrtype
	  and  al,0Fh
	  mov ebx,48
	  mul ebx
	  mov edi,pTERSEDATA
	  lea ebx,(TERSEDATA PTR [edi]).szptrtype1
	  add eax,ebx	;now have addr of correct data type.
	.ELSE
	  xor  eax,eax
	  mov  al,(OBJECT PTR [esi]).ndatatype
	  and  al,0Fh
	  mov ebx,48
	  mul ebx
	  mov edi,pTERSEDATA
	  lea ebx,(TERSEDATA PTR [edi]).sztype1
	  add eax,ebx	;now have addr of correct data type.
	.ENDIF
	mov ebx,ytop
	; inc ebx  12-1-00
	dec ebx	; 13-1-00
	mov edx,xleft
	inc edx
	inc edx	; 12-1-00
	invoke TEXTOUTx, hdc, edx,ebx, eax,3
      .ELSEIF al==00100000b ;pointer
	lea eax,szptr
pt1:	mov ebx,ytop
	dec ebx
	mov edx,xleft
	inc edx
	inc edx
	invoke TEXTOUTx, hdc, edx,ebx, eax,3
      .ELSEIF al==01000000b ;structure
	lea eax,szstruc
	jmp pt1
      .ELSEIF al==01100000b ;array
	lea eax,szarray
	jmp pt1
      .ELSEIF al==10000000b ;generic data
;	lea eax,szgen
;	jmp pt1
      .ENDIF

      mov cl,(OBJECT PTR [esi]).fstatus2
      and cl,11100000b
      .IF cl==10000000b ;generic data.
	;.fstatus/bit6 used for displaying data-declaration,
	;which already done above.
      .ELSE
	xor ecx,ecx
	mov cl,(OBJECT PTR [esi]).fstatus
	and cl,01000000b	;extract bit 6
	.IF cl==01000000b	;display initial value.
	  lea eax,szequals
	  mov ebx,ybottom
	  sub ebx,2 ;3
	  mov ecx,xleft
	  add ecx,2
	  invoke TEXTOUTx, hdc, ecx,ebx, eax,1
	  lea eax,(OBJECT PTR [esi]).sztext2
	  mov ebx,ybottom
	  sub ebx,2 ;3
	  mov ecx,xleft
	  add ecx,8
	  invoke TEXTOUTx, hdc, ecx,ebx, eax,126
	.ENDIF
      .ENDIF

      invoke SelectObject, hdc,holdfont

    .ENDIF



    ret
paint_res ENDP
;--------------------------------------------------------------------------
.DATA
szio  BYTE "i/o",0
.CODE
paint_hard	PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL xright:SDWORD
	LOCAL ybottom:SDWORD
	LOCAL xleft:SDWORD
	LOCAL ytop:SDWORD
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL xend1:SDWORD, yend1:SDWORD
	LOCAL state:BYTE
	LOCAL xdiffnormsave:DWORD, ydiffnormsave:DWORD
	LOCAL holdfont:DWORD
; "paint_hard"
;this is a method, to display hardware. almost same as paint_res().
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;the default hardware object has .fextype=09. it's dialog box will
;configure for other types. interrupt-type has .nexttype=51.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;ANY CODE INSERTED BELOW SHOULD TEST "STATE", not g_nstate.
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF


      mov esi,pobject

;dimensions for basic data element... (private)
      mov eax,(OBJECT PTR [esi]).wwidth
      add eax,(OBJECT PTR [esi]).xtopleft
      mov xright,eax
      mov ebx,(OBJECT PTR [esi]).height
      add ebx,(OBJECT PTR [esi]).ytopleft
      mov ybottom,ebx
      mov eax,(OBJECT PTR [esi]).xtopleft
      mov xleft,eax
      mov eax,(OBJECT PTR [esi]).ytopleft
      mov ytop,eax

;draw private data...
;Note, this code is the same as for paint_res -- data objects have
;.nexttype =3 =private, =4 =global, whereas hardware objects
;use 50 and 51.  Also hardware cannot have temporary (grey pen).
;we draw this basic box for all data objects, and a black pen
;is private/permanent, .nexttype=50/.fconfig/bits6/5=0/0.
  mov ax,(OBJECT PTR [esi]).nexttype
  .IF ax==50	;private.
    mov al,(OBJECT PTR [esi]).fconfig
    and al,01100000b	;extract bits 6/5
    .IF al==0		;private permanent (static)
we2:	invoke Rectangle, hdc, xleft,ytop, xright,ybottom
    .ELSEIF al==0100000b	;private temporary.
      ;ERROR. shouldnever be here.
      jmp we2
    .ENDIF
  .ENDIF

;draw global data...
;global data has .nexttype=51. .fconfig/bits6/5=0/0 =shareable
;permanent. .fconfig/bits6/5=0/1 =task-visible permanent.
;.fconfig/bits6/5=1/0 =global visible permenent.
  mov ax,(OBJECT PTR [esi]).nexttype
  .IF ax==51	;global
    mov al,(OBJECT PTR [esi]).fconfig
    and al, 11100000b	;extract bits 7/6/5
    .IF al==10000000b	;6/5=0/0, bit7=1 is shareable-temporary.
      ;ERROR. hardware object cant be temp. should never come here.
      jmp SHORT sa1
    .ELSE
    .ENDIF
    mov al,(OBJECT PTR [esi]).fconfig
    and al,01100000b	;extract bits 6/5
    .IF al==0		;shareable permanent.
sa1:	mov eax,xleft	;draw another box slightly larger
	dec eax		;(get effect of two boxes, space between)
	dec eax
	mov ebx,ytop
	dec ebx
	dec ebx
	mov ecx,xright
	inc ecx
	inc ecx
	mov edx,ybottom
	inc edx
	inc edx
	invoke Rectangle, hdc,eax,ebx,ecx,edx
	invoke Rectangle, hdc, xleft,ytop, xright,ybottom
    .ELSEIF al==0100000b  ;task-global perm. (file)
tsk1:	mov eax,xleft	;draw another box slightly larger
	dec eax		;(get effect of two boxes, space between)
	dec eax
	mov ebx,ytop
	dec ebx
	dec ebx
	mov ecx,xright
	inc ecx
	inc ecx
	mov edx,ybottom
	inc edx
	inc edx
	invoke Rectangle, hdc,eax,ebx,ecx,edx
	  mov eax,xleft
	  dec eax		;
	  mov ebx,ytop
	  dec ebx
	  mov ecx,xright
	  inc ecx
	  mov edx,ybottom
	  inc edx
	  invoke Rectangle, hdc,eax,ebx,ecx,edx
	invoke Rectangle, hdc, xleft,ytop, xright,ybottom
    .ELSEIF al==1000000b  ;global over files. perm.  (public)
      jmp tsk1
    .ENDIF
  .ENDIF

;no, i've set it as red-fill in defaultnewhardware().
;;this is a hardware object (i/o) so need to identify box as different...
;;draw two diagonals...
;  mov ebx,xleft
;  add ebx,4
;  push ebx
;  invoke MoveToEx, hdc, ebx,ytop,0
;  mov eax,xright
;  sub eax,4
;  push eax
;  invoke LineTo,   hdc, eax,ybottom
;  pop	eax
;  invoke MoveToEx, hdc, eax,ytop,0
;  pop	ebx
;  invoke LineTo,   hdc, ebx,ybottom


;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 invoke CreateRectRgn, xleft,ytop, xright,ybottom	  ;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...
	mov esi,pobject
	mov eax,(OBJECT PTR [esi]).xtopleft	    ;display text in res
	add eax,28 ;26 ;2	  ; 13-1-00
        mov ebx,(OBJECT PTR [esi]).ytopleft           ;/
        mov ecx,(OBJECT PTR [esi]).height             ;/
	sar ecx,1				   ;/
      add ebx,ecx                                   ;/
	sub ebx,8 ;7  12-1-00
;offset text, from OBJECT.x/ylabeloffset ....
	mov ecx,eax
	mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	cwde		;sign-extends ax -->eax.
	add ecx,eax	;new x-coord.
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov eax,ecx	;restore ax=x-coord

  xor ecx,ecx
  mov cl,(OBJECT PTR [esi]).fstatus
  and cx,01100000b  ;extract bits 5/6
  .IF cl==00100000b   ;display label
	lea edx,(OBJECT PTR [esi]).sztext1
	 invoke TEXTOUTx, hdc,eax,ebx,edx,62	;/
  .ENDIF


;now draw a line from resource to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if cmt locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE
	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of resource.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.
	;...snap_ method also sets global g_xdiffnorm/g_ydiffnorm, used by
	;draw1starrow() and draw2ndarrow().
	;i need to save these, because snapping source-end below will
	;overwrite them...
	mov eax,g_xdiffnorm
	mov xdiffnormsave,eax
	mov eax,g_ydiffnorm
	mov ydiffnormsave,eax
      ;now draw line...
	  ;aah, except also want line at "this end" to be on boundary...
		  mov eax,xend
		  mov xend1,eax
		  mov eax,yend
		  mov yend1,eax
		  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
	invoke snapPTR PTR [ebx+ptrs+psnap], esi,ADDR xend1,ADDR yend1
      ;NOW can draw line...
      ;but don't if resource is shareable...
      mov ax,(OBJECT PTR [esi]).nexttype
      .IF ax==51    ;global hardware res.
	mov al,(OBJECT PTR [esi]).fconfig
	and al,01100000b
	.IF al==0	;shareable
	.ELSE
do7:	  invoke MoveToEx, hdc, xend1,yend1,0
	  invoke LineTo, hdc, xend,yend
	.ENDIF
      .ELSE
	jmp do7
      .ENDIF
    .ENDIF

;some types of hardware objects will need embellishments on the wire.
;hardware interrupt object is .nexttype=50 or 51, .nfunctype =1.
;Note that it is also
;possible to draw a separate wire of interrupt-type -- this wire
;has .nexttype=17.
;anyway, determine if current object needs wire-embellishment, and
;draw an arrowhead...
	mov eax,xdiffnormsave
	mov g_xdiffnorm,eax
	mov eax,ydiffnormsave
	mov g_ydiffnorm,eax
  .IF state==4
  .ELSEIF state==5
  .ELSE
	mov eax,1 ;actually, draw2ndarrow doesn't use thisparam.
	invoke draw2ndarrow, hdc,plock,xend,yend,eax,esi
	;(plock=addr of parent node, eax=ring#, esi=addr of wire)
	;(the last line drawn will be to back of arrow)
  .ENDIF

    .IF state==4
    .ELSEIF state==5
    .ELSE
      ;always use standard font...
      invoke SelectObject, hdc,g_hfontx1x  ;g_hfontx1  12-1-00
      mov holdfont,eax

;if hardware-data is externally-declared, put "extern" above box...
      xor eax,eax
      mov al,(OBJECT PTR [esi]).fstatus
      and ax,0100b    ;bit2=1, external.
      .IF ax==0100b
	lea eax,szextern2
	mov ebx,ytop
	sub ebx,14 ;13	12-1-00
	mov ecx,xleft
	sub ecx,2
	invoke TEXTOUTx, hdc, ecx,ebx, eax,6
      .ELSE
;if data is public, put "public" above box (extern always overrides)...
	mov ax,(OBJECT PTR [esi]).nexttype
	.IF ax==51   ;global hardware.
	  mov al,(OBJECT PTR [esi]).fconfig
	  and al,011100000b ;extract bits 7/6/5.
	  .IF al==01000000b ;global (public)
	    lea eax,szpublic
	    mov ebx,ytop
	    sub ebx,14 ;13  12-1-00
	    mov ecx,xleft
	    sub ecx,2
	    invoke TEXTOUTx, hdc, ecx,ebx, eax,6
	  .ENDIF
	.ENDIF
      .ENDIF

;want to display "I/O" underneath the box...
	lea eax,szio
	mov ebx,ybottom
	sub ebx,4 ;3 ;2  12-1-00
	mov ecx,xleft
	add ecx,2
	invoke TEXTOUTx, hdc, ecx,ebx, eax,3

      invoke SelectObject, hdc,holdfont

;want to display data-type inside box (label is on right side)...
      mov al,(OBJECT PTR [esi]).ndatatype
      and al,0Fh			;lower 4 bits only.
      .IF al==0Fh		;pointer datatype.
	xor  eax,eax
	mov  al,(OBJECT PTR [esi]).nptrtype
	and  al,0Fh
	mov ebx,48
	mul ebx
	mov edi,pTERSEDATA
	lea ebx,(TERSEDATA PTR [edi]).szptrtype1
	add eax,ebx	;now have addr of correct data type.
      .ELSE
	xor  eax,eax
	mov  al,(OBJECT PTR [esi]).ndatatype
	and  al,0Fh
	mov ebx,48
	mul ebx
	mov edi,pTERSEDATA
	lea ebx,(TERSEDATA PTR [edi]).sztype1
	add eax,ebx	;now have addr of correct data type.
      .ENDIF
      mov ebx,ytop
      ; inc ebx  12-1-00
      dec ebx	; 13-1-00
      mov edx,xleft
      inc edx
      inc edx	; 12-1-00
      invoke TEXTOUTx, hdc, edx,ebx, eax,3


    .ENDIF


    ret
paint_hard ENDP
;--------------------------------------------------------------------------
isitreturnwire PROC STDCALL USES edi esi ebx ecx edx,pwire:DWORD
    LOCAL pnodepathend:DWORD
    LOCAL pparent:DWORD
; "isitreturnwire"
;called from paint-arc() when a difference is found between color
;of wire and that of ring-1 of dest-node, for case of wire going
;to ring-1.
;return eax=1 if wire is execution-flow 1-way return-to-node of
;an execution path out of a ring>1 of a node. else eax=0.

    mov esi,pwire

    mov ax,(OBJECT PTR [esi]).nexttype
    cmp ax,10	    ;precaution.
    jne ret0	    ;/
    mov eax,(OBJECT PTR [esi]).rplock2 ;node at end of path.
    add eax,pTERSEDATA
    mov pnodepathend,eax

loop0:
    mov eax,(OBJECT PTR [esi]).rplock1	;node that wire comes from
    add eax,pTERSEDATA
    mov pparent,eax
    cmp eax,pnodepathend
    je ret1		;beginning of path found.

    ;pparent-->parent-node, find exec-flow i/p to ring-1.
    ;return esi-->found wire, eax=# wires found...
    ;(2nd param =0, not used in findinnerinwire())
    invoke findinnerinwire, pparent,0	 ;**func is in GOO2C.ASM**
    cmp eax,0
    je	ret0		;no i/p wire found.
    jmp loop0


ret1:	mov eax,1
	ret
ret0:	mov eax,0
	ret
isitreturnwire ENDP
;--------------------------------------------------------------------------
.DATA	  ;bezier experiment for drawing a wire...
bez1	POINT <0,0> ;x5/y5, loaded in draw1starrow()
bez2	POINT <0,0> ;x4/y4,  "
bez3	POINT <0,0> ;xknee2/yknee2, loaded in paint_arc
bez4	POINT <0,0> ;xmid/ymid,      "
bez5	POINT <0,0> ;xknee3/yknee3,  "
bez6	POINT <0,0> ;x4/y4, loaded in draw2ndarrow()
bez7	POINT <0,0> ;s5/y5,  "
szinter BYTE "inter-task",0

.CODE
paint_arc PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL xright:SDWORD
	LOCAL ybottom:SDWORD
	LOCAL xleft:SDWORD
	LOCAL ytop:SDWORD
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL xend1:SDWORD, yend1:SDWORD
	LOCAL xstart:SDWORD, ystart:SDWORD
	LOCAL state:BYTE
	LOCAL hfontsave:DWORD, hpendefault:DWORD, hpensave:DWORD
	LOCAL ncolorring:BYTE
;  "paint_arc"
;this is a method, to display wires. it differs from displaying
;nodes/resources mainly in that .wwidth/.height is actually coords
;of other end of wire.
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;note that state4 is when placing 1st end of a wire, state5 placing
;second end. a problem is that this wire can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore code below handling states4/5...
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF

      mov esi,pobject
      mov hpendefault,0


;011000
	  mov ebx,pTERSEDATA
	  mov al,(TERSEDATA PTR [ebx]).fviewprefs
	  and al,010b	;bit1=1 white space either side act,cond,wires.
	  jz bypass5white
  cmp state,4	    ;placing 1st end wire.
  je  xbypass ;bypass5white	;don't draw thick background white wire.
    ;...arrows not yet drawn, so bezier pts not all calc'd
  cmp state,5	    ;placing 2nd end wire.
  jne nobypass
    ;normally will bypass color-coding also, but end of wire gets
    ;placed and painted while still in state=5, so dest-node can miss
    ;out on getting repainted (with new ring colors)...
    mov eax,(OBJECT PTR [esi]).rplock2
    cmp eax,0
    je	xbypass     ;wire dest bezier points not yet calc'd.
    jmp	zbypass     ;paint colors.
nobypass:
;draw white either side of wire (for crossing over rings)...
;load the bezier points. they are saved in the wire...
;(future, can use saved bezier pts for quicker redraw of wire, as
; recalc them every time below)
  mov eax,(OBJECT PTR [esi]).xknee2
  mov bez3.pt_x,eax
  mov eax,(OBJECT PTR [esi]).yknee2
  mov bez3.pt_y,eax
  mov eax,(OBJECT PTR [esi]).xmid
  mov bez4.pt_x,eax
  mov eax,(OBJECT PTR [esi]).ymid
  mov bez4.pt_y,eax
  mov eax,(OBJECT PTR [esi]).xknee3
  mov bez5.pt_x,eax
  mov eax,(OBJECT PTR [esi]).yknee3
  mov bez5.pt_y,eax
  mov eax,(OBJECT PTR [esi]).bez1x
  mov bez1.pt_x,eax
  mov eax,(OBJECT PTR [esi]).bez1y
  mov bez1.pt_y,eax
  mov eax,(OBJECT PTR [esi]).bez2x
  mov bez2.pt_x,eax
  mov eax,(OBJECT PTR [esi]).bez2y
  mov bez2.pt_y,eax
  mov eax,(OBJECT PTR [esi]).bez6x
  mov bez6.pt_x,eax
  mov eax,(OBJECT PTR [esi]).bez6y
  mov bez6.pt_y,eax
  mov eax,(OBJECT PTR [esi]).bez7x
  mov bez7.pt_x,eax
  mov eax,DWORD PTR (OBJECT PTR [esi]).nfunctype ;bez7y
  mov bez7.pt_y,eax
    invoke SelectObject, hdc,g_hpenwhite5
    mov hpensave,eax
    invoke PolyBezier, hdc,ADDR bez1,7
    invoke SelectObject, hdc,hpensave
bypass5white:


;031000
;optional color-coding of rings...
zbypass:
      ;mov eax,(OBJECT PTR [esi]).rplock2
      ;.IF eax==0	;element doesn't have dest-parent yet.
      ;		  ;...(could have tested for state==4/5 placing new element)
      ;		  ;...abovecode bypasses here for states4/5 anyway.
      ;.ELSE
	mov eax,(OBJECT PTR [esi]).rplock1   ;begin-parent.
	cmp eax,0
	je  mono1  ;precaution.
	add eax,pTERSEDATA	;absolute addr begin-node.
	mov edi,eax
;	mov ebx,pTERSEDATA
;	mov al,(TERSEDATA PTR [ebx]).fviewprefs
;	and al,01	;bit0=1 color coded rings.
;	jz mono1
	cmp g_fredrawdiag,WIPEOUTobjs
	je mono1
	mov ax,(OBJECT PTR [esi]).nexttype
	cmp ax,10	;execution-flow 1-way
	je  okay1
	cmp ax,11	; " 2-way
	je  okay1
	cmp ax,12	; "
	jne mono1
okay1:	  ;use color of ring attached to...
	  ;(edi set above to begin-parent, esi current wire-element)
	  mov al,(OBJECT PTR [edi]).nring1colorindex
	  add al,(OBJECT PTR [esi]).nbeginring ;which ring attached to.
	  dec al
	  mov ncolorring,al
	  mov (OBJECT PTR [esi]).nring1colorindex,al ;set this element.
	    mov eax,(OBJECT PTR [esi]).rplock2
	    cmp eax,0
	    je bydest	 ;dest-end not yet set.(could be still in state=5
	      ; and dest-node is set)
	    ;if wire is 1-way exec-flow return-wire of a path out of
	    ;node, wire.fconfig2/bit2 will be set (so leave node color
	    ;alone)...
	    mov al,(OBJECT PTR [esi]).fconfig2
	    and al,0100b	;bit2
	    cmp al,0100b
	    je bydest
	      ;also set color of destination-node...
		mov ebx,(OBJECT PTR [esi]).rplock1
		mov edi,(OBJECT PTR [esi]).rplock2
		.IF ebx==edi  ;wire loops back to same node.
		.ELSEIF state==5 ;problem, .nendring not yet set.
		    ;051000 lbuttonup() now sets state=0 in state=5
		    ;and dest-end placed, then generates a wmpaint,
		    ;so never gets here.
		  ;push eax
		  ;invoke InvalidateRgn, g_hwnd,0,FALSE
		  add edi,pTERSEDATA
		  invoke add2updatelist, esi ;redraw the wire.
		  ;invoke add2updatelist,edi  ;redraw the dest-node.
		  mov g2_fredrawdiag,UPDATEobjs
		   ;...wmpaint() will reload g_fredrawdiag.
		  ;pop eax
		.ELSE
		  mov al,ncolorring
		  mov bl,(OBJECT PTR [esi]).nendring
		  .IF bl==1	;wire goes to ring1 of node.
		    add edi,pTERSEDATA
		      mov bl,(OBJECT PTR [edi]).nring1colorindex
		      .IF bl==al
		      .ELSE
			;colors don't match...
			;if this wire is 1-way return from a path
			;out of same node, possibility of endless
			;loop...
			invoke isitreturnwire, esi
			;returns eax=1 if it is...
			.IF eax==1
			  mov al,(OBJECT PTR [esi]).fconfig2
			  or al,0100b	    ;set bit2.
			  mov (OBJECT PTR [esi]).fconfig2,al
			.ELSE
			  mov al,(OBJECT PTR [esi]).fconfig2
			  and al,11111011b	    ;clr bit2.
			  mov (OBJECT PTR [esi]).fconfig2,al
			  mov al,ncolorring
			  mov (OBJECT PTR [edi]).nring1colorindex,al
			  ;push eax
			  ;invoke InvalidateRgn, g_hwnd,0,FALSE
			  mov g2_fredrawdiag,ENTIRE
			  ;invoke add2updatelist, edi
			  ;mov g2_fredrawdiag,UPDATEobjs
			  ;pop eax
			.ENDIF
		      .ENDIF
		  .ELSE
		    ;make sure flag is clr...
			  mov al,(OBJECT PTR [esi]).fconfig2
			  and al,11111011b	    ;clr bit2.
			  mov (OBJECT PTR [esi]).fconfig2,al
		  .ENDIF
		.ENDIF
bydest: ;note, do all color calcs above, even if not display color...
	mov ebx,pTERSEDATA
	mov al,(TERSEDATA PTR [ebx]).fviewprefs
	and al,01	;bit0=1 color coded rings.
	jz mono1
	      mov al,ncolorring
	      and al,0111b
	      .IF al==0
		mov eax,g_hpen000      ;black
	      .ELSEIF al==001b
		mov eax,g_hpen001      ;red
	      .ELSEIF al==010b
		mov eax,g_hpen100      ;blue
	      .ELSEIF al==011b
		mov eax,g_hpen101      ;pink
	      .ELSEIF al==100b
		mov eax,g_hpen110      ;aqua-blue
	      .ELSEIF al==101b
		mov eax,g_hpen010      ;green
	      .ELSEIF al==110b
		mov eax,g_hpen011      ;yellow
	      .ELSEIF al==111b
		mov eax,g_hpen111      ;grey
	      .ENDIF
	      invoke SelectObject, hdc,eax
	      mov hpendefault,eax
      ;.ENDIF
      ;jmp SHORT xbypass
mono1:
;    invoke SelectObject, hdc,hpendefault
xbypass:


;firstly, draw a little circle at the middle of the wire...
;however, when doing wipeout, maybe middle was highlighted, which
;is an inverted ellipse bigger than the normal ellipse as below.
;so, for wipeout case, (where brush is white) draw bigger circle...
      mov eax,(OBJECT PTR [esi]).xmid
      add eax,2 ;3
      mov xright,eax
      sub eax,4 ;6
      mov xleft,eax
      mov eax,(OBJECT PTR [esi]).ymid
      add eax,2 ;3
      mov ybottom,eax
      sub eax,4 ;6
      mov ytop,eax
      invoke Ellipse, hdc, xleft,ytop, xright,ybottom
	;if wire is inter-task, make circle thicker...
	mov al,(OBJECT PTR [esi]).fconfig
	and al,0100000b     ;bit5
	.IF al==0100000b
	  mov eax,xleft
	  dec eax
	  dec eax
	  mov ebx,ytop
	  dec ebx
	  dec ebx
	  mov ecx,xright
	  inc ecx
	  inc ecx
	  mov edx,ybottom
	  inc edx
	  inc edx
	  invoke Ellipse, hdc, eax,ebx,ecx,edx
	  mov eax,xleft
	  dec eax
	  mov ebx,ytop
	  dec ebx
	  mov ecx,xright
	  inc ecx
	  mov edx,ybottom
	  inc edx
	  invoke Ellipse, hdc, eax,ebx,ecx,edx
	  mov eax,xleft
	  inc eax
	  mov ebx,ytop
	  inc ebx
	  mov ecx,xright
	  dec ecx
	  mov edx,ybottom
	  dec edx
	  invoke Ellipse, hdc, eax,ebx,ecx,edx
	  ;and a little text message...
	    invoke SelectObject, hdc, g_hfontx1x
	    mov hfontsave,eax
	    mov eax,xright
	    inc eax
	    inc eax
	    inc eax
	    mov ebx,ytop
	    sub ebx,6 ;5	12-1-00
	    invoke TextOut, hdc,eax,ebx,ADDR szinter,10
	    invoke SelectObject, hdc,hfontsave
	.ENDIF
    .IF g_fredrawdiag==WIPEOUTobjs
      mov eax,xleft
      sub eax,6
      mov ebx,ytop
      sub ebx,6
      mov ecx,xright
      add ecx,6
      mov edx,ybottom
      add edx,6
      invoke Ellipse, hdc, eax,ebx,ecx,edx ;overwrite previous.
    .ENDIF

    .IF state==4
;when placing 1st-end of a wire, it's confusing to go through all
;that code below. just get out...
;there's a bug with initial values of x/yknes2/3 -- they are fixed
;and don't move. cop-out...
      ret
    .ENDIF

;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 mov eax,xleft
 sub eax,5
 mov ebx,ytop
 sub ebx,5
 mov ecx,xright
 add ecx,5
 mov edx,ybottom
 add edx,5
 invoke CreateEllipticRgn, eax,ebx,ecx,edx ;xleft,ytop, xright,ybottom	;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...
	mov esi,pobject
  xor ecx,ecx
  mov cl,(OBJECT PTR [esi]).fstatus
  and cx,01100000b  ;extract bits 5/6
  .IF cl==00100000b   ;display label
	mov eax,(OBJECT PTR [esi]).xmid
	sub eax,10				      ;/
	mov ebx,(OBJECT PTR [esi]).ymid
	sub ebx,17 ;16	12-1-00
;offset text, from OBJECT.x/ylabeloffset ....
	mov ecx,eax
	mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	cwde		;sign-extends ax -->eax.
	add ecx,eax	;new x-coord.
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov eax,ecx	;restore ax=x-coord
	mov xstart,eax
	mov ystart,ebx

	lea edx,(OBJECT PTR [esi]).sztext1	  ;1st label can be
	 invoke TEXTOUTx, hdc,xstart,ystart,edx,190  ;sztext1+sztext2
						       ; +sztext3
;if there's a reply label, it's below the middle of wire...
	add ystart,18
	lea edx,(OBJECT PTR [esi]).sztext4
	 invoke TEXTOUTx, hdc,xstart,ystart,edx,62  ;sztext4 only
  .ENDIF

;note i'm testing below for rplock1/2==0, but they should always
;be non-0, as wires always have both ends locked to parents. ***NOTE***

;goosee has a problem when dragging end of a wire (after highlighting
;the middle). wmmousemove/state8/g_nknee=2/3/4 > wipes immediately
; > posts to xuser1 > updates. however, the immediate wipe may be
;not quite the solution, because of the dynamic way in which ends
;are snapped in this paint_arc() routine.
;try directly painting without the snapping... just redraw from the
;previous bezier points...
;HEY, MAYBE SHOULD DO THIS FOR ALL WIPEOUTS!!!...
  .IF g_fredrawdiag==WIPEOUTobjs
    .IF g_nknee==4
wipe1:	;redraw from previous set of bezier points.
	invoke PolyBezier, hdc, ADDR bez1, 7
    .ELSEIF g_nknee==5
      jmp wipe1
    .ENDIF
  .ENDIF
;... and continue on to snap and wipe again...

;.....
;DRAWING FIRST HALF OF WIRE
;normal conditions for drawing 1st half of wire, is it has to be
;drawn from middle to knee2 then to x/ytopleft...
;note although snap_arc is called (via psnap method table), it only
;returns recommended snapped-to wire-end coords, and it is up to
;this paint_arc function to update the OBJECT.

;Note, when placing 2nd end of wire (state 5), the knees and middle are
;simply to track in a straight line between the two end coords.
;we'll update them after snapping xtopleft/ytopleft...

    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if cmt locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
      ;(if we allowed state4 to come this far, it would come here)
    .ELSE
	mov ebx,(OBJECT PTR [esi]).xtopleft  ;start-end of wire.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ytopleft	;/
	mov yend,ebx			 ;/
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.

	;need to store ring# returned from snap_tonode/snap_tores
	;into current wire, 1st end...
	  mov (OBJECT PTR [esi]).nbeginring, al

	  ;update wire coords...
	  mov  eax,xend
	  mov (OBJECT PTR [esi]).xtopleft,eax
	  mov  eax,yend
	  mov (OBJECT PTR [esi]).ytopleft,eax
    .ENDIF

;now this is where we take care of knees/middle coords in state5...
      .IF state==5	    ;local state, see note above.
	;firstly, track xmid/ymid...
	mov eax,(OBJECT PTR [esi]).xtopleft
	sub eax,(OBJECT PTR [esi]).wwidth     ;note in state5, this end
	sar eax,1			      ;tracks the mouse, and
	add eax,(OBJECT PTR [esi]).wwidth     ;isn't snapped (rplock2=0)
	mov (OBJECT PTR [esi]).xmid,eax       ;(refer wmmousemove()
	mov eax,(OBJECT PTR [esi]).ytopleft	;for tracking of 2nd end)
	sub eax,(OBJECT PTR [esi]).height
	sar eax,1
	add eax,(OBJECT PTR [esi]).height
	mov (OBJECT PTR [esi]).ymid,eax
	  ;now track xknee2/yknee2...
	mov eax,(OBJECT PTR [esi]).xtopleft
	sub eax,(OBJECT PTR [esi]).xmid
	sar eax,1
	add eax,(OBJECT PTR [esi]).xmid
	mov (OBJECT PTR [esi]).xknee2,eax
	mov eax,(OBJECT PTR [esi]).ytopleft
	sub eax,(OBJECT PTR [esi]).ymid
	sar eax,1
	add eax,(OBJECT PTR [esi]).ymid
	mov (OBJECT PTR [esi]).yknee2,eax
	  ;now track xknee3/yknee3...
	mov eax,(OBJECT PTR [esi]).wwidth
	sub eax,(OBJECT PTR [esi]).xmid
	sar eax,1
	add eax,(OBJECT PTR [esi]).xmid
	mov (OBJECT PTR [esi]).xknee3,eax
	mov eax,(OBJECT PTR [esi]).height
	sub eax,(OBJECT PTR [esi]).ymid
	sar eax,1
	add eax,(OBJECT PTR [esi]).ymid
	mov (OBJECT PTR [esi]).yknee3,eax
      .ENDIF

;;draw from x/ymid to x/yknee2...
;	mov eax,(OBJECT PTR [esi]).xmid	;addr of midddle of wire.
;	mov ebx,(OBJECT PTR [esi]).ymid	;/
;	invoke MoveToEx, hdc, eax,ebx,0
;	mov eax,(OBJECT PTR [esi]).xknee2
;	mov ebx,(OBJECT PTR [esi]).yknee2
;	invoke LineTo, hdc, eax,ebx

;this is where can draw an arrowhead if wire is reply-type...
	mov eax,(OBJECT PTR [esi]).xtopleft  ;precaution.
	mov xend,eax
	mov eax,(OBJECT PTR [esi]).ytopleft  ;/
	mov yend,eax
	  xor eax,eax
	  mov al,(OBJECT PTR [esi]).nbeginring
	  invoke draw1starrow, hdc,edi,xend,yend,eax,esi
	;(edi=addr of parent node, eax=ring#, esi=addr of wire)
	;(the last line drawn will be to back of arrow)

;      ;now draw line to complete drawing 1st half of wire...
;      mov eax,(OBJECT PTR [esi]).xknee2
;      mov ebx,(OBJECT PTR [esi]).yknee2
;      invoke LineTo, hdc, eax,ebx


;......
;DRAWING SECOND HALF OF WIRE
;now draw a line from middle of wire to other (destination) parent-object...

      mov eax,(OBJECT PTR [esi]).rplock2	;non-0 if locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
      mov plock,eax
      .IF eax==0	    ;do nothing, as not locked.
	;this condition will exist in state5, when placing 2nd end.
	;it is responsibility of wmmousemove() to track 2nd wire end.
      .ELSE
	mov ebx,(OBJECT PTR [esi]).wwidth  ;2nd-end of wire.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).height  ;/
	mov yend,ebx			 ;/
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.

	;need to store ring# returned from snap_tonode/snap_tores
	;into current wire, 2nd end...
	  mov (OBJECT PTR [esi]).nendring, al
	  ;update wire coords...
	  mov  eax,xend
	  mov (OBJECT PTR [esi]).wwidth,eax
	  mov  eax,yend
	  mov (OBJECT PTR [esi]).height,eax
      .ENDIF

;	;draw from x/ymid to x/yknee3...
;	mov eax,(OBJECT PTR [esi]).xmid	;addr of midddle of wire.
;	mov ebx,(OBJECT PTR [esi]).ymid	;/
;	invoke MoveToEx, hdc, eax,ebx,0
;	mov eax,(OBJECT PTR [esi]).xknee3
;	mov ebx,(OBJECT PTR [esi]).yknee3
;	invoke LineTo, hdc, eax,ebx

	;this is where can draw an arrowhead at destination-end of wire.
	  mov eax,(OBJECT PTR [esi]).wwidth  ;reload end coords
	  mov  xend,eax 		     ;(necessary because of
	  mov eax,(OBJECT PTR [esi]).height  ; state5)
	  mov  yend,eax
	  xor eax,eax
	  mov al,(OBJECT PTR [esi]).nendring
	  invoke draw2ndarrow, hdc,edi,xend,yend,eax,esi
	;(edi=addr of parent node, eax=ring#, esi=addr of wire)
	;(the last line drawn will be to back of arrow)

;;now draw line to complete 2nd end of wire...
;	;invoke LineTo, hdc, xend,yend
;	mov eax,(OBJECT PTR [esi]).xknee3
;	mov ebx,(OBJECT PTR [esi]).yknee3
;	invoke LineTo, hdc, eax,ebx

;experiment... HAVE DECIDED TO KEEP THIS METHOD!
  mov eax,(OBJECT PTR [esi]).xknee2
  mov bez3.pt_x,eax
  mov eax,(OBJECT PTR [esi]).yknee2
  mov bez3.pt_y,eax
  mov eax,(OBJECT PTR [esi]).xmid
  mov bez4.pt_x,eax
  mov eax,(OBJECT PTR [esi]).ymid
  mov bez4.pt_y,eax
  mov eax,(OBJECT PTR [esi]).xknee3
  mov bez5.pt_x,eax
  mov eax,(OBJECT PTR [esi]).yknee3
  mov bez5.pt_y,eax

  invoke PolyBezier, hdc, ADDR bez1, 7

;tack this on... draw little circles at knee2/3...
;let's only display them if wire selected...
;no, also when wipeout-ing, as they're getting left on-screen...

  .IF g_phighlightedobject==esi
    jmp SHORT E1
  .ELSEIF g_fredrawdiag==WIPEOUTobjs

E1:  mov eax,(OBJECT PTR [esi]).xknee2
      mov xend,eax
      mov eax,(OBJECT PTR [esi]).yknee2
      mov yend,eax
      mov ebx,xend
      mov eax,yend
      sub xend,1 ;2
      sub yend,1 ;2
      add eax,2
      add ebx,2
      invoke Ellipse, hdc, xend,yend, ebx,eax

      mov eax,(OBJECT PTR [esi]).xknee3
      mov xend,eax
      mov eax,(OBJECT PTR [esi]).yknee3
      mov yend,eax
      mov ebx,xend
      mov eax,yend
      sub xend,1 ;2
      sub yend,1 ;2
      add eax,2
      add ebx,2
      invoke Ellipse, hdc, xend,yend, ebx,eax
  .ENDIF

  .IF hpendefault==0
  .ELSE
    invoke SelectObject, hdc,hpendefault
  .ENDIF

    ret
paint_arc ENDP
;--------------------------------------------------------------------------
paint_comp PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
    LOCAL dummy:DWORD
    ret
paint_comp ENDP
;--------------------------------------------------------------------------
paint_super PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
    LOCAL dummy:DWORD
    ret
paint_super ENDP
;--------------------------------------------------------------------------
paint_jb   PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
    LOCAL dummy:DWORD
    ret
paint_jb ENDP
;--------------------------------------------------------------------------
paint_cmt  PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL xright:SDWORD
	LOCAL ybottom:SDWORD
	LOCAL xleft:SDWORD
	LOCAL ytop:SDWORD
	LOCAL textrect:RECT
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL state:BYTE
; "paint_cmt"
;this is a method, to display comments.
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF


      mov esi,pobject

      mov eax,(OBJECT PTR [esi]).wwidth
      add eax,(OBJECT PTR [esi]).xtopleft
      mov xright,eax
      mov ebx,(OBJECT PTR [esi]).height
      add ebx,(OBJECT PTR [esi]).ytopleft
      mov ybottom,ebx
      mov eax,(OBJECT PTR [esi]).xtopleft
      mov xleft,eax
      mov eax,(OBJECT PTR [esi]).ytopleft
      mov ytop,eax

      invoke Ellipse, hdc, xleft,ytop, xright,ybottom
    .IF g_fredrawdiag==WIPEOUTobjs
      mov eax,xleft
      sub eax,6
      mov ebx,ytop
      sub ebx,6
      mov ecx,xright
      add ecx,6
      mov edx,ybottom
      add edx,6
      invoke Ellipse, hdc, eax,ebx,ecx,edx ;overwrite previous.
    .ENDIF


;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 mov eax,xleft
 sub eax,5
 mov ebx,ytop
 sub ebx,5
 mov ecx,xright
 add ecx,5
 mov edx,ybottom
 add edx,5
 invoke CreateEllipticRgn, eax,ebx,ecx,edx ;xleft,ytop, xright,ybottom	;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...first x-coord...
    xor eax,eax
    mov al,(OBJECT PTR [esi]).fstatus
    and ax,01100000b	    ;extract bits 5/6
    .IF ax==0100000b	    ;bit5=1, display label.
	mov  eax,(OBJECT PTR [esi]).xmid
	add  eax,2
	  ;offset text, from OBJECT.x/ylabeloffset ....
	  mov ecx,eax
	  mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	  cwde		;sign-extends ax -->eax.
	  add ecx,eax	;new x-coord.
	mov  textrect.rc_left,ecx
;now y-coord...
	mov  ebx,(OBJECT PTR [esi]).ymid
	sub  ebx,11 ;10  12-1-00
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov  textrect.rc_top,ebx

	lea edx,(OBJECT PTR [esi]).sztext2     ;sztext2+3+4+5+6 (1024chars)
	invoke DrawText, hdc,edx,-1,ADDR textrect,DT_CALCRECT
	lea edx,(OBJECT PTR [esi]).sztext2
	invoke DrawText, hdc,edx,-1,ADDR textrect,DT_NOCLIP+DT_NOPREFIX
    .ENDIF

;now draw a line from comment to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if cmt locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE
	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of comment.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
	  ;as these coords outside node, snap_tonode() will return
	  ;xend/yend snapped to outermost ring. however for non-concentric
	  ;rings want to snap to ring 1...
	  mov edi,plock
	  mov ax,(OBJECT PTR [edi]).nexttype
	  .IF ax==0 ;node.
	    mov eax,(OBJECT PTR [edi]).xdeltacentre
	    .IF eax==0	;no x-offset of rings.
	      mov eax,(OBJECT PTR [edi]).ydeltacentre
	      .IF eax==0
		;rings are concentric...
	      .ELSE
jjt:		;rings non-concentric...
		mov g_nsnapring,1
		;...global variable, used by snap_tonode(), forces
		;snap to that ring. (default is g_nsnapring=0).
	      .ENDIF
	    .ELSE
	      jmp jjt
	    .ENDIF
	  .ENDIF
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  ;mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.
      ;now draw line...
      mov ecx,(OBJECT PTR [esi]).xmid  ;comment middle
      mov edx,(OBJECT PTR [esi]).ymid  ;/
      invoke MoveToEx, hdc, ecx,edx,0
	mov eax,xend	  ;end of line.
	mov ebx,yend	  ;/
      invoke LineTo, hdc, eax,ebx
    .ENDIF

    ret
paint_cmt ENDP
;--------------------------------------------------------------------------
.DATA
szcond BYTE "?",0
.CODE
paint_cond  PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL xright:SDWORD
	LOCAL ybottom:SDWORD
	LOCAL xleft:SDWORD
	LOCAL ytop:SDWORD
	LOCAL textrect:RECT
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL hprevfont:DWORD
	LOCAL hfontsave:DWORD, hpensave:DWORD, hpendefault:DWORD
	LOCAL state:BYTE
	LOCAL fleft:BYTE
; "paint_cond"
;this is a method, to display conditions. similar to paint_cmt().
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF

      mov esi,pobject
      mov hpensave,0
      mov hpendefault,0

;300900
;(based on code to draw a line further down in this func)
;draw a 5-pixel white line from comment to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if cmt locked to parent.
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE
	  mov ebx,pTERSEDATA
	  mov al,(TERSEDATA PTR [ebx]).fviewprefs
	  and al,010b	;bit1=1 white space either side act,cond,wires.
	  jz kss1
	xor eax,eax
	mov al,(OBJECT PTR [esi]).nbeginring
	mov g_nsnapring,eax
	  mov edi,plock
	  xor eax,eax
	  mov al,(OBJECT PTR [edi]).nrings ;# rings on parent.
	  ;cmp al,g_nsnapring
	  .IF eax<=g_nsnapring
	    jmp kss1	  ;don't paint white line.
	  .ENDIF
	inc g_nsnapring	  ;this is the difference from line-draw below!
	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of comment.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
      invoke SelectObject, hdc,g_hpenwhite5
      mov hpensave,eax
      mov ecx,(OBJECT PTR [esi]).xmid  ;comment middle
      mov edx,(OBJECT PTR [esi]).ymid  ;/
      invoke MoveToEx, hdc, ecx,edx,0
	mov eax,xend	  ;end of line.
	mov ebx,yend	  ;/
      invoke LineTo, hdc, eax,ebx
      invoke SelectObject, hdc,hpensave
    .ENDIF
kss1:


;031000
;optional color-coding of rings...
;      mov hpendefault,0
      .IF plock==0	;element doesn't have parent yet.
		  ;...(could have tested for state==4/5 placing new element)
      .ELSE
	mov edi,plock
	mov ebx,pTERSEDATA
	mov al,(TERSEDATA PTR [ebx]).fviewprefs
	and al,01	;bit0=1 color coded rings.
	jz mono1
	cmp g_fredrawdiag,WIPEOUTobjs
	je mono1
	  invoke SelectObject, hdc,g_hpen000	;black.
	  mov hpendefault,eax
	  ;use color of ring attached to...
	  ;(edi set above to parent, esi current element)
	  mov al,(OBJECT PTR [edi]).nring1colorindex
	  add al,(OBJECT PTR [esi]).nbeginring ;which ring attached to.
	  dec al
	  ;**NOTE** this field not set if color-coding turned off...
	  mov (OBJECT PTR [esi]).nring1colorindex,al ;set this element.
	  ;...which doesn't matter.
	      and al,0111b
	      .IF al==0
		mov eax,g_hpen000      ;black
	      .ELSEIF al==001b
		mov eax,g_hpen001      ;red
	      .ELSEIF al==010b
		mov eax,g_hpen100      ;blue
	      .ELSEIF al==011b
		mov eax,g_hpen101      ;pink
	      .ELSEIF al==100b
		mov eax,g_hpen110      ;aqua-blue
	      .ELSEIF al==101b
		mov eax,g_hpen010      ;green
	      .ELSEIF al==110b
		mov eax,g_hpen011      ;yellow
	      .ELSEIF al==111b
		mov eax,g_hpen111      ;grey
	      .ENDIF
	      invoke SelectObject, hdc,eax
      .ENDIF
mono1:


      mov eax,(OBJECT PTR [esi]).wwidth
      add eax,(OBJECT PTR [esi]).xtopleft
      mov xright,eax
      mov ebx,(OBJECT PTR [esi]).height
      add ebx,(OBJECT PTR [esi]).ytopleft
      mov ybottom,ebx
      mov eax,(OBJECT PTR [esi]).xtopleft
      mov xleft,eax
      mov eax,(OBJECT PTR [esi]).ytopleft
      mov ytop,eax
      invoke Ellipse, hdc, xleft,ytop, xright,ybottom
    .IF g_fredrawdiag==WIPEOUTobjs
      mov eax,xleft
      sub eax,6
      mov ebx,ytop
      sub ebx,6
      mov ecx,xright
      add ecx,6
      mov edx,ybottom
      add edx,6
      invoke Ellipse, hdc, eax,ebx,ecx,edx ;overwrite previous.
    .ENDIF

;141200 if cond on left-side of node, reorient "?" and text on left...
    .IF plock==0    ;cond not attached to anything (precaution).
    .ELSE
      mov edi,plock
      ;edi-->parent, esi-->cond.
;      ;let's restrict this feature to totem-poles only...
      mov al,(OBJECT PTR [edi]).fconfig3
      and al,0100b ;bit2.
      .IF al==0100b	;totem-pole,
	mov eax,(OBJECT PTR [edi]).nringwidth ;normally 0 for totempoles.
	xor ecx,ecx
	mov cl,(OBJECT PTR [esi]).nbeginring  ;ring cond is attached to.
	dec ecx
	mul ecx
	mov edx,(OBJECT PTR [edi]).xtopleft
	sub edx,eax
	mov eax,edx
      .ELSE		;concentric.
	mov eax,(OBJECT PTR [edi]).nringwidth
	.IF eax==0  ;precaution for older diags.
	  mov eax,8
	  mov (OBJECT PTR [edi]).nringwidth,8
	.ENDIF
	xor ecx,ecx
	mov cl,(OBJECT PTR [edi]).nrings
	dec ecx
	mul ecx
	mov edx,(OBJECT PTR [edi]).xtopleft
	sub edx,eax
	mov eax,edx
      .ENDIF
      mov ecx,(OBJECT PTR [esi]).xtopleft
      add ecx,(OBJECT PTR [esi]).wwidth
      .IF SDWORD PTR eax>ecx
	;cond is to left of parent...
	mov fleft,1
      .ELSE
	mov fleft,0
      .ENDIF
    .ENDIF

;also display a big "?"...
    invoke SelectObject, hdc,g_hfontx1p5
    mov hprevfont,eax
    mov al,(OBJECT PTR [esi]).fconfig2
    and al,011b
    .IF al==01	    ;if-then
      mov eax,ytop
      mov ecx,xright
      .IF fleft==0
	sub eax,8 ;7 ;4	12-1-00
	dec ecx
      .ELSE
	sub eax,8
	sub ecx,13
      .ENDIF
      push ecx
      push eax
      invoke TextOut, hdc, ecx,eax,ADDR szcond,1
      pop eax
      pop ecx
      inc ecx
      invoke TextOut, hdc, ecx,eax,ADDR szcond,1
    .ELSEIF al==10b  ;while-do
      mov eax,ytop
      mov ecx,xright
      .IF fleft==0
	sub eax,8
	dec ecx
	dec ecx
      .ELSE
	sub eax,8
	sub ecx,14
      .ENDIF
      push ecx
      push eax
      invoke TextOut, hdc, ecx,eax,ADDR szcond,1
      pop eax
      pop ecx
      dec ecx
      invoke TextOut, hdc, ecx,eax,ADDR szcond,1
      mov eax,ytop
      mov ecx,xright
      .IF fleft==0
	sub eax,8
	add ecx,2
      .ELSE
	sub eax,8
	sub ecx,10
      .ENDIF
      push ecx
      push eax
      invoke TextOut, hdc, ecx,eax,ADDR szcond,1
      pop eax
      pop ecx
      dec ecx
      invoke TextOut, hdc, ecx,eax,ADDR szcond,1
    .ENDIF
    invoke SelectObject, hdc,hprevfont

;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 mov eax,xleft
 sub eax,5
 mov ebx,ytop
 sub ebx,5
 mov ecx,xright
 add ecx,5
 mov edx,ybottom
 add edx,5
 invoke CreateEllipticRgn, eax,ebx,ecx,edx ;xleft,ytop, xright,ybottom	;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...first x-coord...
    xor eax,eax
    mov al,(OBJECT PTR [esi]).fstatus
    and ax,01100000b	    ;extract bits 5/6
    .IF ax==0100000b	    ;bit5=1, display label.
;	invoke SelectObject, hdc,g_hfontx1courier
;	mov hfontsave,eax
	mov  eax,(OBJECT PTR [esi]).xmid
	add  eax,12 ;11 ;10 ;2	12-1-00 23-1-00
	  ;offset text, from OBJECT.x/ylabeloffset ....
	  mov ecx,eax
	  mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	  cwde		;sign-extends ax -->eax.
	  add ecx,eax	;new x-coord.
	mov  textrect.rc_left,ecx
;now y-coord...
	mov  ebx,(OBJECT PTR [esi]).ymid
	sub  ebx,9 ;8 ;10  12-1-00
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov  textrect.rc_top,ebx
	lea edx,(OBJECT PTR [esi]).sztext2     ;sztext2+3+4+5+6 (1024chars)
	invoke DrawText, hdc,edx,-1,ADDR textrect,DT_CALCRECT
	.IF fleft==0
	  lea edx,(OBJECT PTR [esi]).sztext2
	  invoke DrawText, hdc,edx,-1,ADDR textrect,DT_NOCLIP+DT_NOPREFIX
	.ELSE
	  mov eax,textrect.rc_left
	  mov ecx,textrect.rc_right
	  sub ecx,eax	;width.
	  mov textrect.rc_right,eax
	  sub textrect.rc_left,ecx
	  sub textrect.rc_left,23
	  sub textrect.rc_right,23
	  lea edx,(OBJECT PTR [esi]).sztext2
	  invoke DrawText,hdc,edx,-1,ADDR textrect,DT_NOCLIP+DT_NOPREFIX+DT_RIGHT
	.ENDIF
;	invoke SelectObject, hdc,hfontsave
    .ENDIF

;now draw a line from comment to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if cmt locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE

	;note, wmlbuttondown()/state4 determined which ring of parent
	;node the action is on, and stored it in .nbeginring.
	;this is now passed to a global variable "g_nsnapring",
	;which snap_tonode() (the only snap_ method that an action obj
	;will call, as it can only be attached to anode) to use
	;to snap xend/yend to that ring...
	xor eax,eax
	mov al,(OBJECT PTR [esi]).nbeginring
	mov g_nsnapring,eax


	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of comment.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.
      ;now draw line...

;now for the default pen...
      mov ecx,(OBJECT PTR [esi]).xmid  ;comment middle
      mov edx,(OBJECT PTR [esi]).ymid  ;/
      invoke MoveToEx, hdc, ecx,edx,0
	mov eax,xend	  ;end of line.
	mov ebx,yend	  ;/
      invoke LineTo, hdc, eax,ebx
    .ENDIF

    .IF hpendefault==0
    .ELSE
      invoke SelectObject, hdc,hpendefault ;when entered this func.
    .ENDIF

    ret
paint_cond ENDP
;--------------------------------------------------------------------------
.DATA
szact	BYTE "!",0
.CODE
paint_act  PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
	LOCAL xright:SDWORD
	LOCAL ybottom:SDWORD
	LOCAL xleft:SDWORD
	LOCAL ytop:SDWORD
	LOCAL textrect:RECT
	LOCAL xend:SDWORD, yend:SDWORD
	LOCAL plock:DWORD
	LOCAL hprevfont:DWORD, hpensave:DWORD, hpendefault:DWORD
	LOCAL state:BYTE, fleft:BYTE
;   "paint_act"
;this is a method, to display actions. similar to paint_cmt().
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
    mov al,g_nstate
    mov state,al
    mov eax,g_pmovingobject
    .IF eax==pobject
    .ELSE
      .IF state==4
	mov state,0
      .ELSEIF state==5
	mov state,0
      .ENDIF
    .ENDIF

      mov esi,pobject
      mov hpensave,0
      mov hpendefault,0

;300900
;(based on code to draw a line further down in this func)
;draw a 5-pixel white line from action-mid to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if cmt locked to parent.
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE
	  mov ebx,pTERSEDATA
	  mov al,(TERSEDATA PTR [ebx]).fviewprefs
	  and al,010b	;bit1=1 white space either side act,cond,wires.
	  jz kss1
	xor eax,eax
	mov al,(OBJECT PTR [esi]).nbeginring
	mov g_nsnapring,eax
	  mov edi,plock
	  xor eax,eax
	  mov al,(OBJECT PTR [edi]).nrings ;# rings on parent.
	  ;cmp al,g_nsnapring
	  .IF eax<=g_nsnapring
	    jmp kss1	  ;don't paint white line.
	  .ENDIF
	inc g_nsnapring	  ;this is the difference from line-draw below!
	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of comment.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
      invoke SelectObject, hdc,g_hpenwhite5
      mov hpensave,eax
      mov ecx,(OBJECT PTR [esi]).xmid  ;comment middle
      mov edx,(OBJECT PTR [esi]).ymid  ;/
      invoke MoveToEx, hdc, ecx,edx,0
	mov eax,xend	  ;end of line.
	mov ebx,yend	  ;/
      invoke LineTo, hdc, eax,ebx
      invoke SelectObject, hdc,hpensave
    .ENDIF
kss1:


;031000
;optional color-coding of rings...
;      mov hpendefault,0
      .IF plock==0	;element doesn't have parent yet.
		  ;...(could have tested for state==4/5 placing new element)
      .ELSE
	mov edi,plock
	mov ebx,pTERSEDATA
	mov al,(TERSEDATA PTR [ebx]).fviewprefs
	and al,01	;bit0=1 color coded rings.
	jz mono1
	cmp g_fredrawdiag,WIPEOUTobjs
	je mono1
	  invoke SelectObject, hdc,g_hpen000	;black.
	  mov hpendefault,eax
	  ;use color of ring attached to...
	  ;(edi set above to parent, esi current element)
	  mov al,(OBJECT PTR [edi]).nring1colorindex
	  add al,(OBJECT PTR [esi]).nbeginring ;which ring attached to.
	  dec al
	  ;**NOTE** this field not set if color-coding turned off...
	  mov (OBJECT PTR [esi]).nring1colorindex,al ;set this element.
	  ;...see also paint_cond(). this doesn't matter.
	      and al,0111b
	      .IF al==0
		mov eax,g_hpen000      ;black
	      .ELSEIF al==001b
		mov eax,g_hpen001      ;red
	      .ELSEIF al==010b
		mov eax,g_hpen100      ;blue
	      .ELSEIF al==011b
		mov eax,g_hpen101      ;pink
	      .ELSEIF al==100b
		mov eax,g_hpen110      ;aqua-blue
	      .ELSEIF al==101b
		mov eax,g_hpen010      ;green
	      .ELSEIF al==110b
		mov eax,g_hpen011      ;yellow
	      .ELSEIF al==111b
		mov eax,g_hpen111      ;grey
	      .ENDIF
	      invoke SelectObject, hdc,eax
      .ENDIF
mono1:



      mov eax,(OBJECT PTR [esi]).wwidth
      add eax,(OBJECT PTR [esi]).xtopleft
      mov xright,eax
      mov ebx,(OBJECT PTR [esi]).height
      add ebx,(OBJECT PTR [esi]).ytopleft
      mov ybottom,ebx
      mov eax,(OBJECT PTR [esi]).xtopleft
      mov xleft,eax
      mov eax,(OBJECT PTR [esi]).ytopleft
      mov ytop,eax
      invoke Ellipse, hdc, xleft,ytop, xright,ybottom
    .IF g_fredrawdiag==WIPEOUTobjs
      mov eax,xleft
      sub eax,6
      mov ebx,ytop
      sub ebx,6
      mov ecx,xright
      add ecx,6
      mov edx,ybottom
      add edx,6
      invoke Ellipse, hdc, eax,ebx,ecx,edx ;overwrite previous.
    .ENDIF

;141200 if action on left-side of node, reorient "!" and text on left...
    .IF plock==0    ;action not attached to anything (precaution).
    .ELSE
      mov edi,plock
      ;edi-->parent, esi-->cond.
      mov al,(OBJECT PTR [edi]).fconfig3
      and al,0100b ;bit2.
      .IF al==0100b	;totem-pole,
	mov eax,(OBJECT PTR [edi]).nringwidth ;normally 0 for totempoles.
	xor ecx,ecx
	mov cl,(OBJECT PTR [esi]).nbeginring  ;ring cond is attached to.
	dec ecx
	mul ecx
	mov edx,(OBJECT PTR [edi]).xtopleft
	sub edx,eax
	mov eax,edx
      .ELSE		;concentric.
	mov eax,(OBJECT PTR [edi]).nringwidth
	.IF eax==0  ;precaution for older diags.
	  mov eax,8
	  mov (OBJECT PTR [edi]).nringwidth,8
	.ENDIF
	xor ecx,ecx
	mov cl,(OBJECT PTR [edi]).nrings
	dec ecx
	mul ecx
	mov edx,(OBJECT PTR [edi]).xtopleft
	sub edx,eax
	mov eax,edx
      .ENDIF
      mov ecx,(OBJECT PTR [esi]).xtopleft
      add ecx,(OBJECT PTR [esi]).wwidth
      .IF SDWORD PTR eax>ecx
	;action is to left of parent...
	mov fleft,1
      .ELSE
	mov fleft,0
      .ENDIF
    .ENDIF

;also display a big "!"...
    invoke SelectObject, hdc,g_hfontx1p5
    mov hprevfont,eax
;if OBJECT.fconfig/bit5 =1, then it is exit-after-action...
    mov al,(OBJECT PTR [esi]).fconfig
    and al,0100000b
    .IF al==100000b
      mov eax,ytop
      mov ebx,xright
      .IF fleft==0
	sub eax,8 ;7 ;4	12-1-00
      .ELSE
	sub eax,8
	sub ebx,12
      .ENDIF
      push ebx
      push eax
      invoke TextOut, hdc, ebx,eax,ADDR szact,1
      pop eax
      pop ebx
      dec ebx
      invoke TextOut, hdc, ebx,eax,ADDR szact,1
      mov eax,ytop
      mov ebx,xright
      .IF fleft==0
	sub eax,8 ;7 ;4	12-1-00
	add ebx,4
      .ELSE
	sub eax,8
	sub ebx,8
      .ENDIF
      push ebx
      push eax
      invoke TextOut, hdc, ebx,eax,ADDR szact,1
      pop eax
      pop ebx
      dec ebx
      invoke TextOut, hdc, ebx,eax,ADDR szact,1
    .ELSE
      mov eax,ytop
      mov ebx,xright
      .IF fleft==0
	sub eax,8 ;7 ;4	12-1-00
      .ELSE
	sub eax,8
	sub ebx,12
      .ENDIF
      push ebx
      push eax
      invoke TextOut, hdc, ebx,eax,ADDR szact,1
      pop eax
      pop ebx
      inc ebx
      invoke TextOut, hdc, ebx,eax,ADDR szact,1
    .ENDIF
    invoke SelectObject, hdc,hprevfont

;when an object is highlighted, need to draw it black...
hidres:
	mov esi,pobject
	cmp g_perrorobject,esi
	je  oo1
;also have multiple highlighted objects...
	  mov al,(OBJECT PTR [esi]).fconfig2
	  and al,80h	    ;bit7.
	  .IF al==80h
	    .IF g_fclrhighlighted==0
	      jmp SHORT oo1b
	    .ELSE
	      and (OBJECT PTR [esi]).fconfig2,7Fh ;clr bit7.
	    .ENDIF
	  .ENDIF
	.IF g_phighlightedobject==esi
	  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 mov eax,xleft
 sub eax,5
 mov ebx,ytop
 sub ebx,5
 mov ecx,xright
 add ecx,5
 mov edx,ybottom
 add edx,5
 invoke CreateEllipticRgn, eax,ebx,ecx,edx ;xleft,ytop, xright,ybottom	;-->eax=hrgn
	  push eax
	  invoke InvertRgn, hdc, eax
	  pop  eax
	  invoke DeleteObject, eax
	.ENDIF

;now to display text on the object...first x-coord...
    xor eax,eax
    mov al,(OBJECT PTR [esi]).fstatus
    and ax,01100000b	    ;extract bits 5/6
    .IF ax==0100000b	    ;bit5=1, display label.
	mov  eax,(OBJECT PTR [esi]).xmid
	add  eax,10 ;11 ;10 ;2	12-1-00 --no, back to 10
	  ;offset text, from OBJECT.x/ylabeloffset ....
	  mov ecx,eax
	  mov ax,(OBJECT PTR [esi]).xlabeloffset	;x offset (signed)
	  cwde		;sign-extends ax -->eax.
	  add ecx,eax	;new x-coord.
	mov  textrect.rc_left,ecx
;now y-coord...
	mov  ebx,(OBJECT PTR [esi]).ymid
	sub  ebx,9 ;8 ;10  12-1-00
	mov ax,(OBJECT PTR [esi]).ylabeloffset	;y offset (signed)
	cwde
	add ebx,eax	;new y-coord
	mov  textrect.rc_top,ebx

	lea edx,(OBJECT PTR [esi]).sztext2     ;sztext2+3+4+5+6 (1024chars)
	invoke DrawText, hdc,edx,-1,ADDR textrect,DT_CALCRECT
;	lea edx,(OBJECT PTR [esi]).sztext2
;	invoke DrawText, hdc,edx,-1,ADDR textrect,DT_NOCLIP+DT_NOPREFIX
	.IF fleft==0
	  lea edx,(OBJECT PTR [esi]).sztext2
	  invoke DrawText, hdc,edx,-1,ADDR textrect,DT_NOCLIP+DT_NOPREFIX
	.ELSE
	  mov eax,textrect.rc_left
	  mov ecx,textrect.rc_right
	  sub ecx,eax	;width.
	  mov textrect.rc_right,eax
	  sub textrect.rc_left,ecx
	  sub textrect.rc_left,22
	  sub textrect.rc_right,22
	  lea edx,(OBJECT PTR [esi]).sztext2
	  invoke DrawText,hdc,edx,-1,ADDR textrect,DT_NOCLIP+DT_NOPREFIX+DT_RIGHT
	.ENDIF
    .ENDIF

;now draw a line from action to parent-object...
    mov eax,(OBJECT PTR [esi]).rplock1	;non-0 if cmt locked to parent.
			    ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
    mov plock,eax
    .IF eax==0	    ;do nothing, as not locked.
    .ELSE

	;note, wmlbuttondown()/state4 determined which ring of parent
	;node the action is on, and stored it in .nbeginring.
	;this is now passed to a global variable "g_nsnapring",
	;which snap_tonode() (the only snap_ method that an action obj
	;will call, as it can only be attached to anode) to use
	;to snap xend/yend to that ring...
	xor eax,eax
	mov al,(OBJECT PTR [esi]).nbeginring
	mov g_nsnapring,eax

	mov ebx,(OBJECT PTR [esi]).xmid	;addr of middle of comment.
	mov xend,ebx			 ;/
	mov ebx,(OBJECT PTR [esi]).ymid	;/
	mov yend,ebx			 ;/
		  ;now, IMPORTANT ... call "snap_" method of PARENT obj...
		  mov edi,plock
		  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
	          ;(relative to "ptrs", which is start of the methods table)
	invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend
	;...will return nearest point on boundary of parent, in xend/yend.
      ;now draw line...
      mov ecx,(OBJECT PTR [esi]).xmid  ;comment middle
      mov edx,(OBJECT PTR [esi]).ymid  ;/
      invoke MoveToEx, hdc, ecx,edx,0
	mov eax,xend	  ;end of line.
	mov ebx,yend	  ;/
      invoke LineTo, hdc, eax,ebx
    .ENDIF

    .IF hpendefault==0
    .ELSE
      invoke SelectObject, hdc,hpendefault ;when entered this func.
    .ENDIF

    ret
paint_act ENDP
;--------------------------------------------------------------------------
paint_sub  PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
    LOCAL dummy:DWORD
    ret
paint_sub ENDP
;--------------------------------------------------------------------------
paint_att  PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
    LOCAL dummy:DWORD
    ret
paint_att ENDP
;--------------------------------------------------------------------------
paint_fnc  PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
    LOCAL dummy:DWORD
    ret
paint_fnc ENDP
;--------------------------------------------------------------------------
delete_node     PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
    LOCAL dummy:DWORD

    mov esi,pobject

;;*NO* i will allow...
;;cannot delete a node if it has a child...
;    mov al,(OBJECT PTR [esi]).fstatus2
;    and al,01
;    .IF al==01	    ;bit0=1 if has a child.
;      ;error msg here...
;      ret
;    .ENDIF

; "delete_node"
;if delete a node, if it is a clone, decr. parent's child-count...
;(note .nchildren is only count of a node's immediate children, not any
; further down the chain)
    mov eax,(OBJECT PTR [esi]).rplock1
    .IF eax==0	;no parent.
    .ELSE
      add eax,pTERSEDATA	;make addr absolute.
      mov ebx,eax
      mov ax,(OBJECT PTR [ebx]).nexttype
      .IF ax==0	;parent is a node.
	mov al,(OBJECT PTR [ebx]).nchildren
	.IF al==0	;precaution.
	.ELSE
	  dec (OBJECT PTR [ebx]).nchildren
	.ENDIF
      .ELSE
	;a datatype-node can be attached to a pointer resource...
	mov al,(OBJECT PTR [ebx]).nchildresources
	.IF al==0	;precaution.
	.ELSE
	  dec (OBJECT PTR [ebx]).nchildresources
	  ;...the child-node inthis context is not treated as a node,
	  ;but as a datatype, a resource.
	.ENDIF
      .ENDIF
    .ENDIF

    mov (OBJECT PTR [esi]).fstatus,0

    invoke deleteslaves, pobject

    ret
delete_node ENDP
;--------------------------------------------------------------------------
delete_icon	PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
    LOCAL dummy:DWORD

    mov esi,pobject

; "delete_icon"

    mov eax,(OBJECT PTR [esi]).rplock1
    .IF eax==0	;no parent.
    .ELSE
      add eax,pTERSEDATA	;make addr absolute.
      mov ebx,eax
      mov ax,(OBJECT PTR [ebx]).nexttype
      .IF ax==0	;parent is a node.


      .ENDIF
    .ENDIF

    mov (OBJECT PTR [esi]).fstatus,0

;will an icon ever have slaves?...
    invoke deleteslaves, pobject

    ret
delete_icon ENDP
;--------------------------------------------------------------------------
delete_res     PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
    LOCAL dummy:DWORD

    mov esi,pobject

;(note .nchildresources is only count of a res's immediate children, not any
; further down the chain)
    mov eax,(OBJECT PTR [esi]).rplock1
    .IF eax==0	;no parent.
    .ELSE
      add eax,pTERSEDATA	;make addr absolute.
      mov ebx,eax
      dec (OBJECT PTR [ebx]).nchildresources
    .ENDIF

    mov (OBJECT PTR [esi]).fstatus,0

    invoke deleteslaves, pobject

    ret
delete_res ENDP
;--------------------------------------------------------------------------
delete_any     PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
    LOCAL dummy:DWORD

    mov esi,pobject

    mov (OBJECT PTR [esi]).fstatus,0

    invoke deleteslaves, pobject

    ret
delete_any ENDP
;--------------------------------------------------------------------------
delete_arc      PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
    LOCAL dummy:DWORD
; "delete_arc"

    mov esi,pobject

;031000
    ;restore ring1 color of destination-node...
	      mov ax,(OBJECT PTR [esi]).nexttype
	      .IF ax==10	;execution-flow 1-way
xx1:		mov ebx,(OBJECT PTR [esi]).rplock1
		mov edi,(OBJECT PTR [esi]).rplock2
		.IF ebx==edi  ;wire loops back to same node.
		.ELSE
		  mov bl,(OBJECT PTR [esi]).nendring
		  .IF bl==1	;wire goes to ring1 of node.
		    add edi,pTERSEDATA
		      mov bl,(OBJECT PTR [edi]).nring1colorindex
		      .IF bl==0 	;color already level-1.
		      .ELSE
			mov (OBJECT PTR [edi]).nring1colorindex,0 ;level-1
			invoke InvalidateRgn, g_hwnd,0,FALSE
			mov g_fredrawdiag,ENTIRE
			;invoke add2updatelist, edi
			;mov g_fredrawdiag,UPDATEobjs
		      .ENDIF
		  .ENDIF
		.ENDIF
	      .ELSEIF ax==11	    ;exec.-flow 2-way
		jmp xx1
	      .ELSEIF ax==12	    ;/
		jmp xx1
	      .ENDIF

    mov (OBJECT PTR [esi]).fstatus,0

    invoke deleteslaves, pobject

    ret
delete_arc ENDP
;--------------------------------------------------------------------------
delete_jb       PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
    LOCAL dummy:DWORD

    mov esi,pobject

    mov (OBJECT PTR [esi]).fstatus,0

    invoke deleteslaves, pobject

    ret
delete_jb ENDP
;--------------------------------------------------------------------------
delete_at       PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
    LOCAL dummy:DWORD
    ret
delete_at ENDP
;--------------------------------------------------------------------------
delete_sub      PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
    LOCAL dummy:DWORD
    ret
delete_sub ENDP
;--------------------------------------------------------------------------
delete_fnc      PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
    LOCAL dummy:DWORD
    ret
delete_fnc ENDP
;--------------------------------------------------------------------------
drag_node       PROC STDCALL USES edi esi eax ebx ecx edx, pmoving:DWORD
    LOCAL xfixed:SDWORD, yfixed:SDWORD
    LOCAL xchange:SDWORD, ychange:SDWORD
;called from wmmousemove/state8 > via pdrag method table. "drag_node"
;also from wmmousemove()/state5 (placing 2nd end new object).
;g_xdiff/g_ydiff was set in method that detected lbuttondown on the
;object (on_node()) -- difference between mouse and xmid/ymid.
;pmoving is the object being dragged.
;this routine also uses g_nmousex/g_nmousey -- world coords.

    .IF g_nstate==5    ;placing other end, new object.
      mov edi,pmoving
      mov eax,g_nmousex
      mov (OBJECT PTR [edi]).xmid,eax
      mov ebx,(OBJECT PTR [edi]).wwidth
      sar ebx,1
      sub eax,ebx
      mov (OBJECT PTR [edi]).xtopleft,eax
      mov eax,g_nmousey
      mov (OBJECT PTR [edi]).ymid,eax
      mov ebx,(OBJECT PTR [edi]).height
      sar ebx,1
      sub eax,ebx
      mov (OBJECT PTR [edi]).ytopleft,eax
      invoke add2updatelist, pmoving
      ret
    .ENDIF

;this correction stops object from "jumping" when it is first dragged...
	mov eax,g_nmousex   ;mouse x-coord (world)
	sub eax,g_xdiff
	mov xfixed,eax	    ;corrected for initial lbuttondown difference.
	mov eax,g_nmousey   ;mouse y-coord.
	sub eax,g_ydiff
	mov yfixed,eax

;calc change to apply to object coords...
	mov edi,pmoving
	mov eax,(OBJECT PTR [edi]).xmid
	sub eax,xfixed
	mov xchange,eax	    ;x-change.
	mov eax,(OBJECT PTR [edi]).ymid
	sub eax,yfixed
	mov ychange,eax	    ;y-change.

;update object coords...
	mov eax,(OBJECT PTR [edi]).xmid
	sub eax,xchange
	mov (OBJECT PTR [edi]).xmid,eax
	mov eax,(OBJECT PTR [edi]).xtopleft
	sub eax,xchange
	mov (OBJECT PTR [edi]).xtopleft,eax
	mov eax,(OBJECT PTR [edi]).ymid
	sub eax,ychange
	mov (OBJECT PTR [edi]).ymid,eax
	mov eax,(OBJECT PTR [edi]).ytopleft
	sub eax,ychange
	mov (OBJECT PTR [edi]).ytopleft,eax

    invoke add2updatelist, pmoving

;***NOTE*** lots more code in goofee.

;need to locate all slave objects (locked-to this object)
;and add them to updatelist also
;and update their coords...

    invoke updateslaves, pmoving, xchange,ychange

    ret
drag_node ENDP
;--------------------------------------------------------------------------
updateslaves PROC STDCALL USES ebx ecx edx esi edi, pmoving:DWORD, \
			    xchange:DWORD, ychange:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL ffound:BYTE
    LOCAL fcontrol:BYTE
;locate all slaves locked to object pmoving, and update their
;coordinates by an amount xchange/ychange.
;also add slave objects to update list.
;this routine will have to be reentrant, as a slave object may in
;turn have its own slaves.
;(see also wipeoutslaves()).
;called from drag_*** method, while dragging an object.

;if plock1==pmoving, update slave.xtopleft/.ytopleft by xchange/ychange.
;if plock2==pmoving, update slave.wwidth/.height by xchange/ychange, as
;it is a wire (wwidth/height are coords other end of wire).

;note that i've commented out updating of knee2/3 of slave wires, nor
;am i updating xmid/ymid. the new bezier curve for wires seems to
;be very flexible and it seems to be messy if further dragging
;occurs now.

;if <control> key held down, don't drag any child non-wire type
;elements... (but still add them to update list)...
    invoke GetAsyncKeyState, VK_CONTROL
    and ax,8000h	;bit15=1 if key down.
    .IF ax==8000h
      mov fcontrol,1
    .ELSE
      mov fcontrol,0
    .ENDIF

;scan through all objects...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0  ;precaution.
	    jmp j03
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	    mov ax,(OBJECT PTR [esi]).nexttype
	    .IF ax==-1	    ;data object
	    .ELSE
	      .IF esi==pmoving	;don't test itself.
	      .ELSE
		mov ffound,0
		mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		.IF eax==pmoving
		  mov al,(OBJECT PTR [esi]).fconfig
		  and al,01
		  .IF al==0	;non-wire type.
		    .IF fcontrol==1
		      ;don't move non-wire type if <control> held down...
		      invoke add2updatelist,esi
		      jmp hack2
		    .ENDIF
		  .ENDIF
		    mov eax,xchange		    ;update coords
		    sub (OBJECT PTR [esi]).xtopleft,eax ;/  (wires and
		    mov eax,ychange		    ;/	     non-wire
		    sub (OBJECT PTR [esi]).ytopleft,eax ;/     types)
		    mov ffound,1
		    jmp SHORT tst1	;in case other end wire on same node.
		.ELSE
tst1:		  mov eax,(OBJECT PTR [esi]).rplock2
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pmoving

		    mov al,(OBJECT PTR [esi]).fconfig
		    and al,01
		    .IF al==01	    ;wire type.
			mov eax,xchange		    ;update coords
			sub (OBJECT PTR [esi]).wwidth,eax ;/ (intended for
			mov eax,ychange		    ;/	 other end
			sub (OBJECT PTR [esi]).height,eax ;/	 of wires)
		    .ENDIF

		    mov ffound,1
		  .ENDIF
		.ENDIF
		.IF ffound==1
		    mov al,(OBJECT PTR [esi]).fconfig
		    and al,01
		    .IF al==0	    ;non-wire type.
		      ;non-wire type, update middle coords,
		      ;(but only once if both locks on same parent)
		      mov eax,xchange
		      sub (OBJECT PTR [esi]).xmid,eax
		      mov eax,ychange
		      sub (OBJECT PTR [esi]).ymid,eax
		    .ENDIF

		    invoke add2updatelist, esi
		    ;now for recursion...
		    ;...however, if current object is a wire, we
		    ;don't want to look any "lower" (the only slave
		    ;a wire can have is probably only a comment attached
		    ;to it)...
		    mov al,(OBJECT PTR [esi]).fconfig
		    and al,01
		    .IF al==01	;wire-type.
		    .ELSE
		      invoke updateslaves, esi,xchange,ychange
		    .ENDIF

hack2:		  mov ffound,0
		.ENDIF
	      .ENDIF
	    .ENDIF
	  .ENDIF
	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  j02 ;nextobj
      jmp SHORT j03
j02:  jmp nextobj
j03:

  ret
updateslaves ENDP
;--------------------------------------------------------------------------
wipeoutslaves PROC STDCALL USES ebx ecx edx esi edi, pmoving:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL ffound:BYTE
;very similar to updateslaves(), except *doesn't* alter slave-object
;coordinates, and adds slaves to wipeout list.
;locate all slaves locked to object pmoving.
;this routine will have to be reentrant, as a slave object may in
;turn have its own slaves.
;called from wipeslaves_*** method, while dragging an object.


;scan through all objects...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp j03
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	    mov ax,(OBJECT PTR [esi]).nexttype
	    .IF ax==-1	    ;data object
	    .ELSE
	      .IF esi==pmoving ;don't test itself.
	      .ELSE
		mov ffound,0
		mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		.IF eax==pmoving
		  mov ffound,1
		  jmp SHORT tst1	;in case other end wire on same node.
		.ELSE
tst1:		  mov eax,(OBJECT PTR [esi]).rplock2
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pmoving
		    mov ffound,1
		  .ENDIF
		.ENDIF
		.IF ffound==1

		    invoke add2wipeoutlist, esi
		    ;now for recursion...
		    invoke wipeoutslaves, esi

		  mov ffound,0
		.ENDIF
	      .ENDIF
	    .ENDIF
	  .ENDIF
x1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  j02 ;nextobj
      jmp SHORT j03
j02:  jmp nextobj
j03:

  ret
wipeoutslaves ENDP
;--------------------------------------------------------------------------
deleteslaves PROC STDCALL USES ebx ecx edx esi edi, pmoving:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL ffound:BYTE
;very similar to wipeoutslaves().
;locate all slaves locked to object pmoving.
;this routine will have to be reentrant, as a slave object may in
;turn have its own slaves.
;called from delete_*** method.

;note, will also delete data objects if locked to a valid object that
;is marked for deletion.

;scan through all objects...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp j03
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	      .IF esi==pmoving ;don't test itself.
	      .ELSE
		mov ffound,0
		mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		.IF eax==pmoving
		  mov ffound,1
		  jmp SHORT tst1	;in case other end wire on same node.
		.ELSE
tst1:		  mov eax,(OBJECT PTR [esi]).rplock2
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pmoving
		    mov ffound,1
		  .ENDIF
		.ENDIF
		.IF ffound==1

		    mov (OBJECT PTR [esi]).fstatus,0 ;kill it.
		    ;now for recursion...
		    invoke deleteslaves, esi

		  mov ffound,0
		.ENDIF
	      .ENDIF

	  .ENDIF
x1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  j02 ;nextobj
      jmp SHORT j03
j02:  jmp nextobj
j03:

  ret
deleteslaves ENDP
;--------------------------------------------------------------------------
fixwiremid PROC PROC STDCALL USES ebx ecx edx esi edi,pparent:DWORD,pnew:DWORD
    LOCAL xcorrection:DWORD, ycorrection:DWORD
;from lbuttonup()/state5.
;a wire has been placed with both ends on same node. need to auto-fix
;middle coords of wire outside the parent node...
;(code taken from goofee upinnode5())
;similar to fixnewchild(), which does same thing for new node.
;note -- wire.nendring isn't correct when this func called.

    mov esi,pnew
    mov edi,pparent

	mov  eax,(OBJECT PTR [edi]).xmid
	sub  eax,(OBJECT PTR [esi]).xmid	;xdelta

	xor ecx,ecx
	mov  cl,(OBJECT PTR [edi]).nrings	;added 16/12/96
	sub  cl,(OBJECT PTR [esi]).nbeginring ;nendring	;/
	inc  ecx				;/
	imul ecx				;/ -->dx:ax
	mov xcorrection,eax
	mov  ecx,(OBJECT PTR [esi]).xmid		;/
	sub  ecx,eax				;/
	mov  eax,ecx				;/
	mov (OBJECT PTR [esi]).xmid,eax	    ;new xmid of loopback.

	mov  ecx,(OBJECT PTR [esi]).xknee2
	sub  ecx,xcorrection
	mov (OBJECT PTR [esi]).xknee2,ecx
	mov  ecx,(OBJECT PTR [esi]).xknee3
	sub  ecx,xcorrection
	mov (OBJECT PTR [esi]).xknee3,ecx


	mov  eax,(OBJECT PTR [edi]).ymid
	sub  eax,(OBJECT PTR [esi]).ymid	;ydelta

	xor ecx,ecx
	mov  cl,(OBJECT PTR [edi]).nrings	;added 16/12/96
	sub  cl,(OBJECT PTR [esi]).nbeginring ;nendring	;/
	inc  ecx				;/
	imul ecx				;/ -->dx:ax
	mov ycorrection,eax
	mov  ecx,(OBJECT PTR [esi]).ymid		;/
	sub  ecx,eax				;/
	mov  eax,ecx				;/
	mov (OBJECT PTR [esi]).ymid,eax

	mov  ecx,(OBJECT PTR [esi]).yknee2
	sub  ecx,ycorrection
	mov (OBJECT PTR [esi]).yknee2,ecx
	mov  ecx,(OBJECT PTR [esi]).yknee3
	sub  ecx,ycorrection
	mov (OBJECT PTR [esi]).yknee3,ecx

;24-4-98 sometimes we are getting wires mid-point jumping way off...
;do a limit-check here...
;esi-->new wire, edi-->node wire-end is on.
	mov eax,(OBJECT PTR [edi]).xmid
	sub eax,(OBJECT PTR [esi]).xmid
	mov ecx,eax
	and ecx,8000h
	.IF ecx==0	;+ve.
	  .IF SDWORD PTR eax>100
	    mov eax,(OBJECT PTR [edi]).xmid
	    sub eax,100
	    mov (OBJECT PTR [esi]).xmid,eax
	  .ENDIF
	.ELSE
	  .IF SDWORD PTR eax<-100
	    mov eax,(OBJECT PTR [edi]).xmid
	    add eax,100
	    mov (OBJECT PTR [esi]).xmid,eax
	  .ENDIF
	.ENDIF
	mov eax,(OBJECT PTR [edi]).ymid
	sub eax,(OBJECT PTR [esi]).ymid
	mov ecx,eax
	and ecx,8000h
	.IF ecx==0	;+ve.
	  .IF SDWORD PTR eax>100
	    mov eax,(OBJECT PTR [edi]).ymid
	    sub eax,100
	    mov (OBJECT PTR [esi]).ymid,eax
	  .ENDIF
	.ELSE
	  .IF SDWORD PTR eax<-100
	    mov eax,(OBJECT PTR [edi]).ymid
	    add eax,100
	    mov (OBJECT PTR [esi]).ymid,eax
	  .ENDIF
	.ENDIF


  ret
fixwiremid ENDP
;--------------------------------------------------------------------------
fixnewchild PROC PROC STDCALL USES ebx ecx edx esi edi,pparent:DWORD,pnew:DWORD
;from lbuttonup()/state5.
;a new node has been placed, with lbuttondown and lbuttonup on top
;of same parent node.  need to auto-fix
;middle coords of new obj outside the parent node...
;(code taken from goofee upinnode5())
;similar to fixwiremid(), which does same thing for new wire.

    mov esi,pnew
    mov edi,pparent

	mov  eax,(OBJECT PTR [edi]).xmid
	sub  eax,(OBJECT PTR [esi]).xtopleft ;xmid	;xdelta

	xor ecx,ecx
	mov  cl,(OBJECT PTR [edi]).nrings	;added 16/12/96
;*???	sub  cl,(OBJECT PTR [esi]).nendring	;/
	inc  ecx				;/
	imul ecx				;/ -->dx:ax
	mov  ecx,(OBJECT PTR [esi]).xmid		;/
	sub  ecx,eax				;/
	mov  eax,ecx				;/
	mov (OBJECT PTR [esi]).xmid,eax	    ;new xmid

	mov  eax,(OBJECT PTR [edi]).ymid
	sub  eax,(OBJECT PTR [esi]).ytopleft ;ymid	;ydelta

	xor ecx,ecx
	mov  cl,(OBJECT PTR [edi]).nrings	;added 16/12/96
;*???	sub  cl,(OBJECT PTR [esi]).nendring	;/
	inc  ecx				;/
	imul ecx				;/ -->dx:ax
	mov  ecx,(OBJECT PTR [esi]).ymid		;/
	sub  ecx,eax				;/
	mov  eax,ecx				;/
	mov (OBJECT PTR [esi]).ymid,eax

;do a limit-check here...
;esi-->new wire, edi-->node wire-end is on.
	mov eax,(OBJECT PTR [edi]).xmid
	sub eax,(OBJECT PTR [esi]).xmid
	mov ecx,eax
	and ecx,8000h
	.IF ecx==0	;+ve.
	  .IF SDWORD PTR eax>100
	    mov eax,(OBJECT PTR [edi]).xmid
	    sub eax,100
	    mov (OBJECT PTR [esi]).xmid,eax
	  .ENDIF
	.ELSE
	  .IF SDWORD PTR eax<-100
	    mov eax,(OBJECT PTR [edi]).xmid
	    add eax,100
	    mov (OBJECT PTR [esi]).xmid,eax
	  .ENDIF
	.ENDIF
	mov eax,(OBJECT PTR [edi]).ymid
	sub eax,(OBJECT PTR [esi]).ymid
	mov ecx,eax
	and ecx,8000h
	.IF ecx==0	;+ve.
	  .IF SDWORD PTR eax>100
	    mov eax,(OBJECT PTR [edi]).ymid
	    sub eax,100
	    mov (OBJECT PTR [esi]).ymid,eax
	  .ENDIF
	.ELSE
	  .IF SDWORD PTR eax<-100
	    mov eax,(OBJECT PTR [edi]).ymid
	    add eax,100
	    mov (OBJECT PTR [esi]).ymid,eax
	  .ENDIF
	.ENDIF

;now update other coords of new object...
    mov eax,(OBJECT PTR [esi]).wwidth
    shr eax,1
    mov ebx,(OBJECT PTR [esi]).xmid
    sub ebx,eax
    mov (OBJECT PTR [esi]).xtopleft,ebx
    mov eax,(OBJECT PTR [esi]).height
    shr eax,1
    mov ebx,(OBJECT PTR [esi]).ymid
    sub ebx,eax
    mov (OBJECT PTR [esi]).ytopleft,ebx

  ret
fixnewchild ENDP
;--------------------------------------------------------------------------


drag_arc	PROC STDCALL USES edi esi eax ebx ecx edx, pmoving:DWORD
    LOCAL xchange:SDWORD, ychange:SDWORD
;this is called via "pdrag" method table, from wmmousemove(),	 "drag_arc"
;states5 and 8. state5 is placing second end of wire, state8 is
;dragging middle of wire.

;no, also when placing "1st end" of new wire...
;wmousemove()/state4 > WM_USER+1 > xuser1() > drag_ methods > drag_arc

;NOTE the other drag_ methods use g_xdiff/g_ydiff to prevent an
;initial jump.

    mov esi,pmoving

    .IF g_nstate==5    ;dragging 2nd end of new object.
      ;other end of wire to track mouse, middle to be in middle...
	;calc change...
	mov xchange,0
	mov ychange,0
      mov eax,g_nmousex
      mov (OBJECT PTR [esi]).wwidth,eax
      sub eax,(OBJECT PTR [esi]).xtopleft
      sar eax,1 	     ; /2
      add eax,(OBJECT PTR [esi]).xtopleft
      mov (OBJECT PTR [esi]).xmid,eax
      mov eax,g_nmousey
      mov (OBJECT PTR [esi]).height,eax
      sub eax,(OBJECT PTR [esi]).ytopleft
      sar eax,1
      add eax,(OBJECT PTR [esi]).ytopleft
      mov (OBJECT PTR [esi]).ymid,eax

    .ELSEIF g_nstate==8 	  ;dragging an object.
      ;we're only dragging the middle of the wire if
      ;pmoving (this wire) = g_pmovingobject...
      mov eax,pmoving

      .IF eax==g_pmovingobject

	  ;we are directly dragging this wire, but which knee?
	  ;on_arc (which detected mouse on the wire) sets g_nknee...
	  .IF g_nknee==1    ;mouse on middle of wire.
	      ;dragging middle of wire...
	      mov eax,(OBJECT PTR [esi]).xmid
	      sub eax,g_nmousex
	      mov xchange,eax
	      mov eax,(OBJECT PTR [esi]).ymid
	      sub eax,g_nmousey
	      mov ychange,eax
	      mov eax,g_nmousex
	      mov (OBJECT PTR [esi]).xmid,eax
	      mov eax,g_nmousey
	      mov (OBJECT PTR [esi]).ymid,eax

		;bezier experiment...
		;drag along knee2/3 as well...
		mov eax,xchange
		sub (OBJECT PTR [esi]).xknee2,eax
		sub (OBJECT PTR [esi]).xknee3,eax
		mov eax,ychange
		sub (OBJECT PTR [esi]).yknee2,eax
		sub (OBJECT PTR [esi]).yknee3,eax

;only allow knees to be selected if wire is highlighted...
;wmlbuttondown detected this, and put into state8, and set pmovingobject.
;the knees are not normally selectable. first the middle has to be
;highlighted, then lbuttondown on a knee (which paint_arc will display
;when wire highlighted) will result in state8 ... so this is the only
;way we can get g_nknee =2/3 when come here...
	  .ELSEIF g_nknee==2	;mouse on knee2
		  mov eax,(OBJECT PTR [esi]).xknee2
		sub eax,g_nmousex
		mov xchange,eax
		mov eax,(OBJECT PTR [esi]).yknee2
		sub eax,g_nmousey
		mov ychange,eax
		mov eax,g_nmousex
		mov (OBJECT PTR [esi]).xknee2,eax
		mov eax,g_nmousey
		mov (OBJECT PTR [esi]).yknee2,eax
	  .ELSEIF g_nknee==3	;mouse on knee3
		mov eax,(OBJECT PTR [esi]).xknee3
		sub eax,g_nmousex
		mov xchange,eax
		mov eax,(OBJECT PTR [esi]).yknee3
		sub eax,g_nmousey
		mov ychange,eax
		mov eax,g_nmousex
		mov (OBJECT PTR [esi]).xknee3,eax
		mov eax,g_nmousey
		mov (OBJECT PTR [esi]).yknee3,eax
	  .ELSEIF g_nknee==4	;mouse on start-end of wire.
		;note, a problem if this is wire on a master-node,
		;snapclonewires() looks for matching wire on clone,
		;but if xchange/ychange here is too big, the wire
		;on slave will "fall out" of tracking.
		;a further problem is cannot restrict xchange/ychange
		;as wire then cannot jump rings. so, impose the
		;xchange/ychange restriction only if wire-end is on
		;ring1 of a master node...

		mov ebx,(OBJECT PTR [esi]).rplock1  ;owner-node
		add ebx,pTERSEDATA
		mov eax,(OBJECT PTR [ebx]).rplock1 ;of master node
		.IF eax==0	;master, or free node.
		  mov al,(OBJECT PTR [ebx]).nchildren
		  .IF al==0	;node has no children
		      ;unrestricted xchange/ychange...
gg1:		      mov eax,(OBJECT PTR [esi]).xtopleft
		      sub eax,g_nmousex
		      mov xchange,eax
		      mov eax,(OBJECT PTR [esi]).ytopleft
		      sub eax,g_nmousey
		      mov ychange,eax
		      mov eax,g_nmousex
		      mov (OBJECT PTR [esi]).xtopleft,eax
		      mov eax,g_nmousey
		      mov (OBJECT PTR [esi]).ytopleft,eax
		  .ELSE
		    mov al,(OBJECT PTR [esi]).nbeginring
		    .IF al==1	    ;wire begins on ring1.
		      ;note, i'm restricting xchange/ychange so
		      ;wire can't be pulled out of ring1...
		      ;*NO* can't stop it.
		      mov eax,(OBJECT PTR [esi]).xtopleft
		      sub eax,g_nmousex
		      .IF SDWORD PTR eax<=-1 ;2
			mov xchange,-1 ;2
		      .ELSEIF SDWORD PTR eax>=1 ;2
			mov xchange,1 ;2
		      .ELSE
			mov xchange,eax
		      .ENDIF
		      mov eax,(OBJECT PTR [esi]).ytopleft
		      sub eax,g_nmousey
		      .IF SDWORD PTR eax<=-1 ;2
			mov ychange,-1 ;2
		      .ELSEIF SDWORD PTR eax>=1 ;2
			mov ychange,1 ;2
		      .ELSE
			mov ychange,eax
		      .ENDIF
		      mov eax,(OBJECT PTR [esi]).xtopleft
		      sub eax,xchange
		      mov (OBJECT PTR [esi]).xtopleft,eax
		      mov eax,(OBJECT PTR [esi]).ytopleft
		      sub eax,ychange
		      mov (OBJECT PTR [esi]).ytopleft,eax
			;now go ahead and snap the wires on clones...
			;ebx -> master node. esi -> wire.
			mov eax,(OBJECT PTR [esi]).xtopleft
			mov ecx,(OBJECT PTR [esi]).ytopleft
			;2nd param =0 means first end of wire...
			invoke snapclonewires, esi,0,ebx, eax,ecx
			.IF eax==-1
			  ret	;error
			.ENDIF
		    .ELSE
		      jmp gg1
		    .ENDIF
		  .ENDIF
		.ELSE
		  jmp gg1
		.ENDIF

		  ;i've got a problem, parent node not redrawing
		  ;while i'm dragging wire end...
		  mov eax,(OBJECT PTR [esi]).rplock1	;get parent.
		  add eax,pTERSEDATA	;cos it's relative.
		  invoke add2updatelist,eax
	  .ELSEIF g_nknee==5	;mouse on destination-end of wire.
	    ;see notes above for g_nknee==4.

		mov ebx,(OBJECT PTR [esi]).rplock2  ;owner-node
		add ebx,pTERSEDATA
		mov eax,(OBJECT PTR [ebx]).rplock1 ;of master node
		.IF eax==0	;master, or free node.
		  mov al,(OBJECT PTR [ebx]).nchildren
		  .IF al==0	;node has no children
		      ;unrestricted xchange/ychange...
xgg1:		      mov eax,(OBJECT PTR [esi]).wwidth
		      sub eax,g_nmousex
		      mov xchange,eax
		      mov eax,(OBJECT PTR [esi]).height
		      sub eax,g_nmousey
		      mov ychange,eax
		      mov eax,g_nmousex
		      mov (OBJECT PTR [esi]).wwidth,eax
		      mov eax,g_nmousey
		      mov (OBJECT PTR [esi]).height,eax
		  .ELSE
		    mov al,(OBJECT PTR [esi]).nendring
		    .IF al==1	    ;wire ends on ring1.
		      ;note, i'm restricting xchange/ychange so
		      ;wire can't be pulled out of ring1...
		      ;*NO* can't stop it.
		      mov eax,(OBJECT PTR [esi]).wwidth
		      sub eax,g_nmousex
		      .IF SDWORD PTR eax<=-1 ;2
			mov xchange,-1 ;2
		      .ELSEIF SDWORD PTR eax>=1 ;2
			mov xchange,1 ;2
		      .ELSE
			mov xchange,eax
		      .ENDIF
		      mov eax,(OBJECT PTR [esi]).height
		      sub eax,g_nmousey
		      .IF SDWORD PTR eax<=-1 ;2
			mov ychange,-1 ;2
		      .ELSEIF SDWORD PTR eax>=1 ;2
			mov ychange,1 ;2
		      .ELSE
			mov ychange,eax
		      .ENDIF
		      mov eax,(OBJECT PTR [esi]).wwidth
		      sub eax,xchange
		      mov (OBJECT PTR [esi]).wwidth,eax
		      mov eax,(OBJECT PTR [esi]).height
		      sub eax,ychange
		      mov (OBJECT PTR [esi]).height,eax
			 ;now go ahead and snap wires on clones...
			 ;ebx -> master node.  esi -> wire.
			 mov eax,(OBJECT PTR [esi]).wwidth
			 mov ecx,(OBJECT PTR [esi]).height
			 ;2nd param =1 means 2nd end of wire...
			 invoke snapclonewires, esi,1,ebx, eax,ecx
			 .IF eax==-1
			   ret	;error
			 .ENDIF
		    .ELSE
		      jmp xgg1
		    .ENDIF
		  .ENDIF
		.ELSE
		  jmp xgg1
		.ENDIF

		  ;i've got a problem, parent node not redrawing
		  ;while i'm dragging wire end...
		  mov eax,(OBJECT PTR [esi]).rplock2	;get parent.
		  add eax,pTERSEDATA   ;cos it's relative.
		  invoke add2updatelist,eax
	  .ELSE
	    ;only other possible value is 0 ...do nothing.
	  .ENDIF

      .ELSE
	;the user is not directly dragging this wire.
	;a parent object is being dragged, pulling this one along...
	;the parent drag_*** method calls updateslaves(), which
	;takes care of adjusting knee2 or knee3 coords of the
	;slave wire.
	;so, do nothing here.
      .ENDIF

    .ELSEIF g_nstate==4  ;placing 1st end of wire.
      ;defaultnewwire() set intial values. just update all of them,
      ;tracking mouse...
      mov eax,(OBJECT PTR [esi]).xtopleft
      sub eax,g_nmousex
      sub (OBJECT PTR [esi]).xtopleft,eax
      sub (OBJECT PTR [esi]).xknee2,eax
      sub (OBJECT PTR [esi]).xmid,eax
      sub (OBJECT PTR [esi]).xknee3,eax
      sub (OBJECT PTR [esi]).wwidth,eax
	mov eax,(OBJECT PTR [esi]).ytopleft
	sub eax,g_nmousey
	sub (OBJECT PTR [esi]).ytopleft,eax
	sub (OBJECT PTR [esi]).yknee2,eax
	sub (OBJECT PTR [esi]).ymid,eax
	sub (OBJECT PTR [esi]).yknee3,eax
	sub (OBJECT PTR [esi]).height,eax


    .ELSE
      ret  ;error.
    .ENDIF

    invoke add2updatelist, pmoving

    .IF g_nstate==5
    .ELSEIF g_nstate==4
    .ELSE

      ;need to locate all slave objects (locked-to this object)
      ;and add them to updatelist also
      ;and update their coords...
      ;(only likely is an attached comment)
      invoke updateslaves, pmoving, xchange,ychange

;      ;if a wire-end is being dragged, and owner-node is a master
;      ;or root (with child nodes, clones), then need to
;      ;snap matching wires on clones...
;      .IF g_nknee==4	;mouse on start-end of wire.
;	mov esi,pmoving
;	mov ebx,(OBJECT PTR [esi]).rplock1  ;owner-node
;	add ebx,pTERSEDATA	;make it absolute.
;	mov ax,(OBJECT PTR [ebx]).nexttype
;	.IF ax==0		;owner is a node.
;	  mov eax,(OBJECT PTR [ebx]).rplock1
;	  .IF eax==0		;owner is "free" (not a clone)
;	    mov al,(OBJECT PTR [ebx]).nchildren
;	    .IF al==0		;has no children
;	    .ELSE
;	      mov eax,(OBJECT PTR [esi]).xtopleft
;	      mov ecx,(OBJECT PTR [esi]).ytopleft
;	      invoke snapclonewires, ebx, eax,ecx
;	    .ENDIF
;	  .ENDIF
;	.ENDIF
;      .ELSEIF g_nknee==5 ;mouse on destination-end of wire.
;	mov esi,pmoving
;	mov ebx,(OBJECT PTR [esi]).rplock2  ;owner-node
;	add ebx,pTERSEDATA	;make it absolute.
;	mov ax,(OBJECT PTR [ebx]).nexttype
;	.IF ax==0		;owner is a node.
;	  mov eax,(OBJECT PTR [ebx]).rplock1 ;(nodes only use rplock1)
;	  .IF eax==0		;owner is "free" (not a clone)
;	    mov al,(OBJECT PTR [ebx]).nchildren
;	    .IF al==0		;has no children
;	    .ELSE
;	      mov eax,(OBJECT PTR [esi]).wwidth
;	      mov ecx,(OBJECT PTR [esi]).height
;	      invoke snapclonewires, ebx, eax,ecx
;	    .ENDIF
;	  .ENDIF
;	.ENDIF
;      .ENDIF

    .ENDIF

    ret
drag_arc ENDP
;--------------------------------------------------------------------------
drag_super      PROC STDCALL USES edi esi eax ebx ecx edx, pmoving:DWORD
    LOCAL dummy:DWORD
    ret
drag_super ENDP
;--------------------------------------------------------------------------
drag_att       PROC STDCALL USES edi esi eax ebx ecx edx, pmoving:DWORD
    LOCAL dummy:DWORD
    ret
drag_att ENDP
;--------------------------------------------------------------------------
drag_sub       PROC STDCALL USES edi esi eax ebx ecx edx, pmoving:DWORD
    LOCAL dummy:DWORD
    ret
drag_sub ENDP
;--------------------------------------------------------------------------
.DATA
sznoer1  DB "ERROR: Cannot select a function postfix, as this node is "
	 DB "an ISR.  See Interrupt wire dialog box for postfix values "
	 DB "and Language & Editor dialog box for ISR function format.",0
szauter1 BYTE "For ""execute command"" and ""open child diagram"" "
	 BYTE "double-click action, the node must have only one ring.",0Dh,0Ah
	 BYTE "For ""auto-filename"" and ""custom-filename"" "
	 BYTE "double-click action, the node may have more than one ring.",0
szauter2 DB "ERROR: The first node in a thread is allowed to have the "
	 DB "double-click action of auto-filename-generation or "
	 DB "open-diagram only.",0
szler2	 DB "ERROR: You have selected the open-diagram double-click "
	 DB "option, however there must also be entries in ""Node label"" "
	 DB "and ""Filespec"" fields.  The former becomes the label of "
	 DB "the matching node in the linked-to diagram. The latter is "
	 DB "the "".GOO"" filename of the diagram to be opened.",0
szerrdelring BYTE "Sorry, you are not allowed to delete a ring if it "
	    BYTE "has wires on it. Delete or move the wires first.",0
szerrring1  BYTE "You have entered a number that is too large. You can "
	    BYTE "insert a ring after any existing ring, or delete "
	    BYTE "any existing ring. The innermost "
	    BYTE "ring is number 1, increasing outward.",0
szerrdelring2 BYTE "You are not allowed to delete ring number one. "
	      BYTE "This is the innermost ring.",0
szerdiagin1   BYTE "As you have selected double-click action of "
	      BYTE """diagram"", the node must be a function. It "
	      BYTE "cannot be in-line code. Further, this version "
	      BYTE "of GOOSEE requires the node to be a library-function.",0
szerby1  BYTE "You have tried to add a ring to a child-node (clone). "
	 BYTE "You can only add rings to ""free"" or master nodes. "
	 BYTE "The GOO language principle is that a child-node inherits "
	 BYTE "the code of the parent, and does not itself have any code.",0
szerlf3  BYTE "You have tried to change the node-type to ""library function""."
	 BYTE "However, a library function cannot be a child of another "
	 BYTE "node. A library function is an external function, and "
	 BYTE "it is simply drawn as a standalone (free) node on the "
	 BYTE "diagram, without any rings or code.",0
szerlf4  BYTE "You have tried to change the node-type to inline-code. "
	 BYTE "However, a child-node (clone) must be a function.",0
szerlf5  BYTE "You have tried to change the node-type to a library "
	 BYTE "function. However, the node is master (root) of a clone-"
	 BYTE "chain and must be a normal or ISR function (as must "
	 BYTE "the clones). A library function must be a standalone node.",0
szerlf7  BYTE "You have tried to change the node to inline code, "
	 BYTE "however, the node is master (root) of a clone-chain, and "
	 BYTE "must be a normal or ISR function.",0
szerlf8  BYTE "WARNING: you have just changed a function to inline code. "
	 BYTE "Be aware that an inline code-block cannot have attached "
	 BYTE "data/hardware elements. If you have these, either delete "
	 BYTE "them, or change this node back to a function.",0Dh,0Ah
	 BYTE "Also, if you are changing a library function node to "
	 BYTE "inline code, this is most likely inappropriate. A library "
	 BYTE "(API) function must be a function. Ditto for an ISR "
	 BYTE "function.",0
szerlf9  BYTE "You have tried to change the node to a library function. "
	 BYTE "However, a library function is an external function, i.e., "
	 BYTE "does not have its code in this diagram. Therefore,it is "
	 BYTE "not appropriate for the node to have rings. Delete all "
	 BYTE "rings, any attached data/hardware elements, then you can "
	 BYTE "make it into a library function node.",0
szerlf10 BYTE "You have tried to change the function-type to an ISR. "
	 BYTE "However, this is a child-node (clone), that must be the "
	 BYTE "same type as the master (root) node in the clone-chain. "
	 BYTE "GOOSEE has restored the node-type correctly.",0
szerlf11 BYTE "You have tried to change the function-type to a "
	 BYTE "normal function. However, this is a child-node (clone), "
	 BYTE "and the function-type must be the same as the master "
	 BYTE "(root) node in the clone-chain. GOOSEE has restored "
	 BYTE "the function-type correctly.",0
szersiz  BYTE "A library-function node must be standalone, i.e., have "
	 BYTE "no child nodes (clones). Nor may it have any attached "
	 BYTE "data/hardware resources. GOOSEE will not allow you to "
	 BYTE "make this selection.",0
szersiz1 BYTE "An external function (normal, ISR, or library), does not "
	 BYTE "have its code in this file (current thread of diagram). "
	 BYTE "Therefore any attached data/hardware resources must "
	 BYTE "also be marked as external. GOOSEE detects that the node "
	 BYTE "does have resources attached, but won't check them "
	 BYTE "individually until code generation is performed. You "
	 BYTE "right now make sure they are external via their dialog "
	 BYTE "boxes.",0
szer311  BYTE "You are trying to make a function-node external, but it "
	 BYTE "has more than one ring. Rings >1 means that the node has "
	 BYTE "internal code, whereas an external function has no code "
	 BYTE "defined in this diagram.",0
szer311b BYTE "External functions do not have code in this diagram. "
	 BYTE "Therefore a function-node that is external cannot have "
	 BYTE "more than one ring.",0
szer182d BYTE "You have selected double-click action to open a file "
	 BYTE "with a custom filename, however you haven't entered the "
	 BYTE "filename into the ""Filespec"" edit box.",0
szeree	 BYTE "Sorry, an in-line-code node isn't allowed to have "
	 BYTE "any color-fill. ANY color inside ring-1 of a node "
	 BYTE "designates the node is a function.",0

.CODE
KENTER5proc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;WM_RBUTTONDOWN > wmrbuttondown() > on a normal node
;brings up a dialog box.   "nodeproc"

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit1 = invisible node.
	test  al,00000010b
	jz ke219
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_INVIS,BM_SETCHECK,1,0
	pop  eax
ke219:
	;bit5 = display label on diagram, bit6=display filespec
	test  al,00100000b    ;test bit5
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
	test  al,01000000b    ;test bit6
	jz ke21v
	push eax
	invoke SendDlgItemMessage,hdlg,KDNN,BM_SETCHECK,1,0
	pop  eax
ke21v:
	test  al,01100000b	   ;test if display no text.
	jnz ke22
	push eax
	invoke SendDlgItemMessage,hdlg,KDNONE,BM_SETCHECK,1,0
	pop  eax
ke22:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;checkbox, force label to be function-name...
    mov al,(OBJECT PTR [edi]).fconfig
    and al,080h 	;bit7=1, label is funcname.
    .IF al==0
    .ELSE
	invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0
    .ENDIF


;display fill color...
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl+0 to +9 (10 digits)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,9,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .ncolor1 even if it's not turned on.
kenf2:

;display file number...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,Kobjnum,WM_SETTEXT,0,esi


;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.

;19-4-97 display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  cwde	    ;sign-extend ax>eax
	  neg eax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  cwde
	  neg eax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.

;display number of this object/element...
	xor  edx,edx
	xor  eax,eax
	mov  ax,(OBJECT PTR [edi]).number
	invoke bin2dec		;-->szasciitbl
	lea  esi,szasciitbl+4	;as value limited to 4 digits.
xoreldgblanks:	mov  al,[esi]	   ;ignore ldg blanks
		cmp  al," "	   ;/
		jne  xoldgblanks   ;/
		inc  esi	   ;/
		jmp  xoreldgblanks ;/
xoldgblanks:			   ;/
 invoke SendDlgItemMessage,hdlg,IDD_K5PU,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K5PU,EM_LIMITTEXT,4,0 ;set limit.

;extended filespec (was .szreplylabel/.timeout)...
;i.e. action after double-click
	lea  esi,(OBJECT PTR [edi]).sztext2
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,KSPEC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KSPEC,EM_LIMITTEXT,126,0 ;set limit.

;double-click action...
;111000 ... if .nring1colorindex>0, then node isn't top-level, so
;don't allow double-click action. exception is library-func...
    mov al,(OBJECT PTR [edi]).nfunctype
    .IF al==0	    ;inline code, don't allow double-click if not top.
tstdbl:	mov al,(OBJECT PTR [edi]).nring1colorindex
      .IF al==0     ;ring1=black, top-level node.
	jmp SHORT okdbl
      .ELSE	    ;not top-level, leave checkboxes blank.
	;disable "Filespec:" editbox...
	invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,TRUE,0
;	mov (OBJECT PTR [edi]).sztext2,0
;	;...(entire field zeroed when ok exit from dialogbox).
      .ENDIF
    .ELSEIF al==1   ;normal func, /
      jmp tstdbl
    .ELSEIF al==2   ;isr, /
      jmp tstdbl
    .ELSE	    ;library func, etc(future).
okdbl:	mov  al,(OBJECT PTR [edi]).fconfig
	and  al,00011000b	;bits 3/4
	.IF  al==0		;automatic generation of filename
	  invoke SendDlgItemMessage,hdlg,KSPA,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;custom filename to edit.
	invoke SendDlgItemMessage,hdlg,KSPF,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;command -- execute application.
	invoke SendDlgItemMessage,hdlg,KSPC,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;open another diagram.
	invoke SendDlgItemMessage,hdlg,KSPD,BM_SETCHECK,1,0
	.ENDIF
    .ENDIF

;upload function post/prefix strings...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,306,CB_ADDSTRING,0,esi
    mov	ecx,8  ;4
      mov  esi,pTERSEDATA
    lea	eax,(TERSEDATA PTR [esi]).szpfunc1
    mov esi,eax
hmmzz:
    mov  al,[esi]
    cmp  al,0		;ignore null strings.
    je	 immzz
    push ecx
    invoke SendDlgItemMessage,hdlg,306,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,64	;16
    loop hmmzz
immzz:

;upload function data post/prefix strings...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,307,CB_ADDSTRING,0,esi
    mov	ecx,16
      mov  esi,pTERSEDATA
    lea	eax,(TERSEDATA PTR [esi]).szpre1
    mov esi,eax
xhmmzz:
    mov  al,[esi]
    cmp  al,0		;ignore null strings.
    je	 ximmzz
    push ecx
    invoke SendDlgItemMessage,hdlg,307,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48
    loop xhmmzz
ximmzz:

;upload function data type strings...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,308,CB_ADDSTRING,0,esi
    mov	ecx,16
      mov  esi,pTERSEDATA
    lea	eax,(TERSEDATA PTR [esi]).sztype1
    mov esi,eax
xxhmmzz:
    mov  al,[esi]
    cmp  al,0		;ignore null strings.
    je	 xximmzz
    push ecx
    invoke SendDlgItemMessage,hdlg,308,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48
    loop xxhmmzz
xximmzz:

;upload structure type strings...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,411,CB_ADDSTRING,0,esi
    mov	ecx,13
      mov  esi,pTERSEDATA
    lea	eax,(TERSEDATA PTR [esi]).szptrtype4
    mov esi,eax
exxhmmzz:
    mov  al,[esi]
    cmp  al,0		;ignore null strings.
    je	 exximmzz
    push ecx
    invoke SendDlgItemMessage,hdlg,411,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48
    loop exxhmmzz
exximmzz:

;set checkboxes for function type...
    ;except, if a clone, get it from the master (root node)...
    mov ebx,(OBJECT PTR [edi]).rpmaster
    .IF ebx==0
      mov al,(OBJECT PTR [edi]).nfunctype
    .ELSE
      add ebx,pTERSEDATA
      mov al,(OBJECT PTR [ebx]).nfunctype
      mov (OBJECT PTR [edi]).nfunctype,al
    .ENDIF
    .IF al==0	;default, node is not a function.
	invoke SendDlgItemMessage,hdlg,408,BM_SETCHECK,1,0
    .ELSEIF al==1  ;node is a normal function.
	invoke SendDlgItemMessage,hdlg,403,BM_SETCHECK,1,0
    .ELSEIF al==2  ;node is a ISR.
	invoke SendDlgItemMessage,hdlg,401,BM_SETCHECK,1,0
    .ELSEIF al==3  ;node is a library function.
	invoke SendDlgItemMessage,hdlg,420,BM_SETCHECK,1,0
    .ENDIF

;set checkboxes for function visibility...
    mov al,(OBJECT PTR [edi]).fstatus2
    and al,0110b    ;bits 2/1
    .IF al==000	;
	;private node...don't have this option.
    .ELSEIF al==010b  ;file-visible (compiles with "static" prefix)
	invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,1,0
    .ELSEIF al==100b  ;public-visible (can be accessed by other files)
	invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,1,0
    .ELSEIF al==110b  ;external --not defined this file ("extern" prefix)
	invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,1,0
    .ENDIF
    ;except, if a clone, must be file-visible only...
    mov eax,(OBJECT PTR [edi]).rpmaster
    .IF eax==0
    .ELSE
;	mov ebx,eax
;	add ebx,pTERSEDATA
;	mov al,(OBJECT PTR [ebx]).fstatus2 ;get bits 2/1
;	and al,0110b
	mov bl,(OBJECT PTR [edi]).fstatus2
	and bl,11111011b       ;want bits2/1 =01 file-visible
	or  bl,00000010b	;/
	mov (OBJECT PTR [edi]).fstatus2,bl
	invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,1,0
	invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0
	invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0
    .ENDIF

;display label of node that owns this node...
;note that this is read-only, so no need to unload from dialog.
;note, "pointing to itself" when external comes from resources.
;-- not sure about usage with nodes.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	  .IF eax==edi	 ;when external it points to itself.
	    xor eax,eax
	    mov al,(OBJECT PTR [edi]).fstatus
	    and al,0100b	;also fstatus/bit2=1 if external.
	    .IF al==0100b
	      lea eax,szextern1
	      jmp SHORT ext1
	    .ENDIF
	  .ELSE
	    mov ebx,eax
	    lea eax,(OBJECT PTR [ebx]).sztext1
ext1:	    invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	  .ENDIF
	.ENDIF

;grey some edit boxes, depending on function type...
      invoke SendDlgItemMessage,hdlg,401,BM_GETCHECK,0,0
      .IF ax==1 	      ;isr func.
;	invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
;	invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
;	invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
;	invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
      .ENDIF
      invoke SendDlgItemMessage,hdlg,420,BM_GETCHECK,0,0
      .IF ax==1 	     ;library func
       invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,TRUE,0 ;insertring
       invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,TRUE,0 ;deletering
       invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,1,0 ;set external.
      .ENDIF
      invoke SendDlgItemMessage,hdlg,403,BM_GETCHECK,0,0
      .IF ax==1 	      ;normal func
      .ENDIF
      invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0
      .IF ax==1 	      ;inline code
       invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
      .ENDIF

;also, if node is a child, it inherits prototype from master and has
;greyed insert-ring/delete-ring...
    mov ebx,(OBJECT PTR [edi]).rplock1	;not .rpmaster
    .IF ebx==0	    ;not a clone.(would also have .rplock1=0)
    .ELSE
      add ebx,pTERSEDATA
      mov ax,(OBJECT PTR [ebx]).nexttype
      .IF ax==0     ;parent is a node.
	mov ebx,(OBJECT PTR [edi]).rpmaster
	add ebx,pTERSEDATA	;master node.(root)
	lea eax,(OBJECT PTR [ebx]).sztext5  ;passedprototype is in sztext5=384bytes
	lea ecx,(OBJECT PTR [edi]).sztext5
	push ebx
	invoke lstrcpy, ecx,eax	    ;from master to child.
	pop ebx
	lea eax,(OBJECT PTR [ebx]).sztext4  ;returnprototype is in sztext4=64 bytes
	lea ecx,(OBJECT PTR [edi]).sztext4
	push ebx
	invoke lstrcpy, ecx,eax	    ;from master to child.
	pop ebx
	lea eax,(OBJECT PTR [ebx]).sztext6  ;prefixprototype is in sztext6=64 bytes
	lea ecx,(OBJECT PTR [edi]).sztext6
	push ebx
	invoke lstrcpy, ecx,eax	    ;from master to child.
	pop ebx
	lea eax,(OBJECT PTR [ebx]).sztext7  ;postfixprototype is in sztext7=64 bytes
	lea ecx,(OBJECT PTR [edi]).sztext7
	push ebx
	invoke lstrcpy, ecx,eax	    ;from master to child.
	pop ebx
	invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
	invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
	invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
	invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
	invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,TRUE,0 ;insertring
	invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,TRUE,0 ;deletering
	invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,TRUE,0 ;filespec
      .ELSE
	;the only other possibility is that a parent of a node can be
	;a pointer data element...
	;the only valid edit-box is the prototype-return...
	;no, let's also allow the passed datatypes...
	invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,FALSE,0 ;protoreturn
	invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,FALSE,0 ;protopassed
	invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;protoprefix
	invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;protopostfi
	invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,TRUE,0 ;insertring
	invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,TRUE,0 ;deletering
	invoke SendDlgItemMessage,hdlg,102,EM_SETREADONLY,TRUE,0 ;name
	invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,TRUE,0 ;filespec
	invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0 ;file-visibility
	 ;...this was set above for clones, but clear it here.
      .ENDIF
    .ENDIF

;upload prototype string...
;i've split it up...
      ;returned string..
      lea eax,(OBJECT PTR [edi]).sztext4
      invoke SendDlgItemMessage,hdlg,404,WM_SETTEXT,0,eax
      invoke SendDlgItemMessage,hdlg,404,EM_LIMITTEXT,62,0 ;set limit.
      ;passed params string...
      lea eax,(OBJECT PTR [edi]).sztext5
      invoke SendDlgItemMessage,hdlg,419,WM_SETTEXT,0,eax
      invoke SendDlgItemMessage,hdlg,419,EM_LIMITTEXT,382,0 ;set limit.
      ;func prefix (use sztext6)...
      lea eax,(OBJECT PTR [edi]).sztext6
      invoke SendDlgItemMessage,hdlg,429,WM_SETTEXT,0,eax
      invoke SendDlgItemMessage,hdlg,429,EM_LIMITTEXT,62,0 ;set limit.
      ;func postfix (use sztext7)...
      lea eax,(OBJECT PTR [edi]).sztext7
      invoke SendDlgItemMessage,hdlg,430,WM_SETTEXT,0,eax
      invoke SendDlgItemMessage,hdlg,430,EM_LIMITTEXT,62,0 ;set limit.

;can have non-concentric rings...
	mov al,(OBJECT PTR [edi]).fconfig3
	and al,0100b	;bit2
	.IF al==0	;concentric rings. (old default)
	  invoke SendDlgItemMessage,hdlg,229,BM_SETCHECK,1,0
	.ELSE		;non-concentric rings.
	  mov al,(OBJECT PTR [edi]).fconfig3
	  and al,011000b ;bit4/3.
	  .IF al==0
	    ;totem-pole grows up, standard spacing...
	    invoke SendDlgItemMessage,hdlg,232,BM_SETCHECK,1,0
	  .ELSEIF al==01000b
	    ;totem-pole grows down, standard spacing...
	    invoke SendDlgItemMessage,hdlg,235,BM_SETCHECK,1,0
	  .ELSE
	    ;custom rings...
	    invoke SendDlgItemMessage,hdlg,236,BM_SETCHECK,1,0
	  .ENDIF
	.ENDIF



      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK
      mov  g_fhaschanged,1

;update the database...

;get the name...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,64+128			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse)
		inc  esi			  ;/
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi

;get the prototype string...
    mov eax,(OBJECT PTR [edi]).rplock1
    .IF eax==0	    ;=0, not a clone.(can't change if a clone)
		lea  esi,(OBJECT PTR [edi]).sztext4 ;zeroise it first.
		mov  ecx,64+384+64+64			  ;/
xzoo1:		mov  [esi],BYTE PTR 0		  ;/
		inc  esi			  ;/
		loop xzoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext4		;returned string
	invoke SendDlgItemMessage,hdlg,404,WM_GETTEXT,63,esi
	lea  esi,(OBJECT PTR [edi]).sztext5		;passed string
	invoke SendDlgItemMessage,hdlg,419,WM_GETTEXT,383,esi
	lea  esi,(OBJECT PTR [edi]).sztext6		;func prefix
	invoke SendDlgItemMessage,hdlg,429,WM_GETTEXT,63,esi
	lea  esi,(OBJECT PTR [edi]).sztext7		;func postfix
	invoke SendDlgItemMessage,hdlg,430,WM_GETTEXT,63,esi
    .ELSE
      ;its a clone, but if a datatype-node, need allow return-datatype
      ;update... and passed datatypes...
      mov al,(OBJECT PTR [edi]).fstatus2
      and al,1000b	;extract bit3
      .IF al==1000b	;a datatype-node
	lea  esi,(OBJECT PTR [edi]).sztext4		;returned string
	invoke SendDlgItemMessage,hdlg,404,WM_GETTEXT,63,esi
	lea  esi,(OBJECT PTR [edi]).sztext5		;passed string
	invoke SendDlgItemMessage,hdlg,419,WM_GETTEXT,383,esi
      .ENDIF
    .ENDIF

 invoke SendDlgItemMessage,hdlg,IDD_INVIS,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;invisible node button is checked.
	  or  bl,00000010b
	.ELSE
	  and bx,1111111111111101b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bx,1111111111011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,KDNN,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;filespec display checkbox is checked.
	  or  bl,01000000b	  ;bit6
	.ELSE
	  and bx,1111111110111111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;NO, readonly...
;;update number of object (was "subproject") ...
; invoke SendDlgItemMessage,hdlg,IDD_K5PU,WM_GETTEXT,5,ADDR szasciitbl
;	invoke str2longint, ADDR szasciitbl	;-->integer in eax
;	mov  (OBJECT PTR [edi]).number,ax

;update font size in .fstatus field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .ncolour1 field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,10,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset

;double-click action...
	lea  eax,(OBJECT PTR [edi]).sztext2	   ;filespec.
	invoke SendDlgItemMessage,hdlg,KSPEC,WM_GETTEXT,127,eax
	and  (OBJECT PTR [edi]).fconfig,11100111b ;clr bits3/4.
;defaults to auto-filename generation....
   invoke SendDlgItemMessage,hdlg,KSPF,BM_GETCHECK,0,0	;custom filename.
	.IF ax==1
	  or  (OBJECT PTR [edi]).fconfig,00001000b
	.ENDIF
   invoke SendDlgItemMessage,hdlg,KSPC,BM_GETCHECK,0,0	;command.
	.IF ax==1
	  or  (OBJECT PTR [edi]).fconfig,00010000b
	.ENDIF
   invoke SendDlgItemMessage,hdlg,KSPD,BM_GETCHECK,0,0	;diagram.
	.IF ax==1
	  ;to link to another diagram, there must be entries in both
	  ;.sztext1 and .sztext2...
	  mov  al,(OBJECT PTR [edi]).sztext1
	  .IF  al==0  ;no good. function name required.
	    jmp  SHORT dd14
	  .ELSE
	    mov al,(OBJECT PTR [edi]).sztext2
	    .IF al==0	;no good   .goo name required.
dd14:	      lea	eax,szler2
	      invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONQUESTION
	      jmp   zoono1	;do not end dialog box.
	    .ENDIF
	  .ENDIF
	  or  (OBJECT PTR [edi]).fconfig,00011000b ;set open-diagram selection.
	  ;also, .nfunctype cannot be 0 (inline code)...
	  mov al,(OBJECT PTR [edi]).nfunctype
	  .IF al==0
	    mov (OBJECT PTR [edi]).nfunctype,1
	  .ENDIF
	.ENDIF
	mov  al,(OBJECT PTR [edi]).nrings ;#rings.
	.IF al==1
	.ELSE
	  ;only auto-filename gen. is allowed to have multiple rings...
	  ;(as it is expanding on current diagram)
	    ;exception is 1st node in diagram. it will have multiple
	    ;rings, be bright-yellow, and may have dbl-clk action to
	    ;open a parent diagram...
	    ;*NO* only allow auto-filename and custom-filename for
	    ;top node...
	    test (OBJECT PTR [edi]).fconfig,0100b
	    jz	b14	;if no color-fill, carry on.
	    mov	eax,(OBJECT PTR [edi]).ncolour1	  ;color.
	    .IF eax==0FFFFh  ;deep yellow.
	      mov	al,(OBJECT PTR [edi]).fconfig
	      and	al,00011000b	;extract bits 4/3.
	      .IF	al==0		;auto-gen. fine.
	      .ELSEIF al==0001000b	;custom filename. ok.
		;check that have a custom filename...
		mov al,(OBJECT PTR [edi]).sztext2
		.IF al==0
		  lea eax,szer182d
		  invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
		  jmp zoono1	    ;stay in dialog box.
		.ENDIF
	      .ELSE			;don't allow.
		lea	eax,szauter2
		invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
		and	(OBJECT PTR [edi]).fconfig,11100111b  ;clr bits4/3.
		jmp	zoono1	;do not end dialog box.
	      .ENDIF
	      jmp xc14	;leave as-is. jump past all color changing stuff.
	    .ENDIF
b14:	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,00011000b	;extract bits 4/3.
	  .IF  al==0		;auto-gen. fine.
	  .ELSEIF al==01000b	;custom filename gen. fine.
	  .ELSE
	    lea	eax,szauter1
	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	    and	(OBJECT PTR [edi]).fconfig,11100111b  ;clr bits4/3.
	    jmp	zoono1	;do not end dialog box.
	  .ENDIF
	.ENDIF
;set node color according to dblclk action...
c14:	mov  al,(OBJECT PTR [edi]).fconfig
	and  al,00011000b		;extracts bits 4/3.
	.IF  al==0			;auto-gen.
;*	  test (OBJECT PTR [edi]).fconfig,0100b
;*	  jz   a14	;if no color-fill, leave until we do dblclk.
;*	  ;this is awkward, as may already have bright-yellow if
;*	  ;first node in thread. don't want to override...
;*	  ;if already any shade of yellow, leave alone...
;*	  mov  eax,(OBJECT PTR [edi]).ncolour1
;*	  .IF  eax==0FFFFh	;yellow!
;*	  .ELSE
;*	    mov	(OBJECT PTR [edi]).ncolour1,0C0FFFFh ;pale yellow.
;*	  .ENDIF
;*a14:
	.ELSEIF al==00001000b		;custom filename.
	  or   (OBJECT PTR [edi]).fconfig,0100b ;turn on color-fill.
	  ;171000 ... no, purple-pink...
	  mov  (OBJECT PTR [edi]).ncolour1,0FF00FFh ;purple-pink
	    ;... was =008080FFh ;pale red.
	.ELSEIF al==00010000b		;execute application.
	  or   (OBJECT PTR [edi]).fconfig,0100b ;turn on color-fill.
	  ;171000 ... now red...
	  mov  (OBJECT PTR [edi]).ncolour1,0FFh ;red
	    ;... was =0FF00FFh ;pink-purple.
	.ELSEIF al==00011000b		;open diagram.
;	  test (OBJECT PTR [edi]).fconfig,0100b
;	  jz   e14			     ;no fill-color.
;	  mov  eax,(OBJECT PTR [edi]).ncolour1
;	  .IF  eax==0FFFFh	;deep yellow! leave it as-is.
;	  .ELSE
e14:	    or	(OBJECT PTR [edi]).fconfig,0100b ;turn on color-fill.
	    mov	(OBJECT PTR [edi]).ncolour1,0FFFF00h ;aqua-blue.
;	  .ENDIF
	.ENDIF
xc14:

;get function type...
   invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0	;inline code
   .IF ax==1	    ;not a function (inline code)
     ;warning, if changing to inline and wasn't before...
     mov al,(OBJECT PTR [edi]).nfunctype
     .IF al==0	    ;already inline
     .ELSE
       lea eax,szerlf8
       invoke MessageBox,g_hwnd,eax,ADDR szgoosee,MB_OK+MB_ICONEXCLAMATION
     .ENDIF
     ;can't be inline if a master-node of a clone-chain...
     mov al,(OBJECT PTR [edi]).nchildren
     .IF al==0
     .ELSE
       lea eax,szerlf7
       jmp ff1
     .ENDIF
     ;can't be inline if a child node...
	 mov eax,(OBJECT PTR [edi]).rplock1
	 .IF eax==0
	 .ELSE
	   lea eax,szerlf4
ff1:	   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	   jmp zoono1
	 .ENDIF
     ;cannot be inline code if dblclk action is "diagram"...
     mov bl,(OBJECT PTR [edi]).fconfig
     and bl,011000b	;diagram dblclk action.
     .IF bl==011000b
	    lea	eax,szerdiagin1
	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	    jmp	zoono1	;do not end dialog box.
     .ENDIF
       ;171200 inline can't have color-fill...
       mov al,(OBJECT PTR [edi]).fconfig
       and al,0100b ;bit2 =1 if color-fill on.
       .IF al==0100b
	 lea eax,szeree
	 jmp ff1
       .ENDIF
     ;everything ok, make it inline...
     mov (OBJECT PTR [edi]).nfunctype,0
   .ELSE
     invoke SendDlgItemMessage,hdlg,403,BM_GETCHECK,0,0	;normal func
     .IF ax==1	    ;normal function
       ;but if a child, must be same as master...
       mov ebx,(OBJECT PTR [edi]).rpmaster
       .IF ebx==0	;free/master
	 mov (OBJECT PTR [edi]).nfunctype,1
	 ;i'll rely on paint_node() to pickup if node doesn't have
	 ;color-fill, and set it to default grey.
       .ELSE
	   add ebx,pTERSEDATA
	   mov cl,(OBJECT PTR [ebx]).nfunctype	;master functype
	   .IF cl==1	    ;master is a normal node.
	     mov (OBJECT PTR [edi]).nfunctype,1
	   .ELSE
	     mov (OBJECT PTR [edi]).nfunctype,cl
	     lea eax,szerlf11
	     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	   .ENDIF
       .ENDIF
     .ELSE
       invoke SendDlgItemMessage,hdlg,420,BM_GETCHECK,0,0 ;library func
       .IF ax==1	    ;library function
	 ;cannot allow to be a library func if has rings...
	 mov al,(OBJECT PTR [edi]).nrings
	 .IF al==1
	 .ELSE
	   lea eax,szerlf9
	   jmp pu1
	 .ENDIF
	 ;cannot allow to be a library func if a child-node (clone)...
	 mov eax,(OBJECT PTR [edi]).rplock1
	 .IF eax==0
	   ;cannot allow to be a library func if a master of clone-chain...
	   mov al,(OBJECT PTR [edi]).nchildren
	   .IF al == 0
	     mov (OBJECT PTR [edi]).nfunctype,3
	   .ELSE
	     lea eax,szerlf5
	     jmp pu1
	   .ENDIF
	 .ELSE
	   lea eax,szerlf3
pu1:	   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	   jmp zoono1
	 .ENDIF
	 ;also, a library func not allowed attached resources...
	 mov al,(OBJECT PTR [edi]).nchildresources
	 .IF al==0
	 .ELSE
	  ;a library-func node not allowed to have attached resources...
siz1:	    lea	eax,szersiz
	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	    jmp zoono1
	 .ENDIF

       .ELSE
	 ;can only be a isr if master is...
	 mov ebx,(OBJECT PTR [edi]).rpmaster
	 .IF ebx==0	;a free node or a master.
	   mov (OBJECT PTR [edi]).nfunctype,2  ;ISR.
	 .ELSE
	   add ebx,pTERSEDATA
	   mov cl,(OBJECT PTR [ebx]).nfunctype
	   .IF cl==2	    ;master is an isr. ok
	     mov (OBJECT PTR [edi]).nfunctype,2
	   .ELSE
	     mov (OBJECT PTR [edi]).nfunctype,cl
	     lea eax,szerlf10
	     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	   .ENDIF
	 .ENDIF
       .ENDIF
     .ENDIF
   .ENDIF

;get function-visibility...
   invoke SendDlgItemMessage,hdlg,421,BM_GETCHECK,0,0	;file-visible
   .IF ax==1
     mov al,(OBJECT PTR [edi]).fstatus2
     and al,11111011b
     or  al,00000010b
     mov (OBJECT PTR [edi]).fstatus2,al
     jmp endvis
   .ENDIF
   invoke SendDlgItemMessage,hdlg,422,BM_GETCHECK,0,0	;public-visible
   .IF ax==1
     mov al,(OBJECT PTR [edi]).fstatus2
     and al,11111101b
     or  al,00000100b
     mov (OBJECT PTR [edi]).fstatus2,al
     jmp endvis
   .ENDIF
   invoke SendDlgItemMessage,hdlg,423,BM_GETCHECK,0,0	;external
   .IF ax==1
	 ;external func attached resources must be external also...
	 mov al,(OBJECT PTR [edi]).nchildresources
	 .IF al==0
	 .ELSE
	    lea	eax,szersiz1
	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	 .ENDIF
	 ;external func cannot have nrings>1...
	 mov al,(OBJECT PTR [edi]).nrings
	 .IF al==1
	 .ELSE
	    lea	eax,szer311
	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	    jmp zoono1	;stay in dialog box.
	 .ENDIF
     mov al,(OBJECT PTR [edi]).fstatus2
     or  al,00000110b
     mov (OBJECT PTR [edi]).fstatus2,al
     jmp endvis
   .ENDIF
   ;if get here, then visibility must be private...
     mov al,(OBJECT PTR [edi]).fstatus2
     and al,11111001b  ;bits 2/1=00.
     mov (OBJECT PTR [edi]).fstatus2,al

endvis:


;get "insert ring (after)"...
   invoke SendDlgItemMessage,hdlg,233,BM_GETCHECK,0,0
   .IF ax==1
      ;however, child-nodes aren't allowed to have more than 1 ring...
      mov ecx,(OBJECT PTR [edi]).rplock1
      .IF ecx==0    ;free node or master.
      .ELSE
	lea eax,szerby1
	invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	jmp by1
      .ENDIF
      ;nor are external nodes...
      mov cl,(OBJECT PTR [edi]).fstatus2
      and cl,110b
      .IF cl==110b
;	mov (OBJECT PTR [edi]).nrings,1 ;precaution.
	lea eax,szer311b
	invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	jmp by1
      .ENDIF
      xor ebx,ebx
      mov bl,(OBJECT PTR [edi]).nrings
      .IF g_nring>ebx
	;out of range...
jjo:	    lea	eax,szerrring1
	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	    jmp	zoono1	;do not end dialog box.
      .ELSEIF g_nring==0
	;error.
      .ELSE
	invoke insertring, edi,g_nring
	;...inserts a ring after g_nring, in node edi. moves wires.
	;...returns eax=0 if fail.
      .ENDIF
   .ENDIF

;get "delete ring#"...
   invoke SendDlgItemMessage,hdlg,234,BM_GETCHECK,0,0
   cmp ax,1
   jne by1
; invoke SendDlgItemMessage,hdlg,416,WM_GETTEXT,3,ADDR szasciitbl
; invoke str2longint, ADDR szasciitbl	;-->integer in eax
  mov eax,g_nring
  .IF eax>0
    .IF eax==1
	    lea	eax,szerrdelring2
	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	    jmp	zoono1	;do not end dialog box.
    .ELSE
      xor ebx,ebx
      mov bl,(OBJECT PTR [edi]).nrings
      .IF eax>ebx
	;out of range...
	    lea	eax,szerrring1
	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	    jmp	zoono1	;do not end dialog box.
      .ELSE
	invoke deletering, edi,eax
	.IF eax==0	;failed.
	    lea	eax,szerrdelring
	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	    jmp	zoono1	;do not end dialog box.
	.ENDIF
      .ENDIF
    .ENDIF
  .ENDIF
by1:

;get checkbox, force label to be funcname...
   invoke SendDlgItemMessage,hdlg,228,BM_GETCHECK,0,0
   .IF ax==1
     or (OBJECT PTR [edi]).fconfig,080h     ;set bit7
   .ELSE
     and (OBJECT PTR [edi]).fconfig,01111111b  ;clr bit7
   .ENDIF

;can have non-concentric rings...
   invoke SendDlgItemMessage,hdlg,229,BM_GETCHECK,0,0 ;concentric.
   .IF ax==1
     test (OBJECT PTR [edi]).fconfig3,0100b ;bit2.
     jz jjq   ;already conc.
     ;these are the old defaults...
     and (OBJECT PTR [edi]).fconfig3,11100011b ;clr bit4/3/2.
     ;set these before fixnonconc2conc()...
     mov (OBJECT PTR [edi]).wwidth,32
     mov (OBJECT PTR [edi]).height,32
       mov eax,(OBJECT PTR [edi]).xmid
       sub eax,16			 ;wwidth/2.
       mov (OBJECT PTR [edi]).xtopleft,eax
       mov eax,(OBJECT PTR [edi]).ymid
       sub eax,16			 ;height/2.
       mov (OBJECT PTR [edi]).ytopleft,eax
     mov ecx,(OBJECT PTR [edi]).xdeltacentre
     mov edx,(OBJECT PTR [edi]).ydeltacentre
     mov (OBJECT PTR [edi]).xdeltacentre,0
     mov (OBJECT PTR [edi]).ydeltacentre,0
     invoke fixnonconc2conc, edi,ecx,edx ;adjs wire-ends, conds/actions.
       mov (OBJECT PTR [edi]).nringwidth,8 ;gap between rings.
   .ENDIF

   invoke SendDlgItemMessage,hdlg,232,BM_GETCHECK,0,0 ;totem-pole,growup.
   .IF ax==1
     mov al,(OBJECT PTR [edi]).fconfig3
     and al,011100b ;bit4/3/2.
     .IF al==00100b
       jmp jjq	;already totem-pole, grow-up.
     .ELSEIF al==0  ;currently concentric rings.
       ;the new code handles non-conc and ellipses...
       ; in snap_tonode(), on_node(), paint_node())
jjn:	or (OBJECT PTR [edi]).fconfig3,0100b	;set bit2.
       and (OBJECT PTR [edi]).fconfig3,11100111b ;clr bits 4/3.
       mov (OBJECT PTR [edi]).wwidth,32
       mov (OBJECT PTR [edi]).height,32
       mov (OBJECT PTR [edi]).nringwidth,0 ;all rings same size.
       mov eax,(OBJECT PTR [edi]).xmid
       sub eax,16			 ;wwidth/2.
       mov (OBJECT PTR [edi]).xtopleft,eax
       mov eax,(OBJECT PTR [edi]).ymid
       sub eax,16			 ;height/2.
       mov (OBJECT PTR [edi]).ytopleft,eax
       mov (OBJECT PTR [edi]).xdeltacentre,0
       mov (OBJECT PTR [edi]).ydeltacentre,-42
       ;...must set these before call fixconc2nonconc().
       invoke fixconc2nonconc, edi    ;adjs wire-ends, cond/actions.
     .ELSEIF al==01100b ;currently totem-pole grow-down.
       ;umm, i really need a "fixnoncon2nonconc()", but for now,
       ;go via concentric (copy code from above)...
hhq:	 and (OBJECT PTR [edi]).fconfig3,11100011b ;clr bit4/3/2.
	 ;set these before fixnonconc2conc()...
	 mov (OBJECT PTR [edi]).wwidth,32
	 mov (OBJECT PTR [edi]).height,32
	 mov eax,(OBJECT PTR [edi]).xmid
	 sub eax,16			 ;wwidth/2.
	 mov (OBJECT PTR [edi]).xtopleft,eax
	 mov eax,(OBJECT PTR [edi]).ymid
	 sub eax,16			 ;height/2.
	 mov (OBJECT PTR [edi]).ytopleft,eax
	 mov ecx,(OBJECT PTR [edi]).xdeltacentre
	 mov edx,(OBJECT PTR [edi]).ydeltacentre
	 mov (OBJECT PTR [edi]).xdeltacentre,0
	 mov (OBJECT PTR [edi]).ydeltacentre,0
	 invoke fixnonconc2conc, edi,ecx,edx ;adjs wire-ends, conds/actions.
	 mov (OBJECT PTR [edi]).nringwidth,8 ;gap between rings.
	   ;don't know if this necessary...
	   ;invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	   ;mov g_fredrawdiag,ENTIRE		;redraw entire window.
	   ;push g_nmousex
	   ;push g_nmousey
	   ;invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
	   ;pop	g_nmousey
	   ;pop	g_nmousex
	     ;now change conc to totempole growup...
	     jmp jjn
     .ELSE ;custom
       ;go via concentric also...maybe
       ;but not implemented yet
     .ENDIF
   .ENDIF
jjq:

   invoke SendDlgItemMessage,hdlg,235,BM_GETCHECK,0,0 ;totem-pole,growdown.
   .IF ax==1
     mov al,(OBJECT PTR [edi]).fconfig3
     and al,011100b ;bit4/3/2.
     .IF al==01100b
       jmp xjjq	;already totem-pole, grow-down.
     .ELSEIF al==0  ;currently concentric rings.
       ;the new code handles non-conc and ellipses...
       ; in snap_tonode(), on_node(), paint_node())
xjjn:	or (OBJECT PTR [edi]).fconfig3,01100b	;set bits3/2.
       and (OBJECT PTR [edi]).fconfig3,11101111b ;clr bit 4.
       mov (OBJECT PTR [edi]).wwidth,32
       mov (OBJECT PTR [edi]).height,32
       mov (OBJECT PTR [edi]).nringwidth,0 ;all rings same size.
       mov eax,(OBJECT PTR [edi]).xmid
       sub eax,16			 ;wwidth/2.
       mov (OBJECT PTR [edi]).xtopleft,eax
       mov eax,(OBJECT PTR [edi]).ymid
       sub eax,16			 ;height/2.
       mov (OBJECT PTR [edi]).ytopleft,eax
       mov (OBJECT PTR [edi]).xdeltacentre,0
       mov (OBJECT PTR [edi]).ydeltacentre,42
       ;...must set these before call fixconc2nonconc().
       invoke fixconc2nonconc, edi    ;adjs wire-ends, cond/actions.
     .ELSEIF al==00100b ;currently totem-pole grow-up.
       ;umm, i really need a "fixnoncon2nonconc()", but for now,
       ;go via concentric (copy code from above)...
xhhq:	 and (OBJECT PTR [edi]).fconfig3,11100011b ;clr bit4/3/2.
	 ;set these before fixnonconc2conc()...
	 mov (OBJECT PTR [edi]).wwidth,32
	 mov (OBJECT PTR [edi]).height,32
	 mov eax,(OBJECT PTR [edi]).xmid
	 sub eax,16			 ;wwidth/2.
	 mov (OBJECT PTR [edi]).xtopleft,eax
	 mov eax,(OBJECT PTR [edi]).ymid
	 sub eax,16			 ;height/2.
	 mov (OBJECT PTR [edi]).ytopleft,eax
	 mov ecx,(OBJECT PTR [edi]).xdeltacentre
	 mov edx,(OBJECT PTR [edi]).ydeltacentre
	 mov (OBJECT PTR [edi]).xdeltacentre,0
	 mov (OBJECT PTR [edi]).ydeltacentre,0
	 invoke fixnonconc2conc, edi,ecx,edx ;adjs wire-ends, conds/actions.
	 mov (OBJECT PTR [edi]).nringwidth,8 ;gap between rings.
	   ;don't know if this necessary...
	   ;invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	   ;mov g_fredrawdiag,ENTIRE		;redraw entire window.
	   ;push g_nmousex
	   ;push g_nmousey
	   ;invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
	   ;pop	g_nmousey
	   ;pop	g_nmousex
	     ;now change conc to totempole growdown...
	     jmp xjjn
     .ELSE ;custom
       ;go via concentric also...maybe
       ;but not implemented yet
     .ENDIF
   .ENDIF
xjjq:




      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF ax==IDCANCEL ;(lo-wparam)
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE

    .ELSEIF ax==401	;isr function
      mov eax,(OBJECT PTR [edi]).rplock1  ;is it a clone?
      cmp eax,0
      jne cc1
      invoke SendDlgItemMessage,hdlg,408,BM_SETCHECK,0,0    ;inline code
      invoke SendDlgItemMessage,hdlg,403,BM_SETCHECK,0,0    ;normal func
      invoke SendDlgItemMessage,hdlg,401,BM_SETCHECK,1,0    ;isr func
      invoke SendDlgItemMessage,hdlg,420,BM_SETCHECK,0,0    ;library func
       invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,FALSE,0 ;insertring
       invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,FALSE,0 ;deletering
	;double-click action...
	;but only if top-level...
	mov al,(OBJECT PTR [edi]).nring1colorindex
	.IF al==0	;ring1=black, top-level.
	  ;enable "Filespec:" editbox...
	  invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,0,0 ;filespec
	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	  invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	  invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
	  .IF ax==1
	    invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	  .ELSE
	    invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
	  .ENDIF
	  ;label must be function-name...
	  invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;check it.
	.ELSE	;keep them off...
	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	  invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	  invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	  invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename
	  ;disable "Filespec:" editbox...
	  invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,TRUE,0
	  ;and clr it...
	  lea esi,sznull
	  invoke SendDlgItemMessage,hdlg,KSPEC,WM_SETTEXT,0,esi
	.ENDIF

	;if isr func is external...
	invoke SendDlgItemMessage,hdlg,423,BM_GETCHECK,0,0    ;external
	.IF ax==1
	  ;well, i don't think isr func should be external, only file/public.
	  ;so, maybe below, don't allow this option.
	  jmp hackx
	  ;invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
	  ;invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
	  ;invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
	  ;invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
	  ;invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,TRUE,0 ;insertring
	  ;invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,TRUE,0 ;deletering
	.ELSE
	  invoke SendDlgItemMessage,hdlg,422,BM_GETCHECK,0,0	;public
	  .IF ax==1
	      invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0 ;file-visible
	      invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0 ;not external
	  .ELSE
	    invoke SendDlgItemMessage,hdlg,421,BM_GETCHECK,0,0	;file
	    .IF ax==1
	    .ELSE
	      ;normal func isn't file/public/external visible. only one
	      ;left is private, but that would require funcname to be
	      ;mangled and we haven't implemented that. let's just say
	      ;that all inline nodes are private, and funcs have to be
	      ;file/public/external... default file...
hackx:	      invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,1,0 ;file-visible
	      invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0 ;not external
	      invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0 ;not public
	    .ENDIF
	  .ENDIF
	.ENDIF
cc1:	mov eax,TRUE

    .ELSEIF ax==420	;library function
      mov eax,(OBJECT PTR [edi]).rplock1  ;is it a clone?
      cmp eax,0
      jne cc2
      invoke SendDlgItemMessage,hdlg,420,BM_SETCHECK,1,0  ;library func
      invoke SendDlgItemMessage,hdlg,401,BM_SETCHECK,0,0  ;isr
      invoke SendDlgItemMessage,hdlg,403,BM_SETCHECK,0,0  ;normal
      invoke SendDlgItemMessage,hdlg,408,BM_SETCHECK,0,0    ;inline code
	  ;clear the prototype edit boxes...
	  lea esi,sznull
	  invoke SendDlgItemMessage,hdlg,404,WM_SETTEXT,0,esi
	  invoke SendDlgItemMessage,hdlg,419,WM_SETTEXT,0,esi
	  invoke SendDlgItemMessage,hdlg,429,WM_SETTEXT,0,esi
	  invoke SendDlgItemMessage,hdlg,430,WM_SETTEXT,0,esi
	;disable prototype edit boxes...
	invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
	invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
	invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
	invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
	invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,TRUE,0 ;insertring
	invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,TRUE,0 ;deletering
      invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,1,0  ;mustbe external
      invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0  ;not public
      invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0  ;not file
	;double-click action...
	invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,1,0 ;diagram ticked
	invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename
	  ;enable "Filespec:" editbox...
	  invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,0,0 ;filespec
	;label must be function-name...
	invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;check it.
cc2:	mov eax,TRUE

    .ELSEIF ax==403	;normal function
      mov eax,(OBJECT PTR [edi]).rplock1  ;is it a clone?
      cmp eax,0
      jne cc3  ;jmp if it's a clone.
      invoke SendDlgItemMessage,hdlg,408,BM_SETCHECK,0,0    ;inline code
      invoke SendDlgItemMessage,hdlg,403,BM_SETCHECK,1,0    ;normal func
      invoke SendDlgItemMessage,hdlg,401,BM_SETCHECK,0,0    ;isr func
      invoke SendDlgItemMessage,hdlg,420,BM_SETCHECK,0,0    ;library func
       invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,FALSE,0 ;insertring
       invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,FALSE,0 ;deletering
	;double-click action...
	;but only if top-level...
	mov al,(OBJECT PTR [edi]).nring1colorindex
	.IF al==0	;ring1=black, top-level.
	  ;enable "Filespec:" editbox...
	  invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,0,0 ;filespec
	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	  invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	  invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
	  .IF ax==1
	    invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	  .ELSE
	    invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
	  .ENDIF
	  ;label must be function-name...
	  invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;check it.
	.ELSE	;keep them off...
	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	  invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	  invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	  invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename
	  ;disable "Filespec:" editbox...
	  invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,TRUE,0
	  ;and clr it...
	  lea esi,sznull
	  invoke SendDlgItemMessage,hdlg,KSPEC,WM_SETTEXT,0,esi
	.ENDIF

	;if normal func is external...
	invoke SendDlgItemMessage,hdlg,423,BM_GETCHECK,0,0    ;external
	.IF ax==1
	    ;*NO* i aint going to allow to be external -- only library funcs.
	    ;change it to public...
	    invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,1,0
	    jmp cc3
;	  invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
;	  invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
;	  invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
;	  invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
;	  invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,TRUE,0 ;insertring
;	  invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,TRUE,0 ;deletering
	.ELSE
	  invoke SendDlgItemMessage,hdlg,422,BM_GETCHECK,0,0	;public
	  .IF ax==1
	  .ELSE
	    invoke SendDlgItemMessage,hdlg,421,BM_GETCHECK,0,0	;file
	    .IF ax==1
	    .ELSE
	      ;normal func isn't file/public/external visible. only one
	      ;left is private, but that would require funcname to be
	      ;mangled and we haven't implemented that. let's just say
	      ;that all inline nodes are private, and funcs have to be
	      ;file/public/external... default file...
	      invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,1,0 ;file-visible
	      invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0 ;not external
	      invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0 ;not public
	    .ENDIF
	  .ENDIF
	.ENDIF
cc3:	mov eax,TRUE

    .ELSEIF ax==408	;inline code
      mov eax,(OBJECT PTR [edi]).rplock1  ;is it a clone?
      cmp eax,0
      jne cc4
      mov al,(OBJECT PTR [edi]).nchildresources
      .IF al>0
	     ;*NO* already have a warning when exit dialog, that
	     ;inline code not allowed attached resources.
      .ENDIF
      invoke SendDlgItemMessage,hdlg,408,BM_SETCHECK,1,0    ;inline code
      invoke SendDlgItemMessage,hdlg,403,BM_SETCHECK,0,0    ;normal func
      invoke SendDlgItemMessage,hdlg,401,BM_SETCHECK,0,0    ;isr func
      invoke SendDlgItemMessage,hdlg,420,BM_SETCHECK,0,0    ;library
      invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0
	invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0  ;file-visible
	invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0  ;public-visible
	invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0  ;external
	  ;clear the prototype edit boxes...
	  lea esi,sznull
	  invoke SendDlgItemMessage,hdlg,404,WM_SETTEXT,0,esi
	  invoke SendDlgItemMessage,hdlg,419,WM_SETTEXT,0,esi
	  invoke SendDlgItemMessage,hdlg,429,WM_SETTEXT,0,esi
	  invoke SendDlgItemMessage,hdlg,430,WM_SETTEXT,0,esi
       ;disable prototype edit boxes...
       invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,FALSE,0 ;insertring
       invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,FALSE,0 ;deletering
	;double-click action...
	;but only if top-level...
	mov al,(OBJECT PTR [edi]).nring1colorindex
	.IF al==0	;ring1=black, top-level.
	  ;enable "Filespec:" editbox...
	  invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,0,0 ;filespec
	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	  invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	  invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic
	  invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename
	.ELSE	;keep them off...
	  ;disable "Filespec:" editbox...
	  invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,TRUE,0
	  ;and clr it...
	  lea esi,sznull
	  invoke SendDlgItemMessage,hdlg,KSPEC,WM_SETTEXT,0,esi
	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	  invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	  invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	  invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename
	.ENDIF
	;label cannot be function-name...
	invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,0,0 ;uncheck it.
cc4:	mov eax,TRUE

    .ELSEIF ax==421	;file-visible
      mov eax,(OBJECT PTR [edi]).rplock1  ;is it a clone?
      cmp eax,0
      jne cc5
      ;is it a library func?...
      invoke SendDlgItemMessage,hdlg,420,BM_GETCHECK,0,0 ;library func
      cmp ax,1
      je  cc5
      invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0 ;inline code
      .IF ax==1  ;these must be clear if inline code...
	invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0 ;file-visible.
	invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0 ;public-visible
	invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0 ;external.
      .ELSE
	invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,1,0
	invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0
	invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0
	jmp iv1
      .ENDIF
	;double-click action...
;	invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
;	invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
;	invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic
;	invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename
	    invoke SendDlgItemMessage,hdlg,245,BM_GETCHECK,0,0 ;diagram
	    .IF ax==1
	      ;diagram not allowed, default to...
	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
	      invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	      invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	      invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
	    .ENDIF
	    invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	    .IF ax==1
	      ;command not allowed, default to...
	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
	      invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	      invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	      invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
	    .ENDIF
cc5:  mov eax,TRUE

    .ELSEIF ax==422	;public-visible
      mov eax,(OBJECT PTR [edi]).rplock1  ;is it a clone?
      cmp eax,0
      jne cc6
      invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0 ;inline code
      .IF ax==1  ;these must be clear if inline code...
	invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0  ;file
	invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0  ;public
	invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0  ;external
      .ELSE
	invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0
	invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,1,0
	invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0
iv1:	invoke SendDlgItemMessage,hdlg,403,BM_GETCHECK,0,0 ;normal func
	.IF ax==1
	  invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,FALSE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,FALSE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,FALSE,0 ;insertring
	  invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,FALSE,0 ;deletering
	    ;double-click action...
;	    invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
;	    invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
;	    invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
;	    .IF ax==1
;	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
;	    .ELSE
;	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
;	    .ENDIF
	    invoke SendDlgItemMessage,hdlg,245,BM_GETCHECK,0,0 ;diagram
	    .IF ax==1
	      ;diagram not allowed, default to...
	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
	      invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	      invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	      invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
	    .ENDIF
	    invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	    .IF ax==1
	      ;command not allowed, default to...
	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
	      invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	      invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	      invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
	    .ENDIF
	  ;label must be function-name...
	  invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;check it.
	.ENDIF

	invoke SendDlgItemMessage,hdlg,401,BM_GETCHECK,0,0 ;isr func
	.IF ax==1
	  invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,FALSE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,FALSE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,FALSE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,FALSE,0 ;insertring
	  invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,FALSE,0 ;deletering
	    ;double-click action...
;	    invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
;	    invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
;	    invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
;	    .IF ax==1
;	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
;	    .ELSE
;	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
;	    .ENDIF
	    invoke SendDlgItemMessage,hdlg,245,BM_GETCHECK,0,0 ;diagram
	    .IF ax==1
	      ;diagram not allowed, default to...
	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
	      invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	      invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	      invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
	    .ENDIF
	    invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	    .IF ax==1
	      ;command not allowed, default to...
	      invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic on
	      invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	      invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	      invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;filename
	    .ENDIF
	  ;label must be function-name...
	  invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;check it.
	.ENDIF

	invoke SendDlgItemMessage,hdlg,420,BM_GETCHECK,0,0 ;library func type
	.IF ax==1
	  invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
       invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,TRUE,0 ;insertring
	  invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,TRUE,0 ;deletering
	  ;also, library func must be external, not public...
	  invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,1,0 ;external
	  invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0 ;public
	  invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0 ;file
	  ;label must be function-name...
	  invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;check it.
	.ENDIF
      .ENDIF
cc6:  mov eax,TRUE

    .ELSEIF ax==423	;external
      mov eax,(OBJECT PTR [edi]).rplock1  ;is it a clone?
      cmp eax,0
      jne cc7
      invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0 ;inline code
      .IF ax==1  ;these must be clear if inline code...
	invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0
	invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0
	invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,0,0
      .ELSE
	invoke SendDlgItemMessage,hdlg,401,BM_GETCHECK,0,0 ;isr func
	.IF ax==1
	  ;don't think it's appropriate for isr func to be external.
	.ELSE
	  invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,0,0
	  invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,0,0
	  invoke SendDlgItemMessage,hdlg,423,BM_SETCHECK,1,0
	  invoke SendDlgItemMessage,hdlg,404,EM_SETREADONLY,TRUE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,419,EM_SETREADONLY,TRUE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,429,EM_SETREADONLY,TRUE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,430,EM_SETREADONLY,TRUE,0 ;prototypestr
	  invoke SendDlgItemMessage,hdlg,414,EM_SETREADONLY,TRUE,0 ;insertring
	  invoke SendDlgItemMessage,hdlg,416,EM_SETREADONLY,TRUE,0 ;deletering
	.ENDIF
      .ENDIF
cc7:  mov eax,TRUE

    .ELSEIF ax==243	;dbl-clk to open a textfile, custom filename.
	;must be top-level node...
	;except for library-func(and future)...
	invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0 ;inline code.
	.IF ax==1
	  jmp tst2
	.ENDIF
	invoke SendDlgItemMessage,hdlg,403,BM_GETCHECK,0,0 ;normal func
	.IF ax==1
	  jmp tst2
	.ENDIF
	invoke SendDlgItemMessage,hdlg,401,BM_GETCHECK,0,0 ;isr func
	.IF ax==1
tst2:	  mov al,(OBJECT PTR [edi]).nring1colorindex
	  .IF al==0	;top-level node, ring1=black.
	  .ELSE
	    ;turn off all the dbl-clk buttons...
	    invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename
	    invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	    invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	    invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	    mov eax,TRUE	;have processed this button msg.
	    jmp zby1
	  .ENDIF
	.ENDIF
;library-func, etc, not concerned with levels.

      ;only allow inline, isr & normal funcs to select this(top-level)...
      ;121000 ...also library-func...
	invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0 ;inline code.
	.IF ax==1
	  jmp hh1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,401,BM_GETCHECK,0,0 ;isr func
	.IF ax==1
	  jmp hh1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,420,BM_GETCHECK,0,0 ;library func
	.IF ax==1
	  jmp hh1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,403,BM_GETCHECK,0,0 ;normal func
	.IF ax==1
hh1:	  invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,1,0 ;filename on.
	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	  invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	  invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	  mov eax,TRUE
	.ELSE
	  mov eax,FALSE
	.ENDIF
zby1:

    .ELSEIF ax==246	;dbl-clk to open a textfile, automatic filename.
	;must be top-level node...
	;except for library-func(and future)...
	invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0 ;inline code.
	.IF ax==1
	  jmp xtst2
	.ENDIF
	invoke SendDlgItemMessage,hdlg,403,BM_GETCHECK,0,0 ;normal func
	.IF ax==1
	  jmp xtst2
	.ENDIF
	invoke SendDlgItemMessage,hdlg,401,BM_GETCHECK,0,0 ;isr func
	.IF ax==1
xtst2:	  mov al,(OBJECT PTR [edi]).nring1colorindex
	  .IF al==0	;top-level node, ring1=black.
	  .ELSE
	    ;turn off all the dbl-clk buttons...
	    invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename
	    invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	    invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	    invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	    mov eax,TRUE	;have processed this button msg.
	    jmp xby1
	  .ENDIF
	.ENDIF
;library-func, etc, not concerned with levels.

      ;only allow inline, isr & normal funcs to select this(&top-level)...
      ;121000 ...also library-func...
	invoke SendDlgItemMessage,hdlg,408,BM_GETCHECK,0,0 ;inline code.
	.IF ax==1
	  jmp xhh1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,401,BM_GETCHECK,0,0 ;isr func
	.IF ax==1
	  jmp xhh1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,420,BM_GETCHECK,0,0 ;library func
	.IF ax==1
	  jmp xhh1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,403,BM_GETCHECK,0,0 ;normal func
	.IF ax==1
xhh1:	  invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename on.
	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	  invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	  invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,1,0 ;automatic
	  mov eax,TRUE
	.ELSE
	  mov eax,FALSE
	.ENDIF
xby1:


    .ELSEIF ax==245 ;dbl-clk to open a child diagram.
      ;can only be a library-func...
	invoke SendDlgItemMessage,hdlg,420,BM_GETCHECK,0,0 ;library func
	.IF ax==1
	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,1,0 ;diagram checked
	  invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,0,0 ;filename
	  invoke SendDlgItemMessage,hdlg,244,BM_SETCHECK,0,0 ;command
	  invoke SendDlgItemMessage,hdlg,246,BM_SETCHECK,0,0 ;automatic
	  mov eax,TRUE	;have processed this message.
	.ELSE
;	  invoke SendDlgItemMessage,hdlg,245,BM_SETCHECK,0,0 ;diagram
	  mov eax,FALSE
	.ENDIF


    .ELSEIF ax==228 ;checkbox, force label to be funcname...
      ;only allow to be checked/unchecked if normal or isr func...
      invoke SendDlgItemMessage,hdlg,403,BM_GETCHECK,0,0 ;normal func
      .IF ax==1
ww1:	;but if clone, must remain unchecked...
	cmp (OBJECT PTR [edi]).rpmaster,0
	jnz we2
	;toggle it...
	invoke SendDlgItemMessage,hdlg,228,BM_GETCHECK,0,0
	.IF ax==1	;checked.
we2:	  invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,0,0 ;uncheck it.
	.ELSE
	  invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;check it.
	.ENDIF
      .ELSE
	invoke SendDlgItemMessage,hdlg,401,BM_GETCHECK,0,0 ;isr func
	.IF ax==1
	  jmp ww1
	.ELSE
	  invoke SendDlgItemMessage,hdlg,420,BM_GETCHECK,0,0 ;library func
	  .IF ax==1
	    ;keep it always selected...
	    invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;check it.
	  .ELSE     ;inline etc...
	    ;keep it always unchecked...
	    invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,0,0 ;uncheck it.
	  .ENDIF
	.ENDIF
      .ENDIF
      mov eax,TRUE

    .ELSEIF ax==233 ;insert a ring (after)
	invoke SendDlgItemMessage,hdlg,233,BM_GETCHECK,0,0 ;insert.
	.IF ax==1
	  invoke SendDlgItemMessage,hdlg,233,BM_SETCHECK,0,0 ;clr it.
	.ELSE
	  invoke SendDlgItemMessage,hdlg,233,BM_SETCHECK,1,0 ;check it.
	.ENDIF
	invoke SendDlgItemMessage,hdlg,234,BM_SETCHECK,0,0 ;clr delete.
	mov eax,TRUE

    .ELSEIF ax==234 ;delete ring.
	invoke SendDlgItemMessage,hdlg,234,BM_GETCHECK,0,0 ;delete.
	.IF ax==1
	  invoke SendDlgItemMessage,hdlg,234,BM_SETCHECK,0,0 ;clr it.
	.ELSE
	  invoke SendDlgItemMessage,hdlg,234,BM_SETCHECK,1,0 ;check it.
	.ENDIF
	invoke SendDlgItemMessage,hdlg,233,BM_SETCHECK,0,0 ;clr insert.
	mov eax,TRUE



    .ELSE
      mov eax,FALSE
    .ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE


  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
KENTER5proc	ENDP
;--------------------------------------------------------------------------
commandproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;WM_RBUTTONDOWN > wmrbuttondown() > on a execution-icon (same as a node).
;brings up a dialog box.   "commandproc"

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit5 = display label on diagram, bit6=display filespec
	test  al,00100000b    ;test bit5
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
	test  al,01000000b    ;test bit6
	jz ke21v
	push eax
	invoke SendDlgItemMessage,hdlg,KDNN,BM_SETCHECK,1,0
	pop  eax
ke21v:
	test  al,01100000b	   ;test if display no text.
	jnz ke22
	push eax
	invoke SendDlgItemMessage,hdlg,KDNONE,BM_SETCHECK,1,0
	pop  eax

ke22:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display fill color...
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl+0 to +9 (10 digits)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,9,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .ncolor1 even if it's not turned on.
kenf2:

;display file number...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,Kobjnum,WM_SETTEXT,0,esi


;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.

;19-4-97 display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  cwde	    ;sign-extend ax>eax
	  neg eax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  cwde
	  neg eax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.

;display number of this object/element...
	xor  edx,edx
	xor  eax,eax
	mov  ax,(OBJECT PTR [edi]).number
	invoke bin2dec		;-->szasciitbl
	lea  esi,szasciitbl+4	;as value limited to 4 digits.
xoreldgblanks:	mov  al,[esi]	   ;ignore ldg blanks
		cmp  al," "	   ;/
		jne  xoldgblanks   ;/
		inc  esi	   ;/
		jmp  xoreldgblanks ;/
xoldgblanks:			   ;/
 invoke SendDlgItemMessage,hdlg,IDD_K5PU,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K5PU,EM_LIMITTEXT,4,0 ;set limit.

;extended filespec (was .szreplylabel/.timeout)...
;i.e. action after double-click
	lea  esi,(OBJECT PTR [edi]).sztext2
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,KSPEC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KSPEC,EM_LIMITTEXT,126,0 ;set limit.

;display label of node that owns this node...
;note that this is read-only, so no need to unload from dialog.
;note, "pointing to itself" when external comes from resources.
;-- not sure about usage with nodes.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	  .IF eax==edi	 ;when external it points to itself.
	    xor eax,eax
	    mov al,(OBJECT PTR [edi]).fstatus
	    and al,0100b	;also fstatus/bit2=1 if external.
	    .IF al==0100b
	      lea eax,szextern1
	      jmp SHORT ext1
	    .ENDIF
	  .ELSE
	    mov ebx,eax
	    lea eax,(OBJECT PTR [ebx]).sztext1
ext1:	    invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	  .ENDIF
	.ENDIF



      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK
      mov  g_fhaschanged,1

;update the database...

;get the name...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,64+128			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse)
		inc  esi			  ;/
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi


 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bx,1111111111011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,KDNN,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;filespec display checkbox is checked.
	  or  bl,01000000b	  ;bit6
	.ELSE
	  and bx,1111111110111111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl


;update font size in .fstatus field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .ncolour1 field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,10,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset

;double-click action...
	lea  eax,(OBJECT PTR [edi]).sztext2	   ;filespec.
	invoke SendDlgItemMessage,hdlg,KSPEC,WM_GETTEXT,127,eax


      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF ax==IDCANCEL ;(lo-wparam)
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE


    .ELSE
      mov eax,FALSE
    .ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE


  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
commandproc	ENDP
;--------------------------------------------------------------------------
infoproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;WM_RBUTTONDOWN > wmrbuttondown() > on a text-file-icon (like execution-icon).
;brings up a dialog box.   "infoproc"	(like commandproc())

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit5 = display label on diagram, bit6=display filespec
	test  al,00100000b    ;test bit5
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
	test  al,01000000b    ;test bit6
	jz ke21v
	push eax
	invoke SendDlgItemMessage,hdlg,KDNN,BM_SETCHECK,1,0
	pop  eax
ke21v:
	test  al,01100000b	   ;test if display no text.
	jnz ke22
	push eax
	invoke SendDlgItemMessage,hdlg,KDNONE,BM_SETCHECK,1,0
	pop  eax

ke22:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display fill color...
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl+0 to +9 (10 digits)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,9,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .ncolor1 even if it's not turned on.
kenf2:

;display file number...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,Kobjnum,WM_SETTEXT,0,esi


;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.

;19-4-97 display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  cwde	    ;sign-extend ax>eax
	  neg eax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  cwde
	  neg eax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.

;display number of this object/element...
	xor  edx,edx
	xor  eax,eax
	mov  ax,(OBJECT PTR [edi]).number
	invoke bin2dec		;-->szasciitbl
	lea  esi,szasciitbl+4	;as value limited to 4 digits.
xoreldgblanks:	mov  al,[esi]	   ;ignore ldg blanks
		cmp  al," "	   ;/
		jne  xoldgblanks   ;/
		inc  esi	   ;/
		jmp  xoreldgblanks ;/
xoldgblanks:			   ;/
 invoke SendDlgItemMessage,hdlg,IDD_K5PU,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K5PU,EM_LIMITTEXT,4,0 ;set limit.

;extended filespec (was .szreplylabel/.timeout)...
;i.e. action after double-click
	lea  esi,(OBJECT PTR [edi]).sztext2
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,KSPEC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KSPEC,EM_LIMITTEXT,126,0 ;set limit.

;display label of node that owns this node...
;note that this is read-only, so no need to unload from dialog.
;note, "pointing to itself" when external comes from resources.
;-- not sure about usage with nodes.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	  .IF eax==edi	 ;when external it points to itself.
	    xor eax,eax
	    mov al,(OBJECT PTR [edi]).fstatus
	    and al,0100b	;also fstatus/bit2=1 if external.
	    .IF al==0100b
	      lea eax,szextern1
	      jmp SHORT ext1
	    .ENDIF
	  .ELSE
	    mov ebx,eax
	    lea eax,(OBJECT PTR [ebx]).sztext1
ext1:	    invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	  .ENDIF
	.ENDIF

;have 3 radiobuttons. id=228, compose "#include "filespec""
; id=229, compose insert contents of text-file, id=232, insert text.
;only applies if text-file icon is a child...
;(see also handler for id==228 below)
    mov eax,(OBJECT PTR [edi]).rplock1
    .IF eax==0
	;insert-text editbox...
	invoke SendDlgItemMessage,hdlg,233,EM_SETREADONLY,TRUE,0
    .ELSE
      mov al,(OBJECT PTR [edi]).fconfig2
      and al,01110000b	;extract bits 4/5/6.
      .IF al==00010000b ;"#include "filespec"".
jj:	invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;tick it.
      .ELSEIF al==00100000b ;insert contents of textfile.
	invoke SendDlgItemMessage,hdlg,229,BM_SETCHECK,1,0 ;tick it.
      .ELSEIF al==01000000b ;insert text.
	invoke SendDlgItemMessage,hdlg,232,BM_SETCHECK,1,0 ;tick it.
      .ELSE
	;none selected. default...
	or (OBJECT PTR [edi]).fconfig2,00010000b ;set bit 4.
	jmp jj
      .ENDIF
    .ENDIF

;also upload "insert text" field (.sztext5--8)...
	lea  esi,(OBJECT PTR [edi]).sztext5
 invoke SendDlgItemMessage,hdlg,233,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,233,EM_LIMITTEXT,(384+128+384-2),0 ;limit.
;it will be greyed-out maybe...
      mov al,(OBJECT PTR [edi]).fconfig2
      and al,01110000b	;extract bits 4/5/6.
      .IF al==01000000b ;insert text.
      .ELSE
	invoke SendDlgItemMessage,hdlg,233,EM_SETREADONLY,TRUE,0
      .ENDIF



      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK
      mov  g_fhaschanged,1

;update the database...

;get the name...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,64+128+64+384+128+384	  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse)
		inc  esi			  ;/
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi


 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bx,1111111111011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,KDNN,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;filespec display checkbox is checked.
	  or  bl,01000000b	  ;bit6
	.ELSE
	  and bx,1111111110111111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl


;update font size in .fstatus field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .ncolour1 field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,10,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset

;double-click action...
	lea  eax,(OBJECT PTR [edi]).sztext2	   ;filespec.
	invoke SendDlgItemMessage,hdlg,KSPEC,WM_GETTEXT,127,eax

;insert mode...
   invoke SendDlgItemMessage,hdlg,228,BM_GETCHECK,0,0 ;#include "filespec".
   .IF ax==1
     mov al,(OBJECT PTR [edi]).fconfig2
     and al,10001111b
     or al,00010000b
     mov (OBJECT PTR [edi]).fconfig2,al
   .ENDIF
   invoke SendDlgItemMessage,hdlg,229,BM_GETCHECK,0,0 ;insert file.
   .IF ax==1
     mov al,(OBJECT PTR [edi]).fconfig2
     and al,10001111b
     or al,00100000b
     mov (OBJECT PTR [edi]).fconfig2,al
   .ENDIF
   invoke SendDlgItemMessage,hdlg,232,BM_GETCHECK,0,0 ;insert text.
   .IF ax==1
     mov al,(OBJECT PTR [edi]).fconfig2
     and al,10001111b
     or al,01000000b
     mov (OBJECT PTR [edi]).fconfig2,al
       ;and download editbox...
	lea  eax,(OBJECT PTR [edi]).sztext5   ;.sztext5--8.
	invoke SendDlgItemMessage,hdlg,233,WM_GETTEXT,(384+128+384-1),eax
   .ENDIF





      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF ax==IDCANCEL ;(lo-wparam)
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE

    .ELSEIF ax==228	;compose #include radiobutton.
      ;have 3 radiobuttons. id=228, compose "#include "filespec""
      ; id=229, compose insert contents of text-file, id=232 insert text.
      ;only applies if text-file icon is a child...
      mov eax,(OBJECT PTR [edi]).rplock1
      .IF eax==0
      .ELSE
	invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0 ;#include.
	invoke SendDlgItemMessage,hdlg,229,BM_SETCHECK,0,0 ;insert file.
	invoke SendDlgItemMessage,hdlg,232,BM_SETCHECK,0,0 ;insert text.
	invoke SendDlgItemMessage,hdlg,233,EM_SETREADONLY,TRUE,0
      .ENDIF
      mov eax,TRUE  ;have processed message.

    .ELSEIF ax==229	;compose insert-file radiobutton.
      ;have 3 radiobuttons. id=228, compose "#include "filespec""
      ; id=229, compose insert contents of text-file, id=232 insert text.
      ;only applies if text-file icon is a child...
      mov eax,(OBJECT PTR [edi]).rplock1
      .IF eax==0
      .ELSE
	invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,0,0 ;#include.
	invoke SendDlgItemMessage,hdlg,229,BM_SETCHECK,1,0 ;insert file.
	invoke SendDlgItemMessage,hdlg,232,BM_SETCHECK,0,0 ;insert text.
	invoke SendDlgItemMessage,hdlg,233,EM_SETREADONLY,TRUE,0
      .ENDIF
      mov eax,TRUE  ;have processed message.

    .ELSEIF ax==232	;compose insert-text radiobutton.
      ;have 3 radiobuttons. id=228, compose "#include "filespec""
      ; id=229, compose insert contents of text-file, id=232 insert text.
      ;only applies if text-file icon is a child...
      mov eax,(OBJECT PTR [edi]).rplock1
      .IF eax==0
      .ELSE
	invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,0,0 ;#include.
	invoke SendDlgItemMessage,hdlg,229,BM_SETCHECK,0,0 ;insert file.
	invoke SendDlgItemMessage,hdlg,232,BM_SETCHECK,1,0 ;insert text.
	invoke SendDlgItemMessage,hdlg,233,EM_SETREADONLY,FALSE,0
      .ENDIF
      mov eax,TRUE  ;have processed message.



    .ELSE
      mov eax,FALSE
    .ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE


  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
infoproc	ENDP
;--------------------------------------------------------------------------
.DATA
szermp1 BYTE "One or more top-level nodes must be highlighted first.",0Dh,0Ah
	BYTE "Exit from this dialog-box. Hold down the <shift> key and "
	BYTE "left-click on the top-level nodes, in order in which you "
	BYTE "want them to be composed. They will then be highlighted. "
	BYTE "Then right-click on the make-icon to bring up the dialog-box "
	BYTE "and hit the ""Load"" button.",0

.CODE
makeproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL phighi:DWORD
    LOCAL pszscr1:DWORD
;WM_RBUTTONDOWN > wmrbuttondown() > on a make-icon (like execution-icon).
;dialog box callback.	 "makeproc"	(like commandproc())
;g_phighlightedobjectprev-->previous highlighted object, if any
;(this may be a top-level node) -- press "Load" button to load it.

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit5 = display label on diagram, bit6=display node# list.
	test  al,00100000b    ;test bit5
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
	test  al,01000000b    ;test bit6
	jz ke21v
	push eax
	invoke SendDlgItemMessage,hdlg,KDNN,BM_SETCHECK,1,0
	pop  eax
ke21v:
	test  al,01100000b	   ;test if display no text.
	jnz ke22
	push eax
	invoke SendDlgItemMessage,hdlg,KDNONE,BM_SETCHECK,1,0
	pop  eax

ke22:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display fill color...
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl+0 to +9 (10 digits)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,9,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .ncolor1 even if it's not turned on.
kenf2:

;display file number...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,Kobjnum,WM_SETTEXT,0,esi


;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.

;19-4-97 display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  cwde	    ;sign-extend ax>eax
	  neg eax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  cwde
	  neg eax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.

;display number of this object/element...
	xor  edx,edx
	xor  eax,eax
	mov  ax,(OBJECT PTR [edi]).number
	invoke bin2dec		;-->szasciitbl
	lea  esi,szasciitbl+4	;as value limited to 4 digits.
xoreldgblanks:	mov  al,[esi]	   ;ignore ldg blanks
		cmp  al," "	   ;/
		jne  xoldgblanks   ;/
		inc  esi	   ;/
		jmp  xoreldgblanks ;/
xoldgblanks:			   ;/
 invoke SendDlgItemMessage,hdlg,IDD_K5PU,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K5PU,EM_LIMITTEXT,4,0 ;set limit.

;node# list...
;i.e. action after double-click
	lea  esi,(OBJECT PTR [edi]).sztext2
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,KSPEC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KSPEC,EM_LIMITTEXT,126,0 ;set limit.

;display label of node that owns this node...
;note that this is read-only, so no need to unload from dialog.
;note, "pointing to itself" when external comes from resources.
;-- not sure about usage with nodes.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	  .IF eax==edi	 ;when external it points to itself.
	    xor eax,eax
	    mov al,(OBJECT PTR [edi]).fstatus
	    and al,0100b	;also fstatus/bit2=1 if external.
	    .IF al==0100b
	      lea eax,szextern1
	      jmp SHORT ext1
	    .ENDIF
	  .ELSE
	    mov ebx,eax
	    lea eax,(OBJECT PTR [ebx]).sztext1
ext1:	    invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	  .ENDIF
	.ENDIF



      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK
      mov  g_fhaschanged,1

;update the database...

;get the name...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,64+128			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse)
		inc  esi			  ;/
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi


 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bx,1111111111011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,KDNN,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;node#-list display checkbox is checked.
	  or  bl,01000000b	  ;bit6
	.ELSE
	  and bx,1111111110111111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl


;update font size in .fstatus field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bx,1111111111100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .ncolour1 field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,10,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset

;double-click action...
	lea  eax,(OBJECT PTR [edi]).sztext2	   ;node#-list.
	invoke SendDlgItemMessage,hdlg,KSPEC,WM_GETTEXT,127,eax


      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF ax==IDCANCEL ;(lo-wparam)
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE

    .ELSEIF ax==227	;"Load" button.
      ;if previously left-clicked on one or more top-level nodes
      ;(with <shift> key held down), prior to
      ;right-down on make-icon, should have entires in highlighted-list,
      ;pting to node, else 0. load these into "KSPEC" edit box
      ;(node#-list) as ascii-element#...
      ;note, not using individual selection g_phighlightedobject, as
      ;cannot bring up this dialog box (as state=2). But when objects
      ;added to highlighted-list, state=0.
      mov szscr1,0
      lea eax,szscr1
      mov pszscr1,eax
      mov ebx,0
end2: lea esi,highlighted
      mov eax,highlightedindex
      .IF eax==0
	lea eax,szermp1
	invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	jmp end1x	;get out, nothing in list.
      .ENDIF
      shl eax,1
      shl eax,1
      .IF ebx==eax
	jmp end1	    ;get out.
      .ELSE
	.IF ebx==0	    ;ebx =offset into list.
	.ELSE
	  ;append a comma...
	  mov edi,pszscr1
	  mov [edi],BYTE PTR ","
	  mov [edi+1],BYTE PTR 0
	  inc pszscr1
	.ENDIF
      .ENDIF
      mov edi,[esi+ebx]
      cmp edi,0
      je end2b	    ;precaution, 0 entry in list.
      mov phighi,ebx ;save.
      ;edi-->node...
	mov ebx,edi
	;have ptr to node in ebx...
	.IF ebx==0
	.ELSE
	  xor eax,eax
	  mov ax,(OBJECT PTR [ebx]).number ;element#
	  xor  edx,edx
	  invoke bin2dec		;-->szasciitbl
	  lea  esi,szasciitbl+4	;as value limited to 4 digits.
blanks1:	mov  al,[esi]	   ;ignore ldg blanks
		cmp  al," "	   ;/
		jne  blanks2	 ;/
		inc  esi	   ;/
		jmp  blanks1 ;/
blanks2:  mov edi,pszscr1
	  invoke lstrcpy, edi,esi   ;append.
	  invoke lstrlen, esi
	  add pszscr1,eax
	.ENDIF
      mov ebx,phighi
end2b: add ebx,4
      jmp end2
end1: lea esi,szscr1
      invoke SendDlgItemMessage,hdlg,KSPEC,WM_SETTEXT,0,esi
end1x:
      mov eax,TRUE


    .ELSE
      mov eax,FALSE
    .ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE


  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
makeproc	ENDP
;--------------------------------------------------------------------------
KENTER2proc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL ntype:WORD
;wire dialog. id=206	"wireproc"

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG

;set checkboxes for wire type...
    mov ax,(OBJECT PTR [edi]).nexttype
    .IF al==10	    ;sync 1-way
	invoke SendDlgItemMessage,hdlg,155,BM_SETCHECK,1,0
    .ELSEIF al==11  ;sync 2-way
	invoke SendDlgItemMessage,hdlg,156,BM_SETCHECK,1,0
    .ELSEIF al==13  ;async 1-way
	invoke SendDlgItemMessage,hdlg,157,BM_SETCHECK,1,0
    .ELSEIF al==14  ;async 2-way
	invoke SendDlgItemMessage,hdlg,158,BM_SETCHECK,1,0
    .ENDIF

;upload passed params...
	lea  esi,(OBJECT PTR [edi]).sztext1  ;sztext1+2+3
 invoke SendDlgItemMessage,hdlg,151,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,151,EM_LIMITTEXT,190,0 ;set limit.

;upload return param...
	lea  esi,(OBJECT PTR [edi]).sztext4
 invoke SendDlgItemMessage,hdlg,153,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,153,EM_LIMITTEXT,62,0 ;set limit.

;display label checkbox...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit5 = display label on diagram
	test  al,00100000b    ;test bit5
	jz ke21
	invoke SendDlgItemMessage,hdlg,154,BM_SETCHECK,1,0
ke21:

;set checkbox for inter-task wire...
	mov al,(OBJECT PTR [edi]).fconfig
	and al,0100000b     ;extract bit5
	.IF al==0100000b
	  invoke SendDlgItemMessage,hdlg,214,BM_SETCHECK,1,0
	.ENDIF

;grey some edit boxes, depending on wire type...
      invoke SendDlgItemMessage,hdlg,155,BM_GETCHECK,0,0
      .IF ax==1
       invoke SendDlgItemMessage,hdlg,153,EM_SETREADONLY,TRUE,0 ;returnparam
      .ENDIF
      invoke SendDlgItemMessage,hdlg,156,BM_GETCHECK,0,0
      .IF ax==1
      .ENDIF
      invoke SendDlgItemMessage,hdlg,157,BM_GETCHECK,0,0
      .IF ax==1
       invoke SendDlgItemMessage,hdlg,153,EM_SETREADONLY,TRUE,0 ;returnparam
       invoke SendDlgItemMessage,hdlg,151,EM_SETREADONLY,TRUE,0 ;passparam
      .ENDIF
      invoke SendDlgItemMessage,hdlg,158,BM_GETCHECK,0,0
      .IF ax==1
       invoke SendDlgItemMessage,hdlg,153,EM_SETREADONLY,TRUE,0 ;returnparam
       invoke SendDlgItemMessage,hdlg,151,EM_SETREADONLY,TRUE,0 ;passparam
      .ENDIF




      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK
      mov  g_fhaschanged,1

 invoke SendDlgItemMessage,hdlg,154,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;display-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bx,1111111111011111b
	.ENDIF
	mov (OBJECT PTR [edi]).fstatus,bl

;get the passed parameters string...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,256			  ;/ (zeroise
xzoo1:		mov  [esi],BYTE PTR 0		  ;/  sztext1/2/3/4
		inc  esi			  ;/
		loop xzoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,151,WM_GETTEXT,191,esi

;get the returned param string...
	lea  esi,(OBJECT PTR [edi]).sztext4
 invoke SendDlgItemMessage,hdlg,153,WM_GETTEXT,63,esi

;get wire-type checkboxes...
   ;but also perform a wire-syntax check...
   mov ax,(OBJECT PTR [edi]).nexttype
   mov ntype,ax
   invoke SendDlgItemMessage,hdlg,155,BM_GETCHECK,0,0
	.IF ax==1
	  .IF ntype==10
	  .ELSE
	    invoke wiresyntaxcheck, edi,10
	    .IF eax==0
	      mov (OBJECT PTR [edi]).nexttype,10	;sync 1-way
	    .ELSE
	      jmp dd1	    ;don't end dialog box.
	    .ENDIF
	  .ENDIF
	.ENDIF
   invoke SendDlgItemMessage,hdlg,156,BM_GETCHECK,0,0
	.IF ax==1
	  .IF ntype==11
	  .ELSE
	    invoke wiresyntaxcheck, edi,11
	    .IF eax==0
	      mov (OBJECT PTR [edi]).nexttype,11	;sync 2-way
	    .ELSE
	      jmp dd1	    ;don't end dialog box.
	    .ENDIF
	  .ENDIF
	.ENDIF
   invoke SendDlgItemMessage,hdlg,157,BM_GETCHECK,0,0
	.IF ax==1
	  .IF ntype==13
	  .ELSE
	    invoke wiresyntaxcheck, edi,13
	    .IF eax==0
	      mov (OBJECT PTR [edi]).nexttype,13	;async 1-way
	    .ELSE
	      jmp dd1	    ;don't end dialog box.
	    .ENDIF
	  .ENDIF
	.ENDIF
   invoke SendDlgItemMessage,hdlg,158,BM_GETCHECK,0,0
	.IF ax==1
	  .IF ntype==14
	  .ELSE
	    invoke wiresyntaxcheck, edi,14
	    .IF eax==0
	      mov (OBJECT PTR [edi]).nexttype,14	;async 2-way
	    .ELSE
	      jmp dd1	    ;don't end dialog box.
	    .ENDIF
	  .ENDIF
	.ENDIF

;get inter-task checkbox...
 invoke SendDlgItemMessage,hdlg,214,BM_GETCHECK,0,0
 mov bl,(OBJECT PTR [edi]).fconfig
 .IF ax==1
   or bl,0100000b    ;set bit5
 .ELSE
   and bl,11011111b
 .ENDIF
 mov (OBJECT PTR [edi]).fconfig,bl


      invoke EndDialog, hdlg,TRUE
dd1:  mov eax,TRUE

    .ELSEIF ax==IDCANCEL    ;lo-wparam
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE

    .ELSEIF ax==155	;sync 1-way wire.
      invoke SendDlgItemMessage,hdlg,155,BM_GETCHECK,0,0
      .IF ax==1
       invoke SendDlgItemMessage,hdlg,153,EM_SETREADONLY,TRUE,0 ;returnparam
       invoke SendDlgItemMessage,hdlg,151,EM_SETREADONLY,FALSE,0 ;passparam
      .ENDIF
      mov eax,TRUE

    .ELSEIF ax==156	;sync 2-way wire.
      invoke SendDlgItemMessage,hdlg,156,BM_GETCHECK,0,0
      .IF ax==1
       invoke SendDlgItemMessage,hdlg,153,EM_SETREADONLY,FALSE,0 ;returnparam
       invoke SendDlgItemMessage,hdlg,151,EM_SETREADONLY,FALSE,0 ;passparam
      .ENDIF
      mov eax,TRUE

    .ELSEIF ax==157	;async 1-way wire.
      invoke SendDlgItemMessage,hdlg,157,BM_GETCHECK,0,0
      .IF ax==1
       invoke SendDlgItemMessage,hdlg,153,EM_SETREADONLY,TRUE,0 ;returnparam
       invoke SendDlgItemMessage,hdlg,151,EM_SETREADONLY,TRUE,0 ;passparam
      .ENDIF
      mov eax,TRUE

    .ELSEIF ax==158	;async 2-way wire.
      invoke SendDlgItemMessage,hdlg,158,BM_GETCHECK,0,0
      .IF ax==1
       invoke SendDlgItemMessage,hdlg,153,EM_SETREADONLY,TRUE,0 ;returnparam
       invoke SendDlgItemMessage,hdlg,151,EM_SETREADONLY,TRUE,0 ;passparam
      .ENDIF
      mov eax,TRUE



    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
KENTER2proc	ENDP
;--------------------------------------------------------------------------
xKENTER2proc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL ntype:WORD
;async. wire dialog. id=213

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG

;set checkboxes for wire type...
    mov ax,(OBJECT PTR [edi]).nexttype
    .IF al==10	    ;sync 1-way
	invoke SendDlgItemMessage,hdlg,155,BM_SETCHECK,1,0
    .ELSEIF al==11  ;sync 2-way
	invoke SendDlgItemMessage,hdlg,156,BM_SETCHECK,1,0
    .ELSEIF al==13  ;async 1-way
	invoke SendDlgItemMessage,hdlg,157,BM_SETCHECK,1,0
    .ELSEIF al==14  ;async 2-way
	invoke SendDlgItemMessage,hdlg,158,BM_SETCHECK,1,0
    .ENDIF

;*NOTE* currently not passing params with async wires...

;;upload passed params...
;	lea  esi,(OBJECT PTR [edi]).sztext1  ;sztext1+2+3
; invoke SendDlgItemMessage,hdlg,151,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,151,EM_LIMITTEXT,190,0 ;set limit.
;
;;upload return param...
;	lea  esi,(OBJECT PTR [edi]).sztext4
; invoke SendDlgItemMessage,hdlg,153,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,153,EM_LIMITTEXT,62,0 ;set limit.
;
;;display label checkbox...
;	xor eax,eax
;	mov	al,(OBJECT PTR [edi]).fstatus
;	;bit5 = display label on diagram
;	test  al,00100000b    ;test bit5
;	jz ke21
;	invoke SendDlgItemMessage,hdlg,154,BM_SETCHECK,1,0
;ke21:



      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK
      mov  g_fhaschanged,1

; invoke SendDlgItemMessage,hdlg,154,BM_GETCHECK,0,0
;	xor ebx,ebx
;	mov	bl,(OBJECT PTR [edi]).fstatus
;	.IF ax==1	;display-label button is checked.
;	  or  bl,00100000b
;	.ELSE
;	  and bx,1111111111011111b
;	.ENDIF
;	mov (OBJECT PTR [edi]).fstatus,bl
;
;;get the passed parameters string...
;		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
;		mov  ecx,256			  ;/ (zeroise
;xzoo1:		mov  [esi],BYTE PTR 0		  ;/  sztext1/2/3/4
;		inc  esi			  ;/
;		loop xzoo1			  ;/
;	lea  esi,(OBJECT PTR [edi]).sztext1
; invoke SendDlgItemMessage,hdlg,151,WM_GETTEXT,191,esi
;
;;get the returned param string...
;	lea  esi,(OBJECT PTR [edi]).sztext4
; invoke SendDlgItemMessage,hdlg,153,WM_GETTEXT,63,esi

;get wire-type checkboxes...
   ;but also perform a wire-syntax check...
   mov ax,(OBJECT PTR [edi]).nexttype
   mov ntype,ax
   invoke SendDlgItemMessage,hdlg,155,BM_GETCHECK,0,0
	.IF ax==1
	  .IF ntype==10
	  .ELSE
	    invoke wiresyntaxcheck, edi,10
	    .IF eax==0
	      mov (OBJECT PTR [edi]).nexttype,10	;sync 1-way
	    .ELSE
	      jmp dd1	    ;don't end dialog box.
	    .ENDIF
	  .ENDIF
	.ENDIF
   invoke SendDlgItemMessage,hdlg,156,BM_GETCHECK,0,0
	.IF ax==1
	  .IF ntype==11
	  .ELSE
	    invoke wiresyntaxcheck, edi,11
	    .IF eax==0
	      mov (OBJECT PTR [edi]).nexttype,11	;sync 2-way
	    .ELSE
	      jmp dd1	    ;don't end dialog box.
	    .ENDIF
	  .ENDIF
	.ENDIF
   invoke SendDlgItemMessage,hdlg,157,BM_GETCHECK,0,0
	.IF ax==1
	  .IF ntype==13
	  .ELSE
	    invoke wiresyntaxcheck, edi,13
	    .IF eax==0
	      mov (OBJECT PTR [edi]).nexttype,13	;async 1-way
	    .ELSE
	      jmp dd1	    ;don't end dialog box.
	    .ENDIF
	  .ENDIF
	.ENDIF
   invoke SendDlgItemMessage,hdlg,158,BM_GETCHECK,0,0
	.IF ax==1
	  .IF ntype==14
	  .ELSE
	    invoke wiresyntaxcheck, edi,14
	    .IF eax==0
	      mov (OBJECT PTR [edi]).nexttype,14	;async 2-way
	    .ELSE
	      jmp dd1	    ;don't end dialog box.
	    .ENDIF
	  .ENDIF
	.ENDIF



      invoke EndDialog, hdlg,TRUE
dd1:  mov eax,TRUE
    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
xKENTER2proc	ENDP
;--------------------------------------------------------------------------
.DATA
startup STARTUPINFO < >       ;needs all zeros in fields.
nbytesw DWORD 0,0
szerne1 BYTE "You have not yet specified an external editor. Go to "
	BYTE "menu ""Control/Configuration.../Language & Editor..."" "
	BYTE "to choose the editor.",0
sztemptxt BYTE "temp.txt",0
szerne2 BYTE "GOOSEE could not open the temporary file ""temp.txt"". "
	BYTE "Maybe another application has it open? Does it exist? "
	BYTE "-- if not, create it using an editor, and save in "
	BYTE "working (current) directory (GOOSEE does not look outside "
	BYTE "the current directory for it, i.e., no PATH spec is used). "
	BYTE "Aborting use of external editor.",0
szerfs9 BYTE "Comment, Condition, and Action elements can only store "
	BYTE "a text string of 1022 characters. You have entered more "
	BYTE "than this in the external editor. The text in these "
	BYTE "elements should not be so big, and you are not keeping "
	BYTE "to GOO modularity principles. GOOSEE is now forced to "
	BYTE "truncate the extra text. However, it is not lost -- "
	BYTE "at least not immediately -- open ""temp.txt"" immediately "
	BYTE "with your editor and save the extra text somewhere else.",0
;	BYTE "NOTE also that stupid Notepad.exe pads a small file with "
;	BYTE "space characters and saves it as a file of about 1030 bytes "
;	BYTE "-- GOOSEE handles this by not reading ""temp.txt"" past "
;	BYTE "any string of 30 space characters -- it does however "
;	BYTE "mean that you'll get this error message if your actual "
;	BYTE "text reaches 1022-30 characters.",0

.CODE
KENTER30Cproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;called from wmrbuttondown()/state0.  "commentproc"

	mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit5 = display label on diagram, bit6=display terminal #s.
	test  al,00100000b
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
ke22:
	and  al,00011000b
	.IF  al==0		;x1 font
	  invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	  invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	  invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	  invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display current wire label...
	lea  esi,(OBJECT PTR [edi]).sztext2
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,1022,0 ;set limit.



      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK
      mov  g_fhaschanged,1

;update label...
		lea  esi,(OBJECT PTR [edi]).sztext2 ;zeroise it first.
		mov  ecx,1024			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext2/3/4/5)
		loop zoo1			  ;/
		lea  esi,(OBJECT PTR [edi]).sztext2
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,1023,esi

 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bl,11011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update font size in .fstatus field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl



      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE


    .ELSEIF wparam==250  ;"external editor" button pressed
      ;we want to launch the editor, spec'd in .szeditor,
      ;with a temp filename, say temp.txt, zeroised, then on exit
      ;read the file...
	    mov	edi,prbuttonobject
	    lea eax,(OBJECT PTR [edi]).sztext2
	    invoke openexternaleditor, eax
	    .IF eax==1
	      invoke EndDialog, hdlg,TRUE
	    .ENDIF

      mov eax,TRUE
    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
KENTER30Cproc	ENDP
;--------------------------------------------------------------------------
openexternaleditor PROC STDCALL USES ebx ecx edx esi edi, pdest:DWORD
    LOCAL hfile:DWORD
    LOCAL eaxsave:DWORD
    LOCAL procinfo:PROCESS_INFORMATION
    LOCAL nfsize:DWORD
    LOCAL nspaces:BYTE
;open editor specified in TERSEDATA.szeditor, open "temp.txt",
;write file to pdest.

      mov ebx,pTERSEDATA
      lea ecx,(TERSEDATA PTR [ebx]).szeditor
	mov ebx,ecx
	mov al,[ebx]
	.IF al==0	;no editor.
	    lea	eax,szerne1
ex1:	    invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
	.ELSE
	  ;open file temp.txt...
	  invoke CreateFile, ADDR sztemptxt,\
		GENERIC_READ+GENERIC_WRITE,\
		0,	;don't share! FILE_SHARE_READ+FILE_SHARE_WRITE,\
		0, TRUNCATE_EXISTING,\	;opens an existing file, zeroised.
		FILE_FLAG_WRITE_THROUGH, 0
	  .IF eax==INVALID_HANDLE_VALUE	;-1
	    ;open failed ...
	    lea eax,szerne2		;msg error opening file.
	    jmp ex1
	  .ENDIF
	    mov hfile,eax
	    ;write OBJECT.sztext2--6 (1022+2 chars) to the file
	    mov eax,pdest
	    invoke lstrlen,eax
	    mov ebx,pdest
	    invoke WriteFile, hfile,ebx,eax,ADDR nbytesw,0
;	    invoke FlushFileBuffers, hfile
	    invoke CloseHandle,hfile
	  ;start editor...
	  mov ebx,pTERSEDATA
	  lea ecx,(TERSEDATA PTR [ebx]).szeditor
	  lea eax,szcommandline
	  invoke lstrcpy, eax,ecx
	  lea eax,szcommandline
	  invoke lstrlen, eax
	  add eax,OFFSET szcommandline
	  mov ebx,eax
	  mov [ebx],BYTE PTR " "
	  inc ebx
	  lea eax,sztemptxt
	  invoke lstrcpy, ebx,eax
;	  invoke WinExec, ADDR szcommandline, SW_SHOW ;call editor.

	    mov startup.si_cb,STARTUPINFO_
	    mov startup.si_wShowWindow,SW_SHOW
	    mov startup.si_dwFlags,STARTF_USESHOWWINDOW
	    invoke CreateProcess, 0,ADDR szcommandline,0,0,0,0,0,0, \
			    ADDR startup, ADDR procinfo
	    ;now wait until process has finished...
	    mov eax,procinfo.pi_hProcess    ;handle to the process.
	    invoke WaitForSingleObject, eax,INFINITE ;wait forever.

	  ;now open the file again...
	  invoke CreateFile, ADDR sztemptxt,\
		GENERIC_READ,\
		0,\ 			;don't share!!!
		0, OPEN_EXISTING,\	;opens an existing file.
		FILE_FLAG_WRITE_THROUGH, 0
	  .IF eax==INVALID_HANDLE_VALUE	;-1
	    ;open failed ...
		lea eax,szerne2		;msg error.
		jmp ex1
	  .ENDIF
	  mov hfile,eax
	    ;now read from the file...
	    mov edi,prbuttonobject
	    lea esi,(OBJECT PTR [edi]).sztext2
	    mov nfsize,0
	    mov nspaces,0
	    dec esi
rdnxt:	    inc esi
	    invoke ReadFile, hfile,esi,1,ADDR nbytesw,0 ;read 1 char.
	    .IF nbytesw==0
	      jmp rddone
	    .ENDIF
	      mov BYTE PTR al,[esi] ;in case end is padded with spaces.
	      .IF al==" "
		inc nspaces
		.IF nspaces>=30	;arbitrary
		  sub esi,29
		  mov [esi],BYTE PTR 0
		  jmp SHORT rddone2
		.ENDIF
	      .ELSE
		mov nspaces,0
	      .ENDIF
	    inc nfsize
	    cmp nfsize,1023
	    jae rderr
	    cmp [esi],BYTE PTR 01Ah ;ctrl-Z, end-of-file character.
	    jne rdnxt
	    jmp SHORT rddone
rderr:
	      ;error...
	      lea eax,szerfs9
	      invoke MessageBox,g_hwnd, eax, 0, MB_OK+MB_ICONEXCLAMATION
rddone:     mov [esi],BYTE PTR 0
rddone2:

	  invoke CloseHandle, hfile
	  mov eax,1
	  ret
	.ENDIF

    mov eax,0
    ret
openexternaleditor ENDP
;--------------------------------------------------------------------------
KENTER33proc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;from wmrbuttondown()/state0/on-an-action-object "actionproc"

	mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit5 = display label on diagram, bit6=display terminal #s.
	test  al,00100000b
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
ke22:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display current wire label...
	lea  esi,(OBJECT PTR [edi]).sztext2 ;sztext2+3+4+5+6 (1024chars)
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,1022,0 ;set limit.

;set checkbox for exit-after-action...
	test (OBJECT PTR [edi]).fconfig,00100000b  ;bit5.
	jz  ke33
	invoke SendDlgItemMessage,hdlg,331,BM_SETCHECK,1,0
ke33:

;display ring# on parent that action is on...
	xor eax,eax
	mov  al,(OBJECT PTR [edi]).nbeginring
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,416,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,416,EM_LIMITTEXT,2,0 ;set limit.

;set checkbox, to not auto-compose trailing ";"...
	test (OBJECT PTR [edi]).fconfig2,001000b  ;bit3.
	jz  wke33
	invoke SendDlgItemMessage,hdlg,224,BM_SETCHECK,1,0
wke33:


      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK
      mov  g_fhaschanged,1

;update label...
		lea  esi,(OBJECT PTR [edi]).sztext2 ;zeroise it first.
		mov  ecx,1024			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse)
		inc  esi			  ;/ sztext2/3/4/5/6
		loop zoo1			  ;/
	lea esi,(OBJECT PTR [edi]).sztext2
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,1023,esi

 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bl,11011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update font size in .fstatus field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update exit-after-action bit...
 invoke SendDlgItemMessage,hdlg,331,BM_GETCHECK,0,0
	.IF  ax==1
	  or  (OBJECT PTR [edi]).fconfig,00100000b
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11011111b
	.ENDIF

;update ring# on parent that action is set to...
 invoke SendDlgItemMessage,hdlg,416,WM_GETTEXT,3,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).nbeginring,al

;update do not auto-compose trailing ";" flag...
       invoke SendDlgItemMessage,hdlg,224,BM_GETCHECK,0,0
	.IF  ax==1
	  or  (OBJECT PTR [edi]).fconfig2,00001000b  ;bit3
	.ELSE
	  and (OBJECT PTR [edi]).fconfig2,11110111b
	.ENDIF


      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE


    .ELSEIF wparam==250  ;"external editor" button pressed
      ;we want to launch the editor, spec'd in .szeditor,
      ;with a temp filename, say temp.txt, then on exit
      ;read the file and zeroise it.
	    mov	edi,prbuttonobject
	    lea eax,(OBJECT PTR [edi]).sztext2
	    invoke openexternaleditor, eax
	    .IF eax==1
	      invoke EndDialog, hdlg,TRUE
	    .ENDIF

      mov eax,TRUE

    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
KENTER33proc	ENDP
;--------------------------------------------------------------------------
KENTER30proc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
; from wmrbuttondown/state0/on-an-condition-object  "conditionproc"

	mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit5 = display label on diagram, bit6=display terminal #s.
	test  al,00100000b
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
ke22:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display current wire label...
	lea  esi,(OBJECT PTR [edi]).sztext2
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
;set limits on max chars...
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,1022,0 ;set limit.

;display ring# on parent that condition is on...
	xor eax,eax
	mov  al,(OBJECT PTR [edi]).nbeginring
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,416,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,416,EM_LIMITTEXT,2,0 ;set limit.


;decision type...
	mov al,(OBJECT PTR [edi]).fconfig2
	and al,011b
	.IF al==01	;if-then
	  invoke SendDlgItemMessage,hdlg,214,BM_SETCHECK,1,0
	.ELSE		;while-do
	  invoke SendDlgItemMessage,hdlg,216,BM_SETCHECK,1,0
	.ENDIF


      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK
      mov  g_fhaschanged,1

		lea  esi,(OBJECT PTR [edi]).sztext2 ;zeroise it first.
		mov  ecx,1024			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse)
		inc  esi			  ;/
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext2
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,1023,esi


 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bl,11011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update font size in .status field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update ring# on parent that action is set to...
 invoke SendDlgItemMessage,hdlg,416,WM_GETTEXT,3,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).nbeginring,al

;decision-type...
	invoke SendDlgItemMessage,hdlg,214,BM_GETCHECK,0,0
	mov bl,(OBJECT PTR [edi]).fconfig2
	.IF ax==1   ;if-then
	  or bl,01  ;set bit0
	  and bl,11111101b
	.ELSE
	  or bl,010b ;set bit1
	  and bl,11111110b
	.ENDIF
	mov (OBJECT PTR [edi]).fconfig2,bl


      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE



    .ELSEIF wparam==250  ;"external editor" button pressed
      ;we want to launch the editor, spec'd in .szeditor,
      ;with a temp filename, say temp.txt, then on exit
      ;read the file and zeroise it.
	    mov	edi,prbuttonobject
	    lea eax,(OBJECT PTR [edi]).sztext2
	    invoke openexternaleditor, eax
	    .IF eax==1
	      invoke EndDialog, hdlg,TRUE
	    .ENDIF
      mov eax,TRUE

    .ELSEIF wparam==214 ;if-then condition.
	;attached to ring-1 is special case...
	invoke SendDlgItemMessage,hdlg,416,WM_GETTEXT,3,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	.IF al==1
	  ;keep if-then checked...
	  invoke SendDlgItemMessage,hdlg,216,BM_SETCHECK,0,0
	  invoke SendDlgItemMessage,hdlg,214,BM_SETCHECK,1,0
	.ELSE
	  invoke SendDlgItemMessage,hdlg,216,BM_SETCHECK,0,0
	  invoke SendDlgItemMessage,hdlg,214,BM_SETCHECK,1,0
	.ENDIF
      mov eax,TRUE

    .ELSEIF wparam==216 ;while-do condition.
	;attached to ring-1 is special case...
	invoke SendDlgItemMessage,hdlg,416,WM_GETTEXT,3,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	.IF al==1
	  invoke SendDlgItemMessage,hdlg,216,BM_SETCHECK,0,0
	  invoke SendDlgItemMessage,hdlg,214,BM_SETCHECK,1,0
	.ELSE
	  invoke SendDlgItemMessage,hdlg,214,BM_SETCHECK,0,0
	  invoke SendDlgItemMessage,hdlg,216,BM_SETCHECK,1,0
	.ENDIF
      mov eax,TRUE


    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
KENTER30proc	ENDP
;--------------------------------------------------------------------------
.DATA
nachild	BYTE 0
szexter9 DB "Can only force external declaration for public "
	 DB "data/hardware resources. Also, the external checkbox "
	 BYTE "cannot be set for a data/hardware element that is a "
	 BYTE "child of another data/hardware element.",0
szptrtype1 DB """pointer""",0	;moved out of szptrtype1,2,3---16 above.
				;displays in res.combobox when a pointer.
szptrtype2 DB """array""",0	;/  displ. in res.combo when an array.
szptrtype3 DB """function""",0	;pointer to a function.
szptrtype16 DB """structure""",0 ;/ this displays in datatype combobox
				 ;  when resource is a structure.
szextern1   BYTE "EXTERNAL",0
szersh7    BYTE "Data/hardware elements owned by child-nodes (clones) "
	   BYTE "must be shareable permanent. You have tried to select "
	   BYTE "a different visibility and lifetime setting. GOOSEE is "
	   BYTE "leaving it as it was.",0
szer151b   BYTE " ***XXX***",0 ;***NOTE*** not used.
szeruu1    BYTE "A data/resource that is a child of another data/resource must "
	   BYTE "be private to the parent data/resource.",0
szeruu3    BYTE "A child-data-element of a pointer-element is only a "
	   BYTE "type definition of what the pointer is pointing to, "
	   BYTE "and cannot have a name or initialisation value of "
	   BYTE "its own.",0Dh,0Ah
	   BYTE "GOOSEE is now deleting them.",0


.CODE
KENTER6proc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
  LOCAL fext:BYTE
  LOCAL pparent:DWORD
;from wmrbuttondown/state0  data object dialog. "dataproc"
;dialog box for data of nexttype=03/04, basic variable.
;(structure, array, pointer, generic, have their own dialog boxes).

	mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

	mov nachild,0 ;>0 if this data-element is a child of another data-e.

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit1 = invisible node.
	test  al,00000010b
	jz ke219
	push eax
	invoke SendDlgItemMessage,hdlg,303,BM_SETCHECK,1,0
	pop  eax
ke219:
	;bit5 = display label on diagram, bit6=initial value.
	test  al,00100000b
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
	;bit5 = display label on diagram, bit6=initial value.
	test  al,01000000b
	jz ke21ww
	push eax
	invoke SendDlgItemMessage,hdlg,225,BM_SETCHECK,1,0
	pop  eax
ke21ww:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:



;display fill color...	(even if it can mean something else)
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,10,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .color even if it means something else.
kenf2:

;display task number...	(was resource#)
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,250,WM_SETTEXT,0,esi

;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage, hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.
 ;(see readonly stuff further down)

;display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.

;.sztext2/3 is initial value --numeric, stored
;as ascii chars...
	lea  esi,(OBJECT PTR [edi]).sztext2
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,KSPEC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KSPEC,EM_LIMITTEXT,126,0 ;set limit.


;make it read only if parent is a pointer-element...
;ditto if parent is an array-element...(.fstatus2/bits7/6/5 =011)
	mov ebx,(OBJECT PTR [edi]).rplock1
	.IF ebx==0
	.ELSE
	  add ebx,pTERSEDATA
	  mov ax,(OBJECT PTR [ebx]).nexttype
	  .IF ax==3
	    jmp SHORT pw1
	  .ELSEIF ax==4
pw1:	    mov al,(OBJECT PTR [ebx]).fstatus2
	    and al,11100000b
	    .IF al==00100000b	;pointer
	      mov nachild,1	;used by checkbox/button bypass.
pw99:	      ;name of data...
	      mov (OBJECT PTR [edi]).sztext1,0 ;make sure empty.
	      invoke SendDlgItemMessage,hdlg,102,EM_SETREADONLY,TRUE,0
	      ;also the initialisation value...
		mov (OBJECT PTR [edi]).sztext2,0 ;make sure empty.
		invoke SendDlgItemMessage,hdlg,242,EM_SETREADONLY,TRUE,0
	    .ELSEIF al==01100000b   ;array.
	      mov nachild,2
	      jmp pw99
	    .ELSE
	      mov nachild,3
	    .ENDIF
	  .ELSE
	    mov nachild,0
	  .ENDIF
	.ENDIF

;;now upload the midfix text. stored as ascii...
;	lea  esi,(OBJECT PTR [edi]).sztext3
;	    mov  al,[esi]	;ignore leading blanks.
;	    .WHILE al==" "	;/
;	      inc  esi		;/
;	      mov  al,[esi]	;/
;	    .ENDW		;/
; invoke SendDlgItemMessage,hdlg,360,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,360,EM_LIMITTEXT,62,0 ;set limit.

;have introduced datatype combo/listbox...
  mov  al,(OBJECT PTR [edi]).ndatatype
  and  al,0Fh
  .IF al==0Fh		;data is a reference type (ptr,array,structure)
    mov  al,(OBJECT PTR [edi]).nptrtype
    and  al,0Fh
    .IF  al==0			;pointer.
      lea  esi,szptrtype1
    .ELSEIF al==1		;array.
      lea  esi,szptrtype2
    .ELSE			;structure.
      lea  esi,szptrtype16
    .ENDIF
    invoke SendDlgItemMessage,hdlg,305,CB_ADDSTRING,0,esi
    invoke SendDlgItemMessage,hdlg,305,CB_SETCURSEL,0,0
  .ELSE
    mov	ecx,15	;16	;don't display last entry (refrence)
    mov ebx,pTERSEDATA
    lea	esi,(TERSEDATA PTR [ebx]).sztype1
ummzz:
    push ecx
    invoke SendDlgItemMessage,hdlg,305,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48 ;8
    loop ummzz
;set the selection in the combobox...
    xor	eax,eax
    mov	al,(OBJECT PTR [edi]).ndatatype
    and	al,0Fh			;lower 4 bits only.
    .IF	al==0Fh		;pointer datatype.
      xor  eax,eax
      mov  al,(OBJECT PTR [edi]).nptrtype
      and  al,0Fh
      invoke SendDlgItemMessage,hdlg,305,CB_SETCURSEL,eax,0
    .ELSE
      invoke SendDlgItemMessage,hdlg,305,CB_SETCURSEL,eax,0
    .ENDIF
  .ENDIF

;data memory type combobox...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    mov	ecx,48 ;8
    mov ebx,pTERSEDATA
    lea	esi,(TERSEDATA PTR [ebx]).szpre1
hmmzz:
    mov  al,[esi]
    cmp  al,0		;ignore null strings.
    je	 immzz
    push ecx
    invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48 ;8
    loop hmmzz
immzz:
      xor  eax,eax
      mov  al,(OBJECT PTR [edi]).nmemtype1
      and  al,0Fh
      invoke SendDlgItemMessage,hdlg,358,CB_SETCURSEL,eax,0


;visibility options...
    cmp nachild,0    ;don't set one if a child of another data element.
    jne	g33
	xor eax,eax
	mov  ax,(OBJECT PTR [edi]).nexttype
	.IF  ax==3		;private resource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;private static.
	    invoke SendDlgItemMessage,hdlg,330,BM_SETCHECK,1,0
	  .ELSE 		;private temporary.
	    invoke SendDlgItemMessage,hdlg,334,BM_SETCHECK,1,0
	  .ENDIF
	.ELSEIF al==4		;shareable/global resource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;shareable.
	    ;shareable is temporary if .fconfig.7 =1....
	    mov  al,(OBJECT PTR [edi]).fconfig
	    and  al,10000000b
	    .IF  al==0		;permanent resource.
	      invoke SendDlgItemMessage,hdlg,329,BM_SETCHECK,1,0
	    .ELSE		;temporary resource.
	      invoke SendDlgItemMessage,hdlg,400,BM_SETCHECK,1,0
	    .ENDIF
	  .ELSE 		;global/universal.
	    and  al,01000000b	;test for universal.
	    .IF  al==0
	      invoke SendDlgItemMessage,hdlg,328,BM_SETCHECK,1,0
	    .ELSE
	      invoke SendDlgItemMessage,hdlg,332,BM_SETCHECK,1,0
	    .ENDIF
	  .ENDIF
	.ENDIF
g33:

;display label of node that owns this resource...
;note that this is read-only, so no need to unload from dialog.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	  mov ebx,eax
	  lea eax,(OBJECT PTR [ebx]).sztext1
	  invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	.ENDIF

;i reckon if this is a child of any data-element, i will ignore these...
	cmp nachild,0
	jne  b204
;Force overrides on generated source file...
	test (OBJECT PTR [edi]).fconfig,010b	;bit1=1 do not compose.
	jz   a204
	invoke SendDlgItemMessage,hdlg,218,BM_SETCHECK,1,0
a204:	test (OBJECT PTR [edi]).fstatus,0100b	;bit2=1 force external.
	jz   b204
	invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,1,0
b204:

;upload number of object/element (was sub-project number)...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).number
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,esi


      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK    ;lo-wparam
      mov  g_fhaschanged,1

;update the database...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,192			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext1/2/3)
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi

;;13-3-98 don't allow label to have forbidden characters...
;	invoke findbadchar, si	    ;x=0 not found, else ax-->bad char.
;	.IF  ax==0
;	.ELSE		;bad char found.
;	  lea	ax,cs:SECszbadchar
;	  invoke MESSAGEBOX,iihWnd, cs::ax, 0, MB_OK+MB_ICONEXCLAMATION
;	  mov	(OBJECT PTR [di]).szlabel,0	;clr label.
;	  jmp  zoono1	;don't end the dialog box.
;	.ENDIF

 invoke SendDlgItemMessage,hdlg,303,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;invisible node button is checked.
	  or  bl,00000010b
	.ELSE
	  and bl,11111101b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bl,11011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,225,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;display initial value button is checked.
	  or  bl,01000000b
	.ELSE
	  and bl,10111111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update font size in .status field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .color field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,11,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov  (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset

;initialisation value... (sztext2/3)
    mov	al,(OBJECT PTR [edi]).ndatatype
    and  al,0Fh
    .IF al==0Fh
      mov  al,(OBJECT PTR [edi]).nptrtype
      and  al,0Fh
      .IF  al==0	;ptr.
	jmp e303
      .ELSEIF al==1	;array.
	mov (OBJECT PTR [edi]).sztext2,0
      .ELSE		;structure.
	mov (OBJECT PTR [edi]).sztext2,0
      .ENDIF
    .ELSE
e303:	lea  eax,(OBJECT PTR [edi]).sztext2
	invoke SendDlgItemMessage,hdlg,KSPEC,WM_GETTEXT,127,eax
    .ENDIF
    and	(OBJECT PTR [edi]).fconfig,11100111b ;clr bits3/4.--precaution.

;;midfix text (sztext3)...
;	lea  eax,(OBJECT PTR [edi]).sztext3
; invoke SendDlgItemMessage,hdlg,360,WM_GETTEXT,63,eax

;read datatype selection from listbox/combo...
    invoke SendDlgItemMessage,hdlg,305,CB_GETCURSEL,0,0
    and	ax,0Fh
    mov  cl,(OBJECT PTR [edi]).ndatatype
    and  cl,0Fh
    .IF  cl==0Fh		;reference type.
      ;...can't change from resource.(fixed by attached subnode).
    .ELSE
      mov  cl,(OBJECT PTR [edi]).ndatatype
      and  cl,0F0h	;leave hi-nibble alone, in case want use.
      or   al,cl
      mov  (OBJECT PTR [edi]).ndatatype,al
    .ENDIF

;update memory type from combobox...
    invoke SendDlgItemMessage,hdlg,358,CB_GETCURSEL,0,0
    and	ax,0Fh
      mov  cl,(OBJECT PTR [edi]).nmemtype1
      and  cl,0F0h	;leave hi-nibble alone, in case want use.
      or   al,cl
      mov  (OBJECT PTR [edi]).nmemtype1,al


;update visibility options...
    ;if the owner of this data resource is a clone node, the resource
    ;must be shareable permanent. This is automatically set when
    ;placing the new resource, in wmlbuttondown()/state4.
    ;now, prevent it from being changed...
    mov ebx,(OBJECT PTR [edi]).rplock1	   ;pts to parent.
    .IF ebx==0	;free resource, which isn't allowed --precaution.
    .ELSE
      add ebx,pTERSEDATA    ;make it absolute addr.
      mov eax,(OBJECT PTR [ebx]).rplock1
      .IF eax==0	;parent node is "free".
      .ELSE
	;check that parent is a node...
	mov ax,(OBJECT PTR [ebx]).nexttype
	cmp ax,0	;=0, node.
	jne py1
	invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
	.IF	ax==1		;shareable permanent. ok.
	.ELSE
	  lea eax,szersh7
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  jmp vv1	;bypass reading the checkboxes.
	.ENDIF
      .ENDIF
    .ENDIF
py1:

;if resource is child of a parent resource (cannot happen harwdare element)
;it must retain some characteristics of parent...
    mov ebx,(OBJECT PTR [edi]).rplock1	   ;pts to parent.
    .IF ebx==0	;free resource, which isn't allowed --precaution.
    .ELSE
      add ebx,pTERSEDATA    ;make it absolute addr.
      mov pparent,ebx
      mov ax,(OBJECT PTR [ebx]).nexttype
      cmp ax,3		    ;parent is private data.
      je ee1x
      cmp ax,4		    ;parent is global data.
      jne ee1
ee1x:		;parent is a data element.
;is parent a pointer....
      mov al,(OBJECT PTR [ebx]).fstatus2
      and al,11100000b
      .IF al==00100000b	    ;pointer
	;child can't have a name, nor initialisation value...
	mov al,(OBJECT PTR [edi]).sztext1
	.IF al==0   ;ok
	.ELSE
	  lea eax,szeruu3
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov (OBJECT PTR [edi]).sztext1,0
	.ENDIF
	mov al,(OBJECT PTR [edi]).sztext2
	.IF al==0   ;ok
	.ELSE
	  lea eax,szeruu3
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov (OBJECT PTR [edi]).sztext2,0
	.ENDIF
      .ENDIF

	invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
	.IF	ax==1		;shareable permanent.
we1:	  ;error...
	  lea eax,szeruu1
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  jmp out4
	.ENDIF
	;could check other checkboxes here...
	invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0
	.IF ax==1		;thread (file)
	  jmp we1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0
	.IF ax==1		;shareable-temporary.
	  jmp we1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,332,BM_GETCHECK,0,0
	.IF ax==1		;public
	  jmp we1
	.ENDIF
out4:

      mov ebx,pparent
      mov al,(OBJECT PTR [ebx]).fstatus
      and al,100b	    ;bit2=1, external.
;      .IF al==100b
;	or (OBJECT PTR [edi]).fstatus,100b ;set it in child.
;      .ELSE
	   invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
	   .IF ax==1
	     lea eax,szexter9 ;szeruu1
	     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	     jmp zoono1
	   .ENDIF
;      .ENDIF
      ;it must be private...
      mov (OBJECT PTR [edi]).nexttype,3
      ;and have same perm/temp as parent...
      mov ebx,pparent
      mov al,(OBJECT PTR [ebx]).fconfig
      and al,1100000b	;bit6/5=01 temp-private.
      .IF al==0100000b	  ;yep its temp.
	mov al,(OBJECT PTR [edi]).fconfig
	and al,10111111b
	or  al,00100000b
	mov (OBJECT PTR [edi]).fconfig,al ;set child private-temp
      .ELSE
	;set child private-perm...
	mov al,(OBJECT PTR [edi]).fconfig
	and al,10011111b
	mov (OBJECT PTR [edi]).fconfig,al ;set child private-temp
      .ENDIF
      jmp vv1	;bypass reading the checkboxes.
    .ENDIF
ee1:

;*NO* why not let external res's be any type?...
  mov fext,0
;;if the owner is external, the attached data must be shareable-perm
;;or public. both marked external.
;;the external-flag is checked further down, but here check visibility...
;    mov ebx,(OBJECT PTR [edi]).rplock1
;    add ebx,pTERSEDATA
;    mov ax,(OBJECT PTR [ebx]).nexttype
;	     mov ax,(OBJECT PTR [ebx]).nexttype
;	     .IF ax==0	    ;node
;	       ;node.fstatus2/bit2/1 =11 is external.
;	       mov al,(OBJECT PTR [ebx]).fstatus2
;	       and al,0110b
;	       .IF al==110b ;owner is external.
;		 mov fext,1
;	       .ELSE
;		 mov fext,0
;	       .ENDIF
;	     .ELSE
;	       ;if ever allow res attach another res, parentres.fstatus
;	       ;bit2=1 is external...
;	       mov al,(OBJECT PTR [ebx]).fstatus
;	       and al,0100b
;	       .IF al==0100b	      ;owner-res is external
;		 mov fext,1
;	       .ELSE
;		 mov fext,0
;	       .ENDIF
;	     .ENDIF

;now update from the visibility buttons...
 invoke SendDlgItemMessage,hdlg,334,BM_GETCHECK,0,0
.IF  ax==1		;private-temporary radiobutton checked.
   .IF fext==1
     lea eax,szer151b
     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
   .ELSE
     mov (OBJECT PTR [edi]).nexttype,3
     and (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
     or	 (OBJECT PTR [edi]).fconfig,00100000b	;set bit5.
   .ENDIF
.ELSE
 invoke SendDlgItemMessage,hdlg,330,BM_GETCHECK,0,0
 .IF  ax==1		;private radiobutton checked.
   .IF fext==1
     lea eax,szer151b
     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
   .ELSE
     mov (OBJECT PTR [edi]).nexttype,3
     and (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
   .ENDIF
 .ELSE
   mov	(OBJECT PTR [edi]).nexttype,4
   invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
   .IF	ax==1		;shareable permanent.
     and  (OBJECT PTR [edi]).fconfig,00011111b	;clr bit5&6.
		;...also clr bit7, marks resource shareable as permanent.
   .ELSE
     invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0
     .IF ax==1		;thread (file)
       .IF fext==1
	 lea eax,szer151b
	 invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
       .ELSE
	 and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	 or   (OBJECT PTR [edi]).fconfig,00100000b	;set bit5.
       .ENDIF
     .ELSE
       invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0
       .IF ax==1		;shareable-temporary.
	 .IF fext==1
	   lea eax,szer151b
	   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	 .ELSE
	   and	(OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	   or	(OBJECT PTR [edi]).fconfig,10000000b	;set bit7.
	 .ENDIF
       .ELSE			;global...(public)
	 and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	 or  (OBJECT PTR [edi]).fconfig,01000000b	;global. set bit6.
       .ENDIF
     .ENDIF
   .ENDIF
 .ENDIF
.ENDIF
vv1:

;update force overrides for generated source file...
;218 is the force-not-instantiated override...
	 invoke SendDlgItemMessage,hdlg,218,BM_GETCHECK,0,0
	 .IF ax==1
	   or (OBJECT PTR [edi]).fconfig,010b	;set bit1. do not compose.
	   ;set res. fill color to grey...
	   mov	(OBJECT PTR [edi]).ncolour1,0C0C0C0h
	   or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	 .ELSE
	   mov al,(OBJECT PTR [edi]).fconfig
	   and al,010b	;do-not-compose bit.
	   .IF al==010b
	     and (OBJECT PTR [edi]).fconfig,11111101b ;clr bit1.
	     ;clr fill color...
	     mov	(OBJECT PTR [edi]).ncolour1,0
	     and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	   .ENDIF

;223 is the force-external override...
	   invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
	   .IF ax==1
;only allowed to force external on public data...
	       mov ax,(OBJECT PTR [edi]).nexttype
	       .IF ax==4
		 mov al,(OBJECT PTR [edi]).fconfig
		 and al,01100000b	;extract bits6/5.
		 .IF al==01000000b	;global?
;		 .ELSEIF al==0		;shareable
;		   test (OBJECT PTR [edi]).fconfig,10000000b ;bit7=1 temporary.
;		   jnz	g204
		 .ELSE			;external not allowed.
g204:		   lea	eax,szexter9
		   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		   jmp zoono1
		 .ENDIF
	       .ELSE
		   jmp g204
	       .ENDIF
	     or (OBJECT PTR [edi]).fstatus,0100b ;set bit2. force external.

;*NO* leave resource owned by parent node, even though marked external!!!
;	     ;not sure about this, but need to set res.key1-->a node that
;	     ;is not in this subdiagram. why not point to the resource,
;	     ;i.e. point to itself?...
;	     mov eax,edi
;	     sub eax,pTERSEDATA ;cos relative ptr.
;	     mov (OBJECT PTR [edi]).rplock1,eax
;	     ;...i'm now relying on this to display "EXTERNAL" in the
;	     ;"Who owns me?" box.
	   .ELSE
	     ;if the owner-node is external, the resource must stay
	     ;external also...
	     mov ebx,(OBJECT PTR [edi]).rplock1
	     add ebx,pTERSEDATA ;cos relative ptr.
	     mov ax,(OBJECT PTR [ebx]).nexttype
	     .IF ax==0	    ;node
	       ;node.fstatus2/bit2/1 =11 is external.
	       mov al,(OBJECT PTR [ebx]).fstatus2
	       and al,0110b
	       .IF al==110b ;owner is external.
		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ELSE
	       ;if ever allow res attach another res, parentres.fstatus
	       ;bit2=1 is external...
	       mov al,(OBJECT PTR [ebx]).fstatus
	       and al,0100b
	       .IF al==0100b	      ;owner-res is external
;		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
		 ;no, i think child of data-element should remain private
		 ;not external (cos "extern" will display above it)...
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ENDIF



;	     mov eax,(OBJECT PTR [edi]).rplock1
;	     add eax,pTERSEDATA ;cos relative ptr.
;	     .IF eax==edi ;will only be -->itself if previously set external.
;	       mov (OBJECT PTR [edi]).rplock1,0	;it is now an orphan.
;	     .ENDIF
	   .ENDIF

	 .ENDIF




      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF ax==IDCANCEL    ;lo-wparam
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE

    .ELSEIF ax==218	;force not instantiated in source checkbox.
      .IF nachild==0	;=0 not a child-element of another data-element.
	invoke SendDlgItemMessage,hdlg,218,BM_GETCHECK,0,0
	.IF ax==1
	  invoke SendDlgItemMessage,hdlg,218,BM_SETCHECK,0,0
	.ELSE
	  invoke SendDlgItemMessage,hdlg,218,BM_SETCHECK,1,0
	.ENDIF
      .ENDIF
      mov eax,TRUE

    .ELSEIF ax==223	;force external	checkbox.
      .IF nachild==0	;=0 not a child-element of another data-element.
	  ;only public data allowed to be external...
	  invoke SendDlgItemMessage,hdlg,332,BM_GETCHECK,0,0 ;public
	  .IF ax==1
	    invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,1,0
	  .ELSE
	    invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,0,0
	    ;make sure visibility is set to something else...
	    invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0 ;file
	    cmp ax,1
	    je hackz
	    invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0 ;shareable
	    cmp ax,1
	    je hackz
	    invoke SendDlgItemMessage,hdlg,330,BM_GETCHECK,0,0 ;private
	    cmp ax,1
	    je hackz
	    invoke SendDlgItemMessage,hdlg,334,BM_GETCHECK,0,0 ;private-temp
	    cmp ax,1
	    je hackz
	    invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0 ;share-temp
	    cmp ax,1
	    je hackz
	    ;default it to private...
	    invoke SendDlgItemMessage,hdlg,330,BM_SETCHECK,1,0 ;private-perm
hackz:
	  .ENDIF
      .ELSE
	;parent is a data-element, so can't be external...
	invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,0,0 ;external
	;clear them all...
	invoke SendDlgItemMessage,hdlg,332,BM_SETCHECK,0,0 ;public
	invoke SendDlgItemMessage,hdlg,328,BM_SETCHECK,0,0 ;file
	invoke SendDlgItemMessage,hdlg,329,BM_SETCHECK,0,0 ;shareable
	invoke SendDlgItemMessage,hdlg,400,BM_SETCHECK,0,0 ;share-temp
	invoke SendDlgItemMessage,hdlg,334,BM_SETCHECK,0,0 ;private-temp
	invoke SendDlgItemMessage,hdlg,330,BM_SETCHECK,0,0 ;private-perm
	mov eax,TRUE
      .ENDIF
      mov eax,TRUE

    .ELSE
      mov eax,FALSE
    .ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
KENTER6proc	ENDP
;--------------------------------------------------------------------------
STRUCproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
  LOCAL fext:BYTE
  LOCAL pparent:DWORD
;from wmrbuttondown/state0  structure variable object dialog. "strucproc"
;.RC file id=218.

	mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit1 = invisible node.
	test  al,00000010b
	jz ke219
	push eax
	invoke SendDlgItemMessage,hdlg,303,BM_SETCHECK,1,0
	pop  eax
ke219:
	;bit5 = display label on diagram, bit6=display terminal #s.
	test  al,00100000b
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display fill color...	(even if it can mean something else)
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,10,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .color even if it means something else.
kenf2:

;display file number...	(was resource#)
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,250,WM_SETTEXT,0,esi

;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage, hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.
 ;(see readonly stuff further down)

;display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.

;.sztext5-8 is initial value --stored
;as ascii chars...
	lea  esi,(OBJECT PTR [edi]).sztext5
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,227,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,227,EM_LIMITTEXT,894,0 ;set limit.

;make it read only if parent is a pointer-element...
	mov ebx,(OBJECT PTR [edi]).rplock1
	.IF ebx==0
	.ELSE
	  add ebx,pTERSEDATA
	  mov ax,(OBJECT PTR [ebx]).nexttype
	  .IF ax==3
	    jmp SHORT pw1
	  .ELSEIF ax==4
pw1:	    mov al,(OBJECT PTR [ebx]).fstatus2
	    and al,11100000b
	    .IF al==00100000b	;pointer
pw1x:	;name of data...
       mov (OBJECT PTR [edi]).sztext1,0 ;make sure empty.
       invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_SETREADONLY,TRUE,0
       ;also the initialisation value...
       mov (OBJECT PTR [edi]).sztext5,0 ;make sure empty.
       invoke SendDlgItemMessage,hdlg,227,EM_SETREADONLY,TRUE,0
	    .ELSEIF al==01100000b ;parent is an array.
	      jmp pw1x
	    .ENDIF
	  .ENDIF
	.ENDIF

;structure type combo/listbox...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,224,CB_ADDSTRING,0,esi
  mov  al,(OBJECT PTR [edi]).ndatatype
  and  al,0Fh
    mov	ecx,15	;16
    mov ebx,pTERSEDATA
    lea	esi,(TERSEDATA PTR [ebx]).szptrtype1
ummzz:
    push ecx
    invoke SendDlgItemMessage,hdlg,224,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48
    loop ummzz
;set the selection in the combobox...
    xor	eax,eax
    mov	al,(OBJECT PTR [edi]).ndatatype
    and	al,0Fh			;lower 4 bits only.
      invoke SendDlgItemMessage,hdlg,224,CB_SETCURSEL,eax,0


;data memory type combobox...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    mov	ecx,48 ;8
    mov ebx,pTERSEDATA
    lea	esi,(TERSEDATA PTR [ebx]).szpre1
hmmzz:
    mov  al,[esi]
    cmp  al,0		;ignore null strings.
    je	 immzz
    push ecx
    invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48 ;8
    loop hmmzz
immzz:
      xor  eax,eax
      mov  al,(OBJECT PTR [edi]).nmemtype1
      and  al,0Fh
      invoke SendDlgItemMessage,hdlg,358,CB_SETCURSEL,eax,0


;visibility options...
	xor eax,eax
	mov  ax,(OBJECT PTR [edi]).nexttype
	.IF  ax==3		;private resource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;private static.
	    invoke SendDlgItemMessage,hdlg,330,BM_SETCHECK,1,0
	  .ELSE 		;private temporary.
	    invoke SendDlgItemMessage,hdlg,334,BM_SETCHECK,1,0
	  .ENDIF
	.ELSEIF al==4		;shareable/global resource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;shareable.
	    ;shareable is temporary if .fconfig.7 =1....
	    mov  al,(OBJECT PTR [edi]).fconfig
	    and  al,10000000b
	    .IF  al==0		;permanent resource.
	      invoke SendDlgItemMessage,hdlg,329,BM_SETCHECK,1,0
	    .ELSE		;temporary resource.
	      invoke SendDlgItemMessage,hdlg,400,BM_SETCHECK,1,0
	    .ENDIF
	  .ELSE 		;global/universal.
	    and  al,01000000b	;test for universal.
	    .IF  al==0
	      invoke SendDlgItemMessage,hdlg,328,BM_SETCHECK,1,0
	    .ELSE
	      invoke SendDlgItemMessage,hdlg,332,BM_SETCHECK,1,0
	    .ENDIF
	  .ENDIF
	.ENDIF

;display label of node that owns this resource...
;note that this is read-only, so no need to unload from dialog.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	  mov ebx,eax
	  lea eax,(OBJECT PTR [ebx]).sztext1
	  invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	.ENDIF

;Force overrides on generated source file...
	test (OBJECT PTR [edi]).fconfig,010b	;bit1=1 do not compose.
	jz   a204
	invoke SendDlgItemMessage,hdlg,218,BM_SETCHECK,1,0
a204:	test (OBJECT PTR [edi]).fstatus,0100b	;bit2=1 force external.
	jz   b204
	invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,1,0
b204:

;upload number of object/element (was sub-project number)...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).number
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,esi


      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK    ;lo-wparam
      mov  g_fhaschanged,1

;update the database...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,192			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext1/2/3)
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi

;;13-3-98 don't allow label to have forbidden characters...
;	invoke findbadchar, si	    ;x=0 not found, else ax-->bad char.
;	.IF  ax==0
;	.ELSE		;bad char found.
;	  lea	ax,cs:SECszbadchar
;	  invoke MESSAGEBOX,iihWnd, cs::ax, 0, MB_OK+MB_ICONEXCLAMATION
;	  mov	(OBJECT PTR [di]).szlabel,0	;clr label.
;	  jmp  zoono1	;don't end the dialog box.
;	.ENDIF

 invoke SendDlgItemMessage,hdlg,303,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;invisible node button is checked.
	  or  bl,00000010b
	.ELSE
	  and bl,11111101b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bl,11011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update font size in .status field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .color field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,11,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov  (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset

;initialisation value... (sztext5-8)
		lea  esi,(OBJECT PTR [edi]).sztext5 ;zeroise it first.
		mov  ecx,896			  ;/(also fills following
izoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext5-8)
		loop izoo1			  ;/
	lea  eax,(OBJECT PTR [edi]).sztext5
	invoke SendDlgItemMessage,hdlg,227,WM_GETTEXT,895,eax
    and	(OBJECT PTR [edi]).fconfig,11100111b ;clr bits3/4.--precaution.
    ;...?????? why????


;read structure type from listbox/combo...
    invoke SendDlgItemMessage,hdlg,224,CB_GETCURSEL,0,0
    and	ax,0Fh
      mov  cl,(OBJECT PTR [edi]).ndatatype
      and  cl,0F0h	;leave hi-nibble alone, in case want use.
      or   al,cl
      mov  (OBJECT PTR [edi]).ndatatype,al

;update memory type from combobox...
    invoke SendDlgItemMessage,hdlg,358,CB_GETCURSEL,0,0
    and	ax,0Fh
      mov  cl,(OBJECT PTR [edi]).nmemtype1
      and  cl,0F0h	;leave hi-nibble alone, in case want use.
      or   al,cl
      mov  (OBJECT PTR [edi]).nmemtype1,al


;update visibility options...
    ;if the owner of this data resource is a clone node, the resource
    ;must be shareable permanent. This is automatically set when
    ;placing the new resource, in wmlbuttondown()/state4.
    ;now, prevent it from being changed...
    mov ebx,(OBJECT PTR [edi]).rplock1	   ;pts to parent.
    .IF ebx==0	;free resource, which isn't allowed --precaution.
    .ELSE
      add ebx,pTERSEDATA    ;make it absolute addr.
      mov eax,(OBJECT PTR [ebx]).rplock1
      .IF eax==0	;parent node is "free".
      .ELSE
	;check that parent is a node...
	mov ax,(OBJECT PTR [ebx]).nexttype
	cmp ax,0	;=0, node.
	jne py1
	invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
	.IF	ax==1		;shareable permanent. ok.
	.ELSE
	  lea eax,szersh7
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  jmp vv1	;bypass reading the checkboxes.
	.ENDIF
      .ENDIF
    .ENDIF
py1:

;if resource is child of a parent resource (cannot happen harwdare element)
;it must retain some characteristics of parent...
    mov ebx,(OBJECT PTR [edi]).rplock1	   ;pts to parent.
    .IF ebx==0	;free resource, which isn't allowed --precaution.
    .ELSE
      add ebx,pTERSEDATA    ;make it absolute addr.
      mov pparent,ebx
      mov ax,(OBJECT PTR [ebx]).nexttype
      cmp ax,3		    ;parent is private data.
      je ee1x
      cmp ax,4		    ;parent is global data.
      jne ee1
ee1x:	    ;parent is a data element.
;is parent a pointer....
      mov al,(OBJECT PTR [ebx]).fstatus2
      and al,11100000b
      .IF al==00100000b	    ;pointer
	;child can't have a name, nor initialisation value...
	mov al,(OBJECT PTR [edi]).sztext1
	.IF al==0   ;ok
	.ELSE
	  lea eax,szeruu3
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov (OBJECT PTR [edi]).sztext1,0
	.ENDIF
	mov al,(OBJECT PTR [edi]).sztext5
	.IF al==0   ;ok
	.ELSE
	  lea eax,szeruu3
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov (OBJECT PTR [edi]).sztext5,0
	.ENDIF
      .ENDIF

	invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
	.IF	ax==1		;shareable permanent.
we1:	  ;error...
	  lea eax,szeruu1
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  jmp out4
	.ENDIF
	;could check other checkboxes here...
	invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0
	.IF ax==1		;thread (file)
	  jmp we1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0
	.IF ax==1		;shareable-temporary.
	  jmp we1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,332,BM_GETCHECK,0,0
	.IF ax==1		;public
	  jmp we1
	.ENDIF
out4:

      mov ebx,pparent
      mov al,(OBJECT PTR [ebx]).fstatus
      and al,100b	    ;bit2=1, external.
;      .IF al==100b
;	or (OBJECT PTR [edi]).fstatus,100b ;set it in child.
;      .ELSE
	   invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
	   .IF ax==1
	     lea eax,szexter9 ;szeruu1
	     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	     jmp zoono1
	   .ENDIF
;      .ENDIF
      ;it must be private...
      mov (OBJECT PTR [edi]).nexttype,3
      ;and have same perm/temp as parent...
      mov ebx,pparent
      mov al,(OBJECT PTR [ebx]).fconfig
      and al,1100000b	;bit6/5=01 temp-private.
      .IF al==0100000b	  ;yep its temp.
	mov al,(OBJECT PTR [edi]).fconfig
	and al,10111111b
	or  al,00100000b
	mov (OBJECT PTR [edi]).fconfig,al ;set child private-temp
      .ELSE
	;set child private-perm...
	mov al,(OBJECT PTR [edi]).fconfig
	and al,10011111b
	mov (OBJECT PTR [edi]).fconfig,al ;set child private-temp
      .ENDIF
      jmp vv1	;bypass reading the checkboxes.
    .ENDIF
ee1:

;*NO* why not let external res's be any type?...
  mov fext,0
;;if the owner is external, the attached data must be shareable-perm
;;or public. both marked external.
;;the external-flag is checked further down, but here check visibility...
;    mov ebx,(OBJECT PTR [edi]).rplock1
;    add ebx,pTERSEDATA
;    mov ax,(OBJECT PTR [ebx]).nexttype
;	     mov ax,(OBJECT PTR [ebx]).nexttype
;	     .IF ax==0	    ;node
;	       ;node.fstatus2/bit2/1 =11 is external.
;	       mov al,(OBJECT PTR [ebx]).fstatus2
;	       and al,0110b
;	       .IF al==110b ;owner is external.
;		 mov fext,1
;	       .ELSE
;		 mov fext,0
;	       .ENDIF
;	     .ELSE
;	       ;if ever allow res attach another res, parentres.fstatus
;	       ;bit2=1 is external...
;	       mov al,(OBJECT PTR [ebx]).fstatus
;	       and al,0100b
;	       .IF al==0100b	      ;owner-res is external
;		 mov fext,1
;	       .ELSE
;		 mov fext,0
;	       .ENDIF
;	     .ENDIF

;now update from the visibility buttons...
 invoke SendDlgItemMessage,hdlg,334,BM_GETCHECK,0,0
.IF  ax==1		;private-temporary radiobutton checked.
   .IF fext==1
     lea eax,szer151b
     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
   .ELSE
     mov (OBJECT PTR [edi]).nexttype,3
     and (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
     or	 (OBJECT PTR [edi]).fconfig,00100000b	;set bit5.
   .ENDIF
.ELSE
 invoke SendDlgItemMessage,hdlg,330,BM_GETCHECK,0,0
 .IF  ax==1		;private radiobutton checked.
   .IF fext==1
     lea eax,szer151b
     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
   .ELSE
     mov (OBJECT PTR [edi]).nexttype,3
     and (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
   .ENDIF
 .ELSE
   mov	(OBJECT PTR [edi]).nexttype,4
   invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
   .IF	ax==1		;shareable permanent.
     and  (OBJECT PTR [edi]).fconfig,00011111b	;clr bit5&6.
		;...also clr bit7, marks resource shareable as permanent.
   .ELSE
     invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0
     .IF ax==1		;thread (file)
       .IF fext==1
	 lea eax,szer151b
	 invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
       .ELSE
	 and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	 or   (OBJECT PTR [edi]).fconfig,00100000b	;set bit5.
       .ENDIF
     .ELSE
       invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0
       .IF ax==1		;shareable-temporary.
	 .IF fext==1
	   lea eax,szer151b
	   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	 .ELSE
	   and	(OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	   or	(OBJECT PTR [edi]).fconfig,10000000b	;set bit7.
	 .ENDIF
       .ELSE			;global...(public)
	 and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	 or  (OBJECT PTR [edi]).fconfig,01000000b	;global. set bit6.
       .ENDIF
     .ENDIF
   .ENDIF
 .ENDIF
.ENDIF
vv1:

;update force overrides for generated source file...
;218 is the force-not-instantiated override...
	 invoke SendDlgItemMessage,hdlg,218,BM_GETCHECK,0,0
	 .IF ax==1
	   or (OBJECT PTR [edi]).fconfig,010b	;set bit1. do not compose.
	   ;set res. fill color to grey...
	   mov	(OBJECT PTR [edi]).ncolour1,0C0C0C0h
	   or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	 .ELSE
	   mov al,(OBJECT PTR [edi]).fconfig
	   and al,010b	;do-not-compose bit.
	   .IF al==010b
	     and (OBJECT PTR [edi]).fconfig,11111101b ;clr bit1.
	     ;clr fill color...
	     mov	(OBJECT PTR [edi]).ncolour1,0
	     and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	   .ENDIF

;223 is the force-external override...
	   invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
	   .IF ax==1
;only allowed to force external on public data...
	       mov ax,(OBJECT PTR [edi]).nexttype
	       .IF ax==4
		 mov al,(OBJECT PTR [edi]).fconfig
		 and al,01100000b	;extract bits6/5.
		 .IF al==01000000b	;global?
;		 .ELSEIF al==0		;shareable
;		   test (OBJECT PTR [edi]).fconfig,10000000b ;bit7=1 temporary.
;		   jnz	g204
		 .ELSE			;external not allowed.
g204:		   lea	eax,szexter9
		   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		   jmp zoono1
		 .ENDIF
	       .ELSE
		   jmp g204
	       .ENDIF
	     or (OBJECT PTR [edi]).fstatus,0100b ;set bit2. force external.

;*NO* leave resource owned by parent node, even though marked external!!!
;	     ;not sure about this, but need to set res.key1-->a node that
;	     ;is not in this subdiagram. why not point to the resource,
;	     ;i.e. point to itself?...
;	     mov eax,edi
;	     sub eax,pTERSEDATA ;cos relative ptr.
;	     mov (OBJECT PTR [edi]).rplock1,eax
;	     ;...i'm now relying on this to display "EXTERNAL" in the
;	     ;"Who owns me?" box.
	   .ELSE
	     ;if the owner-node is external, the resource must stay
	     ;external also...
	     mov ebx,(OBJECT PTR [edi]).rplock1
	     add ebx,pTERSEDATA ;cos relative ptr.
	     mov ax,(OBJECT PTR [ebx]).nexttype
	     .IF ax==0	    ;node
	       ;node.fstatus2/bit2/1 =11 is external.
	       mov al,(OBJECT PTR [ebx]).fstatus2
	       and al,0110b
	       .IF al==110b ;owner is external.
		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ELSE
	       ;if ever allow res attach another res, parentres.fstatus
	       ;bit2=1 is external...
	       mov al,(OBJECT PTR [ebx]).fstatus
	       and al,0100b
	       .IF al==0100b	      ;owner-res is external
;		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
		 ;no, i think child of data-element should remain private
		 ;not external (cos "extern" will display above it)...
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ENDIF



;	     mov eax,(OBJECT PTR [edi]).rplock1
;	     add eax,pTERSEDATA ;cos relative ptr.
;	     .IF eax==edi ;will only be -->itself if previously set external.
;	       mov (OBJECT PTR [edi]).rplock1,0	;it is now an orphan.
;	     .ENDIF
	   .ENDIF

	 .ENDIF




      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF ax==IDCANCEL    ;lo-wparam
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE



    .ELSE
      mov eax,FALSE
    .ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
STRUCproc	ENDP
;--------------------------------------------------------------------------
PTRproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
  LOCAL fext:BYTE
  LOCAL pparent:DWORD
;from wmrbuttondown/state0  data object dialog. "ptrproc"
;dialog box for data of .fstatus2/bits7/6/5=001 (pointer variable)

	mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit1 = invisible node.
	test  al,00000010b
	jz ke219
	push eax
	invoke SendDlgItemMessage,hdlg,303,BM_SETCHECK,1,0
	pop  eax
ke219:
	;bit5 = display label on diagram, bit6=display terminal #s.
	test  al,00100000b
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display fill color...	(even if it can mean something else)
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,10,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .color even if it means something else.
kenf2:

;display task number...	(was resource#)
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,250,WM_SETTEXT,0,esi

;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage, hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.

;make it read only if parent is a pointer-element...
	mov ebx,(OBJECT PTR [edi]).rplock1
	.IF ebx==0
	.ELSE
	  add ebx,pTERSEDATA
	  mov ax,(OBJECT PTR [ebx]).nexttype
	  .IF ax==3
	    jmp SHORT pw1
	  .ELSEIF ax==4
pw1:	    mov al,(OBJECT PTR [ebx]).fstatus2
	    and al,11100000b
	    .IF al==00100000b	;pointer
       ;name of data...
       mov (OBJECT PTR [edi]).sztext1,0 ;make sure empty.
       invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_SETREADONLY,TRUE,0
	    .ENDIF
	  .ENDIF
	.ENDIF


;display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.


;data memory type combobox...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    mov	ecx,48 ;8
    mov ebx,pTERSEDATA
    lea	esi,(TERSEDATA PTR [ebx]).szpre1
hmmzz:
    mov  al,[esi]
    cmp  al,0		;ignore null strings.
    je	 immzz
    push ecx
    invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48 ;8
    loop hmmzz
immzz:
      xor  eax,eax
      mov  al,(OBJECT PTR [edi]).nmemtype2
      and  al,0Fh
      invoke SendDlgItemMessage,hdlg,358,CB_SETCURSEL,eax,0


;visibility options...
	xor eax,eax
	mov  ax,(OBJECT PTR [edi]).nexttype
	.IF  ax==3		;private resource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;private static.
	    invoke SendDlgItemMessage,hdlg,330,BM_SETCHECK,1,0
	  .ELSE 		;private temporary.
	    invoke SendDlgItemMessage,hdlg,334,BM_SETCHECK,1,0
	  .ENDIF
	.ELSEIF al==4		;shareable/global resource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;shareable.
	    ;shareable is temporary if .fconfig.7 =1....
	    mov  al,(OBJECT PTR [edi]).fconfig
	    and  al,10000000b
	    .IF  al==0		;permanent resource.
	      invoke SendDlgItemMessage,hdlg,329,BM_SETCHECK,1,0
	    .ELSE		;temporary resource.
	      invoke SendDlgItemMessage,hdlg,400,BM_SETCHECK,1,0
	    .ENDIF
	  .ELSE 		;global/universal.
	    and  al,01000000b	;test for universal.
	    .IF  al==0
	      invoke SendDlgItemMessage,hdlg,328,BM_SETCHECK,1,0
	    .ELSE
	      invoke SendDlgItemMessage,hdlg,332,BM_SETCHECK,1,0
	    .ENDIF
	  .ENDIF
	.ENDIF

;display label of node that owns this resource...
;note that this is read-only, so no need to unload from dialog.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	    mov ebx,eax
	    lea eax,(OBJECT PTR [ebx]).sztext1
	    invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	.ENDIF

;Force overrides on generated source file...
	test (OBJECT PTR [edi]).fconfig,010b	;bit1=1 do not compose.
	jz   a204
	invoke SendDlgItemMessage,hdlg,218,BM_SETCHECK,1,0
a204:	test (OBJECT PTR [edi]).fstatus,0100b	;bit2=1 force external.
	jz   b204
	invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,1,0
b204:

;upload number of object/element (was sub-project number)...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).number
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,esi


      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK    ;lo-wparam
      mov  g_fhaschanged,1

;update the database...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,192			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext1/2/3)
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi

;;13-3-98 don't allow label to have forbidden characters...
;	invoke findbadchar, si	    ;x=0 not found, else ax-->bad char.
;	.IF  ax==0
;	.ELSE		;bad char found.
;	  lea	ax,cs:SECszbadchar
;	  invoke MESSAGEBOX,iihWnd, cs::ax, 0, MB_OK+MB_ICONEXCLAMATION
;	  mov	(OBJECT PTR [di]).szlabel,0	;clr label.
;	  jmp  zoono1	;don't end the dialog box.
;	.ENDIF

 invoke SendDlgItemMessage,hdlg,303,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;invisible node button is checked.
	  or  bl,00000010b
	.ELSE
	  and bl,11111101b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bl,11011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update font size in .status field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .color field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,11,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov  (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset


;update memory type from combobox...
    invoke SendDlgItemMessage,hdlg,358,CB_GETCURSEL,0,0
    and	ax,0Fh
      mov  cl,(OBJECT PTR [edi]).nmemtype2
      and  cl,0F0h	;leave hi-nibble alone, in case want use.
      or   al,cl
      mov  (OBJECT PTR [edi]).nmemtype2,al


;update visibility options...
    ;if the owner of this data resource is a clone node, the resource
    ;must be shareable permanent. This is automatically set when
    ;placing the new resource, in wmlbuttondown()/state4.
    ;now, prevent it from being changed...
    mov ebx,(OBJECT PTR [edi]).rplock1	   ;pts to parent.
    .IF ebx==0	;free resource, which isn't allowed --precaution.
    .ELSE
      add ebx,pTERSEDATA    ;make it absolute addr.
      mov eax,(OBJECT PTR [ebx]).rplock1
      .IF eax==0	;parent node is "free".
      .ELSE
	;check that parent is a node...
	mov ax,(OBJECT PTR [ebx]).nexttype
	cmp ax,0	;=0, node.
	jne py1
	invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
	.IF	ax==1		;shareable permanent. ok.
	.ELSE
	  lea eax,szersh7
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  jmp vv1	;bypass reading the checkboxes.
	.ENDIF
      .ENDIF
    .ENDIF
py1:

;if resource is child of a parent resource (cannot happen harwdare element)
;it must retain some characteristics of parent...
    mov ebx,(OBJECT PTR [edi]).rplock1	   ;pts to parent.
    .IF ebx==0	;free resource, which isn't allowed --precaution.
    .ELSE
      add ebx,pTERSEDATA    ;make it absolute addr.
      mov pparent,ebx
      mov ax,(OBJECT PTR [ebx]).nexttype
      cmp ax,3		    ;parent is private data.
      je ee1x
      cmp ax,4		    ;parent is global data.
      jne ee1
ee1x:		;parent is a data element.
;is parent a pointer....
      mov al,(OBJECT PTR [ebx]).fstatus2
      and al,11100000b
      .IF al==00100000b	    ;pointer
	;child can't have a name, nor initialisation value...
	mov al,(OBJECT PTR [edi]).sztext1
	.IF al==0   ;ok
	.ELSE
	  lea eax,szeruu3
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov (OBJECT PTR [edi]).sztext1,0
	.ENDIF
	mov al,(OBJECT PTR [edi]).sztext2
	.IF al==0   ;ok
	.ELSE
	  lea eax,szeruu3
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov (OBJECT PTR [edi]).sztext2,0
	.ENDIF
      .ENDIF

	invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0 ;shareable
	.IF	ax==1		;shareable permanent.
we1:	  ;error...
	  lea eax,szeruu1
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  jmp out4
	.ENDIF
	;could check other checkboxes here...
	invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0
	.IF ax==1		;thread (file)
	  jmp we1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0
	.IF ax==1		;shareable-temporary.
	  jmp we1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,332,BM_GETCHECK,0,0
	.IF ax==1		;public
	  jmp we1
	.ENDIF
out4:
      mov ebx,pparent
      mov al,(OBJECT PTR [ebx]).fstatus
      and al,100b	    ;bit2=1, external.
;      .IF al==100b
;	or (OBJECT PTR [edi]).fstatus,100b ;set it in child.
;      .ELSE
	   invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0 ;external
	   .IF ax==1
	     lea eax,szexter9 ;szeruu1
	     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	     jmp zoono1
	   .ENDIF
;      .ENDIF
      ;it must be private...
      mov (OBJECT PTR [edi]).nexttype,3
      ;and have same perm/temp as parent...
      mov ebx,pparent
      mov al,(OBJECT PTR [ebx]).fconfig
      and al,1100000b	;bit6/5=01 temp-private.
      .IF al==0100000b	  ;yep its temp.
	mov al,(OBJECT PTR [edi]).fconfig
	and al,10111111b
	or  al,00100000b
	mov (OBJECT PTR [edi]).fconfig,al ;set child private-temp
      .ELSE
	;set child private-perm...
	mov al,(OBJECT PTR [edi]).fconfig
	and al,10011111b
	mov (OBJECT PTR [edi]).fconfig,al ;set child private-temp
      .ENDIF
      jmp vv1	;bypass reading the checkboxes.
    .ENDIF
ee1:


;*NO* why not let external res's be any type?...
  mov fext,0
;...see above code.

;now update from the visibility buttons...
 invoke SendDlgItemMessage,hdlg,334,BM_GETCHECK,0,0
.IF  ax==1		;private-temporary radiobutton checked.
   .IF fext==1
     lea eax,szer151b
     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
   .ELSE
     mov (OBJECT PTR [edi]).nexttype,3
     and (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
     or	 (OBJECT PTR [edi]).fconfig,00100000b	;set bit5.
   .ENDIF
.ELSE
 invoke SendDlgItemMessage,hdlg,330,BM_GETCHECK,0,0
 .IF  ax==1		;private radiobutton checked.
   .IF fext==1
     lea eax,szer151b
     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
   .ELSE
     mov (OBJECT PTR [edi]).nexttype,3
     and (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
   .ENDIF
 .ELSE
   mov	(OBJECT PTR [edi]).nexttype,4
   invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
   .IF	ax==1		;shareable permanent.
     and  (OBJECT PTR [edi]).fconfig,00011111b	;clr bit5&6.
		;...also clr bit7, marks resource shareable as permanent.
   .ELSE
     invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0
     .IF ax==1		;thread (file)
       .IF fext==1
	 lea eax,szer151b
	 invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
       .ELSE
	 and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	 or   (OBJECT PTR [edi]).fconfig,00100000b	;set bit5.
       .ENDIF
     .ELSE
       invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0
       .IF ax==1		;shareable-temporary.
	 .IF fext==1
	   lea eax,szer151b
	   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	 .ELSE
	   and	(OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	   or	(OBJECT PTR [edi]).fconfig,10000000b	;set bit7.
	 .ENDIF
       .ELSE			;global...(public)
	 and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	 or  (OBJECT PTR [edi]).fconfig,01000000b	;global. set bit6.
       .ENDIF
     .ENDIF
   .ENDIF
 .ENDIF
.ENDIF
vv1:

;update force overrides for generated source file...
;218 is the force-not-instantiated override...
	 invoke SendDlgItemMessage,hdlg,218,BM_GETCHECK,0,0
	 .IF ax==1
	   or (OBJECT PTR [edi]).fconfig,010b	;set bit1. do not compose.
	   ;set res. fill color to grey...
	   mov	(OBJECT PTR [edi]).ncolour1,0C0C0C0h
	   or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	 .ELSE
	   mov al,(OBJECT PTR [edi]).fconfig
	   and al,010b	;do-not-compose bit.
	   .IF al==010b
	     and (OBJECT PTR [edi]).fconfig,11111101b ;clr bit1.
	     ;clr fill color...
	     mov	(OBJECT PTR [edi]).ncolour1,0
	     and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	   .ENDIF

;223 is the force-external override...
	   invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
	   .IF ax==1
;only allowed to force external on public data...
	       mov ax,(OBJECT PTR [edi]).nexttype
	       .IF ax==4
		 mov al,(OBJECT PTR [edi]).fconfig
		 and al,01100000b	;extract bits6/5.
		 .IF al==01000000b	;global?
;		 .ELSEIF al==0		;shareable
;		   test (OBJECT PTR [edi]).fconfig,10000000b ;bit7=1 temporary.
;		   jnz	g204
		 .ELSE			;external not allowed.
g204:		   lea	eax,szexter9
		   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		   jmp zoono1
		 .ENDIF
	       .ELSE
		   jmp g204
	       .ENDIF
	     or (OBJECT PTR [edi]).fstatus,0100b ;set bit2. force external.

;*NO* leave resource owned by parent node, even though marked external!!!
;	     ;not sure about this, but need to set res.key1-->a node that
;	     ;is not in this subdiagram. why not point to the resource,
;	     ;i.e. point to itself?...
;	     mov eax,edi
;	     sub eax,pTERSEDATA ;cos relative ptr.
;	     mov (OBJECT PTR [edi]).rplock1,eax
;	     ;...i'm now relying on this to display "EXTERNAL" in the
;	     ;"Who owns me?" box.
	   .ELSE
	     ;if the owner-node is external, the resource must stay
	     ;external also...
	     mov ebx,(OBJECT PTR [edi]).rplock1
	     add ebx,pTERSEDATA ;cos relative ptr.
	     mov ax,(OBJECT PTR [ebx]).nexttype
	     .IF ax==0	    ;node
	       ;node.fstatus2/bit2/1 =11 is external.
	       mov al,(OBJECT PTR [ebx]).fstatus2
	       and al,0110b
	       .IF al==110b ;owner is external.
		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ELSE
	       ;if ever allow res attach another res, parentres.fstatus
	       ;bit2=1 is external...
	       mov al,(OBJECT PTR [ebx]).fstatus
	       and al,0100b
	       .IF al==0100b	      ;owner-res is external
;		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
		 ;no, i think child of data-element should remain private
		 ;not external (cos "extern" will display above it)...
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ENDIF



;	     mov eax,(OBJECT PTR [edi]).rplock1
;	     add eax,pTERSEDATA ;cos relative ptr.
;	     .IF eax==edi ;will only be -->itself if previously set external.
;	       mov (OBJECT PTR [edi]).rplock1,0	;it is now an orphan.
;	     .ENDIF
	   .ENDIF

	 .ENDIF




      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF ax==IDCANCEL    ;lo-wparam
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE


    .ELSE
      mov eax,FALSE
    .ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
PTRproc	ENDP
;--------------------------------------------------------------------------
ARRAYproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
  LOCAL fext:BYTE
  LOCAL pparent:DWORD
;from wmrbuttondown/state0  data object dialog. "arrayproc"
;dialog box for data of .fstatus2/bits7/6/5=011 (array variable)

	mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit1 = invisible node.
	test  al,00000010b
	jz ke219
	push eax
	invoke SendDlgItemMessage,hdlg,303,BM_SETCHECK,1,0
	pop  eax
ke219:
	;bit5 = display label on diagram, bit6=display terminal #s.
	test  al,00100000b
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display fill color...	(even if it can mean something else)
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,10,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .color even if it means something else.
kenf2:

;display task number...	(was resource#)
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,250,WM_SETTEXT,0,esi

;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage, hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.

;.sztext5-8 is initial value --stored
;as ascii chars...
	lea  esi,(OBJECT PTR [edi]).sztext5
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,227,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,227,EM_LIMITTEXT,894,0 ;set limit.

;# elements in array...
;NO, must be stored as ascii string...
;	mov  eax,(OBJECT PTR [edi]).ntimeout
;	invoke bin2dec		;eax-->asciitbl (10 digits+0)
;	lea  esi,szasciitbl
;	    mov  al,[esi]	;ignore leading blanks.
;	    .WHILE al==" "	;/
;	      inc  esi		;/
;	      mov  al,[esi]	;/
;	    .ENDW		;/
	lea  esi,(OBJECT PTR [edi]).sztext2
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,224,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,224,EM_LIMITTEXT,62,0 ;set limit.


;make it read only if parent is a pointer-element...
	mov ebx,(OBJECT PTR [edi]).rplock1
	.IF ebx==0
	.ELSE
	  add ebx,pTERSEDATA
	  mov ax,(OBJECT PTR [ebx]).nexttype
	  .IF ax==3
	    jmp SHORT pw1
	  .ELSEIF ax==4
pw1:	    mov al,(OBJECT PTR [ebx]).fstatus2
	    and al,11100000b
	    .IF al==00100000b	;pointer
       mov (OBJECT PTR [edi]).sztext2,0     ;null string.
       invoke SendDlgItemMessage,hdlg,224,EM_SETREADONLY,TRUE,0  ;#elements
pw1x:
	;name of data...
       mov (OBJECT PTR [edi]).sztext1,0 ;make sure empty.
       invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_SETREADONLY,TRUE,0
       mov (OBJECT PTR [edi]).sztext5,0
       invoke SendDlgItemMessage,hdlg,227,EM_SETREADONLY,TRUE,0  ;initialval
	    .ELSEIF al==01100000b ;parent is an array.
	      jmp pw1x
	    .ENDIF
	  .ENDIF
	.ENDIF


;display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.

;have introduced datatype combo/listbox...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,305,CB_ADDSTRING,0,esi
  mov  al,(OBJECT PTR [edi]).ndatatype
  and  al,0Fh
  .IF al==0Fh		;data is a reference type (ptr,array,structure)
    mov  al,(OBJECT PTR [edi]).nptrtype
    and  al,0Fh
    .IF  al==0			;pointer.
      lea  esi,szptrtype1
    .ELSEIF al==1		;array.
      lea  esi,szptrtype2
    .ELSE			;structure.
      lea  esi,szptrtype16
    .ENDIF
    invoke SendDlgItemMessage,hdlg,305,CB_ADDSTRING,0,esi
    invoke SendDlgItemMessage,hdlg,305,CB_SETCURSEL,0,0
  .ELSE
    mov	ecx,15	;16	;don't display last entry (refrence)
    mov ebx,pTERSEDATA
    lea	esi,(TERSEDATA PTR [ebx]).sztype1
ummzz:
    push ecx
    invoke SendDlgItemMessage,hdlg,305,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48 ;8
    loop ummzz
;set the selection in the combobox...
    xor	eax,eax
    mov	al,(OBJECT PTR [edi]).ndatatype
    and	al,0Fh			;lower 4 bits only.
    .IF	al==0Fh		;pointer datatype.
      xor  eax,eax
      mov  al,(OBJECT PTR [edi]).nptrtype
      and  al,0Fh
      invoke SendDlgItemMessage,hdlg,305,CB_SETCURSEL,eax,0
    .ELSE
      invoke SendDlgItemMessage,hdlg,305,CB_SETCURSEL,eax,0
    .ENDIF
  .ENDIF


;data memory type combobox...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    mov	ecx,48 ;8
    mov ebx,pTERSEDATA
    lea	esi,(TERSEDATA PTR [ebx]).szpre1
hmmzz:
    mov  al,[esi]
    cmp  al,0		;ignore null strings.
    je	 immzz
    push ecx
    invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48 ;8
    loop hmmzz
immzz:
      xor  eax,eax
      mov  al,(OBJECT PTR [edi]).nmemtype2
      and  al,0Fh
      invoke SendDlgItemMessage,hdlg,358,CB_SETCURSEL,eax,0


;visibility options...
	xor eax,eax
	mov  ax,(OBJECT PTR [edi]).nexttype
	.IF  ax==3		;private resource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;private static.
	    invoke SendDlgItemMessage,hdlg,330,BM_SETCHECK,1,0
	  .ELSE 		;private temporary.
	    invoke SendDlgItemMessage,hdlg,334,BM_SETCHECK,1,0
	  .ENDIF
	.ELSEIF al==4		;shareable/global resource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;shareable.
	    ;shareable is temporary if .fconfig.7 =1....
	    mov  al,(OBJECT PTR [edi]).fconfig
	    and  al,10000000b
	    .IF  al==0		;permanent resource.
	      invoke SendDlgItemMessage,hdlg,329,BM_SETCHECK,1,0
	    .ELSE		;temporary resource.
	      invoke SendDlgItemMessage,hdlg,400,BM_SETCHECK,1,0
	    .ENDIF
	  .ELSE 		;global/universal.
	    and  al,01000000b	;test for universal.
	    .IF  al==0
	      invoke SendDlgItemMessage,hdlg,328,BM_SETCHECK,1,0
	    .ELSE
	      invoke SendDlgItemMessage,hdlg,332,BM_SETCHECK,1,0
	    .ENDIF
	  .ENDIF
	.ENDIF

;display label of node that owns this resource...
;note that this is read-only, so no need to unload from dialog.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	    mov ebx,eax
	    lea eax,(OBJECT PTR [ebx]).sztext1
	    invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	.ENDIF

;Force overrides on generated source file...
	test (OBJECT PTR [edi]).fconfig,010b	;bit1=1 do not compose.
	jz   a204
	invoke SendDlgItemMessage,hdlg,218,BM_SETCHECK,1,0
a204:	test (OBJECT PTR [edi]).fstatus,0100b	;bit2=1 force external.
	jz   b204
	invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,1,0
b204:

;upload number of object/element (was sub-project number)...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).number
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,esi



      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK    ;lo-wparam
      mov  g_fhaschanged,1

;update the database...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,192			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext1/2/3)
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi

;;13-3-98 don't allow label to have forbidden characters...
;	invoke findbadchar, si	    ;x=0 not found, else ax-->bad char.
;	.IF  ax==0
;	.ELSE		;bad char found.
;	  lea	ax,cs:SECszbadchar
;	  invoke MESSAGEBOX,iihWnd, cs::ax, 0, MB_OK+MB_ICONEXCLAMATION
;	  mov	(OBJECT PTR [di]).szlabel,0	;clr label.
;	  jmp  zoono1	;don't end the dialog box.
;	.ENDIF

 invoke SendDlgItemMessage,hdlg,303,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;invisible node button is checked.
	  or  bl,00000010b
	.ELSE
	  and bl,11111101b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bl,11011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update font size in .status field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .color field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,11,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov  (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset

;initialisation value... (sztext5-8)
		lea  esi,(OBJECT PTR [edi]).sztext5 ;zeroise it first.
		mov  ecx,896			  ;/(also fills following
izoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext5-8)
		loop izoo1			  ;/
	lea  eax,(OBJECT PTR [edi]).sztext5
	invoke SendDlgItemMessage,hdlg,227,WM_GETTEXT,895,eax
    and	(OBJECT PTR [edi]).fconfig,11100111b ;clr bits3/4.--precaution.
    ;...?????? why????

;read datatype selection from listbox/combo...
    invoke SendDlgItemMessage,hdlg,305,CB_GETCURSEL,0,0
    and	ax,0Fh
    mov  cl,(OBJECT PTR [edi]).ndatatype
    and  cl,0Fh
    .IF  cl==0Fh		;reference type.
      ;...can't change from resource.(fixed by attached subnode).
    .ELSE
      mov  cl,(OBJECT PTR [edi]).ndatatype
      and  cl,0F0h	;leave hi-nibble alone, in case want use.
      or   al,cl
      mov  (OBJECT PTR [edi]).ndatatype,al
    .ENDIF


;update memory type from combobox...
    invoke SendDlgItemMessage,hdlg,358,CB_GETCURSEL,0,0
    and	ax,0Fh
      mov  cl,(OBJECT PTR [edi]).nmemtype2
      and  cl,0F0h	;leave hi-nibble alone, in case want use.
      or   al,cl
      mov  (OBJECT PTR [edi]).nmemtype2,al


;update visibility options...
    ;if the owner of this data resource is a clone node, the resource
    ;must be shareable permanent. This is automatically set when
    ;placing the new resource, in wmlbuttondown()/state4.
    ;now, prevent it from being changed...
    mov ebx,(OBJECT PTR [edi]).rplock1	   ;pts to parent.
    .IF ebx==0	;free resource, which isn't allowed --precaution.
    .ELSE
      add ebx,pTERSEDATA    ;make it absolute addr.
      mov eax,(OBJECT PTR [ebx]).rplock1
      .IF eax==0	;parent node is "free".
      .ELSE
	;check that parent is a node...
	mov ax,(OBJECT PTR [ebx]).nexttype
	cmp ax,0	;=0, node.
	jne py1
	invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
	.IF	ax==1		;shareable permanent. ok.
	.ELSE
	  lea eax,szersh7
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  jmp vv1	;bypass reading the checkboxes.
	.ENDIF
      .ENDIF
    .ENDIF
py1:

;if resource is child of a parent resource (cannot happen harwdare element)
;it must retain some characteristics of parent...
    mov ebx,(OBJECT PTR [edi]).rplock1	   ;pts to parent.
    .IF ebx==0	;free resource, which isn't allowed --precaution.
    .ELSE
      add ebx,pTERSEDATA    ;make it absolute addr.
      mov pparent,ebx
      mov ax,(OBJECT PTR [ebx]).nexttype
      cmp ax,3		    ;parent is private data.
      je ee1x
      cmp ax,4		    ;parent is global data.
      jne ee1
ee1x:		;parent is a data element.
;is parent a pointer....
      mov al,(OBJECT PTR [ebx]).fstatus2
      and al,11100000b
      .IF al==00100000b	    ;pointer
	;child can't have a name, nor initialisation value...
	mov al,(OBJECT PTR [edi]).sztext1
	.IF al==0   ;ok
	.ELSE
	  lea eax,szeruu3
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov (OBJECT PTR [edi]).sztext1,0
	.ENDIF
	mov al,(OBJECT PTR [edi]).sztext2
	.IF al==0   ;ok
	.ELSE
	  lea eax,szeruu3
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov (OBJECT PTR [edi]).sztext2,0
	.ENDIF
      .ENDIF

	invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
	.IF	ax==1		;shareable permanent.
we1:	  ;error...
	  lea eax,szeruu1
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  jmp out4
	.ENDIF
	;could check other checkboxes here...
	invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0
	.IF ax==1		;thread (file)
	  jmp we1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0
	.IF ax==1		;shareable-temporary.
	  jmp we1
	.ENDIF
	invoke SendDlgItemMessage,hdlg,332,BM_GETCHECK,0,0
	.IF ax==1		;public
	  jmp we1
	.ENDIF
out4:
      mov ebx,pparent
      mov al,(OBJECT PTR [ebx]).fstatus
      and al,100b	    ;bit2=1, external.
;      .IF al==100b
;	or (OBJECT PTR [edi]).fstatus,100b ;set it in child.
;      .ELSE
	   invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0 ;external
	   .IF ax==1
	     lea eax,szexter9 ;szeruu1
	     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	     jmp zoono1
	   .ENDIF
;      .ENDIF
      ;it must be private...
      mov (OBJECT PTR [edi]).nexttype,3
      ;and have same perm/temp as parent...
      mov ebx,pparent
      mov al,(OBJECT PTR [ebx]).fconfig
      and al,1100000b	;bit6/5=01 temp-private.
      .IF al==0100000b	  ;yep its temp.
	mov al,(OBJECT PTR [edi]).fconfig
	and al,10111111b
	or  al,00100000b
	mov (OBJECT PTR [edi]).fconfig,al ;set child private-temp
      .ELSE
	;set child private-perm...
	mov al,(OBJECT PTR [edi]).fconfig
	and al,10011111b
	mov (OBJECT PTR [edi]).fconfig,al ;set child private-temp
      .ENDIF
      jmp vv1	;bypass reading the checkboxes.
    .ENDIF
ee1:


;*NO* why not let external res's be any type?...
  mov fext,0
;...see above code.

;now update from the visibility buttons...
 invoke SendDlgItemMessage,hdlg,334,BM_GETCHECK,0,0
.IF  ax==1		;private-temporary radiobutton checked.
   .IF fext==1
     lea eax,szer151b
     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
   .ELSE
     mov (OBJECT PTR [edi]).nexttype,3
     and (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
     or	 (OBJECT PTR [edi]).fconfig,00100000b	;set bit5.
   .ENDIF
.ELSE
 invoke SendDlgItemMessage,hdlg,330,BM_GETCHECK,0,0
 .IF  ax==1		;private radiobutton checked.
   .IF fext==1
     lea eax,szer151b
     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
   .ELSE
     mov (OBJECT PTR [edi]).nexttype,3
     and (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
   .ENDIF
 .ELSE
   mov	(OBJECT PTR [edi]).nexttype,4
   invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
   .IF	ax==1		;shareable permanent.
     and  (OBJECT PTR [edi]).fconfig,00011111b	;clr bit5&6.
		;...also clr bit7, marks resource shareable as permanent.
   .ELSE
     invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0
     .IF ax==1		;thread (file)
       .IF fext==1
	 lea eax,szer151b
	 invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
       .ELSE
	 and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	 or   (OBJECT PTR [edi]).fconfig,00100000b	;set bit5.
       .ENDIF
     .ELSE
       invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0
       .IF ax==1		;shareable-temporary.
	 .IF fext==1
	   lea eax,szer151b
	   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	 .ELSE
	   and	(OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	   or	(OBJECT PTR [edi]).fconfig,10000000b	;set bit7.
	 .ENDIF
       .ELSE			;global...(public)
	 and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	 or  (OBJECT PTR [edi]).fconfig,01000000b	;global. set bit6.
       .ENDIF
     .ENDIF
   .ENDIF
 .ENDIF
.ENDIF
vv1:

;update force overrides for generated source file...
;218 is the force-not-instantiated override...
	 invoke SendDlgItemMessage,hdlg,218,BM_GETCHECK,0,0
	 .IF ax==1
	   or (OBJECT PTR [edi]).fconfig,010b	;set bit1. do not compose.
	   ;set res. fill color to grey...
	   mov	(OBJECT PTR [edi]).ncolour1,0C0C0C0h
	   or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	 .ELSE
	   mov al,(OBJECT PTR [edi]).fconfig
	   and al,010b	;do-not-compose bit.
	   .IF al==010b
	     and (OBJECT PTR [edi]).fconfig,11111101b ;clr bit1.
	     ;clr fill color...
	     mov	(OBJECT PTR [edi]).ncolour1,0
	     and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	   .ENDIF

;223 is the force-external override...
	   invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
	   .IF ax==1
;only allowed to force external on public data...
	       mov ax,(OBJECT PTR [edi]).nexttype
	       .IF ax==4
		 mov al,(OBJECT PTR [edi]).fconfig
		 and al,01100000b	;extract bits6/5.
		 .IF al==01000000b	;global?
;		 .ELSEIF al==0		;shareable
;		   test (OBJECT PTR [edi]).fconfig,10000000b ;bit7=1 temporary.
;		   jnz	g204
		 .ELSE			;external not allowed.
g204:		   lea	eax,szexter9
		   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		   jmp zoono1
		 .ENDIF
	       .ELSE
		   jmp g204
	       .ENDIF
	     or (OBJECT PTR [edi]).fstatus,0100b ;set bit2. force external.

;*NO* leave resource owned by parent node, even though marked external!!!
;	     ;not sure about this, but need to set res.key1-->a node that
;	     ;is not in this subdiagram. why not point to the resource,
;	     ;i.e. point to itself?...
;	     mov eax,edi
;	     sub eax,pTERSEDATA ;cos relative ptr.
;	     mov (OBJECT PTR [edi]).rplock1,eax
;	     ;...i'm now relying on this to display "EXTERNAL" in the
;	     ;"Who owns me?" box.
	   .ELSE
	     ;if the owner-node is external, the resource must stay
	     ;external also...
	     mov ebx,(OBJECT PTR [edi]).rplock1
	     add ebx,pTERSEDATA ;cos relative ptr.
	     mov ax,(OBJECT PTR [ebx]).nexttype
	     .IF ax==0	    ;node
	       ;node.fstatus2/bit2/1 =11 is external.
	       mov al,(OBJECT PTR [ebx]).fstatus2
	       and al,0110b
	       .IF al==110b ;owner is external.
		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ELSE
	       ;if ever allow res attach another res, parentres.fstatus
	       ;bit2=1 is external...
	       mov al,(OBJECT PTR [ebx]).fstatus
	       and al,0100b
	       .IF al==0100b	      ;owner-res is external
;		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
		 ;no, i think child of data-element should remain private
		 ;not external (cos "extern" will display above it)...
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ENDIF



;	     mov eax,(OBJECT PTR [edi]).rplock1
;	     add eax,pTERSEDATA ;cos relative ptr.
;	     .IF eax==edi ;will only be -->itself if previously set external.
;	       mov (OBJECT PTR [edi]).rplock1,0	;it is now an orphan.
;	     .ENDIF
	   .ENDIF

	 .ENDIF


;# elements in array...
;NO, now saving as a ascii string, in .sztext2...
;	invoke SendDlgItemMessage,hdlg,224,WM_GETTEXT,11,ADDR szasciitbl
;	invoke str2longint, ADDR szasciitbl	;-->eax
;	mov  (OBJECT PTR [edi]).ntimeout,eax
		lea  esi,(OBJECT PTR [edi]).sztext2 ;zeroise it first.
		mov  ecx,64			  ;/
xizoo1:		mov  [esi],BYTE PTR 0		  ;/
		inc  esi			  ;/
		loop xizoo1			  ;/
	lea  eax,(OBJECT PTR [edi]).sztext2
	invoke SendDlgItemMessage,hdlg,224,WM_GETTEXT,63,eax



      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF ax==IDCANCEL    ;lo-wparam
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE


    .ELSE
      mov eax,FALSE
    .ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
ARRAYproc	ENDP
;--------------------------------------------------------------------------
genericproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
  LOCAL fext:BYTE
  LOCAL pparent:DWORD
;from wmrbuttondown/state0  data object dialog. "genericproc"
;dialog box for data of .fstatus2/bits7/6/5=100 (generic variable)

	mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit1 = invisible node.
	test  al,00000010b
	jz ke219
	push eax
	invoke SendDlgItemMessage,hdlg,303,BM_SETCHECK,1,0
	pop  eax
ke219:
	;bit5 = display label on diagram, bit6=display terminal #s.
	test  al,00100000b
	jz ke21z
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
	jmp ke21
ke21z:	test al,01000000b   ;bit6=1 display data declaration.
	jz ke21v
	push eax
	invoke SendDlgItemMessage,hdlg,226,BM_SETCHECK,1,0
	pop  eax
	jmp ke21
ke21v:	;display nothing...
	push eax
	invoke SendDlgItemMessage,hdlg,229,BM_SETCHECK,1,0
	pop  eax
ke21:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;display fill color...	(even if it can mean something else)
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,10,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .color even if it means something else.
kenf2:

;display task number...	(was resource#)
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,250,WM_SETTEXT,0,esi

;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage, hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.

;.sztext5-8 is initial value --stored
;as ascii chars...
	lea  esi,(OBJECT PTR [edi]).sztext5
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,227,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,227,EM_LIMITTEXT,894,0 ;set limit.


;display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.


;display label of node that owns this resource...
;note that this is read-only, so no need to unload from dialog.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	    mov ebx,eax
	    lea eax,(OBJECT PTR [ebx]).sztext1
	    invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	.ENDIF

;upload number of object/element (was sub-project number)...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).number
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,esi

;set checkbox for compose-mode...
	mov al,(OBJECT PTR [edi]).fconfig3
	and al,011b	;bits 1/0.
	.IF al==00
	  ;default to...
	  or (OBJECT PTR [edi]).fconfig3,01b
	  invoke SendDlgItemMessage,hdlg,235,BM_SETCHECK,1,0
	.ELSEIF al==01b ;compose inside function.
	  invoke SendDlgItemMessage,hdlg,235,BM_SETCHECK,1,0
	.ELSEIF al==10b ;compose before function.
	  invoke SendDlgItemMessage,hdlg,234,BM_SETCHECK,1,0
	.ELSE	;al=11b ;compose before all funcs.
	  invoke SendDlgItemMessage,hdlg,233,BM_SETCHECK,1,0
	.ENDIF


      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
    .IF	ax==IDOK    ;lo-wparam
      mov  g_fhaschanged,1

;update the database...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,192			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext1/2/3)
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi

 invoke SendDlgItemMessage,hdlg,303,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;invisible node button is checked.
	  or  bl,00000010b
	.ELSE
	  and bl,11111101b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b    ;bit5.
	.ELSE
	  and bl,11011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,226,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly data-declaration button is checked.
	  or  bl,01000000b
	.ELSE
	  and bl,10111111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
; invoke SendDlgItemMessage,hdlg,229,BM_GETCHECK,0,0
;	xor ebx,ebx
;	mov	bl,(OBJECT PTR [edi]).fstatus
;	.IF ax==1	;dispaly nothing button is checked.
;	  or  bl,00000000b
;	.ELSE
;	  and bl,11111111b
;	.ENDIF
;	mov	(OBJECT PTR [edi]).fstatus,bl



;update font size in .status field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .color field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,11,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov  (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset

;declaration... (sztext5-8)
		lea  esi,(OBJECT PTR [edi]).sztext5 ;zeroise it first.
		mov  ecx,896			  ;/(also fills following
izoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext5-8)
		loop izoo1			  ;/
	lea  eax,(OBJECT PTR [edi]).sztext5
	invoke SendDlgItemMessage,hdlg,227,WM_GETTEXT,895,eax
    and	(OBJECT PTR [edi]).fconfig,11100111b ;clr bits3/4.--precaution.
    ;...?????? why????

;update compose mode...
 invoke SendDlgItemMessage,hdlg,235,BM_GETCHECK,0,0 ;compose inside func.
	.IF  ax==1	;button checked.
	  mov al,(OBJECT PTR [edi]).fconfig3
	  and al,11111100b
	  or  al,00000001b
	  mov (OBJECT PTR [edi]).fconfig3,al
	.ENDIF
 invoke SendDlgItemMessage,hdlg,234,BM_GETCHECK,0,0 ;compose before func.
	.IF  ax==1	;button checked.
	  mov al,(OBJECT PTR [edi]).fconfig3
	  and al,11111100b
	  or  al,00000010b
	  mov (OBJECT PTR [edi]).fconfig3,al
	.ENDIF
 invoke SendDlgItemMessage,hdlg,233,BM_GETCHECK,0,0 ;before all funcs.
	.IF  ax==1	;button checked.
	  mov al,(OBJECT PTR [edi]).fconfig3
	  and al,11111100b
	  or  al,00000011b
	  mov (OBJECT PTR [edi]).fconfig3,al
	.ENDIF



      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF ax==IDCANCEL    ;lo-wparam
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE


    .ELSE
      mov eax,FALSE
    .ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
genericproc	ENDP
;--------------------------------------------------------------------------
HARDWAREproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
  LOCAL fext:BYTE
;from wmrbuttondown/state0  data object dialog. "hardwareproc"
;dialog box for hardware interface.
;private has .nexttype=50 (default), global has .nexttype=51.

	mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;set the checkboxes...
	xor eax,eax
	mov	al,(OBJECT PTR [edi]).fstatus
	;bit1 = invisible node.
	test  al,00000010b
	jz ke219
	push eax
	invoke SendDlgItemMessage,hdlg,303,BM_SETCHECK,1,0
	pop  eax
ke219:
	;bit5 = display label on diagram, bit6=display terminal #s.
	test  al,00100000b
	jz ke21
	push eax
	invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_SETCHECK,1,0
	pop  eax
ke21:
	and  al,00011000b
	.IF  al==0		;x1 font
	invoke SendDlgItemMessage,hdlg,K2F1,BM_SETCHECK,1,0
	.ELSEIF al==00001000b	;x1.5 font
	invoke SendDlgItemMessage,hdlg,K2F15,BM_SETCHECK,1,0
	.ELSEIF al==00010000b	;x2 font
	invoke SendDlgItemMessage,hdlg,K2F2,BM_SETCHECK,1,0
	.ELSEIF al==00011000b	;x4 font
	invoke SendDlgItemMessage,hdlg,K2F4,BM_SETCHECK,1,0
	.ENDIF
ke22v:

;"access by" options...
	mov al,(OBJECT PTR [edi]).nfunctype ;(this field used
	   ; differently by nodes)
	.IF  al==0		;variable.
	invoke SendDlgItemMessage,hdlg,216,BM_SETCHECK,1,0
	.ELSEIF al==1		;interrupt.
	invoke SendDlgItemMessage,hdlg,217,BM_SETCHECK,1,0
	.ENDIF


;display fill color...	(even if it can mean something else)
	test (OBJECT PTR [edi]).fconfig,0100b ;bit2=1 turns on color.
	jz   kenf1
	invoke SendDlgItemMessage,hdlg,K5CF,BM_SETCHECK,1,0
ken4:
	mov  eax,(OBJECT PTR [edi]).ncolour1
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,K5FC,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,K5FC,EM_LIMITTEXT,10,0 ;set limit.
	jmp  SHORT kenf2
kenf1:
	invoke SendDlgItemMessage,hdlg,K5NF,BM_SETCHECK,1,0
	jmp ken4 ;display .color even if it means something else.
kenf2:

;display task number...	(was resource#)
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).nfile
	invoke bin2dec		;eax-->asciitbl (10 digits+0)
	lea  esi,szasciitbl
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,250,WM_SETTEXT,0,esi

;display current label...
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage, hdlg,IDD_K2LABEL,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,EM_LIMITTEXT,62,0 ;set limit.

;display label x/y offset...
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).xlabeloffset ;x
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,KXOFF,EM_LIMITTEXT,3,0 ;set limit.
	xor  eax,eax
	xor  edx,edx
	mov  ax,(OBJECT PTR [edi]).ylabeloffset ;y
	mov  cx,ax
	and  cx,8000h	;test if negative
	.IF  cx==0	;+ve
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	.ELSE		;-ve
	  neg ax
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+7
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
	  dec  esi
	  mov  [esi],BYTE PTR "-"
	.ENDIF
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_SETTEXT,0,esi
invoke SendDlgItemMessage,hdlg,KYOFF,EM_LIMITTEXT,3,0 ;set limit.

;;now upload the midfix text. stored as ascii...
;	lea  esi,(OBJECT PTR [edi]).sztext3
;	    mov  al,[esi]	;ignore leading blanks.
;	    .WHILE al==" "	;/
;	      inc  esi		;/
;	      mov  al,[esi]	;/
;	    .ENDW		;/
; invoke SendDlgItemMessage,hdlg,360,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,360,EM_LIMITTEXT,62,0 ;set limit.

;have introduced datatype combo/listbox...
  mov  al,(OBJECT PTR [edi]).ndatatype
  and  al,0Fh
  .IF al==0Fh		;data is a reference type (ptr,array,structure)
    mov  al,(OBJECT PTR [edi]).nptrtype
    and  al,0Fh
    .IF  al==0			;pointer.
      lea  esi,szptrtype1
    .ELSEIF al==1		;array.
      lea  esi,szptrtype2
    .ELSE			;structure.
      lea  esi,szptrtype16
    .ENDIF
    invoke SendDlgItemMessage,hdlg,305,CB_ADDSTRING,0,esi
    invoke SendDlgItemMessage,hdlg,305,CB_SETCURSEL,0,0
  .ELSE
    mov	ecx,15	;16	;don't display last entry (refrence)
    mov ebx,pTERSEDATA
    lea	esi,(TERSEDATA PTR [ebx]).sztype1
ummzz:
    push ecx
    invoke SendDlgItemMessage,hdlg,305,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48 ;8
    loop ummzz
;set the selection in the combobox...
    xor	eax,eax
    mov	al,(OBJECT PTR [edi]).ndatatype
    and	al,0Fh			;lower 4 bits only.
    .IF	al==0Fh		;pointer datatype.
      xor  eax,eax
      mov  al,(OBJECT PTR [edi]).nptrtype
      and  al,0Fh
      invoke SendDlgItemMessage,hdlg,305,CB_SETCURSEL,ax,0
    .ELSE
      invoke SendDlgItemMessage,hdlg,305,CB_SETCURSEL,ax,0
    .ENDIF
  .ENDIF

;data memory type combobox...
;firstly, allow selection of nothing...
      lea  esi,sznull
      invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    mov	ecx,48 ;8
    mov ebx,pTERSEDATA
    lea	esi,(TERSEDATA PTR [ebx]).szpre1
hmmzz:
    mov  al,[esi]
    cmp  al,0		;ignore null strings.
    je	 immzz
    push ecx
    invoke SendDlgItemMessage,hdlg,358,CB_ADDSTRING,0,esi
    pop	ecx
    add	esi,48 ;8
    loop hmmzz
immzz:
      xor  eax,eax
      mov  al,(OBJECT PTR [edi]).nmemtype1
      and  al,0Fh
      invoke SendDlgItemMessage,hdlg,358,CB_SETCURSEL,eax,0

;;variable name prefix combobox...
;;firstly, allow selection of nothing...
;      lea  esi,sznull
;      invoke SendDlgItemMessage,hdlg,228,CB_ADDSTRING,0,esi
;    mov	ecx,48 ;8
;    mov ebx,pTERSEDATA
;    lea	esi,(TERSEDATA PTR [ebx]).szpre1
;xhmmzz:
;    mov  al,[esi]
;    cmp  al,0		;ignore null strings.
;    je	 ximmzz
;    push ecx
;    invoke SendDlgItemMessage,hdlg,228,CB_ADDSTRING,0,esi
;    pop	ecx
;    add	esi,48 ;8
;    loop xhmmzz
;ximmzz:
;      xor  eax,eax
;      mov  al,(OBJECT PTR [edi]).nmemtype2
;      and  al,0Fh
;      invoke SendDlgItemMessage,hdlg,228,CB_SETCURSEL,eax,0


;visibility options...
	xor eax,eax
	mov  ax,(OBJECT PTR [edi]).nexttype
	.IF  ax==50		;private hardwareresource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;private static.
	    invoke SendDlgItemMessage,hdlg,330,BM_SETCHECK,1,0
	  .ELSE 		;private temporary.
	  .ENDIF
	.ELSEIF al==51		;shareable/global resource.
	  mov  al,(OBJECT PTR [edi]).fconfig
	  and  al,01100000b
	  .IF  al==0		;shareable.
	    ;shareable is temporary if .fconfig.7 =1....
	    mov  al,(OBJECT PTR [edi]).fconfig
	    and  al,10000000b
	    .IF  al==0		;permanent resource.
	      invoke SendDlgItemMessage,hdlg,329,BM_SETCHECK,1,0
	    .ELSE		;temporary resource.
	    .ENDIF
	  .ELSE 		;global/universal.
	    and  al,01000000b	;test for universal.
	    .IF  al==0
	      invoke SendDlgItemMessage,hdlg,328,BM_SETCHECK,1,0
	    .ELSE
	      invoke SendDlgItemMessage,hdlg,332,BM_SETCHECK,1,0
	    .ENDIF
	  .ENDIF
	.ENDIF

;display label of node that owns this resource...
;note that this is read-only, so no need to unload from dialog.
	mov eax,(OBJECT PTR [edi]).rplock1
	.IF eax==0
	.ELSE
	  add eax,pTERSEDATA
	  .IF eax==edi	 ;when external it points to itself.
	    xor eax,eax
	    mov al,(OBJECT PTR [edi]).fstatus
	    and al,0100b	;also fstatus/bit2=1 if external.
	    .IF al==0100b
	      lea eax,szextern1
	      jmp SHORT ext1
	    .ENDIF
	  .ELSE
	    mov ebx,eax
	    lea eax,(OBJECT PTR [ebx]).sztext1
ext1:	    invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
	  .ENDIF
	.ENDIF

;Force overrides on generated source file...
	test (OBJECT PTR [edi]).fconfig,010b	;bit1=1 do not compose.
	jz   a204
	invoke SendDlgItemMessage,hdlg,218,BM_SETCHECK,1,0
a204:	test (OBJECT PTR [edi]).fstatus,0100b	;bit2=1 force external.
	jz   b204
	invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,1,0
b204:

;upload number of object/element (was sub-project number)...
	xor eax,eax
	mov	ax,(OBJECT PTR [edi]).number
	  invoke bin2dec		;eax-->szasciitbl
	  lea  esi,szasciitbl+4
	    mov  al,[esi]	;ignore leading blanks.
	    .WHILE al==" "	;/
	      inc  esi		;/
	      mov  al,[esi]	;/
	    .ENDW		;/
 invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,esi

;now upload the description...
	lea  esi,(OBJECT PTR [edi]).sztext5
 invoke SendDlgItemMessage,hdlg,224,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,224,EM_LIMITTEXT,894,0 ;set limit.


      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK
      mov  g_fhaschanged,1

;update the database...
		lea  esi,(OBJECT PTR [edi]).sztext1 ;zeroise it first.
		mov  ecx,1152			  ;/(also fills following
zoo1:		mov  [esi],BYTE PTR 0		  ;/ fields in databse
		inc  esi			  ;/  sztext1/2/3/4/5/6)
		loop zoo1			  ;/
	lea  esi,(OBJECT PTR [edi]).sztext1
 invoke SendDlgItemMessage,hdlg,IDD_K2LABEL,WM_GETTEXT,63,esi

;;13-3-98 don't allow label to have forbidden characters...
;	invoke findbadchar, si	    ;x=0 not found, else ax-->bad char.
;	.IF  ax==0
;	.ELSE		;bad char found.
;	  lea	ax,cs:SECszbadchar
;	  invoke MESSAGEBOX,iihWnd, cs::ax, 0, MB_OK+MB_ICONEXCLAMATION
;	  mov	(OBJECT PTR [di]).szlabel,0	;clr label.
;	  jmp  zoono1	;don't end the dialog box.
;	.ENDIF

 invoke SendDlgItemMessage,hdlg,303,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;invisible node button is checked.
	  or  bl,00000010b
	.ELSE
	  and bl,11111101b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update "access by" options...
 invoke SendDlgItemMessage,hdlg,216,BM_GETCHECK,0,0
    .IF ax==1
      mov (OBJECT PTR [edi]).nfunctype,0	;i/o access by a variable.
    .ENDIF
 invoke SendDlgItemMessage,hdlg,217,BM_GETCHECK,0,0
    .IF ax==1
      mov (OBJECT PTR [edi]).nfunctype,1	;i/o access by interrupt.

      ;***NOTE*** NEED TO SEARCH DATABASE
      ;any dataflow wire connected to this resource must be
      ;set to nexttype=17, interrupt wire. ***NOTE*** TO BE DONE ***

    .ENDIF



 invoke SendDlgItemMessage,hdlg,IDD_K2CHK1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;dispaly-label button is checked.
	  or  bl,00100000b
	.ELSE
	  and bl,11011111b
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update font size in .status field ...
 invoke SendDlgItemMessage,hdlg,K2F1,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F15,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00001000b	;01
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F2,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  and  bl,11100111b	;clr bits3/4
	  or   bl,00010000b	;10
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl
 invoke SendDlgItemMessage,hdlg,K2F4,BM_GETCHECK,0,0
	xor ebx,ebx
	mov	bl,(OBJECT PTR [edi]).fstatus
	.IF ax==1	;button is checked.
	  or   bl,00011000b	;set bits3/4
	.ENDIF
	mov	(OBJECT PTR [edi]).fstatus,bl

;update the .color field...
 invoke SendDlgItemMessage,hdlg,K5CF,BM_GETCHECK,0,0 ;color-on button.
	.IF  ax==1	;button checked.
	  or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	.ELSE
	  and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	.ENDIF
 invoke SendDlgItemMessage,hdlg,K5FC,WM_GETTEXT,11,ADDR szasciitbl
	invoke str2longint, ADDR szasciitbl	;-->eax
	mov  (OBJECT PTR [edi]).ncolour1,eax

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,KXOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).xlabeloffset,ax	;x offset
 invoke SendDlgItemMessage,hdlg,KYOFF,WM_GETTEXT,4,ADDR szascii1
	invoke str2longint, ADDR szascii1	;-->eax
	mov  (OBJECT PTR [edi]).ylabeloffset,ax ;y offset

;;midfix text (sztext3)...
;	lea  eax,(OBJECT PTR [edi]).sztext3
; invoke SendDlgItemMessage,hdlg,360,WM_GETTEXT,63,eax

;read selection from listbox/combo...
    invoke SendDlgItemMessage,hdlg,305,CB_GETCURSEL,0,0
    and	ax,0Fh
    mov  cl,(OBJECT PTR [edi]).ndatatype
    and  cl,0Fh
    .IF  cl==0Fh		;reference type.
      ;...can't change from resource.(fixed by attached subnode).
    .ELSE
      mov  cl,(OBJECT PTR [edi]).ndatatype
      and  cl,0F0h	;leave hi-nibble alone, in case want use.
      or   al,cl
      mov  (OBJECT PTR [edi]).ndatatype,al
    .ENDIF

;update memory type from combobox...
    invoke SendDlgItemMessage,hdlg,358,CB_GETCURSEL,0,0
    and	ax,0Fh
      mov  cl,(OBJECT PTR [edi]).nmemtype1
      and  cl,0F0h	;leave hi-nibble alone, in case want use.
      or   al,cl
      mov  (OBJECT PTR [edi]).nmemtype1,al

;;update variable name prefix from combobox...
;    invoke SendDlgItemMessage,hdlg,228,CB_GETCURSEL,0,0
;    and	ax,0Fh
;      mov  cl,(OBJECT PTR [edi]).nmemtype2
;      and  cl,0F0h	;leave hi-nibble alone, in case want use.
;      or   al,cl
;      mov  (OBJECT PTR [edi]).nmemtype2,al

;*NO* think take this out for now...
 mov fext,0
;;if the owner is external, the attached data must be shareable-perm
;;or public. both marked external.
;;the external-flag is checked further down, but here check visibility...
;    mov ebx,(OBJECT PTR [edi]).rplock1
;    add ebx,pTERSEDATA
;    mov ax,(OBJECT PTR [ebx]).nexttype
;	     mov ax,(OBJECT PTR [ebx]).nexttype
;	     .IF ax==0	    ;node
;	       ;node.fstatus2/bit2/1 =11 is external.
;	       mov al,(OBJECT PTR [ebx]).fstatus2
;	       and al,0110b
;	       .IF al==110b ;owner is external.
;		 mov fext,1
;	       .ELSE
;		 mov fext,0
;	       .ENDIF
;	     .ELSE
;	       ;if ever allow res attach another res, parentres.fstatus
;	       ;bit2=1 is external...
;	       mov al,(OBJECT PTR [ebx]).fstatus
;	       and al,0100b
;	       .IF al==0100b	      ;owner-res is external
;		 mov fext,1
;	       .ELSE
;		 mov fext,0
;	       .ENDIF
;	     .ENDIF


;update visibility options...
 invoke SendDlgItemMessage,hdlg,330,BM_GETCHECK,0,0
 .IF  ax==1		;private radiobutton checked.
   .IF fext==1
     lea eax,szer151b
     invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
   .ELSE
    mov	(OBJECT PTR [edi]).nexttype,50 ;3
    and	(OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
   .ENDIF
 .ELSE
   mov	(OBJECT PTR [edi]).nexttype,51 ;4
   invoke SendDlgItemMessage,hdlg,329,BM_GETCHECK,0,0
   .IF	ax==1		;shareable permanent.
     and  (OBJECT PTR [edi]).fconfig,00011111b	;clr bit5&6.
		;...also clr bit7, marks resource shareable as permanent.
   .ELSE
     invoke SendDlgItemMessage,hdlg,328,BM_GETCHECK,0,0
     .IF ax==1		;thread  (file-visible)
       .IF fext==1
	 lea eax,szer151b
	 invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
       .ELSE
	and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	or   (OBJECT PTR [edi]).fconfig,00100000b	;set bit5.
       .ENDIF
     .ELSE
       invoke SendDlgItemMessage,hdlg,400,BM_GETCHECK,0,0
       .IF ax==1		;shareable-temporary.
       .ELSE			;global... (public)
	 and  (OBJECT PTR [edi]).fconfig,10011111b	;clr bit5&6.
	 or  (OBJECT PTR [edi]).fconfig,01000000b	;global. set bit6.
       .ENDIF
     .ENDIF
   .ENDIF
 .ENDIF

;update force overrides for generated source file...
	 invoke SendDlgItemMessage,hdlg,218,BM_GETCHECK,0,0
	 .IF ax==1
	   or (OBJECT PTR [edi]).fconfig,010b	;set bit1. do not compose.
	   ;set res. fill color to grey...
	   mov	(OBJECT PTR [edi]).ncolour1,0C0C0C0h
	   or (OBJECT PTR [edi]).fconfig,0100b ;set bit2.
	 .ELSE
	   mov al,(OBJECT PTR [edi]).fconfig
	   and al,010b	;do-not-compose bit.
	   .IF al==010b
	     and (OBJECT PTR [edi]).fconfig,11111101b ;clr bit1.
	     ;clr fill color...
	     mov	(OBJECT PTR [edi]).ncolour1,0
	     and (OBJECT PTR [edi]).fconfig,11111011b ;clr bit2
	   .ENDIF

;force-external checkbox...
	   invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
	   .IF ax==1
	     ;only allowed to force external on public and
	     ;permanent-shareable resources <<NO ...
	       mov ax,(OBJECT PTR [edi]).nexttype
	       .IF ax==51 ;4
		 mov al,(OBJECT PTR [edi]).fconfig
		 and al,01100000b	;extract bits6/5.
		 .IF al==01000000b	;global?
;		 .ELSEIF al==0		;shareable
;		   test (OBJECT PTR [edi]).fconfig,10000000b ;bit7=1 temporary.
;		   jnz	g204
		 .ELSE			;external not allowed.
g204:		   lea	eax,szexter9
		   invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		   jmp zoono1
		 .ENDIF
	       .ELSE
		   jmp g204
	       .ENDIF
	     or (OBJECT PTR [edi]).fstatus,0100b ;set bit2. force external.

;*NO* leave external res owned by node!!!!...
;	     ;not sure about this, but need to set res.key1-->a node that
;	     ;is not in this subdiagram. why not point to the resource,
;	     ;i.e. point to itself?...
;	     mov eax,edi
;	     sub eax,pTERSEDATA ;cos relative ptr.
;	     mov (OBJECT PTR [edi]).rplock1,eax
;	     ;...i'm now relying on this to display "EXTERNAL" in the
;	     ;"Who owns me?" box.
	   .ELSE

	     ;if the owner-node is external, the resource must stay
	     ;external also...
	     mov ebx,(OBJECT PTR [edi]).rplock1
	     add ebx,pTERSEDATA ;cos relative ptr.
	     mov ax,(OBJECT PTR [ebx]).nexttype
	     .IF ax==0	    ;node
	       ;node.fstatus2/bit2/1 =11 is external.
	       mov al,(OBJECT PTR [ebx]).fstatus2
	       and al,0110b
	       .IF al==110b ;owner is external.
		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ELSE
	       ;if ever allow res attach another res, parentres.fstatus
	       ;bit2=1 is external...
	       mov al,(OBJECT PTR [ebx]).fstatus
	       and al,0100b
	       .IF al==0100b	      ;owner-res is external
;		 or (OBJECT PTR [edi]).fstatus,0100b  ;set bit2, external.
		 ;no, i think child of data-element should remain private
		 ;not external (cos "extern" will display above it)...
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ELSE
		 and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.(externalbit)
	       .ENDIF
	     .ENDIF


;	     and (OBJECT PTR [edi]).fstatus,11111011b ;clr bit2.
;	     mov eax,(OBJECT PTR [edi]).rplock1
;	     add eax,pTERSEDATA ;cos relative ptr.
;	     .IF eax==edi ;will only be -->itself if previously set external.
;	       mov (OBJECT PTR [edi]).rplock1,0	;it is now an orphan.
;	     .ENDIF
	   .ENDIF
	 .ENDIF

;update description...
	lea  eax,(OBJECT PTR [edi]).sztext5
 invoke SendDlgItemMessage,hdlg,224,WM_GETTEXT,895,eax



      invoke EndDialog, hdlg,TRUE
zoono1:
      mov eax,TRUE
    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
HARDWAREproc	ENDP
;--------------------------------------------------------------------------
PREFSproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:BYTE
;menu Control/GOOSEE preferences... > IDM_PREFS  "prefsproc"

  .IF message==WM_INITDIALOG

;NOTE i've decided to use dblclk to invoke editor, rather than this...
;checkbox for using external editor for Action/Cond/Comment elements
;instead of dialog box...
    mov edi,pTERSEDATA
    mov al,(TERSEDATA PTR [edi]).fgooseeprefs
    and al,01	    ;bit0=1 use ext. ed.  **NOT USED**
    .IF al==01
;	invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,1,0
    .ENDIF

;arrow-key scrolling...
    mov edi,pTERSEDATA
    mov al,(TERSEDATA PTR [edi]).fgooseeprefs
    and al,010b	    ;bit1=0 incremental scrolling.
    .IF al==0
	invoke SendDlgItemMessage,hdlg,215,BM_SETCHECK,1,0
    .ELSE	    ;jump a window.
	invoke SendDlgItemMessage,hdlg,216,BM_SETCHECK,1,0
    .ENDIF

;goosee emergency-fix disable scrolling by mouse...
    mov edi,pTERSEDATA
    mov al,(TERSEDATA PTR [edi]).fgooseeprefs
    and al,0100b	    ;bit2=0 mouse scrolling enabled (default).
    .IF al==0
	invoke SendDlgItemMessage,hdlg,224,BM_SETCHECK,0,0
    .ELSE	    ;disable mouse scrolling.
	invoke SendDlgItemMessage,hdlg,224,BM_SETCHECK,1,0
    .ENDIF

;goosee emergency-fix disable intelligent window paint...
    mov edi,pTERSEDATA
    mov al,(TERSEDATA PTR [edi]).fgooseeprefs
    and al,01000b	    ;bit3=0 intelligent paint enabled (default).
    .IF al==0
	invoke SendDlgItemMessage,hdlg,225,BM_SETCHECK,0,0
    .ELSE	    ;disable intelligent paint.
	invoke SendDlgItemMessage,hdlg,225,BM_SETCHECK,1,0
    .ENDIF

;optional display color-coded rings...
    mov edi,pTERSEDATA
    mov al,(TERSEDATA PTR [edi]).fviewprefs
    and al,01	    ;bit0=1 display color coding.
    .IF al==01
	invoke SendDlgItemMessage,hdlg,226,BM_SETCHECK,1,0
    .ENDIF

;optional display white space either side action, condition, wires...
    mov al,(TERSEDATA PTR [edi]).fviewprefs
    and al,010b	    ;bit1=1 display white space.
    .IF al==010b
	invoke SendDlgItemMessage,hdlg,227,BM_SETCHECK,1,0
    .ENDIF

;default for new nodes...
    mov al,(TERSEDATA PTR [edi]).fviewprefs
    and al,01100b   ;bits 3/2.
    .IF al==0	    ;concentric rings.
	invoke SendDlgItemMessage,hdlg,230,BM_SETCHECK,1,0
    .ELSEIF al==00100b ;totem, grow-up.
	invoke SendDlgItemMessage,hdlg,231,BM_SETCHECK,1,0
    .ELSEIF al==01000b ;totem, grow-down.
	invoke SendDlgItemMessage,hdlg,232,BM_SETCHECK,1,0
    .ENDIF


      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK
      mov  g_fhaschanged,1

;;use external editor checkbox...	  **NOT USED**
;      invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
;	 mov edi,pTERSEDATA
;      .IF ax==1
;	 mov al,(TERSEDATA PTR [edi]).fgooseeprefs
;	 or al,01
;      .ELSE
;	 mov al,(TERSEDATA PTR [edi]).fgooseeprefs
;	 and al,11111110b
;      .ENDIF
;      mov (TERSEDATA PTR [edi]).fgooseeprefs,al

;arrow key scrolling...
      invoke SendDlgItemMessage,hdlg,216,BM_GETCHECK,0,0
	 mov edi,pTERSEDATA
      .IF ax==1 	    ;jump a window.
	 mov al,(TERSEDATA PTR [edi]).fgooseeprefs
	 or al,010b	    ;set bit1.
      .ELSE		    ;incremental scrolling.
	 mov al,(TERSEDATA PTR [edi]).fgooseeprefs
	 and al,11111101b   ;clr bit1.
      .ENDIF
      mov (TERSEDATA PTR [edi]).fgooseeprefs,al

;goosee emergency-fix disable scrolling by mouse...
      invoke SendDlgItemMessage,hdlg,224,BM_GETCHECK,0,0
	 mov edi,pTERSEDATA
      .IF ax==1 	    ;disable mouse scrolling.
	 mov al,(TERSEDATA PTR [edi]).fgooseeprefs
	 or al,0100b	    ;set bit2.
      .ELSE		    ;enable.
	 mov al,(TERSEDATA PTR [edi]).fgooseeprefs
	 and al,11111011b   ;clr bit2.
      .ENDIF
      mov (TERSEDATA PTR [edi]).fgooseeprefs,al

;goosee emergency-fix disable intelligent paint...
      invoke SendDlgItemMessage,hdlg,225,BM_GETCHECK,0,0
	 mov edi,pTERSEDATA
      .IF ax==1 	    ;disable intelligent paint.
	 mov al,(TERSEDATA PTR [edi]).fgooseeprefs
	 or al,01000b	    ;set bit3.
      .ELSE		    ;enable.
	 mov al,(TERSEDATA PTR [edi]).fgooseeprefs
	 and al,11110111b   ;clr bit3.
      .ENDIF
      mov (TERSEDATA PTR [edi]).fgooseeprefs,al

;optional display color coded rings...
      invoke SendDlgItemMessage,hdlg,226,BM_GETCHECK,0,0
	 mov edi,pTERSEDATA
      .IF ax==1 	    ;enable.
	 mov al,(TERSEDATA PTR [edi]).fviewprefs
	 or al,01b	    ;set bit0.
      .ELSE		    ;enable.
	 mov al,(TERSEDATA PTR [edi]).fviewprefs
	 and al,11111110b   ;clr bit0.
      .ENDIF
      mov (TERSEDATA PTR [edi]).fviewprefs,al

;optional white space...
      invoke SendDlgItemMessage,hdlg,227,BM_GETCHECK,0,0
	 mov edi,pTERSEDATA
      .IF ax==1 	    ;enable.
	 mov al,(TERSEDATA PTR [edi]).fviewprefs
	 or al,010b	    ;set bit1.
      .ELSE		    ;enable.
	 mov al,(TERSEDATA PTR [edi]).fviewprefs
	 and al,11111101b   ;clr bit1.
      .ENDIF
      mov (TERSEDATA PTR [edi]).fviewprefs,al

;new node ring default...
      invoke SendDlgItemMessage,hdlg,230,BM_GETCHECK,0,0 ;concentric.
      .IF ax==1
	and (TERSEDATA PTR [edi]).fviewprefs,11110011b
      .ENDIF
      invoke SendDlgItemMessage,hdlg,231,BM_GETCHECK,0,0 ;totem,grow-up.
      .IF ax==1
	and (TERSEDATA PTR [edi]).fviewprefs,11110011b
	or  (TERSEDATA PTR [edi]).fviewprefs,00000100b
      .ENDIF
      invoke SendDlgItemMessage,hdlg,232,BM_GETCHECK,0,0 ;totem,grow-down.
      .IF ax==1
	and (TERSEDATA PTR [edi]).fviewprefs,11110011b
	or  (TERSEDATA PTR [edi]).fviewprefs,00001000b
      .ENDIF



      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
PREFSproc	 ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
SKELETONproc PROC STDCALL,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD

  .IF message==WM_INITDIALOG

      mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    .IF	wparam==IDOK
      mov  g_fhaschanged,1


      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSEIF wparam==IDCANCEL
      invoke EndDialog, hdlg,TRUE
      mov eax,TRUE
    .ELSE
      mov eax,FALSE
    .ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
	invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.
	  push g_nmousex
	  push g_nmousey
	  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
	  pop  g_nmousey
	  pop  g_nmousex
	mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

    ret
SKELETONproc   ENDP
;--------------------------------------------------------------------------
on_node PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
    LOCAL ysqd:DWORD, xsqd:DWORD
    LOCAL hypot:DWORD, radius:DWORD
    LOCAL xcentre:SDWORD,ycentre:SDWORD
    LOCAL xtmp:SDWORD,ytmp:SDWORD,z:DWORD
    LOCAL xr1:DWORD,yr1:DWORD,tmpvar:DWORD,tmpvar2:DWORD,ring:DWORD
; "on_node"
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).

;121200 return g_nring = which ring mousex/y is on. else =0.

    mov esi,pobj

    mov eax,(OBJECT PTR [esi]).xmid
    mov xcentre,eax
    mov eax,(OBJECT PTR [esi]).ymid
    mov ycentre,eax

;;081200
;;want to handle ellipses...
;    mov eax,(OBJECT PTR [esi]).wwidth
;    mov ecx,(OBJECT PTR [esi]).height
;    .IF eax==ecx
;      ;keep going with old code for on_node()...
;    .ELSE
;      ;jump to new routine for on_node()...
;      jmp newonnode
;    .ENDIF

;;101200
;    test (OBJECT PTR [esi]).fconfig3,0100b ;bit2.
;    jz old1
;    jmp newonnode
;old1:
;121200 want to always load g_nring, so always use new code...
    jmp newonnode

;OLD CODE NO LONGER BEING USED!!!

;compute formula hypotenuse=sqrt((nmousey-ymid)^2+((nmousex-xmid)^2)...
    ;y coords...
    mov ecx,(OBJECT PTR [esi]).ymid
    mov eax,nmousey
    sub eax,ecx 		;nmousey-ymid
    mov g_ydiff,eax		;save.
    mov ebx,eax
    imul ebx			;(nmousey-ymid)^2 -->eax
    mov ysqd,eax		;/ save.

    ;x coords...
    mov ecx,(OBJECT PTR [esi]).xmid
    mov eax,nmousex
    sub eax,ecx 		;nmousex-xmid
    mov g_xdiff,eax		;save.
    mov ebx,eax
    imul ebx			;(nmousex-xmid)^2 -->eax
    mov xsqd,eax		;/ save.

    ;node radius...
    mov eax,(OBJECT PTR [esi]).wwidth
    shr eax,1
    mov radius,eax
    xor eax,eax
    mov al,(OBJECT PTR [esi]).nrings
    dec al
    mov ebx,8
    mul ebx
    add radius,eax	;total radius to outer ring

    ;281100
    ;ok if mouse just outside outer ring...
    add radius,2

    ;now add...
    mov eax,ysqd
    add eax,xsqd
    mov hypot,eax
    ;now square-root...
    fild hypot
    fsqrt
    fistp hypot		;will always be +ve.

;now we have the hypotenuse, the distance between mouse and centre of node...

    mov eax,radius	;always +ve value.
    .IF hypot<=eax
	mov eax,pobj
    .ELSE
      mov eax,0
    .ENDIF
    ret

;......................
;081200
;new code to handle ellipses...
newonnode:
    mov eax,(OBJECT PTR [esi]).wwidth
    shr eax,1	    ;want x radius.
    mov xr1,eax
    mov eax,(OBJECT PTR [esi]).height
    shr eax,1
    mov yr1,eax

    mov ring,1	;start from innermost ring.

    mov ecx,(OBJECT PTR [esi]).xmid
    mov eax,nmousex
    sub eax,ecx 		;nmousex-xmid
    mov g_xdiff,eax ;prevents jump when drag node.
    mov ecx,(OBJECT PTR [esi]).ymid
    mov eax,nmousey
    sub eax,ecx 		;nmousey-ymid
    mov g_ydiff,eax ;prevents jump when drag node.


jju:	;new loop-back, for rings with different centres 101200
    ;xtmp=(xcentre+(xdeltacentre*(ring-1))...
    mov eax,(OBJECT PTR [esi]).xdeltacentre ;offset from previous ring.
    mov ecx,ring
    dec ecx
    imul ecx
    add eax,xcentre
    mov ecx,nmousex
    sub ecx,eax
    mov xtmp,ecx
    ;ytmp=(ycentre+(ydeltacentre*(ring-1))...
    mov eax,(OBJECT PTR [esi]).ydeltacentre ;offset from previous ring.
    mov ecx,ring
    dec ecx
    imul ecx
    add eax,ycentre
    mov ecx,nmousey
    sub ecx,eax
    mov ytmp,ecx


;    mov eax,nmousex
;    sub eax,xcentre
;    mov xtmp,eax
;    mov g_xdiff,eax ;prevents jump when drag node.
;    mov eax,nmousey
;    sub eax,ycentre
;    mov ytmp,eax
;    mov g_ydiff,eax ;prevents jump when drag node.

    mov eax,ring	;z=(ring-1)*NRINGWIDTH
    dec eax
    xor edx,edx
    mov ecx,(OBJECT PTR [esi]).nringwidth ;NRINGWIDTH
    mul ecx
    add eax,(NEXTRAWIDTH/4)	;z=((ring-1)*NRINGWIDTH)+(NEXTRAWIDTH/4)
    ;...to detect slightly off node as being on the node, needed
    ;when dragging a wire-end. ...well, when have selected a wire,
    ;then press mouse-button at wire-end, mousex/y must be on-node.
    mov z,eax

      xor edx,edx	;zz=((x^2)/((xr1+z)^2))+((y^2)/((yr1+z)^2))
      mov eax,xtmp
      imul xtmp
      mov ebx,100
      imul ebx
      mov tmpvar,eax
      xor edx,edx
      mov eax,xr1
      add eax,z
      mov ebx,eax
      mul ebx
      mov ebx,eax
      xor edx,edx
      mov eax,tmpvar
      idiv ebx
      mov tmpvar,eax
	xor edx,edx
	mov eax,ytmp
	imul ytmp
	mov ebx,100
	imul ebx
	mov tmpvar2,eax
	xor edx,edx
	mov eax,yr1
	add eax,z
	mov ebx,eax
	mul ebx
	mov ebx,eax
	xor edx,edx
	mov eax,tmpvar2
	idiv ebx
	mov tmpvar2,eax
      mov eax,tmpvar
      add eax,tmpvar2
      ;...zz

    .IF eax>100
      xor eax,eax
      mov al,(OBJECT PTR [esi]).nrings
      .IF eax==ring
	mov eax,0     ;mousex/mousey outside of node.
	mov g_nring,0
      .ELSE
	inc ring	  ;try next-outer ring.
	jmp jju
      .ENDIF
    .ELSE
      mov eax,ring
      mov g_nring,eax	;which ring mousex/y is on.
      mov eax,pobj  ;success, mousex/y is on node.
    .ENDIF

  ret
on_node ENDP
;--------------------------------------------------------------------------
on_any PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
    LOCAL ysqd:DWORD, xsqd:DWORD
    LOCAL hypot:DWORD, radius:DWORD
; "on_any"
;derived from on_node().
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).

    mov esi,pobj

;compute formula hypotenuse=sqrt((nmousey-ymid)^2+((nmousex-xmid)^2)...

    ;y coords...
    mov ecx,(OBJECT PTR [esi]).ymid
    mov eax,nmousey
    sub eax,ecx 		;nmousey-ymid
    mov g_ydiff,eax		;save.
    mov ebx,eax
    imul ebx			;(nmousey-ymid)^2 -->eax
    mov ysqd,eax		;/ save.

    ;x coords...
    mov ecx,(OBJECT PTR [esi]).xmid
    mov eax,nmousex
    sub eax,ecx 		;nmousex-xmid
    mov g_xdiff,eax		;save.
    mov ebx,eax
    imul ebx			;(nmousex-xmid)^2 -->eax
    mov xsqd,eax		;/ save.

    ;node radius...
    mov eax,(OBJECT PTR [esi]).wwidth
    shr eax,1
    mov radius,eax
    xor eax,eax
    mov al,(OBJECT PTR [esi]).nrings
    dec al
    mov ebx,8
    mul ebx
    add radius,eax	;total radius to outer ring

    ;281100
    ;ok if mouse just outside outer ring...
    add radius,2

    ;now add...
    mov eax,ysqd
    add eax,xsqd
    mov hypot,eax
    ;now square-root...
    fild hypot
    fsqrt
    fistp hypot		;will always be +ve.

;now we have the hypotenuse, the distance between mouse and centre of node...

    mov eax,radius	;always +ve value.
    .IF hypot<=eax
	mov eax,pobj
    .ELSE
      mov eax,0
    .ENDIF

  ret
on_any ENDP
;--------------------------------------------------------------------------
on_cmt PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
    LOCAL ysqd:DWORD, xsqd:DWORD
    LOCAL hypot:DWORD, radius:DWORD
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).

    mov esi,pobj

;compute formula hypotenuse=sqrt((nmousey-ymid)^2+((nmousex-xmid)^2)...

    ;y coords...
    mov ecx,(OBJECT PTR [esi]).ymid
    mov eax,nmousey
    sub eax,ecx 		;nmousey-ymid
    mov g_ydiff,eax		;save.
    mov ebx,eax
    imul ebx			;(nmousey-ymid)^2 -->eax
    mov ysqd,eax		;/ save.

    ;x coords...
    mov ecx,(OBJECT PTR [esi]).xmid
    mov eax,nmousex
    sub eax,ecx 		;nmousex-xmid
    mov g_xdiff,eax		;save.
    mov ebx,eax
    imul ebx			;(nmousex-xmid)^2 -->eax
    mov xsqd,eax		;/ save.

    ;node radius...
    mov eax,(OBJECT PTR [esi]).wwidth
    shr eax,1
    mov radius,eax
    xor eax,eax
    mov al,(OBJECT PTR [esi]).nrings
;    dec al  <<< PROBLEM is that Comment/Action/Cond elements have
;such tiny circles, (and only 1 ring) hard to select. but now i'm
;making radius bigger...
    mov ebx,8
    mul ebx
    add radius,eax	;total radius to outer ring

    ;now add...
    mov eax,ysqd
    add eax,xsqd
    mov hypot,eax
    ;now square-root...
    fild hypot
    fsqrt
    fistp hypot		;will always be +ve.

;now we have the hypotenuse, the distance between mouse and centre of node...

    mov eax,radius	;always +ve value.
    .IF hypot<=eax
	mov eax,pobj
    .ELSE
      mov eax,0
    .ENDIF

  ret
on_cmt ENDP
;--------------------------------------------------------------------------
on_res PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
    LOCAL dummy:WORD
;called from wmlbuttondown/state0 > onanobject() > via method-table
;returns eax=0 if fail, else eax pts to object
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).

    mov esi,pobj

    ;y coords...
    mov ecx,(OBJECT PTR [esi]).ymid
    mov eax,nmousey
    sub eax,ecx 		;nmousey-ymid
    mov g_ydiff,eax		;save.

    ;x coords...
    mov ecx,(OBJECT PTR [esi]).xmid
    mov eax,nmousex
    sub eax,ecx 		;nmousex-xmid
    mov g_xdiff,eax		;save.

;now to calc if mouse inside resource rectangle...
    mov eax,(OBJECT PTR [esi]).xtopleft
    .IF SDWORD PTR nmousex>=eax
      add eax,(OBJECT PTR [esi]).wwidth
      .IF SDWORD PTR nmousex<=eax
	mov eax,(OBJECT PTR [esi]).ytopleft
	.IF SDWORD PTR nmousey>=eax
	  add eax,(OBJECT PTR [esi]).height
	  .IF SDWORD PTR nmousey<=eax
	    ;yes!...
	    mov eax,esi     ;return with eax ptg to resource.
	  .ELSE
	    ;fail...
	    xor eax,eax
	  .ENDIF
	.ELSE
	  ;fail...
	  xor eax,eax
	.ENDIF
      .ELSE
	;fail...
	xor eax,eax
      .ENDIF
    .ELSE
      ;fail...
      xor eax,eax
    .ENDIF

  ret
on_res ENDP
;--------------------------------------------------------------------------
on_arc PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
    LOCAL dummy:WORD
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.

	mov edi,pobj
	mov g_nknee,0	;used to show which knee selected. 0=none.

;test if mouse on mid-point of wire...
	mov  eax,(OBJECT PTR [edi]).xmid
	mov  ebx,(OBJECT PTR [edi]).ymid
	mov ecx,nmousex			;mouse x-coord
	mov edx,nmousey			;mouse y-coord
	cmp eax,ecx	      ;test if on-top.
        jae tst1
	sub ecx,eax
	cmp ecx,10  ;15
        jbe tst2
	jmp SHORT try2
tst1:	sub eax,ecx
	cmp eax,10  ;15
        jbe tst2
	jmp SHORT try2
tst2:	cmp ebx,edx
        jae tst3
	sub edx,ebx
	cmp edx,10  ;15
        jbe tst4
	jmp SHORT try2
tst3:	sub ebx,edx
	cmp ebx,10  ;15
        jbe tst4
	jmp SHORT try2
tst4:	;yes, it's on mid-point...
	mov g_nknee,1
	jmp tst6

try2:
;only allowed to test if on knees2/3/4/5 if wire is highlighted.
;reason is, highlight at mid-point first, sets g_phighlighted,
;then paint_arc will display the knees, then this routine can
;allow them to be selected, and drag_arc will allow them to drag!
    .IF edi==g_phighlightedobject
    .ELSE
      ;fail, get out
      mov g_nknee,0 ;precaution.
      jmp znoobject
    .ENDIF

;now test if mouse on knee2...
	mov  eax,(OBJECT PTR [edi]).xknee2
	mov  ebx,(OBJECT PTR [edi]).yknee2
	mov ecx,nmousex			;mouse x-coord
	mov edx,nmousey			;mouse y-coord
	cmp eax,ecx	      ;test if on-top.
	jae xtst1
	sub ecx,eax
	cmp ecx,10  ;15
	jbe xtst2
	jmp SHORT try3b
xtst1:	sub eax,ecx
	cmp eax,10  ;15
	jbe xtst2
	jmp SHORT try3b
xtst2:	cmp ebx,edx
	jae xtst3
	sub edx,ebx
	cmp edx,10  ;15
	jbe xtst4
	jmp SHORT try3b
xtst3:	sub ebx,edx
	cmp ebx,10  ;15
	jbe xtst4
	jmp SHORT try3b
xtst4:	;yes, it's on 1st half-point (knee2)...
	mov g_nknee,2
	jmp tst6

try3b:
;we can also test if mouse is on start of wire (knee4)...
;note, i've narrowed the area to select the wire-end, as if the
;node to which the wire is attached is a master of a clone-chain,
;drag_arc() calls snapclonewires() which finds matching wires on
;clones and drags them also -- their ends have to be +/-4 of the
;master-wires end. so, needto make this slightly smaller or = (otherwise
;mouse coord outside this area will drag master wire but miss
;child wire)...    *NO*, i think can compensate for this in drag_arc()
;-- detect mouse too far from wire-end, truncate difference. but, leave
;this initial capture area small anyway...
	mov  eax,(OBJECT PTR [edi]).xtopleft
	mov  ebx,(OBJECT PTR [edi]).ytopleft
	mov ecx,nmousex			;mouse x-coord
	mov edx,nmousey			;mouse y-coord
	cmp eax,ecx	      ;test if on-top.
	jae qtst1
	sub ecx,eax
	cmp ecx,4 ;10  ;15
	jbe qtst2
	jmp SHORT try3c
qtst1:	sub eax,ecx
	cmp eax,4 ;10  ;15
	jbe qtst2
	jmp SHORT try3c
qtst2:	cmp ebx,edx
	jae qtst3
	sub edx,ebx
	cmp edx,4 ;10  ;15
	jbe qtst4
	jmp SHORT try3c
qtst3:	sub ebx,edx
	cmp ebx,4 ;10  ;15
	jbe qtst4
	jmp SHORT try3c
qtst4:	;yes...
	mov g_nknee,4
	jmp tst6

try3c:
;we can also test if mouse is on destination-end of wire (knee5)...
	mov  eax,(OBJECT PTR [edi]).wwidth
	mov  ebx,(OBJECT PTR [edi]).height
	mov ecx,nmousex			;mouse x-coord
	mov edx,nmousey			;mouse y-coord
	cmp eax,ecx	      ;test if on-top.
	jae rtst1
	sub ecx,eax
	cmp ecx,4 ;10  ;15
	jbe rtst2
	jmp SHORT try3
rtst1:	sub eax,ecx
	cmp eax,4 ;10  ;15
	jbe rtst2
	jmp SHORT try3
rtst2:	cmp ebx,edx
	jae rtst3
	sub edx,ebx
	cmp edx,4 ;10  ;15
	jbe rtst4
	jmp SHORT try3
rtst3:	sub ebx,edx
	cmp ebx,4 ;10  ;15
	jbe rtst4
	jmp SHORT try3
rtst4:	;yes...
	mov g_nknee,5
	jmp tst6

;now test if mouse on knee3...
try3:	mov  eax,(OBJECT PTR [edi]).xknee3
	mov  ebx,(OBJECT PTR [edi]).yknee3
	mov ecx,nmousex			;mouse x-coord
	mov edx,nmousey			;mouse y-coord
	cmp eax,ecx	      ;test if on-top.
	jae ytst1
	sub ecx,eax
	cmp ecx,10  ;15
	jbe ytst2
        jmp SHORT znoobject
ytst1:	sub eax,ecx
	cmp eax,10  ;15
	jbe ytst2
        jmp SHORT znoobject
ytst2:	cmp ebx,edx
	jae ytst3
	sub edx,ebx
	cmp edx,10  ;15
	jbe ytst4
        jmp SHORT znoobject
ytst3:	sub ebx,edx
	cmp ebx,10  ;15
	jbe ytst4
        jmp SHORT znoobject
ytst4:	;yes, it's on second half (knee3)...
	mov g_nknee,3
	jmp tst6


tst6:	;success!... mouse is on wire...
	mov eax,pobj			 ;flag success.
	ret			       ;success.
znoobject:
	mov eax,0		       ;flag failure.
	ret
on_arc ENDP
;--------------------------------------------------------------------------
on_fnc PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
    LOCAL dummy:WORD
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.


  ret
on_fnc ENDP
;--------------------------------------------------------------------------
on_super PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
    LOCAL dummy:WORD
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.


  ret
on_super ENDP
;--------------------------------------------------------------------------
wipeslaves_node PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD
    LOCAL dummy:WORD
;called from wmmousemove()/state2/pmovingobject
;pobj is the moving object. this routine is to detect all objects
;locked to pobj and add them to wipeout list...

  invoke wipeoutslaves, pobj

  ret
wipeslaves_node ENDP
;--------------------------------------------------------------------------
wipeslaves_gen PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD
    LOCAL dummy:WORD
;called from wmmousemove()/state2/pmovingobject
;pobj is the moving object. this routine is to detect all objects
;locked to pobj and add them to wipeout list...

  invoke wipeoutslaves, pobj

  ret
wipeslaves_gen ENDP
;--------------------------------------------------------------------------

snap_tonode PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,pxend:DWORD,pyend:DWORD
    LOCAL xend:SDWORD, yend:SDWORD
    LOCAL mousex:SDWORD, mousey:SDWORD
    LOCAL xcentre:SDWORD, ycentre:SDWORD
    LOCAL ytmp:SDWORD, xtmp:SDWORD
    LOCAL deltaytmp:DWORD
    LOCAL hypot:DWORD, xradring1:DWORD
    LOCAL exactradius:DWORD
    LOCAL ring:DWORD
    LOCAL xr1:DWORD,yr1:DWORD,z:DWORD,zz:DWORD
    LOCAL tmpvar:SDWORD,tmpvar2:SDWORD
    LOCAL xcentre2:SDWORD,ycentre2:SDWORD,ferror:BYTE
; "snap_tonode"
;a method for psnap polymorphic function.
;for placing or adjusting an end of a wire, pxend/pyend.
;(don't need to refer to g_nmousex/y here, as have xend/yend).
;determine nearest point on boundary of pobj and snap xend/yend to it.
;if xend/yend not on node at all, return eax=0 -- but still set xend/yend
;to nearest point on outer boundary of node.
;else return eax=ring that snapped to.
;also returns adjusted xend/yend.

;in the case of wires, immediately after calling this method (from
;paint_arc, via psnap method table), an arrowhead is drawn by calling
;draw1starrow() and draw2ndarrow(). these latter funcs use xend/yend
;but to calc other points, also need g_xdiffnorm/g_ydiffnorm, being
;normalised difference between middle of parent node and wire-end.
;xtmp/ytmp are un-normalised, so (xtmp*100)/hypot performs normalisation.
;i'm going to cheat a bit and make g_xdiffnorm/g_ydiffnorm global.

;note, snap_ methods are not to make the actual changes to coords
;in an OBJECT. the snapped xend/yend is calculated, and on return
;to paint_, it is paint_'s responsibility to update coords in OBJECT.

;a problem with action/condition elements, as they are node-type, not
;wire-type objects. i need to make them snap to a particular ring.
;wmlbuttondown()/state4 (placing new object) should set
;newobject.nbeginring, and paint_act() and paint_cond() can write it
;to global variable "g_nsnapring". if snap_tonode() sees this non-0,
;then calc xend/yend snapped to this ring.
;Note that comment objects will have a line drawn from the object to
;outermost boundary of node, which is ok, leave alone.

    mov esi,pxend
    mov eax,[esi]
    mov xend,eax
    mov esi,pyend
    mov eax,[esi]
    mov yend,eax

;NOTE got this code from goofee WHICH0...
;WHICH0 uses incoming coords-to-be-snapped as mousex/mousey, so let's
;keep these names...
    mov eax,xend
    mov mousex,eax
    mov eax,yend
    mov mousey,eax

    mov esi,pobj	;node.
    mov eax,(OBJECT PTR [esi]).xmid
    mov xcentre,eax
    mov eax,(OBJECT PTR [esi]).ymid
    mov ycentre,eax

;081200
;want to handle ellipses...
;    mov eax,(OBJECT PTR [esi]).wwidth
;    mov ecx,(OBJECT PTR [esi]).height
;    .IF eax==ecx
;      ;keep going with old code for snap_tonode()...
;    .ELSE
;      ;jump to new routine for snap_tonode()...
;      jmp newsnaptonode
;    .ENDIF
    test (OBJECT PTR [esi]).fconfig3,0100b ;bit2.
    jz old1
    jmp newsnaptonode
old1:

	mov  eax,mousey		;compute formula
	sub  eax,ycentre	;/ hypot=sqrt((mousey-centrey)^2
	mov  ebx,eax		;/	 +((mousex-centrex)^2)
	mov  ytmp,eax		;/
	imul  ebx		;/ -->edx:eax
	mov  deltaytmp,eax	 ;/ temp save
	mov  eax,mousex		;/
	sub  eax,xcentre	;/
	mov  ebx,eax		;/
	mov  xtmp,eax		;/
	imul  ebx		;/ -->edx:eax
	add  eax,deltaytmp	;/

    ;now square-root...
    mov hypot,eax
    fild hypot
    fsqrt
    fistp hypot		;will always be +ve.

;following computation is based upon node being a fixed size...
;ok, i'm going to allow varying node size...
    mov eax,(OBJECT PTR [esi]).wwidth	   ;(but rings still have
    shr eax,1	;radius of node.	      8 pixel separation)
    mov xradring1,eax

	  .IF hypot==0	       ;prevent divide-by-0.
	    mov  hypot,1
	  .ENDIF

;now to normalise xtmp/ytmp (as per explanation above)...
	mov eax,xtmp
	xor edx,edx
	mov ebx,100	;determines final arrow-size.
	imul ebx
	mov ebx,hypot
	idiv ebx
	mov g_xdiffnorm,eax
	  ;ditto for ytmp...
	  mov eax,ytmp
	  xor edx,edx
	  mov ebx,100	;determines final arrow-size.
	  imul ebx
	  mov ebx,hypot
	  idiv ebx
	  mov g_ydiffnorm,eax

;now for special hack for action/condition objects...
	.IF g_nsnapring==0
	.ELSE
	    mov eax,g_nsnapring
	    mov ring,eax
	    dec eax
	    mov ebx,8
	    mul ebx
	    add eax,xradring1
	    mov exactradius,eax
	    mov g_nsnapring,0
	    jmp hack2
	.ENDIF


	mov  eax,hypot
	mov  ring,0
	sub  eax,xradring1  ;8		;compute formula
;	dec  eax
	  ;have a problem with arrows jumping in a ring each time this
	  ;func is called. this may fix it ... instead of decr, add 7...
	  ;add eax,7

	  ; 191100
	  ;now it jumps out too easily. try this...
	  ;add eax,5
	    ;WORSE! go back...
	    ; 251100
	    ;i've recoded insertring() and deletering(), so do this...
	    add eax,4
	    ;...optimum, snaps -4<-->+3 either side of ring.

	mov  ebx,8		;/ ring=((hypot-xradring1-1)/8)
	   ;...based on rings numbered from 0.
	  ;...fix ring-spacing at 8 pixels.
	xor edx,edx
	idiv  ebx		;/ -->ax (need idiv, if small neg in ax)
	inc  eax		;/
	mov  ring,eax		;/ (rings numbered from 1, innermost)
	dec  eax		;compute formula
	xor  edx,edx		;/ xradius=15+((ring-1)*8)
	mov  ebx,8		;/
	imul  ebx		;/
	add  eax,xradring1 ;15		;/
	mov  exactradius,eax
;...now has ring= ring# that xend/yend is on (even if node doesn't have
;that many rings). The exact distance from middle of node to the ring
;is now in exactradius.

hack2:
;the code further down will calc the exact xend/yend coords to lie on
;the ring. But, we need to restrict this to only existing rings...
    xor eax,eax
    mov al,(OBJECT PTR [esi]).nrings
    dec eax	    ;ignore ring 1.
    mov ebx,8	    ;ring-spacing.
    mul ebx
    mov ebx,xradring1
    add eax,ebx     ;actual outermost radius of node.
    .IF exactradius>eax
      mov exactradius,eax
      mov ring,0
    .ENDIF
;a precaution...
	mov eax,xradring1
	.IF exactradius<eax
	  mov exactradius,eax	;i.e. 16.
	  mov ring,1
	.ENDIF

;now to snap xend/yend...
	xor edx,edx
	mov  eax,exactradius		;compute formula
	imul xtmp			;/ x=x*(xradius/hypot)
	idiv  hypot			;/
	mov  xtmp,eax			;/
	xor edx,edx
	mov  eax,exactradius		;compute formula
	imul ytmp			;/ y=y*(xradius/hypot)
	idiv  hypot			;/
	mov  ytmp,eax			;/
	mov  eax,xcentre		;compute formula
	add  eax,xtmp			;/ xend=centrex+x
	mov  xend,eax		;/
	mov  eax,ycentre		;compute formula
	add  eax,ytmp		;/
	mov  yend,eax		;/

    mov eax,xend    ;return snapped coords.
    mov esi,pxend
    mov [esi],eax
    mov eax,yend
    mov esi,pyend
    mov [esi],eax
    mov eax,ring    ;ring=0 if orig xend/yend outside node, else ring#.

  ret

;......................................................................
newsnaptonode:
;new code for ellipses...
    mov ferror,0

    mov eax,(OBJECT PTR [esi]).wwidth
    shr eax,1	    ;want x radius.
    mov xr1,eax
    mov eax,(OBJECT PTR [esi]).height
    shr eax,1	    ;want y radius.
    mov yr1,eax

      ;if g_nsnapring non-0, must snap to that ring...
      .IF g_nsnapring==0
	mov eax,1   ;start at ring1.
      .ELSE
	mov ecx,g_nsnapring
	;precaution...
	xor eax,eax
	mov al,(OBJECT PTR [esi]).nrings
	.IF ecx>eax
	.ELSE
	  mov eax,ecx
	.ENDIF
      .ENDIF
    mov ring,eax

jju:	;new loop-back, for rings with different centres 101200
    ;xtmp=(xcentre+(xdeltacentre*(ring-1))...
    mov eax,(OBJECT PTR [esi]).xdeltacentre ;offset from previous ring.
    mov ecx,ring
    dec ecx
    imul ecx
    add eax,xcentre
    mov xcentre2,eax	;save for later.
    mov ecx,mousex
    sub ecx,eax
    mov xtmp,ecx
    ;ytmp=(ycentre+(ydeltacentre*(ring-1))...
    mov eax,(OBJECT PTR [esi]).ydeltacentre ;offset from previous ring.
    mov ecx,ring
    dec ecx
    imul ecx
    add eax,ycentre
    mov ycentre2,eax	;save for later.
    mov ecx,mousey
    sub ecx,eax
    mov ytmp,ecx

;still need hypotenuse and normalised g_xdiffnorm/g_ydiffnorm...
	xor edx,edx
	mov eax,ytmp	;/ hypot=sqrt((mousey-centrey)^2
	mov ebx,eax		;/	 +((mousex-centrex)^2)
	imul ebx		;/ -->edx:eax
	mov deltaytmp,eax	 ;/ temp save
	xor edx,edx
	mov eax,xtmp
	mov ebx,eax		;/
	imul ebx		;/ -->edx:eax
	add  eax,deltaytmp	;/
	;now square-root...
	mov hypot,eax
	fild hypot
	fsqrt
	fistp hypot		;will always be +ve.
	  .IF hypot==0	       ;prevent divide-by-0.
	    mov  hypot,1
	  .ENDIF
	;now to normalise xtmp/ytmp (as per explanation above)...
	mov eax,xtmp
	xor edx,edx
	mov ebx,100	;determines final arrow-size.
	imul ebx
	mov ebx,hypot
	idiv ebx
	mov g_xdiffnorm,eax
	  ;ditto for ytmp...
	  mov eax,ytmp
	  xor edx,edx
	  mov ebx,100	;determines final arrow-size.
	  imul ebx
	  mov ebx,hypot
	  idiv ebx
	  mov g_ydiffnorm,eax
	;...note, g_xdiffnorm/g_ydiffnorm are global variables.

;...............
;this block of code will snap mousex/mousey to nearest ring...
;jju: <<101200 label moved up.
    mov eax,ring	;z=(ring-1)*NRINGWIDTH
    dec eax
    xor edx,edx
    mov ecx,(OBJECT PTR [esi]).nringwidth ;NRINGWIDTH
    mul ecx
    add eax,(NEXTRAWIDTH/2) ;z=((ring-1)*NRINGWIDTH)+(NEXTRAWIDTH/2)
    ;...allow +/- either side of ring to snap to centre.
    ;(stops wires from jumping out the rings).
    mov z,eax
      xor edx,edx	;zz=((x^2)/((xr1+z)^2))+((y^2)/((yr1+z)^2))
      mov eax,xtmp
      imul xtmp
      mov ebx,256 ;100
      imul ebx
      mov tmpvar,eax
      xor edx,edx
      mov eax,xr1
      add eax,z
      mov ebx,eax
      mul ebx
      mov ebx,eax
      xor edx,edx
      mov eax,tmpvar
      idiv ebx
      mov tmpvar,eax
	xor edx,edx
	mov eax,ytmp
	imul ytmp
	mov ebx,256 ;100
	imul ebx
	mov tmpvar2,eax
	xor edx,edx
	mov eax,yr1
	add eax,z
	mov ebx,eax
	mul ebx
	mov ebx,eax
	xor edx,edx
	mov eax,tmpvar2
	idiv ebx
	mov tmpvar2,eax
      mov eax,tmpvar
      add eax,tmpvar2
;      mov ecx,zz
;      mov zzprev,ecx
      mov zz,eax

    ;one problem is if g_nsnapring non-0, need to snap mousex/mousey
    ;to that specific ring (not to nearest ring)...
    ;note that g_nsnapring is a global variable.
    .IF g_nsnapring==0
    .ELSE
      mov g_nsnapring,0
      jmp jje
    .ENDIF

    .IF zz>256 ;100	 ;note, zz will be 256 if exactly on ring.
      ;mousex/y outside current ring.
      xor eax,eax
      mov al,(OBJECT PTR [esi]).nrings
      .IF eax==ring
	mov ferror,1
      .ELSE
	inc ring
	jmp jju     ;try next-outer ring.
      .ENDIF
    .ENDIF

jje:
      ;recalculate zz, based on snapping to exact ring...
      mov eax,ring	;z=(ring-1)*NRINGWIDTH
      dec eax
      xor edx,edx
      mov ecx,(OBJECT PTR [esi]).nringwidth ;NRINGWIDTH
      mul ecx
      mov z,eax
      xor edx,edx	;zz=((x^2)/((xr1+z)^2))+((y^2)/((yr1+z)^2))
      mov eax,xtmp
      imul xtmp
      mov ebx,256 ;100
      imul ebx
      mov tmpvar,eax
      xor edx,edx
      mov eax,xr1
      add eax,z
      mov ebx,eax
      mul ebx
      mov ebx,eax
      xor edx,edx
      mov eax,tmpvar
      idiv ebx
      mov tmpvar,eax
	xor edx,edx
	mov eax,ytmp
	imul ytmp
	mov ebx,256 ;100
	imul ebx
	mov tmpvar2,eax
	xor edx,edx
	mov eax,yr1
	add eax,z
	mov ebx,eax
	mul ebx
	mov ebx,eax
	xor edx,edx
	mov eax,tmpvar2
	idiv ebx
	mov tmpvar2,eax
      mov eax,tmpvar
      add eax,tmpvar2
      .IF eax==0	  ;note, limits range of zz 0 to +2.3G.
	mov eax,1	   ;/precaution.
      .ELSEIF SDWORD PTR eax<0 ;/
	mov eax,7FFFFFFFh  ;/(because of signed calcs below).
      .ENDIF		   ;/
      mov zz,eax

    fild zz
    fsqrt
    fistp zz		;will always be +ve.
      mov eax,xtmp	;((x*10)/zz)+xcentre2
      mov ebx,16 ;10
      imul ebx
      idiv zz
      add eax,xcentre2
      mov xend,eax
	mov eax,ytmp	;((y*10)/zz)+ycentre2
	mov ebx,16 ;10
	imul ebx
	idiv zz
	add eax,ycentre2
	mov yend,eax

;............
    mov eax,xend    ;return snapped coords.
    mov esi,pxend
    mov [esi],eax
    mov eax,yend
    mov esi,pyend
    mov [esi],eax
    .IF ferror==1
      mov eax,0
    .ELSE
      mov eax,ring    ;ring=0 if orig xend/yend outside node, else ring#.
    .ENDIF
  ret

snap_tonode ENDP
;--------------------------------------------------------------------------
snap_toany PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,pxend:DWORD,pyend:DWORD
    LOCAL xend:SDWORD, yend:SDWORD
    LOCAL mousex:SDWORD, mousey:SDWORD
    LOCAL xcentre:SDWORD, ycentre:SDWORD
    LOCAL ytmp:SDWORD, xtmp:SDWORD
    LOCAL deltaytmp:DWORD
    LOCAL hypot:DWORD, xradring1:DWORD
    LOCAL exactradius:DWORD
    LOCAL ring:DWORD
; "snap_toany"
;...based on snap_tonode().
;a method for psnap polymorphic function.
;for placing or adjusting an end of a wire, pxend/pyend.
;(don't need to refer to g_nmousex/y here, as have xend/yend).
;determine nearest point on boundary of pobj and snap xend/yend to it.
;if xend/yend not on node at all, return eax=0 -- but still set xend/yend
;to nearest point on outer boundary of node.
;else return eax=ring that snapped to.
;also returns adjusted xend/yend.

;in the case of wires, immediately after calling this method (from
;paint_arc, via psnap method table), an arrowhead is drawn by calling
;draw1starrow() and draw2ndarrow(). these latter funcs use xend/yend
;but to calc other points, also need g_xdiffnorm/g_ydiffnorm, being
;normalised difference between middle of parent node and wire-end.
;xtmp/ytmp are un-normalised, so (xtmp*100)/hypot performs normalisation.
;i'm going to cheat a bit and make g_xdiffnorm/g_ydiffnorm global.

;note, snap_ methods are not to make the actual changes to coords
;in an OBJECT. the snapped xend/yend is calculated, and on return
;to paint_, it is paint_'s responsibility to update coords in OBJECT.

;a problem with action/condition elements, as they are node-type, not
;wire-type objects. i need to make them snap to a particular ring.
;wmlbuttondown()/state4 (placing new object) should set
;newobject.nbeginring, and paint_act() and paint_cond() can write it
;to global variable "g_nsnapring". if snap_tonode() sees this non-0,
;then calc xend/yend snapped to this ring.
;Note that comment objects will have a line drawn from the object to
;outermost boundary of node, which is ok, leave alone.

    mov esi,pxend
    mov eax,[esi]
    mov xend,eax
    mov esi,pyend
    mov eax,[esi]
    mov yend,eax

;NOTE got this code from goofee WHICH0...
;WHICH0 uses incoming coords-to-be-snapped as mousex/mousey, so let's
;keep these names...
    mov eax,xend
    mov mousex,eax
    mov eax,yend
    mov mousey,eax

    mov esi,pobj	;node.
    mov eax,(OBJECT PTR [esi]).xmid
    mov xcentre,eax
    mov eax,(OBJECT PTR [esi]).ymid
    mov ycentre,eax

	mov  eax,mousey		;compute formula
	sub  eax,ycentre	;/ hypot=sqrt((mousey-centrey)^2
	mov  ebx,eax		;/	 +((mousex-centrex)^2)
	mov  ytmp,eax		;/
	imul  ebx		;/ -->edx:eax
	mov  deltaytmp,eax	 ;/ temp save
	mov  eax,mousex		;/
	sub  eax,xcentre	;/
	mov  ebx,eax		;/
	mov  xtmp,eax		;/
	imul  ebx		;/ -->edx:eax
	add  eax,deltaytmp	;/

    ;now square-root...
    mov hypot,eax
    fild hypot
    fsqrt
    fistp hypot		;will always be +ve.

;following computation is based upon node being a fixed size...
;ok, i'm going to allow varying node size...
    mov eax,(OBJECT PTR [esi]).wwidth	   ;(but rings still have
    shr eax,1	;radius of node.	      8 pixel separation)
    mov xradring1,eax

	  .IF hypot==0	       ;prevent divide-by-0.
	    mov  hypot,1
	  .ENDIF

;now to normalise xtmp/ytmp (as per explanation above)...
	mov eax,xtmp
	xor edx,edx
	mov ebx,100	;determines final arrow-size.
	imul ebx
	mov ebx,hypot
	idiv ebx
	mov g_xdiffnorm,eax
	  ;ditto for ytmp...
	  mov eax,ytmp
	  xor edx,edx
	  mov ebx,100	;determines final arrow-size.
	  imul ebx
	  mov ebx,hypot
	  idiv ebx
	  mov g_ydiffnorm,eax

;now for special hack for action/condition objects...
	.IF g_nsnapring==0
	.ELSE
	    mov eax,g_nsnapring
	    mov ring,eax
	    dec eax
	    mov ebx,8
	    mul ebx
	    add eax,xradring1
	    mov exactradius,eax
	    mov g_nsnapring,0
	    jmp hack2
	.ENDIF


	mov  eax,hypot
	mov  ring,0
	sub  eax,xradring1  ;8		;compute formula
;	dec  eax
	  ;have a problem with arrows jumping in a ring each time this
	  ;func is called. this may fix it ... instead of decr, add 7...
	  ;add eax,7

	  ; 191100
	  ;now it jumps out too easily. try this...
	  ;add eax,5
	    ;WORSE! go back...
	    ; 251100
	    ;i've recoded insertring() and deletering(), so do this...
	    add eax,4
	    ;...optimum, snaps -4<-->+3 either side of ring.

	mov  ebx,8		;/ ring=((hypot-xradring1-1)/8)
	   ;...based on rings numbered from 0.
	  ;...fix ring-spacing at 8 pixels.
	xor edx,edx
	idiv  ebx		;/ -->ax (need idiv, if small neg in ax)
	inc  eax		;/
	mov  ring,eax		;/ (rings numbered from 1, innermost)
	dec  eax		;compute formula
	xor  edx,edx		;/ xradius=15+((ring-1)*8)
	mov  ebx,8		;/
	imul  ebx		;/
	add  eax,xradring1 ;15		;/
	mov  exactradius,eax
;...now has ring= ring# that xend/yend is on (even if node doesn't have
;that many rings). The exact distance from middle of node to the ring
;is now in exactradius.

hack2:
;the code further down will calc the exact xend/yend coords to lie on
;the ring. But, we need to restrict this to only existing rings...
    xor eax,eax
    mov al,(OBJECT PTR [esi]).nrings
    dec eax	    ;ignore ring 1.
    mov ebx,8	    ;ring-spacing.
    mul ebx
    mov ebx,xradring1
    add eax,ebx     ;actual outermost radius of node.
    .IF exactradius>eax
      mov exactradius,eax
      mov ring,0
    .ENDIF
;a precaution...
	mov eax,xradring1
	.IF exactradius<eax
	  mov exactradius,eax	;i.e. 16.
	  mov ring,1
	.ENDIF

;now to snap xend/yend...
	xor edx,edx
	mov  eax,exactradius		;compute formula
	imul xtmp			;/ x=x*(xradius/hypot)
	idiv  hypot			;/
	mov  xtmp,eax			;/
	xor edx,edx
	mov  eax,exactradius		;compute formula
	imul ytmp			;/ y=y*(xradius/hypot)
	idiv  hypot			;/
	mov  ytmp,eax			;/
	mov  eax,xcentre		;compute formula
	add  eax,xtmp			;/ xend=centrex+x
	mov  xend,eax		;/
	mov  eax,ycentre		;compute formula
	add  eax,ytmp		;/
	mov  yend,eax		;/

    mov eax,xend    ;return snapped coords.
    mov esi,pxend
    mov [esi],eax
    mov eax,yend
    mov esi,pyend
    mov [esi],eax
    mov eax,ring    ;ring=0 if orig xend/yend outside node, else ring#.
  ret
snap_toany ENDP
;--------------------------------------------------------------------------
snap_tores PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,pxend:DWORD,pyend:DWORD
    LOCAL xend:SDWORD, yend:SDWORD
    LOCAL mousex:SDWORD, mousey:SDWORD
    LOCAL xcentre:SDWORD, ycentre:SDWORD
    LOCAL ytmp:SDWORD, xtmp:SDWORD
    LOCAL deltaytmp:DWORD
    LOCAL hypot:DWORD, xradring1:DWORD
    LOCAL exactradius:DWORD
    LOCAL ring:DWORD
    LOCAL xradius:DWORD, yradius:DWORD
;a method for psnap polymorphic function.
;for placing or adjusting an end of a wire, pxend/pyend.
;(don't need to refer to g_nmousex/y here, as have xend/yend).
;determine nearest point on boundary of pnode and snap xend/yend to it.
;if xend/yend not on node at all, return eax=0 -- but still set xend/yend
;to nearest point on outer boundary of node.
;else return eax=ring that snapped to.
;also returns adjusted xend/yend.

;in the case of wires, immediately after calling this method (from
;paint_arc, via psnap method table), an arrowhead is drawn by calling
;draw1starrow() and draw2ndarrow(). these latter funcs use xend/yend
;but to calc other points, also need g_xdiffnorm/g_ydiffnorm, being
;normalised difference between middle of parent node and wire-end.
;xtmp/ytmp are un-normalised, so (xtmp*100)/hypot performs normalisation.
;i'm going to cheat a bit and make g_xdiffnorm/g_ydiffnorm global.

    mov esi,pxend
    mov eax,[esi]
    mov xend,eax
    mov esi,pyend
    mov eax,[esi]
    mov yend,eax

;NOTE got this code from goofee WHICH0/WHICH3...
;WHICH0 uses incoming coords-to-be-snapped as mousex/mousey, so let's
;keep these names...
    mov eax,xend
    mov mousex,eax
    mov eax,yend
    mov mousey,eax

    mov esi,pobj	;res.
    mov eax,(OBJECT PTR [esi]).xmid
    mov xcentre,eax
    mov eax,(OBJECT PTR [esi]).ymid
    mov ycentre,eax
    mov eax,(OBJECT PTR [esi]).wwidth
    shr eax,1
    mov xradius,eax	;x-radius of res.
    mov eax,(OBJECT PTR [esi]).height
    shr eax,1
    mov yradius,eax	;y-radius of res.

	mov  eax,mousey		;compute formula
	sub  eax,ycentre	;/ hypot=sqrt((mousey-centrey)^2
	mov  ebx,eax		;/	 +((mousex-centrex)^2)
	mov  ytmp,eax		;/
	imul  ebx		;/ -->edx:eax
	mov  deltaytmp,eax	 ;/ temp save
	mov  eax,mousex		;/
	sub  eax,xcentre	;/
	mov  ebx,eax		;/
	mov  xtmp,eax		;/
	imul  ebx		;/ -->edx:eax
	add  eax,deltaytmp	;/

    ;now square-root...
    mov hypot,eax
    fild hypot
    fsqrt
    fistp hypot		;will always be +ve.

	  .IF hypot==0	       ;prevent divide-by-0.
	    mov  hypot,1
	  .ENDIF

;now to normalise xtmp/ytmp (as per explanation above)...
	xor edx,edx
	mov eax,xtmp
	mov ebx,100	;determines final arrow-size.
	imul ebx
	mov ebx,hypot
	idiv ebx
	mov g_xdiffnorm,eax
	  ;ditto for ytmp...
	  xor edx,edx
	  mov eax,ytmp
	  mov ebx,100	;determines final arrow-size.
	  imul ebx
	  mov ebx,hypot
	  idiv ebx
	  mov g_ydiffnorm,eax

;it's complicated calculating exactly where on the rectangle boundary
;to place xend/yend.
;i don't think we'll use hypot at all.
;just snap xend/yend to one of the corners...

    mov eax,xcentre
    .IF SDWORD PTR mousex>=eax	;mouse is to right of centre of res.
      mov eax,ycentre
      .IF SDWORD PTR mousey>=eax
	;wire onto lower-right corner of res...
	mov eax,xcentre
	add eax,xradius
	mov xend,eax
	mov eax,ycentre
	add eax,yradius
	mov yend,eax
      .ELSE
	;wire onto upper-right corner of res...
	mov eax,xcentre
	add eax,xradius
	mov xend,eax
	mov eax,ycentre
	sub eax,yradius
	mov yend,eax
      .ENDIF
    .ELSE
      mov eax,ycentre
      .IF SDWORD PTR mousey>=eax
	;wire onto lower-left corner of res...
	mov eax,xcentre
	sub eax,xradius
	mov xend,eax
	mov eax,ycentre
	add eax,yradius
	mov yend,eax
      .ELSE
	;wire onto upper-left corner of res...
	mov eax,xcentre
	sub eax,xradius
	mov xend,eax
	mov eax,ycentre
	sub eax,yradius
	mov yend,eax
      .ENDIF
    .ENDIF

    mov eax,xend    ;return snapped coords.
    mov esi,pxend
    mov [esi],eax
    mov eax,yend
    mov esi,pyend
    mov [esi],eax
    mov eax,1	    ;supposed to return ring#, but really for nodes.

  ret
snap_tores ENDP
;--------------------------------------------------------------------------
snap_gen PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,pxend:DWORD,pyend:DWORD
    LOCAL dummy:WORD
;mouse cursor is on an object, pnode, presumably placing
;or adjusting an end of a wire, pxend/pyend.
;(but don't need to refer to g_nmousex/y here, as have xend/yend).
;determine nearest point on boundary of pnode and snap xend/yend to it.
;if xend/yend not on node at all, return eax=0.
;else return eax=ring that snapped to.
;also returns adjusted xend/yend.


  xor eax,eax
  ret
snap_gen ENDP
;--------------------------------------------------------------------------
snap_toarc PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,pxend:DWORD,pyend:DWORD
    LOCAL xend:SDWORD, yend:SDWORD
    LOCAL mousex:SDWORD, mousey:SDWORD
    LOCAL xcentre:SDWORD, ycentre:SDWORD
    LOCAL ytmp:SDWORD, xtmp:SDWORD
    LOCAL deltaytmp:DWORD
    LOCAL hypot:DWORD, xradring1:DWORD
    LOCAL exactradius:DWORD
    LOCAL ring:DWORD
;a method for psnap polymorphic function.
;for placing or adjusting an end of a wire, pxend/pyend.
;(don't need to refer to g_nmousex/y here, as have xend/yend).
;determine nearest point on boundary of pobj and snap xend/yend to it.
;if xend/yend not on pobj at all, return eax=0 -- but still set xend/yend
;to nearest point on outer boundary of pobj.
;else return eax=ring that snapped to.
;also returns adjusted xend/yend.

;note, this function is for attaching a child-object to a wire. the parent
;wire will have a line to the child. The child can be any type of
;object, and the line is to the middle point of the parent wire.

;it's a bit weird attaching another wire to middle of a wire, but
;just in case, the child wire needs this...
;in the case of wires, immediately after calling this method (from
;paint_arc, via psnap method table), an arrowhead is drawn by calling
;draw1starrow() and draw2ndarrow(). these latter funcs use xend/yend
;but to calc other points, also need g_xdiffnorm/g_ydiffnorm, being
;normalised difference between middle of parent node and wire-end.
;xtmp/ytmp are un-normalised, so (xtmp*100)/hypot performs normalisation.
;i'm going to cheat a bit and make g_xdiffnorm/g_ydiffnorm global.

    mov esi,pxend
    mov eax,[esi]
    mov xend,eax
    mov esi,pyend
    mov eax,[esi]
    mov yend,eax

;NOTE got this code from goofee WHICH0...
;WHICH0 uses incoming coords-to-be-snapped as mousex/mousey, so let's
;keep these names...
    mov eax,xend
    mov mousex,eax
    mov eax,yend
    mov mousey,eax

    mov esi,pobj	;node.
    mov eax,(OBJECT PTR [esi]).xmid
    mov xcentre,eax
    mov eax,(OBJECT PTR [esi]).ymid
    mov ycentre,eax

	mov  eax,mousey		;compute formula
	sub  eax,ycentre	;/ hypot=sqrt((mousey-centrey)^2
	mov  ebx,eax		;/	 +((mousex-centrex)^2)
	mov  ytmp,eax		;/
	imul  ebx		;/ -->edx:eax
	mov  deltaytmp,eax	 ;/ temp save
	mov  eax,mousex		;/
	sub  eax,xcentre	;/
	mov  ebx,eax		;/
	mov  xtmp,eax		;/
	imul  ebx		;/ -->edx:eax
	add  eax,deltaytmp	;/

    ;now square-root...
    mov hypot,eax
    fild hypot
    fsqrt
    fistp hypot		;will always be +ve.

	  .IF hypot==0	       ;prevent divide-by-0.
	    mov  hypot,1
	  .ENDIF

;now to normalise xtmp/ytmp (as per explanation above)...
	xor edx,edx
	mov eax,xtmp
	mov ebx,100	;determines final arrow-size.
	imul ebx
	mov ebx,hypot
	idiv ebx
	mov g_xdiffnorm,eax
	  ;ditto for ytmp...
	  xor edx,edx
	  mov eax,ytmp
	  mov ebx,100	;determines final arrow-size.
	  imul ebx
	  mov ebx,hypot
	  idiv ebx
	  mov g_ydiffnorm,eax

;let's say mid-point of wire is a small circle of radius 4 pixels.
    mov exactradius,4
    mov ring,0

;now to snap xend/yend...
	xor edx,edx
	mov  eax,exactradius		;compute formula
	imul xtmp			;/ x=x*(xradius/hypot)
	idiv  hypot			;/
	mov  xtmp,eax			;/
	xor edx,edx
	mov  eax,exactradius		;compute formula
	imul ytmp			;/ y=y*(xradius/hypot)
	idiv  hypot			;/
	mov  ytmp,eax			;/
	mov  eax,xcentre		;compute formula
	add  eax,xtmp			;/ xend=centrex+x
	mov  xend,eax		;/
	mov  eax,ycentre		;compute formula
	add  eax,ytmp		;/
	mov  yend,eax		;/


    mov eax,xend    ;return snapped coords.
    mov esi,pxend
    mov [esi],eax
    mov eax,yend
    mov esi,pyend
    mov [esi],eax
    mov eax,ring
  ret
snap_toarc ENDP
;--------------------------------------------------------------------------
draw1starrow PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD, \
 pparent:DWORD, xendpoint:DWORD,yendpoint:DWORD,ringnum:DWORD,pwire:DWORD
	LOCAL xx2:DWORD, yy2:DWORD, xx3:DWORD, yy3:DWORD
	LOCAL x2:DWORD, y2:DWORD, x3:DWORD, y3:DWORD
	LOCAL xenddiv16:DWORD, yenddiv16:DWORD
	LOCAL xenddiv8:DWORD, yenddiv8:DWORD
	LOCAL xenddiv4:DWORD, yenddiv4:DWORD
	LOCAL xx4:DWORD, yy4:DWORD, x4:DWORD, y4:DWORD
	LOCAL xenddiv32:DWORD, yenddiv32:DWORD
	LOCAL hpenyellow:DWORD,hpenoldblack:DWORD
	LOCAL x5:DWORD, y5:DWORD
;draw arrow at 1st end of wire pwire, locked to node pparent.
;point of contact between wire and node is xendpoint/yendpoint, on ring.
;after drawing the arrow, the last line is to end at middle-back
;of arrowhead, so can draw wire to xknee2/yknee2 upon return.
;also refer draw2ndarrow().

;might as well start at point of arrow...
    invoke MoveToEx, hdc, xendpoint,yendpoint, 0

    mov esi,pwire
    mov edi,pparent

;compute a lot of points, for our various options...

	 mov  eax,g_xdiffnorm	;(see snap_ methods)this is a global var.
	 sar  eax,1
	 sar  eax,1
	 mov  xenddiv4,eax
	 sar  eax,1
	 mov  xenddiv8,eax
	 sar  eax,1
	 mov  xenddiv16,eax	;save
	 sar  eax,1
	 mov  xenddiv32,eax
	 mov  eax,g_ydiffnorm
	 sar  eax,1
	 sar  eax,1
	 mov  yenddiv4,eax
	 sar  eax,1
	 mov  yenddiv8,eax
	 sar  eax,1
	 mov  yenddiv16,eax
	 sar  eax,1
	 mov  yenddiv32,eax

	 ;compute next coords for arrowhead....
	 mov  eax,xendpoint  ;x-tip of arrow.
	 sub  eax,yenddiv32
	 add  eax,xenddiv16
	 mov  x2,eax	    ;1st side-tip of arrow.
	 mov  eax,yendpoint
	 add  eax,yenddiv16
	 add  eax,xenddiv32
	 mov  y2,eax
	 mov  eax,xendpoint
	 add  eax,yenddiv32
	 add  eax,xenddiv16
	 mov  x3,eax	    ;other-side-tip of arrow.
	 mov  eax,yendpoint
	 add  eax,yenddiv16
	 sub  eax,xenddiv32
	 mov  y3,eax
	   ;same thing again, for xx2,yy2,xx3,yy3...
	   mov	eax,xendpoint
	   sub	eax,yenddiv16
	   add	eax,xenddiv8
	   mov	xx2,eax
	   mov	eax,yendpoint
	   add	eax,yenddiv8
	   add	eax,xenddiv16
	   mov	yy2,eax
	   mov	eax,xendpoint
	   add	eax,yenddiv16
	   add	eax,xenddiv8
	   mov	xx3,eax
	   mov	eax,yendpoint
	   add	eax,yenddiv8
	   sub	eax,xenddiv16
	   mov	yy3,eax
		;and coords perpendicular from node...
		mov  eax,xendpoint
		add  eax,xenddiv4
		mov  x4,eax
		mov  eax,yendpoint
		add  eax,yenddiv4
		mov  y4,eax
		mov  eax,xendpoint
		add  eax,xenddiv8
		mov  xx4,eax
		mov  eax,yendpoint
		add  eax,yenddiv8
		mov  yy4,eax
		mov  eax,xendpoint
		add  eax,xenddiv16
		mov  x5,eax
		mov  eax,yendpoint
		add  eax,yenddiv16
		mov  y5,eax


;fall down here, we want an arrow, but what type?...
    mov	ax,(OBJECT PTR [esi]).nexttype
    .IF ax==10	    ;sync., 1-way. no arrow at 1st end.
      invoke LineTo, hdc, x5,y5
    .ELSEIF ax==11	    ;sync with reply.
      invoke LineTo, hdc, x3,y3	  ;one side-point of arrow.
      invoke LineTo, hdc, x2,y2     ;other side.
      invoke LineTo, hdc, xendpoint,yendpoint ;tip of arrow.
    .ELSEIF ax==12 ;sync with reply and timeout
      ;***NOTE*** not yet implemented.
      invoke LineTo, hdc, x3,y3	  ;one side-point of arrow.
      invoke LineTo, hdc, x2,y2     ;other side.
      invoke LineTo, hdc, xendpoint,yendpoint ;tip of arrow.
    .ELSEIF ax==13  ;async, 1-way, no arrow.
      invoke LineTo, hdc, x5,y5
    .ELSEIF ax==14  ;async 2-way.
      invoke LineTo, hdc, x3,y3
      invoke MoveToEx, hdc, x2,y2,0
      invoke LineTo, hdc, xendpoint,yendpoint ;tip of arrow.
      invoke LineTo, hdc, x5,y5	 ;just behind arrow.
    .ELSEIF ax==15  ;default dataflow wire, no arrow.
      invoke LineTo, hdc, x5,y5
    .ELSEIF ax==17  ;interrupt dataflow wire, again no arrow.
      invoke LineTo, hdc, x5,y5
    .ELSE
      invoke LineTo, hdc, x5,y5
    .ENDIF

;bezier...
  mov eax,x5	       ;start-point of bezier curve (start of wire)
  mov bez1.pt_x,eax
  mov (OBJECT PTR [esi]).bez1x,eax ;save point in wire(future quick redraw).
  mov eax,y5
  mov bez1.pt_y,eax
  mov (OBJECT PTR [esi]).bez1y,eax ;save point in wire(future quick redraw).
  mov eax,x4	      ;first control-point.
  mov bez2.pt_x,eax
  mov (OBJECT PTR [esi]).bez2x,eax ;save point in wire(future quick redraw).
  mov eax,y4
  mov bez2.pt_y,eax
  mov (OBJECT PTR [esi]).bez2y,eax ;save point in wire(future quick redraw).


  ret
draw1starrow ENDP
;--------------------------------------------------------------------------
draw2ndarrow PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD, \
 pparent:DWORD, xendpoint:DWORD,yendpoint:DWORD,ringnum:DWORD,pwire:DWORD
	LOCAL xx2:DWORD, yy2:DWORD, xx3:DWORD, yy3:DWORD
	LOCAL x2:DWORD, y2:DWORD, x3:DWORD, y3:DWORD
	LOCAL xenddiv16:DWORD, yenddiv16:DWORD
	LOCAL xenddiv8:DWORD, yenddiv8:DWORD
	LOCAL xenddiv4:DWORD, yenddiv4:DWORD
	LOCAL xx4:DWORD, yy4:DWORD, x4:DWORD, y4:DWORD
	LOCAL xenddiv32:DWORD, yenddiv32:DWORD
	LOCAL hpenyellow:DWORD,hpenoldblack:DWORD
	LOCAL x5:DWORD, y5:DWORD
;draw arrow at 2nd end of wire pwire, locked to node pparent.
;point of contact between wire and node is xendpoint/yendpoint, on ring.
;after drawing the arrow, the last line is to end at middle-back
;of arrowhead, so can draw wire to xknee2/yknee2 upon return.
;see draw1starrow() for drawing arrow at 1st-end of wire.
;snap_ method is called by paint_ method just prior ro calling
;draw1starrow() and draw2nd arrow(). the snap_ methods set global
;variables g_xdiffnorm/g_ydiffnorm that are used in here to draw arrows.

;might as well start at point of arrow...
    invoke MoveToEx, hdc, xendpoint,yendpoint, 0

    mov esi,pwire
    mov edi,pparent

;compute a lot of points, for our various options...

	 mov  eax,g_xdiffnorm	;(see snap_ methods)
	 sar  eax,1
	 sar  eax,1
	 mov  xenddiv4,eax
	 sar  eax,1
	 mov  xenddiv8,eax
	 sar  eax,1
	 mov  xenddiv16,eax	;save
	 sar  eax,1
	 mov  xenddiv32,eax
	 mov  eax,g_ydiffnorm
	 sar  eax,1
	 sar  eax,1
	 mov  yenddiv4,eax
	 sar  eax,1
	 mov  yenddiv8,eax
	 sar  eax,1
	 mov  yenddiv16,eax
	 sar  eax,1
	 mov  yenddiv32,eax

	 ;compute next coords for arrowhead....
	 mov  eax,xendpoint  ;x-tip of arrow.
	 sub  eax,yenddiv32
	 add  eax,xenddiv16
	 mov  x2,eax	    ;1st side-tip of arrow.
	 mov  eax,yendpoint
	 add  eax,yenddiv16
	 add  eax,xenddiv32
	 mov  y2,eax
	 mov  eax,xendpoint
	 add  eax,yenddiv32
	 add  eax,xenddiv16
	 mov  x3,eax	    ;other-side-tip of arrow.
	 mov  eax,yendpoint
	 add  eax,yenddiv16
	 sub  eax,xenddiv32
	 mov  y3,eax
	   ;same thing again, for xx2,yy2,xx3,yy3...
	   mov	eax,xendpoint
	   sub	eax,yenddiv16
	   add	eax,xenddiv8
	   mov	xx2,eax
	   mov	eax,yendpoint
	   add	eax,yenddiv8
	   add	eax,xenddiv16
	   mov	yy2,eax
	   mov	eax,xendpoint
	   add	eax,yenddiv16
	   add	eax,xenddiv8
	   mov	xx3,eax
	   mov	eax,yendpoint
	   add	eax,yenddiv8
	   sub	eax,xenddiv16
	   mov	yy3,eax
		;and coords perpendicular from node...
		mov  eax,xendpoint
		add  eax,xenddiv4
		mov  x4,eax
		mov  eax,yendpoint
		add  eax,yenddiv4
		mov  y4,eax
		mov  eax,xendpoint
		add  eax,xenddiv8
		mov  xx4,eax
		mov  eax,yendpoint
		add  eax,yenddiv8
		mov  yy4,eax
		mov  eax,xendpoint
		add  eax,xenddiv16
		mov  x5,eax
		mov  eax,yendpoint
		add  eax,yenddiv16
		mov  y5,eax

;fall down here, we want an arrow, but what type?...
    mov	ax,(OBJECT PTR [esi]).nexttype
    .IF ax==10	    ;sync 1-way.
      jmp SHORT sy1
    .ELSEIF ax==11  ;sync with reply.
sy1:  invoke LineTo, hdc, x3,y3	  ;one side-point of arrow.
      invoke LineTo, hdc, x2,y2     ;other side.
      invoke LineTo, hdc, xendpoint,yendpoint ;tip of arrow.
      invoke MoveToEx, hdc, x5,y5,0
    .ELSEIF ax==12 ;sync with reply and timeout
      jmp sy1	    ;***NOTE*** not yet implemented.
    .ELSEIF ax==13   ;async 1-way.
      jmp SHORT sy2
    .ELSEIF ax==14  ;async 2-way.
sy2:  invoke LineTo, hdc, x3,y3
      invoke MoveToEx, hdc, x2,y2,0
      invoke LineTo, hdc, xendpoint,yendpoint ;tip of arrow.
      invoke LineTo, hdc, x5,y5 ;xx4,yy4	;just behind arrow.
    .ELSEIF ax==15	;default dataflow wire.
      invoke LineTo, hdc, x5,y5
    .ELSEIF ax==17	;interrupt dataflow wire.
      invoke LineTo, hdc, x2,y2
      invoke LineTo, hdc, xx3,yy3
      invoke LineTo, hdc, xx2,yy2
      invoke LineTo, hdc, x4,y4
      invoke MoveToEx, hdc, xendpoint,yendpoint,0
      invoke LineTo, hdc, x5,y5
    .ELSEIF ax==22	;mutual-exclusion wire.
      invoke LineTo, hdc, xx4,yy4
      invoke LineTo, hdc, xx2,yy2
      invoke LineTo, hdc, x4,y4
      invoke LineTo, hdc, xx3,yy3
      invoke LineTo, hdc, xx4,yy4
    .ELSEIF ax==50	;hardware, private, object.
hn1:	;interrupt object. this is a NODE-TYPE object.
      ;but it still has a line, generated in paint_hard().
      ;paint_hard has already drawn the line, a straight line, so
      ;bypass those bezier settings below.
      mov al,(OBJECT PTR [esi]).nfunctype
      .IF al==1	 ;interrupt access method
	invoke LineTo, hdc, x2,y2
	invoke LineTo, hdc, xx3,yy3
	invoke LineTo, hdc, xx2,yy2
	invoke LineTo, hdc, x4,y4
	invoke MoveToEx, hdc, xendpoint,yendpoint,0
	invoke LineTo, hdc, x5,y5
	ret
      .ELSE		   ;=0, variable access.
	;paint_hard() has already drawn the line, then calls here.
	;no line-end embellishment required, so getout...
	ret
      .ENDIF
    .ELSEIF ax==51	;hardware, global, object.(node-type).
      jmp hn1
    .ELSE
      invoke LineTo, hdc, x5,y5
    .ENDIF

;bezier...
  mov eax,x4
  mov bez6.pt_x,eax	;last control-point of beziercurve.
  mov (OBJECT PTR [esi]).bez6x,eax ;save point in wire(future quick redraw).
  mov eax,y4
  mov bez6.pt_y,eax
  mov (OBJECT PTR [esi]).bez6y,eax ;save point in wire(future quick redraw).
  mov eax,x5		;end-point of bezier curve.
  mov bez7.pt_x,eax
  mov (OBJECT PTR [esi]).bez7x,eax ;save point in wire(future quick redraw).
  mov eax,y5
  mov bez7.pt_y,eax
  mov DWORD PTR (OBJECT PTR [esi]).nfunctype,eax
   ;... .nfunctype--.spare88-->.bez7y save point wire(future quick redraw).


  ret
draw2ndarrow ENDP
;--------------------------------------------------------------------------
findifisr PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD


  xor eax,eax
  ret
findifisr ENDP
;--------------------------------------------------------------------------
binto3dec PROC STDCALL USES ebx ecx edx esi edi, pszdest:DWORD
;enter with value in ax, convert to 3-digit decimal ascii, retaining
;leading zeros...
  mov  edi,pszdest
	xor	edx,edx
	mov	ecx,10
	div	cx
	add	dl,30h	;ascii
	mov	BYTE PTR [edi+2],dl
	xor	edx,edx
	div	cx
	add	dl,30h
	mov	BYTE PTR [edi+1],dl
	xor	edx,edx
	div	cx
	add	dl,30h
	mov	BYTE PTR [edi],dl

  ret
binto3dec ENDP
;--------------------------------------------------------------------------
insertring PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD,nring:DWORD
    LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
    LOCAL nnewring:DWORD
;    LOCAL exactradius:DWORD,xradring1:DWORD
;    LOCAL xcentre:SDWORD,ycentre:SDWORD,hypot:DWORD,xtmp:SDWORD,ytmp:SDWORD
;    LOCAL deltaxtmp:SDWORD,deltaytmp:SDWORD,xend:SDWORD,yend:SDWORD
; "insertring"
;called from KENTER5proc, node dialog box callback, to insert a ring.
;pobj is the node, nring is the ring# that the ring is to be inserted
;after.
;any wires on outer rings are adjusted. -- their .beginring or .endring
;value is incremented, and end coords adjusted to snap to correct ring.

    mov ebx,pobj			  ;node.
    inc (OBJECT PTR [ebx]).nrings

;    mov eax,(OBJECT PTR [ebx]).xmid
;    mov xcentre,eax
;    mov eax,(OBJECT PTR [ebx]).ymid
;    mov ycentre,eax
;	mov eax,(OBJECT PTR [ebx]).wwidth ;node.
;	shr eax,1
;	mov xradring1,eax   ;radius of ring1.

;scan through all objects...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0 ;extreme precaution.
	    jmp j03
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	      .IF esi==pobj ;don't test itself.
	      .ELSE
		mov al,(OBJECT PTR [esi]).fconfig
		and al,01	;bit0=1 if wire type.
		.IF al==01
		  mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pobj
		    ;1st end of wire is connected to node.
		    xor eax,eax
		    mov al,(OBJECT PTR [esi]).nbeginring
		    mov ecx,nring
		    .IF al>cl	 ;is wire at a ring outer from insertion?
		      ;update wire's .beginring...
		      inc eax
		      mov nnewring,eax	  ;new ring# wire is to snapto.
		      inc (OBJECT PTR [esi]).nbeginring
		      ;...though this gets auto-set by snap_tonode anyway.
			;modify .xtopleft/.ytopleft so will autosnap
			;to next-outer ring when next call WM_PAINT>wmpaint>
			; paint_arc>snap_tonode...
		      ;esi-->wire, ebx-->node

;		      ;081200
;		      ;want to handle ellipses...
;		      mov ebx,pobj	       ;node.
;		      mov eax,(OBJECT PTR [ebx]).wwidth
;		      mov ecx,(OBJECT PTR [ebx]).height
;		      .IF eax==ecx
;			jmp jjn

;			  ; 251100 new code to calc new wire-end coords...
;			  ; (adapted from snap_tonode())
;			  mov eax,nnewring
;			  dec eax
;			  xor edx,edx
;			  mov ecx,8
;			  imul ecx
;			  add eax,xradring1
;			  mov exactradius,eax ;radius exactly on ring.
;			mov eax,(OBJECT PTR [esi]).xtopleft  ;wire.
;			sub eax,xcentre ;subtr. node centre.
;			mov ecx,eax
;			mov xtmp,eax
;			imul ecx	;delta-x sqrd
;			mov deltaxtmp,eax
;			mov eax,(OBJECT PTR [esi]).ytopleft  ;wire.
;			sub eax,ycentre
;			mov ytmp,eax
;			mov ecx,eax
;			imul ecx	;delta-y sqrd.
;			mov deltaytmp,eax
;			add eax,deltaxtmp
;			mov hypot,eax
;			fild hypot
;			fsqrt
;			fistp hypot  ;actual hypot to current wire coords.
;			  xor edx,edx
;			  mov eax,exactradius
;			  imul xtmp
;			  idiv hypot
;			  mov xtmp,eax
;			  xor edx,edx
;			  mov eax,exactradius
;			  imul ytmp
;			  idiv hypot
;			  mov ytmp,eax
;			  mov eax,xcentre
;			  add eax,xtmp
;			  mov xend,eax
;			  mov eax,ycentre
;			  add eax,ytmp
;			  mov yend,eax
;			  ;...xend/yend are new snapped wire coords.
;			    mov eax,xend
;			    mov (OBJECT PTR [esi]).xtopleft,eax
;			    mov eax,yend
;			    mov (OBJECT PTR [esi]).ytopleft,eax

;very old code...
;			mov eax,(OBJECT PTR [esi]).xtopleft
;			sub eax,(OBJECT PTR [ebx]).xmid	;node
;			.IF SDWORD PTR eax>=0
;			  add (OBJECT PTR [esi]).xtopleft,2 ;enoughtosnapout
;			.ELSE
;			  sub (OBJECT PTR [esi]).xtopleft,2 ;/
;			.ENDIF
;			mov eax,(OBJECT PTR [esi]).ytopleft
;			sub eax,(OBJECT PTR [ebx]).ymid	;node
;			.IF SDWORD PTR eax>=0
;			  add (OBJECT PTR [esi]).ytopleft,2 ;enoughtosnapout
;			.ELSE
;			  sub (OBJECT PTR [esi]).ytopleft,2 ;/
;			.ENDIF

;		      .ELSE
			;new routine for ellipse...
			push g_nsnapring	;precaution.
			push g_xdiffnorm	;/
			push g_ydiffnorm	;/
			mov eax,nnewring
			mov g_nsnapring,eax	;global, used by snap_tonode().
			mov ebx,pobj	    ;node.
			 ;offset wire-end for nonconcentric rings...
			 mov eax,(OBJECT PTR [ebx]).xdeltacentre
			 add (OBJECT PTR [esi]).xtopleft,eax ;wire.
			 mov eax,(OBJECT PTR [ebx]).ydeltacentre
			 add (OBJECT PTR [esi]).ytopleft,eax
			mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
			mov ebx,eax
			lea ecx,(OBJECT PTR [esi]).xtopleft	;wire.
			lea edx,(OBJECT PTR [esi]).ytopleft
			;calls snap_tonode()...
			invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx
			;...will return nearest point on nnewring, in
			;	.xtopleft/.ytopleft of wire.
			pop g_ydiffnorm
			pop g_xdiffnorm
			pop g_nsnapring
;		      .ENDIF


		    .ENDIF
		      jmp SHORT tst1	;in case other end wire on same node.
		  .ELSE
tst1:		    mov eax,(OBJECT PTR [esi]).rplock2
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		    .IF eax==pobj
		      ;2nd end of wire is connected to node.
		      xor eax,eax
		      mov al,(OBJECT PTR [esi]).nendring
		      mov ecx,nring
		      .IF al>cl	 ;is wire at a ring outer from insertion?
			inc eax
			mov nnewring,eax ;new ring# wire must snap to.
			;update wire's .nendring...
			inc (OBJECT PTR [esi]).nendring
			;...though this gets auto-set by snap_tonode anyway.
			;modify .wwidth/.height(end coords)so will autosnap
			;to next-outer ring when next call WM_PAINT>wmpaint>
			; paint_arc...

			;091200 new routine for ellipse...
			push g_nsnapring	;precaution.
			push g_xdiffnorm	;/
			push g_ydiffnorm	;/
			mov eax,nnewring
			mov g_nsnapring,eax ;global, used by snap_tonode().
			mov ebx,pobj	  ;node.
			 ;offset wire-end for nonconcentric rings...
			 mov eax,(OBJECT PTR [ebx]).xdeltacentre
			 add (OBJECT PTR [esi]).wwidth,eax ;wire.
			 mov eax,(OBJECT PTR [ebx]).ydeltacentre
			 add (OBJECT PTR [esi]).height,eax
			mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
			mov ebx,eax
			lea ecx,(OBJECT PTR [esi]).wwidth	;wire.
			lea edx,(OBJECT PTR [esi]).height
			;calls snap_tonode()...
			invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx
			;...will return nearest point on nnewring, in
			;	.wwidth/height of wire.
			pop g_ydiffnorm
			pop g_xdiffnorm
			pop g_nsnapring


;; 251100 new code to calc new wire-end coords...
;; (adapted from snap_tonode())
;			  mov eax,nnewring
;			  dec eax
;			  xor edx,edx
;			  mov ecx,8
;			  imul ecx
;			  add eax,xradring1
;			  mov exactradius,eax ;radius exactly on ring.
;			mov eax,(OBJECT PTR [esi]).wwidth	;wire.
;			sub eax,xcentre ;subtr. node centre.
;			mov ecx,eax
;			mov xtmp,eax
;			imul ecx	;delta-x sqrd
;			mov deltaxtmp,eax
;			mov eax,(OBJECT PTR [esi]).height	;wire.
;			sub eax,ycentre
;			mov ytmp,eax
;			mov ecx,eax
;			imul ecx	;delta-y sqrd.
;			mov deltaytmp,eax
;			add eax,deltaxtmp
;			mov hypot,eax
;			fild hypot
;			fsqrt
;			fistp hypot  ;actual hypot to current wire coords.
;			  xor edx,edx
;			  mov eax,exactradius
;			  imul xtmp
;			  idiv hypot
;			  mov xtmp,eax
;			  xor edx,edx
;			  mov eax,exactradius
;			  imul ytmp
;			  idiv hypot
;			  mov ytmp,eax
;			  mov eax,xcentre
;			  add eax,xtmp
;			  mov xend,eax
;			  mov eax,ycentre
;			  add eax,ytmp
;			  mov yend,eax
;			  ;...xend/yend are new snapped wire coords.
;			    mov eax,xend
;			    mov (OBJECT PTR [esi]).wwidth,eax
;			    mov eax,yend
;			    mov (OBJECT PTR [esi]).height,eax


;old code...
;			mov eax,(OBJECT PTR [esi]).wwidth
;			sub eax,(OBJECT PTR [ebx]).xmid	;node
;			.IF SDWORD PTR eax>=0
;			  add (OBJECT PTR [esi]).wwidth,2 ;enoughtosnapout
;			.ELSE
;			  sub (OBJECT PTR [esi]).wwidth,2 ;/
;			.ENDIF
;			mov eax,(OBJECT PTR [esi]).height
;			sub eax,(OBJECT PTR [ebx]).ymid	;node
;			.IF SDWORD PTR eax>=0
;			  add (OBJECT PTR [esi]).height,2 ;enoughtosnapout
;			.ELSE
;			  sub (OBJECT PTR [esi]).height,2 ;/
;			.ENDIF


		      .ENDIF
		    .ENDIF
		  .ENDIF
		.ELSE
		  ;it's a node-type.
		  ;an action or condition object will have .rplock1
		  ;set to its parent, and .nbeginring set to the ring
		  ;it's connected to on the parent...
		  mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pobj
		    ;it is connected to pobj parent.
		    mov ax,(OBJECT PTR [esi]).nexttype
		    .IF ax==32	;condition element.
kk1:		      mov al,(OBJECT PTR [esi]).nbeginring
		      mov ecx,nring
		      .IF al>cl	 ;is action at a ring outer from insertion?
			inc (OBJECT PTR [esi]).nbeginring
			 ;offset cond/action for nonconcentric rings...
			 mov ebx,pobj	;node.
			 mov eax,(OBJECT PTR [ebx]).xdeltacentre
			 add (OBJECT PTR [esi]).xtopleft,eax
			 add (OBJECT PTR [esi]).xmid,eax
			 mov eax,(OBJECT PTR [ebx]).ydeltacentre
			 add (OBJECT PTR [esi]).ytopleft,eax
			 add (OBJECT PTR [esi]).ymid,eax
		      .ENDIF
		    .ELSEIF ax==33 ;action element.
		      jmp kk1
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	  .ENDIF
x1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  j02 ;nextobj
      jmp SHORT j03
j02:  jmp nextobj
j03:





  ret
insertring ENDP
;--------------------------------------------------------------------------
deletering PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD,nring:DWORD
    LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
    LOCAL nnewring:DWORD
;    LOCAL exactradius:DWORD,xradring1:DWORD
;    LOCAL xcentre:SDWORD,ycentre:SDWORD,hypot:DWORD,xtmp:SDWORD,ytmp:SDWORD
;    LOCAL deltaxtmp:SDWORD,deltaytmp:SDWORD,xend:SDWORD,yend:SDWORD
; "deletering"
;called from KENTER5proc, node dialog box callback, to delete	a ring.
;pobj is the node, nring is the ring#.
;any wires on outer rings are adjusted. -- their .beginring or .endring
;value is decremented, and coords adjusted to snap to correct ring.

;a ring will not be deleted if it has any wires attached.
;returns eax=0 if fail.

    mov ebx,pobj		    ;node.

;    mov eax,(OBJECT PTR [ebx]).xmid
;    mov xcentre,eax
;    mov eax,(OBJECT PTR [ebx]).ymid
;    mov ycentre,eax
;	mov eax,(OBJECT PTR [ebx]).wwidth ;node.
;	shr eax,1
;	mov xradring1,eax   ;radius of ring1.

;scan through all objects...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0 ;extreme precaution.
	    jmp delfail
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	      .IF esi==pobj ;don't test itself.
	      .ELSE
		mov al,(OBJECT PTR [esi]).fconfig
		and al,01	;bit0=1 if wire type.
		.IF al==01
		  mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pobj
		    ;1st end of wire is connected to node.
		    xor eax,eax
		    mov al,(OBJECT PTR [esi]).nbeginring
		    .IF eax==nring
		      ;fail. cannot delete ring...
		      jmp delfail
		    .ENDIF
		  .ELSE
		    mov eax,(OBJECT PTR [esi]).rplock2
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		    .IF eax==pobj
		      ;2nd end of wire is connected to node.
		      xor eax,eax
		      mov al,(OBJECT PTR [esi]).nendring
		      .IF eax==nring
			;fail. cannot delete ring...
			jmp delfail
		      .ENDIF
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	  .ENDIF
x1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  j02 ;nextobj
      jmp SHORT j03
j02:  jmp nextobj
j03:

;fall down here, then found no wires on ring, so delete it...
;have to go through database AGAIN, moving wires on outer rings
;in one ring...
;scan through all objects...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	;as we loop around, edi->start of TERSEDATA, esi->current object...
xnextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	      .IF esi==pobj ;don't test itself.
	      .ELSE
		mov al,(OBJECT PTR [esi]).fconfig
		and al,01	;bit0=1 if wire type.
		.IF al==01
		  mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pobj
		    ;1st end of wire is connected to node.
		    xor eax,eax
		    mov al,(OBJECT PTR [esi]).nbeginring
		    mov ecx,nring
		    .IF al>cl	 ;is wire at a ring outer from deletion?
		      ;update wire's .beginring...
		      dec eax
		      mov nnewring,eax ;ring# that wire must now snapto.
		      dec (OBJECT PTR [esi]).nbeginring
		      ;...though this gets auto-set by snap_tonode anyway.
			;modify .xtopleft/.ytopleft so will autosnap
			;to next-inner ring when next call WM_PAINT>wmpaint>
			; paint_arc>snap_tonode...


			;091200 new routine for ellipse...
			push g_nsnapring	;precaution.
			push g_xdiffnorm	;/
			push g_ydiffnorm	;/
			mov eax,nnewring
			mov g_nsnapring,eax	;global, used by snap_tonode().
			mov ebx,pobj
			 ;offset wire-end for nonconcentric rings...
			 mov eax,(OBJECT PTR [ebx]).xdeltacentre
			 sub (OBJECT PTR [esi]).xtopleft,eax ;wire.
			 mov eax,(OBJECT PTR [ebx]).ydeltacentre
			 sub (OBJECT PTR [esi]).ytopleft,eax
			mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
			mov ebx,eax
			lea ecx,(OBJECT PTR [esi]).xtopleft	;wire.
			lea edx,(OBJECT PTR [esi]).ytopleft
			;calls snap_tonode()...
			invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx
			;...will return nearest point on nnewring, in
			;	.xtopleft/.ytopleft of wire.
			pop g_ydiffnorm
			pop g_xdiffnorm
			pop g_nsnapring


;; 251100 new code to calc new wire-end coords...
;; (adapted from snap_tonode())
;			  mov eax,nnewring
;			  dec eax
;			  xor edx,edx
;			  mov ecx,8
;			  imul ecx
;			  add eax,xradring1
;			  mov exactradius,eax ;radius exactly on ring.
;			mov eax,(OBJECT PTR [esi]).xtopleft  ;wire.
;			sub eax,xcentre ;subtr. node centre.
;			mov ecx,eax
;			mov xtmp,eax
;			imul ecx	;delta-x sqrd
;			mov deltaxtmp,eax
;			mov eax,(OBJECT PTR [esi]).ytopleft  ;wire.
;			sub eax,ycentre
;			mov ytmp,eax
;			mov ecx,eax
;			imul ecx	;delta-y sqrd.
;			mov deltaytmp,eax
;			add eax,deltaxtmp
;			mov hypot,eax
;			fild hypot
;			fsqrt
;			fistp hypot  ;actual hypot to current wire coords.
;			  xor edx,edx
;			  mov eax,exactradius
;			  imul xtmp
;			  idiv hypot
;			  mov xtmp,eax
;			  xor edx,edx
;			  mov eax,exactradius
;			  imul ytmp
;			  idiv hypot
;			  mov ytmp,eax
;			  mov eax,xcentre
;			  add eax,xtmp
;			  mov xend,eax
;			  mov eax,ycentre
;			  add eax,ytmp
;			  mov yend,eax
;			  ;...xend/yend are new snapped wire coords.
;			    mov eax,xend
;			    mov (OBJECT PTR [esi]).xtopleft,eax
;			    mov eax,yend
;			    mov (OBJECT PTR [esi]).ytopleft,eax


;old code...
;			mov eax,(OBJECT PTR [esi]).xtopleft
;			sub eax,(OBJECT PTR [ebx]).xmid	;node
;			.IF SDWORD PTR eax>=0
;			  sub (OBJECT PTR [esi]).xtopleft,10 ;enoughtosnapout
;			.ELSE
;			  add (OBJECT PTR [esi]).xtopleft,10 ;/
;			.ENDIF
;			mov eax,(OBJECT PTR [esi]).ytopleft
;			sub eax,(OBJECT PTR [ebx]).ymid	;node
;			.IF SDWORD PTR eax>=0
;			  sub (OBJECT PTR [esi]).ytopleft,10 ;enoughtosnapout
;			.ELSE
;			  add (OBJECT PTR [esi]).ytopleft,10 ;/
;			.ENDIF


		    .ENDIF
		      jmp SHORT xtst1	;in case other end wire on same node.
		  .ELSE
xtst1:		    mov eax,(OBJECT PTR [esi]).rplock2
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		    .IF eax==pobj
		      ;2nd end of wire is connected to node.
		      xor eax,eax
		      mov al,(OBJECT PTR [esi]).nendring
		      mov ecx,nring
		      .IF al>cl	 ;is wire at a ring outer from deletion?
			;update wire's .nendring...
		      dec eax
		      mov nnewring,eax ;ring# that wire must now snapto.
			dec (OBJECT PTR [esi]).nendring
			;...though this gets auto-set by snap_tonode anyway.
			;modify .xtopleft/.ytopleft so will autosnap
			;to next-inner ring when next call WM_PAINT>wmpaint>
			; paint_arc...

			;new routine for ellipse...
			push g_nsnapring	;precaution.
			push g_xdiffnorm	;/
			push g_ydiffnorm	;/
			mov eax,nnewring
			mov g_nsnapring,eax ;global, used by snap_tonode().
			mov ebx,pobj	  ;node.
			 ;offset wire-end for nonconcentric rings...
			 mov eax,(OBJECT PTR [ebx]).xdeltacentre
			 sub (OBJECT PTR [esi]).wwidth,eax ;wire.
			 mov eax,(OBJECT PTR [ebx]).ydeltacentre
			 sub (OBJECT PTR [esi]).height,eax
			mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
			mov ebx,eax
			lea ecx,(OBJECT PTR [esi]).wwidth	;wire.
			lea edx,(OBJECT PTR [esi]).height
			;calls snap_tonode()...
			invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx
			;...will return nearest point on nnewring, in
			;	.xtopleft/.ytopleft of wire.
			pop g_ydiffnorm
			pop g_xdiffnorm
			pop g_nsnapring


;; 251100 new code to calc new wire-end coords...
;; (adapted from snap_tonode())
;			  mov eax,nnewring
;			  dec eax
;			  xor edx,edx
;			  mov ecx,8
;			  imul ecx
;			  add eax,xradring1
;			  mov exactradius,eax ;radius exactly on ring.
;			mov eax,(OBJECT PTR [esi]).wwidth	;wire.
;			sub eax,xcentre ;subtr. node centre.
;			mov ecx,eax
;			mov xtmp,eax
;			imul ecx	;delta-x sqrd
;			mov deltaxtmp,eax
;			mov eax,(OBJECT PTR [esi]).height	;wire.
;			sub eax,ycentre
;			mov ytmp,eax
;			mov ecx,eax
;			imul ecx	;delta-y sqrd.
;			mov deltaytmp,eax
;			add eax,deltaxtmp
;			mov hypot,eax
;			fild hypot
;			fsqrt
;			fistp hypot  ;actual hypot to current wire coords.
;			  xor edx,edx
;			  mov eax,exactradius
;			  imul xtmp
;			  idiv hypot
;			  mov xtmp,eax
;			  xor edx,edx
;			  mov eax,exactradius
;			  imul ytmp
;			  idiv hypot
;			  mov ytmp,eax
;			  mov eax,xcentre
;			  add eax,xtmp
;			  mov xend,eax
;			  mov eax,ycentre
;			  add eax,ytmp
;			  mov yend,eax
;			  ;...xend/yend are new snapped wire coords.
;			    mov eax,xend
;			    mov (OBJECT PTR [esi]).wwidth,eax
;			    mov eax,yend
;			    mov (OBJECT PTR [esi]).height,eax


;old code...
;			mov eax,(OBJECT PTR [esi]).wwidth
;			sub eax,(OBJECT PTR [ebx]).xmid	;node
;			.IF SDWORD PTR eax>=0
;			  sub (OBJECT PTR [esi]).wwidth,10 ;enoughtosnapout
;			.ELSE
;			  add (OBJECT PTR [esi]).wwidth,10 ;/
;			.ENDIF
;			mov eax,(OBJECT PTR [esi]).height
;			sub eax,(OBJECT PTR [ebx]).ymid	;node
;			.IF SDWORD PTR eax>=0
;			  sub (OBJECT PTR [esi]).height,10 ;enoughtosnapout
;			.ELSE
;			  add (OBJECT PTR [esi]).height,10 ;/
;			.ENDIF


		      .ENDIF
		    .ENDIF
		  .ENDIF

		.ELSE
		  ;it's a node-type.
		  ;an action or condition object will have .rplock1
		  ;set to its parent, and .nbeginring set to the ring
		  ;it's connected to on the parent...
		  mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pobj
		    ;it is connected to pobj parent.
		    mov ax,(OBJECT PTR [esi]).nexttype
		    .IF ax==32	;condition element.
kk1:		      mov al,(OBJECT PTR [esi]).nbeginring
		      mov ecx,nring
		      .IF al>cl	 ;is action at a ring outer from deletion?
			dec (OBJECT PTR [esi]).nbeginring
			 ;offset cond/action for nonconcentric rings...
			 mov ebx,pobj	;node.
			 mov eax,(OBJECT PTR [ebx]).xdeltacentre
			 sub (OBJECT PTR [esi]).xtopleft,eax
			 sub (OBJECT PTR [esi]).xmid,eax
			 mov eax,(OBJECT PTR [ebx]).ydeltacentre
			 sub (OBJECT PTR [esi]).ytopleft,eax
			 sub (OBJECT PTR [esi]).ymid,eax
		      .ELSEIF al==cl ;is action on ring to be deleted?
			mov (OBJECT PTR [esi]).fstatus,0 ;delete action.
		      .ENDIF
		    .ELSEIF ax==33 ;action element.
		      jmp kk1
		    .ENDIF
		  .ENDIF
		.ENDIF

	      .ENDIF
	  .ENDIF
xx1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  xj02 ;nextobj
      jmp SHORT xj03
xj02:  jmp xnextobj
xj03:

    mov ebx,pobj
    dec (OBJECT PTR [ebx]).nrings
    xor eax,eax
    mov al,(OBJECT PTR [ebx]).nrings
    ret

delfail:
    xor eax,eax
    ret
deletering ENDP
;--------------------------------------------------------------------------
fixnonconc2conc PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD, \
    oldxdelta:DWORD,oldydelta:DWORD
    LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
; "fixnonconc2conc"
;a node with totem-pole rings has been converted to concentric.
;nodeproc() calls this func.
;need to find all wires attached to this node and adj end coords,
;and all cond/action elements and adj their x/ytopleft & x/ymid
;(note, cond/action will auto-snap to the correct ring).

    mov ebx,pobj			  ;node.


;scan through all objects...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0 ;extreme precaution.
	    jmp j03
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	      .IF esi==pobj ;don't test itself.
	      .ELSE
		mov al,(OBJECT PTR [esi]).fconfig
		and al,01	;bit0=1 if wire type.
		.IF al==01
		  mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pobj
		    ;1st end of wire is connected to node.
		      ;esi-->wire, ebx-->node

			;new routine for ellipse...
			push g_nsnapring	;precaution.
			push g_xdiffnorm	;/
			push g_ydiffnorm	;/
			xor eax,eax
			mov al,(OBJECT PTR [esi]).nbeginring
			mov g_nsnapring,eax ;global, used by snap_tonode().
			mov ebx,pobj	    ;node.
			 ;offset wire-end for nonconcentric rings...
			 mov ecx,g_nsnapring
			 dec ecx
			 mov eax,oldxdelta ;(OBJECT PTR [ebx]).xdeltacentre
			 imul ecx
			 sub (OBJECT PTR [esi]).xtopleft,eax
			 mov eax,oldydelta ;(OBJECT PTR [ebx]).ydeltacentre
			 imul ecx
			 sub (OBJECT PTR [esi]).ytopleft,eax
			mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
			mov ebx,eax
			lea ecx,(OBJECT PTR [esi]).xtopleft	;wire.
			lea edx,(OBJECT PTR [esi]).ytopleft
			;calls snap_tonode()...
			invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx
			;...will return nearest point on g_nsnapring, in
			;	.xtopleft/.ytopleft of wire.
			pop g_ydiffnorm
			pop g_xdiffnorm
			pop g_nsnapring


		      jmp SHORT tst1	;in case other end wire on same node.
		  .ELSE
tst1:		    mov eax,(OBJECT PTR [esi]).rplock2
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		    .IF eax==pobj
		      ;2nd end of wire is connected to node.

			;091200 new routine for ellipse...
			push g_nsnapring	;precaution.
			push g_xdiffnorm	;/
			push g_ydiffnorm	;/
			xor eax,eax
			mov al,(OBJECT PTR [esi]).nendring
			mov g_nsnapring,eax ;global, used by snap_tonode().
			mov ebx,pobj	    ;node.
			 ;offset wire-end for nonconcentric rings...
			 mov ecx,g_nsnapring
			 dec ecx
			 mov eax,oldxdelta ;(OBJECT PTR [ebx]).xdeltacentre
			 imul ecx
			 sub (OBJECT PTR [esi]).wwidth,eax
			 mov eax,oldydelta ;(OBJECT PTR [ebx]).ydeltacentre
			 imul ecx
			 sub (OBJECT PTR [esi]).height,eax
			mov ebx,pobj	  ;node.
			mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
			mov ebx,eax
			lea ecx,(OBJECT PTR [esi]).wwidth	;wire.
			lea edx,(OBJECT PTR [esi]).height
			;calls snap_tonode()...
			invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx
			;...will return nearest point on g_nsnapring, in
			;	.wwidth/height of wire.
			pop g_ydiffnorm
			pop g_xdiffnorm
			pop g_nsnapring

		    .ENDIF
		  .ENDIF
		.ELSE
		  ;it's a node-type.
		  ;an action or condition object will have .rplock1
		  ;set to its parent, and .nbeginring set to the ring
		  ;it's connected to on the parent...
		  mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pobj
		    ;it is connected to pobj parent.
		    mov ax,(OBJECT PTR [esi]).nexttype
		    .IF ax==32	;condition element.
kk1:		      xor ecx,ecx
		      mov cl,(OBJECT PTR [esi]).nbeginring
		      dec ecx
			 ;offset cond/action for nonconcentric rings...
			 mov ebx,pobj	;node.
			 mov eax,oldxdelta ;(OBJECT PTR [ebx]).xdeltacentre
			 imul ecx
			 sub (OBJECT PTR [esi]).xtopleft,eax
			 sub (OBJECT PTR [esi]).xmid,eax
			 mov eax,oldydelta ;(OBJECT PTR [ebx]).ydeltacentre
			 imul ecx
			 sub (OBJECT PTR [esi]).ytopleft,eax
			 sub (OBJECT PTR [esi]).ymid,eax
		    .ELSEIF ax==33 ;action element.
		      jmp kk1
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	  .ENDIF
x1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  j02 ;nextobj
      jmp SHORT j03
j02:  jmp nextobj
j03:



    ret
fixnonconc2conc ENDP
;--------------------------------------------------------------------------
fixconc2nonconc PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD
    LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
; "fixconc2nonconc"
;a node with concentric rings has been converted to totem-pole.
;nodeproc() calls this func.
;need to find all wires attached to this node and adj end coords,
;and all cond/action elements and adj their x/ytopleft & x/ymid
;(note, cond/action will auto-snap to the correct ring).

    mov ebx,pobj			  ;node.


;scan through all objects...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0 ;extreme precaution.
	    jmp j03
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	      .IF esi==pobj ;don't test itself.
	      .ELSE
		mov al,(OBJECT PTR [esi]).fconfig
		and al,01	;bit0=1 if wire type.
		.IF al==01
		  mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pobj
		    ;1st end of wire is connected to node.
		      ;esi-->wire, ebx-->node

			;new routine for ellipse...
			push g_nsnapring	;precaution.
			push g_xdiffnorm	;/
			push g_ydiffnorm	;/
			xor eax,eax
			mov al,(OBJECT PTR [esi]).nbeginring
			mov g_nsnapring,eax ;global, used by snap_tonode().
			mov ebx,pobj	    ;node.
			 ;offset wire-end for nonconcentric rings...
			 mov ecx,g_nsnapring
			 dec ecx
			 mov eax,(OBJECT PTR [ebx]).xdeltacentre
			 imul ecx
			 add (OBJECT PTR [esi]).xtopleft,eax
			 mov eax,(OBJECT PTR [ebx]).ydeltacentre
			 imul ecx
			 add (OBJECT PTR [esi]).ytopleft,eax
			mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
			mov ebx,eax
			lea ecx,(OBJECT PTR [esi]).xtopleft	;wire.
			lea edx,(OBJECT PTR [esi]).ytopleft
			;calls snap_tonode()...
			invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx
			;...will return nearest point on g_nsnapring, in
			;	.xtopleft/.ytopleft of wire.
			pop g_ydiffnorm
			pop g_xdiffnorm
			pop g_nsnapring


		      jmp SHORT tst1	;in case other end wire on same node.
		  .ELSE
tst1:		    mov eax,(OBJECT PTR [esi]).rplock2
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		    .IF eax==pobj
		      ;2nd end of wire is connected to node.

			;091200 new routine for ellipse...
			push g_nsnapring	;precaution.
			push g_xdiffnorm	;/
			push g_ydiffnorm	;/
			xor eax,eax
			mov al,(OBJECT PTR [esi]).nendring
			mov g_nsnapring,eax ;global, used by snap_tonode().
			mov ebx,pobj	    ;node.
			 ;offset wire-end for nonconcentric rings...
			 mov ecx,g_nsnapring
			 dec ecx
			 mov eax,(OBJECT PTR [ebx]).xdeltacentre
			 imul ecx
			 add (OBJECT PTR [esi]).wwidth,eax
			 mov eax,(OBJECT PTR [ebx]).ydeltacentre
			 imul ecx
			 add (OBJECT PTR [esi]).height,eax
			mov ebx,pobj	  ;node.
			mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
			mov ebx,eax
			lea ecx,(OBJECT PTR [esi]).wwidth	;wire.
			lea edx,(OBJECT PTR [esi]).height
			;calls snap_tonode()...
			invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx
			;...will return nearest point on g_nsnapring, in
			;	.wwidth/height of wire.
			pop g_ydiffnorm
			pop g_xdiffnorm
			pop g_nsnapring

		    .ENDIF
		  .ENDIF
		.ELSE
		  ;it's a node-type.
		  ;an action or condition object will have .rplock1
		  ;set to its parent, and .nbeginring set to the ring
		  ;it's connected to on the parent...
		  mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pobj
		    ;it is connected to pobj parent.
		    mov ax,(OBJECT PTR [esi]).nexttype
		    .IF ax==32	;condition element.
kk1:		      xor ecx,ecx
		      mov cl,(OBJECT PTR [esi]).nbeginring
		      dec ecx
			 ;offset cond/action for nonconcentric rings...
			 mov ebx,pobj	;node.
			 mov eax,(OBJECT PTR [ebx]).xdeltacentre
			 imul ecx
			 add (OBJECT PTR [esi]).xtopleft,eax
			 add (OBJECT PTR [esi]).xmid,eax
			 mov eax,(OBJECT PTR [ebx]).ydeltacentre
			 imul ecx
			 add (OBJECT PTR [esi]).ytopleft,eax
			 add (OBJECT PTR [esi]).ymid,eax
		    .ELSEIF ax==33 ;action element.
		      jmp kk1
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	  .ENDIF
x1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  j02 ;nextobj
      jmp SHORT j03
j02:  jmp nextobj
j03:



    ret
fixconc2nonconc ENDP
;--------------------------------------------------------------------------
findmaster PROC STDCALL USES ebx ecx edx esi edi, plock:DWORD
    LOCAL dummy:BYTE
; "findmaster"
;a child has it's .rplock1/2 pointing to a parent (wires use .rplock1
;for 1st end, .rplock2 for 2nd end, node-types only use .rplock1).
;the address of the parent is supplied to this function, and it must
;be traced to find the master, at the head of any possible owner-chain.
;addr of master returned in eax.

;note that this func is intended for use by clone-nodes, and the master
;addr will be stored in .rpmaster (not by this func though).

    mov esi,plock
x1: mov edi,(OBJECT PTR [esi]).rplock1
    .IF edi==0
      ;esi has addr of master...
      mov eax,esi
      ret
    .ENDIF
    add edi,pTERSEDATA	;make addr absolute.
    mov esi,edi
    jmp x1

    ret
findmaster ENDP
;--------------------------------------------------------------------------
drawblobs PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD,pobj:DWORD
    LOCAL xend:DWORD, yend:DWORD
    LOCAL pmaster:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL ffound:BYTE
;called from paint_node().	"drawblobs"
;pobj is a child node. need to determine wires and resources attached
;to master of chain, and draw them as blobs on pobj.

;firstly, get the master...
    mov ebx,pobj
    mov edi,(OBJECT PTR [ebx]).rpmaster
    add edi,pTERSEDATA
    mov pmaster,edi

;now, need to scan database, finding wires/resources attached to pmaster
;and draw them on pobj (ebx)...

;scan through all objects...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0 ;extreme precaution.
	    jmp j03
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	  .IF ax==01	;bit0=1, valid object.
	      .IF esi==pobj ;don't test itself.
	      .ELSEIF esi==pmaster ;leave out master also.
	      .ELSE
		mov ffound,0
		mov eax,(OBJECT PTR [esi]).rplock1
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		.IF eax==pmaster
		  ;now draw a blob...
		  mov al,(OBJECT PTR [esi]).fconfig
		  and al,01	;bit0=1 wire-type.
		  .IF al==01
		    mov al,(OBJECT PTR [esi]).nbeginring
		    .IF al==1	;wires on master must be on ring1.
		      mov eax,(OBJECT PTR [esi]).xtopleft
		      mov xend,eax
		      mov eax,(OBJECT PTR [esi]).ytopleft
		      mov yend,eax
			;...these are coords on ring1 of master. need to
			;translate these to pobj...
bb1:			push esi
			push edi
			mov esi,pmaster
			mov edi,pobj
			mov eax,(OBJECT PTR [edi]).xmid
			sub eax,(OBJECT PTR [esi]).xmid
			add xend,eax
			mov eax,(OBJECT PTR [edi]).ymid
			sub eax,(OBJECT PTR [esi]).ymid
			add yend,eax
			pop  edi
			pop  esi
		      mov eax,xend
		      mov ebx,yend
		      mov ecx,eax
		      mov edx,ebx
		      dec eax
		      dec ebx
		      inc ecx
		      inc edx
		      invoke Ellipse, hdc, eax,ebx,ecx,edx
		      mov eax,xend
		      mov ebx,yend
		      mov ecx,eax
		      mov edx,ebx
		      dec eax
		      dec eax
		      dec ebx
		      dec ebx
		      inc ecx
		      inc ecx
		      inc edx
		      inc edx
		      invoke Ellipse, hdc, eax,ebx,ecx,edx
		    .ENDIF
		  .ELSE
		    ;*NO* don't draw blob for shareable. Reason is,
		    ;paint_res() & paint_hard() no longer draw a line
		    ;from res to node -- instead, have to place a
		    ;dataflow wire.
;		    ;now we are looking for resources, shareable,
;		    ;(and permanent too i think) -- .nexttype=4/.fconfig
;		    ;bits6/5=0/0...
;		    mov ax,(OBJECT PTR [esi]).nexttype
;		    .IF ax==4	;global data
;		      jmp SHORT gh1
;		    .ELSEIF ax==51   ;global hardware
;gh1:		      mov al,(OBJECT PTR [esi]).fconfig
;		      and al,01100000b	;extract bits 6/5.
;		      .IF al==0 	;shareable permanant.
;			mov eax,(OBJECT PTR [esi]).xmid
;			mov xend,eax
;			mov eax,(OBJECT PTR [esi]).ymid
;			mov yend,eax
;			;need to recalc coords for ring1...
;			;(this is for generic handling -- we are only going
;			;to make blobs for wires on ring1 of master)
;			mov g_nsnapring,1 ;used by snap_tonode().
;			invoke snap_tonode, pmaster,ADDR xend,ADDR yend
;			;...returns snapped coords in xend/yend.
;			;now draw the blob on current node...
;			jmp bb1
;		      .ENDIF
;		    .ENDIF
		  .ENDIF
		  mov ffound,1
		.ELSE
		  mov eax,(OBJECT PTR [esi]).rplock2
			    ;ALL OBJECT PTRS RELATIVE TO TERSEDATA
			    ;assuming eax has value to be written...
			    .IF eax==0
			    .ELSE
			      add eax,pTERSEDATA
			    .ENDIF
		  .IF eax==pmaster
		    ;now draw a blob...
		    mov al,(OBJECT PTR [esi]).fconfig
		    and al,01	;bit0=1 wire-type.
		    .IF al==01
		      mov al,(OBJECT PTR [esi]).nendring ;nbeginring
		      .IF al==1	;wires on master must be on ring1.
			mov eax,(OBJECT PTR [esi]).wwidth
			mov xend,eax
			mov eax,(OBJECT PTR [esi]).height
			mov yend,eax
			jmp bb1
		      .ENDIF
		    .ENDIF
		    mov ffound,1
		  .ENDIF
		.ENDIF
		.IF ffound==1


		  mov ffound,0
		.ENDIF
	      .ENDIF

	  .ENDIF
x1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop  j02 ;nextobj
      jmp SHORT j03
j02:  jmp nextobj
j03:




  ret
drawblobs ENDP
;--------------------------------------------------------------------------
snapclonewires PROC STDCALL USES ebx ecx edx esi edi,pmwire:DWORD, \
				nend:DWORD,pmaster:DWORD, \
				xend:DWORD, yend:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL ffound:BYTE
;called from drag_arc().	    "snapclonewires"
;pmaster is root node of a clone-chain. a wire-end is being moved on
;the master. the wire-end's coords are xend/yend.
;this function is to search the database and find if any clone (child
;of the master) has a wire as the approx. same coords -- if so, snap it
;to exactly xend/yend.
;nend =0 if 1st-end of wire, =1 if destination-end of wire. (used
;inside snapclonewires2()).
;pmwire -> wire on master node.

;two loops are required. the first scans the database for clones of the
;master. if found, a second loop inside the first, scans the database
;looking for a wire-end at the same approx coords.
;note, a clone has .rpmaster field that points to the master of the chain.

    mov ffound,0

;do a syntax check first on the master wire...
    invoke wiresyntaxcheck0, pmwire
    .IF eax==-1
		mov esi,pmwire
		mov g_perrorobject,esi
		mov g_pmovingobject,0
		mov poldmovingobject,0
		mov g_nstate,0
		mov g_nknee,0
		invoke add2updatelist,esi
		mov g_fredrawdiag,UPDATEobjs
		invoke InvalidateRgn, g_hwnd,0,FALSE
		mov eax,-1
      ret
    .ENDIF

;1st loop...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp uu3
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and al,01
	  .IF al==01	;bit0=1, valid object.
	      .IF esi==pmaster	    ;don't test master.
	      .ELSE
		mov ax,(OBJECT PTR [esi]).nexttype
		.IF ax==0   ;a node.
		  mov eax,(OBJECT PTR [esi]).rpmaster
		  .IF eax==0	;not a clone
		  .ELSE
		    mov eax,(OBJECT PTR [esi]).rplock1
		    .IF eax==0	;precaution check, not a clone.
		    .ELSE
		      mov eax,(OBJECT PTR [esi]).rpmaster
		      add eax,pTERSEDATA    ;make addr absolute.
		      .IF eax==pmaster
			;we're in!!!
			mov ffound,1   ;want to redraw this clone.
			;esi -> found clone.
			invoke add2wipeoutlist, esi
			;(...a wipeout occurs inside snapclonewires2())
		   invoke snapclonewires2,pmwire,nend,pmaster,esi,xend,yend
			.IF eax==-1
			  ret	;get out.
			.ENDIF
			invoke add2updatelist, esi
		      .ENDIF
		    .ENDIF
		  .ENDIF
		.ENDIF
	      .ENDIF
	  .ENDIF
	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
	loop uu2 ;nextobj
uu1:	jmp SHORT uu3
uu2:	jmp nextobj
uu3:

;    .IF ffound==1
;		    mov g_fredrawdiag,WIPEOUTobjs
;		    invoke UpdateWindow, g_hwnd
;		    mov g_fredrawdiag,UPDATEobjs
;		    invoke InvalidateRgn, g_hwnd,ENTIRE
;    .ENDIF

;this is the final return...
    ret
snapclonewires ENDP
;--------------------------------------------------------------------------
.DATA
szerct3 BYTE "HOLD ON! One of the wires at the same relative terminal "
	BYTE "position (coordinates) in a clone-chain (a master or root "
	BYTE "node with child-nodes) is of a different type. All wires "
	BYTE "to matching terminals must be of same type (e.g. "
	BYTE "sync. 1-way) and also have the same end (source or "
	BYTE "destination) at the terminals.", 0Dh, 0Ah
	BYTE "GOOSEE has highlighted the offending wire. Fix this now.",0
;***NOTE*** not using szernh3 anymore, but left in cos code still there...
szernh3 BYTE "HOLD ON! The GOO language requires that ring 1 of a node "
	BYTE "should have one Synchronous input wire and one Synchronous "
	BYTE "output wire (or a single Sync. 2-way wire). The same "
	BYTE "restriction applies to Asynchronous wires.",0Dh,0Ah
	BYTE "GOOSEE has "
	BYTE "found a violation of this and has highlighted the "
	BYTE "offending wire. Fix it now.",0
;***NOTE*** ditto...
szerde1 BYTE "HOLD ON! You have made a GOO visual syntax error. A two-"
	BYTE "way wire, that is a wire with a reply, must have its "
	BYTE "destination-end at ring 1 of a node (after all, a node "
	BYTE "is like a function, with ring 1 the entry and exit point). "
	BYTE "You have placed a 2-way wire the wrong way round.",0Dh,0Ah
	BYTE "GOOSEE has highlighted the offending wire. Fix it now."
	BYTE "If child-nodes (clones) are involved, check the wiring "
	BYTE "on those too.",0
szer1w	BYTE "HOLD ON! You have made a GOO visual syntax error. "
	BYTE "You already have a 2-way execution-flow (sync or async) wired "
	BYTE "to ring 1 of a node. You cannot have any more or 1-way "
	BYTE "execution-flow wires attached to ring 1.",0Dh,0Ah
	BYTE "GOOSEE has highlighted the offending wire. Fix it now.",0

.CODE
snapclonewires2 PROC STDCALL USES ebx ecx edx esi edi,pmwire:DWORD, \
			nend:DWORD,pmaster:DWORD, \
			pclone:DWORD, xend:DWORD, yend:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL ffound:BYTE
    LOCAL xendclone:DWORD, yendclone:DWORD
    LOCAL ntype:WORD, nhits:BYTE
    LOCAL f2way:BYTE
;called from snapclonewires(). this is 2nd loop.  "snapclonewires2"
;two loops are required. the first scans the database for clones of the
;master. if found, a second loop inside the first, scans the database
;looking for a wire-end at the same approx coords.
;nend =0 if 1st end of master wire, =1 if destination-end.
;pmwire -> wire on master node. need to check that wire on clone is
;of same type.
;returns eax=0 if no wires found, else eax=1. else eax=-1 error.

;only one wire should be found at xend/yend on the clone, with
;matching nexttype and correct end. use a counter to catch error...
    mov nhits,0
;note, i've commented out some error checking, as it's now done in
;wiresyntaxcheck0() -- better and more centralised.

    mov ffound,0

	      ;type of wire on master-node...
	      mov ebx,pmwire
	      mov ax,(OBJECT PTR [ebx]).nexttype
	      mov ntype,ax

	      ;if wire on master is async or sync 2-way, it's destination-end
	      ;must be on ring1...
	      mov f2way,0
	      .IF ntype==11	;sync 2-way
		jmp rt1
	      .ELSEIF ntype==12 ;sync 2-way+timeout
rt1:
	jmp by3 ;BYPASS error chking.
		.IF nend==0	;1st end of wire.
		  lea eax,szerde1
		  mov esi,pmwire ;see wq1: code
		  jmp wq1
		.ELSE
by3:		  mov f2way,1	;flag that have sync2-way at master node.
		.ENDIF		;clone is not allowed any sync 1-ways.
	      .ELSEIF ntype==14 ;async 2-way
	jmp by4 ;BYPASS
		.IF nend==0	;1st end of wire.
		  lea eax,szerde1
		  mov esi,pmwire ;see wq1: code
		  jmp wq1
		.ELSE
by4:		  mov f2way,2	;flag that have async 2-way at master node.
		.ENDIF		;this means clone is not allowed to
	      .ENDIF		;have any async 1-ways at all.


		;translate xend/yend (wire coords on master node)
		;to matching coords on current clone...
			mov ebx,pmaster
			mov edi,pclone
			mov eax,xend
			mov xendclone,eax
			mov eax,(OBJECT PTR [edi]).xmid
			sub eax,(OBJECT PTR [ebx]).xmid
			add xendclone,eax
			mov eax,yend
			mov yendclone,eax
			mov eax,(OBJECT PTR [edi]).ymid
			sub eax,(OBJECT PTR [ebx]).ymid
			add yendclone,eax


;2nd loop...
	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp kj3
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and al,01
	  .IF al==01	;bit0=1, valid object.
	    mov al,(OBJECT PTR [esi]).fconfig
	    and al,01
	    .IF al==01	    ;wire-type object.

	      ;exclude wire-on-master from search...
	      cmp esi,pmwire
	      je  kk1

	      ;check for an error. if f2way=1, not allowed to have
	      ;any sync 1-way wires attached to the clone...
	      mov ax,(OBJECT PTR [esi]).nexttype
	      .IF f2way==1
		.IF ax==10	  ;sync 1-way
vg1:		  mov eax,(OBJECT PTR [esi]).rplock1
		  add eax,pTERSEDATA
		  .IF eax==pclone
		    ;error
		    lea eax,szer1w
		    jmp wq1
		  .ENDIF
		  mov eax,(OBJECT PTR [esi]).rplock2
		  add eax,pTERSEDATA
		  .IF eax==pclone
		    ;error
		    lea eax,szer1w
		    jmp wq1
		  .ENDIF
		.ENDIF
	      .ELSEIF f2way==2	;not allowed any async 1-ways
		.IF ax==13  ;async 1-way
		  jmp vg1
		.ENDIF
	      .ENDIF

	      mov ax,(OBJECT PTR [esi]).nexttype
	      .IF ax==ntype	;ok
	      .ELSE
		;do a quick error-check that no other type of wire
		;at same end coords as xendclone/yendclone...
		;this code is partly a repeat of the main code below.
		.IF nend==0	;1st end of master wire.
		  mov eax,(OBJECT PTR [esi]).xtopleft
		  sub eax,xendclone
		  .IF SDWORD PTR eax<0
		    neg eax	;make it positive.
		  .ENDIF
		  .IF eax<=3 ;2	;let's say wire has to be within 2 pixels.
		    mov eax,(OBJECT PTR [esi]).ytopleft
		    sub eax,yendclone
		    .IF SDWORD PTR eax<0
		      neg eax
		    .ENDIF
		    .IF eax<=3 ;2
		      ;error found!!!
		      lea eax,szerct3
		      jmp wq1
		    .ENDIF
		  .ENDIF
		.ELSE		;2nd end of master wire.
		  mov eax,(OBJECT PTR [esi]).wwidth
		  sub eax,xendclone
		  .IF SDWORD PTR eax<0
		    neg eax	;make it positive.
		  .ENDIF
		  .IF eax<=3 ;2	;let's say wire has to be within 2 pixels.
		    mov eax,(OBJECT PTR [esi]).height
		    sub eax,yendclone
		    .IF SDWORD PTR eax<0
		      neg eax
		    .ENDIF
		    .IF eax<=3 ;2
		      ;error found!!!
		      lea eax,szerct3
		      jmp wq1
		    .ENDIF
		  .ENDIF
		.ENDIF
		jmp kk1 ;ignore this wire.
	      .ENDIF

	      cmp nend,0    ;=0 if 1st-end of master wire, so only
	      jne jj1	    ;search for same end of wires on clone.

		;look at begin-end of wire...
		  mov eax,(OBJECT PTR [esi]).rplock1 ;owner of 1stend.
		  add eax,pTERSEDATA	;make absolute.
		  .IF eax==pclone
			inc nhits     ;count of wires found.
			jmp erb3    ;BYPASS see note at start func.
			.IF nhits>1
			  lea eax,szernh3 ;more than 1 hit is error.
wq1:		invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
		mov g_perrorobject,esi
		mov g_pmovingobject,0
		mov poldmovingobject,0
		mov g_nstate,0
		mov g_nknee,0
		invoke add2updatelist,esi
		mov g_fredrawdiag,UPDATEobjs
		invoke InvalidateRgn, g_hwnd,0,FALSE
		mov eax,-1
		ret
			.ENDIF
erb3:
		  .ELSE
		    jmp kk1	;ignore this wire.
		  .ENDIF
		mov eax,(OBJECT PTR [esi]).xtopleft
		sub eax,xendclone
		.IF SDWORD PTR eax<0
		  neg eax     ;make it positive.
		.ENDIF
		.IF eax<=3 ;2	;let's say wire has to be within 2 pixels.
		  mov eax,(OBJECT PTR [esi]).ytopleft
		  sub eax,yendclone
		  .IF SDWORD PTR eax<0
		    neg eax
		  .ENDIF
		  .IF eax<=3 ;2
		    ;found!!! so, snap it...
		      ;first wipe it out...
		      invoke add2wipeoutlist, esi
		      mov g_fredrawdiag,WIPEOUTobjs
		      invoke InvalidateRgn, g_hwnd,0,FALSE
		      invoke UpdateWindow, g_hwnd
		    mov eax,xendclone
		    mov (OBJECT PTR [esi]).xtopleft,eax
		    mov eax,yendclone
		    mov (OBJECT PTR [esi]).ytopleft,eax
		    invoke add2updatelist, esi
		    mov ffound,1
		    jmp kk1	  ;(loopbacks not allowed ring1)
		  .ENDIF
		.ENDIF
		jmp kk1 ;cos nend now used, only look one end.

jj1:		;look at destination-end of wire...
		  mov eax,(OBJECT PTR [esi]).rplock2 ;owner of 2ndend.
		  add eax,pTERSEDATA	;make absolute.
		  .IF eax==pclone
			inc nhits     ;count of wires found.
			jmp erb4    ;BYPASS see note begin func.
			.IF nhits>1
			  lea eax,szernh3 ;more than 1 hit is error.
			  jmp wq1
			.ENDIF
erb4:
		  .ELSE
		    jmp kk1	;ignore this wire.
		  .ENDIF
		mov eax,(OBJECT PTR [esi]).wwidth
		sub eax,xendclone
		.IF SDWORD PTR eax<0
		  neg eax     ;make it positive.
		.ENDIF
		.IF eax<=3 ;2	;let's say wire has to be within 2 pixels.
		  mov eax,(OBJECT PTR [esi]).height
		  sub eax,yendclone
		  .IF SDWORD PTR eax<0
		    neg eax
		  .ENDIF
		  .IF eax<=3 ;2
		    ;found!!! so, snap it...
		      ;first wipe it out...
		      invoke add2wipeoutlist, esi
		      mov g_fredrawdiag,WIPEOUTobjs
		      invoke InvalidateRgn, g_hwnd,0,FALSE
		      invoke UpdateWindow, g_hwnd
		    mov eax,xendclone
		    mov (OBJECT PTR [esi]).wwidth,eax
		    mov eax,yendclone
		    mov (OBJECT PTR [esi]).height,eax
		    invoke add2updatelist, esi
		    mov ffound,1
		  .ENDIF
		.ENDIF

	    .ENDIF
	  .ENDIF
kk1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
	loop kj2  ;nextobj
kj1:	jmp SHORT kj3
kj2:	jmp nextobj
kj3:

;this is the final return...
    xor eax,eax
    mov al,ffound
    ret
snapclonewires2 ENDP
;--------------------------------------------------------------------------
.DATA
szerws4 BYTE "GOO syntax error! The start-end of a 2-way execution-flow"
	BYTE "wire must be on a ring number greater than 1. "
	BYTE "Ring 1 of a node is like the entry-and-exit point of "
	BYTE "a function, and a 2-way wire is like the call and return. "
	BYTE "The rings >1 are locations within the function, and "
	BYTE "these are allowed to call other functions, i.e., have "
	BYTE "start-end of 2-way wires on them.",0Dh,0Ah
	BYTE "GOOSEE is also applying this restriction to async "
	BYTE "2-way signaling wires.",0Dh,0Ah
	BYTE "GOOSEE is taking you "
	BYTE "back to the dialog box.",0
szerws5 BYTE "GOO syntax error! A 2-way execution-flow wire must have "
	BYTE "its destination-end on ring 1 of a node. This is "
	BYTE "because ring 1 is like the entry-and-exit point of a "
	BYTE "function, and the 2-way wire is the call-and-return.",0

.CODE
wiresyntaxcheck PROC STDCALL USES ebx ecx edx esi edi, pawire:DWORD,nnewtype:DWORD
    LOCAL noldtype:WORD
;  "wiresyntaxcheck"
;called from wireproc, wire dialog box when change type of wire.
;nnewtype is the wire-type that the dialog box desires to change wire to.
;return eax=0 if ok.


;if wire is 2-way, must start on node of ring >1 and end on ring=1...
    mov esi,pawire
    mov eax,nnewtype
    .IF ax==11		;sync 2-way
      jmp SHORT ch1
    .ELSEIF ax==12	;sync 2-way+reply
ch1:  mov al,(OBJECT PTR [esi]).nbeginring
      .IF al==1 ;fail
	lea eax,szerws4
ch2:	invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	mov eax,1
	ret
      .ENDIF
      mov al,(OBJECT PTR [esi]).nendring
      .IF al==1 	;ok
      .ELSE
	lea eax,szerws5
	jmp ch2
      .ENDIF
    .ELSEIF ax==14	;async 2-way
      jmp ch1
    .ENDIF


;check the number of and types of sync and async wires on destination
;node & ring ...(this code can be based on snapclonewires2())
    ;temporarily put the new wiretype into the wire...
    mov ax,(OBJECT PTR [esi]).nexttype
    mov noldtype,ax
    mov eax,nnewtype
    mov (OBJECT PTR [esi]).nexttype,ax
    invoke wiresyntaxcheck0,esi
    mov bx,noldtype
    mov (OBJECT PTR [esi]).nexttype,bx
    .IF eax==-1 ;error
      mov eax,1     ;don't leave dialog box.
      ret
    .ENDIF


    xor eax,eax
    ret
wiresyntaxcheck ENDP
;--------------------------------------------------------------------------
.DATA
szerwnc1    BYTE "GOO syntax error! Any ring of a node can only have "
	    BYTE "one input and one output execution-flow path."
	    BYTE "The current version of GOOSEE also imposes this "
	    BYTE "limitation on asynchronous-signal wires, though this is in "
	    BYTE "addition -- i.e., there can be two inputs and two "
	    BYTE "outputs if they are sync and async. "
	    BYTE "Note that a 2-way wire constitutes both an input and "
	    BYTE "and output.",0Dh,0Ah
	    BYTE 0Dh,0Ah
	    BYTE "Note also that if you really need to have more than "
	    BYTE "one input to the same node/ring, ""wired-OR"" is "
	    BYTE "acceptable for execution-flow wires (not signal wires) "
	    BYTE "-- achieved by placement of two or more "
	    BYTE "destination-ends overlapping -- as long as there is "
	    BYTE "still only one output path from the node/ring.",0Dh,0Ah
	    BYTE 0Dh,0Ah
	    BYTE "Note that signal wires have greater freedom of placement "
	    BYTE "than execution-flow wires. Wired-OR inputs are not allowed, "
	    BYTE "but multiple o/ps from the same ring are -- this is for the "
	    BYTE "purpose of posting a signal to many nodes."
	    BYTE 0Dh,0Ah
	    BYTE "If you have just placed a new wire, GOOSEE will "
	    BYTE "now delete it. An offending existing wire, that "
	    BYTE "maybe you have just been manipulating, will not "
	    BYTE "be deleted, but you must reposition the wire-end "
	    BYTE "for correct syntax or delete it yourself.",0

szerr1e     BYTE "GOO syntax error! You are not allowed to start a "
	    BYTE "2-way execution-flow (synchronous) or signal "
	    BYTE "(asynchronous) wire from ring 1 "
	    BYTE "of a node. Think of a node as like a function, with "
	    BYTE "ring 1 the entry-and-exit point. Therefore, the "
       BYTE "DESTINATION-end of a 2-way wire should be at ring 1. "
       BYTE "The start-end of the wire must come from a ring >1.",0Dh,0Ah
	    BYTE "If you have just placed a new wire, GOOSEE will "
	    BYTE "now delete it. An offending existing wire, that "
	    BYTE "maybe you have just been manipulating, will not "
	    BYTE "be deleted, but you must reposition the wire-end "
	    BYTE "for correct syntax or delete it yourself.",0
szerr2e     BYTE "GOO syntax error! A 2-way execution-flow (synchronous) "
	    BYTE "or signal (asynchronous) "
	    BYTE "wire must start from a ring number greater than 1, "
	    BYTE "and its destination-end MUST BE ON RING 1 of a node."
	    BYTE 0Dh,0Ah
	    BYTE "If you have just placed a new wire, GOOSEE will "
	    BYTE "now delete it. An offending existing wire, that "
	    BYTE "maybe you have just been manipulating, will not "
	    BYTE "be deleted, but you must reposition the wire-end "
	    BYTE "for correct syntax or delete it yourself.",0
szersn1     BYTE "GOO syntax error! It is not correct for a 2-way "
	    BYTE "execution-flow (synchronous) or signal (asynchronous) "
	    BYTE "wire to start and end on "
	    BYTE "the same node. However, you may connect 1-way wires within "
	    BYTE "the same node.", 0Dh,0Ah
	    BYTE "If you have just placed a new wire, GOOSEE will "
	    BYTE "now delete it. An offending existing wire, that "
	    BYTE "maybe you have just been manipulating, will not "
	    BYTE "be deleted, but you must reposition the wire-end "
	    BYTE "for correct syntax or delete it yourself.",0

.CODE
wiresyntaxcheck0 PROC STDCALL USES ebx ecx edx esi edi, pnewwire:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL nbeginring:BYTE, nendring:BYTE
    LOCAL nbegin:BYTE, nend:BYTE
    LOCAL nasync2:BYTE, nsync2:BYTE
    LOCAL plock1:DWORD, plock2:DWORD
    LOCAL nsync1st:BYTE,nasync1st:BYTE
    LOCAL nsync2nd:BYTE,nasync2nd:BYTE
    LOCAL fsync:BYTE,fsync2:BYTE, f2way:BYTE
;   "wiresyntaxcheck0"
;called from wmlbuttonup()/state5, have just placed a new wire.
;also called from wmlbuttonup()/state8/g_nknee=4or5, have moved a
;wire end.
;perform some basic syntax checking, return eax=-1 if need to
;delete new wire. this function is checking execution-flow wires.

    mov esi,pnewwire
    mov nsync1st,0
    mov nsync2nd,0
    mov nasync1st,0
    mov nasync2nd,0
    mov f2way,0

     ;101000...
     ;ignore 1-way exec-flow return-wire to ring-1, .fconfig2/bit2 set...
     ;(paint_arc() will already have set this flag)
     mov bl,(OBJECT PTR [esi]).fconfig2
     and bl,0100b
     .IF bl==0100b
       xor eax,eax	;don't delete new wire.
       ret
     .ENDIF

;firstly, exclude other wire types...
    ;exclude inter-task new wire...
    mov al,(OBJECT PTR [esi]).fconfig
    and al,0100000b
    .IF al==0100000b	;bit5
      xor eax,eax
      ret
    .ENDIF
    mov ax,(OBJECT PTR [esi]).nexttype
    .IF ax==10	;sync 1-way
      mov fsync,1
      mov nsync1st,1	    ;wire count 1st end of wire.
      mov nsync2nd,1	    ;wire count destination-end.
    .ELSEIF ax==11 ;sync 2-way
      mov f2way,1
      mov fsync,1
      mov nsync1st,2
      mov nsync2nd,2
po1:	;check that it doesn't come from ring1...
	mov al,(OBJECT PTR [esi]).nbeginring
	.IF al==1
	  lea eax,szerr1e
	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov eax,-1
	  ret
	.ENDIF
	;but it must end at ring 1...
	mov al,(OBJECT PTR [esi]).nendring
	.IF al==1
	.ELSE
	  lea eax,szerr2e
po3:	  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	  mov eax,-1
	  ret
	.ENDIF
	;a 2-way wire must not start and end on the same node...
	mov eax,(OBJECT PTR [esi]).rplock1
	mov ecx,(OBJECT PTR [esi]).rplock2
	.IF eax==ecx
	  lea eax,szersn1
	  jmp po3
	.ENDIF
    .ELSEIF ax==12 ;sync 2-way+timeout
      mov f2way,1
      mov fsync,1
      mov nsync1st,2
      mov nsync2nd,2
      jmp po1
    .ELSEIF ax==13 ;async 1-way
      mov fsync,0
      mov nasync1st,1
      mov nasync2nd,1
    .ELSEIF ax==14 ;async 2-way
      mov f2way,1
      mov fsync,0
      mov nasync1st,2
      mov nasync2nd,2
      jmp po1
    .ELSE
      xor eax,eax
      ret
    .ENDIF

    mov nbegin,0
    mov nend,0
    mov al,(OBJECT PTR [esi]).nbeginring
    mov nbeginring,al
    mov al,(OBJECT PTR [esi]).nendring
    mov nendring,al
    mov eax,(OBJECT PTR [esi]).rplock1
    add eax,pTERSEDATA
    mov plock1,eax	    ;owner node, 1st end of wire.
    mov eax,(OBJECT PTR [esi]).rplock2
    add eax,pTERSEDATA
    mov plock2,eax	    ;owner node, 2nd end of wire.

;for each ring of a node, there can only be one of the same-end
;for each type of wire...
;this is only a preliminary check, as may want to change wire type
;via dialog box later.

	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp uu3
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and al,01
	  .IF al==01	;bit0=1, valid object.
	      mov al,(OBJECT PTR [esi]).fconfig
	      and al,0100000b	    ;bit5, inter-task.
	      .IF esi==pnewwire	    ;don't test itself
	      .ELSEIF al==0100000b  ;ignore inter-task wires.
	      .ELSE
		mov al,(OBJECT PTR [esi]).fconfig
		and al,01
		.IF al==01	;wire type.

		  mov nsync2,0
		  mov nasync2,0
		  mov ax,(OBJECT PTR [esi]).nexttype
		  .IF ax==10	;sync 1-way
		    mov nsync2,1	;wire count add, both ends.
		    mov fsync2,1
		  .ELSEIF ax==11 ;sync 2-way
		    mov nsync2,2
		    mov fsync2,1
		  .ELSEIF ax==12 ;sync 2-way+timeout
		    mov nsync2,2
		    mov fsync2,1
		  .ELSEIF ax==13 ;async 1-way
		    mov nasync2,1
		    mov fsync2,0
		  .ELSEIF ax==14 ;async 2-way
		    mov nasync2,2
		    mov fsync2,0
		  .ELSE
		    jmp az1
		  .ENDIF

		  ;ignore if sync/async mismatch...
		  mov al,fsync
		  cmp al,fsync2
		  jne  az1

		  ;check begin-end of wire...
		  mov eax,(OBJECT PTR [esi]).rplock1
		  add eax,pTERSEDATA
		  .IF eax==plock1	   ;same end as new wire.
		    .IF al==nbeginring	;on same ring.
		      mov al,nsync2	;sync wire.
		      add nsync1st,al	;total effective sync o/ps
		      .IF nsync1st>1
ss1:			lea eax,szerwnc1
			invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
			mov eax,-1
			ret
		      .ENDIF
		      mov al,nasync2
		      add nasync1st,al
		      .IF nasync1st>1
			jmp ss1
		      .ENDIF
		    .ENDIF
		  .ELSEIF eax==plock2	    ;opp.ends on same node.
		    mov al,(OBJECT PTR [esi]).nbeginring
		    .IF al==nendring	;on same ring.
		      mov al,nsync2	;sync wire.
		      add nsync1st,al	;total effective sync o/ps
		      .IF nsync1st>2
xss1:			lea eax,szerwnc1
			invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
			mov eax,-1
			ret
		      .ENDIF
		      mov al,nasync2
		      add nasync1st,al
		      .IF nasync1st>2
			;jmp xss1
			;...i've removed this check, to allow multiple
			;async o/ps.
		      .ENDIF
		    .ENDIF
		  .ENDIF

		  ;check destination-end of wire...
		  mov eax,(OBJECT PTR [esi]).rplock2
		  add eax,pTERSEDATA
		  .IF eax==plock2     ;same end as new wire.
		    mov al,(OBJECT PTR [esi]).nendring
		     ;101000...
		     ;ignore return-wire (to ring-1, .fconfig2/bit2 set)...
		     mov bl,(OBJECT PTR [esi]).fconfig2
		     and bl,0100b
		     .IF bl==0100b
		    .ELSEIF al==nendring	;on same ring.
		      mov al,nsync2
		      add nsync2nd,al
		      .IF nsync2nd>1  ;more than 1 i/ps >error.

			;however, we will allow wired-OR to same coords...
			;pnewwire -> new wire, esi ->a wire same dest.
			;but, one of them at least must be 1-way.
			;we have destination-ends both together here.
			mov ebx,pnewwire
			mov ax,(OBJECT PTR [ebx]).nexttype
			mov cx,(OBJECT PTR [esi]).nexttype
			.IF ax==10	;sync 1-way
			  jmp SHORT s1w
			.ELSEIF cx==10
s1w:			  mov eax,(OBJECT PTR [esi]).wwidth
			  sub eax,(OBJECT PTR [ebx]).wwidth
			  .IF SDWORD PTR eax<0
			    neg eax	;make it positive.
			  .ENDIF
			  .IF eax<=3 ;let's say wire has to be within 3 pixels.
			    mov eax,(OBJECT PTR [esi]).height
			    sub eax,(OBJECT PTR [ebx]).height
			    .IF SDWORD PTR eax<0
			      neg eax
			    .ENDIF
			    .IF eax<=3 ;2
			      ;found!!! so, can allow 2 sync destinations at
			      ;the same node/ring.
			      dec nsync2nd
			      jmp az1
			    .ENDIF
			  .ENDIF
			.ENDIF

yss3:
			lea eax,szerwnc1
			invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
			mov eax,-1
			ret
		      .ENDIF
		      mov al,nasync2
		      add nasync2nd,al
		      .IF nasync2nd>1

;			;see same check for wired-OR...
;			mov ebx,pnewwire
;			mov ax,(OBJECT PTR [ebx]).nexttype
;			mov cx,(OBJECT PTR [esi]).nexttype
;			.IF ax==13
;			  jmp s1w
;			.ELSEIF cx==13
;			  jmp s1w
;			.ENDIF
;			jmp yss3

			lea eax,szerwnc1
			invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
			mov eax,-1
			ret

		      .ENDIF
		    .ENDIF
		  .ELSEIF eax==plock1  ;opp.ends, same node.
		    mov al,(OBJECT PTR [esi]).nendring
		    .IF al==nbeginring	;on same ring.
		      mov al,nsync2
		      add nsync2nd,al
		      .IF nsync2nd>2  ;more than 2 i/ps
xss3:			jmp errexit1   ;SEE BELOW...
			;lea eax,szerwnc1
			;invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
			;mov eax,-1
			;ret
		      .ENDIF
		      mov al,nasync2
		      add nasync2nd,al
		      .IF nasync2nd>2
			  ;jmp xss3
			  lea eax,szerwnc1
			  invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
			  mov eax,-1
			  ret
		      .ENDIF
		    .ENDIF
		  .ENDIF

		.ENDIF
	      .ENDIF
	  .ENDIF
az1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
	loop uu2 ;nextobj
uu1:	jmp SHORT uu3
uu2:	jmp nextobj
uu3:



normexit:
;a final check...
		;xor eax,eax
		;ret
		      ;a bug. 1 sync i/p, 1 sync o/p on node. add another
		      ;o/p (all 1-way). accepts it...
		      mov eax,plock1
		      xor ebx,ebx
		      mov bl,nbeginring
		      push esi
		      invoke checkwireor, eax,ebx,pnewwire
		      ;... returns edx=total actual sync o/p paths.
		      pop esi
		      .IF edx>1
			jmp ww1 ;error.
		      .ENDIF

    xor eax,eax
    ret

errexit1: ;note, only coming here for one error condition above.
	  ;i had a node with 2 wire-or sync1wayi/ps already existing, added
	  ;i added a sync1way *o/p*, and it wouldn't accept it.
	  ;that circumstance will come here...
	  ;the above code hasn't caught all wire-or cases...
	  mov esi,pnewwire
	  mov eax,(OBJECT PTR [esi]).rplock1 ;BEGIN end.
	  add eax,pTERSEDATA
	  xor ecx,ecx
	  mov cl,(OBJECT PTR [esi]).nbeginring
	  invoke checkwireor, eax,ecx,esi ;node at begin-end of new wire.
	  ;... return eax =# dest.-end 2-way sync i/p wires at same coords.
	  ;... ebx =# dest.-end 1-way sync i/p wires at same coords.
	  ;... ecx =# other wire inputs at same coords.
	  ;... edx =# actual sync o/ps (incl reply of 2-way sync)
	  cmp edx,1
	  ja  ww1	;too many o/ps.
	  xor edx,edx
	  mov dl,nsync2nd
	  sub edx,ebx
	  sub edx,eax
	  .IF SDWORD PTR edx<=1
	    ;ok...
	    jmp normexit
	    ;xor eax,eax
	    ;ret
	  .ENDIF
ww1:	lea eax,szerwnc1
	invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	mov eax,-1
	ret
wiresyntaxcheck0 ENDP
;--------------------------------------------------------------------------
createdatawire PROC STDCALL USES ebx ecx edx esi edi, presource:DWORD
;called from wmlbuttonup()/state5.
;presource is a new resource. previously, paint_res() (data resource) and
;paint_hard() (hardware resource) drew a straight line to the parent
;node, outermost ring.
;however, this creates a problem with clones, as moving a resource
;also moves the terminal point on the node.
;so, am creating a dataflow wire.
;wmlbuttondown()/state4 saves the mouse coords as global nmousex_save
;and nmousey_save, and on entry to here we have g_nmousex/g_nmousey
;for the 1st end of the wire.
    ;***NOT USING THIS FUNCTION***

    mov esi,presource
    invoke createnewobject,0	;returns eax=0 no obj created
    .IF eax==0	    ;precaution.
    .ELSE
      mov edi,eax   ;new wire.
      ;customise to a resource...
      invoke defaultnewdatawire, eax
      ;now further settings...
      ;1st end of wire must be at resource end...
      mov eax,(OBJECT PTR [esi]).xmid ;g_nmousex
      mov (OBJECT PTR [edi]).xtopleft,eax
      mov eax,(OBJECT PTR [esi]).ymid ;g_nmousey
      mov (OBJECT PTR [edi]).ytopleft,eax
      ;2nd end of wire, on node...
      mov eax,nmousex_save
      mov (OBJECT PTR [edi]).wwidth,eax
      mov eax,nmousey_save
      mov (OBJECT PTR [edi]).height,eax
      ;now for all the middle points (xmid/ymid, knee2, knee3)...

      mov eax,(OBJECT PTR [edi]).wwidth
      sub eax,(OBJECT PTR [edi]).xtopleft
      sar eax,1 	     ; /2
      add eax,(OBJECT PTR [edi]).xtopleft
      mov (OBJECT PTR [edi]).xmid,eax
      mov eax,(OBJECT PTR [edi]).height
      sub eax,(OBJECT PTR [edi]).ytopleft
      sar eax,1
      add eax,(OBJECT PTR [edi]).ytopleft
      mov (OBJECT PTR [edi]).ymid,eax

      mov eax,(OBJECT PTR [edi]).xmid
      sub eax,(OBJECT PTR [edi]).xtopleft
      sar eax,1 	     ; /2
      add eax,(OBJECT PTR [edi]).xtopleft
      mov (OBJECT PTR [edi]).xknee2,eax
      mov eax,(OBJECT PTR [edi]).ymid
      sub eax,(OBJECT PTR [edi]).ytopleft
      sar eax,1
      add eax,(OBJECT PTR [edi]).ytopleft
      mov (OBJECT PTR [edi]).yknee2,eax

      mov eax,(OBJECT PTR [edi]).wwidth
      sub eax,(OBJECT PTR [edi]).xmid
      sar eax,1 	     ; /2
      add eax,(OBJECT PTR [edi]).xmid
      mov (OBJECT PTR [edi]).xknee3,eax
      mov eax,(OBJECT PTR [edi]).height
      sub eax,(OBJECT PTR [edi]).ymid
      sar eax,1
      add eax,(OBJECT PTR [edi]).ymid
      mov (OBJECT PTR [edi]).yknee3,eax

      ;and lock the ends to their owners...
      mov eax,esi	    ;resource.
      sub eax,pTERSEDATA    ;make addr relative.
      mov (OBJECT PTR [edi]).rplock1,eax    ;1st end of wire locked to res.
      mov eax,(OBJECT PTR [esi]).rplock1 ;resource is locked to owner node.
      mov (OBJECT PTR [edi]).rplock2,eax ;2nd end of wire locked to node.

    .ENDIF

  ret
createdatawire ENDP
;--------------------------------------------------------------------------
.DATA
szerwod1    BYTE "The wire-OR configuration that you have tried to "
	    BYTE "create is incorrect. You have execution-flow (sync) "
	    BYTE "input wire/s to the same point, which is wire-OR, "
	    BYTE "but you have just tried to add a 2-way execution-flow "
	    BYTE "wire that STARTS from the wire-OR point -- this is "
	    BYTE "wrong. Logically, any execution-flow out of the "
	    BYTE "wire-OR point must be the return-path.",0Dh,0Ah
	    BYTE "You may connect a 1-way wire out of the wire-OR "
	    BYTE "point, but not a 2-way. Also, you can only have "
	    BYTE "one output wire, for logical program construction.",0Dh,0Ah
	    BYTE 0Dh,0Ah
	    BYTE "Another dialog box follows with more generic "
	    BYTE "information. read that also.",0

.CODE
checkwireor PROC STDCALL USES esi edi, \
		     pcnode:DWORD,ncring:DWORD,pnewwire:DWORD
    LOCAL ncount2wayin:DWORD,ncount1wayin:DWORD
    LOCAL ncountotherin:DWORD, ncountouts:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL xend:DWORD,yend:DWORD
    LOCAL f2way:BYTE
; "checkwireor"
;search entire database for any sync i/p wires.
;return count of # sync 2-way i/ps (destination-ends) in eax.
;return count of # sync 1-way i/ps ( " ) in ebx.
;return count of other wire-types (dest. ends) at same coords in ecx.

;finds first sync i/p, uses its coords to compare with all others.
;also count # sync o/ps from node, return in edx.
;when find sync i/p wire-or, snap them together.

    mov ncount2wayin,0
    mov ncount1wayin,0
    mov ncountotherin,0
    mov ncountouts,0
    mov xend,0
    mov yend,0
    mov f2way,0
    mov ebx,pnewwire
    mov ax,(OBJECT PTR [ebx]).nexttype
    .If ax==11	;sync 2way
      mov f2way,1
    .ELSEIF ax==12 ;sync2way+time
      mov f2way,1
    .ENDIF

	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp nextobjy
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and ax,01
	.IF ax==01	;bit0=1, valid object.
	  ;yes, this loop will test ALL wires, incl. the one we're testing.
	    mov al,(OBJECT PTR [esi]).fconfig
	    and al,01
	    .IF al==1	    ;wire-type.



	      ;also count # sync o/ps...(begin-end 1-way AND dest-end
	      ;2-way count here)...
	      mov ax,(OBJECT PTR [esi]).nexttype
	      .IF ax==10 ;sync1way
		mov eax,(OBJECT PTR [esi]).rplock1
		add eax,pTERSEDATA
		.IF eax==pcnode
		  ;but ignore any other ring...
		  xor eax,eax
		  mov al,(OBJECT PTR [esi]).nbeginring
		  .IF eax==ncring
		    inc ncountouts
		  .ENDIF
		.ENDIF
	      .ELSEIF ax==11 ;s2w
tt1:		mov eax,(OBJECT PTR [esi]).rplock2
		add eax,pTERSEDATA
		.IF eax==pcnode
		  ;but ignore any other ring...
		  xor eax,eax
		  mov al,(OBJECT PTR [esi]).nendring
		  .IF eax==ncring
		    inc ncountouts
		  .ENDIF
		.ENDIF
		mov eax,(OBJECT PTR [esi]).rplock1
		add eax,pTERSEDATA
		.IF eax==pcnode
		  ;but ignore any other ring...
		  xor eax,eax
		  mov al,(OBJECT PTR [esi]).nbeginring
		  .IF eax==ncring
		    inc ncountouts
		  .ENDIF
		.ENDIF
	      .ELSEIF ax==12 ;s2w+time
		jmp tt1
	      .ENDIF

	      ;only executed once, when first sync i/p found...
	      ;(to get xend/yend coords)
	      .IF xend==0
		mov ax,(OBJECT PTR [esi]).nexttype
		.IF ax==10 ;sync 1way.
		  mov eax,(OBJECT PTR [esi]).rplock2 ;dest.node.
		  add eax,pTERSEDATA
		  .IF eax==pcnode
		    ;but must be on same ring...
		    xor eax,eax
		    mov al,(OBJECT PTR [esi]).nendring
		    .IF eax==ncring
		      mov ncount1wayin,1
qq1:		      mov eax,(OBJECT PTR [esi]).wwidth
		      mov xend,eax
		      mov eax,(OBJECT PTR [esi]).height
		      mov yend,eax
		      jmp qq5
		    .ENDIF
		  .ENDIF
		.ELSEIF ax==11 ;sync 2way.
qq2:		  mov eax,(OBJECT PTR [esi]).rplock2
		  add eax,pTERSEDATA
		  .IF eax==pcnode
		    ;but must be on same ring...
		    xor eax,eax
		    mov al,(OBJECT PTR [esi]).nendring
		    .IF eax==ncring
		      mov ncount2wayin,1
		      jmp qq1
		    .ENDIF
		  .ENDIF
		.ELSEIF ax==12 ;sync 2way_timeout.
		  jmp qq2
		.ENDIF
	      .ENDIF

		mov eax,(OBJECT PTR [esi]).wwidth
		sub eax,xend
		.IF SDWORD PTR eax<0
		  neg eax
		.ENDIF
		.IF eax<4
		  mov eax,(OBJECT PTR [esi]).height
		  sub eax,yend
		  .IF SDWORD PTR eax<0
		    neg eax
		  .ENDIF
		  .IF eax<4
		    ;wired-or found...
		    mov ax,(OBJECT PTR [esi]).nexttype
		    .IF ax==10	    ;sync 1-way.
		      inc ncount1wayin
hh1:		      ;probably good, snap them together...
		      mov eax,xend
		      mov (OBJECT PTR [esi]).wwidth,eax
		      mov eax,yend
		      mov (OBJECT PTR [esi]).height,eax
		    .ELSEIF ax==11	;sync 2-way.
		      inc ncount2wayin
		      jmp hh1
		    .ELSEIF ax==12	;sync 2-way+timeout.
		      inc ncount2wayin
		      jmp hh1
		    .ELSE
		      inc ncountotherin
		    .ENDIF
		  .ENDIF
		.ENDIF
	    .ENDIF
	.ENDIF
qq5:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
    loop nextobjx
    jmp  SHORT nextobjy
nextobjx: jmp nextobj
nextobjy:

;    .IF ncount1wayin==0
;      invoke MessageBeep,-1
;    .ENDIF


;final problem. if new wire is 2-way, and it isn't wire-or with other
;sync i/ps, it will be an error...
;special case here is for a 2way starting from the node...
    .IF xend==0 ;non0 if any sync i/p found (other than newwire).
    .ELSE
      .IF f2way==1
	mov ebx,pnewwire
	mov eax,(OBJECT PTR [ebx]).xtopleft
	sub eax,xend
	.IF SDWORD PTR eax<0
	  neg eax
	.ENDIF
	.IF eax<4
	  mov eax,(OBJECT PTR [ebx]).ytopleft
	  sub eax,yend
	  .IF SDWORD PTR eax<0
	    neg eax
	  .ENDIF
	  .IF eax<4
	    ;inc ncount1wayin
	    ;jmp hg1
	    ;no, this also is wrong...
	    lea eax,szerwod1
	    invoke MessageBox,g_hwnd,eax,0,MB_OK+MB_ICONEXCLAMATION
	    jmp SHORT xhh1
	  .ENDIF
	.ENDIF
	;fall here if 2way o/p wire isn't wire-or with other sync i/ps...
	;error...
xhh1:	mov eax,0
	mov ebx,0
	mov ecx,0
	ret
      .ENDIF
    .ENDIF
hg1:
    mov eax,ncount2wayin   ;cnt of dest-end 2-way at xend/yend.
    mov ebx,ncount1wayin   ; " 1-way  "
    mov ecx,ncountotherin  ; " other wire types " .
    mov edx,ncountouts ;ACTUAL sync o/ps, incl reply of 2-ways.

    ret
checkwireor ENDP
;--------------------------------------------------------------------------
numhighlighted	EQU	128 ;32
.DATA?
highlighted	DWORD numhighlighted DUP(?)
highlightednewlist DWORD numhighlighted DUP(?) ;used in duplicatehighlighted()
.DATA
highlightedindex DWORD 0	    ;index of next free entry.
highlightedindexnewlist DWORD 0	    ;index of next free entry.

.CODE
add2highlightedlist PROC STDCALL USES eax ebx ecx edx edi esi, pobj:DWORD
    LOCAL dummy:BYTE
; "add2highlightedlist"
;list of multiple highlighted elements. (hold <shift> key while selecting).

    .IF pobj==0 ;precaution.
      ret
    .ENDIF

         mov eax,pobj
	 mov ebx,highlightedindex	 ;index to next free entry.
       .IF DWORD PTR ebx<numhighlighted	 ;max size of highlighted-list buffer.
         shl ebx,1              ;convert to relative offset.
	   shl ebx,1		  ;(based on 4 bytes per entry)
	 lea esi,highlighted	 ;/
         cmp ebx,0              ;empty list.
         je  nadd3             ;/
nadd2:	dec ebx			;find out if it is already in list.
	      dec ebx			;/
	      dec ebx			;/
            dec ebx			;/
	      mov edx,[ebx+esi]	      ;/
            cmp edx,eax			;/
            je  nadd			;/jmp if yes it is.
	      cmp ebx,0			;/
            jne nadd2			;/
	      ;fall down here if it isn't already in list.
;add object to list...
	      mov ebx,highlightedindex	;append it to end of list.
              shl ebx,1               ;/
	        shl ebx,1		   ;/
nadd3:   mov [ebx+esi],eax        ;/
	 inc highlightedindex	;/
nadd:
       .ENDIF

	ret
add2highlightedlist ENDP
;--------------------------------------------------------------------------
.DATA
sz2errfailread	DB "The file you have just opened cannot be read "
	       DB "from. Closing file. Unfortunately, "
	       BYTE "a RAM memory block has been corrupted -- exit "
	       BYTE "from GOOSEE immediately.",0

.CODE
openadiagram PROC STDCALL USES ebx ecx edx edi esi,panode:DWORD
    LOCAL hfile:DWORD
;called from xdblclk(), on node with dblclk-action to open a diagram.
;node must be library function.

    mov esi,panode
    lea eax,(OBJECT PTR [esi]).sztext2

	;open existing file...
	invoke CreateFile, eax,\
		GENERIC_READ+GENERIC_WRITE,\
		FILE_SHARE_READ+FILE_SHARE_WRITE,\
		0, OPEN_EXISTING,\	;only opens an existing file.
		FILE_ATTRIBUTE_NORMAL, 0
	cmp eax,INVALID_HANDLE_VALUE	;-1
	jne ofok
	  ;open failed ...
	  mov g_nstate,0
        mov g_pmovingobject,0
	mov g_pselectedobjectnew,0
          invoke MessageBox, g_hwnd, ADDR szerr1,\
			 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
	  ret
ofok:
    mov hfile,eax   ;handle of newly-opened file.

;Before we go ahead and read the file, is it correct
;signature? correct version?
    invoke ReadFile, hfile,ADDR testsignature,8,ADDR nbytesread,0
						;read first 8 bytes.
	.IF eax==0		;=0 if failed.
	  ;failed to read file...
ferrr:	  lea eax,szerrfailread
ferr:	  mov g_nstate,0
	  mov g_pmovingobject,0
	  mov g_pselectedobjectnew,0
          invoke MessageBox, g_hwnd, eax,\
        		 ADDR szerrortitle, MB_OK+MB_ICONEXCLAMATION
	  invoke CloseHandle, hfile ;close file.
	  ret
	.ELSE
	  ;set filepointer back to start of file...
	  invoke SetFilePointer, hfile,0,0,FILE_BEGIN
	  .IF eax==-1
		;fail...
		jmp ferrr
	  .ENDIF
	  .IF testversion==10
	    ;correct version. now test for signature...
	    .IF testsignature==0
	      ;i will accept this as ok...
	    .ELSE
	      ;no, i really want to load the whole database first.
	      ;so, i'm checking for signature further down...
	    .ENDIF
	  .ELSE
	    ;incorrect version...
	    .IF testversion<10
		;old datafile version...
	      lea eax,szerroldver
		jmp ferr	;error message and close file.
	    .ELSE
	      ;later version????....
	      lea eax,szerrfuturever
	      jmp ferr	;error message and close file.
	    .ENDIF
	  .ENDIF
	.ENDIF
;if get here, file open and correct version etc...

    mov eax,hfile
    mov g_hfile,eax	;handle of newly-opened file.
    mov esi,panode
    lea eax,(OBJECT PTR [esi]).sztext2
    lea ebx,szfile
    invoke lstrcpy, ebx,eax


;get size of file...
    invoke GetFileSize, g_hfile,0
	.IF eax==-1
	  ;function failed...
	  mov g_hfile,-1
	  lea eax,sz2errfailread
	  jmp ferr
	.ELSE
      mov g_nfilesize,eax
	.ENDIF

;allocate a memory block...
;actually, the mem block already exists, made in wmcreate, so really
;just need to call LocalReAlloc() to resize it ...
        invoke LocalReAlloc, pTERSEDATA,g_nfilesize,LMEM_MOVEABLE
					;all absolute pointers are invalid...
					mov g_pmovingobject,0
					mov poldmovingobject,0
					mov g_pselectedobject,0
					mov g_pselectedobjectnew,0
					mov g_phighlightedobject,0
					mov g_perrorobject,0
					mov wipeoutsindex,0
					mov updatesindex,0
					mov highlightedindex,0
					mov g_nstate,0
					mov highlightedindexnewlist,0
	.IF eax==0
	  ;LocalRealloc() fail...
	  lea eax,szerralloc1
	  mov g_hfile,-1
	  jmp ferr		;error message and close file.
        .ELSE
          mov pTERSEDATA,eax    ;new pointer.
        .ENDIF


;read file and write to block...
	mov eax,pTERSEDATA
    invoke ReadFile, g_hfile,eax,g_nfilesize,ADDR nbytesread,0
	.IF eax==0
	  ;fail...
	  mov g_hfile,-1
	  lea eax,sz2errfailread
	  jmp ferr		;error message and close file.
	.ELSE
	.ENDIF

;if get here, then file has been opened and loaded to memory!
;pTERSEDATA points to memory block.

;a bit late, but now check signature...
    invoke calcsig  ;returns sig in eax.
    mov esi,pTERSEDATA
    cmp (TERSEDATA PTR [esi]).nsignature,eax
    je	ok2
    invoke MessageBox, g_hwnd, ADDR szersig1,\
			 0, MB_OK+MB_ICONEXCLAMATION
ok2:

      mov g_nstate,0
      mov g_pmovingobject,0
      mov g_pselectedobjectnew,0
	invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
	mov g_fredrawdiag,ENTIRE		;redraw entire window.


    ret
openadiagram ENDP
;--------------------------------------------------------------------------
.DATA
szerinteg1 BYTE "The database integrity check on the currently open "
	   BYTE ".GOO file has found one or more elements have incorrect "
	   BYTE """element number"" fields. Most likely you created "
	   BYTE "this .GOO file on a version of GOOSEE prior to 0.97, "
	   BYTE "which had a bug that caused the element number of a node "
	   BYTE "to change if it was greater than 99.",0Dh,0Ah
	   BYTE "GOOSEE has now corrected all the element numbers and "
	   BYTE "it is recommended that you save the .GOO file.",0
sz17300    BYTE "Integrity check of currently open .GOO file completed.",0Dh,0Ah
	   BYTE "Note that this check is done automatically every time a file is "
	   BYTE "saved.",0


.CODE
checkintegrity PROC STDCALL USES ebx ecx edx esi edi,fsuppress:DWORD
    LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
    LOCAL fnumber:DWORD
; "checkintegrity"
;called via "Control/Check database integrity" > IDM_INTEGRITY
;go thru all elements of database, check integrity.
;fsuppress=1 suppress messages. =0 display msgs.

    mov fnumber,0      ;cnt of # elements with incorrect .number field.

	mov edi,pTERSEDATA
	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
	xor ecx,ecx
	mov cx,(TERSEDATA PTR [edi]).numobjects
	  .IF cx==0
	    jmp kj3
	  .ENDIF
	;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
	mov esisave,esi
	mov edisave,edi
	mov ecxsave,ecx
	xor eax,eax
	mov al,(OBJECT PTR [esi]).fstatus
	and al,01
	  .IF al==01	;bit0=1, valid object.
	    mov ax,(OBJECT PTR [esi]).nexttype
	    .IF ax==-1	    ;data object
	    .ELSE

	      ;check for .number correct...
	      mov ebx,pTERSEDATA
	      lea ecx,(TERSEDATA PTR [ebx]).OBJECTS ;start of objects database.
	      mov eax,esi
	      sub eax,ecx
	      xor edx,edx
	      xor ecx,ecx
	      mov ecx,(SIZEOF OBJECT) ;(TERSEDATA PTR [ebx]).nsizeobject
	      div ecx
	      ;ax now has correct number of element...
	      mov bx,(OBJECT PTR [esi]).number
	      .IF bx==ax
	      .ELSE
		inc fnumber
		mov (OBJECT PTR [esi]).number,ax    ;correct it.
	      .ENDIF



	    .ENDIF
	  .ENDIF
kk1:	mov ecx,ecxsave
	mov edi,edisave
	mov esi,esisave
	xor eax,eax
	mov ax,(TERSEDATA PTR [edi]).nsizeobject
	add esi,eax		;addr of next object.
	loop kj2  ;nextobj
kj1:	jmp SHORT kj3
kj2:	jmp nextobj
kj3:

  .IF fsuppress==0
    .IF fnumber==0     ;display all msgs.
    .ELSE
      invoke MessageBox, g_hwnd, ADDR szerinteg1,\
			 0, MB_OK+MB_ICONEXCLAMATION
    .ENDIF
      invoke MessageBox, g_hwnd, ADDR sz17300,\
			 ADDR szgoosee, MB_OK
  .ELSEIF fsuppress==1 ;suppress all msgs.
  .ELSEIF fsuppress==2 ;suppress final msg, allow error msgs.
    .IF fnumber==0
    .ELSE
      invoke MessageBox, g_hwnd, ADDR szerinteg1,\
			 0, MB_OK+MB_ICONEXCLAMATION
    .ENDIF
  .ENDIF

    ret
checkintegrity ENDP
;--------------------------------------------------------------------------
.DATA
szer21300  BYTE "There are no highlighted elements.",0Dh,0Ah
	   BYTE "With this version of GOOSEE, you must individually "
	   BYTE "highlight each element that you want to duplicate, "
	   BYTE "by pressing and holding down the <shift> key "
	   BYTE "then left-mouse-button clicking on the desired "
	   BYTE "elements. Then you select ""File/Duplicate"", then "
	   BYTE "move the mouse cursor to where you want the duplicated "
	   BYTE "elements to be placed. Use the arrow keys to scroll, "
	   BYTE "then left-mouse-button click to place the "
	   BYTE "duplicated elements. Note that you can scroll with "
	   BYTE "the mouse, as it is left-button-up that will actually "
	   BYTE "deposit the duplicated elements.",0

.CODE
duplicatehighlighted PROC STDCALL USES ebx ecx edx esi edi
    LOCAL ebxsave:DWORD,ebxsave2:DWORD
    LOCAL nsizeobjectssave:DWORD,nsizeactualsave:DWORD
    LOCAL nsizeobjectsold:DWORD,pendactualold:DWORD
    LOCAL nsizeactualold:DWORD
    LOCAL rporiginal:DWORD,pnew:DWORD,plock1:DWORD,plock2:DWORD
    LOCAL pmaster:DWORD
    LOCAL numobjectsprev:DWORD
; "duplicatehighlighted"
;from File/Duplicate > IDM_DUP
;duplicate elements stored in "highlighted" list.

;have to go thru "highlighted" and copy the elements onto the
;end of the database.
;place new element-pointers in "highlightednewlist"
;problem, everytime call LocalReAlloc(), all absolute pointers
;become invalid... so, convert pointers in highlighted lists to relative.

;return numobjectsprev -- number of objects prior to duplication. 0 if err.

;check if anything highlighted...
    .IF highlightedindex==0
      invoke MessageBox, g_hwnd, ADDR szer21300,\
			 0, MB_OK+MB_ICONEXCLAMATION
      xor eax,eax
      ret
    .ENDIF

;find out size current database...
      mov esi,pTERSEDATA
      xor eax,eax
      xor ecx,ecx
      xor edx,edx
      mov ax,(TERSEDATA PTR [esi]).numobjects
	mov numobjectsprev,eax ;this will be returned from func.
      mov cx,(TERSEDATA PTR [esi]).nsizeobject
      mul ecx	    ;eax=size of OBJECTS database.
      mov nsizeobjectssave,eax	;save size of old OBJECTS database.
      lea ebx,(TERSEDATA PTR [esi]).OBJECTS
      add ebx,eax	    ;ACTUAL end of total database.
      sub ebx,pTERSEDATA
      mov nsizeactualsave,ebx	;ACTUAL size of total database.

;new elements will be placed in highlightednewlist...
      mov eax,highlightedindex	      ;set size of new list the same.
      mov highlightedindexnewlist,eax

;convert all entries in highlighted list to relative pointers...
    mov ebx,0
send2:
    lea esi,highlighted 	;start of highlighted list.
    mov ebxsave,ebx
    mov eax,highlightedindex	;end of list.
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je send1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0		    ;precaution.
    je send3
      ;drop here, edi->element from highlighted list...
      sub edi,pTERSEDATA
      mov [esi+ebx],edi     ;now pointer is relative.
send3:
    mov ebx,ebxsave
    add ebx,4
    jmp send2
send1:


;.......
;go thru every element in highlighted list, copy to end database...
    mov ebx,0
xend2:
    lea esi,highlighted 	;start of highlighted list.
    mov ebxsave,ebx
    mov eax,highlightedindex	;end of list.
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je xend1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0		    ;precaution.
    je xend3
    ;drop here, edi->element from highlighted list...
    mov rporiginal,edi

      ;find out size current database...
      mov esi,pTERSEDATA
      xor eax,eax
      xor ecx,ecx
      xor edx,edx
      mov ax,(TERSEDATA PTR [esi]).numobjects
      mov cx,(TERSEDATA PTR [esi]).nsizeobject
      mul ecx	    ;eax=size of OBJECTS database.
      mov nsizeobjectsold,eax	;save size of old OBJECTS database.
      lea ebx,(TERSEDATA PTR [esi]).OBJECTS
      add ebx,eax	    ;ACTUAL end of total database.
      mov pendactualold,ebx	 ;save.
      sub ebx,pTERSEDATA
      mov nsizeactualold,ebx	;ACTUAL size of total database.

      ;increase memory block...
      mov eax,nsizeactualold
      xor ecx,ecx
      mov cx,(TERSEDATA PTR [esi]).nsizeobject
      add eax,ecx
      invoke LocalReAlloc, pTERSEDATA,eax,LMEM_MOVEABLE
                  .IF eax==0
                    ;fail...
		    invoke DestroyWindow, g_hwnd     ;exit.
		    mov g_nfilesize,0
		    invoke MessageBox, g_hwnd, ADDR szerralloc2b,\
			 0, MB_OK+MB_ICONEXCLAMATION
		    ret
		  .ENDIF
		  mov pTERSEDATA,eax	;new pointer.
      ;ah-ha! pendactualold (pointer to total end of old database) is
      ;now invalid. recalculate it...
      add eax,nsizeactualold
      mov pendactualold,eax

      ;copy element to end of database...
      mov edi,rporiginal	   ;(relative pointer)
      add edi,pTERSEDATA
      ;edi->element to be copied...
      mov esi,pTERSEDATA
      xor ecx,ecx
      mov cx,(TERSEDATA PTR [esi]).nsizeobject
      mov esi,pendactualold	;where copying to.
qq1:  mov al,[edi]
      mov [esi],al
      inc edi
      inc esi
      loop qq1

      ;update...
      mov esi,pTERSEDATA
      inc (TERSEDATA PTR [esi]).numobjects
      mov eax,g_nfilesize
      xor ecx,ecx
      mov cx,(TERSEDATA PTR [esi]).nsizeobject
      add eax,ecx
      mov g_nfilesize,eax
      ;entry in highlightednewlist for new element...
      mov ebx,ebxsave
      lea esi,highlightednewlist
      mov eax,pendactualold
      sub eax,pTERSEDATA	;convert to relative pointer.
      mov [esi+ebx],eax

xend3:
    mov ebx,ebxsave
    add ebx,4
    jmp xend2
xend1:


;convert all entries in highlighted list back to absolute pointers...
    mov ebx,0
dend2:
    lea esi,highlighted 	;start of highlighted list.
    mov ebxsave,ebx
    mov eax,highlightedindex	;end of list.
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je dend1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0		    ;precaution.
    je dend3
      ;drop here, edi->element from highlighted list...
      add edi,pTERSEDATA
      mov [esi+ebx],edi     ;now pointer is absolute.
dend3:
    mov ebx,ebxsave
    add ebx,4
    jmp dend2
dend1:

;convert all entries in highlightednewlist back to absolute pointers...
    mov ebx,0
fend2:
    lea esi,highlightednewlist	;start of highlightednewlist.
    mov ebxsave,ebx
    mov eax,highlightedindexnewlist	;end of list.
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je fend1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0		    ;precaution.
    je fend3
      ;drop here, edi->element from highlighted list...
      add edi,pTERSEDATA
      mov [esi+ebx],edi     ;now pointer is absolute.
fend3:
    mov ebx,ebxsave
    add ebx,4
    jmp fend2
fend1:


;........
;updating pointers inside each duplicated element is a problem.
;we have the old list in "highlighted" and the duplicated list
;in "highlightednewlist".
;for each pointer-field in a duplicated element, see if it points
;to an element in "highlighted" -- if not, erase new element.
;--if yes, lookup matching entry in "highlightednewlist" and load
;new value into pointer-field.

;outer loop, go thru highlightednewlist...
    mov ebx,0
zend2:
    lea esi,highlightednewlist	;start of highlightednewlist.
    mov ebxsave,ebx
    mov eax,highlightedindexnewlist	;end of list.
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je zend1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0		    ;precaution.
    je zend3
    ;drop here, edi->element from highlightednewlist...
    mov pnew,edi

      ;inner loop, for each pointer-field of duplicated element, search
      ;old highlighted list...

      ;WARNING, ZEROISING THIS...
      mov edi,pnew
      mov (OBJECT PTR [edi]).rpdata,0

      ;update .rplock1...
      mov edi,pnew
      mov eax,(OBJECT PTR [edi]).rplock1
      .IF eax != 0
	add eax,pTERSEDATA
	mov plock1,eax
	mov ebx,0
vend2:	lea esi,highlighted	;start of highlighted list.
	mov ebxsave2,ebx
	mov eax,highlightedindex	;end of list.
	shl eax,1
	shl eax,1
	cmp ebx,eax
	je vend1	    ;get out.
	mov edi,[esi+ebx]
	cmp edi,0		    ;precaution.
	je vend3
	;drop here, edi->element from highlighted list...
	  .IF edi==plock1
	    ;now get matching element from highlightednewlist...
	    lea esi,highlightednewlist
	    mov eax,[esi+ebx]
	    sub eax,pTERSEDATA
	    mov esi,pnew
	    mov (OBJECT PTR [esi]).rplock1,eax
	    jmp vend7
	  .ENDIF
vend3:	mov ebx,ebxsave2
	add ebx,4
	jmp vend2
vend1:	;failed to find parent element in highlighted list, so delete...
	;no, careful -- maybe we have duplicated a clone...
	mov edi,pnew
	mov eax,(OBJECT PTR [edi]).rpmaster
	.IF eax==0	;not a child.
	  ;delete it...
	  mov (OBJECT PTR [edi]).fstatus,0
	.ELSE
	  ;any child node will have .rpmaster->master-element. findmaster()
	  ;traces .rplock1 up thru the chain until it finds an element
	  ;with rpmaster=0.
	  ;thus nodes, data and wires can have non-zero .rpmaster...
	  mov ax,(OBJECT PTR [edi]).nexttype
	  .IF ax==0	;node
	    ;leave .rpmaster and .rplock1 as they are in original...
	    ;(we have duplicated a clone)
	  .ELSE
	    ;delete it...
	    mov (OBJECT PTR [edi]).fstatus,0
	  .ENDIF
	.ENDIF
vend7:
      .ENDIF

      ;update .rplock2...
      mov edi,pnew
      mov eax,(OBJECT PTR [edi]).rplock2  ;(used by wires, 2nd end).
      .IF eax != 0
	add eax,pTERSEDATA
	mov plock2,eax
	mov ebx,0
wend2:	lea esi,highlighted	;start of highlighted list.
	mov ebxsave2,ebx
	mov eax,highlightedindex	;end of list.
	shl eax,1
	shl eax,1
	cmp ebx,eax
	je wend1	    ;get out.
	mov edi,[esi+ebx]
	cmp edi,0		    ;precaution.
	je wend3
	;drop here, edi->element from highlighted list...
	  .IF edi==plock2
	    ;now get matching element from highlightednewlist...
	    lea esi,highlightednewlist
	    mov eax,[esi+ebx]
	    sub eax,pTERSEDATA
	    mov esi,pnew
	    mov (OBJECT PTR [esi]).rplock2,eax
	    jmp wend7
	  .ENDIF
wend3:	mov ebx,ebxsave2
	add ebx,4
	jmp wend2
wend1:	;failed to find parent element in highlighted list, so delete...
	mov edi,pnew
	mov (OBJECT PTR [edi]).fstatus,0
wend7:
      .ENDIF

	;update .rpmaster...
	;we have already taken care of this in the case of clones.
	;for data, update it...
	mov edi,pnew
	mov ax,(OBJECT PTR [edi]).nexttype
	.IF ax==0	;node
	.ELSE
	  mov eax,(OBJECT PTR [edi]).rpmaster
	  .IF eax != 0
	    add eax,pTERSEDATA
	    mov pmaster,eax
	    mov ebx,0
rend2:	    lea esi,highlighted	;start of highlighted list.
	    mov ebxsave2,ebx
	    mov eax,highlightedindex	;end of list.
	    shl eax,1
	    shl eax,1
	    cmp ebx,eax
	    je rend1	    ;get out.
	    mov edi,[esi+ebx]
	    cmp edi,0		    ;precaution.
	    je rend3
	    ;drop here, edi->element from highlighted list...
	      .IF edi==pmaster
		;now get matching element from highlightednewlist...
		lea esi,highlightednewlist
		mov eax,[esi+ebx]
		sub eax,pTERSEDATA
		mov esi,pnew
		mov (OBJECT PTR [esi]).rpmaster,eax
		jmp rend7
	      .ENDIF
rend3:	    mov ebx,ebxsave2
	    add ebx,4
	    jmp rend2
rend1:	    ;failed to find master element in highlighted list, so delete...
	    mov edi,pnew
	    mov (OBJECT PTR [edi]).fstatus,0
rend7:
	  .ENDIF
	.ENDIF

	;update .number...
	mov esi,pnew
	    mov ebx,pTERSEDATA
	    lea ecx,(TERSEDATA PTR [ebx]).OBJECTS ;start of objects database.
	    mov eax,esi
	    sub eax,ecx
	    xor edx,edx
	    xor ecx,ecx
	    mov ecx,(SIZEOF OBJECT) ;(TERSEDATA PTR [ebx]).nsizeobject
	    div ecx
	    ;ax now has correct number of element...
	    mov (OBJECT PTR [esi]).number,ax


zend3:
    mov ebx,ebxsave
    add ebx,4
    jmp zend2
zend1:


;.......
;clear any invalid pointers...
			mov g_pmovingobject,0
			mov poldmovingobject,0
			mov g_pselectedobject,0
			mov g_pselectedobjectnew,0
			mov g_phighlightedobject,0
			mov g_perrorobject,0
			mov wipeoutsindex,0
			mov updatesindex,0

;don't need highlighted list anymore...
		mov g_fclrhighlighted,1
		mov highlightedindex,0
		;...the flag set will cause paint_*() to clr .fconfig2/bit7,
		;removing any highlighting. the index removes list of
		;highlighted objects.
    mov g_nstate,0


;exit from this routine with highlightednewlist pointing to
;all of the duplicated elements.
;suggest that their coords track the mouse until a left-click.
;wmmousemove() will perform the tracking...
    mov nmxold,0	;used in wmmousemove()
    mov nmyold,0	;/


    mov eax,numobjectsprev
    ret
duplicatehighlighted ENDP
;--------------------------------------------------------------------------
updateduplicates PROC STDCALL USES ebx ecx edx esi edi
    LOCAL ebxsave:DWORD
; "updateduplicates"
;from wmmousemove() if highlightedindexnewlist non-0.
;new duplicated elements were created by duplicatehighlighted().
;we have global deltax/deltay, change in mouse position, to
;allow new elements to track the mouse...

    mov ebx,0
fend2:
    lea esi,highlightednewlist	;start of highlightednewlist.
    mov ebxsave,ebx
    mov eax,highlightedindexnewlist	;end of list.
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je fend1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0		    ;precaution.
    je fend3
      ;drop here, edi->element from highlighted list...
      mov eax,(OBJECT PTR [edi]).xtopleft
      add eax,deltax
      mov (OBJECT PTR [edi]).xtopleft,eax
      mov eax,(OBJECT PTR [edi]).ytopleft
      add eax,deltay
      mov (OBJECT PTR [edi]).ytopleft,eax
      mov eax,(OBJECT PTR [edi]).xmid
      add eax,deltax
      mov (OBJECT PTR [edi]).xmid,eax
      mov eax,(OBJECT PTR [edi]).ymid
      add eax,deltay
      mov (OBJECT PTR [edi]).ymid,eax
      ;for wires only...
      mov al,(OBJECT PTR [edi]).fconfig
      and al,01
      .IF al==01	;wire-type.
	mov eax,(OBJECT PTR [edi]).wwidth
	add eax,deltax
	mov (OBJECT PTR [edi]).wwidth,eax
	mov eax,(OBJECT PTR [edi]).height
	add eax,deltay
	mov (OBJECT PTR [edi]).height,eax
	mov eax,(OBJECT PTR [edi]).xknee2
	add eax,deltax
	mov (OBJECT PTR [edi]).xknee2,eax
	mov eax,(OBJECT PTR [edi]).yknee2
	add eax,deltay
	mov (OBJECT PTR [edi]).yknee2,eax
	mov eax,(OBJECT PTR [edi]).xknee3
	add eax,deltax
	mov (OBJECT PTR [edi]).xknee3,eax
	mov eax,(OBJECT PTR [edi]).yknee3
	add eax,deltay
	mov (OBJECT PTR [edi]).yknee3,eax
      .ENDIF
fend3:
    mov ebx,ebxsave
    add ebx,4
    jmp fend2
fend1:


    ret
updateduplicates ENDP
;--------------------------------------------------------------------------
updatemove PROC STDCALL USES ebx ecx edx esi edi
    LOCAL ebxsave:DWORD
; "updatemove"
;from wmmousemove() if fmovinghighlighted non-0.
;we have global deltax/deltay, change in mouse position, to
;allow elements to track the mouse...

;a problem. don't change wire-end coords if attached to a element
;not in highlighted list.

    mov ebx,0
fend2:
    lea esi,highlighted	;start of highlightedlist.
    mov ebxsave,ebx
    mov eax,highlightedindex	;end of list.
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je fend1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0		    ;precaution.
    je fend3
      ;drop here, edi->element from highlighted list...
      mov al,(OBJECT PTR [edi]).fconfig
      and al,01
      .IF al==0	;non-wire-type.
	mov eax,(OBJECT PTR [edi]).xtopleft
	add eax,deltax
	mov (OBJECT PTR [edi]).xtopleft,eax
	mov eax,(OBJECT PTR [edi]).ytopleft
	add eax,deltay
	mov (OBJECT PTR [edi]).ytopleft,eax
	mov eax,(OBJECT PTR [edi]).xmid
	add eax,deltax
	mov (OBJECT PTR [edi]).xmid,eax
	mov eax,(OBJECT PTR [edi]).ymid
	add eax,deltay
	mov (OBJECT PTR [edi]).ymid,eax
      .ELSE
	;for wires, have to consider if ends are attached outside...
	mov eax,(OBJECT PTR [edi]).rplock1
	add eax,pTERSEDATA
	invoke ishighlighted, eax ;return eax=TRUE if begin-end inside.
	.IF eax==TRUE
	  mov eax,(OBJECT PTR [edi]).rplock2
	  add eax,pTERSEDATA
	  invoke ishighlighted, eax ;return eax=TRUE if begin-end inside.
	  .IF eax==TRUE
	    ;both ends inside...
	    mov eax,(OBJECT PTR [edi]).xtopleft
	    add eax,deltax
	    mov (OBJECT PTR [edi]).xtopleft,eax
	    mov eax,(OBJECT PTR [edi]).ytopleft
	    add eax,deltay
	    mov (OBJECT PTR [edi]).ytopleft,eax
	    mov eax,(OBJECT PTR [edi]).xmid
	    add eax,deltax
	    mov (OBJECT PTR [edi]).xmid,eax
	    mov eax,(OBJECT PTR [edi]).ymid
	    add eax,deltay
	    mov (OBJECT PTR [edi]).ymid,eax
	    mov eax,(OBJECT PTR [edi]).wwidth
	    add eax,deltax
	    mov (OBJECT PTR [edi]).wwidth,eax
	    mov eax,(OBJECT PTR [edi]).height
	    add eax,deltay
	    mov (OBJECT PTR [edi]).height,eax
	    mov eax,(OBJECT PTR [edi]).xknee2
	    add eax,deltax
	    mov (OBJECT PTR [edi]).xknee2,eax
	    mov eax,(OBJECT PTR [edi]).yknee2
	    add eax,deltay
	    mov (OBJECT PTR [edi]).yknee2,eax
	    mov eax,(OBJECT PTR [edi]).xknee3
	    add eax,deltax
	    mov (OBJECT PTR [edi]).xknee3,eax
	    mov eax,(OBJECT PTR [edi]).yknee3
	    add eax,deltay
	    mov (OBJECT PTR [edi]).yknee3,eax
	  .ELSE
	    ;begin-end only inside...
	    mov eax,(OBJECT PTR [edi]).xtopleft
	    add eax,deltax
	    mov (OBJECT PTR [edi]).xtopleft,eax
	    mov eax,(OBJECT PTR [edi]).ytopleft
	    add eax,deltay
	    mov (OBJECT PTR [edi]).ytopleft,eax
	    mov eax,(OBJECT PTR [edi]).xknee2
	    add eax,deltax
	    mov (OBJECT PTR [edi]).xknee2,eax
	    mov eax,(OBJECT PTR [edi]).yknee2
	    add eax,deltay
	    mov (OBJECT PTR [edi]).yknee2,eax
	  .ENDIF
	.ELSE
	  mov eax,(OBJECT PTR [edi]).rplock2
	  add eax,pTERSEDATA
	  invoke ishighlighted, eax ;return eax=TRUE if begin-end inside.
	  .IF eax==TRUE
	    ;dest-end only inside...
	    mov eax,(OBJECT PTR [edi]).wwidth
	    add eax,deltax
	    mov (OBJECT PTR [edi]).wwidth,eax
	    mov eax,(OBJECT PTR [edi]).height
	    add eax,deltay
	    mov (OBJECT PTR [edi]).height,eax
	    mov eax,(OBJECT PTR [edi]).xknee3
	    add eax,deltax
	    mov (OBJECT PTR [edi]).xknee3,eax
	    mov eax,(OBJECT PTR [edi]).yknee3
	    add eax,deltay
	    mov (OBJECT PTR [edi]).yknee3,eax
	  .ELSE
	    ;nothing inside...
	  .ENDIF
	.ENDIF
      .ENDIF
fend3:
    mov ebx,ebxsave
    add ebx,4
    jmp fend2
fend1:


    ret
updatemove ENDP
;--------------------------------------------------------------------------
ishighlighted PROC STDCALL USES ebx ecx edx esi edi, pelement
    LOCAL ebxsave:DWORD
; "ishighlighted"
;called from updatemove()
;return TRUE if pelement is in highlighted list.

    mov ebx,0
fend2:
    lea esi,highlighted	;start of highlightedlist.
    mov ebxsave,ebx
    mov eax,highlightedindex	;end of list.
    shl eax,1
    shl eax,1
    cmp ebx,eax
    je fend1	    ;get out.
    mov edi,[esi+ebx]
    cmp edi,0		    ;precaution.
    je fend3
      ;drop here, edi->element from highlighted list...
      .IF edi==pelement
	mov eax,TRUE
	ret
      .ENDIF
fend3:
    mov ebx,ebxsave
    add ebx,4
    jmp fend2
fend1:
    mov eax,FALSE
    ret
ishighlighted ENDP
;--------------------------------------------------------------------------
;***MOVED TO GOOSEE_C.C***
;highlightinsiderect PROC STDCALL USES ebx ecx edx esi edi
;    LOCAL xadiff:DWORD,yadiff:DWORD
;    LOCAL ecxsave:DWORD,esisave:DWORD,edisave:DWORD
;    LOCAL xleft:DWORD,xright:DWORD,ytop:DWORD,ybot:DWORD
;; "highlightinsiderect"
;;"control/selection rectangle" -->IDM_RECT-->g_nstate=20
;; -->wmlbuttondown, set 1st corner, g_nstate=21
;; -->wmmousemove,track 2nd corner,g_nstate=22
;; -->wmlbuttonup, set 2nd corner, call highlightinsiderect().
;; n1stx,n1sty=1st corner, n2ndx,n2ndy=2nd corner.
;
;    ;find which corner is top-left, which bot-right...
;    mov eax,n1stx
;    mov ebx,n2ndx
;    .IF SDWORD PTR eax<ebx
;      mov xleft,eax
;      mov eax,n2ndx
;      mov xright,eax
;    .ELSE
;      mov xright,eax
;      mov eax,n2ndx
;      mov xleft,eax
;    .ENDIF
;    mov eax,n1sty
;    mov ebx,n2ndy
;    .IF SDWORD PTR eax<ebx
;      mov ytop,eax
;      mov eax,n2ndy
;      mov ybot,eax
;    .ELSE
;      mov ybot,eax
;      mov eax,n2ndy
;      mov ytop,eax
;    .ENDIF
;    mov eax,xright
;    sub eax,xleft
;    mov xadiff,eax   ;always +ve.
;    mov eax,ybot
;    sub eax,ytop
;    mov yadiff,eax   ;always +ve.
;
;	mov edi,pTERSEDATA
;	lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
;	xor ecx,ecx
;	mov cx,(TERSEDATA PTR [edi]).numobjects
;	  .IF cx==0 ;empty.
;	    jmp kf4
;	  .ENDIF
;	;as we loop around, edi->start of TERSEDATA, esi->current object...
;nextobj:
;	mov esisave,esi
;	mov edisave,edi
;	mov ecxsave,ecx
;	xor eax,eax
;	mov al,(OBJECT PTR [esi]).fstatus
;	and ax,01
;	  .IF ax==01	;bit0=1, valid object.
;	    mov ax,(OBJECT PTR [esi]).nexttype
;	    .IF ax==-1
;	    .ELSE		;not a data object.
;	      ;is it inside rectangle?...
;
;	      mov eax,(OBJECT PTR [esi]).xmid
;	      mov edx,(OBJECT PTR [esi]).ymid
;	      mov ecx,xleft
;	      .IF SDWORD PTR eax>ecx	;in left side?
;		mov ecx,xright
;		.IF SDWORD PTR eax<ecx ;in right side?
;		  mov ecx,ytop
;		  .IF SDWORD PTR edx>ecx	;in top side?
;		    mov ecx,ybot
;		    .IF SDWORD PTR edx<ecx
;		      ;success! object is inside rectangle.
;		      or (OBJECT PTR [esi]).fconfig2,10000000b ;set bit7.
;		      invoke add2highlightedlist,esi
;		    .ENDIF
;		  .ENDIF
;		.ENDIF
;	      .ENDIF
;
;	    .ENDIF
;	  .ENDIF
;kf1:	mov ecx,ecxsave
;	mov edi,edisave
;	mov esi,esisave
;	xor eax,eax
;	mov ax,(TERSEDATA PTR [edi]).nsizeobject
;	add esi,eax		;addr of next object.
;      loop kf3 ;nextobj
;      jmp SHORT kf4
;kf3:  jmp nextobj
;kf4:
;
;    mov n1stx,0
;    mov n1sty,0
;    mov n2ndx,0
;    mov n2ndy,0
;    ret
;highlightinsiderect ENDP
;--------------------------------------------------------------------------

TESTDISPLAY PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD
    LOCAL hold:DWORD
;***TEST***
   invoke SelectObject,hdc,g_hfontx1
   mov hold,eax
     xor eax,eax
     mov al,g_nstate		;***TEST POINT**
     .IF SDWORD PTR eax<0
      neg eax
      mov szasciitbl-1,"-"
     .ELSE
      mov szasciitbl-1,"+"
     .ENDIF
     invoke bin2dec
     lea eax,szasciitbl-1
     invoke TEXTOUTx, hdc, 5,5,eax, 11
     mov eax,xtest ;g_nxprnpixsize ;g_nxratio ;xwinext ;g_xdiffnorm		;***TEST POINT**
     .IF SDWORD PTR eax<0
      neg eax
      mov szasciitbl-1,"-"
     .ELSE
      mov szasciitbl-1,"+"
     .ENDIF
     invoke bin2dec
     lea eax,szasciitbl-1
     invoke TEXTOUTx, hdc, 5,20, eax,11
     mov eax,ytest ;g_nyprnpixsize ;g_nyratio ;ywinext ;g_ydiffnorm		;***TEST POINT**
     .IF SDWORD PTR eax<0
      neg eax
      mov szasciitbl-1,"-"
     .ELSE
      mov szasciitbl-1,"+"
     .ENDIF
     invoke bin2dec
     lea eax,szasciitbl-1
     invoke TEXTOUTx, hdc, 5,35,eax, 11

  invoke SelectObject, hdc, hold
  ret
TESTDISPLAY ENDP


;--------------------------------------------------------------------------

INCLUDE goo2c.asm
end start





     mov eax,g_ydiffnorm ;ytmp ;xtmp ;hypot	  ;***TEST POINT**
     .IF SDWORD PTR eax<0
      neg eax
      mov szasciitbl-1,"-"
     .ELSE
      mov szasciitbl-1,"+"
     .ENDIF
     invoke bin2dec
     lea eax,szasciitbl-1
     invoke MessageBox, g_hwnd, eax,0, MB_OK+MB_ICONEXCLAMATION
